/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/base/common/errors","vs/base/common/types","vs/base/common/uri","vs/base/common/path","vs/base/common/network","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/arrays","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/resources","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/uuid","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetry","vs/base/common/process","vs/platform/product/common/productService","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/stream","os","child_process","vs/platform/instantiation/common/descriptors","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/node/zip","vs/base/common/decorators","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/base/node/processes","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/base/common/map","vs/base/common/assert","vs/base/common/json","vs/base/common/processes","vs/base/common/skipList","vs/base/common/hash","vs/base/common/console","vs/base/common/marshalling","vs/base/common/labels","vs/base/node/decoder","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","vs/platform/environment/node/userDataPath","vs/platform/environment/node/argvHelper","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/iterator","graceful-fs","crypto","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Z=function(x){for(var i=[],C=0,D=x.length;C<D;C++)i[C]=Q[x[C]];return i};define(Q[55],Z([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ok=void 0;function C(D,P){if(!D)throw new Error(P?`Assertion failed (${P})`:"Assertion Failed")}i.ok=C}),define(Q[44],Z([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.throttle=i.debounce=i.memoize=i.createDecorator=void 0;function C(L){return(I,c,p)=>{let b=null,O=null;if(typeof p.value=="function"?(b="value",O=p.value):typeof p.get=="function"&&(b="get",O=p.get),!O)throw new Error("not supported");p[b]=L(O,c)}}i.createDecorator=C;function D(L,I,c){let p=null,b=null;if(typeof c.value=="function"?(p="value",b=c.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(p="get",b=c.get),!b)throw new Error("not supported");const O=`$memoize$${I}`;c[p]=function(...h){return this.hasOwnProperty(O)||Object.defineProperty(this,O,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,h)}),this[O]}}i.memoize=D;function P(L,I,c){return C((p,b)=>{const O=`$debounce$${b}`,h=`$debounce$result$${b}`;return function(...S){this[h]||(this[h]=c?c():void 0),clearTimeout(this[O]),I&&(this[h]=I(this[h],...S),S=[this[h]]),this[O]=setTimeout(()=>{p.apply(this,S),this[h]=c?c():void 0},L)}})}i.debounce=P;function R(L,I,c){return C((p,b)=>{const O=`$throttle$timer$${b}`,h=`$throttle$result$${b}`,S=`$throttle$lastRun$${b}`,y=`$throttle$pending$${b}`;return function(...g){if(this[h]||(this[h]=c?c():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),I&&(this[h]=I(this[h],...g)),this[y])return;const a=this[S]+L;a<=Date.now()?(this[S]=Date.now(),p.apply(this,[this[h]]),this[h]=c?c():void 0):(this[y]=!0,this[O]=setTimeout(()=>{this[y]=!1,this[S]=Date.now(),p.apply(this,[this[h]]),this[h]=c?c():void 0},a-Date.now()))}})}i.throttle=R}),define(Q[56],Z([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getNodeType=i.stripComments=i.visit=i.findNodeAtOffset=i.contains=i.getNodeValue=i.getNodePath=i.findNodeAtLocation=i.parseTree=i.parse=i.getLocation=i.createScanner=i.ParseOptions=i.ParseErrorCode=i.SyntaxKind=i.ScanError=void 0;var C;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(C=i.ScanError||(i.ScanError={}));var D;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(D=i.SyntaxKind||(i.SyntaxKind={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P=i.ParseErrorCode||(i.ParseErrorCode={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R=i.ParseOptions||(i.ParseOptions={}));function L(t,r=!1){let e=0,n=t.length,s="",l=0,u=16,d=0;function w(ie){let he=0,j=0;for(;he<ie;){const q=t.charCodeAt(e);if(q>=48&&q<=57)j=j*16+q-48;else if(q>=65&&q<=70)j=j*16+q-65+10;else if(q>=97&&q<=102)j=j*16+q-97+10;else break;e++,he++}return he<ie&&(j=-1),j}function T(ie){e=ie,s="",l=0,u=16,d=0}function N(){const ie=e;if(t.charCodeAt(e)===48)e++;else for(e++;e<t.length&&p(t.charCodeAt(e));)e++;if(e<t.length&&t.charCodeAt(e)===46)if(e++,e<t.length&&p(t.charCodeAt(e)))for(e++;e<t.length&&p(t.charCodeAt(e));)e++;else return d=3,t.substring(ie,e);let he=e;if(e<t.length&&(t.charCodeAt(e)===69||t.charCodeAt(e)===101))if(e++,(e<t.length&&t.charCodeAt(e)===43||t.charCodeAt(e)===45)&&e++,e<t.length&&p(t.charCodeAt(e))){for(e++;e<t.length&&p(t.charCodeAt(e));)e++;he=e}else d=3;return t.substring(ie,he)}function _(){let ie="",he=e;for(;;){if(e>=n){ie+=t.substring(he,e),d=2;break}const j=t.charCodeAt(e);if(j===34){ie+=t.substring(he,e),e++;break}if(j===92){if(ie+=t.substring(he,e),e++,e>=n){d=2;break}switch(t.charCodeAt(e++)){case 34:ie+='"';break;case 92:ie+="\\";break;case 47:ie+="/";break;case 98:ie+="\b";break;case 102:ie+="\f";break;case 110:ie+=`
`;break;case 114:ie+="\r";break;case 116:ie+="	";break;case 117:{const se=w(4);se>=0?ie+=String.fromCharCode(se):d=4;break}default:d=5}he=e;continue}if(j>=0&&j<=31)if(c(j)){ie+=t.substring(he,e),d=2;break}else d=6;e++}return ie}function Y(){if(s="",d=0,l=e,e>=n)return l=n,u=17;let ie=t.charCodeAt(e);if(I(ie)){do e++,s+=String.fromCharCode(ie),ie=t.charCodeAt(e);while(I(ie));return u=15}if(c(ie))return e++,s+=String.fromCharCode(ie),ie===13&&t.charCodeAt(e)===10&&(e++,s+=`
`),u=14;switch(ie){case 123:return e++,u=1;case 125:return e++,u=2;case 91:return e++,u=3;case 93:return e++,u=4;case 58:return e++,u=6;case 44:return e++,u=5;case 34:return e++,s=_(),u=10;case 47:{const he=e-1;if(t.charCodeAt(e+1)===47){for(e+=2;e<n&&!c(t.charCodeAt(e));)e++;return s=t.substring(he,e),u=12}if(t.charCodeAt(e+1)===42){e+=2;const j=n-1;let q=!1;for(;e<j;){if(t.charCodeAt(e)===42&&t.charCodeAt(e+1)===47){e+=2,q=!0;break}e++}return q||(e++,d=1),s=t.substring(he,e),u=13}return s+=String.fromCharCode(ie),e++,u=16}case 45:if(s+=String.fromCharCode(ie),e++,e===n||!p(t.charCodeAt(e)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=N(),u=11;default:for(;e<n&&re(ie);)e++,ie=t.charCodeAt(e);if(l!==e){switch(s=t.substring(l,e),s){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return s+=String.fromCharCode(ie),e++,u=16}}function re(ie){if(I(ie)||c(ie))return!1;switch(ie){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function te(){let ie;do ie=Y();while(ie>=12&&ie<=15);return ie}return{setPosition:T,getPosition:()=>e,scan:r?te:Y,getToken:()=>u,getTokenValue:()=>s,getTokenOffset:()=>l,getTokenLength:()=>e-l,getTokenError:()=>d}}i.createScanner=L;function I(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function c(t){return t===10||t===13||t===8232||t===8233}function p(t){return t>=48&&t<=57}var b;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(b||(b={}));function O(t,r){const e=[],n=new Object;let s;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function d(w,T,N,_){l.value=w,l.offset=T,l.length=N,l.type=_,l.colonOffset=void 0,s=l}try{E(t,{onObjectBegin:(w,T)=>{if(r<=w)throw n;s=void 0,u=r>w,e.push("")},onObjectProperty:(w,T,N)=>{if(r<T||(d(w,T,N,"property"),e[e.length-1]=w,r<=T+N))throw n},onObjectEnd:(w,T)=>{if(r<=w)throw n;s=void 0,e.pop()},onArrayBegin:(w,T)=>{if(r<=w)throw n;s=void 0,e.push(0)},onArrayEnd:(w,T)=>{if(r<=w)throw n;s=void 0,e.pop()},onLiteralValue:(w,T,N)=>{if(r<T||(d(w,T,N,o(w)),r<=T+N))throw n},onSeparator:(w,T,N)=>{if(r<=T)throw n;if(w===":"&&s&&s.type==="property")s.colonOffset=T,u=!1,s=void 0;else if(w===","){const _=e[e.length-1];typeof _=="number"?e[e.length-1]=_+1:(u=!0,e[e.length-1]=""),s=void 0}}})}catch(w){if(w!==n)throw w}return{path:e,previousNode:s,isAtPropertyKey:u,matches:w=>{let T=0;for(let N=0;T<w.length&&N<e.length;N++)if(w[T]===e[N]||w[T]==="*")T++;else if(w[T]!=="**")return!1;return T===w.length}}}i.getLocation=O;function h(t,r=[],e=R.DEFAULT){let n=null,s=[];const l=[];function u(w){Array.isArray(s)?s.push(w):n!==null&&(s[n]=w)}return E(t,{onObjectBegin:()=>{const w={};u(w),l.push(s),s=w,n=null},onObjectProperty:w=>{n=w},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const w=[];u(w),l.push(s),s=w,n=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:u,onError:(w,T,N)=>{r.push({error:w,offset:T,length:N})}},e),s[0]}i.parse=h;function S(t,r=[],e=R.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(w){n.type==="property"&&(n.length=w-n.offset,n=n.parent)}function l(w){return n.children.push(w),w}E(t,{onObjectBegin:w=>{n=l({type:"object",offset:w,length:-1,parent:n,children:[]})},onObjectProperty:(w,T,N)=>{n=l({type:"property",offset:T,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:w,offset:T,length:N,parent:n})},onObjectEnd:(w,T)=>{n.length=w+T-n.offset,n=n.parent,s(w+T)},onArrayBegin:(w,T)=>{n=l({type:"array",offset:w,length:-1,parent:n,children:[]})},onArrayEnd:(w,T)=>{n.length=w+T-n.offset,n=n.parent,s(w+T)},onLiteralValue:(w,T,N)=>{l({type:o(w),offset:T,length:N,parent:n,value:w}),s(T+N)},onSeparator:(w,T,N)=>{n.type==="property"&&(w===":"?n.colonOffset=T:w===","&&s(T))},onError:(w,T,N)=>{r.push({error:w,offset:T,length:N})}},e);const d=n.children[0];return d&&delete d.parent,d}i.parseTree=S;function y(t,r){if(!t)return;let e=t;for(let n of r)if(typeof n=="string"){if(e.type!=="object"||!Array.isArray(e.children))return;let s=!1;for(const l of e.children)if(Array.isArray(l.children)&&l.children[0].value===n){e=l.children[1],s=!0;break}if(!s)return}else{const s=n;if(e.type!=="array"||s<0||!Array.isArray(e.children)||s>=e.children.length)return;e=e.children[s]}return e}i.findNodeAtLocation=y;function g(t){if(!t.parent||!t.parent.children)return[];const r=g(t.parent);if(t.parent.type==="property"){const e=t.parent.children[0].value;r.push(e)}else if(t.parent.type==="array"){const e=t.parent.children.indexOf(t);e!==-1&&r.push(e)}return r}i.getNodePath=g;function a(t){switch(t.type){case"array":return t.children.map(a);case"object":{const r=Object.create(null);for(let e of t.children){const n=e.children[1];n&&(r[e.children[0].value]=a(n))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}i.getNodeValue=a;function f(t,r,e=!1){return r>=t.offset&&r<t.offset+t.length||e&&r===t.offset+t.length}i.contains=f;function m(t,r,e=!1){if(f(t,r,e)){const n=t.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=r;s++){const l=m(n[s],r,e);if(l)return l}return t}}i.findNodeAtOffset=m;function E(t,r,e=R.DEFAULT){const n=L(t,!1);function s(J){return J?()=>J(n.getTokenOffset(),n.getTokenLength()):()=>!0}function l(J){return J?ee=>J(ee,n.getTokenOffset(),n.getTokenLength()):()=>!0}const u=s(r.onObjectBegin),d=l(r.onObjectProperty),w=s(r.onObjectEnd),T=s(r.onArrayBegin),N=s(r.onArrayEnd),_=l(r.onLiteralValue),Y=l(r.onSeparator),re=s(r.onComment),te=l(r.onError),ie=e&&e.disallowComments,he=e&&e.allowTrailingComma;function j(){for(;;){const J=n.scan();switch(n.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:ie||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(J){case 12:case 13:ie?q(10):re();break;case 16:q(1);break;case 15:case 14:break;default:return J}}}function q(J,ee=[],G=[]){if(te(J),ee.length+G.length>0){let U=n.getToken();for(;U!==17;){if(ee.indexOf(U)!==-1){j();break}else if(G.indexOf(U)!==-1)break;U=j()}}}function se(J){const ee=n.getTokenValue();return J?_(ee):d(ee),j(),!0}function M(){switch(n.getToken()){case 11:{let J=0;try{J=JSON.parse(n.getTokenValue()),typeof J!="number"&&(q(2),J=0)}catch{q(2)}_(J);break}case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return j(),!0}function A(){return n.getToken()!==10?(q(3,[],[2,5]),!1):(se(!1),n.getToken()===6?(Y(":"),j(),ne()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function W(){u(),j();let J=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(J||q(4,[],[]),Y(","),j(),n.getToken()===2&&he)break}else J&&q(6,[],[]);A()||q(4,[],[2,5]),J=!0}return w(),n.getToken()!==2?q(7,[2],[]):j(),!0}function K(){T(),j();let J=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(J||q(4,[],[]),Y(","),j(),n.getToken()===4&&he)break}else J&&q(6,[],[]);ne()||q(4,[],[4,5]),J=!0}return N(),n.getToken()!==4?q(8,[4],[]):j(),!0}function ne(){switch(n.getToken()){case 3:return K();case 1:return W();case 10:return se(!0);default:return M()}}return j(),n.getToken()===17?e.allowEmptyContent?!0:(q(4,[],[]),!1):ne()?(n.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}i.visit=E;function v(t,r){let e=L(t),n=[],s,l=0,u;do switch(u=e.getPosition(),s=e.scan(),s){case 12:case 13:case 17:l!==u&&n.push(t.substring(l,u)),r!==void 0&&n.push(e.getTokenValue().replace(/[^\r\n]/g,r)),l=e.getPosition();break}while(s!==17);return n.join("")}i.stripComments=v;function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}i.getNodeType=o}),function(){function x(P){const R=[];typeof P=="number"&&R.push("code/timeOrigin",P);function L(c){R.push(c,Date.now())}function I(){const c=[];for(let p=0;p<R.length;p+=2)c.push({name:R[p],startTime:R[p+1]});return c}return{mark:L,getMarks:I}}function i(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const L of performance.getEntriesByType("mark"))R.push({name:L.name,startTime:Math.round(P+L.startTime)});return R}};if(typeof process=="object"){const P=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function C(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=i()),P.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=C(D))}(),define(Q[57],Z([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.sanitizeProcessEnvironment=i.TerminateResponseCode=i.Source=void 0;var C;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(C=i.Source||(i.Source={}));var D;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(D=i.TerminateResponseCode||(i.TerminateResponseCode={}));function P(R,...L){const I=L.reduce((b,O)=>(b[O]=!0,b),{}),c=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(b=>!I[b]).forEach(b=>{for(let O=0;O<c.length;O++)if(b.search(c[O])!==-1){delete R[b];break}})}i.sanitizeProcessEnvironment=P}),function(x,i){if(typeof exports=="object"&&typeof module=="object")module.exports=i();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],i);else{var C=i();for(var D in C)(typeof exports=="object"?exports:x)[D]=C[D]}}(typeof self!="undefined"?self:this,function(){return function(x){var i={};function C(D){if(i[D])return i[D].exports;var P=i[D]={i:D,l:!1,exports:{}};return x[D].call(P.exports,P,P.exports,C),P.l=!0,P.exports}return C.m=x,C.c=i,C.d=function(D,P,R){C.o(D,P)||Object.defineProperty(D,P,{enumerable:!0,get:R})},C.r=function(D){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},C.t=function(D,P){if(1&P&&(D=C(D)),8&P||4&P&&typeof D=="object"&&D&&D.__esModule)return D;var R=Object.create(null);if(C.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:D}),2&P&&typeof D!="string")for(var L in D)C.d(R,L,function(I){return D[I]}.bind(null,L));return R},C.n=function(D){var P=D&&D.__esModule?function(){return D.default}:function(){return D};return C.d(P,"a",P),P},C.o=function(D,P){return Object.prototype.hasOwnProperty.call(D,P)},C.p="",C(C.s=0)}([function(x,i,C){(function(D){var P;i=x.exports=G,P=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var F=Array.prototype.slice.call(arguments,0);F.unshift("SEMVER"),console.log.apply(console,F)}:function(){},i.SEMVER_SPEC_VERSION="2.0.0";var R=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,I=i.re=[],c=i.src=[],p=0,b=p++;c[b]="0|[1-9]\\d*";var O=p++;c[O]="[0-9]+";var h=p++;c[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=p++;c[S]="("+c[b]+")\\.("+c[b]+")\\.("+c[b]+")";var y=p++;c[y]="("+c[O]+")\\.("+c[O]+")\\.("+c[O]+")";var g=p++;c[g]="(?:"+c[b]+"|"+c[h]+")";var a=p++;c[a]="(?:"+c[O]+"|"+c[h]+")";var f=p++;c[f]="(?:-("+c[g]+"(?:\\."+c[g]+")*))";var m=p++;c[m]="(?:-?("+c[a]+"(?:\\."+c[a]+")*))";var E=p++;c[E]="[0-9A-Za-z-]+";var v=p++;c[v]="(?:\\+("+c[E]+"(?:\\."+c[E]+")*))";var o=p++,t="v?"+c[S]+c[f]+"?"+c[v]+"?";c[o]="^"+t+"$";var r="[v=\\s]*"+c[y]+c[m]+"?"+c[v]+"?",e=p++;c[e]="^"+r+"$";var n=p++;c[n]="((?:<|>)?=?)";var s=p++;c[s]=c[O]+"|x|X|\\*";var l=p++;c[l]=c[b]+"|x|X|\\*";var u=p++;c[u]="[v=\\s]*("+c[l]+")(?:\\.("+c[l]+")(?:\\.("+c[l]+")(?:"+c[f]+")?"+c[v]+"?)?)?";var d=p++;c[d]="[v=\\s]*("+c[s]+")(?:\\.("+c[s]+")(?:\\.("+c[s]+")(?:"+c[m]+")?"+c[v]+"?)?)?";var w=p++;c[w]="^"+c[n]+"\\s*"+c[u]+"$";var T=p++;c[T]="^"+c[n]+"\\s*"+c[d]+"$";var N=p++;c[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=p++;c[_]="(?:~>?)";var Y=p++;c[Y]="(\\s*)"+c[_]+"\\s+",I[Y]=new RegExp(c[Y],"g");var re=p++;c[re]="^"+c[_]+c[u]+"$";var te=p++;c[te]="^"+c[_]+c[d]+"$";var ie=p++;c[ie]="(?:\\^)";var he=p++;c[he]="(\\s*)"+c[ie]+"\\s+",I[he]=new RegExp(c[he],"g");var j=p++;c[j]="^"+c[ie]+c[u]+"$";var q=p++;c[q]="^"+c[ie]+c[d]+"$";var se=p++;c[se]="^"+c[n]+"\\s*("+r+")$|^$";var M=p++;c[M]="^"+c[n]+"\\s*("+t+")$|^$";var A=p++;c[A]="(\\s*)"+c[n]+"\\s*("+r+"|"+c[u]+")",I[A]=new RegExp(c[A],"g");var W=p++;c[W]="^\\s*("+c[u]+")\\s+-\\s+("+c[u]+")\\s*$";var K=p++;c[K]="^\\s*("+c[d]+")\\s+-\\s+("+c[d]+")\\s*$";var ne=p++;c[ne]="(<|>)?=?\\s*\\*";for(var J=0;J<35;J++)P(J,c[J]),I[J]||(I[J]=new RegExp(c[J]));function ee(F,V){if(F instanceof G)return F;if(typeof F!="string"||F.length>R||!(V?I[e]:I[o]).test(F))return null;try{return new G(F,V)}catch{return null}}function G(F,V){if(F instanceof G){if(F.loose===V)return F;F=F.version}else if(typeof F!="string")throw new TypeError("Invalid Version: "+F);if(F.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof G))return new G(F,V);P("SemVer",F,V),this.loose=V;var $=F.trim().match(V?I[e]:I[o]);if(!$)throw new TypeError("Invalid Version: "+F);if(this.raw=F,this.major=+$[1],this.minor=+$[2],this.patch=+$[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");$[4]?this.prerelease=$[4].split(".").map(function(ce){if(/^[0-9]+$/.test(ce)){var de=+ce;if(de>=0&&de<L)return de}return ce}):this.prerelease=[],this.build=$[5]?$[5].split("."):[],this.format()}i.parse=ee,i.valid=function(F,V){var $=ee(F,V);return $?$.version:null},i.clean=function(F,V){var $=ee(F.trim().replace(/^[=v]+/,""),V);return $?$.version:null},i.SemVer=G,G.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},G.prototype.toString=function(){return this.version},G.prototype.compare=function(F){return P("SemVer.compare",this.version,this.loose,F),F instanceof G||(F=new G(F,this.loose)),this.compareMain(F)||this.comparePre(F)},G.prototype.compareMain=function(F){return F instanceof G||(F=new G(F,this.loose)),k(this.major,F.major)||k(this.minor,F.minor)||k(this.patch,F.patch)},G.prototype.comparePre=function(F){if(F instanceof G||(F=new G(F,this.loose)),this.prerelease.length&&!F.prerelease.length)return-1;if(!this.prerelease.length&&F.prerelease.length)return 1;if(!this.prerelease.length&&!F.prerelease.length)return 0;var V=0;do{var $=this.prerelease[V],ce=F.prerelease[V];if(P("prerelease compare",V,$,ce),$===void 0&&ce===void 0)return 0;if(ce===void 0)return 1;if($===void 0)return-1;if($!==ce)return k($,ce)}while(++V)},G.prototype.inc=function(F,V){switch(F){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",V);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",V);break;case"prepatch":this.prerelease.length=0,this.inc("patch",V),this.inc("pre",V);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",V),this.inc("pre",V);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var $=this.prerelease.length;--$>=0;)typeof this.prerelease[$]=="number"&&(this.prerelease[$]++,$=-2);$===-1&&this.prerelease.push(0)}V&&(this.prerelease[0]===V?isNaN(this.prerelease[1])&&(this.prerelease=[V,0]):this.prerelease=[V,0]);break;default:throw new Error("invalid increment argument: "+F)}return this.format(),this.raw=this.version,this},i.inc=function(F,V,$,ce){typeof $=="string"&&(ce=$,$=void 0);try{return new G(F,$).inc(V,ce).version}catch{return null}},i.diff=function(F,V){if(X(F,V))return null;var $=ee(F),ce=ee(V);if($.prerelease.length||ce.prerelease.length){for(var de in $)if((de==="major"||de==="minor"||de==="patch")&&$[de]!==ce[de])return"pre"+de;return"prerelease"}for(var de in $)if((de==="major"||de==="minor"||de==="patch")&&$[de]!==ce[de])return de},i.compareIdentifiers=k;var U=/^[0-9]+$/;function k(F,V){var $=U.test(F),ce=U.test(V);return $&&ce&&(F=+F,V=+V),$&&!ce?-1:ce&&!$?1:F<V?-1:F>V?1:0}function z(F,V,$){return new G(F,$).compare(new G(V,$))}function B(F,V,$){return z(F,V,$)>0}function H(F,V,$){return z(F,V,$)<0}function X(F,V,$){return z(F,V,$)===0}function le(F,V,$){return z(F,V,$)!==0}function ue(F,V,$){return z(F,V,$)>=0}function ye(F,V,$){return z(F,V,$)<=0}function fe(F,V,$,ce){var de;switch(V){case"===":typeof F=="object"&&(F=F.version),typeof $=="object"&&($=$.version),de=F===$;break;case"!==":typeof F=="object"&&(F=F.version),typeof $=="object"&&($=$.version),de=F!==$;break;case"":case"=":case"==":de=X(F,$,ce);break;case"!=":de=le(F,$,ce);break;case">":de=B(F,$,ce);break;case">=":de=ue(F,$,ce);break;case"<":de=H(F,$,ce);break;case"<=":de=ye(F,$,ce);break;default:throw new TypeError("Invalid operator: "+V)}return de}function oe(F,V){if(F instanceof oe){if(F.loose===V)return F;F=F.value}if(!(this instanceof oe))return new oe(F,V);P("comparator",F,V),this.loose=V,this.parse(F),this.semver===pe?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}i.rcompareIdentifiers=function(F,V){return k(V,F)},i.major=function(F,V){return new G(F,V).major},i.minor=function(F,V){return new G(F,V).minor},i.patch=function(F,V){return new G(F,V).patch},i.compare=z,i.compareLoose=function(F,V){return z(F,V,!0)},i.rcompare=function(F,V,$){return z(V,F,$)},i.sort=function(F,V){return F.sort(function($,ce){return i.compare($,ce,V)})},i.rsort=function(F,V){return F.sort(function($,ce){return i.rcompare($,ce,V)})},i.gt=B,i.lt=H,i.eq=X,i.neq=le,i.gte=ue,i.lte=ye,i.cmp=fe,i.Comparator=oe;var pe={};function me(F,V){if(F instanceof me)return F.loose===V?F:new me(F.raw,V);if(F instanceof oe)return new me(F.value,V);if(!(this instanceof me))return new me(F,V);if(this.loose=V,this.raw=F,this.set=F.split(/\s*\|\|\s*/).map(function($){return this.parseRange($.trim())},this).filter(function($){return $.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+F);this.format()}function Ee(F){return!F||F.toLowerCase()==="x"||F==="*"}function Ie(F,V,$,ce,de,Ce,Se,ke,Re,Oe,Ne,De,Le){return((V=Ee($)?"":Ee(ce)?">="+$+".0.0":Ee(de)?">="+$+"."+ce+".0":">="+V)+" "+(ke=Ee(Re)?"":Ee(Oe)?"<"+(+Re+1)+".0.0":Ee(Ne)?"<"+Re+"."+(+Oe+1)+".0":De?"<="+Re+"."+Oe+"."+Ne+"-"+De:"<="+ke)).trim()}function Me(F,V){for(var $=0;$<F.length;$++)if(!F[$].test(V))return!1;if(V.prerelease.length){for($=0;$<F.length;$++)if(P(F[$].semver),F[$].semver!==pe&&F[$].semver.prerelease.length>0){var ce=F[$].semver;if(ce.major===V.major&&ce.minor===V.minor&&ce.patch===V.patch)return!0}return!1}return!0}function xe(F,V,$){try{V=new me(V,$)}catch{return!1}return V.test(F)}function Ve(F,V,$,ce){var de,Ce,Se,ke,Re;switch(F=new G(F,ce),V=new me(V,ce),$){case">":de=B,Ce=ye,Se=H,ke=">",Re=">=";break;case"<":de=H,Ce=ue,Se=B,ke="<",Re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(xe(F,V,ce))return!1;for(var Oe=0;Oe<V.set.length;++Oe){var Ne=V.set[Oe],De=null,Le=null;if(Ne.forEach(function(Ae){Ae.semver===pe&&(Ae=new oe(">=0.0.0")),De=De||Ae,Le=Le||Ae,de(Ae.semver,De.semver,ce)?De=Ae:Se(Ae.semver,Le.semver,ce)&&(Le=Ae)}),De.operator===ke||De.operator===Re||(!Le.operator||Le.operator===ke)&&Ce(F,Le.semver)||Le.operator===Re&&Se(F,Le.semver))return!1}return!0}oe.prototype.parse=function(F){var V=this.loose?I[se]:I[M],$=F.match(V);if(!$)throw new TypeError("Invalid comparator: "+F);this.operator=$[1],this.operator==="="&&(this.operator=""),$[2]?this.semver=new G($[2],this.loose):this.semver=pe},oe.prototype.toString=function(){return this.value},oe.prototype.test=function(F){return P("Comparator.test",F,this.loose),this.semver===pe||(typeof F=="string"&&(F=new G(F,this.loose)),fe(F,this.operator,this.semver,this.loose))},oe.prototype.intersects=function(F,V){if(!(F instanceof oe))throw new TypeError("a Comparator is required");var $;if(this.operator==="")return $=new me(F.value,V),xe(this.value,$,V);if(F.operator==="")return $=new me(this.value,V),xe(F.semver,$,V);var ce=!(this.operator!==">="&&this.operator!==">"||F.operator!==">="&&F.operator!==">"),de=!(this.operator!=="<="&&this.operator!=="<"||F.operator!=="<="&&F.operator!=="<"),Ce=this.semver.version===F.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||F.operator!==">="&&F.operator!=="<="),ke=fe(this.semver,"<",F.semver,V)&&(this.operator===">="||this.operator===">")&&(F.operator==="<="||F.operator==="<"),Re=fe(this.semver,">",F.semver,V)&&(this.operator==="<="||this.operator==="<")&&(F.operator===">="||F.operator===">");return ce||de||Ce&&Se||ke||Re},i.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(F){return F.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(F){var V=this.loose;F=F.trim(),P("range",F,V);var $=V?I[K]:I[W];F=F.replace($,Ie),P("hyphen replace",F),F=F.replace(I[A],"$1$2$3"),P("comparator trim",F,I[A]),F=(F=(F=F.replace(I[Y],"$1~")).replace(I[he],"$1^")).split(/\s+/).join(" ");var ce=V?I[se]:I[M],de=F.split(" ").map(function(Ce){return function(Se,ke){return P("comp",Se),Se=function(Re,Oe){return Re.trim().split(/\s+/).map(function(Ne){return function(De,Le){P("caret",De,Le);var Ae=Le?I[q]:I[j];return De.replace(Ae,function(Fe,ve,we,be,Pe){var Te;return P("caret",De,Fe,ve,we,be,Pe),Ee(ve)?Te="":Ee(we)?Te=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ee(be)?Te=ve==="0"?">="+ve+"."+we+".0 <"+ve+"."+(+we+1)+".0":">="+ve+"."+we+".0 <"+(+ve+1)+".0.0":Pe?(P("replaceCaret pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Te=ve==="0"?we==="0"?">="+ve+"."+we+"."+be+Pe+" <"+ve+"."+we+"."+(+be+1):">="+ve+"."+we+"."+be+Pe+" <"+ve+"."+(+we+1)+".0":">="+ve+"."+we+"."+be+Pe+" <"+(+ve+1)+".0.0"):(P("no pr"),Te=ve==="0"?we==="0"?">="+ve+"."+we+"."+be+" <"+ve+"."+we+"."+(+be+1):">="+ve+"."+we+"."+be+" <"+ve+"."+(+we+1)+".0":">="+ve+"."+we+"."+be+" <"+(+ve+1)+".0.0"),P("caret return",Te),Te})}(Ne,Oe)}).join(" ")}(Se,ke),P("caret",Se),Se=function(Re,Oe){return Re.trim().split(/\s+/).map(function(Ne){return function(De,Le){var Ae=Le?I[te]:I[re];return De.replace(Ae,function(Fe,ve,we,be,Pe){var Te;return P("tilde",De,Fe,ve,we,be,Pe),Ee(ve)?Te="":Ee(we)?Te=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ee(be)?Te=">="+ve+"."+we+".0 <"+ve+"."+(+we+1)+".0":Pe?(P("replaceTilde pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Te=">="+ve+"."+we+"."+be+Pe+" <"+ve+"."+(+we+1)+".0"):Te=">="+ve+"."+we+"."+be+" <"+ve+"."+(+we+1)+".0",P("tilde return",Te),Te})}(Ne,Oe)}).join(" ")}(Se,ke),P("tildes",Se),Se=function(Re,Oe){return P("replaceXRanges",Re,Oe),Re.split(/\s+/).map(function(Ne){return function(De,Le){De=De.trim();var Ae=Le?I[T]:I[w];return De.replace(Ae,function(Fe,ve,we,be,Pe,Te){P("xRange",De,Fe,ve,we,be,Pe,Te);var je=Ee(we),Ue=je||Ee(be),ze=Ue||Ee(Pe);return ve==="="&&ze&&(ve=""),je?Fe=ve===">"||ve==="<"?"<0.0.0":"*":ve&&ze?(Ue&&(be=0),ze&&(Pe=0),ve===">"?(ve=">=",Ue?(we=+we+1,be=0,Pe=0):ze&&(be=+be+1,Pe=0)):ve==="<="&&(ve="<",Ue?we=+we+1:be=+be+1),Fe=ve+we+"."+be+"."+Pe):Ue?Fe=">="+we+".0.0 <"+(+we+1)+".0.0":ze&&(Fe=">="+we+"."+be+".0 <"+we+"."+(+be+1)+".0"),P("xRange return",Fe),Fe})}(Ne,Oe)}).join(" ")}(Se,ke),P("xrange",Se),Se=function(Re,Oe){return P("replaceStars",Re,Oe),Re.trim().replace(I[ne],"")}(Se,ke),P("stars",Se),Se}(Ce,V)}).join(" ").split(/\s+/);return this.loose&&(de=de.filter(function(Ce){return!!Ce.match(ce)})),de=de.map(function(Ce){return new oe(Ce,V)})},me.prototype.intersects=function(F,V){if(!(F instanceof me))throw new TypeError("a Range is required");return this.set.some(function($){return $.every(function(ce){return F.set.some(function(de){return de.every(function(Ce){return ce.intersects(Ce,V)})})})})},i.toComparators=function(F,V){return new me(F,V).set.map(function($){return $.map(function(ce){return ce.value}).join(" ").trim().split(" ")})},me.prototype.test=function(F){if(!F)return!1;typeof F=="string"&&(F=new G(F,this.loose));for(var V=0;V<this.set.length;V++)if(Me(this.set[V],F))return!0;return!1},i.satisfies=xe,i.maxSatisfying=function(F,V,$){var ce=null,de=null;try{var Ce=new me(V,$)}catch{return null}return F.forEach(function(Se){Ce.test(Se)&&(ce&&de.compare(Se)!==-1||(de=new G(ce=Se,$)))}),ce},i.minSatisfying=function(F,V,$){var ce=null,de=null;try{var Ce=new me(V,$)}catch{return null}return F.forEach(function(Se){Ce.test(Se)&&(ce&&de.compare(Se)!==1||(de=new G(ce=Se,$)))}),ce},i.validRange=function(F,V){try{return new me(F,V).range||"*"}catch{return null}},i.ltr=function(F,V,$){return Ve(F,V,"<",$)},i.gtr=function(F,V,$){return Ve(F,V,">",$)},i.outside=Ve,i.prerelease=function(F,V){var $=ee(F,V);return $&&$.prerelease.length?$.prerelease:null},i.intersects=function(F,V,$){return F=new me(F,$),V=new me(V,$),F.intersects(V)},i.coerce=function(F){if(F instanceof G)return F;if(typeof F!="string")return null;var V=F.match(I[N]);return V==null?null:ee((V[1]||"0")+"."+(V[2]||"0")+"."+(V[3]||"0"))}}).call(this,C(1))},function(x,i){var C,D,P=x.exports={};function R(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function I(a){if(C===setTimeout)return setTimeout(a,0);if((C===R||!C)&&setTimeout)return C=setTimeout,setTimeout(a,0);try{return C(a,0)}catch{try{return C.call(null,a,0)}catch{return C.call(this,a,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:R}catch{C=R}try{D=typeof clearTimeout=="function"?clearTimeout:L}catch{D=L}})();var c,p=[],b=!1,O=-1;function h(){b&&c&&(b=!1,c.length?p=c.concat(p):O=-1,p.length&&S())}function S(){if(!b){var a=I(h);b=!0;for(var f=p.length;f;){for(c=p,p=[];++O<f;)c&&c[O].run();O=-1,f=p.length}c=null,b=!1,function(m){if(D===clearTimeout)return clearTimeout(m);if((D===L||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(m);try{D(m)}catch{try{return D.call(null,m)}catch{return D.call(this,m)}}}(a)}}function y(a,f){this.fun=a,this.array=f}function g(){}P.nextTick=function(a){var f=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)f[m-1]=arguments[m];p.push(new y(a,f)),p.length!==1||b||I(S)},y.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=g,P.addListener=g,P.once=g,P.off=g,P.removeListener=g,P.removeAllListeners=g,P.emit=g,P.prependListener=g,P.prependOnceListener=g,P.listeners=function(a){return[]},P.binding=function(a){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(a){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Q[58],Z([0,1]),function(x,i){"use strict";var C;Object.defineProperty(i,"__esModule",{value:!0}),i.SkipList=void 0;class D{constructor(I,c,p){this.level=I,this.key=c,this.value=p,this.forward=[]}}const P=void 0;class R{constructor(I,c=2**16){this.comparator=I,this[C]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(c)|0),this._header=new D(this._maxLevel,P,P)}get size(){return this._size}clear(){this._header=new D(this._maxLevel,P,P)}has(I){return Boolean(R._search(this,I,this.comparator))}get(I){return R._search(this,I,this.comparator)?.value}set(I,c){return R._insert(this,I,c,this.comparator)&&(this._size+=1),this}delete(I){const c=R._delete(this,I,this.comparator);return c&&(this._size-=1),c}forEach(I,c){let p=this._header.forward[0];for(;p;)I.call(c,p.value,p.key,this),p=p.forward[0]}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this._header.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this._header.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this._header.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",c=this._header.forward[0];for(;c;)I+=`node(${c.key}, ${c.value}, lvl:${c.level})`,c=c.forward[0];return I}static _search(I,c,p){let b=I._header;for(let O=I._level-1;O>=0;O--)for(;b.forward[O]&&p(b.forward[O].key,c)<0;)b=b.forward[O];if(b=b.forward[0],b&&p(b.key,c)===0)return b}static _insert(I,c,p,b){let O=[],h=I._header;for(let S=I._level-1;S>=0;S--){for(;h.forward[S]&&b(h.forward[S].key,c)<0;)h=h.forward[S];O[S]=h}if(h=h.forward[0],h&&b(h.key,c)===0)return h.value=p,!1;{let S=R._randomLevel(I);if(S>I._level){for(let y=I._level;y<S;y++)O[y]=I._header;I._level=S}h=new D(S,c,p);for(let y=0;y<S;y++)h.forward[y]=O[y].forward[y],O[y].forward[y]=h;return!0}}static _randomLevel(I,c=.5){let p=1;for(;Math.random()<c&&p<I._maxLevel;)p+=1;return p}static _delete(I,c,p){let b=[],O=I._header;for(let h=I._level-1;h>=0;h--){for(;O.forward[h]&&p(O.forward[h].key,c)<0;)O=O.forward[h];b[h]=O}if(O=O.forward[0],!O||p(O.key,c)!==0)return!1;for(let h=0;h<I._level&&b[h].forward[h]===O;h++)b[h].forward[h]=O.forward[h];for(;I._level>0&&I._header.forward[I._level-1]===P;)I._level-=1;return!0}}i.SkipList=R}),define(Q[37],Z([0,1,7,2]),function(x,i,C,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.prefixedStream=i.prefixedReadable=i.transform=i.toReadable=i.emptyStream=i.toStream=i.peekStream=i.listenStream=i.consumeStream=i.peekReadable=i.consumeReadable=i.newWriteableStream=i.isReadableBufferedStream=i.isReadableStream=void 0;function P(E){const v=E;return v?[v.on,v.pause,v.resume,v.destroy].every(o=>typeof o=="function"):!1}i.isReadableStream=P;function R(E){const v=E;return v?P(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}i.isReadableBufferedStream=R;function L(E,v){return new I(E,v)}i.newWriteableStream=L;class I{constructor(v,o){this.reducer=v,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(v){if(!this.state.destroyed){if(this.state.flowing)this.emitData(v);else if(this.buffer.data.push(v),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(v){this.state.destroyed||(this.state.flowing?this.emitError(v):this.buffer.error.push(v))}end(v){this.state.destroyed||(typeof v!="undefined"&&this.write(v),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(v){this.listeners.data.slice(0).forEach(o=>o(v))}emitError(v){this.listeners.error.length===0?(0,C.onUnexpectedError)(v):this.listeners.error.slice(0).forEach(o=>o(v))}emitEnd(){this.listeners.end.slice(0).forEach(v=>v())}on(v,o){if(!this.state.destroyed)switch(v){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(v,o){if(this.state.destroyed)return;let t;switch(v){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(o);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const v=this.reducer(this.buffer.data);this.emitData(v),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const v of this.buffer.error)this.emitError(v);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function c(E,v){const o=[];let t;for(;(t=E.read())!==null;)o.push(t);return v(o)}i.consumeReadable=c;function p(E,v,o){const t=[];let r;for(;(r=E.read())!==null&&t.length<o;)t.push(r);return r===null&&t.length>0?v(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const e=r;return r=void 0,e}return E.read()}}}i.peekReadable=p;function b(E,v){return new Promise((o,t)=>{const r=[];O(E,{onData:e=>{v&&r.push(e)},onError:e=>{v?t(e):o(void 0)},onEnd:()=>{o(v?v(r):void 0)}})})}i.consumeStream=b;function O(E,v){let o=!1;return E.on("error",t=>{o||v.onError(t)}),E.on("end",()=>{o||v.onEnd()}),E.on("data",t=>{o||v.onData(t)}),(0,D.toDisposable)(()=>o=!0)}i.listenStream=O;function h(E,v){return new Promise((o,t)=>{const r=new D.DisposableStore,e=[],n=u=>{if(e.push(u),e.length>v)return r.dispose(),E.pause(),o({stream:E,buffer:e,ended:!1})},s=u=>t(u),l=()=>o({stream:E,buffer:e,ended:!0});r.add((0,D.toDisposable)(()=>E.removeListener("error",s))),E.on("error",s),r.add((0,D.toDisposable)(()=>E.removeListener("end",l))),E.on("end",l),r.add((0,D.toDisposable)(()=>E.removeListener("data",n))),E.on("data",n)})}i.peekStream=h;function S(E,v){const o=L(v);return o.end(E),o}i.toStream=S;function y(){const E=L(()=>{throw new Error("not supported")});return E.end(),E}i.emptyStream=y;function g(E){let v=!1;return{read:()=>v?null:(v=!0,E)}}i.toReadable=g;function a(E,v,o){const t=L(o);return O(E,{onData:r=>t.write(v.data(r)),onError:r=>t.error(v.error?v.error(r):r),onEnd:()=>t.end()}),t}i.transform=a;function f(E,v,o){let t=!1;return{read:()=>{const r=v.read();return t?r:(t=!0,r!==null?o([E,r]):E)}}}i.prefixedReadable=f;function m(E,v,o){let t=!1;const r=L(o);return O(v,{onData:e=>t?r.write(e):(t=!0,r.write(o([E,e]))),onError:e=>r.error(e),onEnd:()=>{t||(t=!0,r.write(E)),r.end()}}),r}i.prefixedStream=m}),define(Q[17],Z([0,1,37]),function(x,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.encodeBase64=i.decodeBase64=i.prefixedBufferStream=i.prefixedBufferReadable=i.newWriteableBufferStream=i.streamToBufferReadableStream=i.bufferToStream=i.bufferedStreamToBuffer=i.streamToBuffer=i.bufferToReadable=i.readableToBuffer=i.writeUInt8=i.readUInt8=i.writeUInt32LE=i.readUInt32LE=i.writeUInt32BE=i.readUInt32BE=i.writeUInt16LE=i.readUInt16LE=i.VSBuffer=void 0;const D=typeof Buffer!="undefined";let P,R;class L{constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}static alloc(d){return D?new L(Buffer.allocUnsafe(d)):new L(new Uint8Array(d))}static wrap(d){return D&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new L(d)}static fromString(d,w){return!(w?.dontUseNodeBuffer||!1)&&D?new L(Buffer.from(d)):(P||(P=new TextEncoder),new L(P.encode(d)))}static fromByteArray(d){const w=L.alloc(d.length);for(let T=0,N=d.length;T<N;T++)w.buffer[T]=d[T];return w}static concat(d,w){if(typeof w=="undefined"){w=0;for(let _=0,Y=d.length;_<Y;_++)w+=d[_].byteLength}const T=L.alloc(w);let N=0;for(let _=0,Y=d.length;_<Y;_++){const re=d[_];T.set(re,N),N+=re.byteLength}return T}clone(){const d=L.alloc(this.byteLength);return d.set(this),d}toString(){return D?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(d,w){return new L(this.buffer.subarray(d,w))}set(d,w){if(d instanceof L)this.buffer.set(d.buffer,w);else if(d instanceof Uint8Array)this.buffer.set(d,w);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),w);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),w);else throw new Error("Unkown argument 'array'")}readUInt32BE(d){return p(this.buffer,d)}writeUInt32BE(d,w){b(this.buffer,d,w)}readUInt32LE(d){return O(this.buffer,d)}writeUInt32LE(d,w){h(this.buffer,d,w)}readUInt8(d){return S(this.buffer,d)}writeUInt8(d,w){y(this.buffer,d,w)}}i.VSBuffer=L;function I(u,d){return u[d+0]<<0>>>0|u[d+1]<<8>>>0}i.readUInt16LE=I;function c(u,d,w){u[w+0]=d&255,d=d>>>8,u[w+1]=d&255}i.writeUInt16LE=c;function p(u,d){return u[d]*2**24+u[d+1]*2**16+u[d+2]*2**8+u[d+3]}i.readUInt32BE=p;function b(u,d,w){u[w+3]=d,d=d>>>8,u[w+2]=d,d=d>>>8,u[w+1]=d,d=d>>>8,u[w]=d}i.writeUInt32BE=b;function O(u,d){return u[d+0]<<0>>>0|u[d+1]<<8>>>0|u[d+2]<<16>>>0|u[d+3]<<24>>>0}i.readUInt32LE=O;function h(u,d,w){u[w+0]=d&255,d=d>>>8,u[w+1]=d&255,d=d>>>8,u[w+2]=d&255,d=d>>>8,u[w+3]=d&255}i.writeUInt32LE=h;function S(u,d){return u[d]}i.readUInt8=S;function y(u,d,w){u[w]=d}i.writeUInt8=y;function g(u){return C.consumeReadable(u,d=>L.concat(d))}i.readableToBuffer=g;function a(u){return C.toReadable(u)}i.bufferToReadable=a;function f(u){return C.consumeStream(u,d=>L.concat(d))}i.streamToBuffer=f;async function m(u){return u.ended?L.concat(u.buffer):L.concat([...u.buffer,await f(u.stream)])}i.bufferedStreamToBuffer=m;function E(u){return C.toStream(u,d=>L.concat(d))}i.bufferToStream=E;function v(u){return C.transform(u,{data:d=>typeof d=="string"?L.fromString(d):L.wrap(d)},d=>L.concat(d))}i.streamToBufferReadableStream=v;function o(u){return C.newWriteableStream(d=>L.concat(d),u)}i.newWriteableBufferStream=o;function t(u,d){return C.prefixedReadable(u,d,w=>L.concat(w))}i.prefixedBufferReadable=t;function r(u,d){return C.prefixedStream(u,d,w=>L.concat(w))}i.prefixedBufferStream=r;function e(u){let d=0,w=0,T=0;const N=new Uint8Array(Math.floor(u.length/4*3)),_=re=>{switch(w){case 3:N[T++]=d|re,w=0;break;case 2:N[T++]=d|re>>>2,d=re<<6,w=3;break;case 1:N[T++]=d|re>>>4,d=re<<4,w=2;break;default:d=re<<2,w=1}};for(let re=0;re<u.length;re++){const te=u.charCodeAt(re);if(te>=65&&te<=90)_(te-65);else if(te>=97&&te<=122)_(te-97+26);else if(te>=48&&te<=57)_(te-48+52);else if(te===43||te===45)_(62);else if(te===47||te===95)_(63);else{if(te===61)break;throw new SyntaxError(`Unexpected base64 character ${u[re]}`)}}const Y=T;for(;w>0;)_(0);return L.wrap(N).slice(0,Y)}i.decodeBase64=e;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:u},d=!0,w=!1){const T=w?s:n;let N="";const _=u.byteLength%3;let Y=0;for(;Y<u.byteLength-_;Y+=3){const re=u[Y+0],te=u[Y+1],ie=u[Y+2];N+=T[re>>>2],N+=T[(re<<4|te>>>4)&63],N+=T[(te<<2|ie>>>6)&63],N+=T[ie&63]}if(_===1){const re=u[Y+0];N+=T[re>>>2],N+=T[re<<4&63],d&&(N+="==")}else if(_===2){const re=u[Y+0],te=u[Y+1];N+=T[re>>>2],N+=T[(re<<4|te>>>4)&63],N+=T[te<<2&63],d&&(N+="=")}return N}i.encodeBase64=l}),define(Q[59],Z([0,1,26]),function(x,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.StringSHA1=i.toHexString=i.Hasher=i.stringHash=i.numberHash=i.doHash=i.hash=void 0;function D(f){return P(f,0)}i.hash=D;function P(f,m){switch(typeof f){case"object":return f===null?R(349,m):Array.isArray(f)?c(f,m):p(f,m);case"string":return I(f,m);case"boolean":return L(f,m);case"number":return R(f,m);case"undefined":return R(937,m);default:return R(617,m)}}i.doHash=P;function R(f,m){return(m<<5)-m+f|0}i.numberHash=R;function L(f,m){return R(f?433:863,m)}function I(f,m){m=R(149417,m);for(let E=0,v=f.length;E<v;E++)m=R(f.charCodeAt(E),m);return m}i.stringHash=I;function c(f,m){return m=R(104579,m),f.reduce((E,v)=>P(v,E),m)}function p(f,m){return m=R(181387,m),Object.keys(f).sort().reduce((E,v)=>(E=I(v,E),P(f[v],E)),m)}class b{constructor(){this._value=0}get value(){return this._value}hash(m){return this._value=P(m,this._value),this._value}}i.Hasher=b;var O;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(O||(O={}));function h(f,m,E=32){const v=E-m,o=~((1<<v)-1);return(f<<m|(o&f)>>>v)>>>0}function S(f,m=0,E=f.byteLength,v=0){for(let o=0;o<E;o++)f[m+o]=v}function y(f,m,E="0"){for(;f.length<m;)f=E+f;return f}function g(f,m=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(E=>E.toString(16).padStart(2,"0")).join(""):y((f>>>0).toString(16),m/4)}i.toHexString=g;class a{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(m){const E=m.length;if(E===0)return;const v=this._buff;let o=this._buffLen,t=this._leftoverHighSurrogate,r,e;for(t!==0?(r=t,e=-1,t=0):(r=m.charCodeAt(0),e=0);;){let n=r;if(C.isHighSurrogate(r))if(e+1<E){const s=m.charCodeAt(e+1);C.isLowSurrogate(s)?(e++,n=C.computeCodePoint(r,s)):n=65533}else{t=r;break}else C.isLowSurrogate(r)&&(n=65533);if(o=this._push(v,o,n),e++,e<E)r=m.charCodeAt(e);else break}this._buffLen=o,this._leftoverHighSurrogate=t}_push(m,E,v){return v<128?m[E++]=v:v<2048?(m[E++]=192|(v&1984)>>>6,m[E++]=128|(v&63)>>>0):v<65536?(m[E++]=224|(v&61440)>>>12,m[E++]=128|(v&4032)>>>6,m[E++]=128|(v&63)>>>0):(m[E++]=240|(v&1835008)>>>18,m[E++]=128|(v&258048)>>>12,m[E++]=128|(v&4032)>>>6,m[E++]=128|(v&63)>>>0),E>=64&&(this._step(),E-=64,this._totalLen+=64,m[0]=m[64+0],m[1]=m[64+1],m[2]=m[64+2]),E}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,S(this._buff,this._buffLen),this._buffLen>56&&(this._step(),S(this._buff));const m=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(m/4294967296),!1),this._buffDV.setUint32(60,m%4294967296,!1),this._step()}_step(){const m=a._bigBlock32,E=this._buffDV;for(let u=0;u<64;u+=4)m.setUint32(u,E.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)m.setUint32(u,h(m.getUint32(u-12,!1)^m.getUint32(u-32,!1)^m.getUint32(u-56,!1)^m.getUint32(u-64,!1),1),!1);let v=this._h0,o=this._h1,t=this._h2,r=this._h3,e=this._h4,n,s,l;for(let u=0;u<80;u++)u<20?(n=o&t|~o&r,s=1518500249):u<40?(n=o^t^r,s=1859775393):u<60?(n=o&t|o&r|t&r,s=2400959708):(n=o^t^r,s=3395469782),l=h(v,5)+n+e+s+m.getUint32(u*4,!1)&4294967295,e=r,r=t,t=h(o,30),o=v,v=l;this._h0=this._h0+v&4294967295,this._h1=this._h1+o&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+e&4294967295}}i.StringSHA1=a,a._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Q[21],Z([0,1,8]),function(x,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.filter=i.getCaseInsensitive=i.distinct=i.getOrDefault=i.safeStringify=i.equals=i.mixin=i.cloneAndChange=i.deepFreeze=i.deepClone=void 0;function D(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const a=Array.isArray(g)?[]:{};return Object.keys(g).forEach(f=>{g[f]&&typeof g[f]=="object"?a[f]=D(g[f]):a[f]=g[f]}),a}i.deepClone=D;function P(g){if(!g||typeof g!="object")return g;const a=[g];for(;a.length>0;){const f=a.shift();Object.freeze(f);for(const m in f)if(R.call(f,m)){const E=f[m];typeof E=="object"&&!Object.isFrozen(E)&&a.push(E)}}return g}i.deepFreeze=P;const R=Object.prototype.hasOwnProperty;function L(g,a){return I(g,a,new Set)}i.cloneAndChange=L;function I(g,a,f){if((0,C.isUndefinedOrNull)(g))return g;const m=a(g);if(typeof m!="undefined")return m;if((0,C.isArray)(g)){const E=[];for(const v of g)E.push(I(v,a,f));return E}if((0,C.isObject)(g)){if(f.has(g))throw new Error("Cannot clone recursive data-structure");f.add(g);const E={};for(let v in g)R.call(g,v)&&(E[v]=I(g[v],a,f));return f.delete(g),E}return g}function c(g,a,f=!0){return(0,C.isObject)(g)?((0,C.isObject)(a)&&Object.keys(a).forEach(m=>{m in g?f&&((0,C.isObject)(g[m])&&(0,C.isObject)(a[m])?c(g[m],a[m],f):g[m]=a[m]):g[m]=a[m]}),g):a}i.mixin=c;function p(g,a){if(g===a)return!0;if(g==null||a===null||a===void 0||typeof g!=typeof a||typeof g!="object"||Array.isArray(g)!==Array.isArray(a))return!1;let f,m;if(Array.isArray(g)){if(g.length!==a.length)return!1;for(f=0;f<g.length;f++)if(!p(g[f],a[f]))return!1}else{const E=[];for(m in g)E.push(m);E.sort();const v=[];for(m in a)v.push(m);if(v.sort(),!p(E,v))return!1;for(f=0;f<E.length;f++)if(!p(g[E[f]],a[E[f]]))return!1}return!0}i.equals=p;function b(g){const a=new Set;return JSON.stringify(g,(f,m)=>{if((0,C.isObject)(m)||Array.isArray(m)){if(a.has(m))return"[Circular]";a.add(m)}return m})}i.safeStringify=b;function O(g,a,f){const m=a(g);return typeof m=="undefined"?f:m}i.getOrDefault=O;function h(g,a){const f=Object.create(null);return!g||!a||Object.keys(a).forEach(E=>{const v=g[E],o=a[E];p(v,o)||(f[E]=o)}),f}i.distinct=h;function S(g,a){const f=a.toLowerCase(),m=Object.keys(g).find(E=>E.toLowerCase()===f);return m?g[m]:g[a]}i.getCaseInsensitive=S;function y(g,a){const f=Object.create(null);for(const[m,E]of Object.entries(g))a(m,E)&&(f[m]=E);return f}i.filter=y}),define(Q[60],Z([0,1,9]),function(x,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.log=i.getFirstFrame=i.parse=i.isRemoteConsoleLog=void 0;function D(p){const b=p;return b&&typeof b.type=="string"&&typeof b.severity=="string"}i.isRemoteConsoleLog=D;function P(p){const b=[];let O;try{const h=JSON.parse(p.arguments),S=h[h.length-1];S&&S.__$stack&&(h.pop(),O=S.__$stack),b.push(...h)}catch{b.push("Unable to log remote console arguments",p.arguments)}return{args:b,stack:O}}i.parse=P;function R(p){if(typeof p!="string")return R(P(p).stack);const b=p;if(b){const O=L(b),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(O||"");if(h&&h.length===4)return{uri:C.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}i.getFirstFrame=R;function L(p){if(!p)return p;const b=p.indexOf(`
`);return b===-1?p:p.substring(0,b)}function I(p,b){const{args:O,stack:h}=P(p),S=typeof O[0]=="string"&&O.length===1;let y=L(h);y&&(y=`(${y.trim()})`);let g=[];if(typeof O[0]=="string"?y&&S?g=[`%c[${b}] %c${O[0]} %c${y}`,c("blue"),c(""),c("grey")]:g=[`%c[${b}] %c${O[0]}`,c("blue"),c(""),...O.slice(1)]:g=[`%c[${b}]%`,c("blue"),...O],y&&!S&&g.push(y),typeof console[p.severity]!="function")throw new Error("Unknown console method");console[p.severity].apply(console,g)}i.log=I;function c(p){return`color: ${p}`}}),define(Q[61],Z([0,1,17,26,9]),function(x,i,C,D,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.revive=i.MarshalledId=i.parse=i.stringify=void 0;function R(b){return JSON.stringify(b,c)}i.stringify=R;function L(b){let O=JSON.parse(b);return O=p(O),O}i.parse=L;var I;(function(b){b[b.Uri=1]="Uri",b[b.Regexp=2]="Regexp",b[b.ScmResource=3]="ScmResource",b[b.ScmResourceGroup=4]="ScmResourceGroup",b[b.ScmProvider=5]="ScmProvider",b[b.CommentController=6]="CommentController",b[b.CommentThread=7]="CommentThread",b[b.CommentThreadReply=8]="CommentThreadReply",b[b.CommentNode=9]="CommentNode",b[b.CommentThreadNode=10]="CommentThreadNode",b[b.TimelineActionContext=11]="TimelineActionContext",b[b.NotebookCellActionContext=12]="NotebookCellActionContext",b[b.TestItemContext=13]="TestItemContext",b[b.Date=14]="Date"})(I=i.MarshalledId||(i.MarshalledId={}));function c(b,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,D.regExpFlags)(O)}:O}function p(b,O=0){if(!b||O>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return P.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 14:return new Date(b.source)}if(b instanceof C.VSBuffer||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let h=0;h<b.length;++h)b[h]=p(b[h],O+1);else for(const h in b)Object.hasOwnProperty.call(b,h)&&(b[h]=p(b[h],O+1))}return b}i.revive=p}),define(Q[62],Z([0,1,45,11,10,12,22,26,9]),function(x,i,C,D,P,R,L,I,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.splitName=i.unmnemonicLabel=i.mnemonicButtonLabel=i.mnemonicMenuLabel=i.template=i.shorten=i.untildify=i.tildify=i.normalizeDriveLetter=i.getBaseLabel=i.getPathLabel=void 0;function p(n,s,l){if(typeof n=="string"&&(n=c.URI.file(n)),l){const d=l.getWorkspaceFolder(n);if(d){const w=l.getWorkspace().folders.length>1;let T;if((0,L.isEqual)(d.uri,n)?T="":T=(0,L.relativePath)(d.uri,n),w){const N=d.name?d.name:(0,L.basename)(d.uri);T=T?N+" \u2022 "+T:N}return T}}if(n.scheme!==D.Schemas.file&&n.scheme!==D.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,C.hasDriveLetter)(n.fsPath))return(0,P.normalize)(O(n.fsPath));let u=(0,P.normalize)(n.fsPath);return!R.isWindows&&s?.userHome&&(u=S(u,s.userHome.fsPath)),u}i.getPathLabel=p;function b(n){if(!n)return;typeof n=="string"&&(n=c.URI.file(n));const s=(0,L.basename)(n)||(n.scheme===D.Schemas.file?n.fsPath:n.path);return R.isWindows&&(0,C.isRootOrDriveLetter)(s)?O(s):s}i.getBaseLabel=b;function O(n,s){return(0,C.hasDriveLetter)(n,s)?n.charAt(0).toUpperCase()+n.slice(1):n}i.normalizeDriveLetter=O;let h=Object.create(null);function S(n,s){if(R.isWindows||!n||!s)return n;let l=h.original===s?h.normalized:void 0;return l||(l=`${(0,I.rtrim)(s,P.posix.sep)}${P.posix.sep}`,h={original:s,normalized:l}),(R.isLinux?n.startsWith(l):(0,I.startsWithIgnoreCase)(n,l))&&(n=`~/${n.substr(l.length)}`),n}i.tildify=S;function y(n,s){return n.replace(/^~($|\/|\\)/,`${s}$1`)}i.untildify=y;const g="\u2026",a="\\\\",f="~";function m(n,s=P.sep){const l=new Array(n.length);let u=!1;for(let d=0;d<n.length;d++){let w=n[d];if(w===""){l[d]=`.${s}`;continue}if(!w){l[d]=w;continue}u=!0;let T="";w.indexOf(a)===0?(T=w.substr(0,w.indexOf(a)+a.length),w=w.substr(w.indexOf(a)+a.length)):w.indexOf(s)===0?(T=w.substr(0,w.indexOf(s)+s.length),w=w.substr(w.indexOf(s)+s.length)):w.indexOf(f)===0&&(T=w.substr(0,w.indexOf(f)+f.length),w=w.substr(w.indexOf(f)+f.length));const N=w.split(s);for(let _=1;u&&_<=N.length;_++)for(let Y=N.length-_;u&&Y>=0;Y--){u=!1;let re=N.slice(Y,Y+_).join(s);for(let te=0;!u&&te<n.length;te++)if(te!==d&&n[te]&&n[te].indexOf(re)>-1){const ie=Y+_===N.length,he=Y>0&&n[te].indexOf(s)>-1?s+re:re,j=n[te].endsWith(he);u=!ie||j}if(!u){let te="";(N[0].endsWith(":")||T!=="")&&(Y===1&&(Y=0,_++,re=N[0]+s+re),Y>0&&(te=N[0]+s),te=T+te),Y>0&&(te=te+g+s),te=te+re,Y+_<N.length&&(te=te+s+g),l[d]=te}}u&&(l[d]=w)}return l}i.shorten=m;var E;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(E||(E={}));function v(n,s=Object.create(null)){const l=[];let u=!1,d="";for(const w of n)if(w==="$"||u&&w==="{")d&&l.push({value:d,type:E.TEXT}),d="",u=!0;else if(w==="}"&&u){const T=s[d];if(typeof T=="string")T.length&&l.push({value:T,type:E.VARIABLE});else if(T){const N=l[l.length-1];(!N||N.type!==E.SEPARATOR)&&l.push({value:T.label,type:E.SEPARATOR})}d="",u=!1}else d+=w;return d&&!u&&l.push({value:d,type:E.TEXT}),l.filter((w,T)=>{if(w.type===E.SEPARATOR){const N=l[T-1],_=l[T+1];return[N,_].every(Y=>Y&&(Y.type===E.VARIABLE||Y.type===E.TEXT)&&Y.value.length>0)}return!0}).map(w=>w.value).join("")}i.template=v;function o(n,s){return R.isMacintosh||s?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):n.replace(/&&|&/g,l=>l==="&"?"&&":"&")}i.mnemonicMenuLabel=o;function t(n,s){return R.isMacintosh||s?n.replace(/\(&&\w\)|&&/g,""):R.isWindows?n.replace(/&&|&/g,l=>l==="&"?"&&":"&"):n.replace(/&&/g,"_")}i.mnemonicButtonLabel=t;function r(n){return n.replace(/&/g,"&&")}i.unmnemonicLabel=r;function e(n){const s=n.indexOf("/")!==-1?P.posix:P.win32,l=s.basename(n),u=s.dirname(n);return l.length?{name:l,parentPath:u}:{name:u,parentPath:""}}i.splitName=e}),define(Q[27],Z([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.generateUuid=i.isUUID=void 0;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(c){return C.test(c)}i.isUUID=D;const P=new Uint8Array(16),R=[];for(let c=0;c<256;c++)R.push(c.toString(16).padStart(2,"0"));let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(c){for(let p=0;p<c.length;p++)c[p]=Math.floor(Math.random()*256);return c};function I(){L(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let c=0,p="";return p+=R[P[c++]],p+=R[P[c++]],p+=R[P[c++]],p+=R[P[c++]],p+="-",p+=R[P[c++]],p+=R[P[c++]],p+="-",p+=R[P[c++]],p+=R[P[c++]],p+="-",p+=R[P[c++]],p+=R[P[c++]],p+="-",p+=R[P[c++]],p+=R[P[c++]],p+=R[P[c++]],p+=R[P[c++]],p+=R[P[c++]],p+=R[P[c++]],p}i.generateUuid=I}),define(Q[63],Z([0,1,131]),function(x,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LineDecoder=void 0;class D{constructor(R="utf8"){this.stringDecoder=new C.StringDecoder(R),this.remaining=null}write(R){const L=[],I=this.remaining?this.remaining+this.stringDecoder.write(R):this.stringDecoder.write(R);if(I.length<1)return L;let c=0,p,b=c;for(;b<I.length;)if(p=I.charCodeAt(b),p===13||p===10){if(L.push(I.substring(c,b)),b++,b<I.length){const O=p;p=I.charCodeAt(b),(O===13&&p===10||O===10&&p===13)&&b++}c=b}else b++;return this.remaining=c<I.length?I.substr(c):null,L}end(){return this.remaining}}i.LineDecoder=D}),define(Q[64],Z([0,1,38,10,15]),function(x,i,C,D,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getFirstAvailablePowerShellInstallation=i.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,L=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var c;(function(v){v[v.x64=0]="x64",v[v.x86=1]="x86",v[v.ARM=2]="ARM"})(c||(c={}));let p;switch(process.arch){case"ia32":case"x32":p=1;break;case"arm":case"arm64":p=2;break;default:p=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class O{constructor(o,t,r){this.exePath=o,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await P.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function h({useAlternateBitness:v=!1}={}){return v?p===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function S({useAlternateBitness:v=!1,findPreview:o=!1}={}){const t=h({useAlternateBitness:v});if(!t)return null;const r=D.join(t,"PowerShell");if(!await P.SymlinkSupport.existsDirectory(r))return null;let e=-1,n=null;for(const u of await P.Promises.readdir(r)){let d=-1;if(o){const T=u.indexOf("-");if(T<0)continue;const N=u.substring(0,T);if(!R.test(N)||u.substring(T+1)!=="preview")continue;d=parseInt(N,10)}else{if(!R.test(u))continue;d=parseInt(u,10)}if(d<=e)continue;const w=D.join(r,u,"pwsh.exe");!await P.SymlinkSupport.existsFile(w)||(n=w,e=d)}if(!n)return null;const s=t.includes("x86")?" (x86)":"",l=o?" Preview":"";return new O(n,`PowerShell${l}${s}`,!0)}async function y({findPreview:v}={}){if(!process.env.LOCALAPPDATA)return null;const o=D.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await P.SymlinkSupport.existsDirectory(o))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=v?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const e of await P.Promises.readdir(o))if(t.test(e)){const n=D.join(o,e,"pwsh.exe");return new O(n,r)}return null}function g(){const v=D.join(C.homedir(),".dotnet","tools","pwsh.exe");return new O(v,".NET Core PowerShell Global Tool")}function a(){const v=D.join(process.env.windir,p===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new O(v,"Windows PowerShell",!0)}async function*f(){let v=await S();v&&(yield v),v=await S({useAlternateBitness:!0}),v&&(yield v),v=await y(),v&&(yield v),v=g(),v&&(yield v),v=await S({findPreview:!0}),v&&(yield v),v=await y({findPreview:!0}),v&&(yield v),v=await S({useAlternateBitness:!0,findPreview:!0}),v&&(yield v),v=a(),v&&(yield v)}async function*m(){for await(const v of f())await v.exists()&&(yield v)}i.enumeratePowerShellInstallations=m;async function E(){for await(const v of m())return v;return null}i.getFirstAvailablePowerShellInstallation=E});var ge=this&&this.__decorate||function(x,i,C,D){var P=arguments.length,R=P<3?i:D===null?D=Object.getOwnPropertyDescriptor(i,C):D,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(x,i,C,D);else for(var I=x.length-1;I>=0;I--)(L=x[I])&&(R=(P<3?L(R):P>3?L(i,C,R):L(i,C))||R);return P>3&&R&&Object.defineProperty(i,C,R),R};define(Q[46],Z([0,1,18,3,17,24,44,7,6,2,61,26,8]),function(x,i,C,D,P,R,L,I,c,p,b,O,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IPCLogger=i.logWithColors=i.ProxyChannel=i.StaticRouter=i.getNextTickChannel=i.getDelayedChannel=i.IPCClient=i.IPCServer=i.ChannelClient=i.RequestInitiator=i.ChannelServer=i.ResponseType=i.RequestType=void 0;var S;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(S=i.RequestType||(i.RequestType={}));function y(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(g=i.ResponseType||(i.ResponseType={}));function a(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(f||(f={}));class m{constructor(A){this.buffer=A,this.pos=0}read(A){const W=this.buffer.slice(this.pos,this.pos+A);return this.pos+=W.byteLength,W}}class E{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(A){this.buffers.push(A)}}var v;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(v||(v={}));function o(M){const A=P.VSBuffer.alloc(4);return A.writeUInt32BE(M,0),A}function t(M){return M.read(4).readUInt32BE(0)}function r(M){const A=P.VSBuffer.alloc(1);return A.writeUInt8(M,0),A}const e={Undefined:r(v.Undefined),String:r(v.String),Buffer:r(v.Buffer),VSBuffer:r(v.VSBuffer),Array:r(v.Array),Object:r(v.Object)},n=typeof Buffer!="undefined";function s(M,A){if(typeof A=="undefined")M.write(e.Undefined);else if(typeof A=="string"){const W=P.VSBuffer.fromString(A);M.write(e.String),M.write(o(W.byteLength)),M.write(W)}else if(n&&Buffer.isBuffer(A)){const W=P.VSBuffer.wrap(A);M.write(e.Buffer),M.write(o(W.byteLength)),M.write(W)}else if(A instanceof P.VSBuffer)M.write(e.VSBuffer),M.write(o(A.byteLength)),M.write(A);else if(Array.isArray(A)){M.write(e.Array),M.write(o(A.length));for(const W of A)s(M,W)}else{const W=P.VSBuffer.fromString(JSON.stringify(A));M.write(e.Object),M.write(o(W.byteLength)),M.write(W)}}function l(M){switch(M.read(1).readUInt8(0)){case v.Undefined:return;case v.String:return M.read(t(M)).toString();case v.Buffer:return M.read(t(M)).buffer;case v.VSBuffer:return M.read(t(M));case v.Array:{const W=t(M),K=[];for(let ne=0;ne<W;ne++)K.push(l(M));return K}case v.Object:return JSON.parse(M.read(t(M)).toString())}}class u{constructor(A,W,K=null,ne=1e3){this.protocol=A,this.ctx=W,this.logger=K,this.timeoutDelay=ne,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(J=>this.onRawMessage(J)),this.sendResponse({type:200})}registerChannel(A,W){this.channels.set(A,W),setTimeout(()=>this.flushPendingRequests(A),0)}sendResponse(A){switch(A.type){case 200:{const W=this.send([A.type]);this.logger&&this.logger.logOutgoing(W,0,1,a(A.type));return}case 201:case 202:case 204:case 203:{const W=this.send([A.type,A.id],A.data);this.logger&&this.logger.logOutgoing(W,A.id,1,a(A.type),A.data);return}}}send(A,W=void 0){const K=new E;return s(K,A),s(K,W),this.sendBuffer(K.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onRawMessage(A){const W=new m(A),K=l(W),ne=l(W),J=K[0];switch(J){case 100:return this.logger&&this.logger.logIncoming(A.byteLength,K[1],1,`${y(J)}: ${K[2]}.${K[3]}`,ne),this.onPromise({type:J,id:K[1],channelName:K[2],name:K[3],arg:ne});case 102:return this.logger&&this.logger.logIncoming(A.byteLength,K[1],1,`${y(J)}: ${K[2]}.${K[3]}`,ne),this.onEventListen({type:J,id:K[1],channelName:K[2],name:K[3],arg:ne});case 101:return this.logger&&this.logger.logIncoming(A.byteLength,K[1],1,`${y(J)}`),this.disposeActiveRequest({type:J,id:K[1]});case 103:return this.logger&&this.logger.logIncoming(A.byteLength,K[1],1,`${y(J)}`),this.disposeActiveRequest({type:J,id:K[1]})}}onPromise(A){const W=this.channels.get(A.channelName);if(!W){this.collectPendingRequest(A);return}const K=new R.CancellationTokenSource;let ne;try{ne=W.call(this.ctx,A.name,A.arg,K.token)}catch(G){ne=Promise.reject(G)}const J=A.id;ne.then(G=>{this.sendResponse({id:J,data:G,type:201}),this.activeRequests.delete(A.id)},G=>{G instanceof Error?this.sendResponse({id:J,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split?G.stack.split(`
`):G.stack:void 0},type:202}):this.sendResponse({id:J,data:G,type:203}),this.activeRequests.delete(A.id)});const ee=(0,p.toDisposable)(()=>K.cancel());this.activeRequests.set(A.id,ee)}onEventListen(A){const W=this.channels.get(A.channelName);if(!W){this.collectPendingRequest(A);return}const K=A.id,J=W.listen(this.ctx,A.name,A.arg)(ee=>this.sendResponse({id:K,data:ee,type:204}));this.activeRequests.set(A.id,J)}disposeActiveRequest(A){const W=this.activeRequests.get(A.id);W&&(W.dispose(),this.activeRequests.delete(A.id))}collectPendingRequest(A){let W=this.pendingRequests.get(A.channelName);W||(W=[],this.pendingRequests.set(A.channelName,W));const K=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.sendResponse({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:A,timeoutTimer:K})}flushPendingRequests(A){const W=this.pendingRequests.get(A);if(W){for(const K of W)switch(clearTimeout(K.timeoutTimer),K.request.type){case 100:this.onPromise(K.request);break;case 102:this.onEventListen(K.request);break}this.pendingRequests.delete(A)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(A=>A.dispose()),this.activeRequests.clear()}}i.ChannelServer=u;var d;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(d=i.RequestInitiator||(i.RequestInitiator={}));class w{constructor(A,W=null){this.protocol=A,this.isDisposed=!1,this.state=f.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new c.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(K=>this.onBuffer(K)),this.logger=W}getChannel(A){const W=this;return{call(K,ne,J){return W.isDisposed?Promise.reject(I.canceled()):W.requestPromise(A,K,ne,J)},listen(K,ne){return W.isDisposed?Promise.reject(I.canceled()):W.requestEvent(A,K,ne)}}}requestPromise(A,W,K,ne=R.CancellationToken.None){const J=this.lastRequestId++,G={id:J,type:100,channelName:A,name:W,arg:K};if(ne.isCancellationRequested)return Promise.reject(I.canceled());let U;return new Promise((z,B)=>{if(ne.isCancellationRequested)return B(I.canceled());const H=()=>{const ye=fe=>{switch(fe.type){case 201:this.handlers.delete(J),z(fe.data);break;case 202:{this.handlers.delete(J);const oe=new Error(fe.data.message);oe.stack=fe.data.stack,oe.name=fe.data.name,B(oe);break}case 203:this.handlers.delete(J),B(fe.data);break}};this.handlers.set(J,ye),this.sendRequest(G)};let X=null;this.state===f.Idle?H():(X=(0,D.createCancelablePromise)(ye=>this.whenInitialized()),X.then(()=>{X=null,H()}));const le=()=>{X?(X.cancel(),X=null):this.sendRequest({id:J,type:101}),B(I.canceled())},ue=ne.onCancellationRequested(le);U=(0,p.combinedDisposable)((0,p.toDisposable)(le),ue),this.activeRequests.add(U)}).finally(()=>{this.activeRequests.delete(U)})}requestEvent(A,W,K){const ne=this.lastRequestId++,ee={id:ne,type:102,channelName:A,name:W,arg:K};let G=null;const U=new c.Emitter({onFirstListenerAdd:()=>{G=(0,D.createCancelablePromise)(z=>this.whenInitialized()),G.then(()=>{G=null,this.activeRequests.add(U),this.sendRequest(ee)})},onLastListenerRemove:()=>{G?(G.cancel(),G=null):(this.activeRequests.delete(U),this.sendRequest({id:ne,type:103}))}}),k=z=>U.fire(z.data);return this.handlers.set(ne,k),U.event}sendRequest(A){switch(A.type){case 100:case 102:{const W=this.send([A.type,A.id,A.channelName,A.name],A.arg);this.logger&&this.logger.logOutgoing(W,A.id,0,`${y(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const W=this.send([A.type,A.id]);this.logger&&this.logger.logOutgoing(W,A.id,0,y(A.type));return}}}send(A,W=void 0){const K=new E;return s(K,A),s(K,W),this.sendBuffer(K.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onBuffer(A){const W=new m(A),K=l(W),ne=l(W),J=K[0];switch(J){case 200:return this.logger&&this.logger.logIncoming(A.byteLength,0,0,a(J)),this.onResponse({type:K[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(A.byteLength,K[1],0,a(J),ne),this.onResponse({type:K[0],id:K[1],data:ne})}}onResponse(A){if(A.type===200){this.state=f.Idle,this._onDidInitialize.fire();return}const W=this.handlers.get(A.id);W&&W(A)}get onDidInitializePromise(){return c.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(A=>A.dispose()),this.activeRequests.clear()}}ge([L.memoize],w.prototype,"onDidInitializePromise",null),i.ChannelClient=w;class T{constructor(A){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new c.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new c.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,A(({protocol:W,onDidClientDisconnect:K})=>{c.Event.once(W.onMessage)(J=>{const ee=new m(J),G=l(ee),U=new u(W,G),k=new w(W);this.channels.forEach((B,H)=>U.registerChannel(H,B));const z={channelServer:U,channelClient:k,ctx:G};this._connections.add(z),this._onDidAddConnection.fire(z),K(()=>{U.dispose(),k.dispose(),this._connections.delete(z),this._onDidRemoveConnection.fire(z)})})})}get connections(){const A=[];return this._connections.forEach(W=>A.push(W)),A}getChannel(A,W){const K=this;return{call(ne,J,ee){let G;if((0,h.isFunction)(W)){let k=(0,C.getRandomElement)(K.connections.filter(W));G=k?Promise.resolve(k):c.Event.toPromise(c.Event.filter(K.onDidAddConnection,W))}else G=W.routeCall(K,ne,J);const U=G.then(k=>k.channelClient.getChannel(A));return _(U).call(ne,J,ee)},listen(ne,J){if((0,h.isFunction)(W))return K.getMulticastEvent(A,W,ne,J);const ee=W.routeEvent(K,ne,J).then(G=>G.channelClient.getChannel(A));return _(ee).listen(ne,J)}}}getMulticastEvent(A,W,K,ne){const J=this;let ee=new p.DisposableStore;const G=new c.Emitter({onFirstListenerAdd:()=>{ee=new p.DisposableStore;const U=new c.EventMultiplexer,k=new Map,z=H=>{const le=H.channelClient.getChannel(A).listen(K,ne),ue=U.add(le);k.set(H,ue)},B=H=>{const X=k.get(H);!X||(X.dispose(),k.delete(H))};J.connections.filter(W).forEach(z),c.Event.filter(J.onDidAddConnection,W)(z,void 0,ee),J.onDidRemoveConnection(B,void 0,ee),U.event(G.fire,G,ee),ee.add(U)},onLastListenerRemove:()=>{ee.dispose()}});return G.event}registerChannel(A,W){this.channels.set(A,W),this._connections.forEach(K=>{K.channelServer.registerChannel(A,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}i.IPCServer=T;class N{constructor(A,W,K=null){const ne=new E;s(ne,W),A.send(ne.buffer),this.channelClient=new w(A,K),this.channelServer=new u(A,W,K)}getChannel(A){return this.channelClient.getChannel(A)}registerChannel(A,W){this.channelServer.registerChannel(A,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}i.IPCClient=N;function _(M){return{call(A,W,K){return M.then(ne=>ne.call(A,W,K))},listen(A,W){const K=new c.Relay;return M.then(ne=>K.input=ne.listen(A,W)),K.event}}}i.getDelayedChannel=_;function Y(M){let A=!1;return{call(W,K,ne){return A?M.call(W,K,ne):(0,D.timeout)(0).then(()=>A=!0).then(()=>M.call(W,K,ne))},listen(W,K){if(A)return M.listen(W,K);const ne=new c.Relay;return(0,D.timeout)(0).then(()=>A=!0).then(()=>ne.input=M.listen(W,K)),ne.event}}}i.getNextTickChannel=Y;class re{constructor(A){this.fn=A}routeCall(A){return this.route(A)}routeEvent(A){return this.route(A)}async route(A){for(const W of A.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await c.Event.toPromise(A.onDidAddConnection),await this.route(A)}}i.StaticRouter=re;var te;(function(M){function A(J,ee){const G=J,U=ee&&ee.disableMarshalling,k=new Map;for(const z in G)K(z)&&k.set(z,c.Event.buffer(G[z],!0));return new class{listen(z,B,H){const X=k.get(B);if(X)return X;if(ne(B)){const le=G[B];if(typeof le=="function")return le.call(G,H)}throw new Error(`Event not found: ${B}`)}call(z,B,H){const X=G[B];if(typeof X=="function"){if(!U&&Array.isArray(H))for(let le=0;le<H.length;le++)H[le]=(0,b.revive)(H[le]);return X.apply(G,H)}throw new Error(`Method not found: ${B}`)}}}M.fromService=A;function W(J,ee){const G=ee&&ee.disableMarshalling;return new Proxy({},{get(U,k){if(typeof k=="string")return ee?.properties?.has(k)?ee.properties.get(k):ne(k)?function(z){return J.listen(k,z)}:K(k)?J.listen(k):async function(...z){let B;ee&&!(0,h.isUndefinedOrNull)(ee.context)?B=[ee.context,...z]:B=z;const H=await J.call(k,B);return G?H:(0,b.revive)(H)};throw new Error(`Property not found: ${String(k)}`)}})}M.toService=W;function K(J){return J[0]==="o"&&J[1]==="n"&&O.isUpperAsciiLetter(J.charCodeAt(2))}function ne(J){return/^onDynamic/.test(J)&&O.isUpperAsciiLetter(J.charCodeAt(9))}})(te=i.ProxyChannel||(i.ProxyChannel={}));const ie=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function he(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let A=M.toString();if(A!=="[object Object]")return A}return M}function j(M){return Array.isArray(M)?M.map(he):he(M)}function q(M,A,W,K,ne,J,ee){ee=j(ee);const G=ie[ne],U=G[K%G.length];let k=[`%c[${M}]%c[${String(A).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(K).padStart(5," ")} - ${J}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(J)?(k=k.concat(ee),k.push(")")):k.push(ee),console.log.apply(console,k)}i.logWithColors=q;class se{constructor(A,W){this._outgoingPrefix=A,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(A,W,K,ne,J){this._totalOutgoing+=A,q(this._outgoingPrefix,this._totalOutgoing,A,W,K,ne,J)}logIncoming(A,W,K,ne,J){this._totalIncoming+=A,q(this._incomingPrefix,this._totalIncoming,A,W,K,ne,J)}}i.IPCLogger=se}),define(Q[65],Z([0,1,3,6,2,8]),function(x,i,C,D,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InMemoryStorageDatabase=i.Storage=i.isStorageItemsChangeEvent=i.StorageHint=void 0;var L;(function(O){O[O.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(L=i.StorageHint||(i.StorageHint={}));function I(O){const h=O;return h?.changed instanceof Map||h?.deleted instanceof Set}i.isStorageItemsChangeEvent=I;var c;(function(O){O[O.None=0]="None",O[O.Initialized=1]="Initialized",O[O.Closed=2]="Closed"})(c||(c={}));class p extends P.Disposable{constructor(h,S=Object.create(null)){super();this.database=h,this.options=S,this._onDidChangeStorage=this._register(new D.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=c.None,this.cache=new Map,this.flushDelayer=new C.ThrottledDelayer(p.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(h=>this.onDidChangeItemsExternal(h)))}onDidChangeItemsExternal(h){h.changed?.forEach((S,y)=>this.accept(y,S)),h.deleted?.forEach(S=>this.accept(S,void 0))}accept(h,S){if(this.state===c.Closed)return;let y=!1;(0,R.isUndefinedOrNull)(S)?y=this.cache.delete(h):this.cache.get(h)!==S&&(this.cache.set(h,S),y=!0),y&&this._onDidChangeStorage.fire(h)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===c.None&&(this.state=c.Initialized,this.options.hint!==L.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(h,S){const y=this.cache.get(h);return(0,R.isUndefinedOrNull)(y)?S:y}getBoolean(h,S){const y=this.get(h);return(0,R.isUndefinedOrNull)(y)?S:y==="true"}getNumber(h,S){const y=this.get(h);return(0,R.isUndefinedOrNull)(y)?S:parseInt(y,10)}async set(h,S){if(this.state===c.Closed)return;if((0,R.isUndefinedOrNull)(S))return this.delete(h);const y=String(S);if(this.cache.get(h)!==y)return this.cache.set(h,y),this.pendingInserts.set(h,y),this.pendingDeletes.delete(h),this._onDidChangeStorage.fire(h),this.doFlush()}async delete(h){if(!(this.state===c.Closed||!this.cache.delete(h)))return this.pendingDeletes.has(h)||this.pendingDeletes.add(h),this.pendingInserts.delete(h),this._onDidChangeStorage.fire(h),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=c.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const h={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(h).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(h){if(!!this.hasPending)return this.doFlush(h)}async doFlush(h){return this.flushDelayer.trigger(()=>this.flushPending(),h)}async whenFlushed(){if(!!this.hasPending)return new Promise(h=>this.whenFlushedCallbacks.push(h))}dispose(){this.flushDelayer.dispose(),super.dispose()}}i.Storage=p,p.DEFAULT_FLUSH_DELAY=100;class b{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(h){h.insert&&h.insert.forEach((S,y)=>this.items.set(y,S)),h.delete&&h.delete.forEach(S=>this.items.delete(S))}async close(){}}i.InMemoryStorageDatabase=b}),define(Q[66],Z([4,5]),function(x,i){return x.create("vs/base/common/date",i)}),define(Q[67],Z([0,1,66]),function(x,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.toLocalISOString=i.fromNow=void 0;const D=60,P=D*60,R=P*24,L=R*7,I=R*30,c=R*365;function p(O,h,S){typeof O!="number"&&(O=O.getTime());const y=Math.round((new Date().getTime()-O)/1e3);if(y<-30)return(0,C.localize)(0,null,p(new Date().getTime()+y*1e3,!1));if(y<30)return(0,C.localize)(1,null);let g;return y<D?(g=y,h?g===1?S?(0,C.localize)(2,null,g):(0,C.localize)(3,null,g):S?(0,C.localize)(4,null,g):(0,C.localize)(5,null,g):g===1?S?(0,C.localize)(6,null,g):(0,C.localize)(7,null,g):S?(0,C.localize)(8,null,g):(0,C.localize)(9,null,g)):y<P?(g=Math.floor(y/D),h?g===1?S?(0,C.localize)(10,null,g):(0,C.localize)(11,null,g):S?(0,C.localize)(12,null,g):(0,C.localize)(13,null,g):g===1?S?(0,C.localize)(14,null,g):(0,C.localize)(15,null,g):S?(0,C.localize)(16,null,g):(0,C.localize)(17,null,g)):y<R?(g=Math.floor(y/P),h?g===1?S?(0,C.localize)(18,null,g):(0,C.localize)(19,null,g):S?(0,C.localize)(20,null,g):(0,C.localize)(21,null,g):g===1?S?(0,C.localize)(22,null,g):(0,C.localize)(23,null,g):S?(0,C.localize)(24,null,g):(0,C.localize)(25,null,g)):y<L?(g=Math.floor(y/R),h?g===1?(0,C.localize)(26,null,g):(0,C.localize)(27,null,g):g===1?(0,C.localize)(28,null,g):(0,C.localize)(29,null,g)):y<I?(g=Math.floor(y/L),h?g===1?S?(0,C.localize)(30,null,g):(0,C.localize)(31,null,g):S?(0,C.localize)(32,null,g):(0,C.localize)(33,null,g):g===1?S?(0,C.localize)(34,null,g):(0,C.localize)(35,null,g):S?(0,C.localize)(36,null,g):(0,C.localize)(37,null,g)):y<c?(g=Math.floor(y/I),h?g===1?S?(0,C.localize)(38,null,g):(0,C.localize)(39,null,g):S?(0,C.localize)(40,null,g):(0,C.localize)(41,null,g):g===1?S?(0,C.localize)(42,null,g):(0,C.localize)(43,null,g):S?(0,C.localize)(44,null,g):(0,C.localize)(45,null,g)):(g=Math.floor(y/c),h?g===1?S?(0,C.localize)(46,null,g):(0,C.localize)(47,null,g):S?(0,C.localize)(48,null,g):(0,C.localize)(49,null,g):g===1?S?(0,C.localize)(50,null,g):(0,C.localize)(51,null,g):S?(0,C.localize)(52,null,g):(0,C.localize)(53,null,g))}i.fromNow=p;function b(O){return O.getFullYear()+"-"+String(O.getMonth()+1).padStart(2,"0")+"-"+String(O.getDate()).padStart(2,"0")+"T"+String(O.getHours()).padStart(2,"0")+":"+String(O.getMinutes()).padStart(2,"0")+":"+String(O.getSeconds()).padStart(2,"0")+"."+(O.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}i.toLocalISOString=b}),define(Q[68],Z([4,5]),function(x,i){return x.create("vs/base/common/errorMessage",i)}),define(Q[28],Z([0,1,18,8,68]),function(x,i,C,D,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.toErrorMessage=void 0;function R(p,b){return b&&(p.stack||p.stacktrace)?P.localize(0,null,I(p),L(p.stack)||L(p.stacktrace)):I(p)}function L(p){return Array.isArray(p)?p.join(`
`):p}function I(p){return typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?P.localize(1,null,p.message):p.message||P.localize(2,null)}function c(p=null,b=!1){if(!p)return P.localize(3,null);if(Array.isArray(p)){const O=C.coalesce(p),h=c(O[0],b);return O.length>1?P.localize(4,null,h,O.length):h}if(D.isString(p))return p;if(p.detail){const O=p.detail;if(O.error)return R(O.error,b);if(O.exception)return R(O.exception,b)}return p.stack?R(p,b):p.message?p.message:P.localize(5,null)}i.toErrorMessage=c}),define(Q[69],Z([4,5]),function(x,i){return x.create("vs/base/node/processes",i)}),define(Q[47],Z([0,1,39,45,11,21,10,12,31,57,8,63,15,69]),function(x,i,C,D,P,R,L,I,c,p,b,O,h,S){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.win32=i.createQueuedSender=i.LineProcess=i.AbstractProcess=i.getWindowsShell=i.removeDangerousEnvVariables=i.TerminateResponseCode=i.Source=void 0,Object.defineProperty(i,"Source",{enumerable:!0,get:function(){return p.Source}}),Object.defineProperty(i,"TerminateResponseCode",{enumerable:!0,get:function(){return p.TerminateResponseCode}});function y(t){switch(t){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function g(t,r){if(I.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};r&&(e.cwd=r);const n=C.execFile("taskkill",["/T","/F","/PID",t.pid.toString()],e);return new Promise(s=>{n.once("error",l=>{s({success:!1,error:l})}),n.once("exit",(l,u)=>{s(l===0?{success:!0}:{success:!1,code:l!==null?l:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?y(e.status):1})}else if(I.isLinux||I.isMacintosh)try{const e=P.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",x).fsPath;return new Promise(n=>{C.execFile(e,[t.pid.toString()],{encoding:"utf8",shell:!0},(s,l,u)=>{n(s?{success:!1,error:s}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else t.kill("SIGKILL");return Promise.resolve({success:!0})}function a(t){!t||(delete t.DEBUG,I.isMacintosh&&delete t.DYLD_LIBRARY_PATH,I.isLinux&&delete t.LD_PRELOAD)}i.removeDangerousEnvVariables=a;function f(t=c.env){return t.comspec||"cmd.exe"}i.getWindowsShell=f;class m{constructor(r,e,n,s){if(e!==void 0&&n!==void 0&&s!==void 0)this.cmd=r,this.args=e,this.shell=n,this.options=s;else{const l=r;this.cmd=l.command,this.shell=l.isShellCommand,this.args=l.args.slice(0),this.options=l.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const l=Object.create(null);Object.keys(c.env).forEach(u=>{l[u]=c.env[u]}),Object.keys(this.options.env).forEach(u=>{l[u]=this.options.env[u]}),this.options.env=l}}getSanitizedCommand(){let r=this.cmd.toLowerCase();const e=r.lastIndexOf(L.sep);return e!==-1&&(r=r.substring(e+1)),m.WellKnowCommands[r]?r:"other"}start(r){return I.isWindows&&(this.options&&this.options.cwd&&D.isUNC(this.options.cwd)||!this.options&&D.isUNC(c.cwd()))?Promise.reject(new Error(S.localize(0,null))):this.useExec().then(e=>{let n,s;const l=new Promise((u,d)=>{n=u,s=d});if(e){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=C.exec(u,this.options,(d,w,T)=>{this.childProcess=null;const N=d;N&&N.killed?s({killed:this.terminateRequested,stdout:w.toString(),stderr:T.toString()}):this.handleExec(n,r,d,w,T)})}else{let u=null;const d=w=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(w,n,r,s);const T={terminated:this.terminateRequested};b.isNumber(w)&&(T.cmdCode=w),n(T)};if(this.shell&&I.isWindows){const w=R.deepClone(this.options);w.windowsVerbatimArguments=!0,w.detached=!1;let T=!1,N=!1;const _=[];let Y=this.ensureQuotes(this.cmd);_.push(Y.value),T=Y.quoted,this.args&&this.args.forEach(te=>{Y=this.ensureQuotes(te),_.push(Y.value),N=N&&Y.quoted});const re=["/s","/c"];T?N?re.push('"'+_.join(" ")+'"'):_.length>1?re.push('"'+_[0]+'" '+_.slice(1).join(" ")):re.push('"'+_[0]+'"'):re.push(_.join(" ")),u=C.spawn(f(),re,w)}else this.cmd&&(u=C.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(b.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",w=>{this.childProcess=null,s({terminated:this.terminateRequested,error:w})}),u.pid&&(this.childProcess.on("close",d),this.handleSpawn(u,n,r,s,!0)))}return l})}handleClose(r,e,n,s){}ensureQuotes(r){return m.regexp.test(r)?{value:'"'+r+'"',quoted:!0}:{value:r,quoted:r.length>0&&r[0]==='"'&&r[r.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(r=>r.pid,r=>-1):new Promise(r=>{this.pidResolve=r})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(r=>(this.terminateRequested=!0,g(r,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),r=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(r=>{if(!this.shell||!I.isWindows)return r(!1);const e=C.spawn(f(),["/s","/c"]);e.on("error",n=>r(!0)),e.on("exit",n=>r(!1))})}}i.AbstractProcess=m,m.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},m.regexp=/^[^"].* .*[^"]/;class E extends m{constructor(r,e,n,s){super(r,e,n,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(r,e,n,s,l){[s,l].forEach((u,d)=>{const w=new O.LineDecoder;w.write(u).forEach(_=>{e({line:_,source:d===0?0:1})});const N=w.end();N&&e({line:N,source:d===0?0:1})}),r({terminated:this.terminateRequested,error:n})}handleSpawn(r,e,n,s,l){const u=new O.LineDecoder,d=new O.LineDecoder;r.stdout.on("data",w=>{u.write(w).forEach(N=>n({line:N,source:0}))}),r.stderr.on("data",w=>{d.write(w).forEach(N=>n({line:N,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=d}handleClose(r,e,n,s){const l=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;l&&n({line:l,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&n({line:u,source:1})}}i.LineProcess=E;function v(t){let r=[],e=!1;const n=function(s){if(e){r.push(s);return}(!t.send(s,u=>{if(u&&console.error(u),e=!1,r.length>0){const d=r.slice(0);r=[],d.forEach(w=>n(w))}})||I.isWindows)&&(e=!0)};return{send:n}}i.createQueuedSender=v;var o;(function(t){async function r(e,n,s){if(L.isAbsolute(e))return e;if(n===void 0&&(n=c.cwd()),L.dirname(e)!=="."||(s===void 0&&b.isString(c.env.PATH)&&(s=c.env.PATH.split(L.delimiter)),s===void 0||s.length===0))return L.join(n,e);async function u(d){if(await h.Promises.exists(d)){let w;try{w=await h.Promises.stat(d)}catch(T){T.message.startsWith("EACCES")&&(w=await h.Promises.lstat(d))}return w?!w.isDirectory():!1}return!1}for(let d of s){let w;if(L.isAbsolute(d)?w=L.join(d,e):w=L.join(n,d,e),await u(w))return w;let T=w+".com";if(await u(T)||(T=w+".exe",await u(T)))return T}return L.join(n,e)}t.findExecutable=r})(o=i.win32||(i.win32={}))}),define(Q[70],Z([0,1,38,12,64,47]),function(x,i,C,D,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSystemShellSync=i.getSystemShell=void 0;async function L(S,y){return S===1?D.isWindows?O():R.getWindowsShell(y):p(S,y)}i.getSystemShell=L;function I(S,y){return S===1?D.isWindows?h(y):R.getWindowsShell(y):p(S,y)}i.getSystemShellSync=I;let c=null;function p(S,y){if(D.isLinux&&S===2||D.isMacintosh&&S===3)return"/bin/bash";if(!c){let g;if(D.isWindows)g="/bin/bash";else{if(g=y.SHELL,!g)try{g=(0,C.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}c=g}return c}let b=null;async function O(){return b||(b=(await(0,P.getFirstAvailablePowerShellInstallation)()).exePath),b}function h(S){if(b)return b;const y=D.isWindows&&parseFloat((0,C.release)())>=10,g=S.hasOwnProperty("PROCESSOR_ARCHITEW6432"),a=`${S.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return y?a:R.getWindowsShell(S)}}),define(Q[71],Z([0,1,39,3,17,24,60,7,6,2,21,47,46]),function(x,i,C,D,P,R,L,I,c,p,b,O,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Client=i.Server=void 0;class S extends h.ChannelServer{constructor(a){super({send:f=>{try{process.send&&process.send(f.buffer.toString("base64"))}catch{}},onMessage:c.Event.fromNodeEventEmitter(process,"message",f=>P.VSBuffer.wrap(Buffer.from(f,"base64")))},a);process.once("disconnect",()=>this.dispose())}}i.Server=S;class y{constructor(a,f){this.modulePath=a,this.options=f,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new c.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const m=f&&f.timeout?f.timeout:6e4;this.disposeDelayer=new D.Delayer(m),this.child=null,this._client=null}getChannel(a){const f=this;return{call(m,E,v){return f.requestPromise(a,m,E,v)},listen(m,E){return f.requestEvent(a,m,E)}}}requestPromise(a,f,m,E=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const v=this.getCachedChannel(a),o=(0,D.createCancelablePromise)(e=>v.call(f,m,e)),t=E.onCancellationRequested(()=>o.cancel()),r=(0,p.toDisposable)(()=>o.cancel());return this.activeRequests.add(r),o.finally(()=>{t.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),o}requestEvent(a,f,m){if(!this.disposeDelayer)return c.Event.None;this.disposeDelayer.cancel();let E;const v=new c.Emitter({onFirstListenerAdd:()=>{E=this.getCachedChannel(a).listen(f,m)(v.fire,v),this.activeRequests.add(E)},onLastListenerRemove:()=>{this.activeRequests.delete(E),E.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return v.event}get client(){if(!this._client){const a=this.options&&this.options.args?this.options.args:[],f=Object.create(null);f.env={...(0,b.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(f.env={...f.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(f.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n))),(0,O.removeDangerousEnvVariables)(f.env),this.child=(0,C.fork)(this.modulePath,a,f);const m=new c.Emitter;c.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,L.isRemoteConsoleLog)(n)){(0,L.log)(n,`IPC Library: ${this.options.serverName}`);return}m.fire(P.VSBuffer.wrap(Buffer.from(n,"base64")))});const v=this.options.useQueue?(0,O.createQueuedSender)(this.child):this.child,o=n=>this.child&&this.child.connected&&v.send(n.buffer.toString("base64")),t=m.event,r={send:o,onMessage:t};this._client=new h.ChannelClient(r);const e=()=>this.disposeClient();process.once("exit",e),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,s)=>{process.removeListener("exit",e),this.activeRequests.forEach(l=>(0,p.dispose)(l)),this.activeRequests.clear(),n!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:s})})}return this._client}getCachedChannel(a){let f=this.channels.get(a);return f||(f=this.client.getChannel(a),this.channels.set(a,f)),f}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}i.Client=y}),define(Q[72],Z([4,5]),function(x,i){return x.create("vs/base/node/zip",i)}),define(Q[73],Z([4,5]),function(x,i){return x.create("vs/platform/configuration/common/configurationRegistry",i)}),define(Q[74],Z([4,5]),function(x,i){return x.create("vs/platform/environment/node/shellEnv",i)}),define(Q[75],Z([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",i)}),define(Q[76],Z([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/common/extensionManagement",i)}),define(Q[77],Z([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/common/extensionManagementCLIService",i)}),define(Q[78],Z([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/node/extensionManagementService",i)}),define(Q[79],Z([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/node/extensionManagementUtil",i)}),define(Q[80],Z([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/node/extensionsScanner",i)}),define(Q[81],Z([4,5]),function(x,i){return x.create("vs/platform/extensions/common/extensionValidator",i)}),define(Q[82],Z([4,5]),function(x,i){return x.create("vs/platform/files/common/fileService",i)}),define(Q[83],Z([4,5]),function(x,i){return x.create("vs/platform/files/common/io",i)}),define(Q[84],Z([4,5]),function(x,i){return x.create("vs/platform/files/node/diskFileSystemProvider",i)}),define(Q[85],Z([4,5]),function(x,i){return x.create("vs/platform/request/common/request",i)}),define(Q[86],Z([4,5]),function(x,i){return x.create("vs/platform/telemetry/common/telemetryService",i)}),define(Q[87],Z([0,1,67,44,11,10,31,22,9]),function(x,i,C,D,P,R,L,I,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.parsePtyHostPort=i.parseSearchPort=i.parseExtensionHostPort=i.AbstractNativeEnvironmentService=void 0;class p{constructor(g,a,f){this._args=g,this.paths=a,this.productService=f}get appRoot(){return(0,R.dirname)(P.FileAccess.asFileUri("",x).fsPath)}get userHome(){return c.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return c.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return c.URI.file(this.paths.tmpDir)}get cacheHome(){return c.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,I.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const g=(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",g)}return this.args.logsPath}get userDataSyncLogResource(){return c.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(c.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return c.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return c.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=L.env.VSCODE_PORTABLE;return g?c.URI.file((0,R.join)(g,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,I.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return c.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,R.resolve)(g):(0,R.normalize)((0,R.join)(P.FileAccess.asFileUri("",x).fsPath,"..","extensions"))}get extensionsDownloadPath(){const g=this.args["extensions-download-dir"];return g?(0,R.resolve)(g):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,R.resolve)(g);const a=L.env.VSCODE_EXTENSIONS;if(a)return a;const f=L.env.VSCODE_PORTABLE;return f?(0,R.join)(f,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(a=>/^[^:/?#]+?:\/\//.test(a)?c.URI.parse(a):c.URI.file((0,R.normalize)(a)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?c.URI.parse(g):c.URI.file((0,R.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,I.joinPath)(c.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return c.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ge([D.memoize],p.prototype,"appRoot",null),ge([D.memoize],p.prototype,"userHome",null),ge([D.memoize],p.prototype,"userDataPath",null),ge([D.memoize],p.prototype,"appSettingsHome",null),ge([D.memoize],p.prototype,"tmpDir",null),ge([D.memoize],p.prototype,"cacheHome",null),ge([D.memoize],p.prototype,"userRoamingDataHome",null),ge([D.memoize],p.prototype,"settingsResource",null),ge([D.memoize],p.prototype,"userDataSyncHome",null),ge([D.memoize],p.prototype,"userDataSyncLogResource",null),ge([D.memoize],p.prototype,"sync",null),ge([D.memoize],p.prototype,"machineSettingsResource",null),ge([D.memoize],p.prototype,"globalStorageHome",null),ge([D.memoize],p.prototype,"workspaceStorageHome",null),ge([D.memoize],p.prototype,"keybindingsResource",null),ge([D.memoize],p.prototype,"keyboardLayoutResource",null),ge([D.memoize],p.prototype,"argvResource",null),ge([D.memoize],p.prototype,"snippetsHome",null),ge([D.memoize],p.prototype,"isExtensionDevelopment",null),ge([D.memoize],p.prototype,"untitledWorkspacesHome",null),ge([D.memoize],p.prototype,"installSourcePath",null),ge([D.memoize],p.prototype,"builtinExtensionsPath",null),ge([D.memoize],p.prototype,"extensionsPath",null),ge([D.memoize],p.prototype,"extensionDevelopmentLocationURI",null),ge([D.memoize],p.prototype,"extensionDevelopmentKind",null),ge([D.memoize],p.prototype,"extensionTestsLocationURI",null),ge([D.memoize],p.prototype,"debugExtensionHost",null),ge([D.memoize],p.prototype,"serviceMachineIdResource",null),ge([D.memoize],p.prototype,"telemetryLogResource",null),ge([D.memoize],p.prototype,"disableWorkspaceTrust",null),i.AbstractNativeEnvironmentService=p;function b(y,g){return S(y["inspect-extensions"],y["inspect-brk-extensions"],5870,g,y.debugId,y.extensionEnvironment)}i.parseExtensionHostPort=b;function O(y,g){return S(y["inspect-search"],y["inspect-brk-search"],5876,g,y.extensionEnvironment)}i.parseSearchPort=O;function h(y,g){return S(y["inspect-ptyhost"],y["inspect-brk-ptyhost"],5877,g,y.extensionEnvironment)}i.parsePtyHostPort=h;function S(y,g,a,f,m,E){const o=Number(g||y)||(f?null:a),t=o?Boolean(!!g):!1;let r;if(E)try{r=JSON.parse(E)}catch{}return{port:o,break:t,debugId:m,env:r}}}),define(Q[88],Z([0,1,38,87,132]),function(x,i,C,D,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeEnvironmentService=void 0;class R extends D.AbstractNativeEnvironmentService{constructor(I,c){super(I,{homeDir:(0,C.homedir)(),tmpDir:(0,C.tmpdir)(),userDataDir:(0,P.getUserDataPath)(I)},c)}}i.NativeEnvironmentService=R}),define(Q[89],Z([0,1,21]),function(x,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.localizeManifest=void 0;const D=/^%([\w\d.-]+)%$/i;function P(R,L){const I=c=>{if(typeof c!="string")return;const p=D.exec(c);if(!p)return;const b=L[p[1]]??c;return typeof b=="string"?b:typeof b.message=="string"?b.message:c};return(0,C.cloneAndChange)(R,I)}i.localizeManifest=P}),define(Q[48],Z([0,1,81]),function(x,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isEngineValid=i.isValidExtensionVersion=i.isValidVersion=i.normalizeVersion=i.parseVersion=i.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function R(h){return h=h.trim(),h==="*"||D.test(h)}i.isValidVersionStr=R;function L(h){if(!R(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let S=h.match(D);return S?{hasCaret:S[1]==="^",hasGreaterEquals:S[1]===">=",majorBase:S[2]==="x"?0:parseInt(S[2],10),majorMustEqual:S[2]!=="x",minorBase:S[4]==="x"?0:parseInt(S[4],10),minorMustEqual:S[4]!=="x",patchBase:S[6]==="x"?0:parseInt(S[6],10),patchMustEqual:S[6]!=="x",preRelease:S[8]||null}:null}i.parseVersion=L;function I(h){if(!h)return null;let S=h.majorBase,y=h.majorMustEqual,g=h.minorBase,a=h.minorMustEqual,f=h.patchBase,m=h.patchMustEqual;h.hasCaret&&(S===0||(a=!1),m=!1);let E=0;if(h.preRelease){const v=P.exec(h.preRelease);if(v){const[,o,t,r]=v;E=Date.UTC(Number(o),Number(t)-1,Number(r))}}return{majorBase:S,majorMustEqual:y,minorBase:g,minorMustEqual:a,patchBase:f,patchMustEqual:m,isMinimum:h.hasGreaterEquals,notBefore:E}}i.normalizeVersion=I;function c(h,S,y){let g;typeof h=="string"?g=I(L(h)):g=h;let a;S instanceof Date?a=S.getTime():typeof S=="string"&&(a=new Date(S).getTime());let f;if(typeof y=="string"?f=I(L(y)):f=y,!g||!f)return!1;let m=g.majorBase,E=g.minorBase,v=g.patchBase,o=f.majorBase,t=f.minorBase,r=f.patchBase,e=f.notBefore,n=f.majorMustEqual,s=f.minorMustEqual,l=f.patchMustEqual;return f.isMinimum?m>o?!0:m<o?!1:E>t?!0:E<t||a&&a<e?!1:v>=r:(m===1&&o===0&&(!n||!s||!l)&&(o=1,t=0,r=0,n=!0,s=!1,l=!1),m<o?!1:m>o?!n:E<t?!1:E>t?!s:v<r?!1:v>r?!l:!(a&&a<e))}i.isValidVersion=c;function p(h,S,y,g){return y.isBuiltin||typeof y.main=="undefined"?!0:O(h,S,y.engines.vscode,g)}i.isValidExtensionVersion=p;function b(h,S,y){return h==="*"||O(S,y,h)}i.isEngineValid=b;function O(h,S,y,g=[]){let a=I(L(y));if(!a)return g.push(C.localize(0,null,y)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return g.push(C.localize(1,null,y)),!1}else if(!a.majorMustEqual)return g.push(C.localize(2,null,y)),!1;return c(h,S,a)?!0:(g.push(C.localize(3,null,h,y)),!1)}}),define(Q[90],Z([0,1,17,27]),function(x,i,C,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getServiceMachineId=void 0;async function P(R,L,I){let c=I&&I.get("storage.serviceMachineId",0)||null;if(c)return c;try{const b=(await L.readFile(R.serviceMachineIdResource)).value.toString();c=(0,D.isUUID)(b)?b:null}catch{c=null}if(!c){c=(0,D.generateUuid)();try{await L.writeFile(R.serviceMachineIdResource,C.VSBuffer.fromString(c))}catch{}}return I&&I.store("storage.serviceMachineId",c,0,1),c}i.getServiceMachineId=P}),define(Q[40],Z([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SyncDescriptor=void 0;class C{constructor(P,R=[],L=!1){this.ctor=P,this.staticArguments=R,this.supportsDelayedInstantiation=L}}i.SyncDescriptor=C}),define(Q[91],Z([0,1,40]),function(x,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSingletonServiceDescriptors=i.registerSingleton=void 0;const D=[];function P(L,I,c){I instanceof C.SyncDescriptor||(I=new C.SyncDescriptor(I,[],c)),D.push([L,I])}i.registerSingleton=P;function R(){return D}i.getSingletonServiceDescriptors=R}),define(Q[92],Z([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Graph=i.Node=void 0;class C{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}i.Node=C;class D{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(let L of this._nodes.values())L.outgoing.size===0&&R.push(L);return R}insertEdge(R,L){const I=this.lookupOrInsertNode(R),c=this.lookupOrInsertNode(L);I.outgoing.set(this._hashFn(L),c),c.incoming.set(this._hashFn(R),I)}removeNode(R){const L=this._hashFn(R);this._nodes.delete(L);for(let I of this._nodes.values())I.outgoing.delete(L),I.incoming.delete(L)}lookupOrInsertNode(R){const L=this._hashFn(R);let I=this._nodes.get(L);return I||(I=new C(R),this._nodes.set(L,I)),I}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){let R=[];for(let[L,I]of this._nodes)R.push(`${L}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return R.join(`
`)}findCycleSlow(){for(let[R,L]of this._nodes){const I=new Set([R]),c=this._findCycle(L,I);if(c)return c}}_findCycle(R,L){for(let[I,c]of R.outgoing){if(L.has(I))return[...L,I].join(" -> ");L.add(I);const p=this._findCycle(c,L);if(p)return p;L.delete(I)}}}i.Graph=D}),define(Q[25],Z([0,1,8,9,13]),function(x,i,C,D,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getMigratedSettingValue=i.merge=i.getConfigurationValue=i.removeFromValueTree=i.addToValueTree=i.toValuesTree=i.ConfigurationTargetToString=i.ConfigurationTarget=i.isConfigurationUpdateOverrides=i.isConfigurationOverrides=i.IConfigurationService=void 0,i.IConfigurationService=(0,P.createDecorator)("configurationService");function R(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof D.URI)}i.isConfigurationOverrides=R;function L(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||C.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof D.URI)}i.isConfigurationUpdateOverrides=L;var I;(function(a){a[a.USER=1]="USER",a[a.USER_LOCAL=2]="USER_LOCAL",a[a.USER_REMOTE=3]="USER_REMOTE",a[a.WORKSPACE=4]="WORKSPACE",a[a.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",a[a.DEFAULT=6]="DEFAULT",a[a.MEMORY=7]="MEMORY"})(I=i.ConfigurationTarget||(i.ConfigurationTarget={}));function c(a){switch(a){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}i.ConfigurationTargetToString=c;function p(a,f){const m=Object.create(null);for(let E in a)b(m,E,a[E],f);return m}i.toValuesTree=p;function b(a,f,m,E){const v=f.split("."),o=v.pop();let t=a;for(let r=0;r<v.length;r++){let e=v[r],n=t[e];switch(typeof n){case"undefined":n=t[e]=Object.create(null);break;case"object":break;default:E(`Ignoring ${f} as ${v.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}t=n}if(typeof t=="object"&&t!==null)try{t[o]=m}catch{E(`Ignoring ${f} as ${v.join(".")} is ${JSON.stringify(t)}`)}else E(`Ignoring ${f} as ${v.join(".")} is ${JSON.stringify(t)}`)}i.addToValueTree=b;function O(a,f){const m=f.split(".");h(a,m)}i.removeFromValueTree=O;function h(a,f){const m=f.shift();if(f.length===0){delete a[m];return}if(Object.keys(a).indexOf(m)!==-1){const E=a[m];typeof E=="object"&&!Array.isArray(E)&&(h(E,f),Object.keys(E).length===0&&delete a[m])}}function S(a,f,m){function E(t,r){let e=t;for(const n of r){if(typeof e!="object"||e===null)return;e=e[n]}return e}const v=f.split("."),o=E(a,v);return typeof o=="undefined"?m:o}i.getConfigurationValue=S;function y(a,f,m){Object.keys(f).forEach(E=>{E!=="__proto__"&&(E in a?C.isObject(a[E])&&C.isObject(f[E])?y(a[E],f[E],m):m&&(a[E]=f[E]):a[E]=f[E])})}i.merge=y;function g(a,f,m){const E=a.inspect(f),v=a.inspect(m);return typeof E.userValue!="undefined"||typeof E.workspaceValue!="undefined"||typeof E.workspaceFolderValue!="undefined"?E.value:typeof v.userValue!="undefined"||typeof v.workspaceValue!="undefined"||typeof v.workspaceFolderValue!="undefined"?v.value:E.defaultValue}i.getMigratedSettingValue=g}),define(Q[49],Z([0,1,13]),function(x,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IDownloadService=void 0,i.IDownloadService=(0,C.createDecorator)("downloadService")}),define(Q[19],Z([0,1,13]),function(x,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.INativeEnvironmentService=i.IEnvironmentService=void 0,i.IEnvironmentService=(0,C.createDecorator)("environmentService"),i.INativeEnvironmentService=(0,C.refineServiceDecorator)(i.IEnvironmentService)}),define(Q[93],Z([0,1,39,10,74,24,28,7,12,27,70,133,3]),function(x,i,C,D,P,R,L,I,c,p,b,O,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getResolvedShellEnv=void 0;const S=1e4;let y;async function g(f,m,E){return m["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):c.isWindows?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,O.isLaunchedFromCli)(E)&&!m["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,O.isLaunchedFromCli)(E)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=h.Promises.withAsyncBody(async(v,o)=>{const t=new R.CancellationTokenSource,r=setTimeout(()=>{t.dispose(!0),o(new Error((0,P.localize)(0,null)))},S);try{v(await a(f,t.token))}catch(e){!(0,I.isCancellationError)(e)&&!t.token.isCancellationRequested?o(new Error((0,P.localize)(1,null,(0,L.toErrorMessage)(e)))):v({})}finally{clearTimeout(r),t.dispose()}})),y)}i.getResolvedShellEnv=g;async function a(f,m){const E=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",E);const v=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",v);const o=(0,p.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(o+"(.*)"+o),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};f.trace("getUnixShellEnvironment#env",r);const e=await(0,b.getSystemShell)(c.OS,r);return f.trace("getUnixShellEnvironment#shell",e),new Promise((n,s)=>{if(m.isCancellationRequested)return s((0,I.canceled)());const l=(0,D.basename)(e);let u,d;const w=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(u=`& '${process.execPath}' ${w} -p '''${o}'' + JSON.stringify(process.env) + ''${o}'''`,d=["-Login","-Command"]):(u=`'${process.execPath}' ${w} -p '"${o}" + JSON.stringify(process.env) + "${o}"'`,l==="tcsh"?d=["-ic"]:d=["-ilc"]),f.trace("getUnixShellEnvironment#spawn",JSON.stringify(d),u);const T=(0,C.spawn)(e,[...d,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});m.onCancellationRequested(()=>(T.kill(),s((0,I.canceled)()))),T.on("error",Y=>{f.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(Y)),s(Y)});const N=[];T.stdout.on("data",Y=>N.push(Y));const _=[];T.stderr.on("data",Y=>_.push(Y)),T.on("close",(Y,re)=>{const te=Buffer.concat(N).toString("utf8");f.trace("getUnixShellEnvironment#raw",te);const ie=Buffer.concat(_).toString("utf8");if(ie.trim()&&f.trace("getUnixShellEnvironment#stderr",ie),Y||re)return s(new Error((0,P.localize)(2,null,Y,re)));const he=t.exec(te),j=he?he[1]:"{}";try{const q=JSON.parse(j);E?q.ELECTRON_RUN_AS_NODE=E:delete q.ELECTRON_RUN_AS_NODE,v?q.ELECTRON_NO_ATTACH_CONSOLE=v:delete q.ELECTRON_NO_ATTACH_CONSOLE,delete q.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",q),n(q)}catch(q){f.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)(q)),s(q)}})})}}),define(Q[50],Z([0,1,17,7,83,16]),function(x,i,C,D,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.readFileIntoStream=void 0;async function L(b,O,h,S,y,g){let a;try{await I(b,O,h,S,y,g)}catch(f){a=f}finally{a&&y.errorTransformer&&(a=y.errorTransformer(a)),typeof a!="undefined"&&h.error(a),h.end()}}i.readFileIntoStream=L;async function I(b,O,h,S,y,g){c(g);const a=await b.open(O,{create:!1});try{c(g);let f=0,m=0,E=y&&typeof y.length=="number"?y.length:void 0,v=C.VSBuffer.alloc(Math.min(y.bufferSize,typeof E=="number"?E:y.bufferSize)),o=y&&typeof y.position=="number"?y.position:0,t=0;do m=await b.read(a,o,v.buffer,t,v.byteLength-t),o+=m,t+=m,f+=m,typeof E=="number"&&(E-=m),t===v.byteLength&&(await h.write(S(v)),v=C.VSBuffer.alloc(Math.min(y.bufferSize,typeof E=="number"?E:y.bufferSize)),t=0);while(m>0&&(typeof E!="number"||E>0)&&c(g)&&p(f,y));if(t>0){let r=t;typeof E=="number"&&(r=Math.min(t,E)),h.write(S(v.slice(0,r)))}}catch(f){throw(0,R.ensureFileSystemProviderError)(f)}finally{await b.close(a)}}function c(b){if(b.isCancellationRequested)throw(0,D.canceled)();return!0}function p(b,O){if(O?.limits){if(typeof O.limits.memory=="number"&&b>O.limits.memory)throw(0,R.createFileSystemProviderError)((0,P.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof O.limits.size=="number"&&b>O.limits.size)throw(0,R.createFileSystemProviderError)((0,P.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[94],Z([0,1,18,6,2,12,134]),function(x,i,C,D,P,R,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NodeJSWatcher=void 0;class I extends P.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new D.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=D.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(p){const b=this.normalizeRequests(p),O=b.filter(S=>{const y=this.watchers.get(S.path);return y?!(0,C.equals)(y.request.excludes,S.excludes):!0}),h=Array.from(this.watchers.values()).filter(({request:S})=>!b.find(y=>y.path===S.path&&(0,C.equals)(y.excludes,S.excludes))).map(({request:S})=>S.path);O.length&&this.trace(`Request to start watching: ${O.map(S=>`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"})`).join(",")}`),h.length&&this.trace(`Request to stop watching: ${h.join(",")}`);for(const S of h)this.stopWatching(S);for(const S of O)this.startWatching(S)}startWatching(p){const b=new L.NodeJSFileWatcherLibrary(p,h=>this._onDidChangeFile.fire(h),h=>this._onDidLogMessage.fire(h),this.verboseLogging),O={request:p,instance:b};this.watchers.set(p.path,O)}async stop(){for(const[p]of this.watchers)this.stopWatching(p);this.watchers.clear()}stopWatching(p){const b=this.watchers.get(p);b&&(this.watchers.delete(p),b.instance.dispose())}normalizeRequests(p){const b=new Map;for(const O of p){const h=R.isLinux?O.path:O.path.toLowerCase();b.set(h,O)}return Array.from(b.values())}async setVerboseLogging(p){this.verboseLogging=p;for(const[,b]of this.watchers)b.instance.setVerboseLogging(p)}trace(p){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(p)})}toMessage(p,b){return b?`[File Watcher (node.js)] ${p} (path: ${b.request.path})`:`[File Watcher (node.js)] ${p}`}}i.NodeJSWatcher=I}),define(Q[95],Z([0,1,51,94]),function(x,i,C,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NodeJSWatcherClient=void 0;class P extends C.AbstractNonRecursiveWatcherClient{constructor(L,I,c){super(L,I,c);this.init()}createWatcher(){return new D.NodeJSWatcher}}i.NodeJSWatcherClient=P}),define(Q[96],Z([0,1,11,46,71,51]),function(x,i,C,D,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UniversalWatcherClient=void 0;class L extends R.AbstractUniversalWatcherClient{constructor(c,p,b){super(c,p,b);this.init()}createWatcher(c){const p=c.add(new P.Client(C.FileAccess.asFileUri("bootstrap-fork",x).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return c.add(p.onDidProcessExit(({code:b,signal:O})=>this.onError(`terminated by itself with code ${b}, signal: ${O}`))),D.ProxyChannel.toService((0,D.getNextTickChannel)(p.getChannel("watcher")))}}i.UniversalWatcherClient=L}),define(Q[52],Z([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ServiceCollection=void 0;class C{constructor(...P){this._entries=new Map;for(let[R,L]of P)this.set(R,L)}set(P,R){const L=this._entries.get(P);return this._entries.set(P,R),L}has(P){return this._entries.has(P)}get(P){return this._entries.get(P)}}i.ServiceCollection=C}),define(Q[97],Z([0,1,3,7,40,92,13,52]),function(x,i,C,D,P,R,L,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Trace=i.InstantiationService=void 0;const c=!1;class p extends Error{constructor(y){super("cyclic dependency between services");this.message=y.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${y.toString()}`}}class b{constructor(y=new I.ServiceCollection,g=!1,a){this._activeInstantiations=new Set,this._services=y,this._strict=g,this._parent=a,this._services.set(L.IInstantiationService,this)}createChild(y){return new b(y,this._strict,this)}invokeFunction(y,...g){let a=h.traceInvocation(y),f=!1;try{return y({get:E=>{if(f)throw(0,D.illegalState)("service accessor is only valid during the invocation of its target method");const v=this._getOrCreateServiceInstance(E,a);if(!v)throw new Error(`[invokeFunction] unknown service '${E}'`);return v}},...g)}finally{f=!0,a.stop()}}createInstance(y,...g){let a,f;return y instanceof P.SyncDescriptor?(a=h.traceCreation(y.ctor),f=this._createInstance(y.ctor,y.staticArguments.concat(g),a)):(a=h.traceCreation(y),f=this._createInstance(y,g,a)),a.stop(),f}_createInstance(y,g=[],a){let f=L._util.getServiceDependencies(y).sort((v,o)=>v.index-o.index),m=[];for(const v of f){let o=this._getOrCreateServiceInstance(v.id,a);if(!o&&this._strict&&!v.optional)throw new Error(`[createInstance] ${y.name} depends on UNKNOWN service ${v.id}.`);m.push(o)}let E=f.length>0?f[0].index:g.length;if(g.length!==E){console.warn(`[createInstance] First service dependency of ${y.name} at position ${E+1} conflicts with ${g.length} static arguments`);let v=E-g.length;v>0?g=g.concat(new Array(v)):g=g.slice(0,E)}return new y(...[...g,...m])}_setServiceInstance(y,g){if(this._services.get(y)instanceof P.SyncDescriptor)this._services.set(y,g);else if(this._parent)this._parent._setServiceInstance(y,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(y){let g=this._services.get(y);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(y):g}_getOrCreateServiceInstance(y,g){let a=this._getServiceInstanceOrDescriptor(y);return a instanceof P.SyncDescriptor?this._safeCreateAndCacheServiceInstance(y,a,g.branch(y,!0)):(g.branch(y,!1),a)}_safeCreateAndCacheServiceInstance(y,g,a){if(this._activeInstantiations.has(y))throw new Error(`illegal state - RECURSIVELY instantiating service '${y}'`);this._activeInstantiations.add(y);try{return this._createAndCacheServiceInstance(y,g,a)}finally{this._activeInstantiations.delete(y)}}_createAndCacheServiceInstance(y,g,a){const f=new R.Graph(v=>v.id.toString());let m=0;const E=[{id:y,desc:g,_trace:a}];for(;E.length;){const v=E.pop();if(f.lookupOrInsertNode(v),m++>1e3)throw new p(f);for(let o of L._util.getServiceDependencies(v.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(o.id);if(!t&&!o.optional&&console.warn(`[createInstance] ${y} depends on ${o.id} which is NOT registered.`),t instanceof P.SyncDescriptor){const r={id:o.id,desc:t,_trace:v._trace.branch(o.id,!0)};f.insertEdge(v,r),E.push(r)}}}for(;;){const v=f.roots();if(v.length===0){if(!f.isEmpty())throw new p(f);break}for(const{data:o}of v){if(this._getServiceInstanceOrDescriptor(o.id)instanceof P.SyncDescriptor){const r=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,r)}f.removeNode(o)}}return this._getServiceInstanceOrDescriptor(y)}_createServiceInstanceWithOwner(y,g,a=[],f,m){if(this._services.get(y)instanceof P.SyncDescriptor)return this._createServiceInstance(g,a,f,m);if(this._parent)return this._parent._createServiceInstanceWithOwner(y,g,a,f,m);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(y,g=[],a,f){if(a){const m=new C.IdleValue(()=>this._createInstance(y,g,f));return new Proxy(Object.create(null),{get(E,v){if(v in E)return E[v];let o=m.value,t=o[v];return typeof t!="function"||(t=t.bind(o),E[v]=t),t},set(E,v,o){return m.value[v]=o,!0}})}else return this._createInstance(y,g,f)}}i.InstantiationService=b;var O;(function(S){S[S.Creation=0]="Creation",S[S.Invocation=1]="Invocation",S[S.Branch=2]="Branch"})(O||(O={}));class h{constructor(y,g){this.type=y,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(y){return c?new h(1,y.name||y.toString().substring(0,42).replace(/\n/g,"")):h._None}static traceCreation(y){return c?new h(0,y.name):h._None}branch(y,g){let a=new h(2,y.toString());return this._dep.push([y,g,a]),a}stop(){let y=Date.now()-this._start;h._totals+=y;let g=!1;function a(m,E){let v=[],o=new Array(m+1).join("	");for(const[t,r,e]of E._dep)if(r&&e){g=!0,v.push(`${o}CREATES -> ${t}`);let n=a(m+1,e);n&&v.push(n)}else v.push(`${o}uses -> ${t}`);return v.join(`
`)}let f=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${a(1,this)}`,`DONE, took ${y.toFixed(2)}ms (grand total ${h._totals.toFixed(2)}ms)`];(y>2||g)&&console.log(f.join(`
`))}}i.Trace=h,h._None=new class extends h{constructor(){super(-1,null)}stop(){}branch(){return this}},h._totals=0}),define(Q[53],Z([0,1,13]),function(x,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isValidLocalization=i.ILocalizationsService=void 0,i.ILocalizationsService=(0,C.createDecorator)("localizationsService");function D(P){if(typeof P.languageId!="string"||!Array.isArray(P.translations)||P.translations.length===0)return!1;for(const R of P.translations)if(typeof R.id!="string"||typeof R.path!="string")return!1;return!(P.languageName&&typeof P.languageName!="string"||P.localizedLanguageName&&typeof P.localizedLanguageName!="string")}i.isValidLocalization=D}),define(Q[14],Z([0,1,28,6,2,12,13]),function(x,i,C,D,P,R,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LogLevelToString=i.parseLogLevel=i.getLogLevel=i.NullLogService=i.AbstractLoggerService=i.LogService=i.MultiplexLogService=i.AdapterLogger=i.ConsoleLogger=i.ConsoleMainLogger=i.AbstractMessageLogger=i.AbstractLogger=i.format=i.log=i.DEFAULT_LOG_LEVEL=i.LogLevel=i.ILoggerService=i.ILogService=void 0,i.ILogService=(0,L.createDecorator)("logService"),i.ILoggerService=(0,L.createDecorator)("loggerService");function I(){return new Date().toISOString()}var c;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(c=i.LogLevel||(i.LogLevel={})),i.DEFAULT_LOG_LEVEL=c.Info;function p(r,e,n){switch(e){case c.Trace:r.trace(n);break;case c.Debug:r.debug(n);break;case c.Info:r.info(n);break;case c.Warning:r.warn(n);break;case c.Error:r.error(n);break;case c.Critical:r.critical(n);break;default:throw new Error("Invalid log level")}}i.log=p;function b(r){let e="";for(let n=0;n<r.length;n++){let s=r[n];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}e+=(n>0?" ":"")+s}return e}i.format=b;class O extends P.Disposable{constructor(){super(...arguments);this.level=i.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}i.AbstractLogger=O;class h extends O{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...n){this.checkLogLevel(c.Trace)&&this.log(c.Trace,b([e,...n]))}debug(e,...n){this.checkLogLevel(c.Debug)&&this.log(c.Debug,b([e,...n]))}info(e,...n){this.checkLogLevel(c.Info)&&this.log(c.Info,b([e,...n]))}warn(e,...n){this.checkLogLevel(c.Warning)&&this.log(c.Warning,b([e,...n]))}error(e,...n){if(this.checkLogLevel(c.Error))if(e instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=e.stack,this.log(c.Error,b(s))}else this.log(c.Error,b([e,...n]))}critical(e,...n){this.checkLogLevel(c.Critical)&&this.log(c.Critical,b([e,...n]))}flush(){}}i.AbstractMessageLogger=h;class S extends O{constructor(e=i.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!R.isWindows}trace(e,...n){this.getLevel()<=c.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,e,...n):console.log(`[main ${I()}]`,e,...n))}debug(e,...n){this.getLevel()<=c.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,e,...n):console.log(`[main ${I()}]`,e,...n))}info(e,...n){this.getLevel()<=c.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,e,...n):console.log(`[main ${I()}]`,e,...n))}warn(e,...n){this.getLevel()<=c.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,e,...n):console.warn(`[main ${I()}]`,e,...n))}error(e,...n){this.getLevel()<=c.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,e,...n):console.error(`[main ${I()}]`,e,...n))}critical(e,...n){this.getLevel()<=c.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,e,...n):console.error(`[main ${I()}]`,e,...n))}dispose(){}flush(){}}i.ConsoleMainLogger=S;class y extends O{constructor(e=i.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...n){this.getLevel()<=c.Trace&&console.log("%cTRACE","color: #888",e,...n)}debug(e,...n){this.getLevel()<=c.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...n)}info(e,...n){this.getLevel()<=c.Info&&console.log("%c INFO","color: #33f",e,...n)}warn(e,...n){this.getLevel()<=c.Warning&&console.log("%c WARN","color: #993",e,...n)}error(e,...n){this.getLevel()<=c.Error&&console.log("%c  ERR","color: #f33",e,...n)}critical(e,...n){this.getLevel()<=c.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...n)}dispose(){}flush(){}}i.ConsoleLogger=y;class g extends O{constructor(e,n=i.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(n)}trace(e,...n){this.getLevel()<=c.Trace&&this.adapter.log(c.Trace,[this.extractMessage(e),...n])}debug(e,...n){this.getLevel()<=c.Debug&&this.adapter.log(c.Debug,[this.extractMessage(e),...n])}info(e,...n){this.getLevel()<=c.Info&&this.adapter.log(c.Info,[this.extractMessage(e),...n])}warn(e,...n){this.getLevel()<=c.Warning&&this.adapter.log(c.Warning,[this.extractMessage(e),...n])}error(e,...n){this.getLevel()<=c.Error&&this.adapter.log(c.Error,[this.extractMessage(e),...n])}critical(e,...n){this.getLevel()<=c.Critical&&this.adapter.log(c.Critical,[this.extractMessage(e),...n])}extractMessage(e){return typeof e=="string"?e:(0,C.toErrorMessage)(e,this.getLevel()<=c.Trace)}dispose(){}flush(){}}i.AdapterLogger=g;class a extends O{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const n of this.logServices)n.setLevel(e);super.setLevel(e)}trace(e,...n){for(const s of this.logServices)s.trace(e,...n)}debug(e,...n){for(const s of this.logServices)s.debug(e,...n)}info(e,...n){for(const s of this.logServices)s.info(e,...n)}warn(e,...n){for(const s of this.logServices)s.warn(e,...n)}error(e,...n){for(const s of this.logServices)s.error(e,...n)}critical(e,...n){for(const s of this.logServices)s.critical(e,...n)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}i.MultiplexLogService=a;class f extends P.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...n){this.logger.trace(e,...n)}debug(e,...n){this.logger.debug(e,...n)}info(e,...n){this.logger.info(e,...n)}warn(e,...n){this.logger.warn(e,...n)}error(e,...n){this.logger.error(e,...n)}critical(e,...n){this.logger.critical(e,...n)}flush(){this.logger.flush()}}i.LogService=f;class m extends P.Disposable{constructor(e,n){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(l=>l.setLevel(s))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,n){let s=this.loggers.get(e.toString());return s||(s=this.doCreateLogger(e,n?.always?c.Trace:this.logLevel,n),this.loggers.set(e.toString(),s),n?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}i.AbstractLoggerService=m;class E{constructor(){this.onDidChangeLogLevel=new D.Emitter().event}setLevel(e){}getLevel(){return c.Info}trace(e,...n){}debug(e,...n){}info(e,...n){}warn(e,...n){}error(e,...n){}critical(e,...n){}dispose(){}flush(){}}i.NullLogService=E;function v(r){if(r.verbose)return c.Trace;if(typeof r.logLevel=="string"){const e=o(r.logLevel.toLowerCase());if(e!==void 0)return e}return i.DEFAULT_LOG_LEVEL}i.getLogLevel=v;function o(r){switch(r){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Critical;case"off":return c.Off}}i.parseLogLevel=o;function t(r){switch(r){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Critical:return"critical";case c.Off:return"off"}}i.LogLevelToString=t});var ae=this&&this.__param||function(x,i){return function(C,D){i(C,D,x)}};define(Q[98],Z([0,1,39,3,28,6,2,11,10,15,19,14]),function(x,i,C,D,P,R,L,I,c,p,b,O){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsLifecycle=void 0;let h=class extends L.Disposable{constructor(y,g){super();this.environmentService=y,this.logService=g,this.processesLimiter=new D.Limiter(5)}async postUninstall(y){const g=this.parseScript(y,"uninstall");return g&&(this.logService.info(y.identifier.id,y.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(g.script,"uninstall",g.args,!0,y).then(()=>this.logService.info(y.identifier.id,y.manifest.version,"Finished running post uninstall script"),a=>this.logService.error(y.identifier.id,y.manifest.version,`Failed to run post uninstall script: ${a}`)))),p.Promises.rm(this.getExtensionStoragePath(y)).then(void 0,a=>this.logService.error("Error while removing extension storage path",a))}parseScript(y,g){const a=`vscode:${g}`;if(y.location.scheme===I.Schemas.file&&y.manifest&&y.manifest.scripts&&typeof y.manifest.scripts[a]=="string"){const f=y.manifest.scripts[a].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.logService.warn(y.identifier.id,y.manifest.version,`${a} should be a node script`),null):{script:(0,c.join)(y.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}runLifecycleHook(y,g,a,f,m){return new Promise((E,v)=>{const o=this.start(y,g,a,m);let t;const r=e=>{t&&(clearTimeout(t),t=null),e?v(e):E(void 0)};o.on("error",e=>{r((0,P.toErrorMessage)(e)||"Unknown")}),o.on("exit",(e,n)=>{r(e?`post-${g} process exited with code ${e}`:void 0)}),f&&(t=setTimeout(()=>{t=null,o.kill(),v("timed out")},5e3))})}start(y,g,a,f){const m={silent:!0,execArgv:void 0},E=(0,C.fork)(y,[`--type=extension-post-${g}`,...a],m);E.stdout.setEncoding("utf8"),E.stderr.setEncoding("utf8");const v=R.Event.fromNodeEventEmitter(E.stdout,"data"),o=R.Event.fromNodeEventEmitter(E.stderr,"data");v(e=>this.logService.info(f.identifier.id,f.manifest.version,`post-${g}`,e)),o(e=>this.logService.error(f.identifier.id,f.manifest.version,`post-${g}`,e));const t=R.Event.any(R.Event.map(v,e=>({data:`%c${e}`,format:[""]})),R.Event.map(o,e=>({data:`%c${e}`,format:["color: red"]})));return R.Event.debounce(t,(e,n)=>e?{data:e.data+n.data,format:[...e.format,...n.format]}:{data:n.data,format:n.format},100)(e=>{console.group(f.identifier.id),console.log(e.data,...e.format),console.groupEnd()}),E}getExtensionStoragePath(y){return(0,c.join)(this.environmentService.globalStorageHome.fsPath,y.identifier.id.toLowerCase())}};h=ge([ae(0,b.IEnvironmentService),ae(1,O.ILogService)],h),i.ExtensionsLifecycle=h}),define(Q[99],Z([0,1,18,3,7,6,2,10,51,14]),function(x,i,C,D,P,R,L,I,c,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractDiskFileSystemProvider=void 0;class b extends L.Disposable{constructor(h,S){super();this.logService=h,this.options=S,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new D.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new D.ThrottledDelayer(0))}watch(h,S){return S.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(h,S):this.watchNonRecursive(h,S)}watchUniversal(h,S){const y={path:this.toFilePath(h),excludes:S.excludes,recursive:S.recursive},g=(0,C.insert)(this.universalPathsToWatch,y);return this.refreshUniversalWatchers(),(0,L.toDisposable)(()=>{g(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(h=>(0,P.onUnexpectedError)(h))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(S=>this._onDidChangeFile.fire((0,c.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===p.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===p.LogLevel.Trace)})));const h=this.options?.watcher?.recursive?.usePolling;if(h===!0)for(const S of this.universalPathsToWatch)(0,c.isRecursiveWatchRequest)(S)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(h))for(const S of this.universalPathsToWatch)(0,c.isRecursiveWatchRequest)(S)&&h.includes(S.path)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(h,S){const y={path:this.toFilePath(h),excludes:S.excludes,recursive:!1},g=(0,C.insert)(this.nonRecursivePathsToWatch,y);return this.refreshNonRecursiveWatchers(),(0,L.toDisposable)(()=>{g(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(h=>(0,P.onUnexpectedError)(h))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(h=>this._onDidChangeFile.fire((0,c.toFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===p.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===p.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(h){h.type==="error"&&this._onDidWatchError.fire(h.message),this.logService[h.type](h.message)}toFilePath(h){return(0,I.normalize)(h.fsPath)}}i.AbstractDiskFileSystemProvider=b}),define(Q[100],Z([0,1,18,3,17,24,6,59,135,2,54,11,101,22,37,82,16,50,14]),function(x,i,C,D,P,R,L,I,c,p,b,O,h,S,y,g,a,f,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileService=void 0;let E=class extends p.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new L.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new L.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new L.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new L.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new L.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new D.ResourceQueue)}registerProvider(o,t){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,h.mark)(`code/registerFilesystem/${o}`);const r=new p.DisposableStore;return this.provider.set(o,t),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:t}),r.add(t.onDidChangeFile(e=>this._onDidFilesChange.fire(new a.FileChangesEvent(e,!this.isPathCaseSensitive(t))))),typeof t.onDidWatchError=="function"&&r.add(t.onDidWatchError(e=>this._onDidWatchError.fire(new Error(e)))),r.add(t.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:t,scheme:o}))),(0,p.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:t}),this.provider.delete(o),(0,p.dispose)(r)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const t=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(r){t.push(r)}}),!this.provider.has(o)&&await D.Promises.settled(t)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.provider.has(o.scheme)}hasCapability(o,t){const r=this.provider.get(o.scheme);return!!(r&&r.capabilities&t)}listCapabilities(){return c.Iterable.map(this.provider,([o,t])=>({scheme:o,capabilities:t.capabilities}))}async withProvider(o){if(!(0,S.isAbsolutePath)(o))throw new a.FileOperationError((0,g.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const t=this.provider.get(o.scheme);if(!t){const r=new Error;throw r.name="ENOPRO",r.message=(0,g.localize)(1,null,o.toString()),r}return t}async withReadProvider(o){const t=await this.withProvider(o);if((0,a.hasOpenReadWriteCloseCapability)(t)||(0,a.hasReadWriteCapability)(t)||(0,a.hasFileReadStreamCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const t=await this.withProvider(o);if((0,a.hasOpenReadWriteCloseCapability)(t)||(0,a.hasReadWriteCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,t){try{return await this.doResolveFile(o,t)}catch(r){throw(0,a.toFileSystemProviderErrorCode)(r)===a.FileSystemProviderErrorCode.FileNotFound?new a.FileOperationError((0,g.localize)(2,null,this.resourceForError(o)),1):(0,a.ensureFileSystemProviderError)(r)}}async doResolveFile(o,t){const r=await this.withProvider(o),e=this.isPathCaseSensitive(r),n=t?.resolveTo,s=t?.resolveSingleChildDescendants,l=t?.resolveMetadata,u=await r.stat(o);let d;return this.toFileStat(r,o,u,void 0,!!l,(w,T)=>(d||(d=b.TernarySearchTree.forUris(()=>!e),d.set(o,!0),n&&d.fill(!0,n)),d.get(w.resource)||d.findSuperstr(w.resource.with({query:null,fragment:null}))?!0:w.isDirectory&&s?T===1:!1))}async toFileStat(o,t,r,e,n,s){const{providerExtUri:l}=this.getExtUri(o),u={resource:t,name:l.basename(t),isFile:(r.type&a.FileType.File)!=0,isDirectory:(r.type&a.FileType.Directory)!=0,isSymbolicLink:(r.type&a.FileType.SymbolicLink)!=0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&a.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,a.etag)({mtime:r.mtime,size:r.size})};if(u.isDirectory&&s(u,e)){try{const d=await o.readdir(t),w=await D.Promises.settled(d.map(async([T,N])=>{try{const _=l.joinPath(t,T),Y=n?await o.stat(_):{type:N};return await this.toFileStat(o,_,Y,d.length,n,s)}catch(_){return this.logService.trace(_),null}}));u.children=(0,C.coalesce)(w)}catch(d){this.logService.trace(d),u.children=[]}return u}return u}async resolveAll(o){return D.Promises.settled(o.map(async t=>{try{return{stat:await this.doResolveFile(t.resource,t.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async exists(o){const t=await this.withProvider(o);try{return!!await t.stat(o)}catch{return!1}}async canCreateFile(o,t){try{await this.doValidateCreateFile(o,t)}catch(r){return r}return!0}async doValidateCreateFile(o,t){if(!t?.overwrite&&await this.exists(o))throw new a.FileOperationError((0,g.localize)(3,null,this.resourceForError(o)),3,t)}async createFile(o,t=P.VSBuffer.fromString(""),r){await this.doValidateCreateFile(o,r);const e=await this.writeFile(o,t);return this._onDidRunOperation.fire(new a.FileOperationEvent(o,0,e)),e}async writeFile(o,t,r){const e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:n}=this.getExtUri(e);try{await this.validateWriteFile(e,o,r)||await this.mkdirp(e,n.dirname(o));let l;if((0,a.hasReadWriteCapability)(e)&&!(t instanceof P.VSBuffer))if((0,y.isReadableStream)(t)){const u=await(0,y.peekStream)(t,3);u.ended?l=P.VSBuffer.concat(u.buffer):l=u}else l=(0,y.peekReadable)(t,u=>P.VSBuffer.concat(u),3);else l=t;!(0,a.hasOpenReadWriteCloseCapability)(e)||(0,a.hasReadWriteCapability)(e)&&l instanceof P.VSBuffer?await this.doWriteUnbuffered(e,o,r,l):await this.doWriteBuffered(e,o,r,l instanceof P.VSBuffer?(0,P.bufferToReadable)(l):l)}catch(s){throw new a.FileOperationError((0,g.localize)(4,null,this.resourceForError(o),(0,a.ensureFileSystemProviderError)(s).toString()),(0,a.toFileOperationResult)(s),r)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,t,r){if(!!r?.unlock&&!(o.capabilities&8192))throw new Error((0,g.localize)(5,null,this.resourceForError(t)));let n;try{n=await o.stat(t)}catch{return}if((n.type&a.FileType.Directory)!=0)throw new a.FileOperationError((0,g.localize)(6,null,this.resourceForError(t)),0,r);if(this.throwIfFileIsReadonly(t,n),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==a.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&r.mtime<n.mtime&&r.etag!==(0,a.etag)({mtime:r.mtime,size:n.size}))throw new a.FileOperationError((0,g.localize)(7,null),3,r);return n}async readFile(o,t,r){const e=await this.withReadProvider(o);return t?.atomic?this.doReadFileAtomic(e,o,t,r):this.doReadFile(e,o,t,r)}async doReadFileAtomic(o,t,r,e){return new Promise((n,s)=>{this.writeQueue.queueFor(t,this.getExtUri(o).providerExtUri).queue(async()=>{try{const l=await this.doReadFile(o,t,r,e);n(l)}catch(l){s(l)}})})}async doReadFile(o,t,r,e){const n=await this.doReadFileStream(o,t,{...r,preferUnbuffered:!0},e);return{...n,value:await(0,P.streamToBuffer)(n.value)}}async readFileStream(o,t,r){const e=await this.withReadProvider(o);return this.doReadFileStream(e,o,t,r)}async doReadFileStream(o,t,r,e){const n=new R.CancellationTokenSource(e),s=this.validateReadFile(t,r).then(u=>u,u=>{throw n.cancel(),u});let l;try{return typeof r?.etag=="string"&&r.etag!==a.ETAG_DISABLED&&await s,r?.atomic&&(0,a.hasFileAtomicReadCapability)(o)||!((0,a.hasOpenReadWriteCloseCapability)(o)||(0,a.hasFileReadStreamCapability)(o))||(0,a.hasReadWriteCapability)(o)&&r?.preferUnbuffered?l=this.readFileUnbuffered(o,t,r):(0,a.hasFileReadStreamCapability)(o)?l=this.readFileStreamed(o,t,n.token,r):l=this.readFileBuffered(o,t,n.token,r),{...await s,value:l}}catch(u){l&&await(0,y.consumeStream)(l);const d=(0,g.localize)(8,null,this.resourceForError(t),(0,a.ensureFileSystemProviderError)(u).toString());throw u instanceof a.NotModifiedSinceFileOperationError?new a.NotModifiedSinceFileOperationError(d,u.stat,r):new a.FileOperationError(d,(0,a.toFileOperationResult)(u),r)}}readFileStreamed(o,t,r,e=Object.create(null)){const n=o.readFileStream(t,e,r);return(0,y.transform)(n,{data:s=>s instanceof P.VSBuffer?s:P.VSBuffer.wrap(s),error:s=>new a.FileOperationError((0,g.localize)(9,null,this.resourceForError(t),(0,a.ensureFileSystemProviderError)(s).toString()),(0,a.toFileOperationResult)(s),e)},s=>P.VSBuffer.concat(s))}readFileBuffered(o,t,r,e=Object.create(null)){const n=(0,P.newWriteableBufferStream)();return(0,f.readFileIntoStream)(o,t,n,s=>s,{...e,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new a.FileOperationError((0,g.localize)(10,null,this.resourceForError(t),(0,a.ensureFileSystemProviderError)(s).toString()),(0,a.toFileOperationResult)(s),e)},r),n}readFileUnbuffered(o,t,r){const e=(0,y.newWriteableStream)(n=>P.VSBuffer.concat(n));return(async()=>{try{let n;r?.atomic&&(0,a.hasFileAtomicReadCapability)(o)?n=await o.readFile(t,{atomic:!0}):n=await o.readFile(t),typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.validateReadFileLimits(t,n.byteLength,r),e.end(P.VSBuffer.wrap(n))}catch(n){e.error(n),e.end()}})(),e}async validateReadFile(o,t){const r=await this.resolve(o,{resolveMetadata:!0});if(r.isDirectory)throw new a.FileOperationError((0,g.localize)(11,null,this.resourceForError(o)),0,t);if(typeof t?.etag=="string"&&t.etag!==a.ETAG_DISABLED&&t.etag===r.etag)throw new a.NotModifiedSinceFileOperationError((0,g.localize)(12,null),r,t);return this.validateReadFileLimits(o,r.size,t),r}validateReadFileLimits(o,t,r){if(r?.limits){let e;if(typeof r.limits.memory=="number"&&t>r.limits.memory&&(e=9),typeof r.limits.size=="number"&&t>r.limits.size&&(e=7),typeof e=="number")throw new a.FileOperationError((0,g.localize)(13,null,this.resourceForError(o)),e)}}async canMove(o,t,r){return this.doCanMoveCopy(o,t,"move",r)}async canCopy(o,t,r){return this.doCanMoveCopy(o,t,"copy",r)}async doCanMoveCopy(o,t,r,e){if(o.toString()!==t.toString())try{const n=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);await this.doValidateMoveCopy(n,o,s,t,r,e)}catch(n){return n}return!0}async move(o,t,r){const e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),s=await this.doMoveCopy(e,o,n,t,"move",!!r),l=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new a.FileOperationEvent(o,s==="move"?2:3,l)),l}async copy(o,t,r){const e=await this.withReadProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),s=await this.doMoveCopy(e,o,n,t,"copy",!!r),l=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new a.FileOperationEvent(o,s==="copy"?3:2,l)),l}async doMoveCopy(o,t,r,e,n,s){if(t.toString()===e.toString())return n;const{exists:l,isSameResourceWithDifferentPathCase:u}=await this.doValidateMoveCopy(o,t,r,e,n,s);if(l&&!u&&s&&await this.del(e,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(e)),n==="copy"){if(o===r&&(0,a.hasFileFolderCopyCapability)(o))await o.copy(t,e,{overwrite:s});else{const d=await this.resolve(t);d.isDirectory?await this.doCopyFolder(o,d,r,e):await this.doCopyFile(o,t,r,e)}return n}else return o===r?(await o.rename(t,e,{overwrite:s}),n):(await this.doMoveCopy(o,t,r,e,"copy",s),await this.del(t,{recursive:!0}),"copy")}async doCopyFile(o,t,r,e){if((0,a.hasOpenReadWriteCloseCapability)(o)&&(0,a.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(o,t,r,e);if((0,a.hasOpenReadWriteCloseCapability)(o)&&(0,a.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(o,t,r,e);if((0,a.hasReadWriteCapability)(o)&&(0,a.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(o,t,r,e);if((0,a.hasReadWriteCapability)(o)&&(0,a.hasReadWriteCapability)(r))return this.doPipeUnbuffered(o,t,r,e)}async doCopyFolder(o,t,r,e){await r.mkdir(e),Array.isArray(t.children)&&await D.Promises.settled(t.children.map(async n=>{const s=this.getExtUri(r).providerExtUri.joinPath(e,n.name);return n.isDirectory?this.doCopyFolder(o,await this.resolve(n.resource),r,s):this.doCopyFile(o,n.resource,r,s)}))}async doValidateMoveCopy(o,t,r,e,n,s){let l=!1;if(o===r){const{providerExtUri:d,isPathCaseSensitive:w}=this.getExtUri(o);if(w||(l=d.isEqual(t,e)),l&&n==="copy")throw new Error((0,g.localize)(14,null,this.resourceForError(t),this.resourceForError(e)));if(!l&&d.isEqualOrParent(e,t))throw new Error((0,g.localize)(15,null,this.resourceForError(t),this.resourceForError(e)))}const u=await this.exists(e);if(u&&!l){if(!s)throw new a.FileOperationError((0,g.localize)(16,null,this.resourceForError(t),this.resourceForError(e)),4);if(o===r){const{providerExtUri:d}=this.getExtUri(o);if(d.isEqualOrParent(t,e))throw new Error((0,g.localize)(17,null,this.resourceForError(t),this.resourceForError(e)))}}return{exists:u,isSameResourceWithDifferentPathCase:l}}getExtUri(o){const t=this.isPathCaseSensitive(o);return{providerExtUri:t?S.extUri:S.extUriIgnorePathCase,isPathCaseSensitive:t}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(t,o);const r=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new a.FileOperationEvent(o,0,r)),r}async mkdirp(o,t){const r=[],{providerExtUri:e}=this.getExtUri(o);for(;!e.isEqual(t,e.dirname(t));)try{if(((await o.stat(t)).type&a.FileType.Directory)==0)throw new Error((0,g.localize)(18,null,this.resourceForError(t)));break}catch(n){if((0,a.toFileSystemProviderErrorCode)(n)!==a.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(e.basename(t)),t=e.dirname(t)}for(let n=r.length-1;n>=0;n--){t=e.joinPath(t,r[n]);try{await o.mkdir(t)}catch(s){if((0,a.toFileSystemProviderErrorCode)(s)!==a.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(o,t){try{await this.doValidateDelete(o,t)}catch(r){return r}return!0}async doValidateDelete(o,t){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!t?.useTrash&&!(r.capabilities&4096))throw new Error((0,g.localize)(19,null,this.resourceForError(o)));let n;try{n=await r.stat(o)}catch{}if(n)this.throwIfFileIsReadonly(o,n);else throw new a.FileOperationError((0,g.localize)(20,null,this.resourceForError(o)),1);if(!!!t?.recursive){const l=await this.resolve(o);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,g.localize)(21,null,this.resourceForError(o)))}return r}async del(o,t){const r=await this.doValidateDelete(o,t),e=!!t?.useTrash,n=!!t?.recursive;await r.delete(o,{recursive:n,useTrash:e}),this._onDidRunOperation.fire(new a.FileOperationEvent(o,1))}watch(o,t={recursive:!1,excludes:[]}){const r=new p.DisposableStore;let e=!1,n=()=>{e=!0};return r.add((0,p.toDisposable)(()=>n())),(async()=>{try{const s=await this.doWatch(o,t);e?(0,p.dispose)(s):n=()=>(0,p.dispose)(s)}catch(s){this.logService.error(s)}})(),r}async doWatch(o,t){const r=await this.withProvider(o),e=(0,I.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(o),t]);let n=this.activeWatchers.get(e);return n||(n={count:0,disposable:r.watch(o,t)},this.activeWatchers.set(e,n)),n.count+=1,(0,p.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,p.dispose)(n.disposable),this.activeWatchers.delete(e)))})}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,p.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,t,r,e){return this.writeQueue.queueFor(t,this.getExtUri(o).providerExtUri).queue(async()=>{const n=await o.open(t,{create:!0,unlock:r?.unlock??!1});try{(0,y.isReadableStream)(e)||(0,y.isReadableBufferedStream)(e)?await this.doWriteStreamBufferedQueued(o,n,e):await this.doWriteReadableBufferedQueued(o,n,e)}catch(s){throw(0,a.ensureFileSystemProviderError)(s)}finally{await o.close(n)}})}async doWriteStreamBufferedQueued(o,t,r){let e=0,n;if((0,y.isReadableBufferedStream)(r)){if(r.buffer.length>0){const s=P.VSBuffer.concat(r.buffer);await this.doWriteBuffer(o,t,s,s.byteLength,e,0),e+=s.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((s,l)=>{(0,y.listenStream)(n,{onData:async u=>{n.pause();try{await this.doWriteBuffer(o,t,u,u.byteLength,e,0)}catch(d){return l(d)}e+=u.byteLength,setTimeout(()=>n.resume())},onError:u=>l(u),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(o,t,r){let e=0,n;for(;(n=r.read())!==null;)await this.doWriteBuffer(o,t,n,n.byteLength,e,0),e+=n.byteLength}async doWriteBuffer(o,t,r,e,n,s){let l=0;for(;l<e;)l+=await o.write(t,n+l,r.buffer,s+l,e-l)}async doWriteUnbuffered(o,t,r,e){return this.writeQueue.queueFor(t,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,t,r,e))}async doWriteUnbufferedQueued(o,t,r,e){let n;e instanceof P.VSBuffer?n=e:(0,y.isReadableStream)(e)?n=await(0,P.streamToBuffer)(e):(0,y.isReadableBufferedStream)(e)?n=await(0,P.bufferedStreamToBuffer)(e):n=(0,P.readableToBuffer)(e),await o.writeFile(t,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(o,t,r,e){return this.writeQueue.queueFor(e,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,t,r,e))}async doPipeBufferedQueued(o,t,r,e){let n,s;try{n=await o.open(t,{create:!1}),s=await r.open(e,{create:!0,unlock:!1});const l=P.VSBuffer.alloc(this.BUFFER_SIZE);let u=0,d=0,w=0;do w=await o.read(n,u,l.buffer,d,l.byteLength-d),await this.doWriteBuffer(r,s,l,w,u,d),u+=w,d+=w,d===l.byteLength&&(d=0);while(w>0)}catch(l){throw(0,a.ensureFileSystemProviderError)(l)}finally{await D.Promises.settled([typeof n=="number"?o.close(n):Promise.resolve(),typeof s=="number"?r.close(s):Promise.resolve()])}}async doPipeUnbuffered(o,t,r,e){return this.writeQueue.queueFor(e,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,t,r,e))}async doPipeUnbufferedQueued(o,t,r,e){return r.writeFile(e,await o.readFile(t),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,t,r,e){return this.writeQueue.queueFor(e,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,t,r,e))}async doPipeUnbufferedToBufferedQueued(o,t,r,e){const n=await r.open(e,{create:!0,unlock:!1});try{const s=await o.readFile(t);await this.doWriteBuffer(r,n,P.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,a.ensureFileSystemProviderError)(s)}finally{await r.close(n)}}async doPipeBufferedToUnbuffered(o,t,r,e){const n=await(0,P.streamToBuffer)(this.readFileBuffered(o,t,R.CancellationToken.None));await this.doWriteUnbuffered(r,e,void 0,n)}throwIfFileSystemIsReadonly(o,t){if(o.capabilities&2048)throw new a.FileOperationError((0,g.localize)(22,null,this.resourceForError(t)),6);return o}throwIfFileIsReadonly(o,t){if((t.permissions??0)&a.FilePermission.Readonly)throw new a.FileOperationError((0,g.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===O.Schemas.file?o.fsPath:o.toString(!0)}};E=ge([ae(0,m.ILogService)],E),i.FileService=E}),define(Q[102],Z([0,1,103,136,3,54,17,6,45,2,10,12,22,37,15,84,16,50,99,28,96,95]),function(x,i,C,D,P,R,L,I,c,p,b,O,h,S,y,g,a,f,m,E,v,o){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DiskFileSystemProvider=void 0,(()=>{try{(0,D.gracefulify)(C)}catch(r){console.error(`Error enabling graceful-fs: ${(0,E.toErrorMessage)(r)}`)}})();class t extends m.AbstractDiskFileSystemProvider{constructor(e,n){super(e,n);this.onDidChangeCapabilities=I.Event.None,this.resourceLocks=new R.ResourceMap(s=>h.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,O.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(e){try{const{stat:n,symbolicLink:s}=await y.SymlinkSupport.stat(this.toFilePath(e));return{type:this.toType(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(e){try{const n=await y.Promises.readdir(this.toFilePath(e),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async l=>{try{let u;l.isSymbolicLink()?u=(await this.stat((0,h.joinPath)(e,l.name))).type:u=this.toType(l),s.push([l.name,u])}catch(u){this.logService.trace(u)}})),s}catch(n){throw this.toFileSystemProviderError(n)}}toType(e,n){let s;return n?.dangling?s=a.FileType.Unknown:e.isFile()?s=a.FileType.File:e.isDirectory()?s=a.FileType.Directory:s=a.FileType.Unknown,n&&(s|=a.FileType.SymbolicLink),s}async createResourceLock(e){this.logService.trace(`[Disk FileSystemProvider]: request to acquire resource lock (${this.toFilePath(e)})`);let n;for(;n=this.resourceLocks.get(e);)this.logService.trace(`[Disk FileSystemProvider]: waiting for resource lock to be released (${this.toFilePath(e)})`),await n.wait();const s=new P.Barrier;return this.resourceLocks.set(e,s),this.logService.trace(`[Disk FileSystemProvider]: new resource lock created (${this.toFilePath(e)})`),(0,p.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: resource lock disposed (${this.toFilePath(e)})`),this.resourceLocks.delete(e),s.open()})}async readFile(e,n){let s;try{n?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(e)})`),s=await this.createResourceLock(e));const l=this.toFilePath(e);return await y.Promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}finally{s?.dispose()}}readFileStream(e,n,s){const l=(0,S.newWriteableStream)(u=>L.VSBuffer.concat(u.map(d=>L.VSBuffer.wrap(d))).buffer);return(0,f.readFileIntoStream)(this,e,l,u=>u.buffer,{...n,bufferSize:256*1024},s),l}async writeFile(e,n,s){let l;try{const u=this.toFilePath(e);if(!s.create||!s.overwrite){if(await y.Promises.exists(u)){if(!s.overwrite)throw(0,a.createFileSystemProviderError)((0,g.localize)(0,null),a.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,a.createFileSystemProviderError)((0,g.localize)(1,null),a.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(e,{create:!0,unlock:s.unlock}),await this.write(l,0,n,0,n.byteLength)}catch(u){throw await this.toFileSystemProviderWriteError(e,u)}finally{typeof l=="number"&&await this.close(l)}}async open(e,n){let s;(0,a.isFileOpenForWriteOptions)(n)&&(s=await this.createResourceLock(e));let l;try{const u=this.toFilePath(e);if((0,a.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:w}=await y.SymlinkSupport.stat(u);w.mode&128||await y.Promises.chmod(u,w.mode|128)}catch(w){this.logService.trace(w)}let d;if((0,a.isFileOpenForWriteOptions)(n)){if(O.isWindows)try{await y.Promises.truncate(u,0),d="r+"}catch(w){w.code!=="ENOENT"&&this.logService.trace(w)}d||(d="w")}else d="r";l=await y.Promises.open(u,d)}catch(u){throw s?.dispose(),(0,a.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(e,u):this.toFileSystemProviderError(u)}return this.mapHandleToPos.set(l,0),(0,a.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(l,e),s&&this.mapHandleToLock.set(l,s),l}async close(e){try{if(this.mapHandleToPos.delete(e),this.writeHandles.delete(e)&&this.canFlush)try{await y.Promises.fdatasync(e)}catch(n){this.canFlush=!1,this.logService.error(n)}return await y.Promises.close(e)}catch(n){throw this.toFileSystemProviderError(n)}finally{const n=this.mapHandleToLock.get(e);n&&(this.mapHandleToLock.delete(e),n.dispose())}}async read(e,n,s,l,u){const d=this.normalizePos(e,n);let w=null;try{const{bytesRead:T}=await y.Promises.read(e,s,l,u,d);return T}catch(T){throw this.toFileSystemProviderError(T)}finally{this.updatePos(e,d,w)}}normalizePos(e,n){return n===this.mapHandleToPos.get(e)?null:n}updatePos(e,n,s){const l=this.mapHandleToPos.get(e);typeof l=="number"&&(typeof n=="number"||(typeof s=="number"?this.mapHandleToPos.set(e,l+s):this.mapHandleToPos.delete(e)))}async write(e,n,s,l,u){return(0,P.retry)(()=>this.doWrite(e,n,s,l,u),100,3)}async doWrite(e,n,s,l,u){const d=this.normalizePos(e,n);let w=null;try{const{bytesWritten:T}=await y.Promises.write(e,s,l,u,d);return T}catch(T){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(e),T)}finally{this.updatePos(e,d,w)}}async mkdir(e){try{await y.Promises.mkdir(this.toFilePath(e))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(e,n){try{const s=this.toFilePath(e);n.recursive?await y.Promises.rm(s,y.RimRafMode.MOVE):await y.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(e,n,s){const l=this.toFilePath(e),u=this.toFilePath(n);if(l!==u)try{await this.validateTargetDeleted(e,n,"move",s.overwrite),await y.Promises.move(l,u)}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,g.localize)(2,null,(0,b.basename)(l),(0,b.basename)((0,b.dirname)(u)),d.toString()))),this.toFileSystemProviderError(d)}}async copy(e,n,s){const l=this.toFilePath(e),u=this.toFilePath(n);if(l!==u)try{await this.validateTargetDeleted(e,n,"copy",s.overwrite),await y.Promises.copy(l,u,{preserveSymlinks:!0})}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,g.localize)(3,null,(0,b.basename)(l),(0,b.basename)((0,b.dirname)(u)),d.toString()))),this.toFileSystemProviderError(d)}}async validateTargetDeleted(e,n,s,l){const u=this.toFilePath(e),d=this.toFilePath(n);let w=!1;if(!!(this.capabilities&1024)||(w=(0,c.isEqual)(u,d,!0)),w&&s==="copy")throw(0,a.createFileSystemProviderError)((0,g.localize)(4,null),a.FileSystemProviderErrorCode.FileExists);if(!w&&await y.Promises.exists(d)){if(!l)throw(0,a.createFileSystemProviderError)((0,g.localize)(5,null),a.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}createUniversalWatcher(e,n,s){return new v.UniversalWatcherClient(l=>e(l),l=>n(l),s)}createNonRecursiveWatcher(e,n,s){return new o.NodeJSWatcherClient(l=>e(l),l=>n(l),s)}toFileSystemProviderError(e){if(e instanceof a.FileSystemProviderError)return e;let n;switch(e.code){case"ENOENT":n=a.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=a.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=a.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=a.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=a.FileSystemProviderErrorCode.NoPermissions;break;default:n=a.FileSystemProviderErrorCode.Unknown}return(0,a.createFileSystemProviderError)(e,n)}async toFileSystemProviderWriteError(e,n){let s=this.toFileSystemProviderError(n);if(e&&s.code===a.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await y.SymlinkSupport.stat(this.toFilePath(e));l.mode&128||(s=(0,a.createFileSystemProviderError)(n,a.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.logService.trace(l)}return s}}i.DiskFileSystemProvider=t}),define(Q[104],Z([0,1,16,14]),function(x,i,C,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SpdLogLogger=void 0;async function P(I,c,p,b,O){try{const h=await new Promise((y,g)=>{x(["spdlog"],y,g)});h.setFlushOn(D.LogLevel.Trace);const S=await h.createAsyncRotatingLogger(I,c,p,b);return O&&S.clearFormatters(),S}catch(h){console.error(h)}return null}function R(I,c,p){switch(c){case D.LogLevel.Trace:I.trace(p);break;case D.LogLevel.Debug:I.debug(p);break;case D.LogLevel.Info:I.info(p);break;case D.LogLevel.Warning:I.warn(p);break;case D.LogLevel.Error:I.error(p);break;case D.LogLevel.Critical:I.critical(p);break;default:throw new Error("Invalid log level")}}class L extends D.AbstractMessageLogger{constructor(c,p,b,O,h){super();this.buffer=[],this.setLevel(h),this._loggerCreationPromise=this._createSpdLogLogger(c,p,b,O),this._register(this.onDidChangeLogLevel(S=>{this._logger&&this._logger.setLevel(S)}))}async _createSpdLogLogger(c,p,b,O){const h=b?6:1,S=30/h*C.ByteSize.MB,y=await P(c,p,S,h,O);if(y){this._logger=y,this._logger.setLevel(this.getLevel());for(const{level:g,message:a}of this.buffer)R(this._logger,g,a);this.buffer=[]}}log(c,p){this._logger?R(this._logger,c,p):this.getLevel()<=c&&this.buffer.push({level:c,message:p})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}i.SpdLogLogger=L}),define(Q[32],Z([0,1,13]),function(x,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.productSchemaId=i.IProductService=void 0,i.IProductService=(0,C.createDecorator)("productService"),i.productSchemaId="vscode://schemas/vscode-product"}),define(Q[29],Z([0,1,55,8]),function(x,i,C,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Registry=void 0;class P{constructor(){this.data=new Map}add(L,I){C.ok(D.isString(L)),C.ok(D.isObject(I)),C.ok(!this.data.has(L),"There is already an extension with this id"),this.data.set(L,I)}knows(L){return this.data.has(L)}as(L){return this.data.get(L)||null}}i.Registry=new P}),define(Q[105],Z([0,1,6,29]),function(x,i,C,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Extensions=void 0,i.Extensions={JSONContribution:"base.contributions.json"};function P(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class R{constructor(){this._onDidChangeSchema=new C.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(c,p){this.schemasById[P(c)]=p,this._onDidChangeSchema.fire(c)}notifySchemaChanged(c){this._onDidChangeSchema.fire(c)}getSchemaContributions(){return{schemas:this.schemasById}}}const L=new R;D.Registry.add(i.Extensions.JSONContribution,L)}),define(Q[33],Z([0,1,18,6,8,73,105,29]),function(x,i,C,D,P,R,L,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getScopes=i.validateProperty=i.getDefaultValue=i.keyFromOverrideIdentifiers=i.overrideIdentifiersFromKey=i.OVERRIDE_PROPERTY_REGEX=i.OVERRIDE_PROPERTY_PATTERN=i.configurationDefaultsSchemaId=i.resourceLanguageSettingsSchemaId=i.resourceSettings=i.windowSettings=i.machineOverridableSettings=i.machineSettings=i.applicationSettings=i.allSettings=i.ConfigurationScope=i.Extensions=i.EditPresentationTypes=void 0;var c;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(c=i.EditPresentationTypes||(i.EditPresentationTypes={})),i.Extensions={Configuration:"base.contributions.configuration"};var p;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(p=i.ConfigurationScope||(i.ConfigurationScope={})),i.allSettings={properties:{},patternProperties:{}},i.applicationSettings={properties:{},patternProperties:{}},i.machineSettings={properties:{},patternProperties:{}},i.machineOverridableSettings={properties:{},patternProperties:{}},i.windowSettings={properties:{},patternProperties:{}},i.resourceSettings={properties:{},patternProperties:{}},i.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",i.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=I.Registry.as(L.Extensions.JSONContribution);class O{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new D.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new D.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},b.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(o,t=!0){this.registerConfigurations([o],t)}registerConfigurations(o,t=!0){const r=this.doRegisterConfigurations(o,t);b.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(o){const t=this.doDeregisterConfigurations(o);b.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}updateConfigurations({add:o,remove:t}){const r=[];r.push(...this.doDeregisterConfigurations(t)),r.push(...this.doRegisterConfigurations(o,!1)),b.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,C.distinct)(r)})}registerDefaultConfigurations(o){const t=[],r=[];for(const{overrides:e,source:n}of o)for(const s in e)if(t.push(s),i.OVERRIDE_PROPERTY_REGEX.test(s)){const l={...this.configurationDefaultsOverrides.get(s)?.value||{},...e[s]};this.configurationDefaultsOverrides.set(s,{source:n,value:l});const u={type:"object",default:l,description:R.localize(1,null,s),$ref:i.resourceLanguageSettingsSchemaId,defaultDefaultValue:l,source:P.isString(n)?void 0:n};r.push(...y(s)),this.configurationProperties[s]=u,this.defaultLanguageConfigurationOverridesNode.properties[s]=u}else{this.configurationDefaultsOverrides.set(s,{value:e[s],source:n});const l=this.configurationProperties[s];l&&(this.updatePropertyDefaultValue(s,l),this.updateSchema(s,l))}this.registerOverrideIdentifiers(r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t,defaultsOverrides:!0})}deregisterDefaultConfigurations(o){const t=[];for(const{overrides:r,source:e}of o)for(const n in r){const s=this.configurationDefaultsOverrides.get(n),l=P.isString(e)?e:e?.id,u=P.isString(s?.source)?s?.source:s?.source?.id;if(l===u)if(t.push(n),this.configurationDefaultsOverrides.delete(n),i.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const d=this.configurationProperties[n];d&&(this.updatePropertyDefaultValue(n,d),this.updateSchema(n,d))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...o){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(o){for(const t of o)this.overrideIdentifiers.add(t);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(o,t){const r=[];return o.forEach(e=>{r.push(...this.validateAndRegisterProperties(e,t,e.extensionInfo,e.restrictedProperties)),this.configurationContributors.push(e),this.registerJSONConfiguration(e)}),r}doDeregisterConfigurations(o){const t=[],r=e=>{if(e.properties)for(const n in e.properties)t.push(n),delete this.configurationProperties[n],this.removeFromSchema(n,e.properties[n]);e.allOf&&e.allOf.forEach(n=>r(n))};for(const e of o){r(e);const n=this.configurationContributors.indexOf(e);n!==-1&&this.configurationContributors.splice(n,1)}return t}validateAndRegisterProperties(o,t=!0,r,e,n=3){n=P.isUndefinedOrNull(o.scope)?n:o.scope;let s=[],l=o.properties;if(l)for(let d in l){if(t&&m(d)){delete l[d];continue}const w=l[d];if(w.source=r,w.defaultDefaultValue=l[d].default,this.updatePropertyDefaultValue(d,w),i.OVERRIDE_PROPERTY_REGEX.test(d)?w.scope=void 0:(w.scope=P.isUndefinedOrNull(w.scope)?n:w.scope,w.restricted=P.isUndefinedOrNull(w.restricted)?!!e?.includes(d):w.restricted),l[d].hasOwnProperty("included")&&!l[d].included){this.excludedConfigurationProperties[d]=l[d],delete l[d];continue}else this.configurationProperties[d]=l[d];!l[d].deprecationMessage&&l[d].markdownDeprecationMessage&&(l[d].deprecationMessage=l[d].markdownDeprecationMessage),s.push(d)}let u=o.allOf;if(u)for(let d of u)s.push(...this.validateAndRegisterProperties(d,t,r,e,n));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(o){const t=r=>{let e=r.properties;if(e)for(const s in e)this.updateSchema(s,e[s]);let n=r.allOf;n&&n.forEach(t)};t(o)}updateSchema(o,t){switch(i.allSettings.properties[o]=t,t.scope){case 1:i.applicationSettings.properties[o]=t;break;case 2:i.machineSettings.properties[o]=t;break;case 6:i.machineOverridableSettings.properties[o]=t;break;case 3:i.windowSettings.properties[o]=t;break;case 4:i.resourceSettings.properties[o]=t;break;case 5:i.resourceSettings.properties[o]=t,this.resourceLanguageSettingsSchema.properties[o]=t;break}}removeFromSchema(o,t){switch(delete i.allSettings.properties[o],t.scope){case 1:delete i.applicationSettings.properties[o];break;case 2:delete i.machineSettings.properties[o];break;case 6:delete i.machineOverridableSettings.properties[o];break;case 3:delete i.windowSettings.properties[o];break;case 4:case 5:delete i.resourceSettings.properties[o],delete this.resourceLanguageSettingsSchema.properties[o];break}}updateOverridePropertyPatternKey(){for(const o of this.overrideIdentifiers.values()){const t=`[${o}]`,r={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:i.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(t,r),i.allSettings.properties[t]=r,i.applicationSettings.properties[t]=r,i.machineSettings.properties[t]=r,i.machineOverridableSettings.properties[t]=r,i.windowSettings.properties[t]=r,i.resourceSettings.properties[t]=r}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const o={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:i.resourceLanguageSettingsSchemaId};i.allSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=o,i.applicationSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=o,i.machineSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=o,i.machineOverridableSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=o,i.windowSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=o,i.resourceSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=o,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(o,t){const r=this.configurationDefaultsOverrides.get(o);let e=r?.value,n=r?.source;P.isUndefined(e)&&(e=t.defaultDefaultValue,n=void 0),P.isUndefined(e)&&(e=a(t.type)),t.default=e,t.defaultValueSource=n}}const h="\\[([^\\]]+)\\]",S=new RegExp(h,"g");i.OVERRIDE_PROPERTY_PATTERN=`^(${h})+$`,i.OVERRIDE_PROPERTY_REGEX=new RegExp(i.OVERRIDE_PROPERTY_PATTERN);function y(v){const o=[];if(i.OVERRIDE_PROPERTY_REGEX.test(v)){let t=S.exec(v);for(;t?.length;){const r=t[1].trim();r&&o.push(r),t=S.exec(v)}}return(0,C.distinct)(o)}i.overrideIdentifiersFromKey=y;function g(v){return v.reduce((o,t)=>`${o}[${t}]`,"")}i.keyFromOverrideIdentifiers=g;function a(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}i.getDefaultValue=a;const f=new O;I.Registry.add(i.Extensions.Configuration,f);function m(v){return v.trim()?i.OVERRIDE_PROPERTY_REGEX.test(v)?R.localize(7,null,v):f.getConfigurationProperties()[v]!==void 0?R.localize(8,null,v):null:R.localize(6,null)}i.validateProperty=m;function E(){const v=[],o=f.getConfigurationProperties();for(const t of Object.keys(o))v.push([t,o[t].scope]);return v.push(["launch",4]),v.push(["task",4]),v}i.getScopes=E}),define(Q[106],Z([0,1,18,6,56,2,54,21,8,9,25,33,29]),function(x,i,C,D,P,R,L,I,c,p,b,O,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AllKeysConfigurationChangeEvent=i.ConfigurationChangeEvent=i.mergeChanges=i.Configuration=i.UserSettings=i.ConfigurationModelParser=i.DefaultConfigurationModel=i.ConfigurationModel=void 0;class S{constructor(e={},n=[],s=[]){this._contents=e,this._keys=n,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,b.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,n){const s=this.getContentsForOverrideIdentifer(n);return s?e?(0,b.getConfigurationValue)(s,e):s:void 0}getKeysForOverrideIdentifier(e){const n=[];for(const s of this.overrides)s.identifiers.includes(e)&&n.push(...s.keys);return C.distinct(n)}getAllOverrideIdentifiers(){const e=[];for(const n of this.overrides)e.push(...n.identifiers);return C.distinct(e)}override(e){let n=this.overrideConfigurations.get(e);return n||(n=this.createOverrideConfigurationModel(e),this.overrideConfigurations.set(e,n)),n}merge(...e){const n=I.deepClone(this.contents),s=I.deepClone(this.overrides),l=[...this.keys];for(const u of e){this.mergeContents(n,u.contents);for(const d of u.overrides){const[w]=s.filter(T=>C.equals(T.identifiers,d.identifiers));w?(this.mergeContents(w.contents,d.contents),w.keys.push(...d.keys),w.keys=C.distinct(w.keys)):s.push(I.deepClone(d))}for(const d of u.keys)l.indexOf(d)===-1&&l.push(d)}return new S(n,l,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(e){const n=this.getContentsForOverrideIdentifer(e);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let s={};for(const l of C.distinct([...Object.keys(this.contents),...Object.keys(n)])){let u=this.contents[l],d=n[l];d&&(typeof u=="object"&&typeof d=="object"?(u=I.deepClone(u),this.mergeContents(u,d)):u=d),s[l]=u}return new S(s,this.keys,this.overrides)}mergeContents(e,n){for(const s of Object.keys(n)){if(s in e&&c.isObject(e[s])&&c.isObject(n[s])){this.mergeContents(e[s],n[s]);continue}e[s]=I.deepClone(n[s])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?I.deepFreeze(e):e}getContentsForOverrideIdentifer(e){let n=null,s=null;const l=u=>{u&&(s?this.mergeContents(s,u):s=I.deepClone(u))};for(const u of this.overrides)C.equals(u.identifiers,[e])?n=u.contents:u.identifiers.includes(e)&&l(u.contents);return l(n),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,n){this.addKey(e),(0,b.addToValueTree)(this.contents,e,n,s=>{throw new Error(s)})}removeValue(e){this.removeKey(e)&&(0,b.removeFromValueTree)(this.contents,e)}addKey(e){let n=this.keys.length;for(let s=0;s<n;s++)e.indexOf(this.keys[s])===0&&(n=s);this.keys.splice(n,1,e)}removeKey(e){let n=this.keys.indexOf(e);return n!==-1?(this.keys.splice(n,1),!0):!1}}i.ConfigurationModel=S;class y extends S{constructor(e={}){const n=h.Registry.as(O.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(n),l=Object.create(null),u=[];for(const d in n){const w=e[d],T=w!==void 0?w:n[d].default;(0,b.addToValueTree)(l,d,T,N=>console.error(`Conflict in default settings: ${N}`))}for(const d of Object.keys(l))O.OVERRIDE_PROPERTY_REGEX.test(d)&&u.push({identifiers:(0,O.overrideIdentifiersFromKey)(d),keys:Object.keys(l[d]),contents:(0,b.toValuesTree)(l[d],w=>console.error(`Conflict in default settings file: ${w}`))});super(l,s,u)}}i.DefaultConfigurationModel=y;class g{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new S}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,n){if(!c.isUndefinedOrNull(e)){const s=this.doParseContent(e);this.parseRaw(s,n)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,n){this._raw=e;const{contents:s,keys:l,overrides:u,restricted:d}=this.doParseRaw(e,n);this._configurationModel=new S(s,l,u),this._restrictedConfigurations=d||[]}doParseContent(e){let n={},s=null,l=[],u=[],d=[];function w(N){Array.isArray(l)?l.push(N):s!==null&&(l[s]=N)}let T={onObjectBegin:()=>{let N={};w(N),u.push(l),l=N,s=null},onObjectProperty:N=>{s=N},onObjectEnd:()=>{l=u.pop()},onArrayBegin:()=>{let N=[];w(N),u.push(l),l=N,s=null},onArrayEnd:()=>{l=u.pop()},onLiteralValue:w,onError:(N,_,Y)=>{d.push({error:N,offset:_,length:Y})}};if(e)try{P.visit(e,T),n=l[0]||{}}catch(N){console.error(`Error while parsing settings file ${this._name}: ${N}`),this._parseErrors=[N]}return n}doParseRaw(e,n){const s=h.Registry.as(O.Extensions.Configuration).getConfigurationProperties(),l=this.filter(e,s,!0,n);e=l.raw;const u=(0,b.toValuesTree)(e,T=>console.error(`Conflict in settings file ${this._name}: ${T}`)),d=Object.keys(e),w=this.toOverrides(e,T=>console.error(`Conflict in settings file ${this._name}: ${T}`));return{contents:u,keys:d,overrides:w,restricted:l.restricted}}filter(e,n,s,l){if(!l?.scopes&&!l?.skipRestricted)return{raw:e,restricted:[]};const u={},d=[];for(let w in e)if(O.OVERRIDE_PROPERTY_REGEX.test(w)&&s){const T=this.filter(e[w],n,!1,l);u[w]=T.raw,d.push(...T.restricted)}else{const T=n[w],N=T?typeof T.scope!="undefined"?T.scope:3:void 0;T?.restricted&&d.push(w),(N===void 0||l.scopes===void 0||l.scopes.includes(N))&&(l.skipRestricted&&T?.restricted||(u[w]=e[w]))}return{raw:u,restricted:d}}toOverrides(e,n){const s=[];for(const l of Object.keys(e))if(O.OVERRIDE_PROPERTY_REGEX.test(l)){const u={};for(const d in e[l])u[d]=e[l][d];s.push({identifiers:(0,O.overrideIdentifiersFromKey)(l),keys:Object.keys(u),contents:(0,b.toValuesTree)(u,n)})}return s}}i.ConfigurationModelParser=g;class a extends R.Disposable{constructor(e,n,s,l){super();this.userSettingsResource=e,this.scopes=n,this.fileService=l,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(D.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new S}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}i.UserSettings=a;class f{constructor(e,n,s=new S,l=new S,u=new L.ResourceMap,d=new S,w=new L.ResourceMap,T=!0){this._defaultConfiguration=e,this._localUserConfiguration=n,this._remoteUserConfiguration=s,this._workspaceConfiguration=l,this._folderConfigurations=u,this._memoryConfiguration=d,this._memoryConfigurationByResource=w,this._freeze=T,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(e,n,s){return this.getConsolidateConfigurationModel(n,s).getValue(e)}updateValue(e,n,s={}){let l;s.resource?(l=this._memoryConfigurationByResource.get(s.resource),l||(l=new S,this._memoryConfigurationByResource.set(s.resource,l))):l=this._memoryConfiguration,n===void 0?l.removeValue(e):l.setValue(e,n),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,n,s){const l=this.getConsolidateConfigurationModel(n,s),u=this.getFolderConfigurationModelForResource(n.resource,s),d=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,w=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),T=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),N=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),_=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),Y=s?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,re=u?n.overrideIdentifier?u.freeze().override(n.overrideIdentifier).getValue(e):u.freeze().getValue(e):void 0,te=n.overrideIdentifier?d.override(n.overrideIdentifier).getValue(e):d.getValue(e),ie=l.getValue(e),he=C.distinct(C.flatten(l.overrides.map(j=>j.identifiers))).filter(j=>l.getOverrideValue(e,j)!==void 0);return{defaultValue:w,userValue:T,userLocalValue:N,userRemoteValue:_,workspaceValue:Y,workspaceFolderValue:re,memoryValue:te,value:ie,default:w!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,user:T!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userLocal:N!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userRemote:_!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspace:Y!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspaceFolder:re!==void 0?{value:u?.freeze().getValue(e),override:n.overrideIdentifier?u?.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,memory:te!==void 0?{value:d.getValue(e),override:n.overrideIdentifier?d.getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:he.length?he:void 0}}keys(e){const n=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,n){this._folderConfigurations.set(e,n),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,n){const s=[];if(!n){const{added:l,updated:u,removed:d}=o(this._defaultConfiguration,e);n=[...l,...u,...d]}for(const l of n)for(const u of(0,O.overrideIdentifiersFromKey)(l)){const d=this._defaultConfiguration.getKeysForOverrideIdentifier(u),w=e.getKeysForOverrideIdentifier(u),T=[...w.filter(N=>d.indexOf(N)===-1),...d.filter(N=>w.indexOf(N)===-1),...d.filter(N=>!I.equals(this._defaultConfiguration.override(u).getValue(N),e.override(u).getValue(N)))];s.push([u,T])}return this.updateDefaultConfiguration(e),{keys:n,overrides:s}}compareAndUpdateLocalUserConfiguration(e){const{added:n,updated:s,removed:l,overrides:u}=o(this.localUserConfiguration,e),d=[...n,...s,...l];return d.length&&this.updateLocalUserConfiguration(e),{keys:d,overrides:u}}compareAndUpdateRemoteUserConfiguration(e){const{added:n,updated:s,removed:l,overrides:u}=o(this.remoteUserConfiguration,e);let d=[...n,...s,...l];return d.length&&this.updateRemoteUserConfiguration(e),{keys:d,overrides:u}}compareAndUpdateWorkspaceConfiguration(e){const{added:n,updated:s,removed:l,overrides:u}=o(this.workspaceConfiguration,e);let d=[...n,...s,...l];return d.length&&this.updateWorkspaceConfiguration(e),{keys:d,overrides:u}}compareAndUpdateFolderConfiguration(e,n){const s=this.folderConfigurations.get(e),{added:l,updated:u,removed:d,overrides:w}=o(s,n);let T=[...l,...u,...d];return(T.length||!s)&&this.updateFolderConfiguration(e,n),{keys:T,overrides:w}}compareAndDeleteFolderConfiguration(e){const n=this.folderConfigurations.get(e);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:s,updated:l,removed:u,overrides:d}=o(n,void 0);return{keys:[...s,...l,...u],overrides:d}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,n){let s=this.getConsolidatedConfigurationModelForResource(e,n);return e.overrideIdentifier?s.override(e.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:e},n){let s=this.getWorkspaceConsolidatedConfiguration();if(n&&e){const l=n.getFolder(e);l&&(s=this.getFolderConsolidatedConfiguration(l.uri)||s);const u=this._memoryConfigurationByResource.get(e);u&&(s=s.merge(u))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let n=this._foldersConsolidatedConfigurations.get(e);if(!n){const s=this.getWorkspaceConsolidatedConfiguration(),l=this._folderConfigurations.get(e);l?(n=s.merge(l),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(e,n)):n=s}return n}getFolderConfigurationModelForResource(e,n){if(n&&e){const s=n.getFolder(e);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,n)=>{const{contents:s,overrides:l,keys:u}=this._folderConfigurations.get(n);return e.push([n,{contents:s,overrides:l,keys:u}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>e.add(n)),this.userConfiguration.freeze().keys.forEach(n=>e.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>e.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(s=>e.add(s))),[...e.values()]}allOverrideIdentifiers(){const e=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>e.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>e.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>e.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(s=>e.add(s))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>n.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(e).forEach(l=>n.add(l))),[...n.values()]}static parse(e){const n=this.parseConfigurationModel(e.defaults),s=this.parseConfigurationModel(e.user),l=this.parseConfigurationModel(e.workspace),u=e.folders.reduce((d,w)=>(d.set(p.URI.revive(w[0]),this.parseConfigurationModel(w[1])),d),new L.ResourceMap);return new f(n,s,new S,l,u,new S,new L.ResourceMap,!1)}static parseConfigurationModel(e){return new S(e.contents,e.keys,e.overrides).freeze()}}i.Configuration=f;function m(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const e=new Set,n=new Map;for(const l of r)l.keys.forEach(u=>e.add(u)),l.overrides.forEach(([u,d])=>{const w=(0,L.getOrSet)(n,u,new Set);d.forEach(T=>w.add(T))});const s=[];return n.forEach((l,u)=>s.push([u,[...l.values()]])),{keys:[...e.values()],overrides:s}}i.mergeChanges=m;class E{constructor(e,n,s,l){this.change=e,this.previous=n,this.currentConfiguraiton=s,this.currentWorkspace=l,this._previousConfiguration=void 0;const u=new Set;e.keys.forEach(w=>u.add(w)),e.overrides.forEach(([,w])=>w.forEach(T=>u.add(T))),this.affectedKeys=[...u.values()];const d=new S;this.affectedKeys.forEach(w=>d.setValue(w,{})),this.affectedKeysTree=d.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=f.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(n){const s=this.previousConfiguration?this.previousConfiguration.getValue(e,n,this.previous?.workspace):void 0,l=this.currentConfiguraiton.getValue(e,n,this.currentWorkspace);return!I.equals(s,l)}return!0}return!1}doesAffectedKeysTreeContains(e,n){let s=(0,b.toValuesTree)({[n]:!0},()=>{}),l;for(;typeof s=="object"&&(l=Object.keys(s)[0]);){if(e=e[l],!e)return!1;s=s[l]}return!0}}i.ConfigurationChangeEvent=E;class v extends E{constructor(e,n,s,l){super({keys:e.allKeys(),overrides:[]},void 0,e,n);this.source=s,this.sourceConfig=l}}i.AllKeysConfigurationChangeEvent=v;function o(r,e){const{added:n,removed:s,updated:l}=t(e,r),u=[],d=r?.getAllOverrideIdentifiers()||[],w=e?.getAllOverrideIdentifiers()||[];if(e){const T=w.filter(N=>!d.includes(N));for(const N of T)u.push([N,e.getKeysForOverrideIdentifier(N)])}if(r){const T=d.filter(N=>!w.includes(N));for(const N of T)u.push([N,r.getKeysForOverrideIdentifier(N)])}if(e&&r){for(const T of d)if(w.includes(T)){const N=t({contents:r.getOverrideValue(void 0,T)||{},keys:r.getKeysForOverrideIdentifier(T)},{contents:e.getOverrideValue(void 0,T)||{},keys:e.getKeysForOverrideIdentifier(T)});u.push([T,[...N.added,...N.removed,...N.updated]])}}return{added:n,removed:s,updated:l,overrides:u}}function t(r,e){const n=r?e?r.keys.filter(u=>e.keys.indexOf(u)===-1):[...r.keys]:[],s=e?r?e.keys.filter(u=>r.keys.indexOf(u)===-1):[...e.keys]:[],l=[];if(r&&e){for(const u of e.keys)if(r.keys.indexOf(u)!==-1){const d=(0,b.getConfigurationValue)(e.contents,u),w=(0,b.getConfigurationValue)(r.contents,u);I.equals(d,w)||l.push(u)}}return{added:n,removed:s,updated:l}}}),define(Q[107],Z([0,1,3,6,2,22,25,106,33,29]),function(x,i,C,D,P,R,L,I,c,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ConfigurationService=void 0;class b extends P.Disposable{constructor(h,S){super();this.settingsResource=h,this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,S)),this.configuration=new I.Configuration(new I.DefaultConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new C.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(p.Registry.as(c.Extensions.Configuration).onDidUpdateConfiguration(({properties:y})=>this.onDidDefaultConfigurationChange(y))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const h=await this.userConfiguration.loadConfiguration();this.configuration=new I.Configuration(new I.DefaultConfigurationModel,h)}getConfigurationData(){return this.configuration.toData()}getValue(h,S){const y=typeof h=="string"?h:void 0,g=(0,L.isConfigurationOverrides)(h)?h:(0,L.isConfigurationOverrides)(S)?S:{};return this.configuration.getValue(y,g,void 0)}updateValue(h,S,y,g){return Promise.reject(new Error("not supported"))}inspect(h){return this.configuration.inspect(h,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const h=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(h)}onDidChangeUserConfiguration(h){const S=this.configuration.toData(),y=this.configuration.compareAndUpdateLocalUserConfiguration(h);this.trigger(y,S,1)}onDidDefaultConfigurationChange(h){const S=this.configuration.toData(),y=this.configuration.compareAndUpdateDefaultConfiguration(new I.DefaultConfigurationModel,h);this.trigger(y,S,6)}trigger(h,S,y){const g=new I.ConfigurationChangeEvent(h,{data:S},this.configuration);g.source=y,g.sourceConfig=this.getTargetConfiguration(y),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(h){switch(h){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}i.ConfigurationService=b}),define(Q[108],Z([0,1,11]),function(x,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getRemoteName=i.getRemoteAuthority=void 0;function D(R){return R.scheme===C.Schemas.vscodeRemote?R.authority:void 0}i.getRemoteAuthority=D;function P(R){if(!R)return;const L=R.indexOf("+");return L<0?R:R.substr(0,L)}i.getRemoteName=P}),define(Q[34],Z([0,1,26,13,108]),function(x,i,C,D,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IBuiltinExtensionsScannerService=i.isResolverExtension=i.isAuthenticationProviderExtension=i.isLanguagePackExtension=i.ExtensionIdentifier=i.ExtensionType=i.EXTENSION_CATEGORIES=i.isIExtensionIdentifier=i.getWorkspaceSupportTypeMessage=i.ALL_EXTENSION_KINDS=i.UNDEFINED_PUBLISHER=i.BUILTIN_MANIFEST_CACHE_FILE=i.USER_MANIFEST_CACHE_FILE=i.MANIFEST_CACHE_FOLDER=void 0,i.MANIFEST_CACHE_FOLDER="CachedExtensions",i.USER_MANIFEST_CACHE_FILE="user",i.BUILTIN_MANIFEST_CACHE_FILE="builtin",i.UNDEFINED_PUBLISHER="undefined_publisher",i.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}i.getWorkspaceSupportTypeMessage=R;function L(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}i.isIExtensionIdentifier=L,i.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(I=i.ExtensionType||(i.ExtensionType={}));class c{constructor(S){this.value=S,this._lower=S.toLowerCase()}static equals(S,y){if(typeof S=="undefined"||S===null)return typeof y=="undefined"||y===null;if(typeof y=="undefined"||y===null)return!1;if(typeof S=="string"||typeof y=="string"){let g=typeof S=="string"?S:S.value,a=typeof y=="string"?y:y.value;return C.equalsIgnoreCase(g,a)}return S._lower===y._lower}static toKey(S){return typeof S=="string"?S.toLowerCase():S._lower}}i.ExtensionIdentifier=c;function p(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}i.isLanguagePackExtension=p;function b(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}i.isAuthenticationProviderExtension=b;function O(h,S){if(S){const y=`onResolveRemoteAuthority:${(0,P.getRemoteName)(S)}`;return h.activationEvents?.indexOf(y)!==-1}return!1}i.isResolverExtension=O,i.IBuiltinExtensionsScannerService=(0,D.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[20],Z([0,1,26,34]),function(x,i,C,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getExtensionDependencies=i.getMaliciousExtensionsSet=i.BetterMergeId=i.getGalleryExtensionTelemetryData=i.getLocalExtensionTelemetryData=i.groupByExtension=i.getGalleryExtensionId=i.adoptToGalleryExtensionId=i.getExtensionId=i.ExtensionIdentifierWithVersion=i.areSameExtensions=void 0;function P(y,g){return y.uuid&&g.uuid?y.uuid===g.uuid:y.id===g.id?!0:(0,C.compareIgnoreCase)(y.id,g.id)===0}i.areSameExtensions=P;class R{constructor(g,a){this.version=a,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof R?P(this,g)&&this.version===g.version:!1}}i.ExtensionIdentifierWithVersion=R;function L(y,g){return`${y}.${g}`}i.getExtensionId=L;function I(y){return y.toLocaleLowerCase()}i.adoptToGalleryExtensionId=I;function c(y,g){return I(L(y,g))}i.getGalleryExtensionId=c;function p(y,g){const a=[],f=m=>{for(const E of a)if(E.some(v=>P(g(v),g(m))))return E;return null};for(const m of y){const E=f(m);E?E.push(m):a.push([m])}return a}i.groupByExtension=p;function b(y){return{id:y.identifier.id,name:y.manifest.name,galleryId:null,publisherId:y.publisherId,publisherName:y.manifest.publisher,publisherDisplayName:y.publisherDisplayName,dependencies:y.manifest.extensionDependencies&&y.manifest.extensionDependencies.length>0}}i.getLocalExtensionTelemetryData=b;function O(y){return{id:y.identifier.id,name:y.name,galleryId:y.identifier.uuid,publisherId:y.publisherId,publisherName:y.publisher,publisherDisplayName:y.publisherDisplayName,isPreReleaseVersion:y.properties.isPreReleaseVersion,dependencies:!!(y.properties.dependencies&&y.properties.dependencies.length>0),...y.telemetryData}}i.getGalleryExtensionTelemetryData=O,i.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function h(y){const g=new Set;if(y.malicious)for(const a of y.malicious)g.add(a.id);return g}i.getMaliciousExtensionsSet=h;function S(y,g){const a=[],f=g.manifest.extensionDependencies?.slice(0)??[];for(;f.length;){const m=f.shift();if(m&&a.every(E=>!P(E.identifier,{id:m}))){const E=y.filter(v=>P(v.identifier,{id:m}));E.length===1&&(a.push(E[0]),f.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}i.getExtensionDependencies=S}),define(Q[23],Z([0,1,11,76,20,13]),function(x,i,C,D,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IExtensionManagementCLIService=i.PreferencesLocalizedLabel=i.PreferencesLabel=i.ExtensionsChannelId=i.ExtensionsLocalizedLabel=i.ExtensionsLabel=i.DefaultIconPath=i.IExtensionTipsService=i.IGlobalExtensionEnablementService=i.ENABLED_EXTENSIONS_STORAGE_PATH=i.DISABLED_EXTENSIONS_STORAGE_PATH=i.IExtensionManagementService=i.ExtensionManagementError=i.ExtensionManagementErrorCode=i.IExtensionGalleryService=i.InstallOperation=i.StatisticType=i.SortOrder=i.SortBy=i.isIExtensionIdentifier=i.getFallbackTargetPlarforms=i.isTargetPlatformCompatible=i.isNotWebExtensionInWebTargetPlatform=i.getTargetPlatform=i.toTargetPlatform=i.TargetPlatformToString=i.TargetPlatform=i.getIdAndVersion=i.WEB_EXTENSION_TAG=i.EXTENSION_IDENTIFIER_REGEX=i.EXTENSION_IDENTIFIER_PATTERN=void 0,i.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",i.EXTENSION_IDENTIFIER_REGEX=new RegExp(i.EXTENSION_IDENTIFIER_PATTERN),i.WEB_EXTENSION_TAG="__web_extension";const L=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function I(t){const r=L.exec(t);return r&&r[1]?[(0,P.adoptToGalleryExtensionId)(r[1]),r[2]]:[(0,P.adoptToGalleryExtensionId)(t),void 0]}i.getIdAndVersion=I;var c;(function(t){t.WIN32_X64="win32-x64",t.WIN32_IA32="win32-ia32",t.WIN32_ARM64="win32-arm64",t.LINUX_X64="linux-x64",t.LINUX_ARM64="linux-arm64",t.LINUX_ARMHF="linux-armhf",t.ALPINE_X64="alpine-x64",t.ALPINE_ARM64="alpine-arm64",t.DARWIN_X64="darwin-x64",t.DARWIN_ARM64="darwin-arm64",t.WEB="web",t.UNIVERSAL="universal",t.UNKNOWN="unknown",t.UNDEFINED="undefined"})(c=i.TargetPlatform||(i.TargetPlatform={}));function p(t){switch(t){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}i.TargetPlatformToString=p;function b(t){switch(t){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}i.toTargetPlatform=b;function O(t,r){switch(t){case 3:return r==="x64"?"win32-x64":r==="ia32"?"win32-ia32":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}i.getTargetPlatform=O;function h(t,r){return r==="web"&&!t.includes("web")}i.isNotWebExtensionInWebTargetPlatform=h;function S(t,r,e){return h(r,e)?!1:t==="undefined"||t==="universal"?!0:t==="unknown"?!1:t===e?!0:y(e).includes(t)}i.isTargetPlatformCompatible=S;function y(t){switch(t){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}i.getFallbackTargetPlarforms=y;function g(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}i.isIExtensionIdentifier=g;var a;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(a=i.SortBy||(i.SortBy={}));var f;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(f=i.SortOrder||(i.SortOrder={}));var m;(function(t){t.Install="install",t.Uninstall="uninstall"})(m=i.StatisticType||(i.StatisticType={}));var E;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(E=i.InstallOperation||(i.InstallOperation={})),i.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService");var v;(function(t){t.Unsupported="Unsupported",t.UnsupportedPreRelease="UnsupportedPreRelease",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatiblePreRelease="IncompatiblePreRelease",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.Extract="Extract",t.Delete="Delete",t.Rename="Rename",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Internal="Internal"})(v=i.ExtensionManagementErrorCode||(i.ExtensionManagementErrorCode={}));class o extends Error{constructor(r,e){super(r);this.code=e,this.name=e}}i.ExtensionManagementError=o,i.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),i.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",i.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",i.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),i.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),i.DefaultIconPath=C.FileAccess.asBrowserUri("./media/defaultIcon.png",x).toString(!0),i.ExtensionsLabel=(0,D.localize)(0,null),i.ExtensionsLocalizedLabel={value:i.ExtensionsLabel,original:"Extensions"},i.ExtensionsChannelId="extensions",i.PreferencesLabel=(0,D.localize)(1,null),i.PreferencesLocalizedLabel={value:i.PreferencesLabel,original:"Preferences"},i.IExtensionManagementCLIService=(0,R.createDecorator)("IExtensionManagementCLIService")}),define(Q[109],Z([0,1,24,7,62,11,41,9,77,23,20,34]),function(x,i,C,D,P,R,L,I,c,p,b,O){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementCLIService=void 0;const h=a=>(0,c.localize)(0,null,a),S=(0,c.localize)(1,null,"ms-dotnettools.csharp");function y(a,f){return f?`${a.publisher}.${a.name}@${a.version}`:`${a.publisher}.${a.name}`}let g=class{constructor(f,m){this.extensionManagementService=f,this.extensionGalleryService=m}get location(){}async listExtensions(f,m,E=console){let v=await this.extensionManagementService.getInstalled(1);const o=O.EXTENSION_CATEGORIES.map(r=>r.toLowerCase());if(m&&m!==""){if(o.indexOf(m.toLowerCase())<0){E.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}v=v.filter(r=>r.manifest.categories?r.manifest.categories.map(n=>n.toLowerCase()).indexOf(m.toLowerCase())>-1:!1)}else if(m===""){E.log("Possible Categories: "),o.forEach(r=>{E.log(r)});return}this.location&&E.log((0,c.localize)(2,null,this.location)),v=v.sort((r,e)=>r.identifier.id.localeCompare(e.identifier.id));let t;for(let r of v)t!==r.identifier.id&&(t=r.identifier.id,E.log(y(r.manifest,f)))}async installExtensions(f,m,E,v,o=console){const t=[],r=[];f.length&&o.log(this.location?(0,c.localize)(3,null,this.location):(0,c.localize)(4,null));const e=await this.extensionManagementService.getInstalled(1),n=(u,d)=>{const w=e.find(T=>(0,b.areSameExtensions)(T.identifier,{id:u}));if(w){if(!d&&!v)return o.log((0,c.localize)(5,null,u,w.manifest.version,u)),!1;if(d&&w.manifest.version===d)return o.log((0,c.localize)(6,null,`${u}@${d}`)),!1}return!0},s=[],l=[];for(const u of f)if(u instanceof I.URI)s.push(u);else{const[d,w]=(0,p.getIdAndVersion)(u);n(d,w)&&l.push({id:d,version:w,installOptions:{...E,isBuiltin:!1}})}for(const u of m){const[d,w]=(0,p.getIdAndVersion)(u);n(d,w)&&l.push({id:d,version:w,installOptions:{...E,isBuiltin:!0}})}if(s.length&&await Promise.all(s.map(async u=>{try{const d=await this.installVSIX(u,{...E,isBuiltin:!1},v,o);d&&r.push(d)}catch(d){o.error(d.message||d.stack||d),t.push(u.toString())}})),l.length){const u=await this.getGalleryExtensions(l);await Promise.all(l.map(async d=>{const w=u.get(d.id.toLowerCase());if(w)try{const T=await this.installFromGallery(d,w,e,v,o);T&&r.push(T)}catch(T){o.error(T.message||T.stack||T),t.push(d.id)}else o.error(`${h(d.version?`${d.id}@${d.version}`:d.id)}
${S}`),t.push(d.id)}))}if(t.length)throw new Error((0,c.localize)(7,null,t.join(", ")))}async installVSIX(f,m,E,v){const o=await this.extensionManagementService.getManifest(f);if(!o)throw new Error("Invalid vsix");if(await this.validateVSIX(o,E,v))try{return await this.extensionManagementService.install(f,m),v.log((0,c.localize)(8,null,(0,P.getBaseLabel)(f))),o}catch(r){if((0,D.isCancellationError)(r))return v.log((0,c.localize)(9,null,(0,P.getBaseLabel)(f))),null;throw r}return null}async getGalleryExtensions(f){const m=new Map,E=f.some(o=>o.installOptions.installPreReleaseVersion),v=await this.extensionGalleryService.getExtensions(f.map(o=>({...o,preRelease:E})),C.CancellationToken.None);for(const o of v)m.set(o.identifier.id.toLowerCase(),o);return m}async installFromGallery({id:f,version:m,installOptions:E},v,o,t,r){const e=await this.extensionGalleryService.getManifest(v,C.CancellationToken.None);if(e&&!this.validateExtensionKind(e,r))return null;const n=o.find(s=>(0,b.areSameExtensions)(s.identifier,v.identifier));if(n){if(v.version===n.manifest.version)return r.log((0,c.localize)(10,null,m?`${f}@${m}`:f)),null;r.log((0,c.localize)(11,null,f,v.version))}try{return E.isBuiltin?r.log(m?(0,c.localize)(12,null,f,m):(0,c.localize)(13,null,f)):r.log(m?(0,c.localize)(14,null,f,m):(0,c.localize)(15,null,f)),await this.extensionManagementService.installFromGallery(v,{...E,installGivenVersion:!!m}),r.log((0,c.localize)(16,null,f,v.version)),e}catch(s){if((0,D.isCancellationError)(s))return r.log((0,c.localize)(17,null,f)),null;throw s}}validateExtensionKind(f,m){return!0}async validateVSIX(f,m,E){const v={id:(0,b.getGalleryExtensionId)(f.publisher,f.name)},t=(await this.extensionManagementService.getInstalled(1)).find(r=>(0,b.areSameExtensions)(v,r.identifier)&&(0,L.gt)(r.manifest.version,f.version));return t&&!m?(E.log((0,c.localize)(18,null,t.identifier.id,t.manifest.version,f.version)),!1):this.validateExtensionKind(f,E)}async uninstallExtensions(f,m,E=console){const v=async t=>{if(t instanceof I.URI){const r=await this.extensionManagementService.getManifest(t);return y(r)}return t},o=[];for(const t of f){const r=await v(t),n=(await this.extensionManagementService.getInstalled()).filter(s=>(0,b.areSameExtensions)(s.identifier,{id:r}));if(!n.length)throw new Error(`${this.notInstalled(r)}
${S}`);if(n.some(s=>s.type===0)){E.log((0,c.localize)(19,null,r));return}if(!m&&n.some(s=>s.isBuiltin)){E.log((0,c.localize)(20,null,r));return}E.log((0,c.localize)(21,null,r));for(const s of n)await this.extensionManagementService.uninstall(s),o.push(s);this.location?E.log((0,c.localize)(22,null,r,this.location)):E.log((0,c.localize)(23,null,r))}}async locateExtension(f,m=console){const E=await this.extensionManagementService.getInstalled();f.forEach(v=>{E.forEach(o=>{if(o.identifier.id===v&&o.location.scheme===R.Schemas.file){m.log(o.location.fsPath);return}})})}notInstalled(f){return this.location?(0,c.localize)(24,null,f,this.location):(0,c.localize)(25,null,f)}};g=ge([ae(0,p.IExtensionManagementService),ae(1,p.IExtensionGalleryService)],g),i.ExtensionManagementCLIService=g}),define(Q[110],Z([0,1,3,7,2,12,22,41,9,27,15,19,23,20,16,14]),function(x,i,C,D,P,R,L,I,c,p,b,O,h,S,y,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsDownloader=void 0;const a=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let f=class extends P.Disposable{constructor(E,v,o,t){super();this.fileService=v,this.extensionGalleryService=o,this.logService=t,this.extensionsDownloadDir=c.URI.file(E.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(E,v){await this.cleanUpPromise;const o=this.getName(E),t=(0,L.joinPath)(this.extensionsDownloadDir,o);if(!await this.fileService.exists(t)){const r=(0,L.joinPath)(this.extensionsDownloadDir,`.${(0,p.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(E,r,v);try{await this.rename(r,t,Date.now()+2*60*1e3)}catch(e){try{await this.fileService.del(r)}catch{}if(e.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",E.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(e)}. Deleted the vsix from downloaded location`,r.path),e}}return t}async delete(E){await this.cleanUpPromise,await this.fileService.del(E)}async rename(E,v,o){try{await b.Promises.rename(E.fsPath,v.fsPath)}catch(t){if(R.isWindows&&t&&t.code==="EPERM"&&Date.now()<o)return this.logService.info(`Failed renaming ${E} to ${v} with 'EPERM' error. Trying again...`),this.rename(E,v,o);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const E=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(E.children){const v=[],o=[];for(const e of E.children){const n=this.parse(e.name);n&&o.push([n,e])}const t=(0,S.groupByExtension)(o,([e])=>e),r=[];for(const e of t)e.sort((n,s)=>I.rcompare(n[0].version,s[0].version)),v.push(...e.slice(1).map(n=>n[1].resource)),r.push(e[0][1]);r.sort((e,n)=>e.mtime-n.mtime),v.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(e=>e.resource)),await C.Promises.settled(v.map(e=>(this.logService.trace("Deleting vsix from cache",e.path),this.fileService.del(e))))}}catch(E){this.logService.error(E)}}getName(E){return this.cache?`${new S.ExtensionIdentifierWithVersion(E.identifier,E.version).key().toLowerCase()}${E.properties.targetPlatform!=="undefined"?`-${E.properties.targetPlatform}`:""}`:(0,p.generateUuid)()}parse(E){const v=a.exec(E);return v&&v[1]&&v[2]?new S.ExtensionIdentifierWithVersion({id:v[1]},v[2]):null}};f=ge([ae(0,O.INativeEnvironmentService),ae(1,y.IFileService),ae(2,h.IExtensionGalleryService),ae(3,g.ILogService)],f),i.ExtensionsDownloader=f}),define(Q[111],Z([0,1,2,10,15,34]),function(x,i,C,D,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsManifestCache=void 0;class L extends C.Disposable{constructor(c,p){super();this.environmentService=c,this.extensionsManifestCache=(0,D.join)(this.environmentService.userDataPath,R.MANIFEST_CACHE_FOLDER,R.USER_MANIFEST_CACHE_FILE),this._register(p.onDidInstallExtensions(b=>this.onDidInstallExtensions(b))),this._register(p.onDidUninstallExtension(b=>this.onDidUnInstallExtension(b)))}onDidInstallExtensions(c){c.some(p=>!!p.local)&&this.invalidate()}onDidUnInstallExtension(c){c.error||this.invalidate()}invalidate(){P.Promises.rm(this.extensionsManifestCache,P.RimRafMode.MOVE).then(()=>{},()=>{})}}i.ExtensionsManifestCache=L}),define(Q[112],Z([0,1,137,18,3,2,11,10,15,19,23,20,53,14]),function(x,i,C,D,P,R,L,I,c,p,b,O,h,S){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LocalizationsService=void 0;let y=class extends R.Disposable{constructor(f,m,E){super();this.extensionManagementService=f,this.logService=E,this.cache=this._register(new g(m,E)),this.extensionManagementService.registerParticipant({postInstall:async v=>this.postInstallExtension(v),postUninstall:async v=>this.postUninstallExtension(v)})}async getLanguageIds(){const f=await this.cache.getLanguagePacks(),m=["en",...Object.keys(f)];return(0,D.distinct)(m)}async postInstallExtension(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",f.identifier.id),await this.update())}async postUninstallExtension(f){const m=await this.cache.getLanguagePacks();Object.keys(m).some(E=>m[E]&&m[E].extensions.some(v=>(0,O.areSameExtensions)(v.extensionIdentifier,f.identifier)))&&(this.logService.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,m]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),E=await this.cache.update(m);return!(0,D.equals)(Object.keys(f),Object.keys(E))}};y=ge([ae(0,b.IExtensionManagementService),ae(1,p.INativeEnvironmentService),ae(2,S.ILogService)],y),i.LocalizationsService=y;let g=class extends R.Disposable{constructor(f,m){super();this.logService=m,this.languagePacks={},this.languagePacksFilePath=(0,I.join)(f.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new P.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(f){return this.withLanguagePacks(m=>{Object.keys(m).forEach(E=>delete m[E]),this.createLanguagePacksFromExtensions(m,...f)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(f,...m){for(const E of m)E&&E.manifest&&E.manifest.contributes&&E.manifest.contributes.localizations&&E.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(f,E);Object.keys(f).forEach(E=>this.updateHash(f[E]))}createLanguagePacksFromExtension(f,m){const E=m.identifier,v=m.manifest.contributes&&m.manifest.contributes.localizations?m.manifest.contributes.localizations:[];for(const o of v)if(m.location.scheme===L.Schemas.file&&(0,h.isValidLocalization)(o)){let t=f[o.languageId];t||(t={hash:"",extensions:[],translations:{}},f[o.languageId]=t);let r=t.extensions.filter(e=>(0,O.areSameExtensions)(e.extensionIdentifier,E))[0];r?r.version=m.manifest.version:t.extensions.push({extensionIdentifier:E,version:m.manifest.version});for(const e of o.translations)t.translations[e.id]=(0,I.join)(m.location.fsPath,e.path)}}updateHash(f){if(f){const m=(0,C.createHash)("md5");for(const E of f.extensions)m.update(E.extensionIdentifier.uuid||E.extensionIdentifier.id).update(E.version);f.hash=m.digest("hex")}}withLanguagePacks(f=()=>null){return this.languagePacksFileLimiter.queue(()=>{let m=null;return c.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,E=>E.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(E)).then(E=>{try{return JSON.parse(E)}catch{return{}}}).then(E=>(m=f(E),E)).then(E=>{for(const o of Object.keys(E))E[o]||delete E[o];this.languagePacks=E,this.initializedCache=!0;const v=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",v),c.Promises.writeFile(this.languagePacksFilePath,v)}).then(()=>m,E=>this.logService.error(E))})}};g=ge([ae(0,p.INativeEnvironmentService),ae(1,S.ILogService)],g)}),define(Q[42],Z([0,1,17,85,33,13,29]),function(x,i,C,D,P,R,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.updateProxyConfigurationsScope=i.asJson=i.asText=i.isSuccess=i.IRequestService=void 0,i.IRequestService=(0,R.createDecorator)("requestService");function I(y){return y.res.statusCode&&y.res.statusCode>=200&&y.res.statusCode<300||y.res.statusCode===1223}i.isSuccess=I;function c(y){return y.res.statusCode===204}async function p(y){if(!I(y))throw new Error("Server returned "+y.res.statusCode);return c(y)?null:(await(0,C.streamToBuffer)(y.stream)).toString()}i.asText=p;async function b(y){if(!I(y))throw new Error("Server returned "+y.res.statusCode);if(c(y))return null;const a=(await(0,C.streamToBuffer)(y.stream)).toString();try{return JSON.parse(a)}catch(f){throw f.message+=`:
`+a,f}}i.asJson=b;function O(y){S(y)}i.updateProxyConfigurationsScope=O;let h;function S(y){const g=L.Registry.as(P.Extensions.Configuration),a=h;h={id:"http",order:15,title:(0,D.localize)(0,null),type:"object",scope:y,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(4,null),(0,D.localize)(5,null),(0,D.localize)(6,null),(0,D.localize)(7,null)],default:"override",description:(0,D.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(9,null),restricted:!0}}},g.updateConfigurations({add:[h],remove:a?[a]:[]})}S(2)}),define(Q[113],Z([0,1,24,11,16,42]),function(x,i,C,D,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DownloadService=void 0;let L=class{constructor(c,p){this.requestService=c,this.fileService=p}async download(c,p,b=C.CancellationToken.None){if(c.scheme===D.Schemas.file||c.scheme===D.Schemas.vscodeRemote){await this.fileService.copy(c,p);return}const O={type:"GET",url:c.toString()},h=await this.requestService.request(O,b);if(h.res.statusCode===200)await this.fileService.writeFile(p,h.stream);else{const S=await(0,R.asText)(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${S}`)}}};L=ge([ae(0,R.IRequestService),ae(1,P.IFileService)],L),i.DownloadService=L}),define(Q[114],Z([0,1,115,8]),function(x,i,C,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getProxyAgent=void 0;function P(L,I){return L.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:L.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function R(L,I,c={}){const p=(0,C.parse)(L),b=c.proxyUrl||P(p,I);if(!b)return null;const O=(0,C.parse)(b);if(!/^https?:$/.test(O.protocol||""))return null;const h={host:O.hostname||"",port:O.port||(O.protocol==="https"?"443":"80"),auth:O.auth,rejectUnauthorized:(0,D.isBoolean)(c.strictSSL)?c.strictSSL:!0};return p.protocol==="http:"?new(await new Promise((S,y)=>{x(["http-proxy-agent"],S,y)}))(h):new(await new Promise((S,y)=>{x(["https-proxy-agent"],S,y)}))(h)}i.getProxyAgent=R}),define(Q[116],Z([0,1,3,6,2,101,8,65,13]),function(x,i,C,D,P,R,L,I,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.logStorage=i.InMemoryStorageService=i.AbstractStorageService=i.StorageTarget=i.StorageScope=i.WillSaveStateReason=i.IStorageService=i.IS_NEW_KEY=void 0,i.IS_NEW_KEY="__$__isNewStorageMarker";const p="__$__targetStorageMarker";i.IStorageService=(0,c.createDecorator)("storageService");var b;(function(a){a[a.NONE=0]="NONE",a[a.SHUTDOWN=1]="SHUTDOWN"})(b=i.WillSaveStateReason||(i.WillSaveStateReason={}));var O;(function(a){a[a.GLOBAL=0]="GLOBAL",a[a.WORKSPACE=1]="WORKSPACE"})(O=i.StorageScope||(i.StorageScope={}));var h;(function(a){a[a.USER=0]="USER",a[a.MACHINE=1]="MACHINE"})(h=i.StorageTarget||(i.StorageTarget={}));class S extends P.Disposable{constructor(f={flushInterval:S.DEFAULT_FLUSH_INTERVAL}){super();this.options=f,this._onDidChangeValue=this._register(new D.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new D.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new D.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new C.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new P.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,C.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,P.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(f,m){m===p?(f===0?this._globalKeyTargets=void 0:f===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:f})):this._onDidChangeValue.fire({scope:f,key:m,target:this.getKeyTargets(f)[m]})}emitWillSaveState(f){this._onWillSaveState.fire({reason:f})}get(f,m,E){return this.getStorage(m)?.get(f,E)}getBoolean(f,m,E){return this.getStorage(m)?.getBoolean(f,E)}getNumber(f,m,E){return this.getStorage(m)?.getNumber(f,E)}store(f,m,E,v){if((0,L.isUndefinedOrNull)(m)){this.remove(f,E);return}this.withPausedEmitters(()=>{this.updateKeyTarget(f,E,v),this.getStorage(E)?.set(f,m)})}remove(f,m){this.withPausedEmitters(()=>{this.updateKeyTarget(f,m,void 0),this.getStorage(m)?.delete(f)})}withPausedEmitters(f){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{f()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(f,m){const E=[],v=this.getKeyTargets(f);for(const o of Object.keys(v))v[o]===m&&E.push(o);return E}updateKeyTarget(f,m,E){const v=this.getKeyTargets(m);typeof E=="number"?v[f]!==E&&(v[f]=E,this.getStorage(m)?.set(p,JSON.stringify(v))):typeof v[f]=="number"&&(delete v[f],this.getStorage(m)?.set(p,JSON.stringify(v)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(f){return f===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(f){const m=this.get(p,f);if(m)try{return JSON.parse(m)}catch{}return Object.create(null)}isNew(f){return this.getBoolean(i.IS_NEW_KEY,f)===!0}async flush(f=b.NONE){this._onWillSaveState.fire({reason:f});const m=this.getStorage(0),E=this.getStorage(1);switch(f){case b.NONE:await C.Promises.settled([m?.whenFlushed()??Promise.resolve(),E?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await C.Promises.settled([m?.flush(0)??Promise.resolve(),E?.flush(0)??Promise.resolve()]);break}}async logStorage(){const f=this.getStorage(0)?.items??new Map,m=this.getStorage(1)?.items??new Map;return g(f,m,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}i.AbstractStorageService=S,S.DEFAULT_FLUSH_INTERVAL=60*1e3;class y extends S{constructor(){super();this.globalStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(f=>this.emitDidChangeValue(1,f))),this._register(this.globalStorage.onDidChangeStorage(f=>this.emitDidChangeValue(0,f)))}getStorage(f){return f===0?this.globalStorage:this.workspaceStorage}getLogDetails(f){return f===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(f){}}i.InMemoryStorageService=y;async function g(a,f,m,E){const v=l=>{try{return JSON.parse(l)}catch{return l}},o=new Map,t=new Map;a.forEach((l,u)=>{o.set(u,l),t.set(u,v(l))});const r=new Map,e=new Map;f.forEach((l,u)=>{r.set(u,l),e.set(u,v(l))}),console.group(`Storage: Global (path: ${m})`);let n=[];o.forEach((l,u)=>{n.push({key:u,value:l})}),console.table(n),console.groupEnd(),console.log(t),console.group(`Storage: Workspace (path: ${E})`);let s=[];r.forEach((l,u)=>{s.push({key:u,value:l})}),console.table(s),console.groupEnd(),console.log(e)}i.logStorage=g}),define(Q[117],Z([0,1,12,31,9,27]),function(x,i,C,D,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.verifyMicrosoftInternalDomain=i.resolveCommonProperties=void 0;function L(p){if(C.platform===2&&/^penguin(\.|$)/i.test(p))return"chromebook"}async function I(p,b,O,h,S,y,g,a,f,m){const E=Object.create(null);E["common.machineId"]=g,E.sessionID=(0,R.generateUuid)()+Date.now(),E.commitHash=S,E.version=y,E["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),E["common.platform"]=(0,C.PlatformToString)(C.platform),E["common.nodePlatform"]=D.platform,E["common.nodeArch"]=h,E["common.product"]=m||"desktop";const v=c(a||[]);v&&(E["common.msftInternal"]=v);let o=0;const t=Date.now();Object.defineProperties(E,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>o++,enumerable:!0}}),C.isLinuxSnap&&(E["common.snap"]="true");const r=L(O);r&&(E["common.platformDetail"]=r);try{const e=await p.readFile(P.URI.file(f));E["common.source"]=e.value.toString().slice(0,30)}catch{}return E}i.resolveCommonProperties=I;function c(p){const b=D.env.USERDNSDOMAIN;if(!b)return!1;const O=b.toLowerCase();return p.some(h=>O===h)}i.verifyMicrosoftInternalDomain=c}),define(Q[30],Z([0,1,13]),function(x,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryConfiguration=i.TelemetryLevel=i.TELEMETRY_OLD_SETTING_ID=i.TELEMETRY_SETTING_ID=i.TELEMETRY_SECTION_ID=i.machineIdKey=i.lastSessionDateStorageKey=i.firstSessionDateStorageKey=i.currentSessionDateStorageKey=i.ICustomEndpointTelemetryService=i.ITelemetryService=void 0,i.ITelemetryService=(0,C.createDecorator)("telemetryService"),i.ICustomEndpointTelemetryService=(0,C.createDecorator)("customEndpointTelemetryService"),i.currentSessionDateStorageKey="telemetry.currentSessionDate",i.firstSessionDateStorageKey="telemetry.firstSessionDate",i.lastSessionDateStorageKey="telemetry.lastSessionDate",i.machineIdKey="telemetry.machineId",i.TELEMETRY_SECTION_ID="telemetry",i.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",i.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var D;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(D=i.TelemetryLevel||(i.TelemetryLevel={}));var P;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(P=i.TelemetryConfiguration||(i.TelemetryConfiguration={}))}),define(Q[118],Z([0,1,18,3,24,7,6,2,12,8,9,75,23,20,14,32,30]),function(x,i,C,D,P,R,L,I,c,p,b,O,h,S,y,g,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractExtensionTask=i.reportTelemetry=i.joinErrors=i.AbstractExtensionManagementService=void 0;let f=class extends I.Disposable{constructor(r,e,n,s){super();this.galleryService=r,this.telemetryService=e,this.logService=n,this.productService=s,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new L.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new L.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new L.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new L.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,I.toDisposable)(()=>{this.installingExtensions.forEach(l=>l.cancel()),this.uninstallingExtensions.forEach(l=>l.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(r){const e=await this.getTargetPlatform();return r.allTargetPlatforms.some(n=>(0,h.isTargetPlatformCompatible)(n,r.allTargetPlatforms,e))}async installFromGallery(r,e={}){try{if(!this.galleryService.isEnabled())throw new h.ExtensionManagementError(O.localize(0,null),h.ExtensionManagementErrorCode.Internal);const n=await this.checkAndGetCompatibleVersion(r,!e.installGivenVersion,!!e.installPreReleaseVersion);return await this.installExtension(n.manifest,n.extension,e)}catch(n){throw v(this.telemetryService,"extensionGallery:install",(0,S.getGalleryExtensionTelemetryData)(r),void 0,n),this.logService.error("Failed to install extension.",r.identifier.id),this.logService.error(n),E(n)}}async uninstall(r,e={}){return this.logService.trace("ExtensionManagementService#uninstall",r.identifier.id),this.unininstallExtension(r,e)}async reinstallFromGallery(r){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",r.identifier.id),!this.galleryService.isEnabled())throw new Error(O.localize(1,null));const e=await this.getTargetPlatform(),[n]=await this.galleryService.getExtensions([{...r.identifier,preRelease:r.preRelease}],{targetPlatform:e,compatible:!0},P.CancellationToken.None);if(!n)throw new Error(O.localize(2,null));await this.createUninstallExtensionTask(r,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(n)}getExtensionsControlManifest(){const r=new Date().getTime();return(!this.extensionsControlManifest||r-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=r),this.extensionsControlManifest}registerParticipant(r){this.participants.push(r)}async installExtension(r,e,n){if(!b.URI.isUri(e)){let w=this.installingExtensions.get(new S.ExtensionIdentifierWithVersion(e.identifier,e.version).key());if(w)return this.logService.info("Extensions is already requested to install",e.identifier.id),w.waitUntilTaskIsFinished();n={...n,installOnlyNewlyAddedFromExtensionPack:!0}}const s=[],l=[],u=this.createInstallExtensionTask(r,e,n);b.URI.isUri(e)||this.installingExtensions.set(new S.ExtensionIdentifierWithVersion(u.identifier,r.version).key(),u),this._onInstallExtension.fire({identifier:u.identifier,source:e}),this.logService.info("Installing extension:",u.identifier.id),s.push({task:u,manifest:r});let d=!1;try{if(n.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",u.identifier.id);else try{const T=await this.getAllDepsAndPackExtensionsToInstall(u.identifier,r,!!n.installOnlyNewlyAddedFromExtensionPack,!!n.installPreReleaseVersion);for(const{gallery:N,manifest:_}of T)if(d=d||!!_.extensionDependencies?.some(Y=>(0,S.areSameExtensions)({id:Y},u.identifier)),this.installingExtensions.has(new S.ExtensionIdentifierWithVersion(N.identifier,N.version).key()))this.logService.info("Extension is already requested to install",N.identifier.id);else{const Y=this.createInstallExtensionTask(_,N,{...n,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new S.ExtensionIdentifierWithVersion(Y.identifier,_.version).key(),Y),this._onInstallExtension.fire({identifier:Y.identifier,source:N}),this.logService.info("Installing extension:",Y.identifier.id),s.push({task:Y,manifest:_})}}catch(T){if(b.URI.isUri(u.source))(0,C.isNonEmptyArray)(r.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",u.identifier.id,T.message),(0,C.isNonEmptyArray)(r.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",u.identifier.id,T.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",u.identifier.id),T}const w=s.reduce((T,{task:N,manifest:_})=>(T.set(N.identifier.id.toLowerCase(),{task:N,manifest:_}),T),new Map);for(;w.size;){let T;const N=[...w.values()].filter(({manifest:_})=>!_.extensionDependencies?.some(Y=>w.has(Y.toLowerCase())));N.length?T=w.size===1?N:N.filter(({task:_})=>!(_===u&&!d)):(this.logService.info("Found extensions with circular dependencies",N.map(({task:_})=>_.identifier.id)),T=[...w.values()]),await this.joinAllSettled(T.map(async({task:_})=>{const Y=new Date().getTime(),re=(0,p.isUndefined)(n.operation)?_.operation:n.operation;try{const te=await _.run();if(await this.joinAllSettled(this.participants.map(ie=>ie.postInstall(te,_.source,n,P.CancellationToken.None))),!b.URI.isUri(_.source)&&(v(this.telemetryService,re===3?"extensionGallery:update":"extensionGallery:install",(0,S.getGalleryExtensionTelemetryData)(_.source),new Date().getTime()-Y,void 0),c.isWeb&&re!==3))try{await this.galleryService.reportStatistic(te.manifest.publisher,te.manifest.name,te.manifest.version,"install")}catch{}l.push({local:te,identifier:_.identifier,operation:re,source:_.source})}catch(te){throw b.URI.isUri(_.source)||v(this.telemetryService,re===3?"extensionGallery:update":"extensionGallery:install",(0,S.getGalleryExtensionTelemetryData)(_.source),new Date().getTime()-Y,te),this.logService.error("Error while installing the extension:",_.identifier.id),te}finally{w.delete(_.identifier.id.toLowerCase())}}))}return l.forEach(({identifier:T})=>this.logService.info("Extension installed successfully:",T.id)),this._onDidInstallExtensions.fire(l),l.filter(({identifier:T})=>(0,S.areSameExtensions)(T,u.identifier))[0].local}catch(w){if(s.forEach(({task:T})=>T.cancel()),l.length)try{const T=await Promise.allSettled(l.map(({local:N})=>this.createUninstallExtensionTask(N,{versionOnly:!0}).run()));for(let N=0;N<T.length;N++){const _=T[N],{identifier:Y}=l[N];_.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",Y.id):this.logService.warn("Rollback: Error while uninstalling extension",Y.id,(0,R.getErrorMessage)(_.reason))}}catch(T){this.logService.warn("Error while rolling back extensions",(0,R.getErrorMessage)(T),l.map(({identifier:N})=>N.id))}throw this._onDidInstallExtensions.fire(s.map(({task:T})=>({identifier:T.identifier,operation:2,source:T.source}))),w}finally{for(const{task:w,manifest:T}of s)if(!b.URI.isUri(w.source)){const N=new S.ExtensionIdentifierWithVersion(w.identifier,T.version).key();this.installingExtensions.delete(N)||this.logService.warn("Installation task is not found in the cache",N)}}}async joinAllSettled(r){const e=[],n=[],s=await Promise.allSettled(r);for(const l of s)l.status==="fulfilled"?e.push(l.value):n.push(l.reason);if(n.length)throw m(n);return e}async getAllDepsAndPackExtensionsToInstall(r,e,n,s){if(!this.galleryService.isEnabled())return[];let l=await this.getInstalled();const u=[r,...l.map(T=>T.identifier)],d=[],w=async(T,N)=>{const _=N.extensionDependencies||[],Y=[..._];if(N.extensionPack){const re=n?l.find(te=>(0,S.areSameExtensions)(te.identifier,T)):void 0;for(const te of N.extensionPack)re&&re.manifest.extensionPack&&re.manifest.extensionPack.some(ie=>(0,S.areSameExtensions)({id:ie},{id:te}))||Y.every(ie=>!(0,S.areSameExtensions)({id:ie},{id:te}))&&Y.push(te)}if(Y.length){const re=[...u,...d.map(ie=>ie.gallery.identifier)],te=Y.filter(ie=>re.every(he=>!(0,S.areSameExtensions)(he,{id:ie})));if(te.length){const ie=await this.galleryService.getExtensions(te.map(he=>({id:he,preRelease:s})),P.CancellationToken.None);for(const he of ie){if(re.find(se=>(0,S.areSameExtensions)(se,he.identifier)))continue;const j=_.some(se=>(0,S.areSameExtensions)({id:se},he.identifier));let q;try{q=await this.checkAndGetCompatibleVersion(he,!0,s)}catch(se){if(se instanceof h.ExtensionManagementError&&se.code===h.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!j){this.logService.info("Skipping the packed extension as it cannot be installed",he.identifier.id);continue}else throw se}d.push({gallery:q.extension,manifest:q.manifest}),await w(q.extension.identifier,q.manifest)}}}};return await w(r,e),l=await this.getInstalled(),d.filter(T=>!l.some(N=>(0,S.areSameExtensions)(N.identifier,T.gallery.identifier)))}async checkAndGetCompatibleVersion(r,e,n){const s=await this.getExtensionsControlManifest();if((0,S.getMaliciousExtensionsSet)(s).has(r.identifier.id))throw new h.ExtensionManagementError(O.localize(3,null,r.identifier.id),h.ExtensionManagementErrorCode.Malicious);if(!!s.unsupportedPreReleaseExtensions&&!!s.unsupportedPreReleaseExtensions[r.identifier.id])throw new h.ExtensionManagementError(O.localize(4,null,r.identifier.id,s.unsupportedPreReleaseExtensions[r.identifier.id].displayName),h.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(r)){const d=await this.getTargetPlatform();throw new h.ExtensionManagementError(O.localize(5,null,r.identifier.id,this.productService.nameLong,(0,h.TargetPlatformToString)(d)),h.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const l=await this.getCompatibleVersion(r,e,n);if(l){if(n&&e&&r.hasPreReleaseVersion&&!l.properties.isPreReleaseVersion)throw new h.ExtensionManagementError(O.localize(6,null,r.identifier.id,this.productService.nameLong,this.productService.version),h.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!n&&r.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([r.identifier],P.CancellationToken.None))[0]?new h.ExtensionManagementError(O.localize(7,null,r.identifier.id),h.ExtensionManagementErrorCode.ReleaseVersionNotFound):new h.ExtensionManagementError(O.localize(8,null,r.identifier.id,this.productService.nameLong,this.productService.version),h.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",l.identifier.id);const u=await this.galleryService.getManifest(l,P.CancellationToken.None);if(u===null)throw new h.ExtensionManagementError(`Missing manifest for extension ${r.identifier.id}`,h.ExtensionManagementErrorCode.Invalid);if(u.version!==l.version)throw new h.ExtensionManagementError(`Cannot install '${r.identifier.id}' extension because of version mismatch in Marketplace`,h.ExtensionManagementErrorCode.Invalid);return{extension:l,manifest:u}}async getCompatibleVersion(r,e,n){const s=await this.getTargetPlatform();let l=null;return e&&r.hasPreReleaseVersion&&r.properties.isPreReleaseVersion!==n&&(l=(await this.galleryService.getExtensions([{...r.identifier,preRelease:n}],{targetPlatform:s,compatible:!0},P.CancellationToken.None))[0]||null),!l&&await this.galleryService.isExtensionCompatible(r,n,s)&&(l=r),!l&&e&&(l=await this.galleryService.getCompatibleExtension(r,n,s)),l}async unininstallExtension(r,e){const n=this.uninstallingExtensions.get(r.identifier.id.toLowerCase());if(n)return this.logService.info("Extensions is already requested to uninstall",r.identifier.id),n.waitUntilTaskIsFinished();const s=(w,T)=>{const N=this.createUninstallExtensionTask(w,T);return this.uninstallingExtensions.set(N.extension.identifier.id.toLowerCase(),N),this.logService.info("Uninstalling extension:",w.identifier.id),this._onUninstallExtension.fire(w.identifier),N},l=(w,T)=>{T?this.logService.error("Failed to uninstall extension:",w.identifier.id,T.message):this.logService.info("Successfully uninstalled extension:",w.identifier.id),v(this.telemetryService,"extensionGallery:uninstall",(0,S.getLocalExtensionTelemetryData)(w),void 0,T),this._onDidUninstallExtension.fire({identifier:w.identifier,error:T?.code})},u=[],d=[];try{u.push(s(r,{}));const w=await this.getInstalled(1);if(e.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",r.identifier.id);else{const T=this.getAllPackExtensionsToUninstall(r,w);for(const N of T)this.uninstallingExtensions.has(N.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",N.identifier.id):u.push(s(N,{}))}e.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",r.identifier.id):this.checkForDependents(u.map(T=>T.extension),w,r),await this.joinAllSettled(u.map(async T=>{try{if(await T.run(),await this.joinAllSettled(this.participants.map(N=>N.postUninstall(T.extension,e,P.CancellationToken.None))),T.extension.identifier.uuid)try{await this.galleryService.reportStatistic(T.extension.manifest.publisher,T.extension.manifest.name,T.extension.manifest.version,"uninstall")}catch{}l(T.extension)}catch(N){const _=N instanceof h.ExtensionManagementError?N:new h.ExtensionManagementError((0,R.getErrorMessage)(N),h.ExtensionManagementErrorCode.Internal);throw l(T.extension,_),_}finally{d.push(T)}}))}catch(w){const T=w instanceof h.ExtensionManagementError?w:new h.ExtensionManagementError((0,R.getErrorMessage)(w),h.ExtensionManagementErrorCode.Internal);for(const N of u){try{N.cancel()}catch{}d.includes(N)||l(N.extension,T)}throw T}finally{for(const w of u)this.uninstallingExtensions.delete(w.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",w.extension.identifier.id)}}checkForDependents(r,e,n){for(const s of r){const l=this.getDependents(s,e);if(l.length){const u=l.filter(d=>!r.some(w=>(0,S.areSameExtensions)(w.identifier,d.identifier)));if(u.length)throw new Error(this.getDependentsErrorMessage(s,u,n))}}}getDependentsErrorMessage(r,e,n){return n===r?e.length===1?O.localize(9,null,n.manifest.displayName||n.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?O.localize(10,null,n.manifest.displayName||n.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):O.localize(11,null,n.manifest.displayName||n.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):e.length===1?O.localize(12,null,n.manifest.displayName||n.manifest.name,r.manifest.displayName||r.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?O.localize(13,null,n.manifest.displayName||n.manifest.name,r.manifest.displayName||r.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):O.localize(14,null,n.manifest.displayName||n.manifest.name,r.manifest.displayName||r.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name)}getAllPackExtensionsToUninstall(r,e,n=[]){if(n.indexOf(r)!==-1)return[];n.push(r);const s=r.manifest.extensionPack?r.manifest.extensionPack:[];if(s.length){const l=e.filter(d=>!d.isBuiltin&&s.some(w=>(0,S.areSameExtensions)({id:w},d.identifier))),u=[];for(const d of l)u.push(...this.getAllPackExtensionsToUninstall(d,e,n));return[...l,...u]}return[]}getDependents(r,e){return e.filter(n=>n.manifest.extensionDependencies&&n.manifest.extensionDependencies.some(s=>(0,S.areSameExtensions)({id:s},r.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const r=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",r),r}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};f=ge([ae(0,h.IExtensionGalleryService),ae(1,a.ITelemetryService),ae(2,y.ILogService),ae(3,g.IProductService)],f),i.AbstractExtensionManagementService=f;function m(t){const r=Array.isArray(t)?t:[t];return r.length===1?r[0]instanceof Error?r[0]:new Error(r[0]):r.reduce((e,n)=>new Error(`${e.message}${e.message?",":""}${n instanceof Error?n.message:n}`),new Error(""))}i.joinErrors=m;function E(t){if(t instanceof h.ExtensionManagementError)return t;const r=new h.ExtensionManagementError(t.message,h.ExtensionManagementErrorCode.Internal);return r.stack=t.stack,r}function v(t,r,e,n,s){const l=s?s instanceof h.ExtensionManagementError?s.code:h.ExtensionManagementErrorCode.Internal:void 0;t.publicLogError(r,{...e,success:!s,duration:n,errorcode:l})}i.reportTelemetry=v;class o{constructor(){this.barrier=new D.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,D.createCancelablePromise)(r=>this.doRun(r))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,D.createCancelablePromise)(r=>new Promise((e,n)=>{const s=r.onCancellationRequested(()=>{s.dispose(),n((0,R.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}i.AbstractExtensionTask=o}),define(Q[35],Z([0,1,21,8,25,30]),function(x,i,C,D,P,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.cleanRemoteAuthority=i.validateTelemetryData=i.getTelemetryLevel=i.supportsTelemetry=i.configurationTelemetry=i.NullAppender=i.NullEndpointTelemetryService=i.NullTelemetryService=i.NullTelemetryServiceShape=void 0;class L{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(f,m){return Promise.resolve(void 0)}publicLog2(f,m){return this.publicLog(f,m)}publicLogError(f,m){return Promise.resolve(void 0)}publicLogError2(f,m){return this.publicLogError(f,m)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}i.NullTelemetryServiceShape=L,i.NullTelemetryService=new L;class I{async publicLog(f,m,E){}async publicLogError(f,m,E){}}i.NullEndpointTelemetryService=I,i.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function c(a,f){return f.onDidChangeConfiguration(m=>{m.source!==6&&a.publicLog2("updateConfiguration",{configurationSource:(0,P.ConfigurationTargetToString)(m.source),configurationKeys:y(m.sourceConfig)})})}i.configurationTelemetry=c;function p(a,f){return!(f.disableTelemetry||!a.enableTelemetry||f.extensionTestsLocationURI)}i.supportsTelemetry=p;function b(a){const f=a.getValue(R.TELEMETRY_SETTING_ID),m=a.getValue("telemetry.enableCrashReporter");if(a.getValue(R.TELEMETRY_OLD_SETTING_ID)===!1||m===!1)return 0;switch(f??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}i.getTelemetryLevel=b;function O(a){const f=Object.create(null),m=Object.create(null),E=Object.create(null);S(a,E);for(let v in E){v=v.length>150?v.substr(v.length-149):v;const o=E[v];typeof o=="number"?m[v]=o:typeof o=="boolean"?m[v]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${v} has been trimmed to 8192, the original length is ${o.length}`),f[v]=o.substring(0,8191)):typeof o!="undefined"&&o!==null&&(f[v]=o)}return{properties:f,measurements:m}}i.validateTelemetryData=O;function h(a){if(!a)return"none";let f="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(E=>{a.indexOf(`${E}+`)===0&&(f=E)}),f}i.cleanRemoteAuthority=h;function S(a,f,m=0,E){if(!!a)for(let v of Object.getOwnPropertyNames(a)){const o=a[v],t=E?E+v:v;Array.isArray(o)?f[t]=(0,C.safeStringify)(o):o instanceof Date?f[t]=o.toISOString():(0,D.isObject)(o)?m<2?S(o,f,m+1,t+"."):f[t]=(0,C.safeStringify)(o):f[t]=o}}function y(a){if(!a)return[];const f=[];return g(f,"",a),f}function g(a,f,m){m&&typeof m=="object"&&!Array.isArray(m)?Object.keys(m).forEach(E=>g(a,f?`${f}.${E}`:E,m[E])):a.push(f)}}),define(Q[119],Z([0,1,90,35]),function(x,i,C,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.resolveMarketplaceHeaders=void 0;async function P(R,L,I,c,p,b){const O={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${L.nameShort})`},h=await(0,C.getServiceMachineId)(I,p,b);return(0,D.supportsTelemetry)(L,I)&&(0,D.getTelemetryLevel)(c)===3&&(O["X-Market-User-Id"]=h),O}i.resolveMarketplaceHeaders=P}),define(Q[120],Z([0,1,18,24,7,21,12,31,8,9,25,19,23,20,48,16,14,32,42,119,116,30]),function(x,i,C,D,P,R,L,I,c,p,b,O,h,S,y,g,a,f,m,E,v,o){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionGalleryServiceWithNoStorageService=i.ExtensionGalleryService=i.sortExtensionVersions=void 0;const t=L.isWeb?"web":(0,h.getTargetPlatform)(L.platform,I.arch);var r;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished",U[U.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(r||(r={}));function e(...U){return String(U.reduce((k,z)=>k|z,0))}var n;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},d={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class w{constructor(k=d){this.state=k}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(k,z=this.state.pageSize){return new w({...this.state,pageNumber:k,pageSize:z})}withFilter(k,...z){const B=[...this.state.criteria,...z.length?z.map(H=>({filterType:k,value:H})):[{filterType:k}]];return new w({...this.state,criteria:B})}withSortBy(k){return new w({...this.state,sortBy:k})}withSortOrder(k){return new w({...this.state,sortOrder:k})}withFlags(...k){return new w({...this.state,flags:k.reduce((z,B)=>z|B,0)})}withAssetTypes(...k){return new w({...this.state,assetTypes:k})}get raw(){const{criteria:k,pageNumber:z,pageSize:B,sortBy:H,sortOrder:X,flags:le,assetTypes:ue}=this.state;return{filters:[{criteria:k,pageNumber:z,pageSize:B,sortBy:H,sortOrder:X}],assetTypes:ue,flags:le}}get searchText(){const k=this.state.criteria.filter(z=>z.filterType===n.SearchText)[0];return k&&k.value?k.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(k=>String(k.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function T(U,k){const z=(U||[]).filter(B=>B.statisticName===k)[0];return z?z.value:0}function N(U){const k="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(B=>B.assetType.indexOf(k)===0).reduce((B,H)=>{const X=te(U,H.assetType);return X&&B.push([H.assetType.substring(k.length),X]),B},[])}function _(U){if(U.properties){const k=U.properties.filter(H=>H.key===s.Repository),z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),B=k.filter(H=>z.test(H.value))[0];return B?{uri:B.value,fallbackUri:B.value}:null}return te(U,s.Repository)}function Y(U){return{uri:`${U.fallbackAssetUri}/${s.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${s.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function re(U){const k=te(U,s.Icon);if(k)return k;const z=h.DefaultIconPath;return{uri:z,fallbackUri:z}}function te(U,k){return U.files.filter(B=>B.assetType===k)[0]?{uri:`${U.assetUri}/${k}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${k}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}:null}function ie(U,k){const z=U.properties?U.properties.filter(H=>H.key===k):[],B=z.length>0&&z[0].value;return B?B.split(",").map(H=>(0,S.adoptToGalleryExtensionId)(H)):[]}function he(U){const k=U.properties?U.properties.filter(z=>z.key===l.Engine):[];return k.length>0&&k[0].value||""}function j(U){const k=U.properties?U.properties.filter(z=>z.key===l.PreRelease):[];return k.length>0&&k[0].value==="true"}function q(U){const k=U.properties?U.properties.filter(B=>B.key===l.LocalizedLanguages):[],z=k.length>0&&k[0].value||"";return z?z.split(","):[]}function se(U){return U.indexOf("preview")!==-1}function M(U){return U.targetPlatform?(0,h.toTargetPlatform)(U.targetPlatform):"undefined"}function A(U){const k=(0,C.distinct)(U.versions.map(M)),z=!!U.tags?.includes(h.WEB_EXTENSION_TAG),B=k.indexOf("web");return z?B===-1&&k.push("web"):B!==-1&&k.splice(B,1),k}function W(U,k){const z=(0,h.getFallbackTargetPlarforms)(k);for(let B=0;B<U.length;B++){const H=U[B];if(H.version===U[B-1]?.version){let X=B;const le=M(H);if(le===k)for(;X>0&&U[X-1].version===H.version;)X--;else if(z.includes(le))for(;X>0&&U[X-1].version===H.version&&M(U[X-1])!==k;)X--;X!==B&&(U.splice(B,1),U.splice(X,0,H))}}return U}i.sortExtensionVersions=W;function K(U,k,z){U.telemetryData={index:k,querySource:z}}function ne(U,k,z){const B=U.versions[0],H={manifest:te(k,s.Manifest),readme:te(k,s.Details),changelog:te(k,s.Changelog),license:te(k,s.License),repository:_(k),download:Y(k),icon:re(k),coreTranslations:N(k)};return{identifier:{id:(0,S.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:k.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,description:U.shortDescription||"",installCount:T(U.statistics,"install"),rating:T(U.statistics,"averagerating"),ratingCount:T(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:z,assets:H,properties:{dependencies:ie(k,l.Dependency),extensionPack:ie(k,l.ExtensionPack),engine:he(k),localizedLanguages:q(k),targetPlatform:M(k),isPreReleaseVersion:j(k)},hasPreReleaseVersion:j(B),hasReleaseVersion:!0,preview:se(U.flags)}}let J=class{constructor(k,z,B,H,X,le,ue,ye){this.requestService=z,this.logService=B,this.environmentService=H,this.telemetryService=X,this.fileService=le,this.productService=ue,this.configurationService=ye;const fe=ue.extensionsGallery;this.extensionsGalleryUrl=fe&&fe.serviceUrl,this.extensionsControlUrl=fe&&fe.controlUrl,this.commonHeadersPromise=(0,E.resolveMarketplaceHeaders)(ue.version,ue,this.environmentService,this.configurationService,this.fileService,k)}api(k=""){return`${this.extensionsGalleryUrl}${k}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(k,z,B){const H=D.CancellationToken.isCancellationToken(z)?{}:z,X=D.CancellationToken.isCancellationToken(z)?z:B,le=[],ue=[],ye=[],fe=[];let oe=!0;for(const Ee of k){Ee.uuid?ue.push(Ee.uuid):le.push(Ee.id);const Ie=!!(Ee.version||Ee.preRelease);ye.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Ie}),Ee.version&&fe.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),oe=oe&&!!Ee.hasPreRelease&&!Ie}if(!ue.length&&!le.length)return[];let pe=new w().withPage(1,k.length);ue.length&&(pe=pe.withFilter(n.ExtensionId,...ue)),le.length&&(pe=pe.withFilter(n.ExtensionName,...le)),(H.queryAllVersions||oe)&&(pe=pe.withFlags(pe.flags,r.IncludeVersions));const{extensions:me}=await this.queryGalleryExtensions(pe,{targetPlatform:H.targetPlatform??t,includePreRelease:ye,versions:fe,compatible:!!H.compatible},X);return H.source&&me.forEach((Ee,Ie)=>K(Ee,Ie,H.source)),me}async getCompatibleExtension(k,z,B){if((0,h.isNotWebExtensionInWebTargetPlatform)(k.allTargetPlatforms,B))return null;if(await this.isExtensionCompatible(k,z,B))return k;const H=new w().withFlags(r.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,k.identifier.uuid),{extensions:X}=await this.queryGalleryExtensions(H,{targetPlatform:B,compatible:!0,includePreRelease:z},D.CancellationToken.None);return X[0]||null}async isExtensionCompatible(k,z,B){if(!(0,h.isTargetPlatformCompatible)(k.properties.targetPlatform,k.allTargetPlatforms,B)||!z&&k.properties.isPreReleaseVersion)return!1;let H=k.properties.engine;if(!H){const X=await this.getManifest(k,D.CancellationToken.None);if(!X)throw new Error("Manifest was not found");H=X.engines.vscode}return(0,y.isEngineValid)(H,this.productService.version,this.productService.date)}async isValidVersion(k,z,B,H,X){if(!(0,h.isTargetPlatformCompatible)(M(k),H,X)||z!=="any"&&j(k)!==(z==="prerelease"))return!1;if(B){const le=await this.getEngine(k);if(!(0,y.isEngineValid)(le,this.productService.version,this.productService.date))return!1}return!0}async query(k,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let B=k.text||"";const H=(0,R.getOrDefault)(k,oe=>oe.pageSize,50);let X=new w().withPage(1,H);B?(B=B.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(oe,pe,me)=>(X=X.withFilter(n.Category,me||pe),"")),B=B.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(oe,pe,me)=>(X=X.withFilter(n.Tag,me||pe),"")),B=B.replace(/\bfeatured(\s+|\b|$)/g,()=>(X=X.withFilter(n.Featured),"")),B=B.trim(),B&&(B=B.length<200?B:B.substring(0,200),X=X.withFilter(n.SearchText,B)),X=X.withSortBy(0)):k.ids?X=X.withFilter(n.ExtensionId,...k.ids):k.names?X=X.withFilter(n.ExtensionName,...k.names):X=X.withSortBy(4),typeof k.sortBy=="number"&&(X=X.withSortBy(k.sortBy)),typeof k.sortOrder=="number"&&(X=X.withSortOrder(k.sortOrder));const le=async(oe,pe)=>{const{extensions:me,total:Ee}=await this.queryGalleryExtensions(oe,{targetPlatform:t,compatible:!1,includePreRelease:!!k.includePreRelease},pe);return me.forEach((Ie,Me)=>K(Ie,(oe.pageNumber-1)*oe.pageSize+Me,k.source)),{extensions:me,total:Ee}},{extensions:ue,total:ye}=await le(X,z),fe=async(oe,pe)=>{if(pe.isCancellationRequested)throw new P.CancellationError;const{extensions:me}=await le(X.withPage(oe+1),pe);return me};return{firstPage:ue,total:ye,pageSize:X.pageSize,getPage:fe}}async queryGalleryExtensions(k,z,B){const H=k.flags;!!(k.flags&r.IncludeLatestVersionOnly)&&!!(k.flags&r.IncludeVersions)&&(k=k.withFlags(k.flags&~r.IncludeVersions,r.IncludeLatestVersionOnly)),!(k.flags&r.IncludeLatestVersionOnly)&&!(k.flags&r.IncludeVersions)&&(k=k.withFlags(k.flags,r.IncludeLatestVersionOnly)),z.versions?.length&&(k=k.withFlags(k.flags&~r.IncludeLatestVersionOnly,r.IncludeVersions)),k=k.withFlags(k.flags,r.IncludeAssetUri,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeStatistics,r.IncludeVersionProperties);const{galleryExtensions:X,total:le}=await this.queryRawGalleryExtensions(k,B);if(!(k.flags&r.IncludeLatestVersionOnly)){const oe=[];for(const pe of X){const me=await this.toGalleryExtensionWithCriteria(pe,z,!0);me&&oe.push(me)}return{extensions:oe,total:le}}const ye=[],fe=new Map;for(let oe=0;oe<X.length;oe++){const pe=X[oe],me={id:(0,S.getGalleryExtensionId)(pe.publisher.publisherName,pe.extensionName),uuid:pe.extensionId},Ee=(0,c.isBoolean)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(Me=>(0,S.areSameExtensions)(Me,me))?.includePreRelease;let Ie=await this.toGalleryExtensionWithCriteria(pe,z,!1);!Ie||Ie.properties.isPreReleaseVersion&&(!Ee||!Ie.hasReleaseVersion)||!Ie.properties.isPreReleaseVersion&&Ie.properties.targetPlatform!==z.targetPlatform&&Ie.hasPreReleaseVersion?fe.set(pe.extensionId,oe):ye.push([oe,Ie])}if(fe.size){const oe=new Date().getTime(),pe=new w().withFlags(H&~r.IncludeLatestVersionOnly,r.IncludeVersions).withPage(1,fe.size).withFilter(n.ExtensionId,...fe.keys()),{extensions:me}=await this.queryGalleryExtensions(pe,z,B);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-oe,count:fe.size});for(const Ee of me){const Ie=fe.get(Ee.identifier.uuid);ye.push([Ie,Ee])}}return{extensions:ye.sort((oe,pe)=>oe[0]-pe[0]).map(([,oe])=>oe),total:le}}async toGalleryExtensionWithCriteria(k,z,B){const H={id:(0,S.getGalleryExtensionId)(k.publisher.publisherName,k.extensionName),uuid:k.extensionId},X=z.versions?.find(fe=>(0,S.areSameExtensions)(fe,H))?.version,le=(0,c.isBoolean)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(fe=>(0,S.areSameExtensions)(fe,H))?.includePreRelease,ue=A(k),ye=W(k.versions,z.targetPlatform);if(z.compatible&&B&&(0,h.isNotWebExtensionInWebTargetPlatform)(ue,z.targetPlatform))return null;for(let fe=0;fe<ye.length;fe++){const oe=ye[fe];if(!(X&&oe.version!==X)){if(await this.isValidVersion(oe,le?"any":"release",z.compatible,ue,z.targetPlatform))return ne(k,oe,ue);if(X&&oe.version===X)return null}}return X||z.compatible?null:ne(k,k.versions[0],ue)}async queryRawGalleryExtensions(k,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");k=k.withFlags(k.flags,r.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,e(r.Unpublished));const B=await this.commonHeadersPromise,H=JSON.stringify(k.raw),X={...B,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(H.length)},le=new Date().getTime();let ue,ye,fe=0;try{if(ue=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:H,headers:X},z),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:fe};const oe=await(0,m.asJson)(ue);if(oe){const pe=oe.results[0],me=pe.extensions,Ee=pe.resultMetadata&&pe.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return fe=Ee&&Ee.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:me,total:fe}}return{galleryExtensions:[],total:fe}}catch(oe){throw ye=oe,oe}finally{this.telemetryService.publicLog2("galleryService:query",{...k.telemetryData,requestBodySize:String(H.length),duration:new Date().getTime()-le,success:!!ue&&(0,m.isSuccess)(ue),responseBodySize:ue?.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:ye?(0,P.isCancellationError)(ye)?"canceled":(0,P.getErrorMessage)(ye).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(fe)})}}async reportStatistic(k,z,B,H){if(!this.isEnabled())return;const X=L.isWeb?this.api(`/itemName/${k}.${z}/version/${B}/statType/${H==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${k}/extensions/${z}/${B}/stats?statType=${H}`),le=L.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ye={...await this.commonHeadersPromise,Accept:le};try{await this.requestService.request({type:"POST",url:X,headers:ye},D.CancellationToken.None)}catch{}}async download(k,z,B){this.logService.trace("ExtensionGalleryService#download",k.identifier.id);const H=(0,S.getGalleryExtensionTelemetryData)(k),X=new Date().getTime(),le=oe=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...H,duration:oe}),ue=B===2?"install":B===3?"update":"",ye=ue?{uri:`${k.assets.download.uri}${p.URI.parse(k.assets.download.uri).query?"&":"?"}${ue}=true`,fallbackUri:`${k.assets.download.fallbackUri}${p.URI.parse(k.assets.download.fallbackUri).query?"&":"?"}${ue}=true`}:k.assets.download,fe=await this.getAsset(ye);await this.fileService.writeFile(z,fe.stream),le(new Date().getTime()-X)}async getReadme(k,z){if(k.assets.readme){const B=await this.getAsset(k.assets.readme,{},z);return await(0,m.asText)(B)||""}return""}async getManifest(k,z){if(k.assets.manifest){const B=await this.getAsset(k.assets.manifest,{},z),H=await(0,m.asText)(B);return H?JSON.parse(H):null}return null}async getManifestFromRawExtensionVersion(k,z){const B=te(k,s.Manifest);if(!B)throw new Error("Manifest was not found");const H={"Accept-Encoding":"gzip"},X=await this.getAsset(B,{headers:H});return await(0,m.asJson)(X)}async getCoreTranslation(k,z){const B=k.assets.coreTranslations.filter(H=>H[0]===z.toUpperCase())[0];if(B){const H=await this.getAsset(B[1]),X=await(0,m.asText)(H);return X?JSON.parse(X):null}return null}async getChangelog(k,z){if(k.assets.changelog){const B=await this.getAsset(k.assets.changelog,{},z);return await(0,m.asText)(B)||""}return""}async getAllCompatibleVersions(k,z,B){let H=new w().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1);k.identifier.uuid?H=H.withFilter(n.ExtensionId,k.identifier.uuid):H=H.withFilter(n.ExtensionName,k.identifier.id);const{galleryExtensions:X}=await this.queryRawGalleryExtensions(H,D.CancellationToken.None);if(!X.length)return[];const le=A(X[0]);if((0,h.isNotWebExtensionInWebTargetPlatform)(le,B))return[];const ue=[],ye=new Set;return await Promise.all(X[0].versions.map(async fe=>{try{if(ye.has(fe.version))return;await this.isValidVersion(fe,z?"prerelease":"release",!0,le,B)&&(ue.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:j(fe)}),ye.add(fe.version))}catch{}})),ue}async getAsset(k,z={},B=D.CancellationToken.None){const H=await this.commonHeadersPromise,X={type:"GET"},le={...H,...z.headers||{}};z={...z,...X,headers:le};const ue=k.uri,ye=k.fallbackUri,fe={...z,url:ue};try{const oe=await this.requestService.request(fe,B);if(oe.res.statusCode===200)return oe;const pe=await(0,m.asText)(oe);throw new Error(`Expected 200, got back ${oe.res.statusCode} instead.

${pe}`)}catch(oe){if((0,P.isCancellationError)(oe))throw oe;const pe=(0,P.getErrorMessage)(oe);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ue,message:pe});const me={...z,url:ye};return this.requestService.request(me,B)}}async getEngine(k){let z=he(k);if(!z){const B=await this.getManifestFromRawExtensionVersion(k,D.CancellationToken.None);if(!B)throw new Error("Manifest was not found");z=B.engines.vscode}return z}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const k=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},D.CancellationToken.None);if(k.res.statusCode!==200)throw new Error("Could not get extensions report.");const z=await(0,m.asJson)(k),B=[],H={};if(z){for(const X of z.malicious)B.push({id:X});if(z.unsupported)for(const X of Object.keys(z.unsupported)){const le=z.unsupported[X];(0,c.isBoolean)(le)||(H[X.toLowerCase()]=le.preReleaseExtension)}if(z.migrateToPreRelease)for(const[X,le]of Object.entries(z.migrateToPreRelease))(!le.engine||(0,y.isEngineValid)(le.engine,this.productService.version,this.productService.date))&&(H[X.toLowerCase()]=le)}return{malicious:B,unsupportedPreReleaseExtensions:H}}};J=ge([ae(1,m.IRequestService),ae(2,a.ILogService),ae(3,O.IEnvironmentService),ae(4,o.ITelemetryService),ae(5,g.IFileService),ae(6,f.IProductService),ae(7,b.IConfigurationService)],J);let ee=class extends J{constructor(k,z,B,H,X,le,ue,ye){super(k,z,B,H,X,le,ue,ye)}};ee=ge([ae(0,v.IStorageService),ae(1,m.IRequestService),ae(2,a.ILogService),ae(3,O.IEnvironmentService),ae(4,o.ITelemetryService),ae(5,g.IFileService),ae(6,f.IProductService),ae(7,b.IConfigurationService)],ee),i.ExtensionGalleryService=ee;let G=class extends J{constructor(k,z,B,H,X,le,ue){super(void 0,k,z,B,H,X,le,ue)}};G=ge([ae(0,m.IRequestService),ae(1,a.ILogService),ae(2,O.IEnvironmentService),ae(3,o.ITelemetryService),ae(4,g.IFileService),ae(5,f.IProductService),ae(6,b.IConfigurationService)],G),i.ExtensionGalleryServiceWithNoStorageService=G}),define(Q[121],Z([0,1,2,21,12,26,86,25,33,122,29,30,35]),function(x,i,C,D,P,R,L,I,c,p,b,O,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryService=void 0;let S=class{constructor(a,f){this._configurationService=f,this._experimentProperties={},this._disposables=new C.DisposableStore,this._cleanupPatterns=[],this._appenders=a.appenders,this._commonProperties=a.commonProperties||Promise.resolve({}),this._piiPaths=a.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!a.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let m of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,R.escapeRegExpCharacters)(m),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3})}setExperimentProperty(a,f){this._experimentProperties[a]=f}_updateTelemetryLevel(){this._telemetryLevel=(0,h.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const a=await this._commonProperties;let f=a.sessionID,m=a["common.machineId"],E=a["common.firstSessionDate"],v=a["common.msftInternal"];return{sessionId:f,machineId:m,firstSessionDate:E,msftInternal:v}}dispose(){this._disposables.dispose()}_log(a,f,m,E){return this.telemetryLevel<f?Promise.resolve(void 0):this._commonProperties.then(v=>{m=(0,D.mixin)(m,v),m=(0,D.mixin)(m,this._experimentProperties),m=(0,D.cloneAndChange)(m,o=>{if(typeof o=="string")return this._cleanupInfo(o,E)}),this._appenders.forEach(o=>o.log(a,m))},v=>{console.error(v)})}publicLog(a,f,m){return this._log(a,3,f,m)}publicLog2(a,f,m){return this.publicLog(a,f,m)}publicLogError(a,f){return this.sendErrorTelemetry?this._log(a,2,f,!0):Promise.resolve(void 0)}publicLogError2(a,f){return this.publicLogError(a,f)}_anonymizeFilePaths(a){let f=a;const m=[];for(let t of this._cleanupPatterns)for(;;){const r=t.exec(a);if(!r)break;m.push([r.index,t.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(f="";;){const t=v.exec(a);if(!t)break;!E.test(t[0])&&m.every(([r,e])=>t.index<r||t.index>=e)&&(f+=a.substring(o,t.index)+"<REDACTED: user-file-path>",o=v.lastIndex)}return o<a.length&&(f+=a.substr(o)),f}_removePropertiesWithPossibleUserInfo(a){if(!a)return a;const f=a.toLowerCase(),m=/@[a-zA-Z0-9-.]+/,E=/(key|token|sig|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/,v=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return E.test(f)?"<REDACTED: secret>":m.test(f)?"<REDACTED: email>":v.test(f)?"<REDACTED: token>":a}_cleanupInfo(a,f){let m=a;f&&(m=this._anonymizeFilePaths(m));for(let E of this._cleanupPatterns)m=m.replace(E,"");return m=this._removePropertiesWithPossibleUserInfo(m),m}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=ge([ae(1,I.IConfigurationService)],S),i.TelemetryService=S;function y(){const g=(0,L.localize)(0,null,p.default.nameLong),a=p.default.privacyStatementUrl?(0,L.localize)(2,null,"https://aka.ms/vscode-telemetry",p.default.privacyStatementUrl):(0,L.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=P.isWeb?"":(0,L.localize)(3,null),m=(0,L.localize)(4,null),E=(0,L.localize)(5,null),v=(0,L.localize)(6,null),o=(0,L.localize)(7,null),t=`
|       | ${m} | ${E} | ${v} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,L.localize)(8,null);return`
${g} ${a} ${f}

&nbsp;

${o}
${t}

&nbsp;

${r}
`}b.Registry.as(c.Extensions.Configuration).registerConfiguration({id:O.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(9,null),properties:{[O.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,L.localize)(10,null),(0,L.localize)(11,null),(0,L.localize)(12,null),(0,L.localize)(13,null)],markdownDescription:y(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.Registry.as(c.Extensions.Configuration).registerConfiguration({id:O.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(14,null),properties:{[O.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:p.default.privacyStatementUrl?(0,L.localize)(16,null,p.default.nameLong,p.default.privacyStatementUrl):(0,L.localize)(15,null,p.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(17,null,`\`#${O.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Q[123],Z([0,1,7,21,35]),function(x,i,C,D,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AppInsightsAppender=void 0;async function R(I,c){const p=await new Promise((O,h)=>{x(["applicationinsights"],O,h)});let b;return p.defaultClient?(b=new p.TelemetryClient(I),b.channel.setUseDiskRetryCaching(!0)):(p.setup(I).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),b=p.defaultClient),I.indexOf("AIF-")===0&&(b.config.endpointUrl=c?"https://mobile.events.data.microsoft.com/collect/v1":"https://0.0.0.0/collect/v1"),b}class L{constructor(c,p,b,O,h){this._eventPrefix=c,this._defaultData=p,this.testCollector=O,this.mirrored=h,this._defaultData||(this._defaultData=Object.create(null)),typeof b=="function"?this._aiClient=b():this._aiClient=b,this._asyncAIClient=null}_withAIClient(c){if(!!this._aiClient){if(typeof this._aiClient!="string"){c(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=R(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(p=>{c(p)},p=>{(0,C.onUnexpectedError)(p),console.error(p)})}}log(c,p){if(!!this._aiClient){p=(0,D.mixin)(p,this._defaultData),p=(0,P.validateTelemetryData)(p),this.testCollector&&(p.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++");try{this._withAIClient(b=>b.trackEvent({name:this._eventPrefix+"/"+c,properties:p.properties,measurements:p.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(c=>{this._withAIClient(p=>{try{p.flush({callback:()=>{this._aiClient=void 0,c(void 0)}})}catch{}})}):Promise.resolve(void 0)}}i.AppInsightsAppender=L}),define(Q[124],Z([0,1,10,15]),function(x,i,C,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buildTelemetryMessage=void 0;async function P(R,L){const I=Object.create(null),c=(b,O)=>{const h=JSON.parse(b);I[O]=h};if(L){const b=[],O=await D.Promises.readdir(L);for(const S of O)try{(await D.Promises.stat((0,C.join)(L,S))).isDirectory()&&b.push(S)}catch{}const h=[];for(const S of b)(await D.Promises.readdir((0,C.join)(L,S))).filter(g=>g==="telemetry.json").length===1&&h.push(S);for(const S of h){const y=(await D.Promises.readFile((0,C.join)(L,S,"telemetry.json"))).toString();c(y,S)}}let p=(await D.Promises.readFile((0,C.join)(R,"telemetry-core.json"))).toString();return c(p,"vscode-core"),p=(await D.Promises.readFile((0,C.join)(R,"telemetry-extensions.json"))).toString(),c(p,"vscode-extensions"),JSON.stringify(I,null,4)}i.buildTelemetryMessage=P}),define(Q[36],Z([0,1,13]),function(x,i,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IUriIdentityService=void 0,i.IUriIdentityService=(0,C.createDecorator)("IUriIdentityService")}),define(Q[125],Z([0,1,6,2,9,19,20,16,14,36]),function(x,i,C,D,P,R,L,I,c,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsWatcher=void 0;let b=class extends D.Disposable{constructor(h,S,y,g,a){super();this.extensionsManagementService=h,this.logService=g,this.uriIdentityService=a,this._onDidChangeExtensionsByAnotherSource=this._register(new C.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(m=>{this.installedExtensions=m.map(E=>E.identifier),this.startTimestamp=Date.now()}),this._register(h.onInstallExtension(m=>this.onInstallExtension(m))),this._register(h.onDidInstallExtensions(m=>this.onDidInstallExtensions(m))),this._register(h.onDidUninstallExtension(m=>this.onDidUninstallExtension(m)));const f=P.URI.file(y.extensionsPath);this._register(S.watch(f)),this._register(C.Event.filter(S.onDidFilesChange,m=>m.rawChanges.some(E=>this.doesChangeAffects(E,f)))(()=>this.onDidChange()))}doesChangeAffects(h,S){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(h.resource),S)?this.uriIdentityService.extUri.isEqual(h.resource,this.uriIdentityService.extUri.joinPath(S,".obsolete"))?!0:!(h.type!==1&&h.type!==2||this.uriIdentityService.extUri.basename(h.resource).startsWith(".")):!1}onInstallExtension(h){this.addInstallingExtension(h.identifier)}onDidInstallExtensions(h){for(const S of h)this.removeInstallingExtension(S.identifier),S.local&&this.addInstalledExtension(S.identifier)}onDidUninstallExtension(h){h.error||this.removeInstalledExtension(h.identifier)}addInstallingExtension(h){this.removeInstallingExtension(h),this.installingExtensions.push(h)}removeInstallingExtension(h){this.installingExtensions=this.installingExtensions.filter(S=>!(0,L.areSameExtensions)(S,h))}addInstalledExtension(h){this.installedExtensions&&(this.removeInstalledExtension(h),this.installedExtensions.push(h))}removeInstalledExtension(h){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(S=>!(0,L.areSameExtensions)(S,h)))}async onDidChange(){if(this.installedExtensions){const h=await this.extensionsManagementService.getInstalled(1),S=h.filter(g=>[...this.installingExtensions,...this.installedExtensions].some(a=>(0,L.areSameExtensions)(a,g.identifier))?!1:g.installedTimestamp&&g.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",g.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",g.identifier.id),!1)),y=this.installedExtensions.filter(g=>this.installingExtensions.some(a=>(0,L.areSameExtensions)(a,g))?!1:h.every(a=>!(0,L.areSameExtensions)(a.identifier,g))?(this.logService.info("Detected extension removed from another source",g.id),!0):!1);this.installedExtensions=h.map(g=>g.identifier),(S.length||y.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:S,removed:y})}}};b=ge([ae(1,I.IFileService),ae(2,R.INativeEnvironmentService),ae(3,c.ILogService),ae(4,p.IUriIdentityService)],b),i.ExtensionsWatcher=b}),define(Q[126],Z([0,1,36,91,16,22,58,6,2]),function(x,i,C,D,P,R,L,I,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UriIdentityService=void 0;class p{constructor(h){this.uri=h,this.time=p._clock++}touch(){return this.time=p._clock++,this}}p._clock=0;let b=class{constructor(h){this._fileService=h,this._dispooables=new c.DisposableStore,this._limit=2**16;const S=new Map,y=g=>{let a=S.get(g.scheme);return a===void 0&&(a=h.hasProvider(g)&&!this._fileService.hasCapability(g,1024),S.set(g.scheme,a)),a};this._dispooables.add(I.Event.any(h.onDidChangeFileSystemProviderRegistrations,h.onDidChangeFileSystemProviderCapabilities)(g=>{S.delete(g.scheme)})),this.extUri=new R.ExtUri(y),this._canonicalUris=new L.SkipList((g,a)=>this.extUri.compare(g,a,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(h){this._fileService.hasProvider(h)&&(h=(0,R.normalizePath)(h));let S=this._canonicalUris.get(h);return S?S.touch().uri.with({fragment:h.fragment}):(this._canonicalUris.set(h,new p(h)),this._checkTrim(),h)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const h=[...this._canonicalUris.entries()].sort((y,g)=>y[1].touch<g[1].touch?1:y[1].touch>g[1].touch?-1:0);p._clock=0,this._canonicalUris.clear();const S=this._limit*.5;for(let y=0;y<S;y++)this._canonicalUris.set(h[y][0],h[y][1].touch())}};b=ge([ae(0,P.IFileService)],b),i.UriIdentityService=b,(0,D.registerSingleton)(C.IUriIdentityService,b,!0)}),define(Q[43],Z([0,1,103,3,10,8,15,72,138,139]),function(x,i,C,D,P,R,L,I,c,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buffer=i.extract=i.zip=i.ExtractError=void 0;class b extends Error{constructor(t,r){let e=r.message;switch(t){case"CorruptZip":e=`Corrupt ZIP: ${e}`;break}super(e);this.type=t,this.cause=r}}i.ExtractError=b;function O(o){const t=o.externalFileAttributes>>16||33188;return[448,56,7].map(r=>t&r).reduce((r,e)=>r+e,t&61440)}function h(o){if(o instanceof b)return o;let t;return/end of central directory record signature not found/.test(o.message)&&(t="CorruptZip"),new b(t,o)}function S(o,t,r,e,n,s){const l=P.dirname(t),u=P.join(e,l);if(!u.startsWith(e))return Promise.reject(new Error(I.localize(0,null,t)));const d=P.join(e,t);let w;return s.onCancellationRequested(()=>{w&&w.destroy()}),Promise.resolve(L.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((T,N)=>{if(!s.isCancellationRequested)try{w=(0,C.createWriteStream)(d,{mode:r}),w.once("close",()=>T()),w.once("error",N),o.once("error",N),o.pipe(w)}catch(_){N(_)}}))}function y(o,t,r,e){let n=(0,D.createCancelablePromise)(()=>Promise.resolve()),s=0;return e.onCancellationRequested(()=>{n.cancel(),o.close()}),new Promise((l,u)=>{const d=new D.Sequencer,w=T=>{T.isCancellationRequested||(s++,o.readEntry())};o.once("error",u),o.once("close",()=>n.then(()=>{e.isCancellationRequested||o.entryCount===s?l():u(new b("Incomplete",new Error(I.localize(1,null,s,o.entryCount))))},u)),o.readEntry(),o.on("entry",T=>{if(e.isCancellationRequested)return;if(!r.sourcePathRegex.test(T.fileName)){w(e);return}const N=T.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(N)){const re=P.join(t,N);n=(0,D.createCancelablePromise)(te=>L.Promises.mkdir(re,{recursive:!0}).then(()=>w(te)).then(void 0,u));return}const _=a(o,T),Y=O(T);n=(0,D.createCancelablePromise)(re=>d.queue(()=>_.then(te=>S(te,N,Y,t,r,re).then(()=>w(re)))).then(null,u))})})}function g(o,t=!1){return new Promise((r,e)=>{(0,c.open)(o,t?{lazyEntries:!0}:void 0,(n,s)=>{n?e(h(n)):r((0,R.assertIsDefined)(s))})})}function a(o,t){return new Promise((r,e)=>{o.openReadStream(t,(n,s)=>{n?e(h(n)):r((0,R.assertIsDefined)(s))})})}function f(o,t){return new Promise((r,e)=>{const n=new p.ZipFile;t.forEach(l=>{l.contents?n.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&n.addFile(l.localPath,l.path)}),n.end();const s=(0,C.createWriteStream)(o);n.outputStream.pipe(s),n.outputStream.once("error",e),s.once("error",e),s.once("finish",()=>r(o))})}i.zip=f;function m(o,t,r={},e){const n=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let s=g(o,!0);return r.overwrite&&(s=s.then(l=>L.Promises.rm(t).then(()=>l))),s.then(l=>y(l,t,{sourcePathRegex:n},e))}i.extract=m;function E(o,t){return g(o).then(r=>new Promise((e,n)=>{r.on("entry",s=>{s.fileName===t&&a(r,s).then(l=>e(l),l=>n(l))}),r.once("close",()=>n(new Error(I.localize(2,null,t))))}))}function v(o,t){return E(o,t).then(r=>new Promise((e,n)=>{const s=[];r.once("error",n),r.on("data",l=>s.push(l)),r.on("end",()=>e(Buffer.concat(s)))}))}i.buffer=v}),define(Q[127],Z([0,1,43,79]),function(x,i,C,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getManifest=void 0;function P(R){return(0,C.buffer)(R,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch{throw new Error((0,D.localize)(0,null))}})}i.getManifest=P}),define(Q[128],Z([0,1,18,3,7,2,11,10,12,22,41,9,27,15,43,80,19,23,20,89,34,16,14,32]),function(x,i,C,D,P,R,L,I,c,p,b,O,h,S,y,g,a,f,m,E,v,o,t,r){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsScanner=void 0;let e=class extends R.Disposable{constructor(s,l,u,d,w){super();this.beforeRemovingExtension=s,this.fileService=l,this.logService=u,this.environmentService=d,this.productService=w,this._devSystemExtensionsPath=null,this.systemExtensionsPath=d.builtinExtensionsPath,this.extensionsPath=d.extensionsPath,this.uninstalledPath=I.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new D.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(s){const l=[];(s===null||s===0)&&l.push(this.scanSystemExtensions().then(null,u=>Promise.reject(new f.ExtensionManagementError(this.joinErrors(u).message,f.ExtensionManagementErrorCode.Internal)))),(s===null||s===1)&&l.push(this.scanUserExtensions(!0).then(null,u=>Promise.reject(new f.ExtensionManagementError(this.joinErrors(u).message,f.ExtensionManagementErrorCode.Internal))));try{const u=await Promise.all(l);return(0,C.flatten)(u)}catch(u){throw this.joinErrors(u)}}async scanUserExtensions(s){this.logService.trace("Started scanning user extensions");let[l,u]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return u=u.filter(d=>!l[new m.ExtensionIdentifierWithVersion(d.identifier,d.manifest.version).key()]),s&&(u=(0,m.groupByExtension)(u,w=>w.identifier).map(w=>w.sort((T,N)=>b.rcompare(T.manifest.version,N.manifest.version))[0])),this.logService.trace("Scanned user extensions:",u.length),u}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(s,l,u,d){const w=s.key(),T=I.join(this.extensionsPath,`.${(0,h.generateUuid)()}`),N=I.join(this.extensionsPath,w);try{await S.Promises.rm(N)}catch{try{await S.Promises.rm(N)}catch{}throw new f.ExtensionManagementError((0,g.localize)(0,null,N,s.id),f.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(s,l,T,d);let _=await this.scanExtension(O.URI.file(T),1);if(!_)throw new Error((0,g.localize)(1,null,T));await this.storeMetadata(_,{...u,installedTimestamp:Date.now()});try{await this.rename(s,T,N,Date.now()+2*60*1e3),this.logService.info("Renamed to",N)}catch(Y){try{await S.Promises.rm(T)}catch{}if(Y.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",s.id);else throw this.logService.info(`Rename failed because of ${(0,P.getErrorMessage)(Y)}. Deleted from extracted location`,T),Y}try{_=await this.scanExtension(O.URI.file(N),1)}catch{}if(_)return _;throw new Error((0,g.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(s,l){return this.setMetadata(s,l),await this.storeMetadata(s,{...l,installedTimestamp:s.installedTimestamp}),s}async storeMetadata(s,l){l.isMachineScoped=l.isMachineScoped||void 0,l.isBuiltin=l.isBuiltin||void 0,l.installedTimestamp=l.installedTimestamp||void 0;const u=I.join(s.location.fsPath,"package.json"),d=await S.Promises.readFile(u,"utf8"),{manifest:w}=await this.parseManifest(d);return w.__metadata=l,await S.Promises.writeFile(u,JSON.stringify(w,null,"	")),s}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...s){const l=s.map(u=>new m.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version));await this.withUninstalledExtensions(u=>{l.forEach(d=>u[d.key()]=!0)})}async setInstalled(s){await this.withUninstalledExtensions(d=>delete d[s.key()]);const u=(await this.scanExtensions(1)).find(d=>new m.ExtensionIdentifierWithVersion(d.identifier,d.manifest.version).equals(s))||null;return u?(await this.storeMetadata(u,{installedTimestamp:Date.now()}),this.scanExtension(u.location,1)):null}async withUninstalledExtensions(s){return this.uninstalledFileLimiter.queue(async()=>{let l;try{l=await S.Promises.readFile(this.uninstalledPath,"utf8")}catch(d){if(d.code!=="ENOENT")throw d}let u={};if(l)try{u=JSON.parse(l)}catch{}return s&&(s(u),Object.keys(u).length?await S.Promises.writeFile(this.uninstalledPath,JSON.stringify(u)):await S.Promises.rm(this.uninstalledPath)),u})}async removeExtension(s,l){this.logService.trace(`Deleting ${l} extension from disk`,s.identifier.id,s.location.fsPath),await S.Promises.rm(s.location.fsPath),this.logService.info("Deleted from disk",s.identifier.id,s.location.fsPath)}async removeUninstalledExtension(s){await this.removeExtension(s,"uninstalled"),await this.withUninstalledExtensions(l=>delete l[new m.ExtensionIdentifierWithVersion(s.identifier,s.manifest.version).key()])}async extractAtLocation(s,l,u,d){this.logService.trace(`Started extracting the extension from ${l} to ${u}`);try{await S.Promises.rm(u)}catch(w){throw new f.ExtensionManagementError(this.joinErrors(w).message,f.ExtensionManagementErrorCode.Delete)}try{await(0,y.extract)(l,u,{sourcePath:"extension",overwrite:!0},d),this.logService.info(`Extracted extension to ${u}:`,s.id)}catch(w){try{await S.Promises.rm(u)}catch{}let T=f.ExtensionManagementErrorCode.Extract;throw w instanceof y.ExtractError&&(w.type==="CorruptZip"?T=f.ExtensionManagementErrorCode.CorruptZip:w.type==="Incomplete"&&(T=f.ExtensionManagementErrorCode.IncompleteZip)),new f.ExtensionManagementError(w.message,T)}}async rename(s,l,u,d){try{await S.Promises.rename(l,u)}catch(w){if(c.isWindows&&w&&w.code==="EPERM"&&Date.now()<d)return this.logService.info(`Failed renaming ${l} to ${u} with 'EPERM' error. Trying again...`,s.id),this.rename(s,l,u,d);throw new f.ExtensionManagementError(w.message||(0,g.localize)(3,null,l,u),w.code||f.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const s=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return s;const l=this.scanDevSystemExtensions(),[u,d]=await Promise.all([s,l]);return[...u,...d]}async scanExtensionsInDir(s,l){const u=new D.Limiter(10),d=await this.fileService.resolve(O.URI.file(s));return d.children?(await Promise.all(d.children.filter(T=>T.isDirectory).map(T=>u.queue(async()=>l===1&&(0,p.basename)(T.resource).indexOf(".")===0?null:this.scanExtension(T.resource,l))))).filter(T=>T&&T.identifier):[]}async scanExtension(s,l){try{const u=await this.fileService.resolve(s);if(u.children){const{manifest:d,metadata:w}=await this.readManifest(s.fsPath),T=u.children.find(({name:re})=>/^readme(\.txt|\.md|)$/i.test(re))?.resource,N=u.children.find(({name:re})=>/^changelog(\.txt|\.md|)$/i.test(re))?.resource,_={id:(0,m.getGalleryExtensionId)(d.publisher,d.name)},Y={type:l,identifier:_,manifest:d,location:s,readmeUrl:T,changelogUrl:N,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:l===0};return this.setMetadata(Y,w),Y}}catch(u){l!==0&&this.logService.trace(u)}return null}async scanDefaultSystemExtensions(){const s=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",s.length),s}async scanDevSystemExtensions(){const s=this.getDevSystemExtensionsList();if(s.length){const l=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",l.length),l.filter(u=>s.some(d=>(0,m.areSameExtensions)(u.identifier,{id:d})))}else return[]}setMetadata(s,l){s.publisherDisplayName=l?.publisherDisplayName||null,s.publisherId=l?.publisherId||null,s.identifier.uuid=l?.id,s.isMachineScoped=!!l?.isMachineScoped,s.isPreReleaseVersion=!!l?.isPreReleaseVersion,s.preRelease=!!l?.preRelease,s.isBuiltin=s.type===0||!!l?.isBuiltin,s.installedTimestamp=l?.installedTimestamp}async removeUninstalledExtensions(){const s=await this.getUninstalledExtensions(),l=await this.scanAllUserExtensions(),u=new Set;for(const T of l)s[new m.ExtensionIdentifierWithVersion(T.identifier,T.manifest.version).key()]||u.add(T.identifier.id.toLowerCase());const d=(0,m.groupByExtension)(l,T=>T.identifier);await D.Promises.settled(d.map(async T=>{const N=T.sort((_,Y)=>b.rcompare(_.manifest.version,Y.manifest.version))[0];u.has(N.identifier.id.toLowerCase())||await this.beforeRemovingExtension(N)}));const w=l.filter(T=>s[new m.ExtensionIdentifierWithVersion(T.identifier,T.manifest.version).key()]);await D.Promises.settled(w.map(T=>this.removeUninstalledExtension(T)))}async removeOutdatedExtensions(){const s=await this.scanAllUserExtensions(),l=[],u=(0,m.groupByExtension)(s,d=>d.identifier);l.push(...(0,C.flatten)(u.map(d=>d.sort((w,T)=>b.rcompare(w.manifest.version,T.manifest.version)).slice(1)))),await D.Promises.settled(l.map(d=>this.removeExtension(d,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(s=>s.name)}joinErrors(s){const l=Array.isArray(s)?s:[s];return l.length===1?l[0]instanceof Error?l[0]:new Error(l[0]):l.reduce((u,d)=>new Error(`${u.message}${u.message?",":""}${d instanceof Error?d.message:d}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=I.normalize(I.join(L.FileAccess.asFileUri("",x).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(s){const l=[S.Promises.readFile(I.join(s,"package.json"),"utf8").then(T=>this.parseManifest(T)),S.Promises.readFile(I.join(s,"package.nls.json"),"utf8").then(void 0,T=>T.code!=="ENOENT"?Promise.reject(T):"{}").then(T=>JSON.parse(T))],[{manifest:u,metadata:d},w]=await Promise.all(l);return{manifest:(0,E.localizeManifest)(u,w),metadata:d}}parseManifest(s){return new Promise((l,u)=>{try{const d=JSON.parse(s);d.publisher||(d.publisher=v.UNDEFINED_PUBLISHER);const w=d.__metadata||null;l({manifest:d,metadata:w})}catch{u(new Error((0,g.localize)(4,null)))}})}};e=ge([ae(1,o.IFileService),ae(2,t.ILogService),ae(3,a.INativeEnvironmentService),ae(4,r.IProductService)],e),i.ExtensionsScanner=e}),define(Q[129],Z([0,1,28,7,11,10,12,31,22,41,9,27,15,43,78,49,19,118,23,20,110,98,127,111,128,125,48,16,13,14,32,30,36]),function(x,i,C,D,P,R,L,I,c,p,b,O,h,S,y,g,a,f,m,E,v,o,t,r,e,n,s,l,u,d,w,T,N){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementService=void 0;let _=class extends f.AbstractExtensionManagementService{constructor(j,q,se,M,A,W,K,ne,J){super(j,q,se,ne);this.environmentService=M,this.downloadService=A,this.fileService=K;const ee=this._register(W.createInstance(o.ExtensionsLifecycle));this.extensionsScanner=this._register(W.createInstance(e.ExtensionsScanner,U=>ee.postUninstall(U))),this.manifestCache=this._register(new r.ExtensionsManifestCache(M,this)),this.extensionsDownloader=this._register(W.createInstance(v.ExtensionsDownloader));const G=this._register(new n.ExtensionsWatcher(this,K,M,se,J));this._register(G.onDidChangeExtensionsByAnotherSource(({added:U,removed:k})=>{U.length&&this._onDidInstallExtensions.fire(U.map(z=>({identifier:z.identifier,operation:1,local:z}))),k.forEach(z=>this._onDidUninstallExtension.fire({identifier:z}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const j=await this.isAlpineLinux(),q=(0,m.getTargetPlatform)(j?"alpine":L.platform,I.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",q),q})()),this._targetPlatformPromise}async isAlpineLinux(){if(!L.isLinux)return!1;let j;try{j=(await this.fileService.readFile(b.URI.file("/etc/os-release"))).value.toString()}catch{try{j=(await this.fileService.readFile(b.URI.file("/usr/lib/os-release"))).value.toString()}catch(se){this.logService.debug("Error while getting the os-release file.",(0,D.getErrorMessage)(se))}}return!!j&&(j.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(j){this.logService.trace("ExtensionManagementService#zip",j.identifier.id);const q=await this.collectFiles(j),se=await(0,S.zip)((0,c.joinPath)(this.environmentService.tmpDir,(0,O.generateUuid)()).fsPath,q);return b.URI.file(se)}async unzip(j){return this.logService.trace("ExtensionManagementService#unzip",j.toString()),(await this.install(j)).identifier}async getManifest(j){const q=await this.downloadVsix(j),se=R.resolve(q.fsPath);return(0,t.getManifest)(se)}getInstalled(j=null){return this.extensionsScanner.scanExtensions(j)}async install(j,q={}){this.logService.trace("ExtensionManagementService#install",j.toString());const se=await this.downloadVsix(j),M=await(0,t.getManifest)(R.resolve(se.fsPath));if(M.engines&&M.engines.vscode&&!(0,s.isEngineValid)(M.engines.vscode,this.productService.version,this.productService.date))throw new Error(y.localize(0,null,(0,E.getGalleryExtensionId)(M.publisher,M.name),this.productService.version));return this.installExtension(M,se,q)}async updateMetadata(j,q){this.logService.trace("ExtensionManagementService#updateMetadata",j.identifier.id);const se={...j.manifest.__metadata||{},...q};return q.isPreReleaseVersion&&(se.preRelease=!0),j=await this.extensionsScanner.saveMetadataForLocalExtension(j,se),this.manifestCache.invalidate(),j}async updateExtensionScope(j,q){return this.logService.trace("ExtensionManagementService#updateExtensionScope",j.identifier.id),j=await this.extensionsScanner.saveMetadataForLocalExtension(j,{...j.manifest.__metadata||{},isMachineScoped:q}),this.manifestCache.invalidate(),j}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(j){if(j.scheme===P.Schemas.file)return j;const q=(0,c.joinPath)(this.environmentService.tmpDir,(0,O.generateUuid)());return await this.downloadService.download(j,q),q}createInstallExtensionTask(j,q,se){return b.URI.isUri(q)?new te(j,q,se,this.galleryService,this.extensionsScanner,this.logService):new re(q,se,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(j,q){return new ie(j,q,this.extensionsScanner)}async collectFiles(j){const q=async M=>{let A=await h.Promises.readdir(M);A=A.map(ne=>R.join(M,ne));const W=await Promise.all(A.map(ne=>h.Promises.stat(ne)));let K=Promise.resolve([]);return W.forEach((ne,J)=>{const ee=A[J];ne.isFile()&&(K=K.then(G=>[...G,ee])),ne.isDirectory()&&(K=K.then(G=>q(ee).then(U=>[...G,...U])))}),K};return(await q(j.location.fsPath)).map(M=>({path:`extension/${R.relative(j.location.fsPath,M)}`,localPath:M}))}};_=ge([ae(0,m.IExtensionGalleryService),ae(1,T.ITelemetryService),ae(2,d.ILogService),ae(3,a.INativeEnvironmentService),ae(4,g.IDownloadService),ae(5,u.IInstantiationService),ae(6,l.IFileService),ae(7,w.IProductService),ae(8,N.IUriIdentityService)],_),i.ExtensionManagementService=_;class Y extends f.AbstractExtensionTask{constructor(j,q,se,M){super();this.identifier=j,this.source=q,this.extensionsScanner=se,this.logService=M,this._operation=2}get operation(){return this._operation}async installExtension(j,q){try{const se=await this.unsetUninstalledAndGetLocal(j.identifierWithVersion);if(se)return j.metadata?this.extensionsScanner.saveMetadataForLocalExtension(se,{...se.manifest.__metadata||{},...j.metadata}):se}catch{throw L.isMacintosh?new m.ExtensionManagementError(y.localize(1,null),m.ExtensionManagementErrorCode.Internal):new m.ExtensionManagementError(y.localize(2,null),m.ExtensionManagementErrorCode.Internal)}return this.extract(j,q)}async unsetUninstalledAndGetLocal(j){if(!await this.isUninstalled(j))return null;this.logService.trace("Removing the extension from uninstalled list:",j.id);const se=await this.extensionsScanner.setInstalled(j);return this.logService.info("Removed the extension from uninstalled list:",j.id),se}async isUninstalled(j){return!!(await this.extensionsScanner.getUninstalledExtensions())[j.key()]}async extract({zipPath:j,identifierWithVersion:q,metadata:se},M){let A=await this.extensionsScanner.extractUserExtension(q,j,se,M);return this.logService.info("Extracting completed.",q.id),A}}class re extends Y{constructor(j,q,se,M,A){super(j.identifier,j,M,A);this.gallery=j,this.options=q,this.extensionsDownloader=se}async doRun(j){const se=(await this.extensionsScanner.scanExtensions(null)).find(A=>(0,E.areSameExtensions)(A.identifier,this.gallery.identifier));se&&(this._operation=3);const M=await this.downloadInstallableExtension(this.gallery,this._operation);M.metadata.isMachineScoped=this.options.isMachineScoped||se?.isMachineScoped,M.metadata.isBuiltin=this.options.isBuiltin||se?.isBuiltin,M.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,M.metadata.preRelease=this.gallery.hasPreReleaseVersion?this.gallery.properties.isPreReleaseVersion:se?.preRelease||this.options.installPreReleaseVersion;try{const A=await this.installExtension(M,j);return se&&p.neq(se.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(se),A}catch(A){throw await this.deleteDownloadedVSIX(M.zipPath),A}}async deleteDownloadedVSIX(j){try{await this.extensionsDownloader.delete(b.URI.file(j))}catch(q){this.logService.warn("Error while deleting the downloaded vsix",j.toString(),(0,D.getErrorMessage)(q))}}async downloadInstallableExtension(j,q){const se={id:j.identifier.uuid,publisherId:j.publisherId,publisherDisplayName:j.publisherDisplayName};let M;try{this.logService.trace("Started downloading extension:",j.identifier.id),M=(await this.extensionsDownloader.downloadExtension(j,q)).fsPath,this.logService.info("Downloaded extension:",j.identifier.id,M)}catch(A){throw new m.ExtensionManagementError((0,f.joinErrors)(A).message,m.ExtensionManagementErrorCode.Download)}try{const A=await(0,t.getManifest)(M);return{zipPath:M,identifierWithVersion:new E.ExtensionIdentifierWithVersion(j.identifier,A.version),metadata:se}}catch(A){throw await this.deleteDownloadedVSIX(M),new m.ExtensionManagementError((0,f.joinErrors)(A).message,m.ExtensionManagementErrorCode.Invalid)}}}class te extends Y{constructor(j,q,se,M,A,W){super({id:(0,E.getGalleryExtensionId)(j.publisher,j.name)},q,A,W);this.manifest=j,this.location=q,this.options=se,this.galleryService=M}async doRun(j){const q=new E.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),M=(await this.extensionsScanner.scanExtensions(1)).find(W=>(0,E.areSameExtensions)(this.identifier,W.identifier)),A=await this.getMetadata(this.identifier.id,this.manifest.version,j);if(A.isMachineScoped=this.options.isMachineScoped||M?.isMachineScoped,A.isBuiltin=this.options.isBuiltin||M?.isBuiltin,M)if(this._operation=3,q.equals(new E.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version)))try{await this.extensionsScanner.removeExtension(M,"existing")}catch{throw new Error(y.localize(3,null,this.manifest.displayName||this.manifest.name))}else p.gt(M.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(M);else{const W=await this.unsetUninstalledAndGetLocal(q);if(W)try{await this.extensionsScanner.removeExtension(W,"existing")}catch{throw new Error(y.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:R.resolve(this.location.fsPath),identifierWithVersion:q,metadata:A},j)}async getMetadata(j,q,se){try{let[M]=await this.galleryService.getExtensions([{id:j,version:q}],se);if(M||([M]=await this.galleryService.getExtensions([{id:j}],se)),M)return{id:M.identifier.uuid,publisherDisplayName:M.publisherDisplayName,publisherId:M.publisherId,isPreReleaseVersion:M.properties.isPreReleaseVersion,preRelease:M.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class ie extends f.AbstractExtensionTask{constructor(j,q,se){super();this.extension=j,this.options=q,this.extensionsScanner=se}async doRun(j){const q=[],se=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const M=new E.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);q.push(...se.filter(A=>M.equals(new E.ExtensionIdentifierWithVersion(A.identifier,A.manifest.version))))}else q.push(...se.filter(M=>(0,E.areSameExtensions)(M.identifier,this.extension.identifier)));if(!q.length)throw new Error(y.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...q),this.options.remove)for(const M of q)try{j.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(M)}catch(A){throw new Error(y.localize(6,null,(0,C.toErrorMessage)(A)))}}}}),define(Q[130],Z([0,1,115,3,17,7,2,8,25,19,93,14,114,140]),function(x,i,C,D,P,R,L,I,c,p,b,O,h,S){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.RequestService=void 0;let y=class extends L.Disposable{constructor(a,f,m){super();this.environmentService=f,this.logService=m,this.configure(a.getValue()),this._register(a.onDidChangeConfiguration(()=>this.configure(a.getValue()),this))}configure(a){this.proxyUrl=a.http&&a.http.proxy,this.strictSSL=!!(a.http&&a.http.proxyStrictSSL),this.authorization=a.http&&a.http.proxyAuthorization}async request(a,f){this.logService.trace("RequestService#request",a.url);const{proxyUrl:m,strictSSL:E}=this;let v;try{v=await(0,b.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(r){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",r))}const o={...process.env,...v},t=a.agent?a.agent:await(0,h.getProxyAgent)(a.url||"",o,{proxyUrl:m,strictSSL:E});return a.agent=t,a.strictSSL=E,this.authorization&&(a.headers={...a.headers||{},"Proxy-Authorization":this.authorization}),this._request(a,f)}async getNodeRequest(a){return((0,C.parse)(a.url).protocol==="https:"?await new Promise((E,v)=>{x(["https"],E,v)}):await new Promise((E,v)=>{x(["http"],E,v)})).request}_request(a,f){return D.Promises.withAsyncBody(async(m,E)=>{let v;const o=(0,C.parse)(a.url),t=a.getRawRequest?a.getRawRequest(a):await this.getNodeRequest(a),r={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:a.type||"GET",headers:a.headers,agent:a.agent,rejectUnauthorized:(0,I.isBoolean)(a.strictSSL)?a.strictSSL:!0};a.user&&a.password&&(r.auth=a.user+":"+a.password),v=t(r,e=>{const n=(0,I.isNumber)(a.followRedirects)?a.followRedirects:3;if(e.statusCode&&e.statusCode>=300&&e.statusCode<400&&n>0&&e.headers.location)this._request({...a,url:e.headers.location,followRedirects:n-1},f).then(m,E);else{let s=e;e.headers["content-encoding"]==="gzip"&&(s=e.pipe((0,S.createGunzip)())),m({res:e,stream:(0,P.streamToBufferReadableStream)(s)})}}),v.on("error",E),a.timeout&&v.setTimeout(a.timeout),a.data&&typeof a.data=="string"&&v.write(a.data),v.end(),f.onCancellationRequested(()=>{v.abort(),E((0,R.canceled)())})})}async resolveProxy(a){}};y=ge([ae(0,c.IConfigurationService),ae(1,p.INativeEnvironmentService),ae(2,O.ILogService)],y),i.RequestService=y}),define(Q[141],Z([0,1,38,3,17,28,7,2,11,10,31,9,15,25,107,49,113,19,88,120,23,109,129,16,100,102,40,97,52,53,112,14,104,122,32,42,130,117,30,121,35,123,124,36,126]),function(x,i,C,D,P,R,L,I,c,p,b,O,h,S,y,g,a,f,m,E,v,o,t,r,e,n,s,l,u,d,w,T,N,_,Y,re,te,ie,he,j,q,se,M,A,W){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.main=void 0;class K extends I.Disposable{constructor(ee){super();this.argv=ee,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[ee,G]=await this.initServices();return ee.invokeFunction(async U=>{const k=U.get(T.ILogService),z=U.get(r.IFileService),B=U.get(f.INativeEnvironmentService),H=U.get(v.IExtensionManagementCLIService);k.info("CLI main",this.argv),this.registerErrorHandler(k),await this.doRun(B,H,z),await Promise.all(G.map(X=>{(0,D.raceTimeout)(X.flush(),1e3)}))})}async initServices(){const ee=new u.ServiceCollection,G={_serviceBrand:void 0,..._.default};ee.set(Y.IProductService,G);const U=new m.NativeEnvironmentService(this.argv,G);ee.set(f.INativeEnvironmentService,U),await Promise.all([U.appSettingsHome.fsPath,U.extensionsPath].map(ye=>ye?h.Promises.mkdir(ye,{recursive:!0}):void 0));const k=(0,T.getLogLevel)(U),z=[];z.push(new N.SpdLogLogger("cli",(0,p.join)(U.logsPath,"cli.log"),!0,!1,k)),k===T.LogLevel.Trace&&z.push(new T.ConsoleLogger(k));const B=this._register(new T.MultiplexLogService(z));ee.set(T.ILogService,B);const H=this._register(new e.FileService(B));ee.set(r.IFileService,H);const X=this._register(new n.DiskFileSystemProvider(B));H.registerProvider(c.Schemas.file,X);const le=this._register(new y.ConfigurationService(U.settingsResource,H));ee.set(S.IConfigurationService,le),await le.initialize(),ee.set(A.IUriIdentityService,new W.UriIdentityService(H)),ee.set(re.IRequestService,new s.SyncDescriptor(te.RequestService)),ee.set(g.IDownloadService,new s.SyncDescriptor(a.DownloadService)),ee.set(v.IExtensionManagementService,new s.SyncDescriptor(t.ExtensionManagementService)),ee.set(v.IExtensionGalleryService,new s.SyncDescriptor(E.ExtensionGalleryServiceWithNoStorageService)),ee.set(v.IExtensionManagementCLIService,new s.SyncDescriptor(o.ExtensionManagementCLIService)),ee.set(d.ILocalizationsService,new s.SyncDescriptor(w.LocalizationsService));const ue=[];if((0,q.supportsTelemetry)(G,U)){G.aiConfig&&G.aiConfig.asimovKey&&ue.push(new se.AppInsightsAppender("monacoworkbench",null,G.aiConfig.asimovKey));const{appRoot:ye,extensionsPath:fe,installSourcePath:oe}=U,pe={appenders:ue,sendErrorTelemetry:!1,commonProperties:(async()=>{let me;try{const Ee=await h.Promises.readFile((0,p.join)(U.userDataPath,"storage.json"));me=JSON.parse(Ee.toString())[he.machineIdKey]}catch(Ee){Ee.code!=="ENOENT"&&B.error(Ee)}return(0,ie.resolveCommonProperties)(H,(0,C.release)(),(0,C.hostname)(),process.arch,G.commit,G.version,me,G.msftInternalDomains,oe)})(),piiPaths:[ye,fe]};ee.set(he.ITelemetryService,new s.SyncDescriptor(j.TelemetryService,[pe]))}else ee.set(he.ITelemetryService,q.NullTelemetryService);return[new l.InstantiationService(ee),ue]}registerErrorHandler(ee){(0,L.setUnexpectedErrorHandler)(G=>{const U=(0,R.toErrorMessage)(G,!0);!U||ee.error(`[uncaught exception in CLI]: ${U}`)}),process.on("uncaughtException",G=>(0,L.onUnexpectedError)(G)),process.on("unhandledRejection",G=>(0,L.onUnexpectedError)(G))}async doRun(ee,G,U){if(this.argv["install-source"])return this.setInstallSource(ee,U,this.argv["install-source"]);if(this.argv["list-extensions"])return G.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const k={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"]};return G.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],k,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return G.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return G.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(ee.appRoot,ee.extensionsPath))}}asExtensionIdOrVSIX(ee){return ee.map(G=>/\.vsix$/i.test(G)?O.URI.file((0,p.isAbsolute)(G)?G:(0,p.join)((0,b.cwd)(),G)):G)}async setInstallSource(ee,G,U){await G.writeFile(O.URI.file(ee.installSourcePath),P.VSBuffer.fromString(U.slice(0,30)))}}async function ne(J){const ee=new K(J);try{await ee.run()}finally{ee.dispose()}}i.main=ne})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/5554b12acf27056905806867f251c859323ff7e9/core/vs/code/node/cliProcessMain.js.map
