/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var pe=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/arrays","vs/base/common/types","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/buffer","vs/base/common/map","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/base/common/extpath","vs/base/node/pfs","vs/workbench/services/extensions/common/extensions","vs/workbench/services/search/common/search","vs/base/common/glob","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/severity","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/hash","vs/base/common/marshalling","fs","os","vs/platform/instantiation/common/extensions","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/languageSelector","vs/editor/common/model","vs/editor/common/languages","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/prefixSumComputer","vs/editor/common/services/semanticTokensDto","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/tunnel/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/languageFeatureRegistry","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/environment/node/userDataPath","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagement","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/virtualWorkspace","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsDragAndDropService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","path","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ve=function(ee){for(var e=[],d=0,t=ee.length;d<t;d++)e[d]=pe[ee[d]];return e};define(pe[55],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function d(t,I){if(!t)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}e.ok=d}),define(pe[73],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function d(T){return T?T.replace(/\$\((.*?)\)/g,(k,D)=>` ${D} `).trim():""}e.getCodiconAriaLabel=d;class t{constructor(k,D,P){this.id=k,this.definition=D,this.description=P,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function I(T,k){const D=["codicon","codicon-"+T];return k&&D.push("codicon-modifier-"+k),D}e.getClassNamesArray=I;var C;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function D(y){if(y instanceof t)return["codicon","codicon-"+y.id];const c=k.exec(y.id);if(!c)return D(t.error);let[,E,v]=c;const w=["codicon","codicon-"+E];return v&&w.push("codicon-modifier-"+v.substr(1)),w}T.asClassNameArray=D;function P(y){return D(y).join(" ")}T.asClassName=P;function F(y){return"."+D(y).join(".")}T.asCSSSelector=F})(C=e.CSSIcon||(e.CSSIcon={}))}),define(pe[74],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const d=Object.prototype.hasOwnProperty;function t(F){const y=[];for(let c in F)d.call(F,c)&&y.push(F[c]);return y}e.values=t;function I(F,y){for(let c in F)if(d.call(F,c)&&y({key:c,value:F[c]},function(){delete F[c]})===!1)return}e.forEach=I;function C(F,y){const c=Object.create(null);for(const E of F){const v=y(E);let w=c[v];w||(w=c[v]=[]),w.push(E)}return c}e.groupBy=C;function T(F){const y=Object.create(null);return F&&F.forEach((c,E)=>{y[E]=c}),y}e.fromMap=T;function k(F,y){const c=[],E=[];for(let v of F)y.has(v)||c.push(v);for(let v of y)F.has(v)||E.push(v);return{removed:c,added:E}}e.diffSets=k;function D(F,y){const c=[],E=[];for(let[v,w]of F)y.has(v)||c.push(w);for(let[v,w]of y)F.has(v)||E.push(w);return{removed:c,added:E}}e.diffMaps=D;class P{constructor(){this.map=new Map}add(y,c){let E=this.map.get(y);E||(E=new Set,this.map.set(y,E)),E.add(c)}delete(y,c){const E=this.map.get(y);!E||(E.delete(c),E.size===0&&this.map.delete(y))}forEach(y,c){const E=this.map.get(y);!E||E.forEach(c)}}e.SetMap=P}),define(pe[56],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function d(T){return(k,D,P)=>{let F=null,y=null;if(typeof P.value=="function"?(F="value",y=P.value):typeof P.get=="function"&&(F="get",y=P.get),!y)throw new Error("not supported");P[F]=T(y,D)}}e.createDecorator=d;function t(T,k,D){let P=null,F=null;if(typeof D.value=="function"?(P="value",F=D.value,F.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(P="get",F=D.get),!F)throw new Error("not supported");const y=`$memoize$${k}`;D[P]=function(...c){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:F.apply(this,c)}),this[y]}}e.memoize=t;function I(T,k,D){return d((P,F)=>{const y=`$debounce$${F}`,c=`$debounce$result$${F}`;return function(...E){this[c]||(this[c]=D?D():void 0),clearTimeout(this[y]),k&&(this[c]=k(this[c],...E),E=[this[c]]),this[y]=setTimeout(()=>{P.apply(this,E),this[c]=D?D():void 0},T)}})}e.debounce=I;function C(T,k,D){return d((P,F)=>{const y=`$throttle$timer$${F}`,c=`$throttle$result$${F}`,E=`$throttle$lastRun$${F}`,v=`$throttle$pending$${F}`;return function(...w){if(this[c]||(this[c]=D?D():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),k&&(this[c]=k(this[c],...w)),this[v])return;const _=this[E]+T;_<=Date.now()?(this[E]=Date.now(),P.apply(this,[this[c]]),this[c]=D?D():void 0):(this[v]=!0,this[y]=setTimeout(()=>{this[v]=!1,this[E]=Date.now(),P.apply(this,[this[c]]),this[c]=D?D():void 0},_-Date.now()))}})}e.throttle=C}),define(pe[16],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class d{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(S=>{S(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=d,e.errorHandler=new d;function t(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=t;function I(u){D(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=I;function C(u){D(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=C;function T(u){if(u instanceof Error){let{name:r,message:S}=u;const a=u.stacktrace||u.stack;return{$isError:!0,name:r,message:S,stack:a}}return u}e.transformErrorForSerialization=T;const k="Canceled";function D(u){return u instanceof P?!0:u instanceof Error&&u.name===k&&u.message===k}e.isCancellationError=D;class P extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=P;function F(){const u=new Error(k);return u.name=u.message,u}e.canceled=F;function y(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=y;function c(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=c;function E(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=E;function v(u){const r=new Error(`${u} has been disposed`);return r.name="DISPOSED",r}e.disposed=v;function w(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=w;class _ extends Error{constructor(r){super("NotImplemented");r&&(this.message=r)}}e.NotImplementedError=_;class R extends Error{constructor(r){super("NotSupported");r&&(this.message=r)}}e.NotSupportedError=R;class p extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=p;function h(u){const r=u;return r instanceof Error&&Array.isArray(r.actions)}e.isErrorWithActions=h;function s(u,r=Object.create(null)){const S=new Error(u);return r.actions&&(S.actions=r.actions),S}e.createErrorWithActions=s}),define(pe[17],ve([0,1,16]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function t(te,J=0){return te[te.length-(1+J)]}e.tail=t;function I(te){if(te.length===0)throw new Error("Invalid tail call");return[te.slice(0,te.length-1),te[te.length-1]]}e.tail2=I;function C(te,J,ae=(he,we)=>he===we){if(te===J)return!0;if(!te||!J||te.length!==J.length)return!1;for(let he=0,we=te.length;he<we;he++)if(!ae(te[he],J[he]))return!1;return!0}e.equals=C;function T(te,J,ae){let he=0,we=te.length-1;for(;he<=we;){const Ie=(he+we)/2|0,Ne=ae(te[Ie],J);if(Ne<0)he=Ie+1;else if(Ne>0)we=Ie-1;else return Ie}return-(he+1)}e.binarySearch=T;function k(te,J){let ae=0,he=te.length;if(he===0)return 0;for(;ae<he;){const we=Math.floor((ae+he)/2);J(te[we])?he=we:ae=we+1}return ae}e.findFirstInSorted=k;function D(te,J,ae){if(te=te|0,te>=J.length)throw new TypeError("invalid index");let he=J[Math.floor(J.length*Math.random())],we=[],Ie=[],Ne=[];for(let Ee of J){const be=ae(Ee,he);be<0?we.push(Ee):be>0?Ie.push(Ee):Ne.push(Ee)}return te<we.length?D(te,we,ae):te<we.length+Ne.length?Ne[0]:D(te-(we.length+Ne.length),Ie,ae)}e.quickSelect=D;function P(te,J){const ae=[];let he;for(const we of te.slice(0).sort(J))!he||J(he[0],we)!==0?(he=[we],ae.push(he)):he.push(we);return ae}e.groupBy=P;function F(te,J,ae){const he=[];function we(Ee,be,H){if(be===0&&H.length===0)return;const W=he[he.length-1];W&&W.start+W.deleteCount===Ee?(W.deleteCount+=be,W.toInsert.push(...H)):he.push({start:Ee,deleteCount:be,toInsert:H})}let Ie=0,Ne=0;for(;;){if(Ie===te.length){we(Ie,0,J.slice(Ne));break}if(Ne===J.length){we(Ie,te.length-Ie,[]);break}const Ee=te[Ie],be=J[Ne],H=ae(Ee,be);H===0?(Ie+=1,Ne+=1):H<0?(we(Ie,1,[]),Ie+=1):H>0&&(we(Ie,0,[be]),Ne+=1)}return he}e.sortedDiff=F;function y(te,J,ae){const he=F(te,J,ae),we=[],Ie=[];for(const Ne of he)we.push(...te.slice(Ne.start,Ne.start+Ne.deleteCount)),Ie.push(...Ne.toInsert);return{removed:we,added:Ie}}e.delta=y;function c(te,J,ae){if(ae===0)return[];const he=te.slice(0,ae).sort(J);return v(te,J,he,ae,te.length),he}e.top=c;function E(te,J,ae,he,we){return ae===0?Promise.resolve([]):new Promise((Ie,Ne)=>{(async()=>{const Ee=te.length,be=te.slice(0,ae).sort(J);for(let H=ae,W=Math.min(ae+he,Ee);H<Ee;H=W,W=Math.min(W+he,Ee)){if(H>ae&&await new Promise(O=>setTimeout(O)),we&&we.isCancellationRequested)throw(0,d.canceled)();v(te,J,be,H,W)}return be})().then(Ie,Ne)})}e.topAsync=E;function v(te,J,ae,he,we){for(const Ie=ae.length;he<we;he++){const Ne=te[he];if(J(Ne,ae[Ie-1])<0){ae.pop();const Ee=k(ae,be=>J(Ne,be)<0);ae.splice(Ee,0,Ne)}}}function w(te){return te.filter(J=>!!J)}e.coalesce=w;function _(te){let J=0;for(let ae=0;ae<te.length;ae++)te[ae]&&(te[J]=te[ae],J+=1);te.length=J}e.coalesceInPlace=_;function R(te,J,ae){te.splice(ae,0,te.splice(J,1)[0])}e.move=R;function p(te){return!Array.isArray(te)||te.length===0}e.isFalsyOrEmpty=p;function h(te){return Array.isArray(te)&&te.length>0}e.isNonEmptyArray=h;function s(te,J=ae=>ae){const ae=new Set;return te.filter(he=>{const we=J(he);return ae.has(we)?!1:(ae.add(we),!0)})}e.distinct=s;function u(te){const J=new Set;return ae=>{const he=te(ae);return J.has(he)?!1:(J.add(he),!0)}}e.uniqueFilter=u;function r(te,J){const ae=S(te,J);if(ae!==-1)return te[ae]}e.findLast=r;function S(te,J){for(let ae=te.length-1;ae>=0;ae--){const he=te[ae];if(J(he))return ae}return-1}e.lastIndex=S;function a(te,J){return te.length>0?te[0]:J}e.firstOrDefault=a;function i(te,J,ae=(he,we)=>he===we){let he=0;for(let we=0,Ie=Math.min(te.length,J.length);we<Ie&&ae(te[we],J[we]);we++)he++;return he}e.commonPrefixLength=i;function n(te){return[].concat(...te)}e.flatten=n;function o(te,J){let ae=typeof J=="number"?te:0;typeof J=="number"?ae=te:(ae=0,J=te);const he=[];if(ae<=J)for(let we=ae;we<J;we++)he.push(we);else for(let we=ae;we>J;we--)he.push(we);return he}e.range=o;function l(te,J,ae){return te.reduce((he,we)=>(he[J(we)]=ae?ae(we):we,he),Object.create(null))}e.index=l;function f(te,J){return te.push(J),()=>m(te,J)}e.insert=f;function m(te,J){const ae=te.indexOf(J);if(ae>-1)return te.splice(ae,1),J}e.remove=m;function b(te,J,ae){const he=te.slice(0,J),we=te.slice(J);return he.concat(ae,we)}e.arrayInsert=b;function A(te,J){let ae;if(typeof J=="number"){let he=J;ae=()=>{const we=Math.sin(he++)*179426549;return we-Math.floor(we)}}else ae=Math.random;for(let he=te.length-1;he>0;he-=1){const we=Math.floor(ae()*(he+1)),Ie=te[he];te[he]=te[we],te[we]=Ie}}e.shuffle=A;function L(te,J){const ae=te.indexOf(J);ae>-1&&(te.splice(ae,1),te.unshift(J))}e.pushToStart=L;function N(te,J){const ae=te.indexOf(J);ae>-1&&(te.splice(ae,1),te.push(J))}e.pushToEnd=N;function g(te,J){return Array.isArray(te)?te.map(J):J(te)}e.mapArrayOrNot=g;function M(te){return Array.isArray(te)?te:[te]}e.asArray=M;function U(te){return te[Math.floor(Math.random()*te.length)]}e.getRandomElement=U;function j(te,J){for(const ae of te){const he=J(ae);if(he!==void 0)return he}}e.mapFind=j;function K(te,J,ae){const he=x(te,J),we=te.length,Ie=ae.length;te.length=we+Ie;for(let Ne=we-1;Ne>=he;Ne--)te[Ne+Ie]=te[Ne];for(let Ne=0;Ne<Ie;Ne++)te[Ne+he]=ae[Ne]}e.insertInto=K;function B(te,J,ae,he){const we=x(te,J),Ie=te.splice(we,ae);return K(te,we,he),Ie}e.splice=B;function x(te,J){return J<0?Math.max(J+te.length,0):Math.min(J,te.length)}function z(te,J){return(ae,he)=>J(te(ae),te(he))}e.compareBy=z;const G=(te,J)=>te-J;e.numberComparator=G;function q(te,J){if(te.length===0)return;let ae=te[0];for(let he=1;he<te.length;he++){const we=te[he];J(we,ae)>0&&(ae=we)}return ae}e.findMaxBy=q;function Z(te,J){if(te.length===0)return;let ae=te[0];for(let he=1;he<te.length;he++){const we=te[he];J(we,ae)>=0&&(ae=we)}return ae}e.findLastMaxBy=Z;function se(te,J){return q(te,(ae,he)=>-J(ae,he))}e.findMinBy=se;class ue{constructor(J){this.items=J,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(J){let ae=this.firstIdx;for(;ae<this.items.length&&J(this.items[ae]);)ae++;const he=ae===this.firstIdx?null:this.items.slice(this.firstIdx,ae);return this.firstIdx=ae,he}takeFromEndWhile(J){let ae=this.lastIdx;for(;ae>=0&&J(this.items[ae]);)ae--;const he=ae===this.lastIdx?null:this.items.slice(ae+1,this.lastIdx+1);return this.lastIdx=ae,he}peek(){return this.items[this.firstIdx]}dequeue(){const J=this.items[this.firstIdx];return this.firstIdx++,J}takeCount(J){const ae=this.items.slice(this.firstIdx,this.firstIdx+J);return this.firstIdx+=J,ae}}e.ArrayQueue=ue}),define(pe[75],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function d(t){const I=this;let C=!1,T;return function(){return C||(C=!0,T=t.apply(I,arguments)),T}}e.once=d}),define(pe[76],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class d{constructor(I){this._prefix=I,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=d,e.defaultGenerator=new d("id#")}),define(pe[77],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var d;(function(t){function I(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}t.is=I;const C=Object.freeze([]);function T(){return C}t.empty=T;function*k(u){yield u}t.single=k;function D(u){return u||C}t.from=D;function P(u){return!u||u[Symbol.iterator]().next().done===!0}t.isEmpty=P;function F(u){return u[Symbol.iterator]().next().value}t.first=F;function y(u,r){for(const S of u)if(r(S))return!0;return!1}t.some=y;function c(u,r){for(const S of u)if(r(S))return S}t.find=c;function*E(u,r){for(const S of u)r(S)&&(yield S)}t.filter=E;function*v(u,r){let S=0;for(const a of u)yield r(a,S++)}t.map=v;function*w(...u){for(const r of u)for(const S of r)yield S}t.concat=w;function*_(u){for(const r of u)for(const S of r)yield S}t.concatNested=_;function R(u,r,S){let a=S;for(const i of u)a=r(a,i);return a}t.reduce=R;function*p(u,r,S=u.length){for(r<0&&(r+=u.length),S<0?S+=u.length:S>u.length&&(S=u.length);r<S;r++)yield u[r]}t.slice=p;function h(u,r=Number.POSITIVE_INFINITY){const S=[];if(r===0)return[S,u];const a=u[Symbol.iterator]();for(let i=0;i<r;i++){const n=a.next();if(n.done)return[S,t.empty()];S.push(n.value)}return[S,{[Symbol.iterator](){return a}}]}t.consume=h;function s(u,r,S=(a,i)=>a===i){const a=u[Symbol.iterator](),i=r[Symbol.iterator]();for(;;){const n=a.next(),o=i.next();if(n.done!==o.done)return!1;if(n.done)return!0;if(!S(n.value,o.value))return!1}}t.equals=s})(d=e.Iterable||(e.Iterable={}))}),define(pe[57],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var d;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(d=e.ScanError||(e.ScanError={}));var t;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var I;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(I=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(r){r.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function T(r,S=!1){let a=0,i=r.length,n="",o=0,l=16,f=0;function m(U){let j=0,K=0;for(;j<U;){const B=r.charCodeAt(a);if(B>=48&&B<=57)K=K*16+B-48;else if(B>=65&&B<=70)K=K*16+B-65+10;else if(B>=97&&B<=102)K=K*16+B-97+10;else break;a++,j++}return j<U&&(K=-1),K}function b(U){a=U,n="",o=0,l=16,f=0}function A(){const U=a;if(r.charCodeAt(a)===48)a++;else for(a++;a<r.length&&P(r.charCodeAt(a));)a++;if(a<r.length&&r.charCodeAt(a)===46)if(a++,a<r.length&&P(r.charCodeAt(a)))for(a++;a<r.length&&P(r.charCodeAt(a));)a++;else return f=3,r.substring(U,a);let j=a;if(a<r.length&&(r.charCodeAt(a)===69||r.charCodeAt(a)===101))if(a++,(a<r.length&&r.charCodeAt(a)===43||r.charCodeAt(a)===45)&&a++,a<r.length&&P(r.charCodeAt(a))){for(a++;a<r.length&&P(r.charCodeAt(a));)a++;j=a}else f=3;return r.substring(U,j)}function L(){let U="",j=a;for(;;){if(a>=i){U+=r.substring(j,a),f=2;break}const K=r.charCodeAt(a);if(K===34){U+=r.substring(j,a),a++;break}if(K===92){if(U+=r.substring(j,a),a++,a>=i){f=2;break}switch(r.charCodeAt(a++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const x=m(4);x>=0?U+=String.fromCharCode(x):f=4;break}default:f=5}j=a;continue}if(K>=0&&K<=31)if(D(K)){U+=r.substring(j,a),f=2;break}else f=6;a++}return U}function N(){if(n="",f=0,o=a,a>=i)return o=i,l=17;let U=r.charCodeAt(a);if(k(U)){do a++,n+=String.fromCharCode(U),U=r.charCodeAt(a);while(k(U));return l=15}if(D(U))return a++,n+=String.fromCharCode(U),U===13&&r.charCodeAt(a)===10&&(a++,n+=`
`),l=14;switch(U){case 123:return a++,l=1;case 125:return a++,l=2;case 91:return a++,l=3;case 93:return a++,l=4;case 58:return a++,l=6;case 44:return a++,l=5;case 34:return a++,n=L(),l=10;case 47:{const j=a-1;if(r.charCodeAt(a+1)===47){for(a+=2;a<i&&!D(r.charCodeAt(a));)a++;return n=r.substring(j,a),l=12}if(r.charCodeAt(a+1)===42){a+=2;const K=i-1;let B=!1;for(;a<K;){if(r.charCodeAt(a)===42&&r.charCodeAt(a+1)===47){a+=2,B=!0;break}a++}return B||(a++,f=1),n=r.substring(j,a),l=13}return n+=String.fromCharCode(U),a++,l=16}case 45:if(n+=String.fromCharCode(U),a++,a===i||!P(r.charCodeAt(a)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=A(),l=11;default:for(;a<i&&g(U);)a++,U=r.charCodeAt(a);if(o!==a){switch(n=r.substring(o,a),n){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return n+=String.fromCharCode(U),a++,l=16}}function g(U){if(k(U)||D(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let U;do U=N();while(U>=12&&U<=15);return U}return{setPosition:b,getPosition:()=>a,scan:S?M:N,getToken:()=>l,getTokenValue:()=>n,getTokenOffset:()=>o,getTokenLength:()=>a-o,getTokenError:()=>f}}e.createScanner=T;function k(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function D(r){return r===10||r===13||r===8232||r===8233}function P(r){return r>=48&&r<=57}var F;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(F||(F={}));function y(r,S){const a=[],i=new Object;let n;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function f(m,b,A,L){o.value=m,o.offset=b,o.length=A,o.type=L,o.colonOffset=void 0,n=o}try{h(r,{onObjectBegin:(m,b)=>{if(S<=m)throw i;n=void 0,l=S>m,a.push("")},onObjectProperty:(m,b,A)=>{if(S<b||(f(m,b,A,"property"),a[a.length-1]=m,S<=b+A))throw i},onObjectEnd:(m,b)=>{if(S<=m)throw i;n=void 0,a.pop()},onArrayBegin:(m,b)=>{if(S<=m)throw i;n=void 0,a.push(0)},onArrayEnd:(m,b)=>{if(S<=m)throw i;n=void 0,a.pop()},onLiteralValue:(m,b,A)=>{if(S<b||(f(m,b,A,u(m)),S<=b+A))throw i},onSeparator:(m,b,A)=>{if(S<=b)throw i;if(m===":"&&n&&n.type==="property")n.colonOffset=b,l=!1,n=void 0;else if(m===","){const L=a[a.length-1];typeof L=="number"?a[a.length-1]=L+1:(l=!0,a[a.length-1]=""),n=void 0}}})}catch(m){if(m!==i)throw m}return{path:a,previousNode:n,isAtPropertyKey:l,matches:m=>{let b=0;for(let A=0;b<m.length&&A<a.length;A++)if(m[b]===a[A]||m[b]==="*")b++;else if(m[b]!=="**")return!1;return b===m.length}}}e.getLocation=y;function c(r,S=[],a=C.DEFAULT){let i=null,n=[];const o=[];function l(m){Array.isArray(n)?n.push(m):i!==null&&(n[i]=m)}return h(r,{onObjectBegin:()=>{const m={};l(m),o.push(n),n=m,i=null},onObjectProperty:m=>{i=m},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{const m=[];l(m),o.push(n),n=m,i=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:l,onError:(m,b,A)=>{S.push({error:m,offset:b,length:A})}},a),n[0]}e.parse=c;function E(r,S=[],a=C.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(m){i.type==="property"&&(i.length=m-i.offset,i=i.parent)}function o(m){return i.children.push(m),m}h(r,{onObjectBegin:m=>{i=o({type:"object",offset:m,length:-1,parent:i,children:[]})},onObjectProperty:(m,b,A)=>{i=o({type:"property",offset:b,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:m,offset:b,length:A,parent:i})},onObjectEnd:(m,b)=>{i.length=m+b-i.offset,i=i.parent,n(m+b)},onArrayBegin:(m,b)=>{i=o({type:"array",offset:m,length:-1,parent:i,children:[]})},onArrayEnd:(m,b)=>{i.length=m+b-i.offset,i=i.parent,n(m+b)},onLiteralValue:(m,b,A)=>{o({type:u(m),offset:b,length:A,parent:i,value:m}),n(b+A)},onSeparator:(m,b,A)=>{i.type==="property"&&(m===":"?i.colonOffset=b:m===","&&n(b))},onError:(m,b,A)=>{S.push({error:m,offset:b,length:A})}},a);const f=i.children[0];return f&&delete f.parent,f}e.parseTree=E;function v(r,S){if(!r)return;let a=r;for(let i of S)if(typeof i=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let n=!1;for(const o of a.children)if(Array.isArray(o.children)&&o.children[0].value===i){a=o.children[1],n=!0;break}if(!n)return}else{const n=i;if(a.type!=="array"||n<0||!Array.isArray(a.children)||n>=a.children.length)return;a=a.children[n]}return a}e.findNodeAtLocation=v;function w(r){if(!r.parent||!r.parent.children)return[];const S=w(r.parent);if(r.parent.type==="property"){const a=r.parent.children[0].value;S.push(a)}else if(r.parent.type==="array"){const a=r.parent.children.indexOf(r);a!==-1&&S.push(a)}return S}e.getNodePath=w;function _(r){switch(r.type){case"array":return r.children.map(_);case"object":{const S=Object.create(null);for(let a of r.children){const i=a.children[1];i&&(S[a.children[0].value]=_(i))}return S}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=_;function R(r,S,a=!1){return S>=r.offset&&S<r.offset+r.length||a&&S===r.offset+r.length}e.contains=R;function p(r,S,a=!1){if(R(r,S,a)){const i=r.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=S;n++){const o=p(i[n],S,a);if(o)return o}return r}}e.findNodeAtOffset=p;function h(r,S,a=C.DEFAULT){const i=T(r,!1);function n(ue){return ue?()=>ue(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(ue){return ue?te=>ue(te,i.getTokenOffset(),i.getTokenLength()):()=>!0}const l=n(S.onObjectBegin),f=o(S.onObjectProperty),m=n(S.onObjectEnd),b=n(S.onArrayBegin),A=n(S.onArrayEnd),L=o(S.onLiteralValue),N=o(S.onSeparator),g=n(S.onComment),M=o(S.onError),U=a&&a.disallowComments,j=a&&a.allowTrailingComma;function K(){for(;;){const ue=i.scan();switch(i.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:U||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(ue){case 12:case 13:U?B(10):g();break;case 16:B(1);break;case 15:case 14:break;default:return ue}}}function B(ue,te=[],J=[]){if(M(ue),te.length+J.length>0){let ae=i.getToken();for(;ae!==17;){if(te.indexOf(ae)!==-1){K();break}else if(J.indexOf(ae)!==-1)break;ae=K()}}}function x(ue){const te=i.getTokenValue();return ue?L(te):f(te),K(),!0}function z(){switch(i.getToken()){case 11:{let ue=0;try{ue=JSON.parse(i.getTokenValue()),typeof ue!="number"&&(B(2),ue=0)}catch{B(2)}L(ue);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return K(),!0}function G(){return i.getToken()!==10?(B(3,[],[2,5]),!1):(x(!1),i.getToken()===6?(N(":"),K(),se()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function q(){l(),K();let ue=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(ue||B(4,[],[]),N(","),K(),i.getToken()===2&&j)break}else ue&&B(6,[],[]);G()||B(4,[],[2,5]),ue=!0}return m(),i.getToken()!==2?B(7,[2],[]):K(),!0}function Z(){b(),K();let ue=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(ue||B(4,[],[]),N(","),K(),i.getToken()===4&&j)break}else ue&&B(6,[],[]);se()||B(4,[],[4,5]),ue=!0}return A(),i.getToken()!==4?B(8,[4],[]):K(),!0}function se(){switch(i.getToken()){case 3:return Z();case 1:return q();case 10:return x(!0);default:return z()}}return K(),i.getToken()===17?a.allowEmptyContent?!0:(B(4,[],[]),!1):se()?(i.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}e.visit=h;function s(r,S){let a=T(r),i=[],n,o=0,l;do switch(l=a.getPosition(),n=a.scan(),n){case 12:case 13:case 17:o!==l&&i.push(r.substring(o,l)),S!==void 0&&i.push(a.getTokenValue().replace(/[^\r\n]/g,S)),o=a.getPosition();break}while(n!==17);return i.join("")}e.stripComments=s;function u(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(pe[140],ve([0,1,57]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(P,F,y){let c,E,v,w,_;if(F){for(w=F.offset,_=w+F.length,v=w;v>0&&!D(P,v-1);)v--;let l=_;for(;l<P.length&&!D(P,l);)l++;E=P.substring(v,l),c=T(E,y)}else E=P,c=0,v=0,w=0,_=P.length;const R=k(y,P);let p=!1,h=0,s;y.insertSpaces?s=C(" ",y.tabSize||4):s="	";const u=(0,d.createScanner)(E,!1);let r=!1;function S(){return R+C(s,c+h)}function a(){let l=u.scan();for(p=!1;l===15||l===14;)p=p||l===14,l=u.scan();return r=l===16||u.getTokenError()!==0,l}const i=[];function n(l,f,m){!r&&f<_&&m>w&&P.substring(f,m)!==l&&i.push({offset:f,length:m-f,content:l})}let o=a();if(o!==17){const l=u.getTokenOffset()+v,f=C(s,c);n(f,v,l)}for(;o!==17;){let l=u.getTokenOffset()+u.getTokenLength()+v,f=a(),m="";for(;!p&&(f===12||f===13);){const A=u.getTokenOffset()+v;n(" ",l,A),l=u.getTokenOffset()+u.getTokenLength()+v,m=f===12?S():"",f=a()}if(f===2)o!==1&&(h--,m=S());else if(f===4)o!==3&&(h--,m=S());else{switch(o){case 3:case 1:h++,m=S();break;case 5:case 12:m=S();break;case 13:p?m=S():m=" ";break;case 6:m=" ";break;case 10:if(f===6){m="";break}case 7:case 8:case 9:case 11:case 2:case 4:f===12||f===13?m=" ":f!==5&&f!==17&&(r=!0);break;case 16:r=!0;break}p&&(f===12||f===13)&&(m=S())}const b=u.getTokenOffset()+v;n(m,l,b),o=f}return i}e.format=t;function I(P,F){const y=JSON.stringify(P,void 0,F.insertSpaces?F.tabSize||4:"	");return F.eol!==void 0?y.replace(/\r\n|\r|\n/g,F.eol):y}e.toFormattedString=I;function C(P,F){let y="";for(let c=0;c<F;c++)y+=P;return y}function T(P,F){let y=0,c=0;const E=F.tabSize||4;for(;y<P.length;){const v=P.charAt(y);if(v===" ")c++;else if(v==="	")c+=E;else break;y++}return Math.floor(c/E)}function k(P,F){for(let y=0;y<F.length;y++){const c=F.charAt(y);if(c==="\r")return y+1<F.length&&F.charAt(y+1)===`
`?`\r
`:"\r";if(c===`
`)return`
`}return P&&P.eol||`
`}e.getEOL=k;function D(P,F){return`\r
`.indexOf(P.charAt(F))!==-1}e.isEOL=D}),define(pe[141],ve([0,1,57,140]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function I(P,F,y){return C(P,F,void 0,y)}e.removeProperty=I;function C(P,F,y,c,E){const v=F.slice(),w=[],_=(0,d.parseTree)(P,w);let R,p;for(;v.length>0&&(p=v.pop(),R=(0,d.findNodeAtLocation)(_,v),R===void 0&&y!==void 0);)typeof p=="string"?y={[p]:y}:y=[y];if(R)if(R.type==="object"&&typeof p=="string"&&Array.isArray(R.children)){const h=(0,d.findNodeAtLocation)(R,[p]);if(h!==void 0)if(y===void 0){if(!h.parent)throw new Error("Malformed AST");const s=R.children.indexOf(h.parent);let u,r=h.parent.offset+h.parent.length;if(s>0){const S=R.children[s-1];u=S.offset+S.length}else u=R.offset+1,R.children.length>1&&(r=R.children[1].offset);return T(P,{offset:u,length:r-u,content:""},c)}else return T(P,{offset:h.offset,length:h.length,content:JSON.stringify(y)},c);else{if(y===void 0)return[];const s=`${JSON.stringify(p)}: ${JSON.stringify(y)}`,u=E?E(R.children.map(S=>S.children[0].value)):R.children.length;let r;if(u>0){const S=R.children[u-1];r={offset:S.offset+S.length,length:0,content:","+s}}else R.children.length===0?r={offset:R.offset+1,length:0,content:s}:r={offset:R.offset+1,length:0,content:s+","};return T(P,r,c)}}else if(R.type==="array"&&typeof p=="number"&&Array.isArray(R.children))if(y!==void 0){const h=`${JSON.stringify(y)}`;let s;if(R.children.length===0||p===0)s={offset:R.offset+1,length:0,content:R.children.length===0?h:h+","};else{const u=p===-1||p>R.children.length?R.children.length:p,r=R.children[u-1];s={offset:r.offset+r.length,length:0,content:","+h}}return T(P,s,c)}else{const h=p,s=R.children[h];let u;if(R.children.length===1)u={offset:R.offset+1,length:R.length-2,content:""};else if(R.children.length-1===h){const r=R.children[h-1],S=r.offset+r.length,a=R.offset+R.length;u={offset:S,length:a-2-S,content:""}}else u={offset:s.offset,length:R.children[h+1].offset-s.offset,content:""};return T(P,u,c)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${R.type}`);else{if(y===void 0)throw new Error("Can not delete in empty document");return T(P,{offset:_?_.offset:0,length:_?_.length:0,content:JSON.stringify(y)},c)}}e.setProperty=C;function T(P,F,y){let c=k(P,F),E=F.offset,v=F.offset+F.content.length;if(F.length===0||F.content.length===0){for(;E>0&&!(0,t.isEOL)(c,E-1);)E--;for(;v<c.length&&!(0,t.isEOL)(c,v);)v++}const w=(0,t.format)(c,{offset:E,length:v-E},y);for(let R=w.length-1;R>=0;R--){const p=w[R];c=k(c,p),E=Math.min(E,p.offset),v=Math.max(v,p.offset+p.length),v+=p.content.length-p.length}const _=P.length-(c.length-v)-E;return[{offset:E,length:_,content:c.substring(E,v)}]}e.withFormatting=T;function k(P,F){return P.substring(0,F.offset)+F.content+P.substring(F.offset+F.length)}e.applyEdit=k;function D(P,F){let y=F.slice(0).sort((E,v)=>{const w=E.offset-v.offset;return w===0?E.length-v.length:w}),c=P.length;for(let E=y.length-1;E>=0;E--){let v=y[E];if(v.offset+v.length<=c)P=k(P,v);else throw new Error("Overlapping edit");c=v.offset}return P}e.applyEdits=D}),define(pe[93],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class d{constructor(I){this.executor=I,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(I){this._error=I}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(I){return new d(()=>I(this.getValue()))}}e.Lazy=d}),define(pe[6],ve([0,1,75,77]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const I=!1;let C=null;function T(i){C=i}if(e.setDisposableTracker=T,I){const i="__is_disposable_tracked__";T(new class{trackDisposable(n){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[i]||console.log(o)},3e3)}setParent(n,o){if(n&&n!==p.None)try{n[i]=!0}catch{}}markAsDisposed(n){if(n&&n!==p.None)try{n[i]=!0}catch{}}markAsSingleton(n){}})}function k(i){return C?.trackDisposable(i),i}function D(i){C?.markAsDisposed(i)}function P(i,n){C?.setParent(i,n)}function F(i,n){if(!!C)for(const o of i)C.setParent(o,n)}function y(i){return C?.markAsSingleton(i),i}e.markAsSingleton=y;class c extends Error{constructor(n){super(`Encountered errors while disposing of store. Errors: [${n.join(", ")}]`);this.errors=n}}e.MultiDisposeError=c;function E(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=E;function v(i){if(t.Iterable.is(i)){let n=[];for(const o of i)if(o)try{o.dispose()}catch(l){n.push(l)}if(n.length===1)throw n[0];if(n.length>1)throw new c(n);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=v;function w(...i){const n=_(()=>v(i));return F(i,n),n}e.combinedDisposable=w;function _(i){const n=k({dispose:(0,d.once)(()=>{D(n),i()})});return n}e.toDisposable=_;class R{constructor(){this._toDispose=new Set,this._isDisposed=!1,k(this)}dispose(){this._isDisposed||(D(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{v(this._toDispose.values())}finally{this._toDispose.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return P(n,this),this._isDisposed?R.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(n),n}}e.DisposableStore=R,R.DISABLE_DISPOSED_WARNING=!1;class p{constructor(){this._store=new R,k(this),P(this._store,this)}dispose(){D(this),this._store.dispose()}_register(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(n)}}e.Disposable=p,p.None=Object.freeze({dispose(){}});class h{constructor(){this._isDisposed=!1,k(this)}get value(){return this._isDisposed?void 0:this._value}set value(n){this._isDisposed||n===this._value||(this._value?.dispose(),n&&P(n,this),this._value=n)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,D(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const n=this._value;return this._value=void 0,n&&P(n,null),n}}e.MutableDisposable=h;class s{constructor(n){this._disposable=n,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=s;class u{constructor(){this.references=new Map}acquire(n,...o){let l=this.references.get(n);l||(l={counter:0,object:this.createReferencedObject(n,...o)},this.references.set(n,l));const{object:f}=l,m=(0,d.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(n,l.object),this.references.delete(n))});return l.counter++,{object:f,dispose:m}}}e.ReferenceCollection=u;class r{constructor(n){this.referenceCollection=n}async acquire(n,...o){const l=this.referenceCollection.acquire(n,...o);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(f){throw l.dispose(),f}}}e.AsyncReferenceCollection=r;class S{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=S;function a(i){const n=new R;try{i(n)}finally{n.dispose()}}e.disposeOnReturn=a}),define(pe[94],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class d{constructor(C){this.element=C,this.next=d.Undefined,this.prev=d.Undefined}}d.Undefined=new d(void 0);class t{constructor(){this._first=d.Undefined,this._last=d.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===d.Undefined}clear(){let C=this._first;for(;C!==d.Undefined;){const T=C.next;C.prev=d.Undefined,C.next=d.Undefined,C=T}this._first=d.Undefined,this._last=d.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,T){const k=new d(C);if(this._first===d.Undefined)this._first=k,this._last=k;else if(T){const P=this._last;this._last=k,k.prev=P,P.next=k}else{const P=this._first;this._first=k,k.next=P,P.prev=k}this._size+=1;let D=!1;return()=>{D||(D=!0,this._remove(k))}}shift(){if(this._first!==d.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==d.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==d.Undefined&&C.next!==d.Undefined){const T=C.prev;T.next=C.next,C.next.prev=T}else C.prev===d.Undefined&&C.next===d.Undefined?(this._first=d.Undefined,this._last=d.Undefined):C.next===d.Undefined?(this._last=this._last.prev,this._last.next=d.Undefined):C.prev===d.Undefined&&(this._first=this._first.next,this._first.prev=d.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==d.Undefined;)yield C.element,C=C.next}}e.LinkedList=t}),function(ee,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(pe[142],ve([1]),e):(ee=typeof globalThis!="undefined"?globalThis:ee||self,e(ee.marked={}))}(this,function(ee){"use strict";function e(Ee,be){for(var H=0;H<be.length;H++){var W=be[H];W.enumerable=W.enumerable||!1,W.configurable=!0,"value"in W&&(W.writable=!0),Object.defineProperty(Ee,W.key,W)}}function d(Ee,be,H){return be&&e(Ee.prototype,be),H&&e(Ee,H),Object.defineProperty(Ee,"prototype",{writable:!1}),Ee}function t(Ee,be){if(!!Ee){if(typeof Ee=="string")return I(Ee,be);var H=Object.prototype.toString.call(Ee).slice(8,-1);if(H==="Object"&&Ee.constructor&&(H=Ee.constructor.name),H==="Map"||H==="Set")return Array.from(Ee);if(H==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(H))return I(Ee,be)}}function I(Ee,be){(be==null||be>Ee.length)&&(be=Ee.length);for(var H=0,W=new Array(be);H<be;H++)W[H]=Ee[H];return W}function C(Ee,be){var H=typeof Symbol!="undefined"&&Ee[Symbol.iterator]||Ee["@@iterator"];if(H)return(H=H.call(Ee)).next.bind(H);if(Array.isArray(Ee)||(H=t(Ee))||be&&Ee&&typeof Ee.length=="number"){H&&(Ee=H);var W=0;return function(){return W>=Ee.length?{done:!0}:{done:!1,value:Ee[W++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function T(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ee.defaults=T();function k(Ee){ee.defaults=Ee}var D=/[&<>"']/,P=/[&<>"']/g,F=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(be){return c[be]};function v(Ee,be){if(be){if(D.test(Ee))return Ee.replace(P,E)}else if(F.test(Ee))return Ee.replace(y,E);return Ee}var w=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function _(Ee){return Ee.replace(w,function(be,H){return H=H.toLowerCase(),H==="colon"?":":H.charAt(0)==="#"?H.charAt(1)==="x"?String.fromCharCode(parseInt(H.substring(2),16)):String.fromCharCode(+H.substring(1)):""})}var R=/(^|[^\[])\^/g;function p(Ee,be){Ee=Ee.source||Ee,be=be||"";var H={replace:function(O,$){return $=$.source||$,$=$.replace(R,"$1"),Ee=Ee.replace(O,$),H},getRegex:function(){return new RegExp(Ee,be)}};return H}var h=/[^\w:]/g,s=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(Ee,be,H){if(Ee){var W;try{W=decodeURIComponent(_(H)).replace(h,"").toLowerCase()}catch{return null}if(W.indexOf("javascript:")===0||W.indexOf("vbscript:")===0||W.indexOf("data:")===0)return null}be&&!s.test(H)&&(H=n(be,H));try{H=encodeURI(H).replace(/%25/g,"%")}catch{return null}return H}var r={},S=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(Ee,be){r[" "+Ee]||(S.test(Ee)?r[" "+Ee]=Ee+"/":r[" "+Ee]=m(Ee,"/",!0)),Ee=r[" "+Ee];var H=Ee.indexOf(":")===-1;return be.substring(0,2)==="//"?H?be:Ee.replace(a,"$1")+be:be.charAt(0)==="/"?H?be:Ee.replace(i,"$1")+be:Ee+be}var o={exec:function(){}};function l(Ee){for(var be=1,H,W;be<arguments.length;be++){H=arguments[be];for(W in H)Object.prototype.hasOwnProperty.call(H,W)&&(Ee[W]=H[W])}return Ee}function f(Ee,be){var H=Ee.replace(/\|/g,function($,Q,re){for(var de=!1,ye=Q;--ye>=0&&re[ye]==="\\";)de=!de;return de?"|":" |"}),W=H.split(/ \|/),O=0;if(W[0].trim()||W.shift(),W[W.length-1].trim()||W.pop(),W.length>be)W.splice(be);else for(;W.length<be;)W.push("");for(;O<W.length;O++)W[O]=W[O].trim().replace(/\\\|/g,"|");return W}function m(Ee,be,H){var W=Ee.length;if(W===0)return"";for(var O=0;O<W;){var $=Ee.charAt(W-O-1);if($===be&&!H)O++;else if($!==be&&H)O++;else break}return Ee.substr(0,W-O)}function b(Ee,be){if(Ee.indexOf(be[1])===-1)return-1;for(var H=Ee.length,W=0,O=0;O<H;O++)if(Ee[O]==="\\")O++;else if(Ee[O]===be[0])W++;else if(Ee[O]===be[1]&&(W--,W<0))return O;return-1}function A(Ee){Ee&&Ee.sanitize&&!Ee.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(Ee,be){if(be<1)return"";for(var H="";be>1;)be&1&&(H+=Ee),be>>=1,Ee+=Ee;return H+Ee}function N(Ee,be,H,W){var O=be.href,$=be.title?v(be.title):null,Q=Ee[1].replace(/\\([\[\]])/g,"$1");if(Ee[0].charAt(0)!=="!"){W.state.inLink=!0;var re={type:"link",raw:H,href:O,title:$,text:Q,tokens:W.inlineTokens(Q,[])};return W.state.inLink=!1,re}else return{type:"image",raw:H,href:O,title:$,text:v(Q)}}function g(Ee,be){var H=Ee.match(/^(\s+)(?:```)/);if(H===null)return be;var W=H[1];return be.split(`
`).map(function(O){var $=O.match(/^\s+/);if($===null)return O;var Q=$[0];return Q.length>=W.length?O.slice(W.length):O}).join(`
`)}var M=function(){function Ee(H){this.options=H||ee.defaults}var be=Ee.prototype;return be.space=function(W){var O=this.rules.block.newline.exec(W);if(O&&O[0].length>0)return{type:"space",raw:O[0]}},be.code=function(W){var O=this.rules.block.code.exec(W);if(O){var $=O[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:O[0],codeBlockStyle:"indented",text:this.options.pedantic?$:m($,`
`)}}},be.fences=function(W){var O=this.rules.block.fences.exec(W);if(O){var $=O[0],Q=g($,O[3]||"");return{type:"code",raw:$,lang:O[2]?O[2].trim():O[2],text:Q}}},be.heading=function(W){var O=this.rules.block.heading.exec(W);if(O){var $=O[2].trim();if(/#$/.test($)){var Q=m($,"#");(this.options.pedantic||!Q||/ $/.test(Q))&&($=Q.trim())}var re={type:"heading",raw:O[0],depth:O[1].length,text:$,tokens:[]};return this.lexer.inline(re.text,re.tokens),re}},be.hr=function(W){var O=this.rules.block.hr.exec(W);if(O)return{type:"hr",raw:O[0]}},be.blockquote=function(W){var O=this.rules.block.blockquote.exec(W);if(O){var $=O[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:O[0],tokens:this.lexer.blockTokens($,[]),text:$}}},be.list=function(W){var O=this.rules.block.list.exec(W);if(O){var $,Q,re,de,ye,Ae,We,$e,je,He,Ue,Je,rt=O[1].trim(),Re=rt.length>1,tt={type:"list",raw:"",ordered:Re,start:Re?+rt.slice(0,-1):"",loose:!1,items:[]};rt=Re?"\\d{1,9}\\"+rt.slice(-1):"\\"+rt,this.options.pedantic&&(rt=Re?rt:"[*+-]");for(var ne=new RegExp("^( {0,3}"+rt+")((?: [^\\n]*)?(?:\\n|$))");W&&(Je=!1,!(!(O=ne.exec(W))||this.rules.block.hr.test(W)));){if($=O[0],W=W.substring($.length),$e=O[2].split(`
`,1)[0],je=W.split(`
`,1)[0],this.options.pedantic?(de=2,Ue=$e.trimLeft()):(de=O[2].search(/[^ ]/),de=de>4?1:de,Ue=$e.slice(de),de+=O[1].length),Ae=!1,!$e&&/^ *$/.test(je)&&($+=je+`
`,W=W.substring(je.length+1),Je=!0),!Je)for(var oe=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:[*+-]|\\d{1,9}[.)])");W&&(He=W.split(`
`,1)[0],$e=He,this.options.pedantic&&($e=$e.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!oe.test($e));){if($e.search(/[^ ]/)>=de||!$e.trim())Ue+=`
`+$e.slice(de);else if(!Ae)Ue+=`
`+$e;else break;!Ae&&!$e.trim()&&(Ae=!0),$+=He+`
`,W=W.substring(He.length+1)}tt.loose||(We?tt.loose=!0:/\n *\n *$/.test($)&&(We=!0)),this.options.gfm&&(Q=/^\[[ xX]\] /.exec(Ue),Q&&(re=Q[0]!=="[ ] ",Ue=Ue.replace(/^\[[ xX]\] +/,""))),tt.items.push({type:"list_item",raw:$,task:!!Q,checked:re,loose:!1,text:Ue}),tt.raw+=$}tt.items[tt.items.length-1].raw=$.trimRight(),tt.items[tt.items.length-1].text=Ue.trimRight(),tt.raw=tt.raw.trimRight();var Y=tt.items.length;for(ye=0;ye<Y;ye++){this.lexer.state.top=!1,tt.items[ye].tokens=this.lexer.blockTokens(tt.items[ye].text,[]);var ge=tt.items[ye].tokens.filter(function(Oe){return Oe.type==="space"}),_e=ge.every(function(Oe){for(var ze=Oe.raw.split(""),Ze=0,lt=C(ze),vt;!(vt=lt()).done;){var Ge=vt.value;if(Ge===`
`&&(Ze+=1),Ze>1)return!0}return!1});!tt.loose&&ge.length&&_e&&(tt.loose=!0,tt.items[ye].loose=!0)}return tt}},be.html=function(W){var O=this.rules.block.html.exec(W);if(O){var $={type:"html",raw:O[0],pre:!this.options.sanitizer&&(O[1]==="pre"||O[1]==="script"||O[1]==="style"),text:O[0]};return this.options.sanitize&&($.type="paragraph",$.text=this.options.sanitizer?this.options.sanitizer(O[0]):v(O[0]),$.tokens=[],this.lexer.inline($.text,$.tokens)),$}},be.def=function(W){var O=this.rules.block.def.exec(W);if(O){O[3]&&(O[3]=O[3].substring(1,O[3].length-1));var $=O[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:$,raw:O[0],href:O[2],title:O[3]}}},be.table=function(W){var O=this.rules.block.table.exec(W);if(O){var $={type:"table",header:f(O[1]).map(function(We){return{text:We}}),align:O[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:O[3]?O[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if($.header.length===$.align.length){$.raw=O[0];var Q=$.align.length,re,de,ye,Ae;for(re=0;re<Q;re++)/^ *-+: *$/.test($.align[re])?$.align[re]="right":/^ *:-+: *$/.test($.align[re])?$.align[re]="center":/^ *:-+ *$/.test($.align[re])?$.align[re]="left":$.align[re]=null;for(Q=$.rows.length,re=0;re<Q;re++)$.rows[re]=f($.rows[re],$.header.length).map(function(We){return{text:We}});for(Q=$.header.length,de=0;de<Q;de++)$.header[de].tokens=[],this.lexer.inlineTokens($.header[de].text,$.header[de].tokens);for(Q=$.rows.length,de=0;de<Q;de++)for(Ae=$.rows[de],ye=0;ye<Ae.length;ye++)Ae[ye].tokens=[],this.lexer.inlineTokens(Ae[ye].text,Ae[ye].tokens);return $}}},be.lheading=function(W){var O=this.rules.block.lheading.exec(W);if(O){var $={type:"heading",raw:O[0],depth:O[2].charAt(0)==="="?1:2,text:O[1],tokens:[]};return this.lexer.inline($.text,$.tokens),$}},be.paragraph=function(W){var O=this.rules.block.paragraph.exec(W);if(O){var $={type:"paragraph",raw:O[0],text:O[1].charAt(O[1].length-1)===`
`?O[1].slice(0,-1):O[1],tokens:[]};return this.lexer.inline($.text,$.tokens),$}},be.text=function(W){var O=this.rules.block.text.exec(W);if(O){var $={type:"text",raw:O[0],text:O[0],tokens:[]};return this.lexer.inline($.text,$.tokens),$}},be.escape=function(W){var O=this.rules.inline.escape.exec(W);if(O)return{type:"escape",raw:O[0],text:v(O[1])}},be.tag=function(W){var O=this.rules.inline.tag.exec(W);if(O)return!this.lexer.state.inLink&&/^<a /i.test(O[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(O[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(O[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(O[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:O[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(O[0]):v(O[0]):O[0]}},be.link=function(W){var O=this.rules.inline.link.exec(W);if(O){var $=O[2].trim();if(!this.options.pedantic&&/^</.test($)){if(!/>$/.test($))return;var Q=m($.slice(0,-1),"\\");if(($.length-Q.length)%2==0)return}else{var re=b(O[2],"()");if(re>-1){var de=O[0].indexOf("!")===0?5:4,ye=de+O[1].length+re;O[2]=O[2].substring(0,re),O[0]=O[0].substring(0,ye).trim(),O[3]=""}}var Ae=O[2],We="";if(this.options.pedantic){var $e=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);$e&&(Ae=$e[1],We=$e[3])}else We=O[3]?O[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test($)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),N(O,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:We&&We.replace(this.rules.inline._escapes,"$1")},O[0],this.lexer)}},be.reflink=function(W,O){var $;if(($=this.rules.inline.reflink.exec(W))||($=this.rules.inline.nolink.exec(W))){var Q=($[2]||$[1]).replace(/\s+/g," ");if(Q=O[Q.toLowerCase()],!Q||!Q.href){var re=$[0].charAt(0);return{type:"text",raw:re,text:re}}return N($,Q,$[0],this.lexer)}},be.emStrong=function(W,O,$){$===void 0&&($="");var Q=this.rules.inline.emStrong.lDelim.exec(W);if(!!Q&&!(Q[3]&&$.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var re=Q[1]||Q[2]||"";if(!re||re&&($===""||this.rules.inline.punctuation.exec($))){var de=Q[0].length-1,ye,Ae,We=de,$e=0,je=Q[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(je.lastIndex=0,O=O.slice(-1*W.length+de);(Q=je.exec(O))!=null;)if(ye=Q[1]||Q[2]||Q[3]||Q[4]||Q[5]||Q[6],!!ye){if(Ae=ye.length,Q[3]||Q[4]){We+=Ae;continue}else if((Q[5]||Q[6])&&de%3&&!((de+Ae)%3)){$e+=Ae;continue}if(We-=Ae,!(We>0)){if(Ae=Math.min(Ae,Ae+We+$e),Math.min(de,Ae)%2){var He=W.slice(1,de+Q.index+Ae);return{type:"em",raw:W.slice(0,de+Q.index+Ae+1),text:He,tokens:this.lexer.inlineTokens(He,[])}}var Ue=W.slice(2,de+Q.index+Ae-1);return{type:"strong",raw:W.slice(0,de+Q.index+Ae+1),text:Ue,tokens:this.lexer.inlineTokens(Ue,[])}}}}}},be.codespan=function(W){var O=this.rules.inline.code.exec(W);if(O){var $=O[2].replace(/\n/g," "),Q=/[^ ]/.test($),re=/^ /.test($)&&/ $/.test($);return Q&&re&&($=$.substring(1,$.length-1)),$=v($,!0),{type:"codespan",raw:O[0],text:$}}},be.br=function(W){var O=this.rules.inline.br.exec(W);if(O)return{type:"br",raw:O[0]}},be.del=function(W){var O=this.rules.inline.del.exec(W);if(O)return{type:"del",raw:O[0],text:O[2],tokens:this.lexer.inlineTokens(O[2],[])}},be.autolink=function(W,O){var $=this.rules.inline.autolink.exec(W);if($){var Q,re;return $[2]==="@"?(Q=v(this.options.mangle?O($[1]):$[1]),re="mailto:"+Q):(Q=v($[1]),re=Q),{type:"link",raw:$[0],text:Q,href:re,tokens:[{type:"text",raw:Q,text:Q}]}}},be.url=function(W,O){var $;if($=this.rules.inline.url.exec(W)){var Q,re;if($[2]==="@")Q=v(this.options.mangle?O($[0]):$[0]),re="mailto:"+Q;else{var de;do de=$[0],$[0]=this.rules.inline._backpedal.exec($[0])[0];while(de!==$[0]);Q=v($[0]),$[1]==="www."?re="http://"+Q:re=Q}return{type:"link",raw:$[0],text:Q,href:re,tokens:[{type:"text",raw:Q,text:Q}]}}},be.inlineText=function(W,O){var $=this.rules.inline.text.exec(W);if($){var Q;return this.lexer.state.inRawBlock?Q=this.options.sanitize?this.options.sanitizer?this.options.sanitizer($[0]):v($[0]):$[0]:Q=v(this.options.smartypants?O($[0]):$[0]),{type:"text",raw:$[0],text:Q}}},Ee}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:o,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=p(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=p(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=p(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=p(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=p(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=p(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=l({},U),U.gfm=l({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=p(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=p(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=l({},U.normal,{html:p(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:o,paragraph:p(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var j={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:o,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:o,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};j._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",j.punctuation=p(j.punctuation).replace(/punctuation/g,j._punctuation).getRegex(),j.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,j.escapedEmSt=/\\\*|\\_/g,j._comment=p(U._comment).replace("(?:-->|$)","-->").getRegex(),j.emStrong.lDelim=p(j.emStrong.lDelim).replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimAst=p(j.emStrong.rDelimAst,"g").replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimUnd=p(j.emStrong.rDelimUnd,"g").replace(/punct/g,j._punctuation).getRegex(),j._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,j._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,j._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,j.autolink=p(j.autolink).replace("scheme",j._scheme).replace("email",j._email).getRegex(),j._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,j.tag=p(j.tag).replace("comment",j._comment).replace("attribute",j._attribute).getRegex(),j._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,j._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,j._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,j.link=p(j.link).replace("label",j._label).replace("href",j._href).replace("title",j._title).getRegex(),j.reflink=p(j.reflink).replace("label",j._label).replace("ref",U._label).getRegex(),j.nolink=p(j.nolink).replace("ref",U._label).getRegex(),j.reflinkSearch=p(j.reflinkSearch,"g").replace("reflink",j.reflink).replace("nolink",j.nolink).getRegex(),j.normal=l({},j),j.pedantic=l({},j.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:p(/^!?\[(label)\]\((.*?)\)/).replace("label",j._label).getRegex(),reflink:p(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",j._label).getRegex()}),j.gfm=l({},j.normal,{escape:p(j.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),j.gfm.url=p(j.gfm.url,"i").replace("email",j.gfm._extended_email).getRegex(),j.breaks=l({},j.gfm,{br:p(j.br).replace("{2,}","*").getRegex(),text:p(j.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function K(Ee){return Ee.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(Ee){var be="",H,W,O=Ee.length;for(H=0;H<O;H++)W=Ee.charCodeAt(H),Math.random()>.5&&(W="x"+W.toString(16)),be+="&#"+W+";";return be}var x=function(){function Ee(H){this.tokens=[],this.tokens.links=Object.create(null),this.options=H||ee.defaults,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var W={block:U.normal,inline:j.normal};this.options.pedantic?(W.block=U.pedantic,W.inline=j.pedantic):this.options.gfm&&(W.block=U.gfm,this.options.breaks?W.inline=j.breaks:W.inline=j.gfm),this.tokenizer.rules=W}Ee.lex=function(W,O){var $=new Ee(O);return $.lex(W)},Ee.lexInline=function(W,O){var $=new Ee(O);return $.inlineTokens(W)};var be=Ee.prototype;return be.lex=function(W){W=W.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(W,this.tokens);for(var O;O=this.inlineQueue.shift();)this.inlineTokens(O.src,O.tokens);return this.tokens},be.blockTokens=function(W,O){var $=this;O===void 0&&(O=[]),this.options.pedantic&&(W=W.replace(/^ +$/gm,""));for(var Q,re,de,ye;W;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(We){return(Q=We.call({lexer:$},W,O))?(W=W.substring(Q.raw.length),O.push(Q),!0):!1}))){if(Q=this.tokenizer.space(W)){W=W.substring(Q.raw.length),Q.raw.length===1&&O.length>0?O[O.length-1].raw+=`
`:O.push(Q);continue}if(Q=this.tokenizer.code(W)){W=W.substring(Q.raw.length),re=O[O.length-1],re&&(re.type==="paragraph"||re.type==="text")?(re.raw+=`
`+Q.raw,re.text+=`
`+Q.text,this.inlineQueue[this.inlineQueue.length-1].src=re.text):O.push(Q);continue}if(Q=this.tokenizer.fences(W)){W=W.substring(Q.raw.length),O.push(Q);continue}if(Q=this.tokenizer.heading(W)){W=W.substring(Q.raw.length),O.push(Q);continue}if(Q=this.tokenizer.hr(W)){W=W.substring(Q.raw.length),O.push(Q);continue}if(Q=this.tokenizer.blockquote(W)){W=W.substring(Q.raw.length),O.push(Q);continue}if(Q=this.tokenizer.list(W)){W=W.substring(Q.raw.length),O.push(Q);continue}if(Q=this.tokenizer.html(W)){W=W.substring(Q.raw.length),O.push(Q);continue}if(Q=this.tokenizer.def(W)){W=W.substring(Q.raw.length),re=O[O.length-1],re&&(re.type==="paragraph"||re.type==="text")?(re.raw+=`
`+Q.raw,re.text+=`
`+Q.raw,this.inlineQueue[this.inlineQueue.length-1].src=re.text):this.tokens.links[Q.tag]||(this.tokens.links[Q.tag]={href:Q.href,title:Q.title});continue}if(Q=this.tokenizer.table(W)){W=W.substring(Q.raw.length),O.push(Q);continue}if(Q=this.tokenizer.lheading(W)){W=W.substring(Q.raw.length),O.push(Q);continue}if(de=W,this.options.extensions&&this.options.extensions.startBlock&&function(){var We=1/0,$e=W.slice(1),je=void 0;$.options.extensions.startBlock.forEach(function(He){je=He.call({lexer:this},$e),typeof je=="number"&&je>=0&&(We=Math.min(We,je))}),We<1/0&&We>=0&&(de=W.substring(0,We+1))}(),this.state.top&&(Q=this.tokenizer.paragraph(de))){re=O[O.length-1],ye&&re.type==="paragraph"?(re.raw+=`
`+Q.raw,re.text+=`
`+Q.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=re.text):O.push(Q),ye=de.length!==W.length,W=W.substring(Q.raw.length);continue}if(Q=this.tokenizer.text(W)){W=W.substring(Q.raw.length),re=O[O.length-1],re&&re.type==="text"?(re.raw+=`
`+Q.raw,re.text+=`
`+Q.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=re.text):O.push(Q);continue}if(W){var Ae="Infinite loop on byte: "+W.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,O},be.inline=function(W,O){this.inlineQueue.push({src:W,tokens:O})},be.inlineTokens=function(W,O){var $=this;O===void 0&&(O=[]);var Q,re,de,ye=W,Ae,We,$e;if(this.tokens.links){var je=Object.keys(this.tokens.links);if(je.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(ye))!=null;)je.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(ye=ye.slice(0,Ae.index)+"["+L("a",Ae[0].length-2)+"]"+ye.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(ye))!=null;)ye=ye.slice(0,Ae.index)+"["+L("a",Ae[0].length-2)+"]"+ye.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(ye))!=null;)ye=ye.slice(0,Ae.index)+"++"+ye.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;W;)if(We||($e=""),We=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ue){return(Q=Ue.call({lexer:$},W,O))?(W=W.substring(Q.raw.length),O.push(Q),!0):!1}))){if(Q=this.tokenizer.escape(W)){W=W.substring(Q.raw.length),O.push(Q);continue}if(Q=this.tokenizer.tag(W)){W=W.substring(Q.raw.length),re=O[O.length-1],re&&Q.type==="text"&&re.type==="text"?(re.raw+=Q.raw,re.text+=Q.text):O.push(Q);continue}if(Q=this.tokenizer.link(W)){W=W.substring(Q.raw.length),O.push(Q);continue}if(Q=this.tokenizer.reflink(W,this.tokens.links)){W=W.substring(Q.raw.length),re=O[O.length-1],re&&Q.type==="text"&&re.type==="text"?(re.raw+=Q.raw,re.text+=Q.text):O.push(Q);continue}if(Q=this.tokenizer.emStrong(W,ye,$e)){W=W.substring(Q.raw.length),O.push(Q);continue}if(Q=this.tokenizer.codespan(W)){W=W.substring(Q.raw.length),O.push(Q);continue}if(Q=this.tokenizer.br(W)){W=W.substring(Q.raw.length),O.push(Q);continue}if(Q=this.tokenizer.del(W)){W=W.substring(Q.raw.length),O.push(Q);continue}if(Q=this.tokenizer.autolink(W,B)){W=W.substring(Q.raw.length),O.push(Q);continue}if(!this.state.inLink&&(Q=this.tokenizer.url(W,B))){W=W.substring(Q.raw.length),O.push(Q);continue}if(de=W,this.options.extensions&&this.options.extensions.startInline&&function(){var Ue=1/0,Je=W.slice(1),rt=void 0;$.options.extensions.startInline.forEach(function(Re){rt=Re.call({lexer:this},Je),typeof rt=="number"&&rt>=0&&(Ue=Math.min(Ue,rt))}),Ue<1/0&&Ue>=0&&(de=W.substring(0,Ue+1))}(),Q=this.tokenizer.inlineText(de,K)){W=W.substring(Q.raw.length),Q.raw.slice(-1)!=="_"&&($e=Q.raw.slice(-1)),We=!0,re=O[O.length-1],re&&re.type==="text"?(re.raw+=Q.raw,re.text+=Q.text):O.push(Q);continue}if(W){var He="Infinite loop on byte: "+W.charCodeAt(0);if(this.options.silent){console.error(He);break}else throw new Error(He)}}return O},d(Ee,null,[{key:"rules",get:function(){return{block:U,inline:j}}}]),Ee}(),z=function(){function Ee(H){this.options=H||ee.defaults}var be=Ee.prototype;return be.code=function(W,O,$){var Q=(O||"").match(/\S*/)[0];if(this.options.highlight){var re=this.options.highlight(W,Q);re!=null&&re!==W&&($=!0,W=re)}return W=W.replace(/\n$/,"")+`
`,Q?'<pre><code class="'+this.options.langPrefix+v(Q,!0)+'">'+($?W:v(W,!0))+`</code></pre>
`:"<pre><code>"+($?W:v(W,!0))+`</code></pre>
`},be.blockquote=function(W){return`<blockquote>
`+W+`</blockquote>
`},be.html=function(W){return W},be.heading=function(W,O,$,Q){return this.options.headerIds?"<h"+O+' id="'+this.options.headerPrefix+Q.slug($)+'">'+W+"</h"+O+`>
`:"<h"+O+">"+W+"</h"+O+`>
`},be.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},be.list=function(W,O,$){var Q=O?"ol":"ul",re=O&&$!==1?' start="'+$+'"':"";return"<"+Q+re+`>
`+W+"</"+Q+`>
`},be.listitem=function(W){return"<li>"+W+`</li>
`},be.checkbox=function(W){return"<input "+(W?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},be.paragraph=function(W){return"<p>"+W+`</p>
`},be.table=function(W,O){return O&&(O="<tbody>"+O+"</tbody>"),`<table>
<thead>
`+W+`</thead>
`+O+`</table>
`},be.tablerow=function(W){return`<tr>
`+W+`</tr>
`},be.tablecell=function(W,O){var $=O.header?"th":"td",Q=O.align?"<"+$+' align="'+O.align+'">':"<"+$+">";return Q+W+"</"+$+`>
`},be.strong=function(W){return"<strong>"+W+"</strong>"},be.em=function(W){return"<em>"+W+"</em>"},be.codespan=function(W){return"<code>"+W+"</code>"},be.br=function(){return this.options.xhtml?"<br/>":"<br>"},be.del=function(W){return"<del>"+W+"</del>"},be.link=function(W,O,$){if(W=u(this.options.sanitize,this.options.baseUrl,W),W===null)return $;var Q='<a href="'+v(W)+'"';return O&&(Q+=' title="'+O+'"'),Q+=">"+$+"</a>",Q},be.image=function(W,O,$){if(W=u(this.options.sanitize,this.options.baseUrl,W),W===null)return $;var Q='<img src="'+W+'" alt="'+$+'"';return O&&(Q+=' title="'+O+'"'),Q+=this.options.xhtml?"/>":">",Q},be.text=function(W){return W},Ee}(),G=function(){function Ee(){}var be=Ee.prototype;return be.strong=function(W){return W},be.em=function(W){return W},be.codespan=function(W){return W},be.del=function(W){return W},be.html=function(W){return W},be.text=function(W){return W},be.link=function(W,O,$){return""+$},be.image=function(W,O,$){return""+$},be.br=function(){return""},Ee}(),q=function(){function Ee(){this.seen={}}var be=Ee.prototype;return be.serialize=function(W){return W.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},be.getNextSafeSlug=function(W,O){var $=W,Q=0;if(this.seen.hasOwnProperty($)){Q=this.seen[W];do Q++,$=W+"-"+Q;while(this.seen.hasOwnProperty($))}return O||(this.seen[W]=Q,this.seen[$]=0),$},be.slug=function(W,O){O===void 0&&(O={});var $=this.serialize(W);return this.getNextSafeSlug($,O.dryrun)},Ee}(),Z=function(){function Ee(H){this.options=H||ee.defaults,this.options.renderer=this.options.renderer||new z,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new G,this.slugger=new q}Ee.parse=function(W,O){var $=new Ee(O);return $.parse(W)},Ee.parseInline=function(W,O){var $=new Ee(O);return $.parseInline(W)};var be=Ee.prototype;return be.parse=function(W,O){O===void 0&&(O=!0);var $="",Q,re,de,ye,Ae,We,$e,je,He,Ue,Je,rt,Re,tt,ne,oe,Y,ge,_e,Oe=W.length;for(Q=0;Q<Oe;Q++){if(Ue=W[Q],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ue.type]&&(_e=this.options.extensions.renderers[Ue.type].call({parser:this},Ue),_e!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ue.type))){$+=_e||"";continue}switch(Ue.type){case"space":continue;case"hr":{$+=this.renderer.hr();continue}case"heading":{$+=this.renderer.heading(this.parseInline(Ue.tokens),Ue.depth,_(this.parseInline(Ue.tokens,this.textRenderer)),this.slugger);continue}case"code":{$+=this.renderer.code(Ue.text,Ue.lang,Ue.escaped);continue}case"table":{for(je="",$e="",ye=Ue.header.length,re=0;re<ye;re++)$e+=this.renderer.tablecell(this.parseInline(Ue.header[re].tokens),{header:!0,align:Ue.align[re]});for(je+=this.renderer.tablerow($e),He="",ye=Ue.rows.length,re=0;re<ye;re++){for(We=Ue.rows[re],$e="",Ae=We.length,de=0;de<Ae;de++)$e+=this.renderer.tablecell(this.parseInline(We[de].tokens),{header:!1,align:Ue.align[de]});He+=this.renderer.tablerow($e)}$+=this.renderer.table(je,He);continue}case"blockquote":{He=this.parse(Ue.tokens),$+=this.renderer.blockquote(He);continue}case"list":{for(Je=Ue.ordered,rt=Ue.start,Re=Ue.loose,ye=Ue.items.length,He="",re=0;re<ye;re++)ne=Ue.items[re],oe=ne.checked,Y=ne.task,tt="",ne.task&&(ge=this.renderer.checkbox(oe),Re?ne.tokens.length>0&&ne.tokens[0].type==="paragraph"?(ne.tokens[0].text=ge+" "+ne.tokens[0].text,ne.tokens[0].tokens&&ne.tokens[0].tokens.length>0&&ne.tokens[0].tokens[0].type==="text"&&(ne.tokens[0].tokens[0].text=ge+" "+ne.tokens[0].tokens[0].text)):ne.tokens.unshift({type:"text",text:ge}):tt+=ge),tt+=this.parse(ne.tokens,Re),He+=this.renderer.listitem(tt,Y,oe);$+=this.renderer.list(He,Je,rt);continue}case"html":{$+=this.renderer.html(Ue.text);continue}case"paragraph":{$+=this.renderer.paragraph(this.parseInline(Ue.tokens));continue}case"text":{for(He=Ue.tokens?this.parseInline(Ue.tokens):Ue.text;Q+1<Oe&&W[Q+1].type==="text";)Ue=W[++Q],He+=`
`+(Ue.tokens?this.parseInline(Ue.tokens):Ue.text);$+=O?this.renderer.paragraph(He):He;continue}default:{var ze='Token with "'+Ue.type+'" type was not found.';if(this.options.silent){console.error(ze);return}else throw new Error(ze)}}}return $},be.parseInline=function(W,O){O=O||this.renderer;var $="",Q,re,de,ye=W.length;for(Q=0;Q<ye;Q++){if(re=W[Q],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[re.type]&&(de=this.options.extensions.renderers[re.type].call({parser:this},re),de!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(re.type))){$+=de||"";continue}switch(re.type){case"escape":{$+=O.text(re.text);break}case"html":{$+=O.html(re.text);break}case"link":{$+=O.link(re.href,re.title,this.parseInline(re.tokens,O));break}case"image":{$+=O.image(re.href,re.title,re.text);break}case"strong":{$+=O.strong(this.parseInline(re.tokens,O));break}case"em":{$+=O.em(this.parseInline(re.tokens,O));break}case"codespan":{$+=O.codespan(re.text);break}case"br":{$+=O.br();break}case"del":{$+=O.del(this.parseInline(re.tokens,O));break}case"text":{$+=O.text(re.text);break}default:{var Ae='Token with "'+re.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return $},Ee}();function se(Ee,be,H){if(typeof Ee=="undefined"||Ee===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ee!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ee)+", string expected");if(typeof be=="function"&&(H=be,be=null),be=l({},se.defaults,be||{}),A(be),H){var W=be.highlight,O;try{O=x.lex(Ee,be)}catch(de){return H(de)}var $=function(ye){var Ae;if(!ye)try{be.walkTokens&&se.walkTokens(O,be.walkTokens),Ae=Z.parse(O,be)}catch(We){ye=We}return be.highlight=W,ye?H(ye):H(null,Ae)};if(!W||W.length<3||(delete be.highlight,!O.length))return $();var Q=0;se.walkTokens(O,function(de){de.type==="code"&&(Q++,setTimeout(function(){W(de.text,de.lang,function(ye,Ae){if(ye)return $(ye);Ae!=null&&Ae!==de.text&&(de.text=Ae,de.escaped=!0),Q--,Q===0&&$()})},0))}),Q===0&&$();return}try{var re=x.lex(Ee,be);return be.walkTokens&&se.walkTokens(re,be.walkTokens),Z.parse(re,be)}catch(de){if(de.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+v(de.message+"",!0)+"</pre>";throw de}}se.options=se.setOptions=function(Ee){return l(se.defaults,Ee),k(se.defaults),se},se.getDefaults=T,se.defaults=ee.defaults,se.use=function(){for(var Ee=arguments.length,be=new Array(Ee),H=0;H<Ee;H++)be[H]=arguments[H];var W=l.apply(void 0,[{}].concat(be)),O=se.defaults.extensions||{renderers:{},childTokens:{}},$;be.forEach(function(Q){if(Q.extensions&&($=!0,Q.extensions.forEach(function(de){if(!de.name)throw new Error("extension name required");if(de.renderer){var ye=O.renderers?O.renderers[de.name]:null;ye?O.renderers[de.name]=function(){for(var Ae=arguments.length,We=new Array(Ae),$e=0;$e<Ae;$e++)We[$e]=arguments[$e];var je=de.renderer.apply(this,We);return je===!1&&(je=ye.apply(this,We)),je}:O.renderers[de.name]=de.renderer}if(de.tokenizer){if(!de.level||de.level!=="block"&&de.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");O[de.level]?O[de.level].unshift(de.tokenizer):O[de.level]=[de.tokenizer],de.start&&(de.level==="block"?O.startBlock?O.startBlock.push(de.start):O.startBlock=[de.start]:de.level==="inline"&&(O.startInline?O.startInline.push(de.start):O.startInline=[de.start]))}de.childTokens&&(O.childTokens[de.name]=de.childTokens)})),Q.renderer&&function(){var de=se.defaults.renderer||new z,ye=function($e){var je=de[$e];de[$e]=function(){for(var He=arguments.length,Ue=new Array(He),Je=0;Je<He;Je++)Ue[Je]=arguments[Je];var rt=Q.renderer[$e].apply(de,Ue);return rt===!1&&(rt=je.apply(de,Ue)),rt}};for(var Ae in Q.renderer)ye(Ae);W.renderer=de}(),Q.tokenizer&&function(){var de=se.defaults.tokenizer||new M,ye=function($e){var je=de[$e];de[$e]=function(){for(var He=arguments.length,Ue=new Array(He),Je=0;Je<He;Je++)Ue[Je]=arguments[Je];var rt=Q.tokenizer[$e].apply(de,Ue);return rt===!1&&(rt=je.apply(de,Ue)),rt}};for(var Ae in Q.tokenizer)ye(Ae);W.tokenizer=de}(),Q.walkTokens){var re=se.defaults.walkTokens;W.walkTokens=function(de){Q.walkTokens.call(this,de),re&&re.call(this,de)}}$&&(W.extensions=O),se.setOptions(W)})},se.walkTokens=function(Ee,be){for(var H=function(){var Q=O.value;switch(be.call(se,Q),Q.type){case"table":{for(var re=C(Q.header),de;!(de=re()).done;){var ye=de.value;se.walkTokens(ye.tokens,be)}for(var Ae=C(Q.rows),We;!(We=Ae()).done;)for(var $e=We.value,je=C($e),He;!(He=je()).done;){var Ue=He.value;se.walkTokens(Ue.tokens,be)}break}case"list":{se.walkTokens(Q.items,be);break}default:se.defaults.extensions&&se.defaults.extensions.childTokens&&se.defaults.extensions.childTokens[Q.type]?se.defaults.extensions.childTokens[Q.type].forEach(function(Je){se.walkTokens(Q[Je],be)}):Q.tokens&&se.walkTokens(Q.tokens,be)}},W=C(Ee),O;!(O=W()).done;)H()},se.parseInline=function(Ee,be){if(typeof Ee=="undefined"||Ee===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ee!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ee)+", string expected");be=l({},se.defaults,be||{}),A(be);try{var H=x.lexInline(Ee,be);return be.walkTokens&&se.walkTokens(H,be.walkTokens),Z.parseInline(H,be)}catch(W){if(W.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+v(W.message+"",!0)+"</pre>";throw W}},se.Parser=Z,se.parser=Z.parse,se.Renderer=z,se.TextRenderer=G,se.Lexer=x,se.lexer=x.lex,se.Tokenizer=M,se.Slugger=q,se.parse=se;var ue=se.options,te=se.setOptions,J=se.use,ae=se.walkTokens,he=se.parseInline,we=se,Ie=Z.parse,Ne=x.lex;ee.Lexer=x,ee.Parser=Z,ee.Renderer=z,ee.Slugger=q,ee.TextRenderer=G,ee.Tokenizer=M,ee.getDefaults=T,ee.lexer=Ne,ee.marked=se,ee.options=ue,ee.parse=we,ee.parseInline=he,ee.parser=Ie,ee.setOptions=te,ee.use=J,ee.walkTokens=ae,Object.defineProperty(ee,"__esModule",{value:!0})}),define(pe[95],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function d(k,D,P){return Math.min(Math.max(k,D),P)}e.clamp=d;function t(k,D){return(D+k%D)%D}e.rot=t;class I{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=I;class C{constructor(){this._n=1,this._val=0}update(D){return this._val=this._val+(D-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=C;class T{constructor(D){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(D),this._values.fill(0,0,D)}update(D){const P=this._values[this._index];return this._values[this._index]=D,this._index=(this._index+1)%this._values.length,this._sum-=P,this._sum+=D,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=T}),function(){function ee(I){const C=[];typeof I=="number"&&C.push("code/timeOrigin",I);function T(D){C.push(D,Date.now())}function k(){const D=[];for(let P=0;P<C.length;P+=2)D.push({name:C[P],startTime:C[P+1]});return D}return{mark:T,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const T of performance.getEntriesByType("mark"))C.push({name:T.name,startTime:Math.round(I+T.startTime)});return C}};if(typeof process=="object"){const I=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function d(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return d(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=d(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=d(t))}(),define(pe[11],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const d="en";let t=!1,I=!1,C=!1,T=!1,k=!1,D=!1,P=!1,F=!1,y,c=d,E,v;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let w;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?w=e.globals.vscode.process:typeof process!="undefined"&&(w=process);const _=typeof w?.versions?.electron=="string",R=_&&w?.type==="renderer";if(e.isElectronSandboxed=R&&w?.sandboxed,typeof navigator=="object"&&!R)v=navigator.userAgent,t=v.indexOf("Windows")>=0,I=v.indexOf("Macintosh")>=0,F=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=v.indexOf("Linux")>=0,D=!0,y=navigator.language,c=y;else if(typeof w=="object"){t=w.platform==="win32",I=w.platform==="darwin",C=w.platform==="linux",T=C&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,P=_,y=d,c=d;const n=w.env.VSCODE_NLS_CONFIG;if(n)try{const o=JSON.parse(n),l=o.availableLanguages["*"];y=o.locale,c=l||d,E=o._translationsConfigFile}catch{}k=!0}else console.error("Unable to resolve platform.");var p;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(p=e.Platform||(e.Platform={}));function h(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=h;let s=0;I?s=1:t?s=3:C&&(s=2),e.isWindows=t,e.isMacintosh=I,e.isLinux=C,e.isLinuxSnap=T,e.isNative=k,e.isElectron=P,e.isWeb=D,e.isIOS=F,e.platform=s,e.userAgent=v,e.language=c;var u;(function(n){function o(){return e.language}n.value=o;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=l;function f(){return e.language==="en"}n.isDefault=f})(u=e.Language||(e.Language={})),e.locale=y,e.translationsConfigFile=E,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let n=[];e.globals.addEventListener("message",l=>{if(l.data&&l.data.vscodeScheduleAsyncWork)for(let f=0,m=n.length;f<m;f++){const b=n[f];if(b.id===l.data.vscodeScheduleAsyncWork){n.splice(f,1),b.callback();return}}});let o=0;return l=>{const f=++o;n.push({id:f,callback:l}),e.globals.postMessage({vscodeScheduleAsyncWork:f},"*")}}return n=>setTimeout(n)})();var r;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=I||F?2:t?1:3;let S=!0,a=!1;function i(){if(!a){a=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,S=new Uint16Array(n.buffer)[0]===(2<<8)+1}return S}e.isLittleEndian=i,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(pe[37],ve([0,1,11]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof d.globals.vscode!="undefined"&&typeof d.globals.vscode.process!="undefined"){const I=d.globals.vscode.process;t={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return d.isWindows?"win32":d.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(pe[9],ve([0,1,37]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,I=97,C=90,T=122,k=46,D=47,P=92,F=58,y=63;class c extends Error{constructor(s,u,r){let S;typeof u=="string"&&u.indexOf("not ")===0?(S="must not be",u=u.replace(/^not /,"")):S="must be";const a=s.indexOf(".")!==-1?"property":"argument";let i=`The "${s}" ${a} ${S} of type ${u}`;i+=`. Received type ${typeof r}`;super(i);this.code="ERR_INVALID_ARG_TYPE"}}function E(h,s){if(typeof h!="string")throw new c(s,"string",h)}function v(h){return h===D||h===P}function w(h){return h===D}function _(h){return h>=t&&h<=C||h>=I&&h<=T}function R(h,s,u,r){let S="",a=0,i=-1,n=0,o=0;for(let l=0;l<=h.length;++l){if(l<h.length)o=h.charCodeAt(l);else{if(r(o))break;o=D}if(r(o)){if(!(i===l-1||n===1))if(n===2){if(S.length<2||a!==2||S.charCodeAt(S.length-1)!==k||S.charCodeAt(S.length-2)!==k){if(S.length>2){const f=S.lastIndexOf(u);f===-1?(S="",a=0):(S=S.slice(0,f),a=S.length-1-S.lastIndexOf(u)),i=l,n=0;continue}else if(S.length!==0){S="",a=0,i=l,n=0;continue}}s&&(S+=S.length>0?`${u}..`:"..",a=2)}else S.length>0?S+=`${u}${h.slice(i+1,l)}`:S=h.slice(i+1,l),a=l-i-1;i=l,n=0}else o===k&&n!==-1?++n:n=-1}return S}function p(h,s){if(s===null||typeof s!="object")throw new c("pathObject","Object",s);const u=s.dir||s.root,r=s.base||`${s.name||""}${s.ext||""}`;return u?u===s.root?`${u}${r}`:`${u}${h}${r}`:r}e.win32={resolve(...h){let s="",u="",r=!1;for(let S=h.length-1;S>=-1;S--){let a;if(S>=0){if(a=h[S],E(a,"path"),a.length===0)continue}else s.length===0?a=d.cwd():(a=d.env[`=${s}`]||d.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==s.toLowerCase()&&a.charCodeAt(2)===P)&&(a=`${s}\\`));const i=a.length;let n=0,o="",l=!1;const f=a.charCodeAt(0);if(i===1)v(f)&&(n=1,l=!0);else if(v(f))if(l=!0,v(a.charCodeAt(1))){let m=2,b=m;for(;m<i&&!v(a.charCodeAt(m));)m++;if(m<i&&m!==b){const A=a.slice(b,m);for(b=m;m<i&&v(a.charCodeAt(m));)m++;if(m<i&&m!==b){for(b=m;m<i&&!v(a.charCodeAt(m));)m++;(m===i||m!==b)&&(o=`\\\\${A}\\${a.slice(b,m)}`,n=m)}}}else n=1;else _(f)&&a.charCodeAt(1)===F&&(o=a.slice(0,2),n=2,i>2&&v(a.charCodeAt(2))&&(l=!0,n=3));if(o.length>0)if(s.length>0){if(o.toLowerCase()!==s.toLowerCase())continue}else s=o;if(r){if(s.length>0)break}else if(u=`${a.slice(n)}\\${u}`,r=l,l&&s.length>0)break}return u=R(u,!r,"\\",v),r?`${s}\\${u}`:`${s}${u}`||"."},normalize(h){E(h,"path");const s=h.length;if(s===0)return".";let u=0,r,S=!1;const a=h.charCodeAt(0);if(s===1)return w(a)?"\\":h;if(v(a))if(S=!0,v(h.charCodeAt(1))){let n=2,o=n;for(;n<s&&!v(h.charCodeAt(n));)n++;if(n<s&&n!==o){const l=h.slice(o,n);for(o=n;n<s&&v(h.charCodeAt(n));)n++;if(n<s&&n!==o){for(o=n;n<s&&!v(h.charCodeAt(n));)n++;if(n===s)return`\\\\${l}\\${h.slice(o)}\\`;n!==o&&(r=`\\\\${l}\\${h.slice(o,n)}`,u=n)}}}else u=1;else _(a)&&h.charCodeAt(1)===F&&(r=h.slice(0,2),u=2,s>2&&v(h.charCodeAt(2))&&(S=!0,u=3));let i=u<s?R(h.slice(u),!S,"\\",v):"";return i.length===0&&!S&&(i="."),i.length>0&&v(h.charCodeAt(s-1))&&(i+="\\"),r===void 0?S?`\\${i}`:i:S?`${r}\\${i}`:`${r}${i}`},isAbsolute(h){E(h,"path");const s=h.length;if(s===0)return!1;const u=h.charCodeAt(0);return v(u)||s>2&&_(u)&&h.charCodeAt(1)===F&&v(h.charCodeAt(2))},join(...h){if(h.length===0)return".";let s,u;for(let a=0;a<h.length;++a){const i=h[a];E(i,"path"),i.length>0&&(s===void 0?s=u=i:s+=`\\${i}`)}if(s===void 0)return".";let r=!0,S=0;if(typeof u=="string"&&v(u.charCodeAt(0))){++S;const a=u.length;a>1&&v(u.charCodeAt(1))&&(++S,a>2&&(v(u.charCodeAt(2))?++S:r=!1))}if(r){for(;S<s.length&&v(s.charCodeAt(S));)S++;S>=2&&(s=`\\${s.slice(S)}`)}return e.win32.normalize(s)},relative(h,s){if(E(h,"from"),E(s,"to"),h===s)return"";const u=e.win32.resolve(h),r=e.win32.resolve(s);if(u===r||(h=u.toLowerCase(),s=r.toLowerCase(),h===s))return"";let S=0;for(;S<h.length&&h.charCodeAt(S)===P;)S++;let a=h.length;for(;a-1>S&&h.charCodeAt(a-1)===P;)a--;const i=a-S;let n=0;for(;n<s.length&&s.charCodeAt(n)===P;)n++;let o=s.length;for(;o-1>n&&s.charCodeAt(o-1)===P;)o--;const l=o-n,f=i<l?i:l;let m=-1,b=0;for(;b<f;b++){const L=h.charCodeAt(S+b);if(L!==s.charCodeAt(n+b))break;L===P&&(m=b)}if(b!==f){if(m===-1)return r}else{if(l>f){if(s.charCodeAt(n+b)===P)return r.slice(n+b+1);if(b===2)return r.slice(n+b)}i>f&&(h.charCodeAt(S+b)===P?m=b:b===2&&(m=3)),m===-1&&(m=0)}let A="";for(b=S+m+1;b<=a;++b)(b===a||h.charCodeAt(b)===P)&&(A+=A.length===0?"..":"\\..");return n+=m,A.length>0?`${A}${r.slice(n,o)}`:(r.charCodeAt(n)===P&&++n,r.slice(n,o))},toNamespacedPath(h){if(typeof h!="string")return h;if(h.length===0)return"";const s=e.win32.resolve(h);if(s.length<=2)return h;if(s.charCodeAt(0)===P){if(s.charCodeAt(1)===P){const u=s.charCodeAt(2);if(u!==y&&u!==k)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(_(s.charCodeAt(0))&&s.charCodeAt(1)===F&&s.charCodeAt(2)===P)return`\\\\?\\${s}`;return h},dirname(h){E(h,"path");const s=h.length;if(s===0)return".";let u=-1,r=0;const S=h.charCodeAt(0);if(s===1)return v(S)?h:".";if(v(S)){if(u=r=1,v(h.charCodeAt(1))){let n=2,o=n;for(;n<s&&!v(h.charCodeAt(n));)n++;if(n<s&&n!==o){for(o=n;n<s&&v(h.charCodeAt(n));)n++;if(n<s&&n!==o){for(o=n;n<s&&!v(h.charCodeAt(n));)n++;if(n===s)return h;n!==o&&(u=r=n+1)}}}}else _(S)&&h.charCodeAt(1)===F&&(u=s>2&&v(h.charCodeAt(2))?3:2,r=u);let a=-1,i=!0;for(let n=s-1;n>=r;--n)if(v(h.charCodeAt(n))){if(!i){a=n;break}}else i=!1;if(a===-1){if(u===-1)return".";a=u}return h.slice(0,a)},basename(h,s){s!==void 0&&E(s,"ext"),E(h,"path");let u=0,r=-1,S=!0,a;if(h.length>=2&&_(h.charCodeAt(0))&&h.charCodeAt(1)===F&&(u=2),s!==void 0&&s.length>0&&s.length<=h.length){if(s===h)return"";let i=s.length-1,n=-1;for(a=h.length-1;a>=u;--a){const o=h.charCodeAt(a);if(v(o)){if(!S){u=a+1;break}}else n===-1&&(S=!1,n=a+1),i>=0&&(o===s.charCodeAt(i)?--i==-1&&(r=a):(i=-1,r=n))}return u===r?r=n:r===-1&&(r=h.length),h.slice(u,r)}for(a=h.length-1;a>=u;--a)if(v(h.charCodeAt(a))){if(!S){u=a+1;break}}else r===-1&&(S=!1,r=a+1);return r===-1?"":h.slice(u,r)},extname(h){E(h,"path");let s=0,u=-1,r=0,S=-1,a=!0,i=0;h.length>=2&&h.charCodeAt(1)===F&&_(h.charCodeAt(0))&&(s=r=2);for(let n=h.length-1;n>=s;--n){const o=h.charCodeAt(n);if(v(o)){if(!a){r=n+1;break}continue}S===-1&&(a=!1,S=n+1),o===k?u===-1?u=n:i!==1&&(i=1):u!==-1&&(i=-1)}return u===-1||S===-1||i===0||i===1&&u===S-1&&u===r+1?"":h.slice(u,S)},format:p.bind(null,"\\"),parse(h){E(h,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return s;const u=h.length;let r=0,S=h.charCodeAt(0);if(u===1)return v(S)?(s.root=s.dir=h,s):(s.base=s.name=h,s);if(v(S)){if(r=1,v(h.charCodeAt(1))){let m=2,b=m;for(;m<u&&!v(h.charCodeAt(m));)m++;if(m<u&&m!==b){for(b=m;m<u&&v(h.charCodeAt(m));)m++;if(m<u&&m!==b){for(b=m;m<u&&!v(h.charCodeAt(m));)m++;m===u?r=m:m!==b&&(r=m+1)}}}}else if(_(S)&&h.charCodeAt(1)===F){if(u<=2)return s.root=s.dir=h,s;if(r=2,v(h.charCodeAt(2))){if(u===3)return s.root=s.dir=h,s;r=3}}r>0&&(s.root=h.slice(0,r));let a=-1,i=r,n=-1,o=!0,l=h.length-1,f=0;for(;l>=r;--l){if(S=h.charCodeAt(l),v(S)){if(!o){i=l+1;break}continue}n===-1&&(o=!1,n=l+1),S===k?a===-1?a=l:f!==1&&(f=1):a!==-1&&(f=-1)}return n!==-1&&(a===-1||f===0||f===1&&a===n-1&&a===i+1?s.base=s.name=h.slice(i,n):(s.name=h.slice(i,a),s.base=h.slice(i,n),s.ext=h.slice(a,n))),i>0&&i!==r?s.dir=h.slice(0,i-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...h){let s="",u=!1;for(let r=h.length-1;r>=-1&&!u;r--){const S=r>=0?h[r]:d.cwd();E(S,"path"),S.length!==0&&(s=`${S}/${s}`,u=S.charCodeAt(0)===D)}return s=R(s,!u,"/",w),u?`/${s}`:s.length>0?s:"."},normalize(h){if(E(h,"path"),h.length===0)return".";const s=h.charCodeAt(0)===D,u=h.charCodeAt(h.length-1)===D;return h=R(h,!s,"/",w),h.length===0?s?"/":u?"./":".":(u&&(h+="/"),s?`/${h}`:h)},isAbsolute(h){return E(h,"path"),h.length>0&&h.charCodeAt(0)===D},join(...h){if(h.length===0)return".";let s;for(let u=0;u<h.length;++u){const r=h[u];E(r,"path"),r.length>0&&(s===void 0?s=r:s+=`/${r}`)}return s===void 0?".":e.posix.normalize(s)},relative(h,s){if(E(h,"from"),E(s,"to"),h===s||(h=e.posix.resolve(h),s=e.posix.resolve(s),h===s))return"";const u=1,r=h.length,S=r-u,a=1,i=s.length-a,n=S<i?S:i;let o=-1,l=0;for(;l<n;l++){const m=h.charCodeAt(u+l);if(m!==s.charCodeAt(a+l))break;m===D&&(o=l)}if(l===n)if(i>n){if(s.charCodeAt(a+l)===D)return s.slice(a+l+1);if(l===0)return s.slice(a+l)}else S>n&&(h.charCodeAt(u+l)===D?o=l:l===0&&(o=0));let f="";for(l=u+o+1;l<=r;++l)(l===r||h.charCodeAt(l)===D)&&(f+=f.length===0?"..":"/..");return`${f}${s.slice(a+o)}`},toNamespacedPath(h){return h},dirname(h){if(E(h,"path"),h.length===0)return".";const s=h.charCodeAt(0)===D;let u=-1,r=!0;for(let S=h.length-1;S>=1;--S)if(h.charCodeAt(S)===D){if(!r){u=S;break}}else r=!1;return u===-1?s?"/":".":s&&u===1?"//":h.slice(0,u)},basename(h,s){s!==void 0&&E(s,"ext"),E(h,"path");let u=0,r=-1,S=!0,a;if(s!==void 0&&s.length>0&&s.length<=h.length){if(s===h)return"";let i=s.length-1,n=-1;for(a=h.length-1;a>=0;--a){const o=h.charCodeAt(a);if(o===D){if(!S){u=a+1;break}}else n===-1&&(S=!1,n=a+1),i>=0&&(o===s.charCodeAt(i)?--i==-1&&(r=a):(i=-1,r=n))}return u===r?r=n:r===-1&&(r=h.length),h.slice(u,r)}for(a=h.length-1;a>=0;--a)if(h.charCodeAt(a)===D){if(!S){u=a+1;break}}else r===-1&&(S=!1,r=a+1);return r===-1?"":h.slice(u,r)},extname(h){E(h,"path");let s=-1,u=0,r=-1,S=!0,a=0;for(let i=h.length-1;i>=0;--i){const n=h.charCodeAt(i);if(n===D){if(!S){u=i+1;break}continue}r===-1&&(S=!1,r=i+1),n===k?s===-1?s=i:a!==1&&(a=1):s!==-1&&(a=-1)}return s===-1||r===-1||a===0||a===1&&s===r-1&&s===u+1?"":h.slice(s,r)},format:p.bind(null,"/"),parse(h){E(h,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return s;const u=h.charCodeAt(0)===D;let r;u?(s.root="/",r=1):r=0;let S=-1,a=0,i=-1,n=!0,o=h.length-1,l=0;for(;o>=r;--o){const f=h.charCodeAt(o);if(f===D){if(!n){a=o+1;break}continue}i===-1&&(n=!1,i=o+1),f===k?S===-1?S=o:l!==1&&(l=1):S!==-1&&(l=-1)}if(i!==-1){const f=a===0&&u?1:a;S===-1||l===0||l===1&&S===i-1&&S===a+1?s.base=s.name=h.slice(f,i):(s.name=h.slice(f,S),s.base=h.slice(f,i),s.ext=h.slice(S,i))}return a>0?s.dir=h.slice(0,a-1):u&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=d.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=d.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=d.platform==="win32"?e.win32.join:e.posix.join,e.resolve=d.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=d.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=d.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=d.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=d.platform==="win32"?e.win32.extname:e.posix.extname,e.format=d.platform==="win32"?e.win32.format:e.posix.format,e.parse=d.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=d.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=d.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=d.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(pe[96],ve([0,1,9]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var t;(function(y){y.text="text/plain",y.binary="application/octet-stream",y.unknown="application/unknown",y.markdown="text/markdown",y.latex="text/latex"})(t=e.Mimes||(e.Mimes={}));const I={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(y){const c=(0,d.extname)(y),E=I[c.toLowerCase()];return E!==void 0?E:k(y)}e.getMediaOrTextMime=T;function k(y){const c=(0,d.extname)(y);return C[c.toLowerCase()]}e.getMediaMime=k;function D(y){for(const c in C)if(C[c]===y)return c}e.getExtensionForMimeType=D;const P=/^(.+)\/(.+?)(;.+)?$/;function F(y,c){const E=P.exec(y);return E?`${E[1].toLowerCase()}/${E[2].toLowerCase()}${E[3]??""}`:c?void 0:y}e.normalizeMimeType=F}),define(pe[97],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var d;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(d=e.Source||(e.Source={}));var t;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(t=e.TerminateResponseCode||(e.TerminateResponseCode={}));function I(C,...T){const k=T.reduce((F,y)=>(F[y]=!0,F),{}),D=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(F=>!k[F]).forEach(F=>{for(let y=0;y<D.length;y++)if(F.search(D[y])!==-1){delete C[F];break}})}e.sanitizeProcessEnvironment=I}),define(pe[46],ve([0,1,11]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=d.globals.performance&&typeof d.globals.performance.now=="function";class I{constructor(T){this._highResolution=t&&T,this._startTime=this._now(),this._stopTime=-1}static create(T=!0){return new I(T)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?d.globals.performance.now():Date.now()}}e.StopWatch=I}),define(pe[3],ve([0,1,16,75,6,94,46]),function(ee,e,d,t,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var k;(function(s){s.None=()=>I.Disposable.None;function u(x){return(z,G=null,q)=>{let Z=!1,se;return se=x(ue=>{if(!Z)return se?se.dispose():Z=!0,z.call(G,ue)},null,q),Z&&se.dispose(),se}}s.once=u;function r(x,z){return l((G,q=null,Z)=>x(se=>G.call(q,z(se)),null,Z))}s.map=r;function S(x,z){return l((G,q=null,Z)=>x(se=>{z(se),G.call(q,se)},null,Z))}s.forEach=S;function a(x,z){return l((G,q=null,Z)=>x(se=>z(se)&&G.call(q,se),null,Z))}s.filter=a;function i(x){return x}s.signal=i;function n(...x){return(z,G=null,q)=>(0,I.combinedDisposable)(...x.map(Z=>Z(se=>z.call(G,se),null,q)))}s.any=n;function o(x,z,G){let q=G;return r(x,Z=>(q=z(q,Z),q))}s.reduce=o;function l(x){let z;const G=new c({onFirstListenerAdd(){z=x(G.fire,G)},onLastListenerRemove(){z.dispose()}});return G.event}function f(x,z,G,q=100,Z=!1){let se,ue,te=0;return x(J=>{te++,se=G(se,J),Z&&!ue&&(z(se),se=void 0),clearTimeout(ue),ue=setTimeout(()=>{const ae=se;se=void 0,ue=void 0,(!Z||te>1)&&z(ae),te=0},q)})}s.debouncedListener=f;function m(x,z,G=100,q=!1,Z){let se,ue,te,J=0;const ae=new c({leakWarningThreshold:Z,onFirstListenerAdd(){se=x(he=>{J++,ue=z(ue,he),q&&!te&&(ae.fire(ue),ue=void 0),clearTimeout(te),te=setTimeout(()=>{const we=ue;ue=void 0,te=void 0,(!q||J>1)&&ae.fire(we),J=0},G)})},onLastListenerRemove(){se.dispose()}});return ae.event}s.debounce=m;function b(x,z=(G,q)=>G===q){let G=!0,q;return a(x,Z=>{const se=G||!z(Z,q);return G=!1,q=Z,se})}s.latch=b;function A(x,z){return[s.filter(x,z),s.filter(x,G=>!z(G))]}s.split=A;function L(x,z=!1,G=[]){let q=G.slice(),Z=x(te=>{q?q.push(te):ue.fire(te)});const se=()=>{q&&q.forEach(te=>ue.fire(te)),q=null},ue=new c({onFirstListenerAdd(){Z||(Z=x(te=>ue.fire(te)))},onFirstListenerDidAdd(){q&&(z?setTimeout(se):se())},onLastListenerRemove(){Z&&Z.dispose(),Z=null}});return ue.event}s.buffer=L;class N{constructor(z){this.event=z}map(z){return new N(r(this.event,z))}forEach(z){return new N(S(this.event,z))}filter(z){return new N(a(this.event,z))}reduce(z,G){return new N(o(this.event,z,G))}latch(){return new N(b(this.event))}debounce(z,G=100,q=!1,Z){return new N(m(this.event,z,G,q,Z))}on(z,G,q){return this.event(z,G,q)}once(z,G,q){return u(this.event)(z,G,q)}}function g(x){return new N(x)}s.chain=g;function M(x,z,G=q=>q){const q=(...te)=>ue.fire(G(...te)),Z=()=>x.on(z,q),se=()=>x.removeListener(z,q),ue=new c({onFirstListenerAdd:Z,onLastListenerRemove:se});return ue.event}s.fromNodeEventEmitter=M;function U(x,z,G=q=>q){const q=(...te)=>ue.fire(G(...te)),Z=()=>x.addEventListener(z,q),se=()=>x.removeEventListener(z,q),ue=new c({onFirstListenerAdd:Z,onLastListenerRemove:se});return ue.event}s.fromDOMEventEmitter=U;function j(x){return new Promise(z=>u(x)(z))}s.toPromise=j;function K(x,z){return z(void 0),x(G=>z(G))}s.runAndSubscribe=K;function B(x,z){let G=null;function q(se){G?.dispose(),G=new I.DisposableStore,z(se,G)}q(void 0);const Z=x(se=>q(se));return(0,I.toDisposable)(()=>{Z.dispose(),G?.dispose()})}s.runAndSubscribeWithStore=B})(k=e.Event||(e.Event={}));class D{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${D._idPool++}`}start(u){this._stopWatch=new T.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let P=-1;function F(s){const u=P;return P=s,{dispose(){P=u}}}e.setGlobalLeakWarningThreshold=F;class y{constructor(u,r=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=r,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u){let r=P;if(typeof this.customThreshold=="number"&&(r=this.customThreshold),r<=0||u<r)return;this._stacks||(this._stacks=new Map);const S=new Error().stack.split(`
`).slice(3).join(`
`),a=this._stacks.get(S)||0;if(this._stacks.set(S,a+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=r*.5;let i,n=0;for(const[o,l]of this._stacks)(!i||n<l)&&(i=o,n=l);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${n}):`),console.warn(i)}return()=>{const i=this._stacks.get(S)||0;this._stacks.set(S,i-1)}}}class c{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=P>0?new y(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new D(this._options._profName):void 0}get event(){return this._event||(this._event=(u,r,S)=>{this._listeners||(this._listeners=new C.LinkedList);const a=this._listeners.isEmpty();a&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(r?[u,r]:u);a&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,r);const n=this._leakageMon?.check(this._listeners.size),o=(0,I.toDisposable)(()=>{n&&n(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return S instanceof I.DisposableStore?S.add(o):Array.isArray(S)&&S.push(o),o}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,u]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,S]=this._deliveryQueue.shift();try{typeof r=="function"?r.call(void 0,S):r[0].call(r[1],S)}catch(a){(0,d.onUnexpectedError)(a)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=c;class E extends c{async fireAsync(u,r,S){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const a of this._listeners)this._asyncDeliveryQueue.push([a,u]);for(;this._asyncDeliveryQueue.size>0&&!r.isCancellationRequested;){const[a,i]=this._asyncDeliveryQueue.shift(),n=[],o={...i,token:r,waitUntil:l=>{if(Object.isFrozen(n))throw new Error("waitUntil can NOT be called asynchronous");S&&(l=S(l,typeof a=="function"?a:a[0])),n.push(l)}};try{typeof a=="function"?a.call(void 0,o):a[0].call(a[1],o)}catch(l){(0,d.onUnexpectedError)(l);continue}Object.freeze(n),await Promise.allSettled(n).then(l=>{for(const f of l)f.status==="rejected"&&(0,d.onUnexpectedError)(f.reason)})}}}}e.AsyncEmitter=E;class v extends c{constructor(u){super(u);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}e.PauseableEmitter=v;class w extends v{constructor(u){super(u);this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}e.DebounceEmitter=w;class _ extends c{constructor(u){super(u);this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(r=>super.fire(r)),this._queuedEvents=[]})}}e.MicrotaskEmitter=_;class R{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new c({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const r={event:u,listener:null};this.events.push(r),this.hasListeners&&this.hook(r);const S=()=>{this.hasListeners&&this.unhook(r);const a=this.events.indexOf(r);this.events.splice(a,1)};return(0,I.toDisposable)((0,t.once)(S))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(r=>this.emitter.fire(r))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=R;class p{constructor(){this.buffers=[]}wrapEvent(u){return(r,S,a)=>u(i=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>r.call(S,i)):r.call(S,i)},void 0,a)}bufferEvents(u){const r=[];this.buffers.push(r);const S=u();return this.buffers.pop(),r.forEach(a=>a()),S}}e.EventBufferer=p;class h{constructor(){this.listening=!1,this.inputEvent=k.None,this.inputEventListener=I.Disposable.None,this.emitter=new c({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=h}),define(pe[21],ve([0,1,3]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(k,D){const P=setTimeout(k.bind(D),0);return{dispose(){clearTimeout(P)}}});var I;(function(k){function D(P){return P===k.None||P===k.Cancelled||P instanceof C?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}k.isCancellationToken=D,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:d.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(I=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new d.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(D){this._token=void 0,this._parentListener=void 0,this._parentListener=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=I.Cancelled}dispose(D=!1){D&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=I.None}}e.CancellationTokenSource=T}),define(pe[143],ve([0,1,21]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class t{constructor(T){this.task=T,this.result=null}get(){if(this.result)return this.result;const T=new d.CancellationTokenSource,k=this.task(T.token);return this.result={promise:k,dispose:()=>{this.result=null,T.cancel(),T.dispose()}},this.result}}e.Cache=t;class I{constructor(T){this.computeFn=T,this.lastCache=void 0,this.lastArgKey=void 0}get(T){const k=JSON.stringify(T);return this.lastArgKey!==k&&(this.lastArgKey=k,this.lastCache=this.computeFn(T)),this.lastCache}}e.LRUCachedComputed=I}),define(pe[98],ve([0,1,16,6]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function I(h){const s=h;return s?[s.on,s.pause,s.resume,s.destroy].every(u=>typeof u=="function"):!1}e.isReadableStream=I;function C(h){const s=h;return s?I(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}e.isReadableBufferedStream=C;function T(h,s){return new k(h,s)}e.newWriteableStream=T;class k{constructor(s,u){this.reducer=s,this.options=u,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(u=>this.pendingWritePromises.push(u))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(u=>u(s))}emitError(s){this.listeners.error.length===0?(0,d.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(u=>u(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,u){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(u),this.resume();break;case"end":this.listeners.end.push(u),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(u),this.state.flowing&&this.flowErrors();break}}removeListener(s,u){if(this.state.destroyed)return;let r;switch(s){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const S=r.indexOf(u);S>=0&&r.splice(S,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const u=[...this.pendingWritePromises];this.pendingWritePromises.length=0,u.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(h,s){const u=[];let r;for(;(r=h.read())!==null;)u.push(r);return s(u)}e.consumeReadable=D;function P(h,s,u){const r=[];let S;for(;(S=h.read())!==null&&r.length<u;)r.push(S);return S===null&&r.length>0?s(r):{read:()=>{if(r.length>0)return r.shift();if(typeof S!="undefined"){const a=S;return S=void 0,a}return h.read()}}}e.peekReadable=P;function F(h,s){return new Promise((u,r)=>{const S=[];y(h,{onData:a=>{s&&S.push(a)},onError:a=>{s?r(a):u(void 0)},onEnd:()=>{u(s?s(S):void 0)}})})}e.consumeStream=F;function y(h,s){let u=!1;return h.on("error",r=>{u||s.onError(r)}),h.on("end",()=>{u||s.onEnd()}),h.on("data",r=>{u||s.onData(r)}),(0,t.toDisposable)(()=>u=!0)}e.listenStream=y;function c(h,s){return new Promise((u,r)=>{const S=new t.DisposableStore,a=[],i=l=>{if(a.push(l),a.length>s)return S.dispose(),h.pause(),u({stream:h,buffer:a,ended:!1})},n=l=>r(l),o=()=>u({stream:h,buffer:a,ended:!0});S.add((0,t.toDisposable)(()=>h.removeListener("error",n))),h.on("error",n),S.add((0,t.toDisposable)(()=>h.removeListener("end",o))),h.on("end",o),S.add((0,t.toDisposable)(()=>h.removeListener("data",i))),h.on("data",i)})}e.peekStream=c;function E(h,s){const u=T(s);return u.end(h),u}e.toStream=E;function v(){const h=T(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=v;function w(h){let s=!1;return{read:()=>s?null:(s=!0,h)}}e.toReadable=w;function _(h,s,u){const r=T(u);return y(h,{onData:S=>r.write(s.data(S)),onError:S=>r.error(s.error?s.error(S):S),onEnd:()=>r.end()}),r}e.transform=_;function R(h,s,u){let r=!1;return{read:()=>{const S=s.read();return r?S:(r=!0,S!==null?u([h,S]):h)}}}e.prefixedReadable=R;function p(h,s,u){let r=!1;const S=T(u);return y(s,{onData:a=>r?S.write(a):(r=!0,S.write(u([h,a]))),onError:a=>S.error(a),onEnd:()=>{r||(r=!0,S.write(h)),S.end()}}),S}e.prefixedStream=p}),define(pe[23],ve([0,1,98]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let I,C;class T{constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}static alloc(f){return t?new T(Buffer.allocUnsafe(f)):new T(new Uint8Array(f))}static wrap(f){return t&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new T(f)}static fromString(f,m){return!(m?.dontUseNodeBuffer||!1)&&t?new T(Buffer.from(f)):(I||(I=new TextEncoder),new T(I.encode(f)))}static fromByteArray(f){const m=T.alloc(f.length);for(let b=0,A=f.length;b<A;b++)m.buffer[b]=f[b];return m}static concat(f,m){if(typeof m=="undefined"){m=0;for(let L=0,N=f.length;L<N;L++)m+=f[L].byteLength}const b=T.alloc(m);let A=0;for(let L=0,N=f.length;L<N;L++){const g=f[L];b.set(g,A),A+=g.byteLength}return b}clone(){const f=T.alloc(this.byteLength);return f.set(this),f}toString(){return t?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(f,m){return new T(this.buffer.subarray(f,m))}set(f,m){if(f instanceof T)this.buffer.set(f.buffer,m);else if(f instanceof Uint8Array)this.buffer.set(f,m);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),m);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),m);else throw new Error("Unkown argument 'array'")}readUInt32BE(f){return P(this.buffer,f)}writeUInt32BE(f,m){F(this.buffer,f,m)}readUInt32LE(f){return y(this.buffer,f)}writeUInt32LE(f,m){c(this.buffer,f,m)}readUInt8(f){return E(this.buffer,f)}writeUInt8(f,m){v(this.buffer,f,m)}}e.VSBuffer=T;function k(l,f){return l[f+0]<<0>>>0|l[f+1]<<8>>>0}e.readUInt16LE=k;function D(l,f,m){l[m+0]=f&255,f=f>>>8,l[m+1]=f&255}e.writeUInt16LE=D;function P(l,f){return l[f]*2**24+l[f+1]*2**16+l[f+2]*2**8+l[f+3]}e.readUInt32BE=P;function F(l,f,m){l[m+3]=f,f=f>>>8,l[m+2]=f,f=f>>>8,l[m+1]=f,f=f>>>8,l[m]=f}e.writeUInt32BE=F;function y(l,f){return l[f+0]<<0>>>0|l[f+1]<<8>>>0|l[f+2]<<16>>>0|l[f+3]<<24>>>0}e.readUInt32LE=y;function c(l,f,m){l[m+0]=f&255,f=f>>>8,l[m+1]=f&255,f=f>>>8,l[m+2]=f&255,f=f>>>8,l[m+3]=f&255}e.writeUInt32LE=c;function E(l,f){return l[f]}e.readUInt8=E;function v(l,f,m){l[m]=f}e.writeUInt8=v;function w(l){return d.consumeReadable(l,f=>T.concat(f))}e.readableToBuffer=w;function _(l){return d.toReadable(l)}e.bufferToReadable=_;function R(l){return d.consumeStream(l,f=>T.concat(f))}e.streamToBuffer=R;async function p(l){return l.ended?T.concat(l.buffer):T.concat([...l.buffer,await R(l.stream)])}e.bufferedStreamToBuffer=p;function h(l){return d.toStream(l,f=>T.concat(f))}e.bufferToStream=h;function s(l){return d.transform(l,{data:f=>typeof f=="string"?T.fromString(f):T.wrap(f)},f=>T.concat(f))}e.streamToBufferReadableStream=s;function u(l){return d.newWriteableStream(f=>T.concat(f),l)}e.newWriteableBufferStream=u;function r(l,f){return d.prefixedReadable(l,f,m=>T.concat(m))}e.prefixedBufferReadable=r;function S(l,f){return d.prefixedStream(l,f,m=>T.concat(m))}e.prefixedBufferStream=S;function a(l){let f=0,m=0,b=0;const A=new Uint8Array(Math.floor(l.length/4*3)),L=g=>{switch(m){case 3:A[b++]=f|g,m=0;break;case 2:A[b++]=f|g>>>2,f=g<<6,m=3;break;case 1:A[b++]=f|g>>>4,f=g<<4,m=2;break;default:f=g<<2,m=1}};for(let g=0;g<l.length;g++){const M=l.charCodeAt(g);if(M>=65&&M<=90)L(M-65);else if(M>=97&&M<=122)L(M-97+26);else if(M>=48&&M<=57)L(M-48+52);else if(M===43||M===45)L(62);else if(M===47||M===95)L(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${l[g]}`)}}const N=b;for(;m>0;)L(0);return T.wrap(A).slice(0,N)}e.decodeBase64=a;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:l},f=!0,m=!1){const b=m?n:i;let A="";const L=l.byteLength%3;let N=0;for(;N<l.byteLength-L;N+=3){const g=l[N+0],M=l[N+1],U=l[N+2];A+=b[g>>>2],A+=b[(g<<4|M>>>4)&63],A+=b[(M<<2|U>>>6)&63],A+=b[U&63]}if(L===1){const g=l[N+0];A+=b[g>>>2],A+=b[g<<4&63],f&&(A+="==")}else if(L===2){const g=l[N+0],M=l[N+1];A+=b[g>>>2],A+=b[(g<<4|M>>>4)&63],A+=b[M<<2&63],f&&(A+="=")}return A}e.encodeBase64=o}),define(pe[8],ve([0,1,143,93]),function(ee,e,d,t){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function C(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}e.isFalsyOrWhitespace=C;const T=/{(\d+)}/g;function k(Y,...ge){return ge.length===0?Y:Y.replace(T,function(_e,Oe){const ze=parseInt(Oe,10);return isNaN(ze)||ze<0||ze>=ge.length?_e:ge[ze]})}e.format=k;const D=/{([^}]+)}/g;function P(Y,ge){return Y.replace(D,(_e,Oe)=>ge[Oe]??_e)}e.format2=P;function F(Y){return Y.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}e.escape=F;function y(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function c(Y,ge){let _e=0;const Oe=ge.charCodeAt(0);for(let ze=Y.length-1;ze>=0;ze--)Y.charCodeAt(ze)===Oe&&_e++;return _e}e.count=c;function E(Y,ge,_e="\u2026"){return Y.length<=ge?Y:`${Y.substr(0,ge)}${_e}`}e.truncate=E;function v(Y,ge=" "){const _e=w(Y,ge);return _(_e,ge)}e.trim=v;function w(Y,ge){if(!Y||!ge)return Y;const _e=ge.length;if(_e===0||Y.length===0)return Y;let Oe=0;for(;Y.indexOf(ge,Oe)===Oe;)Oe=Oe+_e;return Y.substring(Oe)}e.ltrim=w;function _(Y,ge){if(!Y||!ge)return Y;const _e=ge.length,Oe=Y.length;if(_e===0||Oe===0)return Y;let ze=Oe,Ze=-1;for(;Ze=Y.lastIndexOf(ge,ze-1),!(Ze===-1||Ze+_e!==ze);){if(Ze===0)return"";ze=Ze}return Y.substring(0,ze)}e.rtrim=_;function R(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=R;function p(Y){return Y.replace(/\*/g,"")}e.stripWildcards=p;function h(Y,ge,_e={}){if(!Y)throw new Error("Cannot create regex from empty string");ge||(Y=y(Y)),_e.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let Oe="";return _e.global&&(Oe+="g"),_e.matchCase||(Oe+="i"),_e.multiline&&(Oe+="m"),_e.unicode&&(Oe+="u"),new RegExp(Y,Oe)}e.createRegExp=h;function s(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}e.regExpLeadsToEndlessLoop=s;function u(Y){return!!Y.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=u;function r(Y){return(Y.global?"g":"")+(Y.ignoreCase?"i":"")+(Y.multiline?"m":"")+(Y.unicode?"u":"")}e.regExpFlags=r;function S(Y){return Y.split(/\r\n|\r|\n/)}e.splitLines=S;function a(Y){for(let ge=0,_e=Y.length;ge<_e;ge++){const Oe=Y.charCodeAt(ge);if(Oe!==32&&Oe!==9)return ge}return-1}e.firstNonWhitespaceIndex=a;function i(Y,ge=0,_e=Y.length){for(let Oe=ge;Oe<_e;Oe++){const ze=Y.charCodeAt(Oe);if(ze!==32&&ze!==9)return Y.substring(ge,Oe)}return Y.substring(ge,_e)}e.getLeadingWhitespace=i;function n(Y,ge=Y.length-1){for(let _e=ge;_e>=0;_e--){const Oe=Y.charCodeAt(_e);if(Oe!==32&&Oe!==9)return _e}return-1}e.lastNonWhitespaceIndex=n;function o(Y,ge){return Y<ge?-1:Y>ge?1:0}e.compare=o;function l(Y,ge,_e=0,Oe=Y.length,ze=0,Ze=ge.length){for(;_e<Oe&&ze<Ze;_e++,ze++){let Ge=Y.charCodeAt(_e),at=ge.charCodeAt(ze);if(Ge<at)return-1;if(Ge>at)return 1}const lt=Oe-_e,vt=Ze-ze;return lt<vt?-1:lt>vt?1:0}e.compareSubstring=l;function f(Y,ge){return m(Y,ge,0,Y.length,0,ge.length)}e.compareIgnoreCase=f;function m(Y,ge,_e=0,Oe=Y.length,ze=0,Ze=ge.length){for(;_e<Oe&&ze<Ze;_e++,ze++){let Ge=Y.charCodeAt(_e),at=ge.charCodeAt(ze);if(Ge===at)continue;if(Ge>=128||at>=128)return l(Y.toLowerCase(),ge.toLowerCase(),_e,Oe,ze,Ze);b(Ge)&&(Ge-=32),b(at)&&(at-=32);const Xe=Ge-at;if(Xe!==0)return Xe}const lt=Oe-_e,vt=Ze-ze;return lt<vt?-1:lt>vt?1:0}e.compareSubstringIgnoreCase=m;function b(Y){return Y>=97&&Y<=122}e.isLowerAsciiLetter=b;function A(Y){return Y>=65&&Y<=90}e.isUpperAsciiLetter=A;function L(Y,ge){return Y.length===ge.length&&m(Y,ge)===0}e.equalsIgnoreCase=L;function N(Y,ge){const _e=ge.length;return ge.length>Y.length?!1:m(Y,ge,0,_e)===0}e.startsWithIgnoreCase=N;function g(Y,ge){let _e,Oe=Math.min(Y.length,ge.length);for(_e=0;_e<Oe;_e++)if(Y.charCodeAt(_e)!==ge.charCodeAt(_e))return _e;return Oe}e.commonPrefixLength=g;function M(Y,ge){let _e,Oe=Math.min(Y.length,ge.length);const ze=Y.length-1,Ze=ge.length-1;for(_e=0;_e<Oe;_e++)if(Y.charCodeAt(ze-_e)!==ge.charCodeAt(Ze-_e))return _e;return Oe}e.commonSuffixLength=M;function U(Y){return 55296<=Y&&Y<=56319}e.isHighSurrogate=U;function j(Y){return 56320<=Y&&Y<=57343}e.isLowSurrogate=j;function K(Y,ge){return(Y-55296<<10)+(ge-56320)+65536}e.computeCodePoint=K;function B(Y,ge,_e){const Oe=Y.charCodeAt(_e);if(U(Oe)&&_e+1<ge){const ze=Y.charCodeAt(_e+1);if(j(ze))return K(Oe,ze)}return Oe}e.getNextCodePoint=B;function x(Y,ge){const _e=Y.charCodeAt(ge-1);if(j(_e)&&ge>1){const Oe=Y.charCodeAt(ge-2);if(U(Oe))return K(Oe,_e)}return _e}class z{constructor(ge,_e=0){this._str=ge,this._len=ge.length,this._offset=_e}get offset(){return this._offset}setOffset(ge){this._offset=ge}prevCodePoint(){const ge=x(this._str,this._offset);return this._offset-=ge>=65536?2:1,ge}nextCodePoint(){const ge=B(this._str,this._len,this._offset);return this._offset+=ge>=65536?2:1,ge}eol(){return this._offset>=this._len}}e.CodePointIterator=z;class G{constructor(ge,_e=0){this._iterator=new z(ge,_e)}get offset(){return this._iterator.offset}nextGraphemeLength(){const ge=He.getInstance(),_e=this._iterator,Oe=_e.offset;let ze=ge.getGraphemeBreakType(_e.nextCodePoint());for(;!_e.eol();){const Ze=_e.offset,lt=ge.getGraphemeBreakType(_e.nextCodePoint());if($e(ze,lt)){_e.setOffset(Ze);break}ze=lt}return _e.offset-Oe}prevGraphemeLength(){const ge=He.getInstance(),_e=this._iterator,Oe=_e.offset;let ze=ge.getGraphemeBreakType(_e.prevCodePoint());for(;_e.offset>0;){const Ze=_e.offset,lt=ge.getGraphemeBreakType(_e.prevCodePoint());if($e(lt,ze)){_e.setOffset(Ze);break}ze=lt}return Oe-_e.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=G;function q(Y,ge){return new G(Y,ge).nextGraphemeLength()}e.nextCharLength=q;function Z(Y,ge){return new G(Y,ge).prevGraphemeLength()}e.prevCharLength=Z;function se(Y,ge){ge>0&&j(Y.charCodeAt(ge))&&ge--;const _e=ge+q(Y,ge);return[_e-Z(Y,_e),_e]}e.getCharContainingOffset=se;const ue=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function te(Y){return ue.test(Y)}e.containsRTL=te;const J=/^[\t\n\r\x20-\x7E]*$/;function ae(Y){return J.test(Y)}e.isBasicASCII=ae,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function he(Y){return e.UNUSUAL_LINE_TERMINATORS.test(Y)}e.containsUnusualLineTerminators=he;function we(Y){return Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}e.isFullWidthCharacter=we;function Ie(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129008||Y>=129280&&Y<=129535||Y>=129648&&Y<=129782}e.isEmojiImprecise=Ie;function Ne(Y,ge){if(Y.length<ge)return Y;const _e=/\b/g;let Oe=0;for(;_e.test(Y)&&!(Y.length-_e.lastIndex<ge);)Oe=_e.lastIndex,_e.lastIndex+=1;return Y.substring(Oe).replace(/^\s/,"")}e.lcut=Ne;const Ee=/\x1B\x5B[12]?K/g,be=/\x1b\[\d+m/g,H=/\x1b\[0?m/g;function W(Y){return Y&&(Y=Y.replace(Ee,""),Y=Y.replace(be,""),Y=Y.replace(H,"")),Y}e.removeAnsiEscapeCodes=W,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function O(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}e.startsWithUTF8BOM=O;function $(Y){return O(Y)?Y.substr(1):Y}e.stripUTF8BOM=$;function Q(Y,ge){if(!Y||!ge||Y.length<ge.length)return!1;const _e=ge.length,Oe=Y.toLowerCase();let ze=0,Ze=-1;for(;ze<_e;){const lt=Oe.indexOf(ge[ze],Ze+1);if(lt<0)return!1;Ze=lt,ze++}return!0}e.fuzzyContains=Q;function re(Y,ge=!1){return Y?(ge&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}e.containsUppercaseCharacter=re;function de(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}e.uppercaseFirstLetter=de;function ye(Y,ge=1){if(ge===0)return"";let _e=-1;do _e=Y.indexOf(`
`,_e+1),ge--;while(ge>0&&_e>=0);return _e===-1?Y:(Y[_e-1]==="\r"&&_e--,Y.substr(0,_e))}e.getNLines=ye;function Ae(Y){const ge=90-65+1;return Y=Y%(2*ge),Y<ge?String.fromCharCode(97+Y):String.fromCharCode(65+Y-ge)}e.singleLetterHash=Ae;function We(Y){return He.getInstance().getGraphemeBreakType(Y)}e.getGraphemeBreakType=We;function $e(Y,ge){return Y===0?ge!==5&&ge!==7:Y===2&&ge===3?!1:Y===4||Y===2||Y===3||ge===4||ge===2||ge===3?!0:!(Y===8&&(ge===8||ge===9||ge===11||ge===12)||(Y===11||Y===9)&&(ge===9||ge===10)||(Y===12||Y===10)&&ge===10||ge===5||ge===13||ge===7||Y===1||Y===13&&ge===14||Y===6&&ge===6)}var je;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(je=e.GraphemeBreakType||(e.GraphemeBreakType={}));class He{constructor(){this._data=Ue()}static getInstance(){return He._INSTANCE||(He._INSTANCE=new He),He._INSTANCE}getGraphemeBreakType(ge){if(ge<32)return ge===10?3:ge===13?2:4;if(ge<127)return 0;const _e=this._data,Oe=_e.length/3;let ze=1;for(;ze<=Oe;)if(ge<_e[3*ze])ze=2*ze;else if(ge>_e[3*ze+1])ze=2*ze+1;else return _e[3*ze+2];return 0}}He._INSTANCE=null;function Ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Je(Y,ge){if(Y===0)return 0;const _e=rt(Y,ge);if(_e!==void 0)return _e;const Oe=new z(ge,Y);return Oe.prevCodePoint(),Oe.offset}e.getLeftDeleteOffset=Je;function rt(Y,ge){const _e=new z(ge,Y);let Oe=_e.prevCodePoint();for(;Re(Oe)||Oe===65039||Oe===8419;){if(_e.offset===0)return;Oe=_e.prevCodePoint()}if(!Ie(Oe))return;let ze=_e.offset;return ze>0&&_e.prevCodePoint()===8205&&(ze=_e.offset),ze}function Re(Y){return 127995<=Y&&Y<=127999}var tt;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(tt||(tt={})),e.noBreakWhitespace="\xA0";class ne{constructor(ge){this.confusableDictionary=ge}static getInstance(ge){return ne.cache.get(Array.from(ge))}static getLocales(){return ne._locales.getValue()}isAmbiguous(ge){return this.confusableDictionary.has(ge)}getPrimaryConfusable(ge){return this.confusableDictionary.get(ge)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ne,I=ne,ne.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ne.cache=new d.LRUCachedComputed(Y=>{function ge(at){const Xe=new Map;for(let st=0;st<at.length;st+=2)Xe.set(at[st],at[st+1]);return Xe}function _e(at,Xe){const st=new Map(at);for(const[yt,Pt]of Xe)st.set(yt,Pt);return st}function Oe(at,Xe){if(!at)return Xe;const st=new Map;for(const[yt,Pt]of at)Xe.has(yt)&&st.set(yt,Pt);return st}const ze=I.ambiguousCharacterData.getValue();let Ze=Y.filter(at=>!at.startsWith("_")&&at in ze);Ze.length===0&&(Ze=["_default"]);let lt;for(const at of Ze){const Xe=ge(ze[at]);lt=Oe(lt,Xe)}const vt=ge(ze._common),Ge=_e(vt,lt);return new ne(Ge)}),ne._locales=new t.Lazy(()=>Object.keys(ne.ambiguousCharacterData.getValue()).filter(Y=>!Y.startsWith("_")));class oe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(oe.getRawData())),this._data}static isInvisibleCharacter(ge){return oe.getData().has(ge)}static get codePoints(){return oe.getData()}}e.InvisibleCharacters=oe,oe._data=void 0}),define(pe[58],ve([0,1,8]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(R){return I(R,0)}e.hash=t;function I(R,p){switch(typeof R){case"object":return R===null?C(349,p):Array.isArray(R)?D(R,p):P(R,p);case"string":return k(R,p);case"boolean":return T(R,p);case"number":return C(R,p);case"undefined":return C(937,p);default:return C(617,p)}}e.doHash=I;function C(R,p){return(p<<5)-p+R|0}e.numberHash=C;function T(R,p){return C(R?433:863,p)}function k(R,p){p=C(149417,p);for(let h=0,s=R.length;h<s;h++)p=C(R.charCodeAt(h),p);return p}e.stringHash=k;function D(R,p){return p=C(104579,p),R.reduce((h,s)=>I(s,h),p)}function P(R,p){return p=C(181387,p),Object.keys(R).sort().reduce((h,s)=>(h=k(s,h),I(R[s],h)),p)}class F{constructor(){this._value=0}get value(){return this._value}hash(p){return this._value=I(p,this._value),this._value}}e.Hasher=F;var y;(function(R){R[R.BLOCK_SIZE=64]="BLOCK_SIZE",R[R.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function c(R,p,h=32){const s=h-p,u=~((1<<s)-1);return(R<<p|(u&R)>>>s)>>>0}function E(R,p=0,h=R.byteLength,s=0){for(let u=0;u<h;u++)R[p+u]=s}function v(R,p,h="0"){for(;R.length<p;)R=h+R;return R}function w(R,p=32){return R instanceof ArrayBuffer?Array.from(new Uint8Array(R)).map(h=>h.toString(16).padStart(2,"0")).join(""):v((R>>>0).toString(16),p/4)}e.toHexString=w;class _{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(p){const h=p.length;if(h===0)return;const s=this._buff;let u=this._buffLen,r=this._leftoverHighSurrogate,S,a;for(r!==0?(S=r,a=-1,r=0):(S=p.charCodeAt(0),a=0);;){let i=S;if(d.isHighSurrogate(S))if(a+1<h){const n=p.charCodeAt(a+1);d.isLowSurrogate(n)?(a++,i=d.computeCodePoint(S,n)):i=65533}else{r=S;break}else d.isLowSurrogate(S)&&(i=65533);if(u=this._push(s,u,i),a++,a<h)S=p.charCodeAt(a);else break}this._buffLen=u,this._leftoverHighSurrogate=r}_push(p,h,s){return s<128?p[h++]=s:s<2048?(p[h++]=192|(s&1984)>>>6,p[h++]=128|(s&63)>>>0):s<65536?(p[h++]=224|(s&61440)>>>12,p[h++]=128|(s&4032)>>>6,p[h++]=128|(s&63)>>>0):(p[h++]=240|(s&1835008)>>>18,p[h++]=128|(s&258048)>>>12,p[h++]=128|(s&4032)>>>6,p[h++]=128|(s&63)>>>0),h>=64&&(this._step(),h-=64,this._totalLen+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),h}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,E(this._buff,this._buffLen),this._buffLen>56&&(this._step(),E(this._buff));const p=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(p/4294967296),!1),this._buffDV.setUint32(60,p%4294967296,!1),this._step()}_step(){const p=_._bigBlock32,h=this._buffDV;for(let l=0;l<64;l+=4)p.setUint32(l,h.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)p.setUint32(l,c(p.getUint32(l-12,!1)^p.getUint32(l-32,!1)^p.getUint32(l-56,!1)^p.getUint32(l-64,!1),1),!1);let s=this._h0,u=this._h1,r=this._h2,S=this._h3,a=this._h4,i,n,o;for(let l=0;l<80;l++)l<20?(i=u&r|~u&S,n=1518500249):l<40?(i=u^r^S,n=1859775393):l<60?(i=u&r|u&S|r&S,n=2400959708):(i=u^r^S,n=3395469782),o=c(s,5)+i+a+n+p.getUint32(l*4,!1)&4294967295,a=S,S=r,r=c(u,30),u=s,s=o;this._h0=this._h0+s&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+S&4294967295,this._h4=this._h4+a&4294967295}}e.StringSHA1=_,_._bigBlock32=new DataView(new ArrayBuffer(320))});var Qe=this&&this.__classPrivateFieldSet||function(ee,e,d,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,d):I?I.value=d:e.set(ee,d),d},Te=this&&this.__classPrivateFieldGet||function(ee,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(ee):t?t.value:e.get(ee)};define(pe[24],ve([0,1,17,8]),function(ee,e,d,t){"use strict";var I,C,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function k(a,i,n){let o=a.get(i);return o===void 0&&(o=n,a.set(i,o)),o}e.getOrSet=k;function D(a){const i=[];return a.forEach((n,o)=>{i.push(`${o} => ${n}`)}),`Map(${a.size}) {${i.join(", ")}}`}e.mapToString=D;function P(a){const i=[];return a.forEach(n=>{i.push(n)}),`Set(${a.size}) {${i.join(", ")}}`}e.setToString=P;class F{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const n=i.charCodeAt(0),o=this._value.charCodeAt(this._pos);return n-o}value(){return this._value[this._pos]}}e.StringIterator=F;class y{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=y;class c{constructor(i=!0,n=!0){this._splitOnBackslash=i,this._caseSensitive=n}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let n=i.length-1;n>=0;n--,this._valueLen--){const o=this._value.charCodeAt(n);if(!(o===47||this._splitOnBackslash&&o===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const n=this._value.charCodeAt(this._to);if(n===47||this._splitOnBackslash&&n===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=c;var E;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})(E||(E={}));class v{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new c(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,t.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=v;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var _;(function(a){a[a.Left=-1]="Left",a[a.Mid=0]="Mid",a[a.Right=1]="Right"})(_||(_={}));class R{constructor(i){this._iter=i}static forUris(i=()=>!1){return new R(new v(i))}static forPaths(i=!1){return new R(new c(void 0,!i))}static forStrings(){return new R(new F)}static forConfigKeys(){return new R(new y)}clear(){this._root=void 0}fill(i,n){if(n){const o=n.slice(0);(0,d.shuffle)(o);for(let l of o)this.set(l,i)}else{const o=i.slice(0);(0,d.shuffle)(o);for(let l of o)this.set(l[0],l[1])}}set(i,n){const o=this._iter.reset(i);let l;this._root||(this._root=new w,this._root.segment=o.value());const f=[];for(l=this._root;;){const b=o.cmp(l.segment);if(b>0)l.left||(l.left=new w,l.left.segment=o.value()),f.push([-1,l]),l=l.left;else if(b<0)l.right||(l.right=new w,l.right.segment=o.value()),f.push([1,l]),l=l.right;else if(o.hasNext())o.next(),l.mid||(l.mid=new w,l.mid.segment=o.value()),f.push([0,l]),l=l.mid;else break}const m=l.value;l.value=n,l.key=i;for(let b=f.length-1;b>=0;b--){const A=f[b][1];A.updateHeight();const L=A.balanceFactor();if(L<-1||L>1){const N=f[b][0],g=f[b+1][0];if(N===1&&g===1)f[b][1]=A.rotateLeft();else if(N===-1&&g===-1)f[b][1]=A.rotateRight();else if(N===1&&g===-1)A.right=f[b+1][1]=f[b+1][1].rotateRight(),f[b][1]=A.rotateLeft();else if(N===-1&&g===1)A.left=f[b+1][1]=f[b+1][1].rotateLeft(),f[b][1]=A.rotateRight();else throw new Error;if(b>0)switch(f[b-1][0]){case-1:f[b-1][1].left=f[b][1];break;case 1:f[b-1][1].right=f[b][1];break;case 0:f[b-1][1].mid=f[b][1];break}else this._root=f[0][1]}}return m}get(i){return this._getNode(i)?.value}_getNode(i){const n=this._iter.reset(i);let o=this._root;for(;o;){const l=n.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(n.hasNext())n.next(),o=o.mid;else break}return o}has(i){const n=this._getNode(i);return!(n?.value===void 0&&n?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,n){const o=this._iter.reset(i),l=[];let f=this._root;for(;f;){const m=o.cmp(f.segment);if(m>0)l.push([-1,f]),f=f.left;else if(m<0)l.push([1,f]),f=f.right;else if(o.hasNext())o.next(),l.push([0,f]),f=f.mid;else break}if(!!f){if(n?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const m=this._min(f.right),{key:b,value:A,segment:L}=m;this._delete(m.key,!1),f.key=b,f.value=A,f.segment=L}else{const m=f.left??f.right;if(l.length>0){const[b,A]=l[l.length-1];switch(b){case-1:A.left=m;break;case 0:A.mid=m;break;case 1:A.right=m;break}}else this._root=m}for(let m=l.length-1;m>=0;m--){const b=l[m][1];b.updateHeight();const A=b.balanceFactor();if(A>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),l[m][1]=b.rotateLeft()):A<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),l[m][1]=b.rotateRight()),m>0)switch(l[m-1][0]){case-1:l[m-1][1].left=l[m][1];break;case 1:l[m-1][1].right=l[m][1];break;case 0:l[m-1][1].mid=l[m][1];break}else this._root=l[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const n=this._iter.reset(i);let o=this._root,l;for(;o;){const f=n.cmp(o.segment);if(f>0)o=o.left;else if(f<0)o=o.right;else if(n.hasNext())n.next(),l=o.value||l,o=o.mid;else break}return o&&o.value||l}findSuperstr(i){const n=this._iter.reset(i);let o=this._root;for(;o;){const l=n.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(n.hasNext())n.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(i){for(const[n,o]of this)i(o,n)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=n=>{if(!n)return!0;const o=n.balanceFactor();return o<-1||o>1?!1:i(n.left)&&i(n.right)};return i(this._root)}}e.TernarySearchTree=R;class p{constructor(i,n){this.uri=i,this.value=n}}class h{constructor(i,n){this[I]="ResourceMap",i instanceof h?(this.map=new Map(i.map),this.toKey=n??h.defaultToKey):(this.map=new Map,this.toKey=i??h.defaultToKey)}set(i,n){return this.map.set(this.toKey(i),new p(i,n)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,n){typeof n!="undefined"&&(i=i.bind(n));for(let[o,l]of this.map)i(l.value,l.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=h,h.defaultToKey=a=>a.toString();var s;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(s=e.Touch||(e.Touch={}));class u{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,n=0){const o=this._map.get(i);if(!!o)return n!==0&&this.touch(o,n),o.value}set(i,n,o=0){let l=this._map.get(i);if(l)l.value=n,o!==0&&this.touch(l,o);else{switch(l={key:i,value:n,next:void 0,previous:void 0},o){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(i,l),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const n=this._map.get(i);if(!!n)return this._map.delete(i),this.removeItem(n),this._size--,n.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,n){const o=this._state;let l=this._head;for(;l;){if(n?i.bind(n)(l.value,l.key,this):i(l.value,l.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const i=this,n=this._state;let o=this._head;const l={[Symbol.iterator](){return l},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(o){const f={value:o.key,done:!1};return o=o.next,f}else return{value:void 0,done:!0}}};return l}values(){const i=this,n=this._state;let o=this._head;const l={[Symbol.iterator](){return l},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(o){const f={value:o.value,done:!1};return o=o.next,f}else return{value:void 0,done:!0}}};return l}entries(){const i=this,n=this._state;let o=this._head;const l={[Symbol.iterator](){return l},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(o){const f={value:[o.key,o.value],done:!1};return o=o.next,f}else return{value:void 0,done:!0}}};return l}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let n=this._head,o=this.size;for(;n&&o>i;)this._map.delete(n.key),n=n.next,o--;this._head=n,this._size=o,n&&(n.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const n=i.next,o=i.previous;if(!n||!o)throw new Error("Invalid list");n.previous=o,o.next=n}i.next=void 0,i.previous=void 0,this._state++}touch(i,n){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(n!==1&&n!==2)){if(n===1){if(i===this._head)return;const o=i.next,l=i.previous;i===this._tail?(l.next=void 0,this._tail=l):(o.previous=l,l.next=o),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(n===2){if(i===this._tail)return;const o=i.next,l=i.previous;i===this._head?(o.previous=void 0,this._head=o):(o.previous=l,l.next=o),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((n,o)=>{i.push([o,n])}),i}fromJSON(i){this.clear();for(const[n,o]of i)this.set(n,o)}}e.LinkedMap=u;class r extends u{constructor(i,n=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,n),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,n=2){return super.get(i,n)}peek(i){return super.get(i,0)}set(i,n){return super.set(i,n,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r;class S{constructor(i){T.set(this,void 0),Qe(this,T,i,"f")}get size(){return Te(this,T,"f").size}forEach(i,n){Te(this,T,"f").forEach(i,n)}get(i){return Te(this,T,"f").get(i)}has(i){return Te(this,T,"f").has(i)}entries(){return Te(this,T,"f").entries()}keys(){return Te(this,T,"f").keys()}values(){return Te(this,T,"f").values()}[(T=new WeakMap,Symbol.iterator)](){return Te(this,T,"f").entries()}}e.ReadonlyMapView=S}),define(pe[99],ve([0,1,24,8]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function I(...O){return function($,Q){for(let re=0,de=O.length;re<de;re++){const ye=O[re]($,Q);if(ye)return ye}return null}}e.or=I,e.matchesStrictPrefix=C.bind(void 0,!1),e.matchesPrefix=C.bind(void 0,!0);function C(O,$,Q){if(!Q||Q.length<$.length)return null;let re;return O?re=t.startsWithIgnoreCase(Q,$):re=Q.indexOf($)===0,re?$.length>0?[{start:0,end:$.length}]:[]:null}function T(O,$){const Q=$.toLowerCase().indexOf(O.toLowerCase());return Q===-1?null:[{start:Q,end:Q+O.length}]}e.matchesContiguousSubString=T;function k(O,$){return D(O.toLowerCase(),$.toLowerCase(),0,0)}e.matchesSubString=k;function D(O,$,Q,re){if(Q===O.length)return[];if(re===$.length)return null;if(O[Q]===$[re]){let de=null;return(de=D(O,$,Q+1,re+1))?R({start:re,end:re+1},de):null}return D(O,$,Q,re+1)}function P(O){return 97<=O&&O<=122}function F(O){return 65<=O&&O<=90}e.isUpper=F;function y(O){return 48<=O&&O<=57}function c(O){return O===32||O===9||O===10||O===13}const E=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(O=>E.add(O.charCodeAt(0)));function v(O){return c(O)||E.has(O)}function w(O,$){return O===$||v(O)&&v($)}function _(O){return P(O)||F(O)||y(O)}function R(O,$){return $.length===0?$=[O]:O.end===$[0].start?$[0].start=O.start:$.unshift(O),$}function p(O,$){for(let Q=$;Q<O.length;Q++){const re=O.charCodeAt(Q);if(F(re)||y(re)||Q>0&&!_(O.charCodeAt(Q-1)))return Q}return O.length}function h(O,$,Q,re){if(Q===O.length)return[];if(re===$.length)return null;if(O[Q]!==$[re].toLowerCase())return null;{let de=null,ye=re+1;for(de=h(O,$,Q+1,re+1);!de&&(ye=p($,ye))<$.length;)de=h(O,$,Q+1,ye),ye++;return de===null?null:R({start:re,end:re+1},de)}}function s(O){let $=0,Q=0,re=0,de=0,ye=0;for(let He=0;He<O.length;He++)ye=O.charCodeAt(He),F(ye)&&$++,P(ye)&&Q++,_(ye)&&re++,y(ye)&&de++;const Ae=$/O.length,We=Q/O.length,$e=re/O.length,je=de/O.length;return{upperPercent:Ae,lowerPercent:We,alphaPercent:$e,numericPercent:je}}function u(O){const{upperPercent:$,lowerPercent:Q}=O;return Q===0&&$>.6}function r(O){const{upperPercent:$,lowerPercent:Q,alphaPercent:re,numericPercent:de}=O;return Q>.2&&$<.8&&re>.6&&de<.2}function S(O){let $=0,Q=0,re=0,de=0;for(let ye=0;ye<O.length;ye++)re=O.charCodeAt(ye),F(re)&&$++,P(re)&&Q++,c(re)&&de++;return($===0||Q===0)&&de===0?O.length<=30:$<=5}function a(O,$){if(!$||($=$.trim(),$.length===0)||!S(O)||$.length>60)return null;const Q=s($);if(!r(Q)){if(!u(Q))return null;$=$.toLowerCase()}let re=null,de=0;for(O=O.toLowerCase();de<$.length&&(re=h(O,$,0,de))===null;)de=p($,de+1);return re}e.matchesCamelCase=a;function i(O,$,Q=!1){if(!$||$.length===0)return null;let re=null,de=0;for(O=O.toLowerCase(),$=$.toLowerCase();de<$.length&&(re=n(O,$,0,de,Q))===null;)de=o($,de+1);return re}e.matchesWords=i;function n(O,$,Q,re,de){if(Q===O.length)return[];if(re===$.length)return null;if(w(O.charCodeAt(Q),$.charCodeAt(re))){let ye=null,Ae=re+1;if(ye=n(O,$,Q+1,re+1,de),!de)for(;!ye&&(Ae=o($,Ae))<$.length;)ye=n(O,$,Q+1,Ae,de),Ae++;return ye===null?null:R({start:re,end:re+1},ye)}else return null}function o(O,$){for(let Q=$;Q<O.length;Q++)if(v(O.charCodeAt(Q))||Q>0&&v(O.charCodeAt(Q-1)))return Q;return O.length}const l=I(e.matchesPrefix,a,T),f=I(e.matchesPrefix,a,k),m=new d.LRUCache(1e4);function b(O,$,Q=!1){if(typeof O!="string"||typeof $!="string")return null;let re=m.get(O);re||(re=new RegExp(t.convertSimple2RegExpPattern(O),"i"),m.set(O,re));const de=re.exec($);return de?[{start:de.index,end:de.index+de[0].length}]:Q?f(O,$):l(O,$)}e.matchesFuzzy=b;function A(O,$){const Q=we(O,O.toLowerCase(),0,$,$.toLowerCase(),0,!0);return Q?N(Q):null}e.matchesFuzzy2=A;function L(O,$,Q,re,de,ye){const Ae=Math.min(13,O.length);for(;Q<Ae;Q++){const We=we(O,$,Q,re,de,ye,!1);if(We)return We}return[0,ye]}e.anyScore=L;function N(O){if(typeof O=="undefined")return[];const $=[],Q=O[1];for(let re=O.length-1;re>1;re--){const de=O[re]+Q,ye=$[$.length-1];ye&&ye.end===de?ye.end=de+1:$.push({start:de,end:de+1})}return $}e.createMatches=N;const g=128;function M(){const O=[],$=[];for(let Q=0;Q<=g;Q++)$[Q]=0;for(let Q=0;Q<=g;Q++)O.push($.slice(0));return O}function U(O){const $=[];for(let Q=0;Q<=O;Q++)$[Q]=0;return $}const j=U(2*g),K=U(2*g),B=M(),x=M(),z=M(),G=!1;function q(O,$,Q,re,de){function ye(We,$e,je=" "){for(;We.length<$e;)We=je+We;return We}let Ae=` |   |${re.split("").map(We=>ye(We,3)).join("|")}
`;for(let We=0;We<=Q;We++)We===0?Ae+=" |":Ae+=`${$[We-1]}|`,Ae+=O[We].slice(0,de+1).map($e=>ye($e.toString(),3)).join("|")+`
`;return Ae}function Z(O,$,Q,re){O=O.substr($),Q=Q.substr(re),console.log(q(x,O,O.length,Q,Q.length)),console.log(q(z,O,O.length,Q,Q.length)),console.log(q(B,O,O.length,Q,Q.length))}function se(O,$){if($<0||$>=O.length)return!1;const Q=O.codePointAt($);switch(Q){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(Q)}}function ue(O,$){if($<0||$>=O.length)return!1;switch(O.charCodeAt($)){case 32:case 9:return!0;default:return!1}}function te(O,$,Q){return $[O]!==Q[O]}function J(O,$,Q,re,de,ye,Ae=!1){for(;$<Q&&de<ye;)O[$]===re[de]&&(Ae&&(j[$]=de),$+=1),de+=1;return $===Q}e.isPatternInWord=J;var ae;(function(O){O[O.Diag=1]="Diag",O[O.Left=2]="Left",O[O.LeftLeft=3]="LeftLeft"})(ae||(ae={}));var he;(function(O){O.Default=[-100,0];function $(Q){return!Q||Q.length===2&&Q[0]===-100&&Q[1]===0}O.isDefault=$})(he=e.FuzzyScore||(e.FuzzyScore={}));function we(O,$,Q,re,de,ye,Ae){const We=O.length>g?g:O.length,$e=re.length>g?g:re.length;if(Q>=We||ye>=$e||We-Q>$e-ye||!J($,Q,We,de,ye,$e,!0))return;Ie(We,$e,Q,ye,$,de);let je=1,He=1,Ue=Q,Je=ye;const rt=[!1];for(je=1,Ue=Q;Ue<We;je++,Ue++){const Y=j[Ue],ge=K[Ue],_e=Ue+1<We?K[Ue+1]:$e;for(He=Y-ye+1,Je=Y;Je<_e;He++,Je++){let Oe=Number.MIN_SAFE_INTEGER,ze=!1;Je<=ge&&(Oe=Ne(O,$,Ue,Q,re,de,Je,$e,ye,B[je-1][He-1]===0,rt));let Ze=0;Oe!==Number.MAX_SAFE_INTEGER&&(ze=!0,Ze=Oe+x[je-1][He-1]);const lt=Je>Y,vt=lt?x[je][He-1]+(B[je][He-1]>0?-5:0):0,Ge=Je>Y+1&&B[je][He-1]>0,at=Ge?x[je][He-2]+(B[je][He-2]>0?-5:0):0;if(Ge&&(!lt||at>=vt)&&(!ze||at>=Ze))x[je][He]=at,z[je][He]=3,B[je][He]=0;else if(lt&&(!ze||vt>=Ze))x[je][He]=vt,z[je][He]=2,B[je][He]=0;else if(ze)x[je][He]=Ze,z[je][He]=1,B[je][He]=B[je-1][He-1]+1;else throw new Error("not possible")}}if(G&&Z(O,Q,re,ye),!rt[0]&&!Ae)return;je--,He--;const Re=[x[je][He],ye];let tt=0,ne=0;for(;je>=1;){let Y=He;do{const ge=z[je][Y];if(ge===3)Y=Y-2;else if(ge===2)Y=Y-1;else break}while(Y>=1);tt>1&&$[Q+je-1]===de[ye+He-1]&&!te(Y+ye-1,re,de)&&tt+1>B[je][Y]&&(Y=He),Y===He?tt++:tt=1,ne||(ne=Y),je--,He=Y-1,Re.push(He)}$e===We&&(Re[0]+=2);const oe=ne-We;return Re[0]-=oe,Re}e.fuzzyScore=we;function Ie(O,$,Q,re,de,ye){let Ae=O-1,We=$-1;for(;Ae>=Q&&We>=re;)de[Ae]===ye[We]&&(K[Ae]=We,Ae--),We--}function Ne(O,$,Q,re,de,ye,Ae,We,$e,je,He){if($[Q]!==ye[Ae])return Number.MIN_SAFE_INTEGER;let Ue=1,Je=!1;return Ae===Q-re?Ue=O[Q]===de[Ae]?7:5:te(Ae,de,ye)&&(Ae===0||!te(Ae-1,de,ye))?(Ue=O[Q]===de[Ae]?7:5,Je=!0):se(ye,Ae)&&(Ae===0||!se(ye,Ae-1))?Ue=5:(se(ye,Ae-1)||ue(ye,Ae-1))&&(Ue=5,Je=!0),Ue>1&&Q===re&&(He[0]=!0),Je||(Je=te(Ae,de,ye)||se(ye,Ae-1)||ue(ye,Ae-1)),Q===re?Ae>$e&&(Ue-=Je?3:5):je?Ue+=Je?2:0:Ue+=Je?0:1,Ae+1===We&&(Ue-=Je?3:5),Ue}function Ee(O,$,Q,re,de,ye,Ae){return H(O,$,Q,re,de,ye,!0,Ae)}e.fuzzyScoreGracefulAggressive=Ee;function be(O,$,Q,re,de,ye,Ae){return H(O,$,Q,re,de,ye,!1,Ae)}e.fuzzyScoreGraceful=be;function H(O,$,Q,re,de,ye,Ae,We){let $e=we(O,$,Q,re,de,ye,We);if($e&&!Ae)return $e;if(O.length>=3){const je=Math.min(7,O.length-1);for(let He=Q+1;He<je;He++){const Ue=W(O,He);if(Ue){const Je=we(Ue,Ue.toLowerCase(),Q,re,de,ye,We);Je&&(Je[0]-=3,(!$e||Je[0]>$e[0])&&($e=Je))}}}return $e}function W(O,$){if($+1>=O.length)return;const Q=O[$],re=O[$+1];if(Q!==re)return O.slice(0,$)+re+Q+O.slice($+2)}}),define(pe[144],ve([0,1,73,99,8]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const C=new RegExp(`\\$\\(${d.CSSIcon.iconNameExpression}(?:${d.CSSIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(d.CSSIcon.iconNameCharacter),k=new RegExp(`(\\\\)?${C.source}`,"g");function D(_){return _.replace(k,(R,p)=>p?R:`\\${R}`)}e.escapeIcons=D;const P=new RegExp(`\\\\${C.source}`,"g");function F(_){return _.replace(P,R=>`\\${R}`)}e.markdownEscapeEscapedIcons=F;const y=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function c(_){return _.indexOf(e.iconStartMarker)===-1?_:_.replace(y,(R,p,h,s)=>h?R:p||s||"")}e.stripIcons=c;function E(_){const R=_.indexOf(e.iconStartMarker);return R===-1?{text:_}:v(_,R)}e.parseLabelWithIcons=E;function v(_,R){const p=[];let h="";function s(l){if(l){h+=l;for(const f of l)p.push(S)}}let u=-1,r="",S=0,a,i,n=R;const o=_.length;for(s(_.substr(0,R));n<o;)a=_[n],i=_[n+1],a===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(u=n,s(r),r=e.iconStartMarker,n++):a===")"&&u!==-1?(S+=n-u+1,u=-1,r=""):u!==-1?T.test(a)?r+=a:(s(r),u=-1,r=""):s(a),n++;return s(r),{text:h,iconOffsets:p}}function w(_,R,p=!1){const{text:h,iconOffsets:s}=R;if(!s||s.length===0)return(0,t.matchesFuzzy)(_,h,p);const u=(0,I.ltrim)(h," "),r=h.length-u.length,S=(0,t.matchesFuzzy)(_,u,p);if(S)for(const a of S){const i=s[a.start+r]+r;a.start+=i,a.end+=i}return S}e.matchesFuzzyIconAware=w}),define(pe[100],ve([0,1,16,144]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var I;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(I=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class C{constructor(E="",v=!1){if(this.value=E,typeof this.value!="string")throw(0,d.illegalArgument)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(E,v=0){return this.value+=P(this.supportThemeIcons?(0,t.escapeIcons)(E):E).replace(/([ \t]+)/g,(w,_)=>"&nbsp;".repeat(_.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(E){return this.value+=E,this}appendCodeblock(E,v){return this.value+="\n```",this.value+=E,this.value+=`
`,this.value+=v,this.value+="\n```\n",this}}e.MarkdownString=C;function T(c){return k(c)?!c.value:Array.isArray(c)?c.every(T):!0}e.isEmptyMarkdownString=T;function k(c){return c instanceof C?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}e.isMarkdownString=k;function D(c,E){return c===E?!0:!c||!E?!1:c.value===E.value&&c.isTrusted===E.isTrusted&&c.supportThemeIcons===E.supportThemeIcons}e.markdownStringEqual=D;function P(c){return c.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function F(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=F;function y(c){const E=[],v=c.split("|").map(_=>_.trim());c=v[0];const w=v[1];if(w){const _=/height=(\d+)/.exec(w),R=/width=(\d+)/.exec(w),p=_?_[1]:"",h=R?R[1]:"",s=isFinite(parseInt(h)),u=isFinite(parseInt(p));s&&E.push(`width="${h}"`),u&&E.push(`height="${p}"`)}return{href:c,dimensions:E}}e.parseHrefAndDimensions=y}),define(pe[78],ve([0,1,24]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new d.LRUCache(1e4);function I(P){return D(P,"NFC",t)}e.normalizeNFC=I;const C=new d.LRUCache(1e4);function T(P){return D(P,"NFD",C)}e.normalizeNFD=T;const k=/[^\u0000-\u0080]/;function D(P,F,y){if(!P)return P;const c=y.get(P);if(c)return c;let E;return k.test(P)?E=P.normalize(F):E=P,y.set(P,E),E}e.removeAccents=function(){const P=/[\u0300-\u036f]/g;return function(F){return T(F).replace(P,"")}}()}),define(pe[47],ve([0,1,8]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(t||(t={})),function(I){const C="error",T="warning",k="warn",D="info",P="ignore";function F(c){return c?d.equalsIgnoreCase(C,c)?I.Error:d.equalsIgnoreCase(T,c)||d.equalsIgnoreCase(k,c)?I.Warning:d.equalsIgnoreCase(D,c)?I.Info:I.Ignore:I.Ignore}I.fromValue=F;function y(c){switch(c){case I.Error:return C;case I.Warning:return T;case I.Info:return D;default:return P}}I.toString=y}(t||(t={})),e.default=t}),define(pe[18],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function d(o){return Array.isArray(o)}e.isArray=d;function t(o){return typeof o=="string"}e.isString=t;function I(o){return Array.isArray(o)&&o.every(l=>t(l))}e.isStringArray=I;function C(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=C;function T(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=T;function k(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=k;function D(o){return o===!0||o===!1}e.isBoolean=D;function P(o){return typeof o=="undefined"}e.isUndefined=P;function F(o){return!y(o)}e.isDefined=F;function y(o){return P(o)||o===null}e.isUndefinedOrNull=y;function c(o,l){if(!o)throw new Error(l?`Unexpected type, expected '${l}'`:"Unexpected type")}e.assertType=c;function E(o){if(y(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=E;function v(...o){const l=[];for(let f=0;f<o.length;f++){const m=o[f];if(y(m))throw new Error(`Assertion Failed: argument at index ${f} is undefined or null`);l.push(m)}return l}e.assertAllDefined=v;const w=Object.prototype.hasOwnProperty;function _(o){if(!C(o))return!1;for(let l in o)if(w.call(o,l))return!1;return!0}e.isEmptyObject=_;function R(o){return typeof o=="function"}e.isFunction=R;function p(...o){return o.length>0&&o.every(R)}e.areFunctions=p;function h(o,l){const f=Math.min(o.length,l.length);for(let m=0;m<f;m++)s(o[m],l[m])}e.validateConstraints=h;function s(o,l){if(t(l)){if(typeof o!==l)throw new Error(`argument does not match constraint: typeof ${l}`)}else if(R(l)){try{if(o instanceof l)return}catch{}if(!y(o)&&o.constructor===l||l.length===1&&l.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=s;function u(o){let l=[],f=Object.getPrototypeOf(o);for(;Object.prototype!==f;)l=l.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return l}e.getAllPropertyNames=u;function r(o){const l=[];for(const f of u(o))typeof o[f]=="function"&&l.push(f);return l}e.getAllMethodNames=r;function S(o,l){const f=b=>function(){const A=Array.prototype.slice.call(arguments,0);return l(b,A)};let m={};for(const b of o)m[b]=f(b);return m}e.createProxyObject=S;function a(o){return o===null?void 0:o}e.withNullAsUndefined=a;function i(o){return typeof o=="undefined"?null:o}e.withUndefinedAsNull=i;function n(o,l="Unreachable"){throw new Error(l)}e.assertNever=n}),define(pe[28],ve([0,1,9,11,8,18]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(n){return n===47||n===92}e.isPathSeparator=T;function k(n){return n.replace(/[\\/]/g,d.posix.sep)}e.toSlashes=k;function D(n){return n.indexOf("/")===-1&&(n=k(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=D;function P(n,o=d.posix.sep){if(!n)return"";const l=n.length,f=n.charCodeAt(0);if(T(f)){if(T(n.charCodeAt(1))&&!T(n.charCodeAt(2))){let b=3;const A=b;for(;b<l&&!T(n.charCodeAt(b));b++);if(A!==b&&!T(n.charCodeAt(b+1))){for(b+=1;b<l;b++)if(T(n.charCodeAt(b)))return n.slice(0,b+1).replace(/[\\/]/g,o)}}return o}else if(R(f)&&n.charCodeAt(1)===58)return T(n.charCodeAt(2))?n.slice(0,2)+o:n.slice(0,2);let m=n.indexOf("://");if(m!==-1){for(m+=3;m<l;m++)if(T(n.charCodeAt(m)))return n.slice(0,m+1)}return""}e.getRoot=P;function F(n){if(!t.isWindows||!n||n.length<5)return!1;let o=n.charCodeAt(0);if(o!==92||(o=n.charCodeAt(1),o!==92))return!1;let l=2;const f=l;for(;l<n.length&&(o=n.charCodeAt(l),o!==92);l++);return!(f===l||(o=n.charCodeAt(l+1),isNaN(o)||o===92))}e.isUNC=F;const y=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(n,o=t.isWindows){const l=o?y:c;return!(!n||n.length===0||/^\s+$/.test(n)||(l.lastIndex=0,l.test(n))||o&&E.test(n)||n==="."||n===".."||o&&n[n.length-1]==="."||o&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=v;function w(n,o,l){const f=n===o;return!l||f?f:!n||!o?!1:(0,I.equalsIgnoreCase)(n,o)}e.isEqual=w;function _(n,o,l,f=d.sep){if(n===o)return!0;if(!n||!o||o.length>n.length)return!1;if(l){if(!(0,I.startsWithIgnoreCase)(n,o))return!1;if(o.length===n.length)return!0;let b=o.length;return o.charAt(o.length-1)===f&&b--,n.charAt(b)===f}return o.charAt(o.length-1)!==f&&(o+=f),n.indexOf(o)===0}e.isEqualOrParent=_;function R(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=R;function p(n,o){return t.isWindows&&n.endsWith(":")&&(n+=d.sep),(0,d.isAbsolute)(n)||(n=(0,d.join)(o,n)),n=(0,d.normalize)(n),t.isWindows?(n=(0,I.rtrim)(n,d.sep),n.endsWith(":")&&(n+=d.sep)):(n=(0,I.rtrim)(n,d.sep),n||(n=d.sep)),n}e.sanitizeFilePath=p;function h(n){const o=(0,d.normalize)(n);return t.isWindows?n.length>3?!1:s(o)&&(n.length===2||o.charCodeAt(2)===92):o===d.posix.sep}e.isRootOrDriveLetter=h;function s(n,o){return(o!==void 0?o:t.isWindows)?R(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=s;function u(n){return s(n)?n[0]:void 0}e.getDriveLetter=u;function r(n,o,l){return o.length>n.length?-1:n===o?0:(l&&(n=n.toLowerCase(),o=o.toLowerCase()),n.indexOf(o))}e.indexOfPath=r;function S(n){const o=n.split(":");let l,f,m;for(const b of o){const A=Number(b);(0,C.isNumber)(A)?f===void 0?f=A:m===void 0&&(m=A):l=l?[l,b].join(":"):b}if(!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:f!==void 0?f:void 0,column:m!==void 0?m:f!==void 0?1:void 0}}e.parseLineAndColumnAware=S;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(n,o,l=8){let f="";for(let b=0;b<l;b++)f+=a.charAt(Math.floor(Math.random()*a.length));let m;return o?m=`${o}-${f}`:m=f,n?(0,d.join)(n,m):m}e.randomPath=i}),define(pe[25],ve([0,1,18]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const _=Array.isArray(w)?[]:{};return Object.keys(w).forEach(R=>{w[R]&&typeof w[R]=="object"?_[R]=t(w[R]):_[R]=w[R]}),_}e.deepClone=t;function I(w){if(!w||typeof w!="object")return w;const _=[w];for(;_.length>0;){const R=_.shift();Object.freeze(R);for(const p in R)if(C.call(R,p)){const h=R[p];typeof h=="object"&&!Object.isFrozen(h)&&_.push(h)}}return w}e.deepFreeze=I;const C=Object.prototype.hasOwnProperty;function T(w,_){return k(w,_,new Set)}e.cloneAndChange=T;function k(w,_,R){if((0,d.isUndefinedOrNull)(w))return w;const p=_(w);if(typeof p!="undefined")return p;if((0,d.isArray)(w)){const h=[];for(const s of w)h.push(k(s,_,R));return h}if((0,d.isObject)(w)){if(R.has(w))throw new Error("Cannot clone recursive data-structure");R.add(w);const h={};for(let s in w)C.call(w,s)&&(h[s]=k(w[s],_,R));return R.delete(w),h}return w}function D(w,_,R=!0){return(0,d.isObject)(w)?((0,d.isObject)(_)&&Object.keys(_).forEach(p=>{p in w?R&&((0,d.isObject)(w[p])&&(0,d.isObject)(_[p])?D(w[p],_[p],R):w[p]=_[p]):w[p]=_[p]}),w):_}e.mixin=D;function P(w,_){if(w===_)return!0;if(w==null||_===null||_===void 0||typeof w!=typeof _||typeof w!="object"||Array.isArray(w)!==Array.isArray(_))return!1;let R,p;if(Array.isArray(w)){if(w.length!==_.length)return!1;for(R=0;R<w.length;R++)if(!P(w[R],_[R]))return!1}else{const h=[];for(p in w)h.push(p);h.sort();const s=[];for(p in _)s.push(p);if(s.sort(),!P(h,s))return!1;for(R=0;R<h.length;R++)if(!P(w[h[R]],_[h[R]]))return!1}return!0}e.equals=P;function F(w){const _=new Set;return JSON.stringify(w,(R,p)=>{if((0,d.isObject)(p)||Array.isArray(p)){if(_.has(p))return"[Circular]";_.add(p)}return p})}e.safeStringify=F;function y(w,_,R){const p=_(w);return typeof p=="undefined"?R:p}e.getOrDefault=y;function c(w,_){const R=Object.create(null);return!w||!_||Object.keys(_).forEach(h=>{const s=w[h],u=_[h];P(s,u)||(R[h]=u)}),R}e.distinct=c;function E(w,_){const R=_.toLowerCase(),p=Object.keys(w).find(h=>h.toLowerCase()===R);return p?w[p]:w[_]}e.getCaseInsensitive=E;function v(w,_){const R=Object.create(null);for(const[p,h]of Object.entries(w))_(p,h)&&(R[p]=h);return R}e.filter=v}),define(pe[101],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var d;(function(C){C[C.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",C[C.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",C[C.MAX_UINT_8=255]="MAX_UINT_8",C[C.MAX_UINT_16=65535]="MAX_UINT_16",C[C.MAX_UINT_32=4294967295]="MAX_UINT_32",C[C.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(d=e.Constants||(e.Constants={}));function t(C){return C<0?0:C>255?255:C|0}e.toUint8=t;function I(C){return C<0?0:C>4294967295?4294967295:C|0}e.toUint32=I}),define(pe[2],ve([0,1,9,11]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const I=/^\w[\w\d+.-]*$/,C=/^\//,T=/^\/\//;function k(a,i){if(!a.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${a.authority}", path: "${a.path}", query: "${a.query}", fragment: "${a.fragment}"}`);if(a.scheme&&!I.test(a.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(a.path){if(a.authority){if(!C.test(a.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(a.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(a,i){return!a&&!i?"file":a}function P(a,i){switch(a){case"https":case"http":case"file":i?i[0]!==y&&(i=y+i):i=y;break}return i}const F="",y="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class E{constructor(i,n,o,l,f,m=!1){typeof i=="object"?(this.scheme=i.scheme||F,this.authority=i.authority||F,this.path=i.path||F,this.query=i.query||F,this.fragment=i.fragment||F):(this.scheme=D(i,m),this.authority=n||F,this.path=P(this.scheme,o||F),this.query=l||F,this.fragment=f||F,k(this,m))}static isUri(i){return i instanceof E?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return h(this,!1)}with(i){if(!i)return this;let{scheme:n,authority:o,path:l,query:f,fragment:m}=i;return n===void 0?n=this.scheme:n===null&&(n=F),o===void 0?o=this.authority:o===null&&(o=F),l===void 0?l=this.path:l===null&&(l=F),f===void 0?f=this.query:f===null&&(f=F),m===void 0?m=this.fragment:m===null&&(m=F),n===this.scheme&&o===this.authority&&l===this.path&&f===this.query&&m===this.fragment?this:new w(n,o,l,f,m)}static parse(i,n=!1){const o=c.exec(i);return o?new w(o[2]||F,S(o[4]||F),S(o[5]||F),S(o[7]||F),S(o[9]||F),n):new w(F,F,F,F,F)}static file(i){let n=F;if(t.isWindows&&(i=i.replace(/\\/g,y)),i[0]===y&&i[1]===y){const o=i.indexOf(y,2);o===-1?(n=i.substring(2),i=y):(n=i.substring(2,o),i=i.substring(o)||y)}return new w("file",n,i,F,F)}static from(i){const n=new w(i.scheme,i.authority,i.path,i.query,i.fragment);return k(n,!0),n}static joinPath(i,...n){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return t.isWindows&&i.scheme==="file"?o=E.file(d.win32.join(h(i,!0),...n)).path:o=d.posix.join(i.path,...n),i.with({path:o})}toString(i=!1){return s(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof E)return i;{const n=new w(i);return n._formatted=i.external,n._fsPath=i._sep===v?i.fsPath:null,n}}else return i}}e.URI=E;const v=t.isWindows?1:void 0;class w extends E{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(i=!1){return i?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=v),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const _={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function R(a,i){let n,o=-1;for(let l=0;l<a.length;l++){const f=a.charCodeAt(l);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||i&&f===47)o!==-1&&(n+=encodeURIComponent(a.substring(o,l)),o=-1),n!==void 0&&(n+=a.charAt(l));else{n===void 0&&(n=a.substr(0,l));const m=_[f];m!==void 0?(o!==-1&&(n+=encodeURIComponent(a.substring(o,l)),o=-1),n+=m):o===-1&&(o=l)}}return o!==-1&&(n+=encodeURIComponent(a.substring(o))),n!==void 0?n:a}function p(a){let i;for(let n=0;n<a.length;n++){const o=a.charCodeAt(n);o===35||o===63?(i===void 0&&(i=a.substr(0,n)),i+=_[o]):i!==void 0&&(i+=a[n])}return i!==void 0?i:a}function h(a,i){let n;return a.authority&&a.path.length>1&&a.scheme==="file"?n=`//${a.authority}${a.path}`:a.path.charCodeAt(0)===47&&(a.path.charCodeAt(1)>=65&&a.path.charCodeAt(1)<=90||a.path.charCodeAt(1)>=97&&a.path.charCodeAt(1)<=122)&&a.path.charCodeAt(2)===58?i?n=a.path.substr(1):n=a.path[1].toLowerCase()+a.path.substr(2):n=a.path,t.isWindows&&(n=n.replace(/\//g,"\\")),n}e.uriToFsPath=h;function s(a,i){const n=i?p:R;let o="",{scheme:l,authority:f,path:m,query:b,fragment:A}=a;if(l&&(o+=l,o+=":"),(f||l==="file")&&(o+=y,o+=y),f){let L=f.indexOf("@");if(L!==-1){const N=f.substr(0,L);f=f.substr(L+1),L=N.indexOf(":"),L===-1?o+=n(N,!1):(o+=n(N.substr(0,L),!1),o+=":",o+=n(N.substr(L+1),!1)),o+="@"}f=f.toLowerCase(),L=f.indexOf(":"),L===-1?o+=n(f,!1):(o+=n(f.substr(0,L),!1),o+=f.substr(L))}if(m){if(m.length>=3&&m.charCodeAt(0)===47&&m.charCodeAt(2)===58){const L=m.charCodeAt(1);L>=65&&L<=90&&(m=`/${String.fromCharCode(L+32)}:${m.substr(3)}`)}else if(m.length>=2&&m.charCodeAt(1)===58){const L=m.charCodeAt(0);L>=65&&L<=90&&(m=`${String.fromCharCode(L+32)}:${m.substr(2)}`)}o+=n(m,!0)}return b&&(o+="?",o+=n(b,!1)),A&&(o+="#",o+=i?A:R(A,!1)),o}function u(a){try{return decodeURIComponent(a)}catch{return a.length>3?a.substr(0,3)+u(a.substr(3)):a}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function S(a){return a.match(r)?a.replace(r,i=>u(i)):a}}),define(pe[59],ve([0,1,23,8,2]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function C(F){return JSON.stringify(F,D)}e.stringify=C;function T(F){let y=JSON.parse(F);return y=P(y),y}e.parse=T;var k;(function(F){F[F.Uri=1]="Uri",F[F.Regexp=2]="Regexp",F[F.ScmResource=3]="ScmResource",F[F.ScmResourceGroup=4]="ScmResourceGroup",F[F.ScmProvider=5]="ScmProvider",F[F.CommentController=6]="CommentController",F[F.CommentThread=7]="CommentThread",F[F.CommentThreadReply=8]="CommentThreadReply",F[F.CommentNode=9]="CommentNode",F[F.CommentThreadNode=10]="CommentThreadNode",F[F.TimelineActionContext=11]="TimelineActionContext",F[F.NotebookCellActionContext=12]="NotebookCellActionContext",F[F.TestItemContext=13]="TestItemContext",F[F.Date=14]="Date"})(k=e.MarshalledId||(e.MarshalledId={}));function D(F,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:(0,t.regExpFlags)(y)}:y}function P(F,y=0){if(!F||y>200)return F;if(typeof F=="object"){switch(F.$mid){case 1:return I.URI.revive(F);case 2:return new RegExp(F.source,F.flags);case 14:return new Date(F.source)}if(F instanceof d.VSBuffer||F instanceof Uint8Array)return F;if(Array.isArray(F))for(let c=0;c<F.length;++c)F[c]=P(F[c],y+1);else for(const c in F)Object.hasOwnProperty.call(F,c)&&(F[c]=P(F[c],y+1))}return F}e.revive=P}),define(pe[10],ve([0,1,11,2]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var I;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp",k.vsls="vsls"})(I=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,P,F){this._hosts[D]=P,this._ports[D]=F}setConnectionToken(D,P){this._connectionTokens[D]=P}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(D){if(this._delegate)return this._delegate(D);const P=D.authority;let F=this._hosts[P];F&&F.indexOf(":")!==-1&&(F=`[${F}]`);const y=this._ports[P],c=this._connectionTokens[P];let E=`path=${encodeURIComponent(D.path)}`;return typeof c=="string"&&(E+=`&${e.connectionTokenQueryName}=${encodeURIComponent(c)}`),t.URI.from({scheme:d.isWeb?this._preferredWebSchema:I.vscodeRemoteResource,authority:`${F}:${y}`,path:"/vscode-remote-resource",query:E})}}e.RemoteAuthorities=new C;class T{asBrowserUri(D,P){const F=this.toUri(D,P);return F.scheme===I.vscodeRemote?e.RemoteAuthorities.rewrite(F):F.scheme===I.file&&(d.isNative||typeof d.globals.importScripts=="function"&&d.globals.origin===`${I.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?F.with({scheme:I.vscodeFileResource,authority:F.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):F}asFileUri(D,P){const F=this.toUri(D,P);return F.scheme===I.vscodeFileResource?F.with({scheme:I.file,authority:F.authority!==T.FALLBACK_AUTHORITY?F.authority:null,query:null,fragment:null}):F}toUri(D,P){return t.URI.isUri(D)?D:t.URI.parse(P.toUrl(D))}}T.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new T}),define(pe[22],ve([0,1,28,10,9,11,8,2]),function(ee,e,d,t,I,C,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(E){return(0,k.uriToFsPath)(E,!0)}e.originalFSPath=D;class P{constructor(v){this._ignorePathCasing=v}compare(v,w,_=!1){return v===w?0:(0,T.compare)(this.getComparisonKey(v,_),this.getComparisonKey(w,_))}isEqual(v,w,_=!1){return v===w?!0:!v||!w?!1:this.getComparisonKey(v,_)===this.getComparisonKey(w,_)}getComparisonKey(v,w=!1){return v.with({path:this._ignorePathCasing(v)?v.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(v){return this._ignorePathCasing(v)}isEqualOrParent(v,w,_=!1){if(v.scheme===w.scheme){if(v.scheme===t.Schemas.file)return d.isEqualOrParent(D(v),D(w),this._ignorePathCasing(v))&&v.query===w.query&&(_||v.fragment===w.fragment);if((0,e.isEqualAuthority)(v.authority,w.authority))return d.isEqualOrParent(v.path,w.path,this._ignorePathCasing(v),"/")&&v.query===w.query&&(_||v.fragment===w.fragment)}return!1}joinPath(v,...w){return k.URI.joinPath(v,...w)}basenameOrAuthority(v){return(0,e.basename)(v)||v.authority}basename(v){return I.posix.basename(v.path)}extname(v){return I.posix.extname(v.path)}dirname(v){if(v.path.length===0)return v;let w;return v.scheme===t.Schemas.file?w=k.URI.file(I.dirname(D(v))).path:(w=I.posix.dirname(v.path),v.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),w="/")),v.with({path:w})}normalizePath(v){if(!v.path.length)return v;let w;return v.scheme===t.Schemas.file?w=k.URI.file(I.normalize(D(v))).path:w=I.posix.normalize(v.path),v.with({path:w})}relativePath(v,w){if(v.scheme!==w.scheme||!(0,e.isEqualAuthority)(v.authority,w.authority))return;if(v.scheme===t.Schemas.file){const p=I.relative(D(v),D(w));return C.isWindows?d.toSlashes(p):p}let _=v.path||"/",R=w.path||"/";if(this._ignorePathCasing(v)){let p=0;for(const h=Math.min(_.length,R.length);p<h&&!(_.charCodeAt(p)!==R.charCodeAt(p)&&_.charAt(p).toLowerCase()!==R.charAt(p).toLowerCase());p++);_=R.substr(0,p)+_.substr(p)}return I.posix.relative(_,R)}resolvePath(v,w){if(v.scheme===t.Schemas.file){const _=k.URI.file(I.resolve(D(v),w));return v.with({authority:_.authority,path:_.path})}return w=d.toPosixPath(w),v.with({path:I.posix.resolve(v.path,w)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,w){return v===w||v!==void 0&&w!==void 0&&(0,T.equalsIgnoreCase)(v,w)}hasTrailingPathSeparator(v,w=I.sep){if(v.scheme===t.Schemas.file){const _=D(v);return _.length>d.getRoot(_).length&&_[_.length-1]===w}else{const _=v.path;return _.length>1&&_.charCodeAt(_.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,w=I.sep){return(0,e.hasTrailingPathSeparator)(v,w)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,w=I.sep){let _=!1;if(v.scheme===t.Schemas.file){const R=D(v);_=R!==void 0&&R.length===d.getRoot(R).length&&R[R.length-1]===w}else{w="/";const R=v.path;_=R.length===1&&R.charCodeAt(R.length-1)===47}return!_&&!(0,e.hasTrailingPathSeparator)(v,w)?v.with({path:v.path+"/"}):v}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(E=>E.scheme===t.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new P(E=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function F(E,v){const w=[];for(let _=0;_<E.length;_++){const R=v(E[_]);E.some((p,h)=>h===_?!1:(0,e.isEqualOrParent)(R,v(p)))||w.push(E[_])}return w}e.distinctParents=F;var y;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function v(w){const _=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(h=>{const[s,u]=h.split(":");s&&u&&_.set(s,u)});const p=w.path.substring(0,w.path.indexOf(";"));return p&&_.set(E.META_DATA_MIME,p),_}E.parseMetaData=v})(y=e.DataUri||(e.DataUri={}));function c(E,v,w){if(v){let _=E.path;return _&&_[0]!==I.posix.sep&&(_=I.posix.sep+_),E.with({scheme:w,authority:v,path:_})}return E.with({scheme:w})}e.toLocalResource=c}),define(pe[13],ve([0,1,21,16,3,6,22,11]),function(ee,e,d,t,I,C,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(te){return!!te&&typeof te.then=="function"}e.isThenable=D;function P(te){const J=new d.CancellationTokenSource,ae=te(J.token),he=new Promise((we,Ie)=>{const Ne=J.token.onCancellationRequested(()=>{Ne.dispose(),J.dispose(),Ie(new t.CancellationError)});Promise.resolve(ae).then(Ee=>{Ne.dispose(),J.dispose(),we(Ee)},Ee=>{Ne.dispose(),J.dispose(),Ie(Ee)})});return new class{cancel(){J.cancel()}then(we,Ie){return he.then(we,Ie)}catch(we){return this.then(void 0,we)}finally(we){return he.finally(we)}}}e.createCancelablePromise=P;function F(te,J,ae){return new Promise((he,we)=>{const Ie=J.onCancellationRequested(()=>{Ie.dispose(),he(ae)});te.then(he,we).finally(()=>Ie.dispose())})}e.raceCancellation=F;function y(te,J){return new Promise((ae,he)=>{const we=J.onCancellationRequested(()=>{we.dispose(),he(new t.CancellationError)});te.then(ae,he).finally(()=>we.dispose())})}e.raceCancellationError=y;async function c(te){let J=-1;const ae=te.map((we,Ie)=>we.then(Ne=>(J=Ie,Ne))),he=await Promise.race(ae);return te.forEach((we,Ie)=>{Ie!==J&&we.cancel()}),he}e.raceCancellablePromises=c;function E(te,J,ae){let he;const we=setTimeout(()=>{he?.(void 0),ae?.()},J);return Promise.race([te.finally(()=>clearTimeout(we)),new Promise(Ie=>he=Ie)])}e.raceTimeout=E;function v(te){return new Promise((J,ae)=>{const he=te();D(he)?he.then(J,ae):J(he)})}e.asPromise=v;class w{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(J){if(this.activePromise){if(this.queuedPromiseFactory=J,!this.queuedPromise){const ae=()=>{this.queuedPromise=null;const he=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,he};this.queuedPromise=new Promise(he=>{this.activePromise.then(ae,ae).then(he)})}return new Promise((ae,he)=>{this.queuedPromise.then(ae,he)})}return this.activePromise=J(),new Promise((ae,he)=>{this.activePromise.then(we=>{this.activePromise=null,ae(we)},we=>{this.activePromise=null,he(we)})})}}e.Throttler=w;class _{constructor(){this.current=Promise.resolve(null)}queue(J){return this.current=this.current.then(()=>J(),()=>J())}}e.Sequencer=_;class R{constructor(){this.promiseMap=new Map}queue(J,ae){const we=(this.promiseMap.get(J)??Promise.resolve()).catch(()=>{}).then(ae).finally(()=>{this.promiseMap.get(J)===we&&this.promiseMap.delete(J)});return this.promiseMap.set(J,we),we}}e.SequencerByKey=R;const p=(te,J)=>{let ae=!0;const he=setTimeout(()=>{ae=!1,J()},te);return{isTriggered:()=>ae,dispose:()=>{clearTimeout(he),ae=!1}}},h=te=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,te())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class s{constructor(J){this.defaultDelay=J,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(J,ae=this.defaultDelay){this.task=J,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((we,Ie)=>{this.doResolve=we,this.doReject=Ie}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const we=this.task;return this.task=null,we()}}));const he=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ae===e.MicrotaskDelay?h(he):p(ae,he),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=s;class u{constructor(J){this.delayer=new s(J),this.throttler=new w}trigger(J,ae){return this.delayer.trigger(()=>this.throttler.queue(J),ae)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=u;class r{constructor(){this._isOpen=!1,this._promise=new Promise((J,ae)=>{this._completePromise=J})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=r;class S extends r{constructor(J){super();this._timeout=setTimeout(()=>this.open(),J)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=S;function a(te,J){return J?new Promise((ae,he)=>{const we=setTimeout(()=>{Ie.dispose(),ae()},te),Ie=J.onCancellationRequested(()=>{clearTimeout(we),Ie.dispose(),he(new t.CancellationError)})}):P(ae=>a(te,ae))}e.timeout=a;function i(te,J=0){const ae=setTimeout(te,J);return(0,C.toDisposable)(()=>clearTimeout(ae))}e.disposableTimeout=i;function n(te){const J=[];let ae=0;const he=te.length;function we(){return ae<he?te[ae++]():null}function Ie(Ne){Ne!=null&&J.push(Ne);const Ee=we();return Ee?Ee.then(Ie):Promise.resolve(J)}return Promise.resolve(null).then(Ie)}e.sequence=n;function o(te,J=he=>!!he,ae=null){let he=0;const we=te.length,Ie=()=>{if(he>=we)return Promise.resolve(ae);const Ne=te[he++];return Promise.resolve(Ne()).then(be=>J(be)?Promise.resolve(be):Ie())};return Ie()}e.first=o;function l(te,J=he=>!!he,ae=null){if(te.length===0)return Promise.resolve(ae);let he=te.length;const we=()=>{he=-1;for(const Ie of te)Ie.cancel?.()};return new Promise((Ie,Ne)=>{for(const Ee of te)Ee.then(be=>{--he>=0&&J(be)?(we(),Ie(be)):he===0&&Ie(ae)}).catch(be=>{--he>=0&&(we(),Ne(be))})})}e.firstParallel=l;class f{constructor(J){this._size=0,this.maxDegreeOfParalellism=J,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new I.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(J){return this._size++,new Promise((ae,he)=>{this.outstandingPromises.push({factory:J,c:ae,e:he}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const J=this.outstandingPromises.shift();this.runningPromises++;const ae=J.factory();ae.then(J.c,J.e),ae.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=f;class m extends f{constructor(){super(1)}}e.Queue=m;class b{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const J=new z;return this.drainers.add(J),J.p}isDrained(){for(const[,J]of this.queues)if(J.size>0)return!1;return!0}queueFor(J,ae=T.extUri){const he=ae.getComparisonKey(J);let we=this.queues.get(he);return we||(we=new m,I.Event.once(we.onFinished)(()=>{we?.dispose(),this.queues.delete(he),this.onDidQueueFinish()}),this.queues.set(he,we)),we}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const J of this.drainers)J.complete();this.drainers.clear()}dispose(){for(const[,J]of this.queues)J.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=b;class A{constructor(J,ae){this._token=-1,typeof J=="function"&&typeof ae=="number"&&this.setIfNotSet(J,ae)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(J,ae){this.cancel(),this._token=setTimeout(()=>{this._token=-1,J()},ae)}setIfNotSet(J,ae){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,J()},ae))}}e.TimeoutTimer=A;class L{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(J,ae){this.cancel(),this._token=setInterval(()=>{J()},ae)}}e.IntervalTimer=L;class N{constructor(J,ae){this.timeoutToken=-1,this.runner=J,this.timeout=ae,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(J=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,J)}get delay(){return this.timeout}set delay(J){this.timeout=J}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=N;class g{constructor(J,ae){ae%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ae}ms is not a multiple of 1000ms.`),this.runner=J,this.timeout=ae,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(J=this.timeout){J%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(J/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=g;class M extends N{constructor(J,ae){super(J,ae);this.units=[]}work(J){this.units.push(J),this.isScheduled()||this.schedule()}doRun(){const J=this.units;this.units=[],this.runner&&this.runner(J)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=M;class U extends C.Disposable{constructor(J,ae){super();this.options=J,this.handler=ae,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(J){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+J.length>this.options.maxBufferedWork)return!1}else if(this.pending+J.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...J),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new N(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=te=>{(0,k.setTimeout0)(()=>{if(J)return;const ae=Date.now()+15;te(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ae-Date.now())}}))});let J=!1;return{dispose(){J||(J=!0)}}}:e.runWhenIdle=(te,J)=>{const ae=requestIdleCallback(te,typeof J=="number"?{timeout:J}:void 0);let he=!1;return{dispose(){he||(he=!0,cancelIdleCallback(ae))}}}}();class j{constructor(J){this._didRun=!1,this._executor=()=>{try{this._value=J()}catch(ae){this._error=ae}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=j;async function K(te,J,ae){let he;for(let we=0;we<ae;we++)try{return await te()}catch(Ie){he=Ie,await a(J)}throw he}e.retry=K;class B{hasPending(J){return this._pending?typeof J=="number"?this._pending.taskId===J:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(J,ae,he){return this._pending={taskId:J,cancel:()=>he?.(),promise:ae},ae.then(()=>this.donePending(J),()=>this.donePending(J)),ae}donePending(J){this._pending&&J===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const J=this._next;this._next=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}setNext(J){if(this._next)this._next.run=J;else{let ae,he;const we=new Promise((Ie,Ne)=>{ae=Ie,he=Ne});this._next={run:J,promise:we,promiseResolve:ae,promiseReject:he}}return this._next.promise}}e.TaskSequentializer=B;class x{constructor(J,ae=()=>Date.now()){this.interval=J,this.nowFn=ae,this.lastIncrementTime=0,this.value=0}increment(){const J=this.nowFn();return J-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=J,this.value=0),this.value++,this.value}}e.IntervalCounter=x;class z{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((J,ae)=>{this.completeCallback=J,this.errorCallback=ae})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(J){return new Promise(ae=>{this.completeCallback(J),this.resolved=!0,ae()})}error(J){return new Promise(ae=>{this.errorCallback(J),this.rejected=!0,ae()})}cancel(){new Promise(J=>{this.errorCallback(new t.CancellationError),this.rejected=!0,J()})}}e.DeferredPromise=z;var G;(function(te){async function J(he){let we;const Ie=await Promise.all(he.map(Ne=>Ne.then(Ee=>Ee,Ee=>{we||(we=Ee)})));if(typeof we!="undefined")throw we;return Ie}te.settled=J;function ae(he){return new Promise(async(we,Ie)=>{try{await he(we,Ie)}catch(Ne){Ie(Ne)}})}te.withAsyncBody=ae})(G=e.Promises||(e.Promises={}));var q;(function(te){te[te.Initial=0]="Initial",te[te.DoneOK=1]="DoneOK",te[te.DoneError=2]="DoneError"})(q||(q={}));class Z{constructor(J){this._state=0,this._results=[],this._error=null,this._onStateChanged=new I.Emitter,queueMicrotask(async()=>{const ae={emitOne:he=>this.emitOne(he),emitMany:he=>this.emitMany(he),reject:he=>this.reject(he)};try{await Promise.resolve(J(ae)),this.resolve()}catch(he){this.reject(he)}finally{ae.emitOne=void 0,ae.emitMany=void 0,ae.reject=void 0}})}static fromArray(J){return new Z(ae=>{ae.emitMany(J)})}static fromPromise(J){return new Z(async ae=>{ae.emitMany(await J)})}static fromPromises(J){return new Z(async ae=>{await Promise.all(J.map(async he=>ae.emitOne(await he)))})}static merge(J){return new Z(async ae=>{await Promise.all(J.map(async he=>{for await(const we of he)ae.emitOne(we)}))})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(J<this._results.length)return{done:!1,value:this._results[J++]};if(this._state===1)return{done:!0,value:void 0};await I.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(J,ae){return new Z(async he=>{for await(const we of J)he.emitOne(ae(we))})}map(J){return Z.map(this,J)}static filter(J,ae){return new Z(async he=>{for await(const we of J)ae(we)&&he.emitOne(we)})}filter(J){return Z.filter(this,J)}static coalesce(J){return Z.filter(J,ae=>!!ae)}coalesce(){return Z.coalesce(this)}static async toPromise(J){const ae=[];for await(const he of J)ae.push(he);return ae}toPromise(){return Z.toPromise(this)}emitOne(J){this._state===0&&(this._results.push(J),this._onStateChanged.fire())}emitMany(J){this._state===0&&(this._results=this._results.concat(J),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(J){this._state===0&&(this._state=2,this._error=J,this._onStateChanged.fire())}}e.AsyncIterableObject=Z,Z.EMPTY=Z.fromArray([]);class se extends Z{constructor(J,ae){super(ae);this._source=J}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=se;function ue(te){const J=new d.CancellationTokenSource,ae=te(J.token);return new se(J,async he=>{const we=J.token.onCancellationRequested(()=>{we.dispose(),J.dispose(),he.reject(new t.CancellationError)});try{for await(const Ie of ae){if(J.token.isCancellationRequested)return;he.emitOne(Ie)}we.dispose(),J.dispose()}catch(Ie){we.dispose(),J.dispose(),he.reject(Ie)}})}e.createCancelableAsyncIterable=ue}),define(pe[102],ve([0,1,13,9]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const I=new d.IdleValue(()=>{const m=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:m,collatorIsNumeric:m.resolvedOptions().numeric}}),C=new d.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new d.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(m,b,A=!1){const L=m||"",N=b||"",g=I.value.collator.compare(L,N);return I.value.collatorIsNumeric&&g===0&&L!==N?L<N?-1:1:g}e.compareFileNames=k;function D(m,b){const A=C.value.collator;return m=m||"",b=b||"",u(A,m,b)}e.compareFileNamesDefault=D;function P(m,b){const A=C.value.collator;return m=m||"",b=b||"",i(m,b)||u(A,m,b)}e.compareFileNamesUpper=P;function F(m,b){const A=C.value.collator;return m=m||"",b=b||"",a(m,b)||u(A,m,b)}e.compareFileNamesLower=F;function y(m,b){return m=m||"",b=b||"",m===b?0:m<b?-1:1}e.compareFileNamesUnicode=y;function c(m,b,A=!1){A||(m=m&&m.toLowerCase(),b=b&&b.toLowerCase());const[L,N]=h(m),[g,M]=h(b);return L!==g?L<g?-1:1:N===M?0:N<M?-1:1}e.noIntlCompareFileNames=c;function E(m,b){const[A,L]=h(m),[N,g]=h(b);let M=I.value.collator.compare(L,g);if(M===0){if(I.value.collatorIsNumeric&&L!==g)return L<g?-1:1;if(M=I.value.collator.compare(A,N),I.value.collatorIsNumeric&&M===0&&A!==N)return A<N?-1:1}return M}e.compareFileExtensions=E;function v(m,b){m=m||"",b=b||"";const A=s(m),L=s(b),N=C.value.collator,g=T.value.collator;return u(g,A,L)||u(N,m,b)}e.compareFileExtensionsDefault=v;function w(m,b){m=m||"",b=b||"";const A=s(m),L=s(b),N=C.value.collator,g=T.value.collator;return u(g,A,L)||i(m,b)||u(N,m,b)}e.compareFileExtensionsUpper=w;function _(m,b){m=m||"",b=b||"";const A=s(m),L=s(b),N=C.value.collator,g=T.value.collator;return u(g,A,L)||a(m,b)||u(N,m,b)}e.compareFileExtensionsLower=_;function R(m,b){m=m||"",b=b||"";const A=s(m).toLowerCase(),L=s(b).toLowerCase();return A!==L?A<L?-1:1:m!==b?m<b?-1:1:0}e.compareFileExtensionsUnicode=R;const p=/^(.*?)(\.([^.]*))?$/;function h(m,b=!1){const A=m?p.exec(m):[];let L=[A&&A[1]||"",A&&A[3]||""];return b&&(!L[0]&&L[1]||L[0]&&L[0].charAt(0)===".")&&(L=[L[0]+"."+L[1],""]),L}function s(m){const b=m?p.exec(m):[];return b&&b[1]&&b[1].charAt(0)!=="."&&b[3]||""}function u(m,b,A){let L=m.compare(b,A);return L!==0?L:b.length!==A.length?b.length<A.length?-1:1:0}function r(m){const b=m.charAt(0);return b.toLocaleUpperCase()!==b}function S(m){const b=m.charAt(0);return b.toLocaleLowerCase()!==b}function a(m,b){return r(m)&&S(b)?-1:S(m)&&r(b)?1:0}function i(m,b){return S(m)&&r(b)?-1:r(m)&&S(b)?1:0}function n(m,b,A=!1){return A||(m=m&&m.toLowerCase(),b=b&&b.toLowerCase()),m===b?0:m<b?-1:1}function o(m,b,A=!1){const L=m.split(t.sep),N=b.split(t.sep),g=L.length-1,M=N.length-1;let U,j;for(let K=0;;K++){if(U=g===K,j=M===K,U&&j)return k(L[K],N[K],A);if(U)return-1;if(j)return 1;const B=n(L[K],N[K],A);if(B!==0)return B}}e.comparePaths=o;function l(m,b,A){const L=m.toLowerCase(),N=b.toLowerCase(),g=f(m,b,A);if(g)return g;const M=L.endsWith(A),U=N.endsWith(A);if(M!==U)return M?-1:1;const j=k(L,N);return j!==0?j:L.localeCompare(N)}e.compareAnything=l;function f(m,b,A){const L=m.toLowerCase(),N=b.toLowerCase(),g=L.startsWith(A),M=N.startsWith(A);if(g!==M)return g?-1:1;if(g&&M){if(L.length<N.length)return-1;if(L.length>N.length)return 1}return 0}e.compareByPrefix=f}),define(pe[103],ve([0,1,102,99,58,9,11,8]),function(ee,e,d,t,I,C,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const D=0,P=[D,[]];function F(B,x,z,G){if(!B||!x)return P;const q=B.length,Z=x.length;if(q<Z)return P;const se=B.toLowerCase();return y(x,z,Z,B,se,q,G)}e.scoreFuzzy=F;function y(B,x,z,G,q,Z,se){const ue=[],te=[];for(let we=0;we<z;we++){const Ie=we*Z,Ne=Ie-Z,Ee=we>0,be=B[we],H=x[we];for(let W=0;W<Z;W++){const O=W>0,$=Ie+W,Q=$-1,re=Ne+W-1,de=O?ue[Q]:0,ye=Ee&&O?ue[re]:0,Ae=Ee&&O?te[re]:0;let We;!ye&&Ee?We=0:We=c(be,H,G,q,W,Ae),We&&ye+We>=de&&(se||Ee||q.startsWith(x,W))?(te[$]=Ae+1,ue[$]=ye+We):(te[$]=D,ue[$]=de)}}const J=[];let ae=z-1,he=Z-1;for(;ae>=0&&he>=0;){const we=ae*Z+he;te[we]===D||(J.push(he),ae--),he--}return[ue[z*Z-1],J.reverse()]}function c(B,x,z,G,q,Z){let se=0;if(!E(x,G[q]))return se;if(se+=1,Z>0&&(se+=Z*5),B===z[q]&&(se+=1),q===0)se+=8;else{const ue=v(z.charCodeAt(q-1));ue?se+=ue:(0,t.isUpper)(z.charCodeAt(q))&&Z===0&&(se+=2)}return se}function E(B,x){return B===x?!0:B==="/"||B==="\\"?x==="/"||x==="\\":!1}function v(B){switch(B){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const w=[void 0,[]];function _(B,x,z=0,G=0){const q=x;return q.values&&q.values.length>1?R(B,q.values,z,G):p(B,x,z,G)}e.scoreFuzzy2=_;function R(B,x,z,G){let q=0;const Z=[];for(const se of x){const[ue,te]=p(B,se,z,G);if(typeof ue!="number")return w;q+=ue,Z.push(...te)}return[q,f(Z)]}function p(B,x,z,G){const q=(0,t.fuzzyScore)(x.original,x.originalLowercase,z,B,B.toLowerCase(),G,!0);return q?[q[0],(0,t.createMatches)(q)]:w}const h=Object.freeze({score:0}),s=1<<18,u=1<<17,r=1<<16;function S(B,x,z,G){const q=G.values?G.values:[G];return(0,I.hash)({[G.normalized]:{values:q.map(se=>({value:se.normalized,expectContiguousMatch:se.expectContiguousMatch})),label:B,description:x,allowNonContiguousMatches:z}})}function a(B,x,z,G,q){if(!B||!x.normalized)return h;const Z=G.getItemLabel(B);if(!Z)return h;const se=G.getItemDescription(B),ue=S(Z,se,z,x),te=q[ue];if(te)return te;const J=i(Z,se,G.getItemPath(B),x,z);return q[ue]=J,J}e.scoreItemFuzzy=a;function i(B,x,z,G,q){const Z=!z||!G.containsPathSeparator;return z&&(T.isLinux?G.pathNormalized===z:(0,k.equalsIgnoreCase)(G.pathNormalized,z))?{score:s,labelMatch:[{start:0,end:B.length}],descriptionMatch:x?[{start:0,end:x.length}]:void 0}:G.values&&G.values.length>1?n(B,x,z,G.values,Z,q):o(B,x,z,G,Z,q)}function n(B,x,z,G,q,Z){let se=0;const ue=[],te=[];for(const J of G){const{score:ae,labelMatch:he,descriptionMatch:we}=o(B,x,z,J,q,Z);if(ae===D)return h;se+=ae,he&&ue.push(...he),we&&te.push(...we)}return{score:se,labelMatch:f(ue),descriptionMatch:f(te)}}function o(B,x,z,G,q,Z){if(q||!x){const[se,ue]=F(B,G.normalized,G.normalizedLowercase,Z&&!G.expectContiguousMatch);if(se){const te=(0,t.matchesPrefix)(G.normalized,B);let J;return te?(J=u,J+=Math.round(G.normalized.length/B.length*100)):J=r,{score:J+se,labelMatch:te||l(ue)}}}if(x){let se=x;z&&(se=`${x}${C.sep}`);const ue=se.length,te=`${se}${B}`,[J,ae]=F(te,G.normalized,G.normalizedLowercase,Z&&!G.expectContiguousMatch);if(J){const he=l(ae),we=[],Ie=[];return he.forEach(Ne=>{Ne.start<ue&&Ne.end>ue?(we.push({start:0,end:Ne.end-ue}),Ie.push({start:Ne.start,end:ue})):Ne.start>=ue?we.push({start:Ne.start-ue,end:Ne.end-ue}):Ie.push(Ne)}),{score:J,labelMatch:we,descriptionMatch:Ie}}}return h}function l(B){const x=[];if(!B)return x;let z;for(const G of B)z&&z.end===G?z.end+=1:(z={start:G,end:G+1},x.push(z));return x}function f(B){const x=B.sort((q,Z)=>q.start-Z.start),z=[];let G;for(const q of x)!G||!m(G,q)?(G=q,z.push(q)):(G.start=Math.min(G.start,q.start),G.end=Math.max(G.end,q.end));return z}function m(B,x){return!(B.end<x.start||x.end<B.start)}function b(B,x,z,G,q,Z){const se=a(B,z,G,q,Z),ue=a(x,z,G,q,Z),te=se.score,J=ue.score;if((te===s||J===s)&&te!==J)return te===s?-1:1;if(te>r||J>r){if(te!==J)return te>J?-1:1;if(te<u&&J<u){const be=L(se.labelMatch,ue.labelMatch);if(be!==0)return be}const Ne=q.getItemLabel(B)||"",Ee=q.getItemLabel(x)||"";if(Ne.length!==Ee.length)return Ne.length-Ee.length}if(te!==J)return te>J?-1:1;const ae=Array.isArray(se.labelMatch)&&se.labelMatch.length>0,he=Array.isArray(ue.labelMatch)&&ue.labelMatch.length>0;if(ae&&!he)return-1;if(he&&!ae)return 1;const we=A(B,se,q),Ie=A(x,ue,q);return we&&Ie&&we!==Ie?Ie>we?-1:1:N(B,x,z,q)}e.compareItemsByFuzzyScore=b;function A(B,x,z){let G=-1,q=-1;if(x.descriptionMatch&&x.descriptionMatch.length?G=x.descriptionMatch[0].start:x.labelMatch&&x.labelMatch.length&&(G=x.labelMatch[0].start),x.labelMatch&&x.labelMatch.length){if(q=x.labelMatch[x.labelMatch.length-1].end,x.descriptionMatch&&x.descriptionMatch.length){const Z=z.getItemDescription(B);Z&&(q+=Z.length)}}else x.descriptionMatch&&x.descriptionMatch.length&&(q=x.descriptionMatch[x.descriptionMatch.length-1].end);return q-G}function L(B,x){if(!B&&!x||(!B||!B.length)&&(!x||!x.length))return 0;if(!x||!x.length)return-1;if(!B||!B.length)return 1;const z=B[0].start,q=B[B.length-1].end-z,Z=x[0].start,ue=x[x.length-1].end-Z;return q===ue?0:ue<q?1:-1}function N(B,x,z,G){const q=G.getItemLabel(B)||"",Z=G.getItemLabel(x)||"",se=G.getItemDescription(B),ue=G.getItemDescription(x),te=q.length+(se?se.length:0),J=Z.length+(ue?ue.length:0);if(te!==J)return te-J;const ae=G.getItemPath(B),he=G.getItemPath(x);return ae&&he&&ae.length!==he.length?ae.length-he.length:q!==Z?(0,d.compareAnything)(q,Z,z.normalized):se&&ue&&se!==ue?(0,d.compareAnything)(se,ue,z.normalized):ae&&he&&ae!==he?(0,d.compareAnything)(ae,he,z.normalized):0}function g(B){return B.startsWith('"')&&B.endsWith('"')}const M=" ";function U(B){typeof B!="string"&&(B="");const x=B.toLowerCase(),{pathNormalized:z,normalized:G,normalizedLowercase:q}=j(B),Z=z.indexOf(C.sep)>=0,se=g(B);let ue;const te=B.split(M);if(te.length>1)for(const J of te){const ae=g(J),{pathNormalized:he,normalized:we,normalizedLowercase:Ie}=j(J);we&&(ue||(ue=[]),ue.push({original:J,originalLowercase:J.toLowerCase(),pathNormalized:he,normalized:we,normalizedLowercase:Ie,expectContiguousMatch:ae}))}return{original:B,originalLowercase:x,pathNormalized:z,normalized:G,normalizedLowercase:q,values:ue,containsPathSeparator:Z,expectContiguousMatch:se}}e.prepareQuery=U;function j(B){let x;T.isWindows?x=B.replace(/\//g,C.sep):x=B.replace(/\\/g,C.sep);const z=(0,k.stripWildcards)(x).replace(/\s|"/g,"");return{pathNormalized:x,normalized:z,normalizedLowercase:z.toLowerCase()}}function K(B){return Array.isArray(B)?U(B.map(x=>x.original).join(M)):U(B.original)}e.pieceToQuery=K}),define(pe[32],ve([0,1,13,28,24,9,11,8]),function(ee,e,d,t,I,C,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const P="[/\\\\]",F="[^/\\\\]",y=/\//g;function c(z){switch(z){case 0:return"";case 1:return`${F}*?`;default:return`(?:${P}|${F}+${P}|${P}${F}+)*?`}}function E(z,G){if(!z)return[];const q=[];let Z=!1,se=!1,ue="";for(const te of z){switch(te){case G:if(!Z&&!se){q.push(ue),ue="";continue}break;case"{":Z=!0;break;case"}":Z=!1;break;case"[":se=!0;break;case"]":se=!1;break}ue+=te}return ue&&q.push(ue),q}e.splitGlobAware=E;function v(z){if(!z)return"";let G="";const q=E(z,e.GLOB_SPLIT);if(q.every(Z=>Z===e.GLOBSTAR))G=".*";else{let Z=!1;q.forEach((se,ue)=>{if(se===e.GLOBSTAR){Z||(G+=c(2),Z=!0);return}let te=!1,J="",ae=!1,he="";for(const we of se){if(we!=="}"&&te){J+=we;continue}if(ae&&(we!=="]"||!he)){let Ie;we==="-"?Ie=we:(we==="^"||we==="!")&&!he?Ie="^":we===e.GLOB_SPLIT?Ie="":Ie=(0,k.escapeRegExpCharacters)(we),he+=Ie;continue}switch(we){case"{":te=!0;continue;case"[":ae=!0;continue;case"}":{G+=`(?:${E(J,",").map(Ee=>v(Ee)).join("|")})`,te=!1,J="";break}case"]":G+="["+he+"]",ae=!1,he="";break;case"?":G+=F;continue;case"*":G+=c(1);continue;default:G+=(0,k.escapeRegExpCharacters)(we)}}ue<q.length-1&&(q[ue+1]!==e.GLOBSTAR||ue+2<q.length)&&(G+=P),Z=!1})}return G}const w=/^\*\*\/\*\.[\w\.-]+$/,_=/^\*\*\/([\w\.-]+)\/?$/,R=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,p=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,u=new I.LRUCache(1e4),r=function(){return!1},S=function(){return null};function a(z,G){if(!z)return S;let q;typeof z!="string"?q=z.pattern:q=z,q=q.trim();const Z=`${q}_${!!G.trimForExclusions}`;let se=u.get(Z);if(se)return i(se,z);let ue;if(w.test(q)){const te=q.substr(4);se=function(J,ae){return typeof J=="string"&&J.endsWith(te)?q:null}}else(ue=_.exec(n(q,G)))?se=o(ue[1],q):(G.trimForExclusions?p:R).test(q)?se=l(q,G):(ue=h.exec(n(q,G)))?se=f(ue[1].substr(1),q,!0):(ue=s.exec(n(q,G)))?se=f(ue[1],q,!1):se=m(q);return u.set(Z,se),i(se,z)}function i(z,G){return typeof G=="string"?z:function(q,Z){return(0,t.isEqualOrParent)(q,G.base,!T.isLinux)?z(q.substr(G.base.length+1),Z):null}}function n(z,G){return G.trimForExclusions&&z.endsWith("/**")?z.substr(0,z.length-2):z}function o(z,G){const q=`/${z}`,Z=`\\${z}`,se=function(te,J){return typeof te!="string"?null:J?J===z?G:null:te===z||te.endsWith(q)||te.endsWith(Z)?G:null},ue=[z];return se.basenames=ue,se.patterns=[G],se.allBasenames=ue,se}function l(z,G){const q=x(z.slice(1,-1).split(",").map(J=>a(J,G)).filter(J=>J!==S),z),Z=q.length;if(!Z)return S;if(Z===1)return q[0];const se=function(J,ae){for(let he=0,we=q.length;he<we;he++)if(q[he](J,ae))return z;return null},ue=q.find(J=>!!J.allBasenames);ue&&(se.allBasenames=ue.allBasenames);const te=q.reduce((J,ae)=>ae.allPaths?J.concat(ae.allPaths):J,[]);return te.length&&(se.allPaths=te),se}function f(z,G,q){const Z=C.sep===C.posix.sep,se=Z?z:z.replace(y,C.sep),ue=C.sep+se,te=C.posix.sep+z,J=q?function(ae,he){return typeof ae=="string"&&(ae===se||ae.endsWith(ue)||!Z&&(ae===z||ae.endsWith(te)))?G:null}:function(ae,he){return typeof ae=="string"&&(ae===se||!Z&&ae===z)?G:null};return J.allPaths=[(q?"*/":"./")+z],J}function m(z){try{const G=new RegExp(`^${v(z)}$`);return function(q){return G.lastIndex=0,typeof q=="string"&&G.test(q)?z:null}}catch{return S}}function b(z,G,q){return!z||typeof G!="string"?!1:A(z)(G,void 0,q)}e.match=b;function A(z,G={}){if(!z)return r;if(typeof z=="string"||M(z)){const q=a(z,G);if(q===S)return r;const Z=function(se,ue){return!!q(se,ue)};return q.allBasenames&&(Z.allBasenames=q.allBasenames),q.allPaths&&(Z.allPaths=q.allPaths),Z}return K(z,G)}e.parse=A;function L(z){if(!z)return;let G;return q=>(G||(G=(z()||Promise.resolve([])).then(Z=>Z?g(Z):{})),G.then(Z=>!!Z[q]))}e.hasSiblingPromiseFn=L;function N(z){if(!z)return;let G;return q=>{if(!G){const Z=z();G=Z?g(Z):{}}return!!G[q]}}e.hasSiblingFn=N;function g(z){const G={};for(const q of z)G[q]=!0;return G}function M(z){const G=z;return G?typeof G.base=="string"&&typeof G.pattern=="string":!1}e.isRelativePattern=M;function U(z){return z.allBasenames||[]}e.getBasenameTerms=U;function j(z){return z.allPaths||[]}e.getPathTerms=j;function K(z,G){const q=x(Object.getOwnPropertyNames(z).map(J=>B(J,z[J],G)).filter(J=>J!==S)),Z=q.length;if(!Z)return S;if(!q.some(J=>!!J.requiresSiblings)){if(Z===1)return q[0];const J=function(we,Ie){for(let Ne=0,Ee=q.length;Ne<Ee;Ne++){const be=q[Ne](we,Ie);if(be)return be}return null},ae=q.find(we=>!!we.allBasenames);ae&&(J.allBasenames=ae.allBasenames);const he=q.reduce((we,Ie)=>Ie.allPaths?we.concat(Ie.allPaths):we,[]);return he.length&&(J.allPaths=he),J}const se=function(J,ae,he){let we;for(let Ie=0,Ne=q.length;Ie<Ne;Ie++){const Ee=q[Ie];Ee.requiresSiblings&&he&&(ae||(ae=(0,C.basename)(J)),we||(we=ae.substr(0,ae.length-(0,C.extname)(J).length)));const be=Ee(J,ae,we,he);if(be)return be}return null},ue=q.find(J=>!!J.allBasenames);ue&&(se.allBasenames=ue.allBasenames);const te=q.reduce((J,ae)=>ae.allPaths?J.concat(ae.allPaths):J,[]);return te.length&&(se.allPaths=te),se}function B(z,G,q){if(G===!1)return S;const Z=a(z,q);if(Z===S)return S;if(typeof G=="boolean")return Z;if(G){const se=G.when;if(typeof se=="string"){const ue=(te,J,ae,he)=>{if(!he||!Z(te,J))return null;const we=se.replace("$(basename)",ae),Ie=he(we);return(0,d.isThenable)(Ie)?Ie.then(Ne=>Ne?z:null):Ie?z:null};return ue.requiresSiblings=!0,ue}}return Z}function x(z,G){const q=z.filter(J=>!!J.basenames);if(q.length<2)return z;const Z=q.reduce((J,ae)=>{const he=ae.basenames;return he?J.concat(he):J},[]);let se;if(G){se=[];for(let J=0,ae=Z.length;J<ae;J++)se.push(G)}else se=q.reduce((J,ae)=>{const he=ae.patterns;return he?J.concat(he):J},[]);const ue=function(J,ae){if(typeof J!="string")return null;if(!ae){let we;for(we=J.length;we>0;we--){const Ie=J.charCodeAt(we-1);if(Ie===47||Ie===92)break}ae=J.substr(we)}const he=Z.indexOf(ae);return he!==-1?se[he]:null};ue.basenames=Z,ue.patterns=se,ue.allBasenames=Z;const te=z.filter(J=>!J.basenames);return te.push(ue),te}}),define(pe[79],ve([0,1,28,10,9,11,22,8,2]),function(ee,e,d,t,I,C,T,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(i,n,o){if(typeof i=="string"&&(i=D.URI.file(i)),o){const f=o.getWorkspaceFolder(i);if(f){const m=o.getWorkspace().folders.length>1;let b;if((0,T.isEqual)(f.uri,i)?b="":b=(0,T.relativePath)(f.uri,i),m){const A=f.name?f.name:(0,T.basename)(f.uri);b=b?A+" \u2022 "+b:A}return b}}if(i.scheme!==t.Schemas.file&&i.scheme!==t.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,d.hasDriveLetter)(i.fsPath))return(0,I.normalize)(y(i.fsPath));let l=(0,I.normalize)(i.fsPath);return!C.isWindows&&n?.userHome&&(l=E(l,n.userHome.fsPath)),l}e.getPathLabel=P;function F(i){if(!i)return;typeof i=="string"&&(i=D.URI.file(i));const n=(0,T.basename)(i)||(i.scheme===t.Schemas.file?i.fsPath:i.path);return C.isWindows&&(0,d.isRootOrDriveLetter)(n)?y(n):n}e.getBaseLabel=F;function y(i,n){return(0,d.hasDriveLetter)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=y;let c=Object.create(null);function E(i,n){if(C.isWindows||!i||!n)return i;let o=c.original===n?c.normalized:void 0;return o||(o=`${(0,k.rtrim)(n,I.posix.sep)}${I.posix.sep}`,c={original:n,normalized:o}),(C.isLinux?i.startsWith(o):(0,k.startsWithIgnoreCase)(i,o))&&(i=`~/${i.substr(o.length)}`),i}e.tildify=E;function v(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=v;const w="\u2026",_="\\\\",R="~";function p(i,n=I.sep){const o=new Array(i.length);let l=!1;for(let f=0;f<i.length;f++){let m=i[f];if(m===""){o[f]=`.${n}`;continue}if(!m){o[f]=m;continue}l=!0;let b="";m.indexOf(_)===0?(b=m.substr(0,m.indexOf(_)+_.length),m=m.substr(m.indexOf(_)+_.length)):m.indexOf(n)===0?(b=m.substr(0,m.indexOf(n)+n.length),m=m.substr(m.indexOf(n)+n.length)):m.indexOf(R)===0&&(b=m.substr(0,m.indexOf(R)+R.length),m=m.substr(m.indexOf(R)+R.length));const A=m.split(n);for(let L=1;l&&L<=A.length;L++)for(let N=A.length-L;l&&N>=0;N--){l=!1;let g=A.slice(N,N+L).join(n);for(let M=0;!l&&M<i.length;M++)if(M!==f&&i[M]&&i[M].indexOf(g)>-1){const U=N+L===A.length,j=N>0&&i[M].indexOf(n)>-1?n+g:g,K=i[M].endsWith(j);l=!U||K}if(!l){let M="";(A[0].endsWith(":")||b!=="")&&(N===1&&(N=0,L++,g=A[0]+n+g),N>0&&(M=A[0]+n),M=b+M),N>0&&(M=M+w+n),M=M+g,N+L<A.length&&(M=M+n+w),o[f]=M}}l&&(o[f]=m)}return o}e.shorten=p;var h;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function s(i,n=Object.create(null)){const o=[];let l=!1,f="";for(const m of i)if(m==="$"||l&&m==="{")f&&o.push({value:f,type:h.TEXT}),f="",l=!0;else if(m==="}"&&l){const b=n[f];if(typeof b=="string")b.length&&o.push({value:b,type:h.VARIABLE});else if(b){const A=o[o.length-1];(!A||A.type!==h.SEPARATOR)&&o.push({value:b.label,type:h.SEPARATOR})}f="",l=!1}else f+=m;return f&&!l&&o.push({value:f,type:h.TEXT}),o.filter((m,b)=>{if(m.type===h.SEPARATOR){const A=o[b-1],L=o[b+1];return[A,L].every(N=>N&&(N.type===h.VARIABLE||N.type===h.TEXT)&&N.value.length>0)}return!0}).map(m=>m.value).join("")}e.template=s;function u(i,n){return C.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):i.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=u;function r(i,n){return C.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,""):C.isWindows?i.replace(/&&|&/g,o=>o==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=r;function S(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=S;function a(i){const n=i.indexOf("/")!==-1?I.posix:I.win32,o=n.basename(i),l=n.dirname(i);return o.length?{name:o,parentPath:l}:{name:l,parentPath:""}}e.splitName=a}),define(pe[104],ve([0,1,2]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(F){return F.toJSON()}class I{constructor(y){this._uriTransformer=y}transformIncoming(y){const c=this._uriTransformer.transformIncoming(y);return c===y?y:t(d.URI.from(c))}transformOutgoing(y){const c=this._uriTransformer.transformOutgoing(y);return c===y?y:t(d.URI.from(c))}transformOutgoingURI(y){const c=this._uriTransformer.transformOutgoing(y);return c===y?y:d.URI.from(c)}transformOutgoingScheme(y){return this._uriTransformer.transformOutgoingScheme(y)}}e.URITransformer=I,e.DefaultURITransformer=new class{transformIncoming(F){return F}transformOutgoing(F){return F}transformOutgoingURI(F){return F}transformOutgoingScheme(F){return F}};function C(F,y,c){if(!F||c>200)return null;if(typeof F=="object"){if(F instanceof d.URI)return y.transformOutgoing(F);for(let E in F)if(Object.hasOwnProperty.call(F,E)){const v=C(F[E],y,c+1);v!==null&&(F[E]=v)}}return null}function T(F,y){const c=C(F,y,0);return c===null?F:c}e.transformOutgoingURIs=T;function k(F,y,c,E){if(!F||E>200)return null;if(typeof F=="object"){if(F.$mid===1)return c?d.URI.revive(y.transformIncoming(F)):y.transformIncoming(F);for(let v in F)if(Object.hasOwnProperty.call(F,v)){const w=k(F[v],y,c,E+1);w!==null&&(F[v]=w)}}return null}function D(F,y){const c=k(F,y,!1,0);return c===null?F:c}e.transformIncomingURIs=D;function P(F,y){const c=k(F,y,!0,0);return c===null?F:c}e.transformAndReviveIncomingURIs=P}),define(pe[33],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const d=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(D){return d.test(D)}e.isUUID=t;const I=new Uint8Array(16),C=[];for(let D=0;D<256;D++)C.push(D.toString(16).padStart(2,"0"));let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(D){for(let P=0;P<D.length;P++)D[P]=Math.floor(Math.random()*256);return D};function k(){T(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let D=0,P="";return P+=C[I[D++]],P+=C[I[D++]],P+=C[I[D++]],P+=C[I[D++]],P+="-",P+=C[I[D++]],P+=C[I[D++]],P+="-",P+=C[I[D++]],P+=C[I[D++]],P+="-",P+=C[I[D++]],P+=C[I[D++]],P+="-",P+=C[I[D++]],P+=C[I[D++]],P+=C[I[D++]],P+=C[I[D++]],P+=C[I[D++]],P+=C[I[D++]],P}e.generateUuid=k}),define(pe[145],ve([0,1,105]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class t{constructor(C="utf8"){this.stringDecoder=new d.StringDecoder(C),this.remaining=null}write(C){const T=[],k=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(k.length<1)return T;let D=0,P,F=D;for(;F<k.length;)if(P=k.charCodeAt(F),P===13||P===10){if(T.push(k.substring(D,F)),F++,F<k.length){const y=P;P=k.charCodeAt(F),(y===13&&P===10||y===10&&P===13)&&F++}D=F}else F++;return this.remaining=D<k.length?k.substr(D):null,T}end(){return this.remaining}}e.LineDecoder=t}),define(pe[29],ve([0,1,60,61,294,13,28,78,9,11,22,2]),function(ee,e,d,t,I,C,T,k,D,P,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var c;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(c=e.RimRafMode||(e.RimRafMode={}));async function E(U,j=c.UNLINK){if((0,T.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return j===c.UNLINK?w(U):v(U)}async function v(U){try{const j=(0,T.randomPath)((0,t.tmpdir)());try{await d.promises.rename(U,j)}catch{return w(U)}w(j).catch(K=>{})}catch(j){if(j.code!=="ENOENT")throw j}}async function w(U){return e.Promises.rmdir(U,{recursive:!0,maxRetries:3})}function _(U){if((0,T.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");d.rmdirSync(U,{recursive:!0})}e.rimrafSync=_;async function R(U,j){return s(await(j?p(U):(0,I.promisify)(d.readdir)(U)))}async function p(U){try{return await(0,I.promisify)(d.readdir)(U,{withFileTypes:!0})}catch(B){console.warn("[node.js fs] readdir with filetypes failed with error: ",B)}const j=[],K=await R(U);for(const B of K){let x=!1,z=!1,G=!1;try{const q=await e.Promises.lstat((0,D.join)(U,B));x=q.isFile(),z=q.isDirectory(),G=q.isSymbolicLink()}catch(q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",q)}j.push({name:B,isFile:()=>x,isDirectory:()=>z,isSymbolicLink:()=>G})}return j}function h(U){return s(d.readdirSync(U))}e.readdirSync=h;function s(U){return U.map(j=>typeof j=="string"?P.isMacintosh?(0,k.normalizeNFC)(j):j:(j.name=P.isMacintosh?(0,k.normalizeNFC)(j.name):j.name,j))}async function u(U){const j=await R(U),K=[];for(const B of j)await S.existsDirectory((0,D.join)(U,B))&&K.push(B);return K}function r(U,j=1e3){return new Promise(K=>{let B=!1;const x=setInterval(()=>{B||(B=!0,d.access(U,z=>{B=!1,z&&(clearInterval(x),K(void 0))}))},j)})}e.whenDeleted=r;var S;(function(U){async function j(x){let z;try{if(z=await e.Promises.lstat(x),!z.isSymbolicLink())return{stat:z}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(G){if(G.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(P.isWindows&&G.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(q){if(q.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw q}throw G}}U.stat=j;async function K(x){try{const{stat:z,symbolicLink:G}=await U.stat(x);return z.isFile()&&G?.dangling!==!0}catch{}return!1}U.existsFile=K;async function B(x){try{const{stat:z,symbolicLink:G}=await U.stat(x);return z.isDirectory()&&G?.dangling!==!0}catch{}return!1}U.existsDirectory=B})(S=e.SymlinkSupport||(e.SymlinkSupport={}));const a=new C.ResourceQueue;function i(U,j,K){return a.queueFor(y.URI.file(U),F.extUriBiasedIgnorePathCase).queue(()=>{const B=f(K);return new Promise((x,z)=>o(U,j,B,G=>G?z(G):x()))})}let n=!0;function o(U,j,K,B){if(!n)return d.writeFile(U,j,{mode:K.mode,flag:K.flag},B);d.open(U,K.flag,K.mode,(x,z)=>{if(x)return B(x);d.writeFile(z,j,G=>{if(G)return d.close(z,()=>B(G));d.fdatasync(z,q=>(q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",q),n=!1),d.close(z,Z=>B(Z))))})})}function l(U,j,K){const B=f(K);if(!n)return d.writeFileSync(U,j,{mode:B.mode,flag:B.flag});const x=d.openSync(U,B.flag,B.mode);try{d.writeFileSync(x,j);try{d.fdatasyncSync(x)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),n=!1}}finally{d.closeSync(x)}}e.writeFileSync=l;function f(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function m(U,j){if(U===j)return;async function K(B){try{const x=await e.Promises.lstat(B);if(x.isDirectory()||x.isSymbolicLink())return;await e.Promises.utimes(B,x.atime,new Date)}catch{}}try{await e.Promises.rename(U,j),await K(j)}catch(B){if(U.toLowerCase()!==j.toLowerCase()&&B.code==="EXDEV"||U.endsWith("."))await b(U,j,{preserveSymlinks:!1}),await E(U,c.MOVE),await K(j);else throw B}}async function b(U,j,K){return L(U,j,{root:{source:U,target:j},options:K,handledSourcePaths:new Set})}const A=511;async function L(U,j,K){if(K.handledSourcePaths.has(U))return;K.handledSourcePaths.add(U);const{stat:B,symbolicLink:x}=await S.stat(U);if(x){if(K.options.preserveSymlinks)try{return await M(U,j,K)}catch(z){console.warn("[node.js fs] copy of symlink failed: ",z)}if(x.dangling)return}return B.isDirectory()?N(U,j,B.mode&A,K):g(U,j,B.mode&A)}async function N(U,j,K,B){await e.Promises.mkdir(j,{recursive:!0,mode:K});const x=await R(U);for(const z of x)await L((0,D.join)(U,z),(0,D.join)(j,z),B)}async function g(U,j,K){await e.Promises.copyFile(U,j),await e.Promises.chmod(j,K)}async function M(U,j,K){let B=await e.Promises.readlink(U);(0,T.isEqualOrParent)(B,K.root.source,!P.isLinux)&&(B=(0,D.join)(K.root.target,B.substr(K.root.source.length+1))),await e.Promises.symlink(B,j)}e.Promises=new class{get access(){return(0,I.promisify)(d.access)}get stat(){return(0,I.promisify)(d.stat)}get lstat(){return(0,I.promisify)(d.lstat)}get utimes(){return(0,I.promisify)(d.utimes)}get read(){return(U,j,K,B,x)=>new Promise((z,G)=>{d.read(U,j,K,B,x,(q,Z,se)=>q?G(q):z({bytesRead:Z,buffer:se}))})}get readFile(){return(0,I.promisify)(d.readFile)}get write(){return(U,j,K,B,x)=>new Promise((z,G)=>{d.write(U,j,K,B,x,(q,Z,se)=>q?G(q):z({bytesWritten:Z,buffer:se}))})}get appendFile(){return(0,I.promisify)(d.appendFile)}get fdatasync(){return(0,I.promisify)(d.fdatasync)}get truncate(){return(0,I.promisify)(d.truncate)}get rename(){return(0,I.promisify)(d.rename)}get copyFile(){return(0,I.promisify)(d.copyFile)}get open(){return(0,I.promisify)(d.open)}get close(){return(0,I.promisify)(d.close)}get symlink(){return(0,I.promisify)(d.symlink)}get readlink(){return(0,I.promisify)(d.readlink)}get chmod(){return(0,I.promisify)(d.chmod)}get mkdir(){return(0,I.promisify)(d.mkdir)}get unlink(){return(0,I.promisify)(d.unlink)}get rmdir(){return(0,I.promisify)(d.rmdir)}get realpath(){return(0,I.promisify)(d.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return R}get readDirsInDir(){return u}get writeFile(){return i}get rm(){return E}get move(){return m}get copy(){return b}}}),define(pe[106],ve([0,1,60,9,11,8,29]),function(ee,e,d,t,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function k(c){if(I.isLinux)return c;const E=(0,t.dirname)(c);if(c===E)return c;const v=((0,t.basename)(c)||c).toLowerCase();try{const _=(0,T.readdirSync)(E).filter(R=>R.toLowerCase()===v);if(_.length===1){const R=k(E);if(R)return(0,t.join)(R,_[0])}else if(_.length>1){const R=_.indexOf(v);if(R>=0){const p=k(E);if(p)return(0,t.join)(p,_[R])}}}catch{}return null}e.realcaseSync=k;async function D(c){if(I.isLinux)return c;const E=(0,t.dirname)(c);if(c===E)return c;const v=((0,t.basename)(c)||c).toLowerCase();try{const _=(await T.Promises.readdir(E)).filter(R=>R.toLowerCase()===v);if(_.length===1){const R=await D(E);if(R)return(0,t.join)(R,_[0])}else if(_.length>1){const R=_.indexOf(v);if(R>=0){const p=await D(E);if(p)return(0,t.join)(p,_[R])}}}catch{}return null}e.realcase=D;async function P(c){try{return await T.Promises.realpath(c)}catch{const v=y(c);return await T.Promises.access(v,d.constants.R_OK),v}}e.realpath=P;function F(c){try{return d.realpathSync(c)}catch{const v=y(c);return d.accessSync(v,d.constants.R_OK),v}}e.realpathSync=F;function y(c){return(0,C.rtrim)((0,t.normalize)(c),t.sep)}});var Be=this&&this.__decorate||function(ee,e,d,t){var I=arguments.length,C=I<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,d):t,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(ee,e,d,t);else for(var k=ee.length-1;k>=0;k--)(T=ee[k])&&(C=(I<3?T(C):I>3?T(e,d,C):T(e,d))||C);return I>3&&C&&Object.defineProperty(e,d,C),C};define(pe[107],ve([0,1,17,13,23,21,56,16,3,6,59,8,18]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var E;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(E=e.RequestType||(e.RequestType={}));function v(z){switch(z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(w=e.ResponseType||(e.ResponseType={}));function _(z){switch(z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var R;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(R||(R={}));class p{constructor(G){this.buffer=G,this.pos=0}read(G){const q=this.buffer.slice(this.pos,this.pos+G);return this.pos+=q.byteLength,q}}class h{constructor(){this.buffers=[]}get buffer(){return I.VSBuffer.concat(this.buffers)}write(G){this.buffers.push(G)}}var s;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object"})(s||(s={}));function u(z){const G=I.VSBuffer.alloc(4);return G.writeUInt32BE(z,0),G}function r(z){return z.read(4).readUInt32BE(0)}function S(z){const G=I.VSBuffer.alloc(1);return G.writeUInt8(z,0),G}const a={Undefined:S(s.Undefined),String:S(s.String),Buffer:S(s.Buffer),VSBuffer:S(s.VSBuffer),Array:S(s.Array),Object:S(s.Object)},i=typeof Buffer!="undefined";function n(z,G){if(typeof G=="undefined")z.write(a.Undefined);else if(typeof G=="string"){const q=I.VSBuffer.fromString(G);z.write(a.String),z.write(u(q.byteLength)),z.write(q)}else if(i&&Buffer.isBuffer(G)){const q=I.VSBuffer.wrap(G);z.write(a.Buffer),z.write(u(q.byteLength)),z.write(q)}else if(G instanceof I.VSBuffer)z.write(a.VSBuffer),z.write(u(G.byteLength)),z.write(G);else if(Array.isArray(G)){z.write(a.Array),z.write(u(G.length));for(const q of G)n(z,q)}else{const q=I.VSBuffer.fromString(JSON.stringify(G));z.write(a.Object),z.write(u(q.byteLength)),z.write(q)}}function o(z){switch(z.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return z.read(r(z)).toString();case s.Buffer:return z.read(r(z)).buffer;case s.VSBuffer:return z.read(r(z));case s.Array:{const q=r(z),Z=[];for(let se=0;se<q;se++)Z.push(o(z));return Z}case s.Object:return JSON.parse(z.read(r(z)).toString())}}class l{constructor(G,q,Z=null,se=1e3){this.protocol=G,this.ctx=q,this.logger=Z,this.timeoutDelay=se,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ue=>this.onRawMessage(ue)),this.sendResponse({type:200})}registerChannel(G,q){this.channels.set(G,q),setTimeout(()=>this.flushPendingRequests(G),0)}sendResponse(G){switch(G.type){case 200:{const q=this.send([G.type]);this.logger&&this.logger.logOutgoing(q,0,1,_(G.type));return}case 201:case 202:case 204:case 203:{const q=this.send([G.type,G.id],G.data);this.logger&&this.logger.logOutgoing(q,G.id,1,_(G.type),G.data);return}}}send(G,q=void 0){const Z=new h;return n(Z,G),n(Z,q),this.sendBuffer(Z.buffer)}sendBuffer(G){try{return this.protocol.send(G),G.byteLength}catch{return 0}}onRawMessage(G){const q=new p(G),Z=o(q),se=o(q),ue=Z[0];switch(ue){case 100:return this.logger&&this.logger.logIncoming(G.byteLength,Z[1],1,`${v(ue)}: ${Z[2]}.${Z[3]}`,se),this.onPromise({type:ue,id:Z[1],channelName:Z[2],name:Z[3],arg:se});case 102:return this.logger&&this.logger.logIncoming(G.byteLength,Z[1],1,`${v(ue)}: ${Z[2]}.${Z[3]}`,se),this.onEventListen({type:ue,id:Z[1],channelName:Z[2],name:Z[3],arg:se});case 101:return this.logger&&this.logger.logIncoming(G.byteLength,Z[1],1,`${v(ue)}`),this.disposeActiveRequest({type:ue,id:Z[1]});case 103:return this.logger&&this.logger.logIncoming(G.byteLength,Z[1],1,`${v(ue)}`),this.disposeActiveRequest({type:ue,id:Z[1]})}}onPromise(G){const q=this.channels.get(G.channelName);if(!q){this.collectPendingRequest(G);return}const Z=new C.CancellationTokenSource;let se;try{se=q.call(this.ctx,G.name,G.arg,Z.token)}catch(J){se=Promise.reject(J)}const ue=G.id;se.then(J=>{this.sendResponse({id:ue,data:J,type:201}),this.activeRequests.delete(G.id)},J=>{J instanceof Error?this.sendResponse({id:ue,data:{message:J.message,name:J.name,stack:J.stack?J.stack.split?J.stack.split(`
`):J.stack:void 0},type:202}):this.sendResponse({id:ue,data:J,type:203}),this.activeRequests.delete(G.id)});const te=(0,P.toDisposable)(()=>Z.cancel());this.activeRequests.set(G.id,te)}onEventListen(G){const q=this.channels.get(G.channelName);if(!q){this.collectPendingRequest(G);return}const Z=G.id,ue=q.listen(this.ctx,G.name,G.arg)(te=>this.sendResponse({id:Z,data:te,type:204}));this.activeRequests.set(G.id,ue)}disposeActiveRequest(G){const q=this.activeRequests.get(G.id);q&&(q.dispose(),this.activeRequests.delete(G.id))}collectPendingRequest(G){let q=this.pendingRequests.get(G.channelName);q||(q=[],this.pendingRequests.set(G.channelName,q));const Z=setTimeout(()=>{console.error(`Unknown channel: ${G.channelName}`),G.type===100&&this.sendResponse({id:G.id,data:{name:"Unknown channel",message:`Channel name '${G.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);q.push({request:G,timeoutTimer:Z})}flushPendingRequests(G){const q=this.pendingRequests.get(G);if(q){for(const Z of q)switch(clearTimeout(Z.timeoutTimer),Z.request.type){case 100:this.onPromise(Z.request);break;case 102:this.onEventListen(Z.request);break}this.pendingRequests.delete(G)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(G=>G.dispose()),this.activeRequests.clear()}}e.ChannelServer=l;var f;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));class m{constructor(G,q=null){this.protocol=G,this.isDisposed=!1,this.state=R.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new D.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(Z=>this.onBuffer(Z)),this.logger=q}getChannel(G){const q=this;return{call(Z,se,ue){return q.isDisposed?Promise.reject(k.canceled()):q.requestPromise(G,Z,se,ue)},listen(Z,se){return q.isDisposed?Promise.reject(k.canceled()):q.requestEvent(G,Z,se)}}}requestPromise(G,q,Z,se=C.CancellationToken.None){const ue=this.lastRequestId++,J={id:ue,type:100,channelName:G,name:q,arg:Z};if(se.isCancellationRequested)return Promise.reject(k.canceled());let ae;return new Promise((we,Ie)=>{if(se.isCancellationRequested)return Ie(k.canceled());const Ne=()=>{const W=O=>{switch(O.type){case 201:this.handlers.delete(ue),we(O.data);break;case 202:{this.handlers.delete(ue);const $=new Error(O.data.message);$.stack=O.data.stack,$.name=O.data.name,Ie($);break}case 203:this.handlers.delete(ue),Ie(O.data);break}};this.handlers.set(ue,W),this.sendRequest(J)};let Ee=null;this.state===R.Idle?Ne():(Ee=(0,t.createCancelablePromise)(W=>this.whenInitialized()),Ee.then(()=>{Ee=null,Ne()}));const be=()=>{Ee?(Ee.cancel(),Ee=null):this.sendRequest({id:ue,type:101}),Ie(k.canceled())},H=se.onCancellationRequested(be);ae=(0,P.combinedDisposable)((0,P.toDisposable)(be),H),this.activeRequests.add(ae)}).finally(()=>{this.activeRequests.delete(ae)})}requestEvent(G,q,Z){const se=this.lastRequestId++,te={id:se,type:102,channelName:G,name:q,arg:Z};let J=null;const ae=new D.Emitter({onFirstListenerAdd:()=>{J=(0,t.createCancelablePromise)(we=>this.whenInitialized()),J.then(()=>{J=null,this.activeRequests.add(ae),this.sendRequest(te)})},onLastListenerRemove:()=>{J?(J.cancel(),J=null):(this.activeRequests.delete(ae),this.sendRequest({id:se,type:103}))}}),he=we=>ae.fire(we.data);return this.handlers.set(se,he),ae.event}sendRequest(G){switch(G.type){case 100:case 102:{const q=this.send([G.type,G.id,G.channelName,G.name],G.arg);this.logger&&this.logger.logOutgoing(q,G.id,0,`${v(G.type)}: ${G.channelName}.${G.name}`,G.arg);return}case 101:case 103:{const q=this.send([G.type,G.id]);this.logger&&this.logger.logOutgoing(q,G.id,0,v(G.type));return}}}send(G,q=void 0){const Z=new h;return n(Z,G),n(Z,q),this.sendBuffer(Z.buffer)}sendBuffer(G){try{return this.protocol.send(G),G.byteLength}catch{return 0}}onBuffer(G){const q=new p(G),Z=o(q),se=o(q),ue=Z[0];switch(ue){case 200:return this.logger&&this.logger.logIncoming(G.byteLength,0,0,_(ue)),this.onResponse({type:Z[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(G.byteLength,Z[1],0,_(ue),se),this.onResponse({type:Z[0],id:Z[1],data:se})}}onResponse(G){if(G.type===200){this.state=R.Idle,this._onDidInitialize.fire();return}const q=this.handlers.get(G.id);q&&q(G)}get onDidInitializePromise(){return D.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===R.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(G=>G.dispose()),this.activeRequests.clear()}}Be([T.memoize],m.prototype,"onDidInitializePromise",null),e.ChannelClient=m;class b{constructor(G){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new D.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new D.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,G(({protocol:q,onDidClientDisconnect:Z})=>{D.Event.once(q.onMessage)(ue=>{const te=new p(ue),J=o(te),ae=new l(q,J),he=new m(q);this.channels.forEach((Ie,Ne)=>ae.registerChannel(Ne,Ie));const we={channelServer:ae,channelClient:he,ctx:J};this._connections.add(we),this._onDidAddConnection.fire(we),Z(()=>{ae.dispose(),he.dispose(),this._connections.delete(we),this._onDidRemoveConnection.fire(we)})})})}get connections(){const G=[];return this._connections.forEach(q=>G.push(q)),G}getChannel(G,q){const Z=this;return{call(se,ue,te){let J;if((0,c.isFunction)(q)){let he=(0,d.getRandomElement)(Z.connections.filter(q));J=he?Promise.resolve(he):D.Event.toPromise(D.Event.filter(Z.onDidAddConnection,q))}else J=q.routeCall(Z,se,ue);const ae=J.then(he=>he.channelClient.getChannel(G));return L(ae).call(se,ue,te)},listen(se,ue){if((0,c.isFunction)(q))return Z.getMulticastEvent(G,q,se,ue);const te=q.routeEvent(Z,se,ue).then(J=>J.channelClient.getChannel(G));return L(te).listen(se,ue)}}}getMulticastEvent(G,q,Z,se){const ue=this;let te=new P.DisposableStore;const J=new D.Emitter({onFirstListenerAdd:()=>{te=new P.DisposableStore;const ae=new D.EventMultiplexer,he=new Map,we=Ne=>{const be=Ne.channelClient.getChannel(G).listen(Z,se),H=ae.add(be);he.set(Ne,H)},Ie=Ne=>{const Ee=he.get(Ne);!Ee||(Ee.dispose(),he.delete(Ne))};ue.connections.filter(q).forEach(we),D.Event.filter(ue.onDidAddConnection,q)(we,void 0,te),ue.onDidRemoveConnection(Ie,void 0,te),ae.event(J.fire,J,te),te.add(ae)},onLastListenerRemove:()=>{te.dispose()}});return J.event}registerChannel(G,q){this.channels.set(G,q),this._connections.forEach(Z=>{Z.channelServer.registerChannel(G,q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=b;class A{constructor(G,q,Z=null){const se=new h;n(se,q),G.send(se.buffer),this.channelClient=new m(G,Z),this.channelServer=new l(G,q,Z)}getChannel(G){return this.channelClient.getChannel(G)}registerChannel(G,q){this.channelServer.registerChannel(G,q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=A;function L(z){return{call(G,q,Z){return z.then(se=>se.call(G,q,Z))},listen(G,q){const Z=new D.Relay;return z.then(se=>Z.input=se.listen(G,q)),Z.event}}}e.getDelayedChannel=L;function N(z){let G=!1;return{call(q,Z,se){return G?z.call(q,Z,se):(0,t.timeout)(0).then(()=>G=!0).then(()=>z.call(q,Z,se))},listen(q,Z){if(G)return z.listen(q,Z);const se=new D.Relay;return(0,t.timeout)(0).then(()=>G=!0).then(()=>se.input=z.listen(q,Z)),se.event}}}e.getNextTickChannel=N;class g{constructor(G){this.fn=G}routeCall(G){return this.route(G)}routeEvent(G){return this.route(G)}async route(G){for(const q of G.connections)if(await Promise.resolve(this.fn(q.ctx)))return Promise.resolve(q);return await D.Event.toPromise(G.onDidAddConnection),await this.route(G)}}e.StaticRouter=g;var M;(function(z){function G(ue,te){const J=ue,ae=te&&te.disableMarshalling,he=new Map;for(const we in J)Z(we)&&he.set(we,D.Event.buffer(J[we],!0));return new class{listen(we,Ie,Ne){const Ee=he.get(Ie);if(Ee)return Ee;if(se(Ie)){const be=J[Ie];if(typeof be=="function")return be.call(J,Ne)}throw new Error(`Event not found: ${Ie}`)}call(we,Ie,Ne){const Ee=J[Ie];if(typeof Ee=="function"){if(!ae&&Array.isArray(Ne))for(let be=0;be<Ne.length;be++)Ne[be]=(0,F.revive)(Ne[be]);return Ee.apply(J,Ne)}throw new Error(`Method not found: ${Ie}`)}}}z.fromService=G;function q(ue,te){const J=te&&te.disableMarshalling;return new Proxy({},{get(ae,he){if(typeof he=="string")return te?.properties?.has(he)?te.properties.get(he):se(he)?function(we){return ue.listen(he,we)}:Z(he)?ue.listen(he):async function(...we){let Ie;te&&!(0,c.isUndefinedOrNull)(te.context)?Ie=[te.context,...we]:Ie=we;const Ne=await ue.call(he,Ie);return J?Ne:(0,F.revive)(Ne)};throw new Error(`Property not found: ${String(he)}`)}})}z.toService=q;function Z(ue){return ue[0]==="o"&&ue[1]==="n"&&y.isUpperAsciiLetter(ue.charCodeAt(2))}function se(ue){return/^onDynamic/.test(ue)&&y.isUpperAsciiLetter(ue.charCodeAt(9))}})(M=e.ProxyChannel||(e.ProxyChannel={}));const U=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function j(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){let G=z.toString();if(G!=="[object Object]")return G}return z}function K(z){return Array.isArray(z)?z.map(j):j(z)}function B(z,G,q,Z,se,ue,te){te=K(te);const J=U[se],ae=J[Z%J.length];let he=[`%c[${z}]%c[${String(G).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(Z).padStart(5," ")} - ${ue}`,"color: darkgreen","color: grey","color: grey",`color: ${ae}`];/\($/.test(ue)?(he=he.concat(te),he.push(")")):he.push(te),console.log.apply(console,he)}e.logWithColors=B;class x{constructor(G,q){this._outgoingPrefix=G,this._incomingPrefix=q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(G,q,Z,se,ue){this._totalOutgoing+=G,B(this._outgoingPrefix,this._totalOutgoing,G,q,Z,se,ue)}logIncoming(G,q,Z,se,ue){this._totalIncoming+=G,B(this._incomingPrefix,this._totalIncoming,G,q,Z,se,ue)}}e.IPCLogger=x}),define(pe[108],ve([0,1,23,3,6,107]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(T=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var k;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let o=0;function l(m,b){if(!n.has(m)){const A=String(++o);n.set(m,A)}return n.get(m)}function f(m,b,A,L){if(!i.enableDiagnostics)return;const N=l(m,b);if(L instanceof d.VSBuffer||L instanceof Uint8Array||L instanceof ArrayBuffer||ArrayBuffer.isView(L)){const g=d.VSBuffer.alloc(L.byteLength);g.set(L),i.records.push({timestamp:Date.now(),id:N,label:b,type:A,buff:g})}else i.records.push({timestamp:Date.now(),id:N,label:b,type:A,data:L})}i.traceSocketEvent=f})(k=e.SocketDiagnostics||(e.SocketDiagnostics={}));var D;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(D=e.SocketCloseEventType||(e.SocketCloseEventType={}));let P=null;function F(){return P||(P=d.VSBuffer.alloc(0)),P}class y{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,o){if(n===0)return F();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const b=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=n),b}if(this._chunks[0].byteLength>n){const b=this._chunks[0].slice(0,n);return o&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),b}let l=d.VSBuffer.alloc(n),f=0,m=0;for(;n>0;){const b=this._chunks[m];if(b.byteLength>n){const A=b.slice(0,n);l.set(A,f),f+=n,o&&(this._chunks[m]=b.slice(n),this._totalLength-=n),n-=n}else l.set(b,f),f+=b.byteLength,o?(this._chunks.shift(),this._totalLength-=b.byteLength):m++,n-=b.byteLength}return l}}e.ChunkStream=y;var c;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume"})(c||(c={}));function E(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var v;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(v=e.ProtocolConstants||(e.ProtocolConstants={}));class w{constructor(n,o,l,f){this.type=n,this.id=o,this.ack=l,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class _ extends I.Disposable{constructor(n){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new y,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:E(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const l=this._state.messageType,f=this._state.id,m=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",o),this._onMessage.fire(new w(l,f,m,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class R{constructor(n){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=d.VSBuffer.alloc(13);o.writeUInt8(n.type,0),o.writeUInt32BE(n.id,1),o.writeUInt32BE(n.ack,5),o.writeUInt32BE(n.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:E(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",n.data),this._writeSoon(o,n.data)}_bufferAdd(n,o){const l=this._totalLength===0;return this._data.push(n,o),this._totalLength+=n.byteLength+o.byteLength,l}_bufferTake(){const n=d.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,o){this._bufferAdd(n,o)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const n=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this._socket.write(n)}}class p extends I.Disposable{constructor(n){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new R(this._socket)),this._socketReader=this._register(new _(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new w(1,0,0,n))}}e.Protocol=p;class h extends C.IPCClient{constructor(n,o,l=null){super(n,o,l);this.protocol=n}static fromSocket(n,o){return new h(new p(n),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=h;class s{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=s;class u{constructor(n){this.data=n,this.next=null}}class r{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let n=[],o=0,l=this._first;for(;l;)n[o++]=l.data,l=l.next;return n}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const o=new u(n);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class S{constructor(){this.lastRuns=[];const n=Date.now();for(let o=0;o<S._HISTORY_LENGTH;o++)this.lastRuns[o]=n-1e3*o;setInterval(()=>{for(let o=S._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return S._INSTANCE||(S._INSTANCE=new S),S._INSTANCE}load(){const n=Date.now(),o=(1+S._HISTORY_LENGTH)*1e3;let l=0;for(let f=0;f<S._HISTORY_LENGTH;f++)n-this.lastRuns[f]<=o&&l++;return 1-l/S._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}S._HISTORY_LENGTH=10,S._INSTANCE=null;class a{constructor(n,o=null,l=S.getInstance()){this._onControlMessage=new s,this.onControlMessage=this._onControlMessage.event,this._onMessage=new s,this.onMessage=this._onMessage.event,this._onDidDispose=new s,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new s,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new s,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=l,this._isReconnecting=!1,this._outgoingUnackMsg=new r,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=n,this._socketWriter=new R(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new _(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(f=>this._receiveMessage(f))),this._socketDisposables.push(this._socket.onClose(f=>this._onSocketClose.fire(f))),o&&this._socketReader.acceptChunk(o)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,I.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new w(5,0,0,F());this._socketWriter.write(n),this._socketWriter.flush()}sendPause(){const n=new w(7,0,0,F());this._socketWriter.write(n)}sendResume(){const n=new w(8,0,0,F());this._socketWriter.write(n)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,o){this._isReconnecting=!0,this._socketDisposables=(0,I.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=n,this._socketWriter=new R(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new _(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const n=new w(3,0,this._incomingAckId,F());this._socketWriter.write(n);const o=this._outgoingUnackMsg.toArray();for(let l=0,f=o.length;l<f;l++)this._socketWriter.write(o[l]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new w(6,0,0,F())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data);break}case 2:{this._onControlMessage.fire(n.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const o=this._outgoingUnackMsg.toArray();for(let l=0,f=o.length;l<f;l++)this._socketWriter.write(o[l]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const l=new w(1,o,this._incomingAckId,n);this._outgoingUnackMsg.push(l),this._isReconnecting||(this._socketWriter.write(l),this._recvAckCheck())}sendControl(n){const o=new w(2,0,0,n);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const n=this._outgoingUnackMsg.peek(),o=Date.now()-n.writtenTime,l=Date.now()-this._socketReader.lastReadTime,f=Date.now()-this._lastSocketTimeoutTime;if(o>=2e4&&l>=2e4&&f>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const m=Math.max(2e4-o,2e4-l,2e4-f,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},m)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new w(3,0,this._incomingAckId,F());this._socketWriter.write(n)}}e.PersistentProtocol=a}),define(pe[109],ve([0,1,101]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(k){const D=(0,d.toUint8)(k);this._defaultValue=D,this._asciiMap=t._createAsciiMap(D),this._map=new Map}static _createAsciiMap(k){const D=new Uint8Array(256);for(let P=0;P<256;P++)D[P]=k;return D}set(k,D){const P=(0,d.toUint8)(D);k>=0&&k<256?this._asciiMap[k]=P:this._map.set(k,P)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=t;var I;(function(T){T[T.False=0]="False",T[T.True=1]="True"})(I||(I={}));class C{constructor(){this._actual=new t(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=C}),define(pe[48],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class d{constructor(I,C){this.lineNumber=I,this.column=C}with(I=this.lineNumber,C=this.column){return I===this.lineNumber&&C===this.column?this:new d(I,C)}delta(I=0,C=0){return this.with(this.lineNumber+I,this.column+C)}equals(I){return d.equals(this,I)}static equals(I,C){return!I&&!C?!0:!!I&&!!C&&I.lineNumber===C.lineNumber&&I.column===C.column}isBefore(I){return d.isBefore(this,I)}static isBefore(I,C){return I.lineNumber<C.lineNumber?!0:C.lineNumber<I.lineNumber?!1:I.column<C.column}isBeforeOrEqual(I){return d.isBeforeOrEqual(this,I)}static isBeforeOrEqual(I,C){return I.lineNumber<C.lineNumber?!0:C.lineNumber<I.lineNumber?!1:I.column<=C.column}static compare(I,C){const T=I.lineNumber|0,k=C.lineNumber|0;if(T===k){const D=I.column|0,P=C.column|0;return D-P}return T-k}clone(){return new d(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(I){return new d(I.lineNumber,I.column)}static isIPosition(I){return I&&typeof I.lineNumber=="number"&&typeof I.column=="number"}}e.Position=d}),define(pe[41],ve([0,1,48]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(C,T,k,D){C>k||C===k&&T>D?(this.startLineNumber=k,this.startColumn=D,this.endLineNumber=C,this.endColumn=T):(this.startLineNumber=C,this.startColumn=T,this.endLineNumber=k,this.endColumn=D)}isEmpty(){return t.isEmpty(this)}static isEmpty(C){return C.startLineNumber===C.endLineNumber&&C.startColumn===C.endColumn}containsPosition(C){return t.containsPosition(this,C)}static containsPosition(C,T){return!(T.lineNumber<C.startLineNumber||T.lineNumber>C.endLineNumber||T.lineNumber===C.startLineNumber&&T.column<C.startColumn||T.lineNumber===C.endLineNumber&&T.column>C.endColumn)}static strictContainsPosition(C,T){return!(T.lineNumber<C.startLineNumber||T.lineNumber>C.endLineNumber||T.lineNumber===C.startLineNumber&&T.column<=C.startColumn||T.lineNumber===C.endLineNumber&&T.column>=C.endColumn)}containsRange(C){return t.containsRange(this,C)}static containsRange(C,T){return!(T.startLineNumber<C.startLineNumber||T.endLineNumber<C.startLineNumber||T.startLineNumber>C.endLineNumber||T.endLineNumber>C.endLineNumber||T.startLineNumber===C.startLineNumber&&T.startColumn<C.startColumn||T.endLineNumber===C.endLineNumber&&T.endColumn>C.endColumn)}strictContainsRange(C){return t.strictContainsRange(this,C)}static strictContainsRange(C,T){return!(T.startLineNumber<C.startLineNumber||T.endLineNumber<C.startLineNumber||T.startLineNumber>C.endLineNumber||T.endLineNumber>C.endLineNumber||T.startLineNumber===C.startLineNumber&&T.startColumn<=C.startColumn||T.endLineNumber===C.endLineNumber&&T.endColumn>=C.endColumn)}plusRange(C){return t.plusRange(this,C)}static plusRange(C,T){let k,D,P,F;return T.startLineNumber<C.startLineNumber?(k=T.startLineNumber,D=T.startColumn):T.startLineNumber===C.startLineNumber?(k=T.startLineNumber,D=Math.min(T.startColumn,C.startColumn)):(k=C.startLineNumber,D=C.startColumn),T.endLineNumber>C.endLineNumber?(P=T.endLineNumber,F=T.endColumn):T.endLineNumber===C.endLineNumber?(P=T.endLineNumber,F=Math.max(T.endColumn,C.endColumn)):(P=C.endLineNumber,F=C.endColumn),new t(k,D,P,F)}intersectRanges(C){return t.intersectRanges(this,C)}static intersectRanges(C,T){let k=C.startLineNumber,D=C.startColumn,P=C.endLineNumber,F=C.endColumn,y=T.startLineNumber,c=T.startColumn,E=T.endLineNumber,v=T.endColumn;return k<y?(k=y,D=c):k===y&&(D=Math.max(D,c)),P>E?(P=E,F=v):P===E&&(F=Math.min(F,v)),k>P||k===P&&D>F?null:new t(k,D,P,F)}equalsRange(C){return t.equalsRange(this,C)}static equalsRange(C,T){return!!C&&!!T&&C.startLineNumber===T.startLineNumber&&C.startColumn===T.startColumn&&C.endLineNumber===T.endLineNumber&&C.endColumn===T.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(C){return new d.Position(C.endLineNumber,C.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(C){return new d.Position(C.startLineNumber,C.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(C,T){return new t(this.startLineNumber,this.startColumn,C,T)}setStartPosition(C,T){return new t(C,T,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}static collapseToStart(C){return new t(C.startLineNumber,C.startColumn,C.startLineNumber,C.startColumn)}static fromPositions(C,T=C){return new t(C.lineNumber,C.column,T.lineNumber,T.column)}static lift(C){return C?new t(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):null}static isIRange(C){return C&&typeof C.startLineNumber=="number"&&typeof C.startColumn=="number"&&typeof C.endLineNumber=="number"&&typeof C.endColumn=="number"}static areIntersectingOrTouching(C,T){return!(C.endLineNumber<T.startLineNumber||C.endLineNumber===T.startLineNumber&&C.endColumn<T.startColumn||T.endLineNumber<C.startLineNumber||T.endLineNumber===C.startLineNumber&&T.endColumn<C.startColumn)}static areIntersecting(C,T){return!(C.endLineNumber<T.startLineNumber||C.endLineNumber===T.startLineNumber&&C.endColumn<=T.startColumn||T.endLineNumber<C.startLineNumber||T.endLineNumber===C.startLineNumber&&T.endColumn<=C.startColumn)}static compareRangesUsingStarts(C,T){if(C&&T){const P=C.startLineNumber|0,F=T.startLineNumber|0;if(P===F){const y=C.startColumn|0,c=T.startColumn|0;if(y===c){const E=C.endLineNumber|0,v=T.endLineNumber|0;if(E===v){const w=C.endColumn|0,_=T.endColumn|0;return w-_}return E-v}return y-c}return P-F}return(C?1:0)-(T?1:0)}static compareRangesUsingEnds(C,T){return C.endLineNumber===T.endLineNumber?C.endColumn===T.endColumn?C.startLineNumber===T.startLineNumber?C.startColumn-T.startColumn:C.startLineNumber-T.startLineNumber:C.endColumn-T.endColumn:C.endLineNumber-T.endLineNumber}static spansMultipleLines(C){return C.endLineNumber>C.startLineNumber}}e.Range=t}),define(pe[146],ve([0,1,48,41]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var I;(function(T){T[T.LTR=0]="LTR",T[T.RTL=1]="RTL"})(I=e.SelectionDirection||(e.SelectionDirection={}));class C extends t.Range{constructor(k,D,P,F){super(k,D,P,F);this.selectionStartLineNumber=k,this.selectionStartColumn=D,this.positionLineNumber=P,this.positionColumn=F}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return C.selectionsEqual(this,k)}static selectionsEqual(k,D){return k.selectionStartLineNumber===D.selectionStartLineNumber&&k.selectionStartColumn===D.selectionStartColumn&&k.positionLineNumber===D.positionLineNumber&&k.positionColumn===D.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,D){return this.getDirection()===0?new C(this.startLineNumber,this.startColumn,k,D):new C(k,D,this.startLineNumber,this.startColumn)}getPosition(){return new d.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new d.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(k,D){return this.getDirection()===0?new C(k,D,this.endLineNumber,this.endColumn):new C(this.endLineNumber,this.endColumn,k,D)}static fromPositions(k,D=k){return new C(k.lineNumber,k.column,D.lineNumber,D.column)}static fromRange(k,D){return D===0?new C(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):new C(k.endLineNumber,k.endColumn,k.startLineNumber,k.startColumn)}static liftSelection(k){return new C(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,D){if(k&&!D||!k&&D)return!1;if(!k&&!D)return!0;if(k.length!==D.length)return!1;for(let P=0,F=k.length;P<F;P++)if(!this.selectionsEqual(k[P],D[P]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,D,P,F,y){return y===0?new C(k,D,P,F):new C(P,F,k,D)}}e.Selection=C}),define(pe[147],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}}}),define(pe[148],ve([0,1,109]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(T){T[T.Regular=0]="Regular",T[T.Whitespace=1]="Whitespace",T[T.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class I extends d.CharacterClassifier{constructor(k){super(0);for(let D=0,P=k.length;D<P;D++)this.set(k.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=I;function C(T){const k={};return D=>(k.hasOwnProperty(D)||(k[D]=T(D)),k[D])}e.getMapForWordSeparators=C(T=>new I(T))}),define(pe[110],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function d(k=""){let D="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.USUAL_WORD_SEPARATORS)k.indexOf(P)>=0||(D+="\\"+P);return D+="\\s]+)",new RegExp(D,"g")}e.DEFAULT_WORD_REGEXP=d();function t(k){let D=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)D=k;else{let P="g";k.ignoreCase&&(P+="i"),k.multiline&&(P+="m"),k.unicode&&(P+="u"),D=new RegExp(k.source,P)}return D.lastIndex=0,D}e.ensureValidWordDefinition=t;const I={maxLen:1e3,windowSize:15,timeBudget:150};function C(k,D,P,F,y=I){if(P.length>y.maxLen){let _=k-y.maxLen/2;return _<0?_=0:F+=_,P=P.substring(_,k+y.maxLen/2),C(k,D,P,F,y)}const c=Date.now(),E=k-1-F;let v=-1,w=null;for(let _=1;!(Date.now()-c>=y.timeBudget);_++){const R=E-y.windowSize*_;D.lastIndex=Math.max(0,R);const p=T(D,P,E,v);if(!p&&w||(w=p,R<=0))break;v=R}if(w){const _={word:w[0],startColumn:F+1+w.index,endColumn:F+1+w.index+w[0].length};return D.lastIndex=0,_}return null}e.getWordAtText=C;function T(k,D,P,F){let y;for(;y=k.exec(D);){const c=y.index||0;if(c<=P&&k.lastIndex>=P)return y;if(F>0&&c>F)return null}return null}}),define(pe[80],ve([0,1,32,9]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function I(C,T,k,D){if(Array.isArray(C)){let P=0;for(const F of C){const y=I(F,T,k,D);if(y===10)return y;y>P&&(P=y)}return P}else{if(typeof C=="string")return D?C==="*"?5:C===k?10:0:0;if(C){const{language:P,pattern:F,scheme:y,hasAccessToAllModels:c}=C;if(!D&&!c)return 0;let E=0;if(y)if(y===T.scheme)E=10;else if(y==="*")E=5;else return 0;if(P)if(P===k)E=10;else if(P==="*")E=Math.max(E,5);else return 0;if(F){let v;if(typeof F=="string"?v=F:v={...F,base:(0,t.normalize)(F.base)},v===T.fsPath||(0,d.match)(v,T.fsPath))E=10;else return 0}return E}else return 0}}e.score=I}),define(pe[149],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var d;(function(T){T[T.None=0]="None",T[T.Indent=1]="Indent",T[T.IndentOutdent=2]="IndentOutdent",T[T.Outdent=3]="Outdent"})(d=e.IndentAction||(e.IndentAction={}));class t{constructor(k){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=k.open,this.close=k.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(k.notIn))for(let D=0,P=k.notIn.length;D<P;D++)switch(k.notIn[D]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(k){switch(k){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(k,D){if(k.getTokenCount()===0)return!0;const P=k.findTokenIndexAtOffset(D-2),F=k.getStandardTokenType(P);return this.isOK(F)}_findNeutralCharacterInRange(k,D){for(let P=k;P<=D;P++){const F=String.fromCharCode(P);if(!this.open.includes(F)&&!this.close.includes(F))return F}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class I{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of k)C(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),C(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),C(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),C(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&C(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=I;function C(T,k,D){T.has(k)?T.get(k).push(D):T.set(k,[D])}}),define(pe[150],ve([0,1,109]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var t;(function(E){E[E.Invalid=0]="Invalid",E[E.Start=1]="Start",E[E.H=2]="H",E[E.HT=3]="HT",E[E.HTT=4]="HTT",E[E.HTTP=5]="HTTP",E[E.F=6]="F",E[E.FI=7]="FI",E[E.FIL=8]="FIL",E[E.BeforeColon=9]="BeforeColon",E[E.AfterColon=10]="AfterColon",E[E.AlmostThere=11]="AlmostThere",E[E.End=12]="End",E[E.Accept=13]="Accept",E[E.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class I{constructor(v,w,_){const R=new Uint8Array(v*w);for(let p=0,h=v*w;p<h;p++)R[p]=_;this._data=R,this.rows=v,this.cols=w}get(v,w){return this._data[v*this.cols+w]}set(v,w,_){this._data[v*this.cols+w]=_}}e.Uint8Matrix=I;class C{constructor(v){let w=0,_=0;for(let p=0,h=v.length;p<h;p++){const[s,u,r]=v[p];u>w&&(w=u),s>_&&(_=s),r>_&&(_=r)}w++,_++;const R=new I(_,w,0);for(let p=0,h=v.length;p<h;p++){const[s,u,r]=v[p];R.set(s,u,r)}this._states=R,this._maxCharCode=w}nextState(v,w){return w<0||w>=this._maxCharCode?0:this._states.get(v,w)}}e.StateMachine=C;let T=null;function k(){return T===null&&(T=new C([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),T}var D;(function(E){E[E.None=0]="None",E[E.ForceTermination=1]="ForceTermination",E[E.CannotEndIn=2]="CannotEndIn"})(D||(D={}));let P=null;function F(){if(P===null){P=new d.CharacterClassifier(0);const E=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let w=0;w<E.length;w++)P.set(E.charCodeAt(w),1);const v=".,;";for(let w=0;w<v.length;w++)P.set(v.charCodeAt(w),2)}return P}class y{static _createLink(v,w,_,R,p){let h=p-1;do{const s=w.charCodeAt(h);if(v.get(s)!==2)break;h--}while(h>R);if(R>0){const s=w.charCodeAt(R-1),u=w.charCodeAt(h);(s===40&&u===41||s===91&&u===93||s===123&&u===125)&&h--}return{range:{startLineNumber:_,startColumn:R+1,endLineNumber:_,endColumn:h+2},url:w.substring(R,h+1)}}static computeLinks(v,w=k()){const _=F(),R=[];for(let p=1,h=v.getLineCount();p<=h;p++){const s=v.getLineContent(p),u=s.length;let r=0,S=0,a=0,i=1,n=!1,o=!1,l=!1,f=!1;for(;r<u;){let m=!1;const b=s.charCodeAt(r);if(i===13){let A;switch(b){case 40:n=!0,A=0;break;case 41:A=n?0:1;break;case 91:l=!0,o=!0,A=0;break;case 93:l=!1,A=o?0:1;break;case 123:f=!0,A=0;break;case 125:A=f?0:1;break;case 39:A=a===34||a===96?0:1;break;case 34:A=a===39||a===96?0:1;break;case 96:A=a===39||a===34?0:1;break;case 42:A=a===42?1:0;break;case 124:A=a===124?1:0;break;case 32:A=l?0:1;break;default:A=_.get(b)}A===1&&(R.push(y._createLink(_,s,p,S,r)),m=!0)}else if(i===12){let A;b===91?(o=!0,A=0):A=_.get(b),A===1?m=!0:i=13}else i=w.nextState(i,b),i===0&&(m=!0);m&&(i=1,n=!1,o=!1,f=!1,S=r+1,a=b),r++}i===13&&R.push(y._createLink(_,s,p,S,u))}return R}}e.LinkComputer=y;function c(E){return!E||typeof E.getLineCount!="function"||typeof E.getLineContent!="function"?[]:y.computeLinks(E)}e.computeLinks=c}),define(pe[81],ve([0,1,25]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(p){p[p.Left=1]="Left",p[p.Center=2]="Center",p[p.Right=4]="Right",p[p.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(p){p[p.Inline=1]="Inline",p[p.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var C;(function(p){p[p.Both=0]="Both",p[p.Right=1]="Right",p[p.Left=2]="Left",p[p.None=3]="None"})(C=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var T;(function(p){p[p.TextDefined=0]="TextDefined",p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(T=e.EndOfLinePreference||(e.EndOfLinePreference={}));var k;(function(p){p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(k=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var D;(function(p){p[p.LF=0]="LF",p[p.CRLF=1]="CRLF"})(D=e.EndOfLineSequence||(e.EndOfLineSequence={}));class P{constructor(h){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,h.tabSize|0),this.indentSize=h.tabSize|0,this.insertSpaces=Boolean(h.insertSpaces),this.defaultEOL=h.defaultEOL|0,this.trimAutoWhitespace=Boolean(h.trimAutoWhitespace),this.bracketPairColorizationOptions=h.bracketPairColorizationOptions}equals(h){return this.tabSize===h.tabSize&&this.indentSize===h.indentSize&&this.insertSpaces===h.insertSpaces&&this.defaultEOL===h.defaultEOL&&this.trimAutoWhitespace===h.trimAutoWhitespace&&(0,d.equals)(this.bracketPairColorizationOptions,h.bracketPairColorizationOptions)}createChangeEvent(h){return{tabSize:this.tabSize!==h.tabSize,indentSize:this.indentSize!==h.indentSize,insertSpaces:this.insertSpaces!==h.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==h.trimAutoWhitespace}}}e.TextModelResolvedOptions=P;class F{constructor(h,s){this._findMatchBrand=void 0,this.range=h,this.matches=s}}e.FindMatch=F;var y;(function(p){p[p.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",p[p.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",p[p.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",p[p.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(y=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var c;(function(p){p[p.Left=0]="Left",p[p.Right=1]="Right",p[p.None=2]="None"})(c=e.PositionAffinity||(e.PositionAffinity={}));var E;(function(p){p[p.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(E=e.ModelConstants||(e.ModelConstants={}));class v{constructor(h,s,u,r,S,a){this.identifier=h,this.range=s,this.text=u,this.forceMoveMarkers=r,this.isAutoWhitespaceEdit=S,this._isTracked=a}}e.ValidAnnotatedEditOperation=v;class w{constructor(h,s,u){this.regex=h,this.wordSeparators=s,this.simpleSearch=u}}e.SearchData=w;class _{constructor(h,s,u){this.reverseEdits=h,this.changes=s,this.trimAutoWhitespaceLineNumbers=u}}e.ApplyEditsResult=_;function R(p){return!p.isTooLargeForSyncing()&&!p.isForSimpleWidget}e.shouldSynchronizeModel=R}),define(pe[151],ve([0,1,3,6,81,80]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRegistry=void 0;function T(D){return typeof D=="string"?!1:Array.isArray(D)?D.every(T):!!D.exclusive}class k{constructor(){this._clock=0,this._entries=[],this._onDidChange=new d.Emitter}get onDidChange(){return this._onDidChange.event}register(P,F){let y={selector:P,provider:F,_score:-1,_time:this._clock++};return this._entries.push(y),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,t.toDisposable)(()=>{if(y){const c=this._entries.indexOf(y);c>=0&&(this._entries.splice(c,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),y=void 0)}})}has(P){return this.all(P).length>0}all(P){if(!P)return[];this._updateScores(P);const F=[];for(let y of this._entries)y._score>0&&F.push(y.provider);return F}ordered(P){const F=[];return this._orderedForEach(P,y=>F.push(y.provider)),F}orderedGroups(P){const F=[];let y,c;return this._orderedForEach(P,E=>{y&&c===E._score?y.push(E.provider):(c=E._score,y=[E.provider],F.push(y))}),F}_orderedForEach(P,F){if(!!P){this._updateScores(P);for(const y of this._entries)y._score>0&&F(y)}}_updateScores(P){const F={uri:P.uri.toString(),language:P.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===F.language&&this._lastCandidate.uri===F.uri)){this._lastCandidate=F;for(let y of this._entries)if(y._score=(0,C.score)(y.selector,P.uri,P.getLanguageId(),(0,I.shouldSynchronizeModel)(P)),T(y.selector)&&y._score>0){for(let c of this._entries)c._score=0;y._score=1e3;break}this._entries.sort(k._compareByScoreAndTime)}}static _compareByScoreAndTime(P,F){return P._score<F._score?1:P._score>F._score?-1:P._time<F._time?1:P._time>F._time?-1:0}}e.LanguageFeatureRegistry=k}),define(pe[111],ve([0,1,17,101]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class I{constructor(D){this.values=D,this.prefixSum=new Uint32Array(D.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(D,P){D=(0,t.toUint32)(D);const F=this.values,y=this.prefixSum,c=P.length;return c===0?!1:(this.values=new Uint32Array(F.length+c),this.values.set(F.subarray(0,D),0),this.values.set(F.subarray(D),D+c),this.values.set(P,D),D-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=D-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(y.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(D,P){return D=(0,t.toUint32)(D),P=(0,t.toUint32)(P),this.values[D]===P?!1:(this.values[D]=P,D-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=D-1),!0)}removeValues(D,P){D=(0,t.toUint32)(D),P=(0,t.toUint32)(P);const F=this.values,y=this.prefixSum;if(D>=F.length)return!1;const c=F.length-D;return P>=c&&(P=c),P===0?!1:(this.values=new Uint32Array(F.length-P),this.values.set(F.subarray(0,D),0),this.values.set(F.subarray(D+P),D),this.prefixSum=new Uint32Array(this.values.length),D-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=D-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(y.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(D){return D<0?0:(D=(0,t.toUint32)(D),this._getPrefixSum(D))}_getPrefixSum(D){if(D<=this.prefixSumValidIndex[0])return this.prefixSum[D];let P=this.prefixSumValidIndex[0]+1;P===0&&(this.prefixSum[0]=this.values[0],P++),D>=this.values.length&&(D=this.values.length-1);for(let F=P;F<=D;F++)this.prefixSum[F]=this.prefixSum[F-1]+this.values[F];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],D),this.prefixSum[D]}getIndexOf(D){D=Math.floor(D),this.getTotalSum();let P=0,F=this.values.length-1,y=0,c=0,E=0;for(;P<=F;)if(y=P+(F-P)/2|0,c=this.prefixSum[y],E=c-this.values[y],D<E)F=y-1;else if(D>=c)P=y+1;else break;return new T(y,D-E)}}e.PrefixSumComputer=I;class C{constructor(D){this._values=D,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(D){return this._ensureValid(),D===0?0:this._prefixSum[D-1]}getIndexOf(D){this._ensureValid();const P=this._indexBySum[D],F=P>0?this._prefixSum[P-1]:0;return new T(P,D-F)}removeValues(D,P){this._values.splice(D,P),this._invalidate(D)}insertValues(D,P){this._values=(0,d.arrayInsert)(this._values,D,P),this._invalidate(D)}_invalidate(D){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,D-1)}_ensureValid(){if(!this._isValid){for(let D=this._validEndIndex+1,P=this._values.length;D<P;D++){const F=this._values[D],y=D>0?this._prefixSum[D-1]:0;this._prefixSum[D]=y+F;for(let c=0;c<F;c++)this._indexBySum[y+c]=D}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(D,P){this._values[D]!==P&&(this._values[D]=P,this._invalidate(D))}}e.ConstantTimePrefixSumComputer=C;class T{constructor(D,P){this.index=D,this.remainder=P,this._prefixSumIndexOfResultBrand=void 0,this.index=D,this.remainder=P}}e.PrefixSumIndexOfResult=T}),define(pe[152],ve([0,1,8,48,111]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class C{constructor(k,D,P,F){this._uri=k,this._lines=D,this._eol=P,this._versionId=F,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const D=k.changes;for(const P of D)this._acceptDeleteRange(P.range),this._acceptInsertText(new t.Position(P.range.startLineNumber,P.range.startColumn),P.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,D=this._lines.length,P=new Uint32Array(D);for(let F=0;F<D;F++)P[F]=this._lines[F].length+k;this._lineStarts=new I.PrefixSumComputer(P)}}_setLineText(k,D){this._lines[k]=D,this._lineStarts&&this._lineStarts.setValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,D){if(D.length===0)return;const P=(0,d.splitLines)(D);if(P.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+P[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}P[P.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+P[0]);const F=new Uint32Array(P.length-1);for(let y=1;y<P.length;y++)this._lines.splice(k.lineNumber+y-1,0,P[y]),F[y-1]=P[y].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,F)}}e.MirrorTextModel=C}),define(pe[153],ve([0,1,8,148,48,41,81]),function(ee,e,d,t,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class D{constructor(p,h,s,u){this.searchString=p,this.isRegex=h,this.matchCase=s,this.wordSeparators=u}parseSearchRequest(){if(this.searchString==="")return null;let p;this.isRegex?p=P(this.searchString):p=this.searchString.indexOf(`
`)>=0;let h=null;try{h=d.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:p,global:!0,unicode:!0})}catch{return null}if(!h)return null;let s=!this.isRegex&&!p;return s&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(s=this.matchCase),new T.SearchData(h,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,s?this.searchString:null)}}e.SearchParams=D;function P(R){if(!R||R.length===0)return!1;for(let p=0,h=R.length;p<h;p++)if(R.charCodeAt(p)===92){if(p++,p>=h)break;const u=R.charCodeAt(p);if(u===110||u===114||u===87)return!0}return!1}e.isMultilineRegexSource=P;function F(R,p,h){if(!h)return new T.FindMatch(R,null);const s=[];for(let u=0,r=p.length;u<r;u++)s[u]=p[u];return new T.FindMatch(R,s)}e.createFindMatch=F;class y{constructor(p){const h=[];let s=0;for(let u=0,r=p.length;u<r;u++)p.charCodeAt(u)===10&&(h[s++]=u);this._lineFeedsOffsets=h}findLineFeedCountBeforeOffset(p){const h=this._lineFeedsOffsets;let s=0,u=h.length-1;if(u===-1||p<=h[0])return 0;for(;s<u;){const r=s+((u-s)/2>>0);h[r]>=p?u=r-1:h[r+1]>=p?(s=r,u=r):s=r+1}return s+1}}class c{static findMatches(p,h,s,u,r){const S=h.parseSearchRequest();return S?S.regex.multiline?this._doFindMatchesMultiline(p,s,new _(S.wordSeparators,S.regex),u,r):this._doFindMatchesLineByLine(p,s,S,u,r):[]}static _getMultilineMatchRange(p,h,s,u,r,S){let a,i=0;u?(i=u.findLineFeedCountBeforeOffset(r),a=h+r+i):a=h+r;let n;if(u){const m=u.findLineFeedCountBeforeOffset(r+S.length)-i;n=a+S.length+m}else n=a+S.length;const o=p.getPositionAt(a),l=p.getPositionAt(n);return new C.Range(o.lineNumber,o.column,l.lineNumber,l.column)}static _doFindMatchesMultiline(p,h,s,u,r){const S=p.getOffsetAt(h.getStartPosition()),a=p.getValueInRange(h,1),i=p.getEOL()===`\r
`?new y(a):null,n=[];let o=0,l;for(s.reset(0);l=s.next(a);)if(n[o++]=F(this._getMultilineMatchRange(p,S,a,i,l.index,l[0]),l,u),o>=r)return n;return n}static _doFindMatchesLineByLine(p,h,s,u,r){const S=[];let a=0;if(h.startLineNumber===h.endLineNumber){const n=p.getLineContent(h.startLineNumber).substring(h.startColumn-1,h.endColumn-1);return a=this._findMatchesInLine(s,n,h.startLineNumber,h.startColumn-1,a,S,u,r),S}const i=p.getLineContent(h.startLineNumber).substring(h.startColumn-1);a=this._findMatchesInLine(s,i,h.startLineNumber,h.startColumn-1,a,S,u,r);for(let n=h.startLineNumber+1;n<h.endLineNumber&&a<r;n++)a=this._findMatchesInLine(s,p.getLineContent(n),n,0,a,S,u,r);if(a<r){const n=p.getLineContent(h.endLineNumber).substring(0,h.endColumn-1);a=this._findMatchesInLine(s,n,h.endLineNumber,0,a,S,u,r)}return S}static _findMatchesInLine(p,h,s,u,r,S,a,i){const n=p.wordSeparators;if(!a&&p.simpleSearch){const f=p.simpleSearch,m=f.length,b=h.length;let A=-m;for(;(A=h.indexOf(f,A+m))!==-1;)if((!n||w(n,h,b,A,m))&&(S[r++]=new T.FindMatch(new C.Range(s,A+1+u,s,A+1+m+u),null),r>=i))return r;return r}const o=new _(p.wordSeparators,p.regex);let l;o.reset(0);do if(l=o.next(h),l&&(S[r++]=F(new C.Range(s,l.index+1+u,s,l.index+1+l[0].length+u),l,a),r>=i))return r;while(l);return r}static findNextMatch(p,h,s,u){const r=h.parseSearchRequest();if(!r)return null;const S=new _(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(p,s,S,u):this._doFindNextMatchLineByLine(p,s,S,u)}static _doFindNextMatchMultiline(p,h,s,u){const r=new I.Position(h.lineNumber,1),S=p.getOffsetAt(r),a=p.getLineCount(),i=p.getValueInRange(new C.Range(r.lineNumber,r.column,a,p.getLineMaxColumn(a)),1),n=p.getEOL()===`\r
`?new y(i):null;s.reset(h.column-1);let o=s.next(i);return o?F(this._getMultilineMatchRange(p,S,i,n,o.index,o[0]),o,u):h.lineNumber!==1||h.column!==1?this._doFindNextMatchMultiline(p,new I.Position(1,1),s,u):null}static _doFindNextMatchLineByLine(p,h,s,u){const r=p.getLineCount(),S=h.lineNumber,a=p.getLineContent(S),i=this._findFirstMatchInLine(s,a,S,h.column,u);if(i)return i;for(let n=1;n<=r;n++){const o=(S+n-1)%r,l=p.getLineContent(o+1),f=this._findFirstMatchInLine(s,l,o+1,1,u);if(f)return f}return null}static _findFirstMatchInLine(p,h,s,u,r){p.reset(u-1);const S=p.next(h);return S?F(new C.Range(s,S.index+1,s,S.index+1+S[0].length),S,r):null}static findPreviousMatch(p,h,s,u){const r=h.parseSearchRequest();if(!r)return null;const S=new _(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(p,s,S,u):this._doFindPreviousMatchLineByLine(p,s,S,u)}static _doFindPreviousMatchMultiline(p,h,s,u){const r=this._doFindMatchesMultiline(p,new C.Range(1,1,h.lineNumber,h.column),s,u,10*k);if(r.length>0)return r[r.length-1];const S=p.getLineCount();return h.lineNumber!==S||h.column!==p.getLineMaxColumn(S)?this._doFindPreviousMatchMultiline(p,new I.Position(S,p.getLineMaxColumn(S)),s,u):null}static _doFindPreviousMatchLineByLine(p,h,s,u){const r=p.getLineCount(),S=h.lineNumber,a=p.getLineContent(S).substring(0,h.column-1),i=this._findLastMatchInLine(s,a,S,u);if(i)return i;for(let n=1;n<=r;n++){const o=(r+S-n-1)%r,l=p.getLineContent(o+1),f=this._findLastMatchInLine(s,l,o+1,u);if(f)return f}return null}static _findLastMatchInLine(p,h,s,u){let r=null,S;for(p.reset(0);S=p.next(h);)r=F(new C.Range(s,S.index+1,s,S.index+1+S[0].length),S,u);return r}}e.TextModelSearch=c;function E(R,p,h,s,u){if(s===0)return!0;const r=p.charCodeAt(s-1);if(R.get(r)!==0||r===13||r===10)return!0;if(u>0){const S=p.charCodeAt(s);if(R.get(S)!==0)return!0}return!1}function v(R,p,h,s,u){if(s+u===h)return!0;const r=p.charCodeAt(s+u);if(R.get(r)!==0||r===13||r===10)return!0;if(u>0){const S=p.charCodeAt(s+u-1);if(R.get(S)!==0)return!0}return!1}function w(R,p,h,s,u){return E(R,p,h,s,u)&&v(R,p,h,s,u)}e.isValidMatch=w;class _{constructor(p,h){this._wordSeparators=p,this._searchRegex=h,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(p){this._searchRegex.lastIndex=p,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(p){const h=p.length;let s;do{if(this._prevMatchStartIndex+this._prevMatchLength===h||(s=this._searchRegex.exec(p),!s))return null;const u=s.index,r=s[0].length;if(u===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){d.getNextCodePoint(p,h,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=u,this._prevMatchLength=r,!this._wordSeparators||w(this._wordSeparators,p,h,u,r))return s}while(s);return null}}e.Searcher=_}),define(pe[112],ve([0,1,23,11]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var I;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(I||(I={}));function C(y){for(let c=0,E=y.length;c<E;c+=4){const v=y[c+0],w=y[c+1],_=y[c+2],R=y[c+3];y[c+0]=R,y[c+1]=_,y[c+2]=w,y[c+3]=v}}function T(y){const c=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return t.isLittleEndian()||C(c),d.VSBuffer.wrap(c)}function k(y){const c=y.buffer;if(t.isLittleEndian()||C(c),c.byteOffset%4==0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const E=new Uint8Array(c.byteLength);return E.set(c),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function D(y){const c=new Uint32Array(P(y));let E=0;if(c[E++]=y.id,y.type==="full")c[E++]=1,c[E++]=y.data.length,c.set(y.data,E),E+=y.data.length;else{c[E++]=2,c[E++]=y.deltas.length;for(const v of y.deltas)c[E++]=v.start,c[E++]=v.deleteCount,v.data?(c[E++]=v.data.length,c.set(v.data,E),E+=v.data.length):c[E++]=0}return T(c)}e.encodeSemanticTokensDto=D;function P(y){let c=0;if(c+=1+1,y.type==="full")c+=1+y.data.length;else{c+=1,c+=(1+1+1)*y.deltas.length;for(const E of y.deltas)E.data&&(c+=E.data.length)}return c}function F(y){const c=k(y);let E=0;const v=c[E++];if(c[E++]===1){const p=c[E++],h=c.subarray(E,E+p);return E+=p,{id:v,type:"full",data:h}}const _=c[E++],R=[];for(let p=0;p<_;p++){const h=c[E++],s=c[E++],u=c[E++];let r;u>0&&(r=c.subarray(E,E+u),E+=u),R[p]={start:h,deleteCount:s,data:r}}return{id:v,type:"delta",deltas:R}}e.decodeSemanticTokensDto=F}),define(pe[154],ve([0,1,3,6]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class I{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new d.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(k){this._onDidChange.fire({changedLanguages:k,changedColorMap:!1})}register(k,D){return this._map.set(k,D),this.fire([k]),(0,t.toDisposable)(()=>{this._map.get(k)===D&&(this._map.delete(k),this.fire([k]))})}registerFactory(k,D){this._factories.get(k)?.dispose();const P=new C(this,k,D);return this._factories.set(k,P),(0,t.toDisposable)(()=>{const F=this._factories.get(k);!F||F!==P||(this._factories.delete(k),F.dispose())})}async getOrCreate(k){const D=this.get(k);if(D)return D;const P=this._factories.get(k);return!P||P.isResolved?null:(await P.resolve(),this.get(k))}get(k){return this._map.get(k)||null}isResolved(k){if(this.get(k))return!0;const P=this._factories.get(k);return!!(!P||P.isResolved)}setColorMap(k){this._colorMap=k,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=I;class C extends t.Disposable{constructor(k,D,P){super();this._registry=k,this._languageId=D,this._factory=P,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const k=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,k&&!this._isDisposed&&this._register(this._registry.register(this._languageId,k))}}}),define(pe[82],ve([0,1,2,41,151,154,73]),function(ee,e,d,t,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var k;(function(g){g[g.Null=0]="Null",g[g.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));var D;(function(g){g[g.NotSet=-1]="NotSet",g[g.None=0]="None",g[g.Italic=1]="Italic",g[g.Bold=2]="Bold",g[g.Underline=4]="Underline",g[g.Strikethrough=8]="Strikethrough"})(D=e.FontStyle||(e.FontStyle={}));var P;(function(g){g[g.None=0]="None",g[g.DefaultForeground=1]="DefaultForeground",g[g.DefaultBackground=2]="DefaultBackground"})(P=e.ColorId||(e.ColorId={}));var F;(function(g){g[g.Other=0]="Other",g[g.Comment=1]="Comment",g[g.String=2]="String",g[g.RegEx=3]="RegEx"})(F=e.StandardTokenType||(e.StandardTokenType={}));var y;(function(g){g[g.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",g[g.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",g[g.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",g[g.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",g[g.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",g[g.ITALIC_MASK=1024]="ITALIC_MASK",g[g.BOLD_MASK=2048]="BOLD_MASK",g[g.UNDERLINE_MASK=4096]="UNDERLINE_MASK",g[g.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",g[g.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",g[g.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",g[g.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",g[g.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",g[g.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",g[g.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",g[g.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",g[g.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",g[g.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",g[g.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",g[g.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(y=e.MetadataConsts||(e.MetadataConsts={}));class c{static getLanguageId(M){return(M&255)>>>0}static getTokenType(M){return(M&768)>>>8}static getFontStyle(M){return(M&15360)>>>10}static getForeground(M){return(M&8372224)>>>14}static getBackground(M){return(M&4286578688)>>>23}static getClassNameFromMetadata(M){const U=this.getForeground(M);let j="mtk"+U;const K=this.getFontStyle(M);return K&1&&(j+=" mtki"),K&2&&(j+=" mtkb"),K&4&&(j+=" mtku"),K&8&&(j+=" mtks"),j}static getInlineStyleFromMetadata(M,U){const j=this.getForeground(M),K=this.getFontStyle(M);let B=`color: ${U[j]};`;K&1&&(B+="font-style: italic;"),K&2&&(B+="font-weight: bold;");let x="";return K&4&&(x+=" underline"),K&8&&(x+=" line-through"),x&&(B+=`text-decoration:${x};`),B}static getPresentationFromMetadata(M){const U=this.getForeground(M),j=this.getFontStyle(M);return{foreground:U,italic:Boolean(j&1),bold:Boolean(j&2),underline:Boolean(j&4),strikethrough:Boolean(j&8)}}}e.TokenMetadata=c;class E{constructor(M,U,j){this._tokenBrand=void 0,this.offset=M,this.type=U,this.language=j}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=E;class v{constructor(M,U){this._tokenizationResultBrand=void 0,this.tokens=M,this.endState=U}}e.TokenizationResult=v;class w{constructor(M,U){this._encodedTokenizationResultBrand=void 0,this.tokens=M,this.endState=U}}e.EncodedTokenizationResult=w;var _;(function(g){g[g.Method=0]="Method",g[g.Function=1]="Function",g[g.Constructor=2]="Constructor",g[g.Field=3]="Field",g[g.Variable=4]="Variable",g[g.Class=5]="Class",g[g.Struct=6]="Struct",g[g.Interface=7]="Interface",g[g.Module=8]="Module",g[g.Property=9]="Property",g[g.Event=10]="Event",g[g.Operator=11]="Operator",g[g.Unit=12]="Unit",g[g.Value=13]="Value",g[g.Constant=14]="Constant",g[g.Enum=15]="Enum",g[g.EnumMember=16]="EnumMember",g[g.Keyword=17]="Keyword",g[g.Text=18]="Text",g[g.Color=19]="Color",g[g.File=20]="File",g[g.Reference=21]="Reference",g[g.Customcolor=22]="Customcolor",g[g.Folder=23]="Folder",g[g.TypeParameter=24]="TypeParameter",g[g.User=25]="User",g[g.Issue=26]="Issue",g[g.Snippet=27]="Snippet"})(_=e.CompletionItemKind||(e.CompletionItemKind={}));var R;(function(g){const M=new Map;M.set(0,T.Codicon.symbolMethod),M.set(1,T.Codicon.symbolFunction),M.set(2,T.Codicon.symbolConstructor),M.set(3,T.Codicon.symbolField),M.set(4,T.Codicon.symbolVariable),M.set(5,T.Codicon.symbolClass),M.set(6,T.Codicon.symbolStruct),M.set(7,T.Codicon.symbolInterface),M.set(8,T.Codicon.symbolModule),M.set(9,T.Codicon.symbolProperty),M.set(10,T.Codicon.symbolEvent),M.set(11,T.Codicon.symbolOperator),M.set(12,T.Codicon.symbolUnit),M.set(13,T.Codicon.symbolValue),M.set(15,T.Codicon.symbolEnum),M.set(14,T.Codicon.symbolConstant),M.set(15,T.Codicon.symbolEnum),M.set(16,T.Codicon.symbolEnumMember),M.set(17,T.Codicon.symbolKeyword),M.set(27,T.Codicon.symbolSnippet),M.set(18,T.Codicon.symbolText),M.set(19,T.Codicon.symbolColor),M.set(20,T.Codicon.symbolFile),M.set(21,T.Codicon.symbolReference),M.set(22,T.Codicon.symbolCustomColor),M.set(23,T.Codicon.symbolFolder),M.set(24,T.Codicon.symbolTypeParameter),M.set(25,T.Codicon.account),M.set(26,T.Codicon.issues);function U(B){let x=M.get(B);return x||(console.info("No codicon found for CompletionItemKind "+B),x=T.Codicon.symbolProperty),x}g.toIcon=U;const j=new Map;j.set("method",0),j.set("function",1),j.set("constructor",2),j.set("field",3),j.set("variable",4),j.set("class",5),j.set("struct",6),j.set("interface",7),j.set("module",8),j.set("property",9),j.set("event",10),j.set("operator",11),j.set("unit",12),j.set("value",13),j.set("constant",14),j.set("enum",15),j.set("enum-member",16),j.set("enumMember",16),j.set("keyword",17),j.set("snippet",27),j.set("text",18),j.set("color",19),j.set("file",20),j.set("reference",21),j.set("customcolor",22),j.set("folder",23),j.set("type-parameter",24),j.set("typeParameter",24),j.set("account",25),j.set("issue",26);function K(B,x){let z=j.get(B);return typeof z=="undefined"&&!x&&(z=9),z}g.fromString=K})(R=e.CompletionItemKinds||(e.CompletionItemKinds={}));var p;(function(g){g[g.Deprecated=1]="Deprecated"})(p=e.CompletionItemTag||(e.CompletionItemTag={}));var h;(function(g){g[g.KeepWhitespace=1]="KeepWhitespace",g[g.InsertAsSnippet=4]="InsertAsSnippet"})(h=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var s;(function(g){g[g.Invoke=0]="Invoke",g[g.TriggerCharacter=1]="TriggerCharacter",g[g.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(s=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var u;(function(g){g[g.Automatic=0]="Automatic",g[g.Explicit=1]="Explicit"})(u=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var r;(function(g){g[g.Invoke=1]="Invoke",g[g.Auto=2]="Auto"})(r=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var S;(function(g){g[g.Invoke=1]="Invoke",g[g.TriggerCharacter=2]="TriggerCharacter",g[g.ContentChange=3]="ContentChange"})(S=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var a;(function(g){g[g.Text=0]="Text",g[g.Read=1]="Read",g[g.Write=2]="Write"})(a=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function i(g){return g&&d.URI.isUri(g.uri)&&t.Range.isIRange(g.range)&&(t.Range.isIRange(g.originSelectionRange)||t.Range.isIRange(g.targetSelectionRange))}e.isLocationLink=i;var n;(function(g){g[g.File=0]="File",g[g.Module=1]="Module",g[g.Namespace=2]="Namespace",g[g.Package=3]="Package",g[g.Class=4]="Class",g[g.Method=5]="Method",g[g.Property=6]="Property",g[g.Field=7]="Field",g[g.Constructor=8]="Constructor",g[g.Enum=9]="Enum",g[g.Interface=10]="Interface",g[g.Function=11]="Function",g[g.Variable=12]="Variable",g[g.Constant=13]="Constant",g[g.String=14]="String",g[g.Number=15]="Number",g[g.Boolean=16]="Boolean",g[g.Array=17]="Array",g[g.Object=18]="Object",g[g.Key=19]="Key",g[g.Null=20]="Null",g[g.EnumMember=21]="EnumMember",g[g.Struct=22]="Struct",g[g.Event=23]="Event",g[g.Operator=24]="Operator",g[g.TypeParameter=25]="TypeParameter"})(n=e.SymbolKind||(e.SymbolKind={}));var o;(function(g){g[g.Deprecated=1]="Deprecated"})(o=e.SymbolTag||(e.SymbolTag={}));var l;(function(g){const M=new Map;M.set(0,T.Codicon.symbolFile),M.set(1,T.Codicon.symbolModule),M.set(2,T.Codicon.symbolNamespace),M.set(3,T.Codicon.symbolPackage),M.set(4,T.Codicon.symbolClass),M.set(5,T.Codicon.symbolMethod),M.set(6,T.Codicon.symbolProperty),M.set(7,T.Codicon.symbolField),M.set(8,T.Codicon.symbolConstructor),M.set(9,T.Codicon.symbolEnum),M.set(10,T.Codicon.symbolInterface),M.set(11,T.Codicon.symbolFunction),M.set(12,T.Codicon.symbolVariable),M.set(13,T.Codicon.symbolConstant),M.set(14,T.Codicon.symbolString),M.set(15,T.Codicon.symbolNumber),M.set(16,T.Codicon.symbolBoolean),M.set(17,T.Codicon.symbolArray),M.set(18,T.Codicon.symbolObject),M.set(19,T.Codicon.symbolKey),M.set(20,T.Codicon.symbolNull),M.set(21,T.Codicon.symbolEnumMember),M.set(22,T.Codicon.symbolStruct),M.set(23,T.Codicon.symbolEvent),M.set(24,T.Codicon.symbolOperator),M.set(25,T.Codicon.symbolTypeParameter);function U(j){let K=M.get(j);return K||(console.info("No codicon found for SymbolKind "+j),K=T.Codicon.symbolProperty),K}g.toIcon=U})(l=e.SymbolKinds||(e.SymbolKinds={}));class f{constructor(M){this.value=M}}e.FoldingRangeKind=f,f.Comment=new f("comment"),f.Imports=new f("imports"),f.Region=new f("region");var m;(function(g){function M(U){return!U||typeof U!="object"?!1:typeof U.id=="string"&&typeof U.title=="string"}g.is=M})(m=e.Command||(e.Command={}));var b;(function(g){g[g.Collapsed=0]="Collapsed",g[g.Expanded=1]="Expanded"})(b=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var A;(function(g){g[g.Editing=0]="Editing",g[g.Preview=1]="Preview"})(A=e.CommentMode||(e.CommentMode={}));var L;(function(g){g[g.Other=0]="Other",g[g.Type=1]="Type",g[g.Parameter=2]="Parameter"})(L=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new I.LanguageFeatureRegistry,e.RenameProviderRegistry=new I.LanguageFeatureRegistry,e.CompletionProviderRegistry=new I.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new I.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new I.LanguageFeatureRegistry,e.HoverProviderRegistry=new I.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new I.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new I.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new I.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new I.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new I.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new I.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new I.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new I.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new I.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new I.LanguageFeatureRegistry,e.LinkProviderRegistry=new I.LanguageFeatureRegistry,e.ColorProviderRegistry=new I.LanguageFeatureRegistry,e.SelectionRangeRegistry=new I.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new I.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new I.LanguageFeatureRegistry,e.TokenizationRegistry=new C.TokenizationRegistry;var N;(function(g){g[g.None=0]="None",g[g.Option=1]="Option",g[g.Default=2]="Default",g[g.Preferred=3]="Preferred"})(N=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(pe[155],ve([19,20]),function(ee,e){return ee.create("vs/base/common/date",e)}),define(pe[156],ve([0,1,155]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,I=t*60,C=I*24,T=C*7,k=C*30,D=C*365;function P(y,c,E){typeof y!="number"&&(y=y.getTime());const v=Math.round((new Date().getTime()-y)/1e3);if(v<-30)return(0,d.localize)(0,null,P(new Date().getTime()+v*1e3,!1));if(v<30)return(0,d.localize)(1,null);let w;return v<t?(w=v,c?w===1?E?(0,d.localize)(2,null,w):(0,d.localize)(3,null,w):E?(0,d.localize)(4,null,w):(0,d.localize)(5,null,w):w===1?E?(0,d.localize)(6,null,w):(0,d.localize)(7,null,w):E?(0,d.localize)(8,null,w):(0,d.localize)(9,null,w)):v<I?(w=Math.floor(v/t),c?w===1?E?(0,d.localize)(10,null,w):(0,d.localize)(11,null,w):E?(0,d.localize)(12,null,w):(0,d.localize)(13,null,w):w===1?E?(0,d.localize)(14,null,w):(0,d.localize)(15,null,w):E?(0,d.localize)(16,null,w):(0,d.localize)(17,null,w)):v<C?(w=Math.floor(v/I),c?w===1?E?(0,d.localize)(18,null,w):(0,d.localize)(19,null,w):E?(0,d.localize)(20,null,w):(0,d.localize)(21,null,w):w===1?E?(0,d.localize)(22,null,w):(0,d.localize)(23,null,w):E?(0,d.localize)(24,null,w):(0,d.localize)(25,null,w)):v<T?(w=Math.floor(v/C),c?w===1?(0,d.localize)(26,null,w):(0,d.localize)(27,null,w):w===1?(0,d.localize)(28,null,w):(0,d.localize)(29,null,w)):v<k?(w=Math.floor(v/T),c?w===1?E?(0,d.localize)(30,null,w):(0,d.localize)(31,null,w):E?(0,d.localize)(32,null,w):(0,d.localize)(33,null,w):w===1?E?(0,d.localize)(34,null,w):(0,d.localize)(35,null,w):E?(0,d.localize)(36,null,w):(0,d.localize)(37,null,w)):v<D?(w=Math.floor(v/k),c?w===1?E?(0,d.localize)(38,null,w):(0,d.localize)(39,null,w):E?(0,d.localize)(40,null,w):(0,d.localize)(41,null,w):w===1?E?(0,d.localize)(42,null,w):(0,d.localize)(43,null,w):E?(0,d.localize)(44,null,w):(0,d.localize)(45,null,w)):(w=Math.floor(v/D),c?w===1?E?(0,d.localize)(46,null,w):(0,d.localize)(47,null,w):E?(0,d.localize)(48,null,w):(0,d.localize)(49,null,w):w===1?E?(0,d.localize)(50,null,w):(0,d.localize)(51,null,w):E?(0,d.localize)(52,null,w):(0,d.localize)(53,null,w))}e.fromNow=P;function F(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=F}),define(pe[157],ve([19,20]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(pe[49],ve([0,1,17,18,157]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function C(P,F){return F&&(P.stack||P.stacktrace)?I.localize(0,null,k(P),T(P.stack)||T(P.stacktrace)):k(P)}function T(P){return Array.isArray(P)?P.join(`
`):P}function k(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?I.localize(1,null,P.message):P.message||I.localize(2,null)}function D(P=null,F=!1){if(!P)return I.localize(3,null);if(Array.isArray(P)){const y=d.coalesce(P),c=D(y[0],F);return y.length>1?I.localize(4,null,c,y.length):c}if(t.isString(P))return P;if(P.detail){const y=P.detail;if(y.error)return C(y.error,F);if(y.exception)return C(y.exception,F)}return P.stack?C(P,F):P.message?P.message:I.localize(5,null)}e.toErrorMessage=D}),define(pe[158],ve([19,20]),function(ee,e){return ee.create("vs/base/node/processes",e)}),define(pe[113],ve([0,1,38,28,10,25,9,11,37,97,18,145,29,158]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function v(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function w(r,S){if(k.isWindows)try{const a={stdio:["pipe","pipe","ignore"]};S&&(a.cwd=S);const i=d.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],a);return new Promise(n=>{i.once("error",o=>{n({success:!1,error:o})}),i.once("exit",(o,l)=>{n(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(a){return Promise.resolve({success:!1,error:a,code:a.status?v(a.status):1})}else if(k.isLinux||k.isMacintosh)try{const a=I.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",ee).fsPath;return new Promise(i=>{d.execFile(a,[r.pid.toString()],{encoding:"utf8",shell:!0},(n,o,l)=>{i(n?{success:!1,error:n}:{success:!0})})})}catch(a){return Promise.resolve({success:!1,error:a})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function _(r){!r||(delete r.DEBUG,k.isMacintosh&&delete r.DYLD_LIBRARY_PATH,k.isLinux&&delete r.LD_PRELOAD)}e.removeDangerousEnvVariables=_;function R(r=D.env){return r.comspec||"cmd.exe"}e.getWindowsShell=R;class p{constructor(S,a,i,n){if(a!==void 0&&i!==void 0&&n!==void 0)this.cmd=S,this.args=a,this.shell=i,this.options=n;else{const o=S;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(D.env).forEach(l=>{o[l]=D.env[l]}),Object.keys(this.options.env).forEach(l=>{o[l]=this.options.env[l]}),this.options.env=o}}getSanitizedCommand(){let S=this.cmd.toLowerCase();const a=S.lastIndexOf(T.sep);return a!==-1&&(S=S.substring(a+1)),p.WellKnowCommands[S]?S:"other"}start(S){return k.isWindows&&(this.options&&this.options.cwd&&t.isUNC(this.options.cwd)||!this.options&&t.isUNC(D.cwd()))?Promise.reject(new Error(E.localize(0,null))):this.useExec().then(a=>{let i,n;const o=new Promise((l,f)=>{i=l,n=f});if(a){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=d.exec(l,this.options,(f,m,b)=>{this.childProcess=null;const A=f;A&&A.killed?n({killed:this.terminateRequested,stdout:m.toString(),stderr:b.toString()}):this.handleExec(i,S,f,m,b)})}else{let l=null;const f=m=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(m,i,S,n);const b={terminated:this.terminateRequested};F.isNumber(m)&&(b.cmdCode=m),i(b)};if(this.shell&&k.isWindows){const m=C.deepClone(this.options);m.windowsVerbatimArguments=!0,m.detached=!1;let b=!1,A=!1;const L=[];let N=this.ensureQuotes(this.cmd);L.push(N.value),b=N.quoted,this.args&&this.args.forEach(M=>{N=this.ensureQuotes(M),L.push(N.value),A=A&&N.quoted});const g=["/s","/c"];b?A?g.push('"'+L.join(" ")+'"'):L.length>1?g.push('"'+L[0]+'" '+L.slice(1).join(" ")):g.push('"'+L[0]+'"'):g.push(L.join(" ")),l=d.spawn(R(),g,m)}else this.cmd&&(l=d.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(F.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",m=>{this.childProcess=null,n({terminated:this.terminateRequested,error:m})}),l.pid&&(this.childProcess.on("close",f),this.handleSpawn(l,i,S,n,!0)))}return o})}handleClose(S,a,i,n){}ensureQuotes(S){return p.regexp.test(S)?{value:'"'+S+'"',quoted:!0}:{value:S,quoted:S.length>0&&S[0]==='"'&&S[S.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(S=>S.pid,S=>-1):new Promise(S=>{this.pidResolve=S})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(S=>(this.terminateRequested=!0,w(S,this.options.cwd).then(a=>(a.success&&(this.childProcess=null),a))),S=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(S=>{if(!this.shell||!k.isWindows)return S(!1);const a=d.spawn(R(),["/s","/c"]);a.on("error",i=>S(!0)),a.on("exit",i=>S(!1))})}}e.AbstractProcess=p,p.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},p.regexp=/^[^"].* .*[^"]/;class h extends p{constructor(S,a,i,n){super(S,a,i,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(S,a,i,n,o){[n,o].forEach((l,f)=>{const m=new y.LineDecoder;m.write(l).forEach(L=>{a({line:L,source:f===0?0:1})});const A=m.end();A&&a({line:A,source:f===0?0:1})}),S({terminated:this.terminateRequested,error:i})}handleSpawn(S,a,i,n,o){const l=new y.LineDecoder,f=new y.LineDecoder;S.stdout.on("data",m=>{l.write(m).forEach(A=>i({line:A,source:0}))}),S.stderr.on("data",m=>{f.write(m).forEach(A=>i({line:A,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=f}handleClose(S,a,i,n){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&i({line:o,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&i({line:l,source:1})}}e.LineProcess=h;function s(r){let S=[],a=!1;const i=function(n){if(a){S.push(n);return}(!r.send(n,l=>{if(l&&console.error(l),a=!1,S.length>0){const f=S.slice(0);S=[],f.forEach(m=>i(m))}})||k.isWindows)&&(a=!0)};return{send:i}}e.createQueuedSender=s;var u;(function(r){async function S(a,i,n){if(T.isAbsolute(a))return a;if(i===void 0&&(i=D.cwd()),T.dirname(a)!=="."||(n===void 0&&F.isString(D.env.PATH)&&(n=D.env.PATH.split(T.delimiter)),n===void 0||n.length===0))return T.join(i,a);async function l(f){if(await c.Promises.exists(f)){let m;try{m=await c.Promises.stat(f)}catch(b){b.message.startsWith("EACCES")&&(m=await c.Promises.lstat(f))}return m?!m.isDirectory():!1}return!1}for(let f of n){let m;if(T.isAbsolute(f)?m=T.join(f,a):m=T.join(i,f,a),await l(m))return m;let b=m+".com";if(await l(b)||(b=m+".exe",await l(b)))return b}return T.join(i,a)}r.findExecutable=S})(u=e.win32||(e.win32={}))}),define(pe[159],ve([19,20]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(pe[114],ve([0,1,159,11,110,17,25,147]),function(ee,e,d,t,I,C,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var D;(function(ne){ne[ne.None=0]="None",ne[ne.Keep=1]="Keep",ne[ne.Brackets=2]="Brackets",ne[ne.Advanced=3]="Advanced",ne[ne.Full=4]="Full"})(D=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class P{constructor(oe){this._values=oe}hasChanged(oe){return this._values[oe]}}e.ConfigurationChangedEvent=P;class F{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=F;class y{constructor(oe,Y,ge,_e){this.id=oe,this.name=Y,this.defaultValue=ge,this.schema=_e}applyUpdate(oe,Y){return E(oe,Y)}compute(oe,Y,ge){return ge}}class c{constructor(oe,Y){this.newValue=oe,this.didChange=Y}}e.ApplyUpdateResult=c;function E(ne,oe){if(typeof ne!="object"||typeof oe!="object"||!ne||!oe)return new c(oe,ne!==oe);if(Array.isArray(ne)||Array.isArray(oe)){const ge=Array.isArray(ne)&&Array.isArray(oe)&&C.equals(ne,oe);return new c(oe,ge)}let Y=!1;for(const ge in oe)if(oe.hasOwnProperty(ge)){const _e=E(ne[ge],oe[ge]);_e.didChange&&(ne[ge]=_e.newValue,Y=!0)}return new c(ne,Y)}class v{constructor(oe){this.schema=void 0,this.id=oe,this.name="_never_",this.defaultValue=void 0}applyUpdate(oe,Y){return E(oe,Y)}validate(oe){return this.defaultValue}}class w{constructor(oe,Y,ge,_e){this.id=oe,this.name=Y,this.defaultValue=ge,this.schema=_e}applyUpdate(oe,Y){return E(oe,Y)}validate(oe){return typeof oe=="undefined"?this.defaultValue:oe}compute(oe,Y,ge){return ge}}function _(ne,oe){return typeof ne=="undefined"?oe:ne==="false"?!1:Boolean(ne)}e.boolean=_;class R extends w{constructor(oe,Y,ge,_e=void 0){typeof _e!="undefined"&&(_e.type="boolean",_e.default=ge);super(oe,Y,ge,_e)}validate(oe){return _(oe,this.defaultValue)}}function p(ne,oe,Y,ge){if(typeof ne=="undefined")return oe;let _e=parseInt(ne,10);return isNaN(_e)?oe:(_e=Math.max(Y,_e),_e=Math.min(ge,_e),_e|0)}e.clampedInt=p;class h extends w{constructor(oe,Y,ge,_e,Oe,ze=void 0){typeof ze!="undefined"&&(ze.type="integer",ze.default=ge,ze.minimum=_e,ze.maximum=Oe);super(oe,Y,ge,ze);this.minimum=_e,this.maximum=Oe}static clampedInt(oe,Y,ge,_e){return p(oe,Y,ge,_e)}validate(oe){return h.clampedInt(oe,this.defaultValue,this.minimum,this.maximum)}}class s extends w{constructor(oe,Y,ge,_e,Oe){typeof Oe!="undefined"&&(Oe.type="number",Oe.default=ge);super(oe,Y,ge,Oe);this.validationFn=_e}static clamp(oe,Y,ge){return oe<Y?Y:oe>ge?ge:oe}static float(oe,Y){if(typeof oe=="number")return oe;if(typeof oe=="undefined")return Y;const ge=parseFloat(oe);return isNaN(ge)?Y:ge}validate(oe){return this.validationFn(s.float(oe,this.defaultValue))}}class u extends w{static string(oe,Y){return typeof oe!="string"?Y:oe}constructor(oe,Y,ge,_e=void 0){typeof _e!="undefined"&&(_e.type="string",_e.default=ge);super(oe,Y,ge,_e)}validate(oe){return u.string(oe,this.defaultValue)}}function r(ne,oe,Y){return typeof ne!="string"||Y.indexOf(ne)===-1?oe:ne}e.stringSet=r;class S extends w{constructor(oe,Y,ge,_e,Oe=void 0){typeof Oe!="undefined"&&(Oe.type="string",Oe.enum=_e,Oe.default=ge);super(oe,Y,ge,Oe);this._allowedValues=_e}validate(oe){return r(oe,this.defaultValue,this._allowedValues)}}class a extends y{constructor(oe,Y,ge,_e,Oe,ze,Ze=void 0){typeof Ze!="undefined"&&(Ze.type="string",Ze.enum=Oe,Ze.default=_e);super(oe,Y,ge,Ze);this._allowedValues=Oe,this._convert=ze}validate(oe){return typeof oe!="string"?this.defaultValue:this._allowedValues.indexOf(oe)===-1?this.defaultValue:this._convert(oe)}}function i(ne){switch(ne){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class n extends y{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[d.localize(0,null),d.localize(1,null),d.localize(2,null)],default:"auto",description:d.localize(3,null)})}validate(oe){switch(oe){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(oe,Y,ge){return ge===0?oe.accessibilitySupport:ge}}class o extends y{constructor(){const oe={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",oe,{"editor.comments.insertSpace":{type:"boolean",default:oe.insertSpace,description:d.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:oe.ignoreEmptyLines,description:d.localize(5,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Y=oe;return{insertSpace:_(Y.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:_(Y.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var l;(function(ne){ne[ne.Hidden=0]="Hidden",ne[ne.Blink=1]="Blink",ne[ne.Smooth=2]="Smooth",ne[ne.Phase=3]="Phase",ne[ne.Expand=4]="Expand",ne[ne.Solid=5]="Solid"})(l=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function f(ne){switch(ne){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var m;(function(ne){ne[ne.Line=1]="Line",ne[ne.Block=2]="Block",ne[ne.Underline=3]="Underline",ne[ne.LineThin=4]="LineThin",ne[ne.BlockOutline=5]="BlockOutline",ne[ne.UnderlineThin=6]="UnderlineThin"})(m=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function b(ne){switch(ne){case m.Line:return"line";case m.Block:return"block";case m.Underline:return"underline";case m.LineThin:return"line-thin";case m.BlockOutline:return"block-outline";case m.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=b;function A(ne){switch(ne){case"line":return m.Line;case"block":return m.Block;case"underline":return m.Underline;case"line-thin":return m.LineThin;case"block-outline":return m.BlockOutline;case"underline-thin":return m.UnderlineThin}}class L extends v{constructor(){super(128)}compute(oe,Y,ge){const _e=["monaco-editor"];return Y.get(33)&&_e.push(Y.get(33)),oe.extraEditorClassName&&_e.push(oe.extraEditorClassName),Y.get(66)==="default"?_e.push("mouse-default"):Y.get(66)==="copy"&&_e.push("mouse-copy"),Y.get(100)&&_e.push("showUnused"),Y.get(126)&&_e.push("showDeprecated"),_e.join(" ")}}class N extends R{constructor(){super(32,"emptySelectionClipboard",!0,{description:d.localize(6,null)})}compute(oe,Y,ge){return ge&&oe.emptySelectionClipboard}}class g extends y{constructor(){const oe={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",oe,{"editor.find.cursorMoveOnType":{type:"boolean",default:oe.cursorMoveOnType,description:d.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:oe.seedSearchStringFromSelection,enumDescriptions:[d.localize(8,null),d.localize(9,null),d.localize(10,null)],description:d.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:oe.autoFindInSelection,enumDescriptions:[d.localize(12,null),d.localize(13,null),d.localize(14,null)],description:d.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:oe.globalFindClipboard,description:d.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:oe.addExtraSpaceOnTop,description:d.localize(17,null)},"editor.find.loop":{type:"boolean",default:oe.loop,description:d.localize(18,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Y=oe;return{cursorMoveOnType:_(Y.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof oe.seedSearchStringFromSelection=="boolean"?oe.seedSearchStringFromSelection?"always":"never":r(Y.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof oe.autoFindInSelection=="boolean"?oe.autoFindInSelection?"always":"never":r(Y.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:_(Y.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:_(Y.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:_(Y.loop,this.defaultValue.loop)}}}class M extends y{constructor(){super(45,"fontLigatures",M.OFF,{anyOf:[{type:"boolean",description:d.localize(19,null)},{type:"string",description:d.localize(20,null)}],description:d.localize(21,null),default:!1})}validate(oe){return typeof oe=="undefined"?this.defaultValue:typeof oe=="string"?oe==="false"?M.OFF:oe==="true"?M.ON:oe:Boolean(oe)?M.ON:M.OFF}}e.EditorFontLigatures=M,M.OFF='"liga" off, "calt" off',M.ON='"liga" on, "calt" on';class U extends v{constructor(){super(44)}compute(oe,Y,ge){return oe.fontInfo}}class j extends w{constructor(){super(46,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:d.localize(22,null)})}validate(oe){const Y=s.float(oe,this.defaultValue);return Y===0?e.EDITOR_FONT_DEFAULTS.fontSize:s.clamp(Y,6,100)}compute(oe,Y,ge){return oe.fontInfo.fontSize}}class K extends y{constructor(){super(47,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:K.MINIMUM_VALUE,maximum:K.MAXIMUM_VALUE,errorMessage:d.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:K.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:d.localize(24,null)})}validate(oe){return oe==="normal"||oe==="bold"?oe:String(h.clampedInt(oe,e.EDITOR_FONT_DEFAULTS.fontWeight,K.MINIMUM_VALUE,K.MAXIMUM_VALUE))}}K.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],K.MINIMUM_VALUE=1,K.MAXIMUM_VALUE=1e3;class B extends y{constructor(){const oe={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Y={type:"string",enum:["peek","gotoAndPeek","goto"],default:oe.multiple,enumDescriptions:[d.localize(25,null),d.localize(26,null),d.localize(27,null)]},ge=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(51,"gotoLocation",oe,{"editor.gotoLocation.multiple":{deprecationMessage:d.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:d.localize(29,null),...Y},"editor.gotoLocation.multipleTypeDefinitions":{description:d.localize(30,null),...Y},"editor.gotoLocation.multipleDeclarations":{description:d.localize(31,null),...Y},"editor.gotoLocation.multipleImplementations":{description:d.localize(32,null),...Y},"editor.gotoLocation.multipleReferences":{description:d.localize(33,null),...Y},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:oe.alternativeDefinitionCommand,enum:ge,description:d.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:oe.alternativeTypeDefinitionCommand,enum:ge,description:d.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:oe.alternativeDeclarationCommand,enum:ge,description:d.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:oe.alternativeImplementationCommand,enum:ge,description:d.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:oe.alternativeReferenceCommand,enum:ge,description:d.localize(38,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Y=oe;return{multiple:r(Y.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Y.multipleDefinitions??r(Y.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Y.multipleTypeDefinitions??r(Y.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Y.multipleDeclarations??r(Y.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Y.multipleImplementations??r(Y.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Y.multipleReferences??r(Y.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:u.string(Y.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:u.string(Y.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:u.string(Y.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:u.string(Y.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:u.string(Y.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class x extends y{constructor(){const oe={enabled:!0,delay:300,sticky:!0,above:!0};super(53,"hover",oe,{"editor.hover.enabled":{type:"boolean",default:oe.enabled,description:d.localize(39,null)},"editor.hover.delay":{type:"number",default:oe.delay,minimum:0,maximum:1e4,description:d.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:oe.sticky,description:d.localize(41,null)},"editor.hover.above":{type:"boolean",default:oe.above,description:d.localize(42,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Y=oe;return{enabled:_(Y.enabled,this.defaultValue.enabled),delay:h.clampedInt(Y.delay,this.defaultValue.delay,0,1e4),sticky:_(Y.sticky,this.defaultValue.sticky),above:_(Y.above,this.defaultValue.above)}}}var z;(function(ne){ne[ne.None=0]="None",ne[ne.Text=1]="Text",ne[ne.Blocks=2]="Blocks"})(z=e.RenderMinimap||(e.RenderMinimap={}));class G extends v{constructor(){super(131)}compute(oe,Y,ge){return G.computeLayout(Y,{memory:oe.memory,outerWidth:oe.outerWidth,outerHeight:oe.outerHeight,isDominatedByLongLines:oe.isDominatedByLongLines,lineHeight:oe.fontInfo.lineHeight,viewLineCount:oe.viewLineCount,lineNumbersDigitCount:oe.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:oe.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:oe.fontInfo.maxDigitWidth,pixelRatio:oe.pixelRatio})}static computeContainedMinimapLineCount(oe){const Y=oe.height/oe.lineHeight,ge=oe.scrollBeyondLastLine?Y-1:0,_e=(oe.viewLineCount+ge)/(oe.pixelRatio*oe.height),Oe=Math.floor(oe.viewLineCount/_e);return{typicalViewportLineCount:Y,extraLinesBeyondLastLine:ge,desiredRatio:_e,minimapLineCount:Oe}}static _computeMinimapLayout(oe,Y){const ge=oe.outerWidth,_e=oe.outerHeight,Oe=oe.pixelRatio;if(!oe.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Oe*_e),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:_e};const ze=Y.stableMinimapLayoutInput,Ze=ze&&oe.outerHeight===ze.outerHeight&&oe.lineHeight===ze.lineHeight&&oe.typicalHalfwidthCharacterWidth===ze.typicalHalfwidthCharacterWidth&&oe.pixelRatio===ze.pixelRatio&&oe.scrollBeyondLastLine===ze.scrollBeyondLastLine&&oe.minimap.enabled===ze.minimap.enabled&&oe.minimap.side===ze.minimap.side&&oe.minimap.size===ze.minimap.size&&oe.minimap.showSlider===ze.minimap.showSlider&&oe.minimap.renderCharacters===ze.minimap.renderCharacters&&oe.minimap.maxColumn===ze.minimap.maxColumn&&oe.minimap.scale===ze.minimap.scale&&oe.verticalScrollbarWidth===ze.verticalScrollbarWidth&&oe.isViewportWrapping===ze.isViewportWrapping,lt=oe.lineHeight,vt=oe.typicalHalfwidthCharacterWidth,Ge=oe.scrollBeyondLastLine,at=oe.minimap.renderCharacters;let Xe=Oe>=2?Math.round(oe.minimap.scale*2):oe.minimap.scale;const st=oe.minimap.maxColumn,yt=oe.minimap.size,Pt=oe.minimap.side,Ct=oe.verticalScrollbarWidth,ht=oe.viewLineCount,kt=oe.remainingWidth,Ft=oe.isViewportWrapping,Mt=at?2:3;let xe=Math.floor(Oe*_e);const Se=xe/Oe;let Ce=!1,me=!1,ie=Mt*Xe,ke=Xe/Oe,Le=1;if(yt==="fill"||yt==="fit"){const{typicalViewportLineCount:ft,extraLinesBeyondLastLine:dt,desiredRatio:Bt,minimapLineCount:It}=G.computeContainedMinimapLineCount({viewLineCount:ht,scrollBeyondLastLine:Ge,height:_e,lineHeight:lt,pixelRatio:Oe});if(ht/It>1)Ce=!0,me=!0,Xe=1,ie=1,ke=Xe/Oe;else{let St=!1,gt=Xe+1;if(yt==="fit"){const Ot=Math.ceil((ht+dt)*ie);Ft&&Ze&&kt<=Y.stableFitRemainingWidth?(St=!0,gt=Y.stableFitMaxMinimapScale):St=Ot>xe}if(yt==="fill"||St){Ce=!0;const Ot=Xe;ie=Math.min(lt*Oe,Math.max(1,Math.floor(1/Bt))),Ft&&Ze&&kt<=Y.stableFitRemainingWidth&&(gt=Y.stableFitMaxMinimapScale),Xe=Math.min(gt,Math.max(1,Math.floor(ie/Mt))),Xe>Ot&&(Le=Math.min(2,Xe/Ot)),ke=Xe/Oe/Le,xe=Math.ceil(Math.max(ft,ht+dt)*ie),Ft?(Y.stableMinimapLayoutInput=oe,Y.stableFitRemainingWidth=kt,Y.stableFitMaxMinimapScale=Xe):(Y.stableMinimapLayoutInput=null,Y.stableFitRemainingWidth=0)}}}const Ke=Math.floor(st*ke),Ve=Math.min(Ke,Math.max(0,Math.floor((kt-Ct-2)*ke/(vt+ke)))+e.MINIMAP_GUTTER_WIDTH);let ct=Math.floor(Oe*Ve);const bt=ct/Oe;ct=Math.floor(ct*Le);const Et=at?1:2,ot=Pt==="left"?0:ge-Ve-Ct;return{renderMinimap:Et,minimapLeft:ot,minimapWidth:Ve,minimapHeightIsEditorHeight:Ce,minimapIsSampling:me,minimapScale:Xe,minimapLineHeight:ie,minimapCanvasInnerWidth:ct,minimapCanvasInnerHeight:xe,minimapCanvasOuterWidth:bt,minimapCanvasOuterHeight:Se}}static computeLayout(oe,Y){const ge=Y.outerWidth|0,_e=Y.outerHeight|0,Oe=Y.lineHeight|0,ze=Y.lineNumbersDigitCount|0,Ze=Y.typicalHalfwidthCharacterWidth,lt=Y.maxDigitWidth,vt=Y.pixelRatio,Ge=Y.viewLineCount,at=oe.get(123),Xe=at==="inherit"?oe.get(122):at,st=Xe==="inherit"?oe.get(118):Xe,yt=oe.get(121),Pt=oe.get(2),Ct=Y.isDominatedByLongLines,ht=oe.get(50),kt=oe.get(60).renderType!==0,Ft=oe.get(61),Mt=oe.get(94),xe=oe.get(65),Se=oe.get(92),Ce=Se.verticalScrollbarSize,me=Se.verticalHasArrows,ie=Se.arrowSize,ke=Se.horizontalScrollbarSize,Le=oe.get(58),Ke=oe.get(37);let Ve;if(typeof Le=="string"&&/^\d+(\.\d+)?ch$/.test(Le)){const Wt=parseFloat(Le.substr(0,Le.length-2));Ve=h.clampedInt(Wt*Ze,0,0,1e3)}else Ve=h.clampedInt(Le,0,0,1e3);Ke&&(Ve+=16);let ct=0;if(kt){const Wt=Math.max(ze,Ft);ct=Math.round(Wt*lt)}let bt=0;ht&&(bt=Oe);let Et=0,ot=Et+bt,ft=ot+ct,dt=ft+Ve;const Bt=ge-bt-ct-Ve;let It=!1,Lt=!1,St=-1;Pt!==2&&(Xe==="inherit"&&Ct?(It=!0,Lt=!0):st==="on"||st==="bounded"?Lt=!0:st==="wordWrapColumn"&&(St=yt));const gt=G._computeMinimapLayout({outerWidth:ge,outerHeight:_e,lineHeight:Oe,typicalHalfwidthCharacterWidth:Ze,pixelRatio:vt,scrollBeyondLastLine:Mt,minimap:xe,verticalScrollbarWidth:Ce,viewLineCount:Ge,remainingWidth:Bt,isViewportWrapping:Lt},Y.memory||new F);gt.renderMinimap!==0&&gt.minimapLeft===0&&(Et+=gt.minimapWidth,ot+=gt.minimapWidth,ft+=gt.minimapWidth,dt+=gt.minimapWidth);const Ot=Bt-gt.minimapWidth,qt=Math.max(1,Math.floor((Ot-Ce-2)/Ze)),mt=me?ie:0;return Lt&&(St=Math.max(1,qt),st==="bounded"&&(St=Math.min(St,yt))),{width:ge,height:_e,glyphMarginLeft:Et,glyphMarginWidth:bt,lineNumbersLeft:ot,lineNumbersWidth:ct,decorationsLeft:ft,decorationsWidth:Ve,contentLeft:dt,contentWidth:Ot,minimap:gt,viewportColumn:qt,isWordWrapMinified:It,isViewportWrapping:Lt,wrappingColumn:St,verticalScrollbarWidth:Ce,horizontalScrollbarHeight:ke,overviewRuler:{top:mt,width:Ce,height:_e-2*mt,right:0}}}}e.EditorLayoutInfoComputer=G;class q extends y{constructor(){const oe={enabled:!0};super(57,"lightbulb",oe,{"editor.lightbulb.enabled":{type:"boolean",default:oe.enabled,description:d.localize(43,null)}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{enabled:_(oe.enabled,this.defaultValue.enabled)}}}class Z extends y{constructor(){const oe={enabled:!0,fontSize:0,fontFamily:""};super(127,"inlayHints",oe,{"editor.inlayHints.enabled":{type:"boolean",default:oe.enabled,description:d.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:oe.fontSize,markdownDescription:d.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:oe.fontFamily,markdownDescription:d.localize(46,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Y=oe;return{enabled:_(Y.enabled,this.defaultValue.enabled),fontSize:h.clampedInt(Y.fontSize,this.defaultValue.fontSize,0,100),fontFamily:u.string(Y.fontFamily,this.defaultValue.fontFamily)}}}class se extends s{constructor(){super(59,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,oe=>s.clamp(oe,0,150),{markdownDescription:d.localize(47,null)})}compute(oe,Y,ge){return oe.fontInfo.lineHeight}}class ue extends y{constructor(){const oe={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(65,"minimap",oe,{"editor.minimap.enabled":{type:"boolean",default:oe.enabled,description:d.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[d.localize(49,null),d.localize(50,null),d.localize(51,null)],default:oe.size,description:d.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:oe.side,description:d.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:oe.showSlider,description:d.localize(54,null)},"editor.minimap.scale":{type:"number",default:oe.scale,minimum:1,maximum:3,enum:[1,2,3],description:d.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:oe.renderCharacters,description:d.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:oe.maxColumn,description:d.localize(57,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Y=oe;return{enabled:_(Y.enabled,this.defaultValue.enabled),size:r(Y.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(Y.side,this.defaultValue.side,["right","left"]),showSlider:r(Y.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:_(Y.renderCharacters,this.defaultValue.renderCharacters),scale:h.clampedInt(Y.scale,1,1,3),maxColumn:h.clampedInt(Y.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function te(ne){return ne==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class J extends y{constructor(){super(75,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(59,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Y=oe;return{top:h.clampedInt(Y.top,0,0,1e3),bottom:h.clampedInt(Y.bottom,0,0,1e3)}}}class ae extends y{constructor(){const oe={enabled:!0,cycle:!1};super(76,"parameterHints",oe,{"editor.parameterHints.enabled":{type:"boolean",default:oe.enabled,description:d.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:oe.cycle,description:d.localize(61,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Y=oe;return{enabled:_(Y.enabled,this.defaultValue.enabled),cycle:_(Y.cycle,this.defaultValue.cycle)}}}class he extends v{constructor(){super(129)}compute(oe,Y,ge){return oe.pixelRatio}}class we extends y{constructor(){const oe={other:!0,comments:!1,strings:!1};super(79,"quickSuggestions",oe,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:oe.strings,description:d.localize(62,null)},comments:{type:"boolean",default:oe.comments,description:d.localize(63,null)},other:{type:"boolean",default:oe.other,description:d.localize(64,null)}}}],default:oe,description:d.localize(65,null)});this.defaultValue=oe}validate(oe){if(typeof oe=="boolean")return oe;if(oe&&typeof oe=="object"){const Y=oe,ge={other:_(Y.other,this.defaultValue.other),comments:_(Y.comments,this.defaultValue.comments),strings:_(Y.strings,this.defaultValue.strings)};return ge.other&&ge.comments&&ge.strings?!0:!ge.other&&!ge.comments&&!ge.strings?!1:ge}return this.defaultValue}}var Ie;(function(ne){ne[ne.Off=0]="Off",ne[ne.On=1]="On",ne[ne.Relative=2]="Relative",ne[ne.Interval=3]="Interval",ne[ne.Custom=4]="Custom"})(Ie=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ne extends y{constructor(){super(60,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[d.localize(66,null),d.localize(67,null),d.localize(68,null),d.localize(69,null)],default:"on",description:d.localize(70,null)})}validate(oe){let Y=this.defaultValue.renderType,ge=this.defaultValue.renderFn;return typeof oe!="undefined"&&(typeof oe=="function"?(Y=4,ge=oe):oe==="interval"?Y=3:oe==="relative"?Y=2:oe==="on"?Y=1:Y=0),{renderType:Y,renderFn:ge}}}function Ee(ne){const oe=ne.get(87);return oe==="editable"?ne.get(81):oe!=="on"}e.filterValidationDecorations=Ee;class be extends y{constructor(){const oe=[],Y={type:"number",description:d.localize(71,null)};super(91,"rulers",oe,{type:"array",items:{anyOf:[Y,{type:["object"],properties:{column:Y,color:{type:"string",description:d.localize(72,null),format:"color-hex"}}}]},default:oe,description:d.localize(73,null)})}validate(oe){if(Array.isArray(oe)){const Y=[];for(let ge of oe)if(typeof ge=="number")Y.push({column:h.clampedInt(ge,0,0,1e4),color:null});else if(ge&&typeof ge=="object"){const _e=ge;Y.push({column:h.clampedInt(_e.column,0,0,1e4),color:_e.color})}return Y.sort((ge,_e)=>ge.column-_e.column),Y}return this.defaultValue}}function H(ne,oe){if(typeof ne!="string")return oe;switch(ne){case"hidden":return 2;case"visible":return 3;default:return 1}}class W extends y{constructor(){const oe={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",oe,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(74,null),d.localize(75,null),d.localize(76,null)],default:"auto",description:d.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(78,null),d.localize(79,null),d.localize(80,null)],default:"auto",description:d.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:oe.verticalScrollbarSize,description:d.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:oe.horizontalScrollbarSize,description:d.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:oe.scrollByPage,description:d.localize(84,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Y=oe,ge=h.clampedInt(Y.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),_e=h.clampedInt(Y.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:h.clampedInt(Y.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:H(Y.vertical,this.defaultValue.vertical),horizontal:H(Y.horizontal,this.defaultValue.horizontal),useShadows:_(Y.useShadows,this.defaultValue.useShadows),verticalHasArrows:_(Y.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:_(Y.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:_(Y.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:_(Y.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:ge,horizontalSliderSize:h.clampedInt(Y.horizontalSliderSize,ge,0,1e3),verticalScrollbarSize:_e,verticalSliderSize:h.clampedInt(Y.verticalSliderSize,_e,0,1e3),scrollByPage:_(Y.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class O extends y{constructor(){const oe={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(113,"unicodeHighlight",oe,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.nonBasicASCII,description:d.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:oe.invisibleCharacters,description:d.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:oe.ambiguousCharacters,description:d.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeComments,description:d.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeStrings,description:d.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:oe.allowedCharacters,description:d.localize(90,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:oe.allowedLocales,description:d.localize(91,null)}})}applyUpdate(oe,Y){let ge=!1;Y.allowedCharacters&&(T.equals(oe.allowedCharacters,Y.allowedCharacters)||(oe={...oe,allowedCharacters:Y.allowedCharacters},ge=!0)),Y.allowedLocales&&(T.equals(oe.allowedLocales,Y.allowedLocales)||(oe={...oe,allowedLocales:Y.allowedLocales},ge=!0));const _e=super.applyUpdate(oe,Y);return ge?new c(_e.newValue,!0):_e}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Y=oe;return{nonBasicASCII:de(Y.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:_(Y.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:_(Y.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:de(Y.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:de(Y.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(oe.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(oe.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(oe,Y){if(typeof oe!="object"||!oe)return Y;const ge={};for(const[_e,Oe]of Object.entries(oe))Oe===!0&&(ge[_e]=!0);return ge}}class $ extends y{constructor(){const oe={enabled:!0,mode:"subwordSmart"};super(55,"inlineSuggest",oe,{"editor.inlineSuggest.enabled":{type:"boolean",default:oe.enabled,description:d.localize(92,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Y=oe;return{enabled:_(Y.enabled,this.defaultValue.enabled),mode:r(Y.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class Q extends y{constructor(){const oe={enabled:k.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",oe,{"editor.bracketPairColorization.enabled":{type:"boolean",default:oe.enabled,description:d.localize(93,null)}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{enabled:_(oe.enabled,this.defaultValue.enabled)}}}class re extends y{constructor(){const oe={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",oe,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[d.localize(94,null),d.localize(95,null),d.localize(96,null)],default:oe.bracketPairs,description:d.localize(97,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[d.localize(98,null),d.localize(99,null),d.localize(100,null)],default:oe.bracketPairsHorizontal,description:d.localize(101,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:oe.highlightActiveBracketPair,description:d.localize(102,null)},"editor.guides.indentation":{type:"boolean",default:oe.indentation,description:d.localize(103,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:oe.highlightActiveIndentation,description:d.localize(104,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Y=oe;return{bracketPairs:de(Y.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:de(Y.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:_(Y.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:_(Y.indentation,this.defaultValue.indentation),highlightActiveIndentation:_(Y.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function de(ne,oe,Y){const ge=Y.indexOf(ne);return ge===-1?oe:Y[ge]}class ye extends y{constructor(){const oe={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",oe,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[d.localize(105,null),d.localize(106,null)],default:oe.insertMode,description:d.localize(107,null)},"editor.suggest.filterGraceful":{type:"boolean",default:oe.filterGraceful,description:d.localize(108,null)},"editor.suggest.localityBonus":{type:"boolean",default:oe.localityBonus,description:d.localize(109,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:oe.shareSuggestSelections,markdownDescription:d.localize(110,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:oe.snippetsPreventQuickSuggestions,description:d.localize(111,null)},"editor.suggest.showIcons":{type:"boolean",default:oe.showIcons,description:d.localize(112,null)},"editor.suggest.showStatusBar":{type:"boolean",default:oe.showStatusBar,description:d.localize(113,null)},"editor.suggest.preview":{type:"boolean",default:oe.preview,description:d.localize(114,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:oe.showInlineDetails,description:d.localize(115,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:d.localize(116,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:d.localize(117,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:d.localize(118,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:d.localize(119,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:d.localize(120,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:d.localize(121,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:d.localize(122,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:d.localize(123,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:d.localize(124,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:d.localize(125,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:d.localize(126,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:d.localize(127,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:d.localize(128,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:d.localize(129,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:d.localize(130,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:d.localize(131,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:d.localize(132,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:d.localize(133,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:d.localize(134,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:d.localize(135,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:d.localize(136,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:d.localize(137,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:d.localize(138,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:d.localize(139,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:d.localize(140,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:d.localize(141,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:d.localize(142,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:d.localize(143,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:d.localize(144,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:d.localize(145,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:d.localize(146,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Y=oe;return{insertMode:r(Y.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:_(Y.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:_(Y.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:_(Y.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:_(Y.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:_(Y.showIcons,this.defaultValue.showIcons),showStatusBar:_(Y.showStatusBar,this.defaultValue.showStatusBar),preview:_(Y.preview,this.defaultValue.preview),previewMode:r(Y.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:_(Y.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:_(Y.showMethods,this.defaultValue.showMethods),showFunctions:_(Y.showFunctions,this.defaultValue.showFunctions),showConstructors:_(Y.showConstructors,this.defaultValue.showConstructors),showDeprecated:_(Y.showDeprecated,this.defaultValue.showDeprecated),showFields:_(Y.showFields,this.defaultValue.showFields),showVariables:_(Y.showVariables,this.defaultValue.showVariables),showClasses:_(Y.showClasses,this.defaultValue.showClasses),showStructs:_(Y.showStructs,this.defaultValue.showStructs),showInterfaces:_(Y.showInterfaces,this.defaultValue.showInterfaces),showModules:_(Y.showModules,this.defaultValue.showModules),showProperties:_(Y.showProperties,this.defaultValue.showProperties),showEvents:_(Y.showEvents,this.defaultValue.showEvents),showOperators:_(Y.showOperators,this.defaultValue.showOperators),showUnits:_(Y.showUnits,this.defaultValue.showUnits),showValues:_(Y.showValues,this.defaultValue.showValues),showConstants:_(Y.showConstants,this.defaultValue.showConstants),showEnums:_(Y.showEnums,this.defaultValue.showEnums),showEnumMembers:_(Y.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:_(Y.showKeywords,this.defaultValue.showKeywords),showWords:_(Y.showWords,this.defaultValue.showWords),showColors:_(Y.showColors,this.defaultValue.showColors),showFiles:_(Y.showFiles,this.defaultValue.showFiles),showReferences:_(Y.showReferences,this.defaultValue.showReferences),showFolders:_(Y.showFolders,this.defaultValue.showFolders),showTypeParameters:_(Y.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:_(Y.showSnippets,this.defaultValue.showSnippets),showUsers:_(Y.showUsers,this.defaultValue.showUsers),showIssues:_(Y.showIssues,this.defaultValue.showIssues)}}}class Ae extends y{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:d.localize(147,null),default:!0,type:"boolean"}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:_(oe.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class We extends v{constructor(){super(130)}compute(oe,Y,ge){return Y.get(81)?!0:oe.tabFocusMode}}var $e;(function(ne){ne[ne.None=0]="None",ne[ne.Same=1]="Same",ne[ne.Indent=2]="Indent",ne[ne.DeepIndent=3]="DeepIndent"})($e=e.WrappingIndent||(e.WrappingIndent={}));function je(ne){switch(ne){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class He extends v{constructor(){super(132)}compute(oe,Y,ge){const _e=Y.get(131);return{isDominatedByLongLines:oe.isDominatedByLongLines,isWordWrapMinified:_e.isWordWrapMinified,isViewportWrapping:_e.isViewportWrapping,wrappingColumn:_e.wrappingColumn}}}const Ue="Consolas, 'Courier New', monospace",Je="Menlo, Monaco, 'Courier New', monospace",rt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?Je:t.isLinux?rt:Ue,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Re(ne){return e.editorOptionsRegistry[ne.id]=ne,ne}var tt;(function(ne){ne[ne.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ne[ne.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ne[ne.accessibilitySupport=2]="accessibilitySupport",ne[ne.accessibilityPageSize=3]="accessibilityPageSize",ne[ne.ariaLabel=4]="ariaLabel",ne[ne.autoClosingBrackets=5]="autoClosingBrackets",ne[ne.autoClosingDelete=6]="autoClosingDelete",ne[ne.autoClosingOvertype=7]="autoClosingOvertype",ne[ne.autoClosingQuotes=8]="autoClosingQuotes",ne[ne.autoIndent=9]="autoIndent",ne[ne.automaticLayout=10]="automaticLayout",ne[ne.autoSurround=11]="autoSurround",ne[ne.bracketPairColorization=12]="bracketPairColorization",ne[ne.guides=13]="guides",ne[ne.codeLens=14]="codeLens",ne[ne.codeLensFontFamily=15]="codeLensFontFamily",ne[ne.codeLensFontSize=16]="codeLensFontSize",ne[ne.colorDecorators=17]="colorDecorators",ne[ne.columnSelection=18]="columnSelection",ne[ne.comments=19]="comments",ne[ne.contextmenu=20]="contextmenu",ne[ne.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",ne[ne.cursorBlinking=22]="cursorBlinking",ne[ne.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",ne[ne.cursorStyle=24]="cursorStyle",ne[ne.cursorSurroundingLines=25]="cursorSurroundingLines",ne[ne.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",ne[ne.cursorWidth=27]="cursorWidth",ne[ne.disableLayerHinting=28]="disableLayerHinting",ne[ne.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",ne[ne.domReadOnly=30]="domReadOnly",ne[ne.dragAndDrop=31]="dragAndDrop",ne[ne.emptySelectionClipboard=32]="emptySelectionClipboard",ne[ne.extraEditorClassName=33]="extraEditorClassName",ne[ne.fastScrollSensitivity=34]="fastScrollSensitivity",ne[ne.find=35]="find",ne[ne.fixedOverflowWidgets=36]="fixedOverflowWidgets",ne[ne.folding=37]="folding",ne[ne.foldingStrategy=38]="foldingStrategy",ne[ne.foldingHighlight=39]="foldingHighlight",ne[ne.foldingImportsByDefault=40]="foldingImportsByDefault",ne[ne.foldingMaximumRegions=41]="foldingMaximumRegions",ne[ne.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",ne[ne.fontFamily=43]="fontFamily",ne[ne.fontInfo=44]="fontInfo",ne[ne.fontLigatures=45]="fontLigatures",ne[ne.fontSize=46]="fontSize",ne[ne.fontWeight=47]="fontWeight",ne[ne.formatOnPaste=48]="formatOnPaste",ne[ne.formatOnType=49]="formatOnType",ne[ne.glyphMargin=50]="glyphMargin",ne[ne.gotoLocation=51]="gotoLocation",ne[ne.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",ne[ne.hover=53]="hover",ne[ne.inDiffEditor=54]="inDiffEditor",ne[ne.inlineSuggest=55]="inlineSuggest",ne[ne.letterSpacing=56]="letterSpacing",ne[ne.lightbulb=57]="lightbulb",ne[ne.lineDecorationsWidth=58]="lineDecorationsWidth",ne[ne.lineHeight=59]="lineHeight",ne[ne.lineNumbers=60]="lineNumbers",ne[ne.lineNumbersMinChars=61]="lineNumbersMinChars",ne[ne.linkedEditing=62]="linkedEditing",ne[ne.links=63]="links",ne[ne.matchBrackets=64]="matchBrackets",ne[ne.minimap=65]="minimap",ne[ne.mouseStyle=66]="mouseStyle",ne[ne.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",ne[ne.mouseWheelZoom=68]="mouseWheelZoom",ne[ne.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",ne[ne.multiCursorModifier=70]="multiCursorModifier",ne[ne.multiCursorPaste=71]="multiCursorPaste",ne[ne.occurrencesHighlight=72]="occurrencesHighlight",ne[ne.overviewRulerBorder=73]="overviewRulerBorder",ne[ne.overviewRulerLanes=74]="overviewRulerLanes",ne[ne.padding=75]="padding",ne[ne.parameterHints=76]="parameterHints",ne[ne.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",ne[ne.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",ne[ne.quickSuggestions=79]="quickSuggestions",ne[ne.quickSuggestionsDelay=80]="quickSuggestionsDelay",ne[ne.readOnly=81]="readOnly",ne[ne.renameOnType=82]="renameOnType",ne[ne.renderControlCharacters=83]="renderControlCharacters",ne[ne.renderFinalNewline=84]="renderFinalNewline",ne[ne.renderLineHighlight=85]="renderLineHighlight",ne[ne.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",ne[ne.renderValidationDecorations=87]="renderValidationDecorations",ne[ne.renderWhitespace=88]="renderWhitespace",ne[ne.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",ne[ne.roundedSelection=90]="roundedSelection",ne[ne.rulers=91]="rulers",ne[ne.scrollbar=92]="scrollbar",ne[ne.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",ne[ne.scrollBeyondLastLine=94]="scrollBeyondLastLine",ne[ne.scrollPredominantAxis=95]="scrollPredominantAxis",ne[ne.selectionClipboard=96]="selectionClipboard",ne[ne.selectionHighlight=97]="selectionHighlight",ne[ne.selectOnLineNumbers=98]="selectOnLineNumbers",ne[ne.showFoldingControls=99]="showFoldingControls",ne[ne.showUnused=100]="showUnused",ne[ne.snippetSuggestions=101]="snippetSuggestions",ne[ne.smartSelect=102]="smartSelect",ne[ne.smoothScrolling=103]="smoothScrolling",ne[ne.stickyTabStops=104]="stickyTabStops",ne[ne.stopRenderingLineAfter=105]="stopRenderingLineAfter",ne[ne.suggest=106]="suggest",ne[ne.suggestFontSize=107]="suggestFontSize",ne[ne.suggestLineHeight=108]="suggestLineHeight",ne[ne.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",ne[ne.suggestSelection=110]="suggestSelection",ne[ne.tabCompletion=111]="tabCompletion",ne[ne.tabIndex=112]="tabIndex",ne[ne.unicodeHighlighting=113]="unicodeHighlighting",ne[ne.unusualLineTerminators=114]="unusualLineTerminators",ne[ne.useShadowDOM=115]="useShadowDOM",ne[ne.useTabStops=116]="useTabStops",ne[ne.wordSeparators=117]="wordSeparators",ne[ne.wordWrap=118]="wordWrap",ne[ne.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",ne[ne.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",ne[ne.wordWrapColumn=121]="wordWrapColumn",ne[ne.wordWrapOverride1=122]="wordWrapOverride1",ne[ne.wordWrapOverride2=123]="wordWrapOverride2",ne[ne.wrappingIndent=124]="wrappingIndent",ne[ne.wrappingStrategy=125]="wrappingStrategy",ne[ne.showDeprecated=126]="showDeprecated",ne[ne.inlayHints=127]="inlayHints",ne[ne.editorClassName=128]="editorClassName",ne[ne.pixelRatio=129]="pixelRatio",ne[ne.tabFocusMode=130]="tabFocusMode",ne[ne.layoutInfo=131]="layoutInfo",ne[ne.wrappingInfo=132]="wrappingInfo"})(tt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Re(new R(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:d.localize(148,null)})),acceptSuggestionOnEnter:Re(new S(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",d.localize(149,null),""],markdownDescription:d.localize(150,null)})),accessibilitySupport:Re(new n),accessibilityPageSize:Re(new h(3,"accessibilityPageSize",10,1,1073741824,{description:d.localize(151,null)})),ariaLabel:Re(new u(4,"ariaLabel",d.localize(152,null))),autoClosingBrackets:Re(new S(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(153,null),d.localize(154,null),""],description:d.localize(155,null)})),autoClosingDelete:Re(new S(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",d.localize(156,null),""],description:d.localize(157,null)})),autoClosingOvertype:Re(new S(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",d.localize(158,null),""],description:d.localize(159,null)})),autoClosingQuotes:Re(new S(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(160,null),d.localize(161,null),""],description:d.localize(162,null)})),autoIndent:Re(new a(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],i,{enumDescriptions:[d.localize(163,null),d.localize(164,null),d.localize(165,null),d.localize(166,null),d.localize(167,null)],description:d.localize(168,null)})),automaticLayout:Re(new R(10,"automaticLayout",!1)),autoSurround:Re(new S(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[d.localize(169,null),d.localize(170,null),d.localize(171,null),""],description:d.localize(172,null)})),bracketPairColorization:Re(new Q),bracketPairGuides:Re(new re),stickyTabStops:Re(new R(104,"stickyTabStops",!1,{description:d.localize(173,null)})),codeLens:Re(new R(14,"codeLens",!0,{description:d.localize(174,null)})),codeLensFontFamily:Re(new u(15,"codeLensFontFamily","",{description:d.localize(175,null)})),codeLensFontSize:Re(new h(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:d.localize(176,null)})),colorDecorators:Re(new R(17,"colorDecorators",!0,{description:d.localize(177,null)})),columnSelection:Re(new R(18,"columnSelection",!1,{description:d.localize(178,null)})),comments:Re(new o),contextmenu:Re(new R(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Re(new R(21,"copyWithSyntaxHighlighting",!0,{description:d.localize(179,null)})),cursorBlinking:Re(new a(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],f,{description:d.localize(180,null)})),cursorSmoothCaretAnimation:Re(new R(23,"cursorSmoothCaretAnimation",!1,{description:d.localize(181,null)})),cursorStyle:Re(new a(24,"cursorStyle",m.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],A,{description:d.localize(182,null)})),cursorSurroundingLines:Re(new h(25,"cursorSurroundingLines",0,0,1073741824,{description:d.localize(183,null)})),cursorSurroundingLinesStyle:Re(new S(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[d.localize(184,null),d.localize(185,null)],description:d.localize(186,null)})),cursorWidth:Re(new h(27,"cursorWidth",0,0,1073741824,{markdownDescription:d.localize(187,null)})),disableLayerHinting:Re(new R(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Re(new R(29,"disableMonospaceOptimizations",!1)),domReadOnly:Re(new R(30,"domReadOnly",!1)),dragAndDrop:Re(new R(31,"dragAndDrop",!0,{description:d.localize(188,null)})),emptySelectionClipboard:Re(new N),extraEditorClassName:Re(new u(33,"extraEditorClassName","")),fastScrollSensitivity:Re(new s(34,"fastScrollSensitivity",5,ne=>ne<=0?5:ne,{markdownDescription:d.localize(189,null)})),find:Re(new g),fixedOverflowWidgets:Re(new R(36,"fixedOverflowWidgets",!1)),folding:Re(new R(37,"folding",!0,{description:d.localize(190,null)})),foldingStrategy:Re(new S(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[d.localize(191,null),d.localize(192,null)],description:d.localize(193,null)})),foldingHighlight:Re(new R(39,"foldingHighlight",!0,{description:d.localize(194,null)})),foldingImportsByDefault:Re(new R(40,"foldingImportsByDefault",!1,{description:d.localize(195,null)})),foldingMaximumRegions:Re(new h(41,"foldingMaximumRegions",5e3,10,65e3,{description:d.localize(196,null)})),unfoldOnClickAfterEndOfLine:Re(new R(42,"unfoldOnClickAfterEndOfLine",!1,{description:d.localize(197,null)})),fontFamily:Re(new u(43,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:d.localize(198,null)})),fontInfo:Re(new U),fontLigatures2:Re(new M),fontSize:Re(new j),fontWeight:Re(new K),formatOnPaste:Re(new R(48,"formatOnPaste",!1,{description:d.localize(199,null)})),formatOnType:Re(new R(49,"formatOnType",!1,{description:d.localize(200,null)})),glyphMargin:Re(new R(50,"glyphMargin",!0,{description:d.localize(201,null)})),gotoLocation:Re(new B),hideCursorInOverviewRuler:Re(new R(52,"hideCursorInOverviewRuler",!1,{description:d.localize(202,null)})),hover:Re(new x),inDiffEditor:Re(new R(54,"inDiffEditor",!1)),letterSpacing:Re(new s(56,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ne=>s.clamp(ne,-5,20),{description:d.localize(203,null)})),lightbulb:Re(new q),lineDecorationsWidth:Re(new w(58,"lineDecorationsWidth",10)),lineHeight:Re(new se),lineNumbers:Re(new Ne),lineNumbersMinChars:Re(new h(61,"lineNumbersMinChars",5,1,300)),linkedEditing:Re(new R(62,"linkedEditing",!1,{description:d.localize(204,null)})),links:Re(new R(63,"links",!0,{description:d.localize(205,null)})),matchBrackets:Re(new S(64,"matchBrackets","always",["always","near","never"],{description:d.localize(206,null)})),minimap:Re(new ue),mouseStyle:Re(new S(66,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Re(new s(67,"mouseWheelScrollSensitivity",1,ne=>ne===0?1:ne,{markdownDescription:d.localize(207,null)})),mouseWheelZoom:Re(new R(68,"mouseWheelZoom",!1,{markdownDescription:d.localize(208,null)})),multiCursorMergeOverlapping:Re(new R(69,"multiCursorMergeOverlapping",!0,{description:d.localize(209,null)})),multiCursorModifier:Re(new a(70,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],te,{markdownEnumDescriptions:[d.localize(210,null),d.localize(211,null)],markdownDescription:d.localize(212,null)})),multiCursorPaste:Re(new S(71,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[d.localize(213,null),d.localize(214,null)],markdownDescription:d.localize(215,null)})),occurrencesHighlight:Re(new R(72,"occurrencesHighlight",!0,{description:d.localize(216,null)})),overviewRulerBorder:Re(new R(73,"overviewRulerBorder",!0,{description:d.localize(217,null)})),overviewRulerLanes:Re(new h(74,"overviewRulerLanes",3,0,3)),padding:Re(new J),parameterHints:Re(new ae),peekWidgetDefaultFocus:Re(new S(77,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[d.localize(218,null),d.localize(219,null)],description:d.localize(220,null)})),definitionLinkOpensInPeek:Re(new R(78,"definitionLinkOpensInPeek",!1,{description:d.localize(221,null)})),quickSuggestions:Re(new we),quickSuggestionsDelay:Re(new h(80,"quickSuggestionsDelay",10,0,1073741824,{description:d.localize(222,null)})),readOnly:Re(new R(81,"readOnly",!1)),renameOnType:Re(new R(82,"renameOnType",!1,{description:d.localize(223,null),markdownDeprecationMessage:d.localize(224,null)})),renderControlCharacters:Re(new R(83,"renderControlCharacters",!0,{description:d.localize(225,null),restricted:!0})),renderFinalNewline:Re(new R(84,"renderFinalNewline",!0,{description:d.localize(226,null)})),renderLineHighlight:Re(new S(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",d.localize(227,null)],description:d.localize(228,null)})),renderLineHighlightOnlyWhenFocus:Re(new R(86,"renderLineHighlightOnlyWhenFocus",!1,{description:d.localize(229,null)})),renderValidationDecorations:Re(new S(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Re(new S(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",d.localize(230,null),d.localize(231,null),d.localize(232,null),""],description:d.localize(233,null)})),revealHorizontalRightPadding:Re(new h(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Re(new R(90,"roundedSelection",!0,{description:d.localize(234,null)})),rulers:Re(new be),scrollbar:Re(new W),scrollBeyondLastColumn:Re(new h(93,"scrollBeyondLastColumn",5,0,1073741824,{description:d.localize(235,null)})),scrollBeyondLastLine:Re(new R(94,"scrollBeyondLastLine",!0,{description:d.localize(236,null)})),scrollPredominantAxis:Re(new R(95,"scrollPredominantAxis",!0,{description:d.localize(237,null)})),selectionClipboard:Re(new R(96,"selectionClipboard",!0,{description:d.localize(238,null),included:t.isLinux})),selectionHighlight:Re(new R(97,"selectionHighlight",!0,{description:d.localize(239,null)})),selectOnLineNumbers:Re(new R(98,"selectOnLineNumbers",!0)),showFoldingControls:Re(new S(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[d.localize(240,null),d.localize(241,null)],description:d.localize(242,null)})),showUnused:Re(new R(100,"showUnused",!0,{description:d.localize(243,null)})),showDeprecated:Re(new R(126,"showDeprecated",!0,{description:d.localize(244,null)})),inlayHints:Re(new Z),snippetSuggestions:Re(new S(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[d.localize(245,null),d.localize(246,null),d.localize(247,null),d.localize(248,null)],description:d.localize(249,null)})),smartSelect:Re(new Ae),smoothScrolling:Re(new R(103,"smoothScrolling",!1,{description:d.localize(250,null)})),stopRenderingLineAfter:Re(new h(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Re(new ye),inlineSuggest:Re(new $),suggestFontSize:Re(new h(107,"suggestFontSize",0,0,1e3,{markdownDescription:d.localize(251,null)})),suggestLineHeight:Re(new h(108,"suggestLineHeight",0,0,1e3,{markdownDescription:d.localize(252,null)})),suggestOnTriggerCharacters:Re(new R(109,"suggestOnTriggerCharacters",!0,{description:d.localize(253,null)})),suggestSelection:Re(new S(110,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[d.localize(254,null),d.localize(255,null),d.localize(256,null)],description:d.localize(257,null)})),tabCompletion:Re(new S(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[d.localize(258,null),d.localize(259,null),d.localize(260,null)],description:d.localize(261,null)})),tabIndex:Re(new h(112,"tabIndex",0,-1,1073741824)),unicodeHighlight:Re(new O),unusualLineTerminators:Re(new S(114,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[d.localize(262,null),d.localize(263,null),d.localize(264,null)],description:d.localize(265,null)})),useShadowDOM:Re(new R(115,"useShadowDOM",!0)),useTabStops:Re(new R(116,"useTabStops",!0,{description:d.localize(266,null)})),wordSeparators:Re(new u(117,"wordSeparators",I.USUAL_WORD_SEPARATORS,{description:d.localize(267,null)})),wordWrap:Re(new S(118,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[d.localize(268,null),d.localize(269,null),d.localize(270,null),d.localize(271,null)],description:d.localize(272,null)})),wordWrapBreakAfterCharacters:Re(new u(119,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Re(new u(120,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Re(new h(121,"wordWrapColumn",80,1,1073741824,{markdownDescription:d.localize(273,null)})),wordWrapOverride1:Re(new S(122,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Re(new S(123,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Re(new a(124,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],je,{enumDescriptions:[d.localize(274,null),d.localize(275,null),d.localize(276,null),d.localize(277,null)],description:d.localize(278,null)})),wrappingStrategy:Re(new S(125,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[d.localize(279,null),d.localize(280,null)],description:d.localize(281,null)})),editorClassName:Re(new L),pixelRatio:Re(new he),tabFocusMode:Re(new We),layoutInfo:Re(new G),wrappingInfo:Re(new He)}}),define(pe[160],ve([19,20]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(pe[161],ve([19,20]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(pe[162],ve([19,20]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(pe[163],ve([19,20]),function(ee,e){return ee.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(pe[164],ve([19,20]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(pe[165],ve([19,20]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(pe[166],ve([19,20]),function(ee,e){return ee.create("vs/platform/workspaces/common/workspaces",e)}),define(pe[167],ve([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(pe[168],ve([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(pe[169],ve([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostProgress",e)}),define(pe[170],ve([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(pe[171],ve([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(pe[172],ve([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(pe[173],ve([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(pe[174],ve([19,20]),function(ee,e){return ee.create("vs/workbench/api/node/extHostDebugService",e)}),define(pe[175],ve([19,20]),function(ee,e){return ee.create("vs/workbench/api/node/extHostTunnelService",e)}),define(pe[176],ve([19,20]),function(ee,e){return ee.create("vs/workbench/common/editor",e)}),define(pe[177],ve([19,20]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(pe[178],ve([19,20]),function(ee,e){return ee.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(pe[179],ve([19,20]),function(ee,e){return ee.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(pe[180],ve([19,20]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(pe[181],ve([19,20]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(pe[182],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var d;(function(T){T[T.ACTIVATE=1]="ACTIVATE",T[T.RESTORE=2]="RESTORE",T[T.PRESERVE=3]="PRESERVE"})(d=e.EditorActivation||(e.EditorActivation={}));var t;(function(T){T[T.PICK=0]="PICK",T[T.DISABLED=1]="DISABLED",T[T.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(t=e.EditorResolution||(e.EditorResolution={}));var I;(function(T){T[T.API=0]="API",T[T.USER=1]="USER"})(I=e.EditorOpenContext||(e.EditorOpenContext={}));var C;(function(T){T[T.Center=0]="Center",T[T.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",T[T.NearTop=2]="NearTop",T[T.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(C=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),function(){"use strict";function ee(e,d,t,I){function C(k){const D=T(k),P=[D];return e.isAbsolute(D)||P.unshift(I),e.resolve(...P)}function T(k){const D=process.env.VSCODE_PORTABLE;if(D)return e.join(D,"user-data");let P=process.env.VSCODE_APPDATA;if(P)return e.join(P,t);const F=k["user-data-dir"];if(F)return F;switch(process.platform){case"win32":if(P=process.env.APPDATA,!P){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");P=e.join(y,"AppData","Roaming")}break;case"darwin":P=e.join(d.homedir(),"Library","Application Support");break;case"linux":P=process.env.XDG_CONFIG_HOME||e.join(d.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(P,t)}return{getUserDataPath:C}}if(typeof define=="function")define(pe[183],ve([0,295,61,10,22,37]),function(e,d,t,I,C,T){const k=C.dirname(I.FileAccess.asFileUri("",e)),D=e.__$__nodeRequire(C.joinPath(k,"package.json").fsPath);return ee(d,t,D.name,T.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),d=require("path"),t=require("os");module.exports=ee(d,t,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(pe[184],ve([0,1,162]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const t=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function C(c){return c=c.trim(),c==="*"||t.test(c)}e.isValidVersionStr=C;function T(c){if(!C(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=c.match(t);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}e.parseVersion=T;function k(c){if(!c)return null;let E=c.majorBase,v=c.majorMustEqual,w=c.minorBase,_=c.minorMustEqual,R=c.patchBase,p=c.patchMustEqual;c.hasCaret&&(E===0||(_=!1),p=!1);let h=0;if(c.preRelease){const s=I.exec(c.preRelease);if(s){const[,u,r,S]=s;h=Date.UTC(Number(u),Number(r)-1,Number(S))}}return{majorBase:E,majorMustEqual:v,minorBase:w,minorMustEqual:_,patchBase:R,patchMustEqual:p,isMinimum:c.hasGreaterEquals,notBefore:h}}e.normalizeVersion=k;function D(c,E,v){let w;typeof c=="string"?w=k(T(c)):w=c;let _;E instanceof Date?_=E.getTime():typeof E=="string"&&(_=new Date(E).getTime());let R;if(typeof v=="string"?R=k(T(v)):R=v,!w||!R)return!1;let p=w.majorBase,h=w.minorBase,s=w.patchBase,u=R.majorBase,r=R.minorBase,S=R.patchBase,a=R.notBefore,i=R.majorMustEqual,n=R.minorMustEqual,o=R.patchMustEqual;return R.isMinimum?p>u?!0:p<u?!1:h>r?!0:h<r||_&&_<a?!1:s>=S:(p===1&&u===0&&(!i||!n||!o)&&(u=1,r=0,S=0,i=!0,n=!1,o=!1),p<u?!1:p>u?!i:h<r?!1:h>r?!n:s<S?!1:s>S?!o:!(_&&_<a))}e.isValidVersion=D;function P(c,E,v,w){return v.isBuiltin||typeof v.main=="undefined"?!0:y(c,E,v.engines.vscode,w)}e.isValidExtensionVersion=P;function F(c,E,v){return c==="*"||y(E,v,c)}e.isEngineValid=F;function y(c,E,v,w=[]){let _=k(T(v));if(!_)return w.push(d.localize(0,null,v)),!1;if(_.majorBase===0){if(!_.majorMustEqual||!_.minorMustEqual)return w.push(d.localize(1,null,v)),!1}else if(!_.majorMustEqual)return w.push(d.localize(2,null,v)),!1;return D(c,E,_)?!0:(w.push(d.localize(3,null,c,v)),!1)}}),define(pe[115],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class d{constructor(I,C=[],T=!1){this.ctor=I,this.staticArguments=C,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=d}),define(pe[62],ve([0,1,115]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function I(T,k,D){k instanceof d.SyncDescriptor||(k=new d.SyncDescriptor(k,[],D)),t.push([T,k])}e.registerSingleton=I;function C(){return t}e.getSingletonServiceDescriptors=C}),define(pe[185],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class d{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=d;class t{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let T of this._nodes.values())T.outgoing.size===0&&C.push(T);return C}insertEdge(C,T){const k=this.lookupOrInsertNode(C),D=this.lookupOrInsertNode(T);k.outgoing.set(this._hashFn(T),D),D.incoming.set(this._hashFn(C),k)}removeNode(C){const T=this._hashFn(C);this._nodes.delete(T);for(let k of this._nodes.values())k.outgoing.delete(T),k.incoming.delete(T)}lookupOrInsertNode(C){const T=this._hashFn(C);let k=this._nodes.get(T);return k||(k=new d(C),this._nodes.set(T,k)),k}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[T,k]of this._nodes)C.push(`${T}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,T]of this._nodes){const k=new Set([C]),D=this._findCycle(T,k);if(D)return D}}_findCycle(C,T){for(let[k,D]of C.outgoing){if(T.has(k))return[...T,k].join(" -> ");T.add(k);const P=this._findCycle(D,T);if(P)return P;T.delete(k)}}}e.Graph=t}),define(pe[4],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var d;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function k(D){return D[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=k})(d=e._util||(e._util={})),e.IInstantiationService=I("instantiationService");function t(T,k,D,P){k[d.DI_TARGET]===k?k[d.DI_DEPENDENCIES].push({id:T,index:D,optional:P}):(k[d.DI_DEPENDENCIES]=[{id:T,index:D,optional:P}],k[d.DI_TARGET]=k)}function I(T){if(d.serviceIds.has(T))return d.serviceIds.get(T);const k=function(D,P,F){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(k,D,F,!1)};return k.toString=()=>T,d.serviceIds.set(T,k),k}e.createDecorator=I;function C(T){return T}e.refineServiceDecorator=C}),define(pe[116],ve([0,1,18,2,4]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,I.createDecorator)("configurationService");function C(_){return _&&typeof _=="object"&&(!_.overrideIdentifier||typeof _.overrideIdentifier=="string")&&(!_.resource||_.resource instanceof t.URI)}e.isConfigurationOverrides=C;function T(_){return _&&typeof _=="object"&&(!_.overrideIdentifiers||d.isArray(_.overrideIdentifiers))&&!_.overrideIdentifier&&(!_.resource||_.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=T;var k;(function(_){_[_.USER=1]="USER",_[_.USER_LOCAL=2]="USER_LOCAL",_[_.USER_REMOTE=3]="USER_REMOTE",_[_.WORKSPACE=4]="WORKSPACE",_[_.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",_[_.DEFAULT=6]="DEFAULT",_[_.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function D(_){switch(_){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=D;function P(_,R){const p=Object.create(null);for(let h in _)F(p,h,_[h],R);return p}e.toValuesTree=P;function F(_,R,p,h){const s=R.split("."),u=s.pop();let r=_;for(let S=0;S<s.length;S++){let a=s[S],i=r[a];switch(typeof i){case"undefined":i=r[a]=Object.create(null);break;case"object":break;default:h(`Ignoring ${R} as ${s.slice(0,S+1).join(".")} is ${JSON.stringify(i)}`);return}r=i}if(typeof r=="object"&&r!==null)try{r[u]=p}catch{h(`Ignoring ${R} as ${s.join(".")} is ${JSON.stringify(r)}`)}else h(`Ignoring ${R} as ${s.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=F;function y(_,R){const p=R.split(".");c(_,p)}e.removeFromValueTree=y;function c(_,R){const p=R.shift();if(R.length===0){delete _[p];return}if(Object.keys(_).indexOf(p)!==-1){const h=_[p];typeof h=="object"&&!Array.isArray(h)&&(c(h,R),Object.keys(h).length===0&&delete _[p])}}function E(_,R,p){function h(r,S){let a=r;for(const i of S){if(typeof a!="object"||a===null)return;a=a[i]}return a}const s=R.split("."),u=h(_,s);return typeof u=="undefined"?p:u}e.getConfigurationValue=E;function v(_,R,p){Object.keys(R).forEach(h=>{h!=="__proto__"&&(h in _?d.isObject(_[h])&&d.isObject(R[h])?v(_[h],R[h],p):p&&(_[h]=R[h]):_[h]=R[h])})}e.merge=v;function w(_,R,p){const h=_.inspect(R),s=_.inspect(p);return typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:h.defaultValue}e.getMigratedSettingValue=w}),define(pe[83],ve([0,1,11,8,4]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const C=new Map;C.set("false",!1),C.set("true",!0),C.set("isMac",d.isMacintosh),C.set("isLinux",d.isLinux),C.set("isWindows",d.isWindows),C.set("isWeb",d.isWeb),C.set("isMacNative",d.isMacintosh&&!d.isWeb),C.set("isEdge",d.isEdge),C.set("isFirefox",d.isFirefox),C.set("isChrome",d.isChrome),C.set("isSafari",d.isSafari);const T=Object.prototype.hasOwnProperty;var k;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(k=e.ContextKeyExprType||(e.ContextKeyExprType={}));class D{static false(){return y.INSTANCE}static true(){return c.INSTANCE}static has(g){return E.create(g)}static equals(g,M){return v.create(g,M)}static notEquals(g,M){return R.create(g,M)}static regex(g,M){return a.create(g,M)}static in(g,M){return w.create(g,M)}static not(g){return p.create(g)}static and(...g){return o.create(g,null)}static or(...g){return l.create(g,null,!0)}static greater(g,M){return s.create(g,M)}static greaterEquals(g,M){return u.create(g,M)}static smaller(g,M){return r.create(g,M)}static smallerEquals(g,M){return S.create(g,M)}static deserialize(g,M=!1){if(!!g)return this._deserializeOrExpression(g,M)}static _deserializeOrExpression(g,M){let U=g.split("||");return l.create(U.map(j=>this._deserializeAndExpression(j,M)),null,!0)}static _deserializeAndExpression(g,M){let U=g.split("&&");return o.create(U.map(j=>this._deserializeOne(j,M)),null)}static _deserializeOne(g,M){if(g=g.trim(),g.indexOf("!=")>=0){let U=g.split("!=");return R.create(U[0].trim(),this._deserializeValue(U[1],M))}if(g.indexOf("==")>=0){let U=g.split("==");return v.create(U[0].trim(),this._deserializeValue(U[1],M))}if(g.indexOf("=~")>=0){let U=g.split("=~");return a.create(U[0].trim(),this._deserializeRegexValue(U[1],M))}if(g.indexOf(" in ")>=0){let U=g.split(" in ");return w.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(g)){const U=g.split(">=");return u.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(g)){const U=g.split(">");return s.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(g)){const U=g.split("<=");return S.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(g)){const U=g.split("<");return r.create(U[0].trim(),U[1].trim())}return/^\!\s*/.test(g)?p.create(g.substr(1).trim()):E.create(g)}static _deserializeValue(g,M){if(g=g.trim(),g==="true")return!0;if(g==="false")return!1;let U=/^'([^']*)'$/.exec(g);return U?U[1].trim():g}static _deserializeRegexValue(g,M){if((0,t.isFalsyOrWhitespace)(g)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let U=g.indexOf("/"),j=g.lastIndexOf("/");if(U===j||U<0){if(M)throw new Error(`bad regexp-value '${g}', missing /-enclosure`);return console.warn(`bad regexp-value '${g}', missing /-enclosure`),null}let K=g.slice(U+1,j),B=g[j+1]==="i"?"i":"";try{return new RegExp(K,B)}catch(x){if(M)throw new Error(`bad regexp-value '${g}', parse error: ${x}`);return console.warn(`bad regexp-value '${g}', parse error: ${x}`),null}}}e.ContextKeyExpr=D;function P(N,g){const M=N?N.substituteConstants():void 0,U=g?g.substituteConstants():void 0;return!M&&!U?!0:!M||!U?!1:M.equals(U)}e.expressionsAreEqualWithConstantSubstitution=P;function F(N,g){return N.cmp(g)}class y{constructor(){this.type=0}cmp(g){return this.type-g.type}equals(g){return g.type===this.type}substituteConstants(){return this}evaluate(g){return!1}serialize(){return"false"}keys(){return[]}map(g){return this}negate(){return c.INSTANCE}}e.ContextKeyFalseExpr=y,y.INSTANCE=new y;class c{constructor(){this.type=1}cmp(g){return this.type-g.type}equals(g){return g.type===this.type}substituteConstants(){return this}evaluate(g){return!0}serialize(){return"true"}keys(){return[]}map(g){return this}negate(){return y.INSTANCE}}e.ContextKeyTrueExpr=c,c.INSTANCE=new c;class E{constructor(g,M){this.key=g,this.negated=M,this.type=2}static create(g,M=null){const U=C.get(g);return typeof U=="boolean"?U?c.INSTANCE:y.INSTANCE:new E(g,M)}cmp(g){return g.type!==this.type?this.type-g.type:m(this.key,g.key)}equals(g){return g.type===this.type?this.key===g.key:!1}substituteConstants(){const g=C.get(this.key);return typeof g=="boolean"?g?c.INSTANCE:y.INSTANCE:this}evaluate(g){return!!g.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(g){return g.mapDefined(this.key)}negate(){return this.negated||(this.negated=p.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=E;class v{constructor(g,M,U){this.key=g,this.value=M,this.negated=U,this.type=4}static create(g,M,U=null){if(typeof M=="boolean")return M?E.create(g,U):p.create(g,U);const j=C.get(g);return typeof j=="boolean"?M===(j?"true":"false")?c.INSTANCE:y.INSTANCE:new v(g,M,U)}cmp(g){return g.type!==this.type?this.type-g.type:b(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}substituteConstants(){const g=C.get(this.key);if(typeof g=="boolean"){const M=g?"true":"false";return this.value===M?c.INSTANCE:y.INSTANCE}return this}evaluate(g){return g.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(g){return g.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=R.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=v;class w{constructor(g,M){this.key=g,this.valueKey=M,this.type=10,this.negated=null}static create(g,M){return new w(g,M)}cmp(g){return g.type!==this.type?this.type-g.type:b(this.key,this.valueKey,g.key,g.valueKey)}equals(g){return g.type===this.type?this.key===g.key&&this.valueKey===g.valueKey:!1}substituteConstants(){return this}evaluate(g){const M=g.getValue(this.valueKey),U=g.getValue(this.key);return Array.isArray(M)?M.indexOf(U)>=0:typeof U=="string"&&typeof M=="object"&&M!==null?T.call(M,U):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(g){return g.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=_.create(this)),this.negated}}e.ContextKeyInExpr=w;class _{constructor(g){this._actual=g,this.type=11}static create(g){return new _(g)}cmp(g){return g.type!==this.type?this.type-g.type:this._actual.cmp(g._actual)}equals(g){return g.type===this.type?this._actual.equals(g._actual):!1}substituteConstants(){return this}evaluate(g){return!this._actual.evaluate(g)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(g){return new _(this._actual.map(g))}negate(){return this._actual}}e.ContextKeyNotInExpr=_;class R{constructor(g,M,U){this.key=g,this.value=M,this.negated=U,this.type=5}static create(g,M,U=null){if(typeof M=="boolean")return M?p.create(g,U):E.create(g,U);const j=C.get(g);return typeof j=="boolean"?M===(j?"true":"false")?y.INSTANCE:c.INSTANCE:new R(g,M,U)}cmp(g){return g.type!==this.type?this.type-g.type:b(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}substituteConstants(){const g=C.get(this.key);if(typeof g=="boolean"){const M=g?"true":"false";return this.value===M?y.INSTANCE:c.INSTANCE}return this}evaluate(g){return g.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(g){return g.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=R;class p{constructor(g,M){this.key=g,this.negated=M,this.type=3}static create(g,M=null){const U=C.get(g);return typeof U=="boolean"?U?y.INSTANCE:c.INSTANCE:new p(g,M)}cmp(g){return g.type!==this.type?this.type-g.type:m(this.key,g.key)}equals(g){return g.type===this.type?this.key===g.key:!1}substituteConstants(){const g=C.get(this.key);return typeof g=="boolean"?g?y.INSTANCE:c.INSTANCE:this}evaluate(g){return!g.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(g){return g.mapNot(this.key)}negate(){return this.negated||(this.negated=E.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=p;function h(N,g){if(typeof N=="string"){const M=parseFloat(N);isNaN(M)||(N=M)}return typeof N=="string"||typeof N=="number"?g(N):y.INSTANCE}class s{constructor(g,M,U){this.key=g,this.value=M,this.negated=U,this.type=12}static create(g,M,U=null){return h(M,j=>new s(g,j,U))}cmp(g){return g.type!==this.type?this.type-g.type:b(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}substituteConstants(){return this}evaluate(g){return typeof this.value=="string"?!1:parseFloat(g.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(g){return g.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=s;class u{constructor(g,M,U){this.key=g,this.value=M,this.negated=U,this.type=13}static create(g,M,U=null){return h(M,j=>new u(g,j,U))}cmp(g){return g.type!==this.type?this.type-g.type:b(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}substituteConstants(){return this}evaluate(g){return typeof this.value=="string"?!1:parseFloat(g.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(g){return g.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=u;class r{constructor(g,M,U){this.key=g,this.value=M,this.negated=U,this.type=14}static create(g,M,U=null){return h(M,j=>new r(g,j,U))}cmp(g){return g.type!==this.type?this.type-g.type:b(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}substituteConstants(){return this}evaluate(g){return typeof this.value=="string"?!1:parseFloat(g.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(g){return g.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=r;class S{constructor(g,M,U){this.key=g,this.value=M,this.negated=U,this.type=15}static create(g,M,U=null){return h(M,j=>new S(g,j,U))}cmp(g){return g.type!==this.type?this.type-g.type:b(this.key,this.value,g.key,g.value)}equals(g){return g.type===this.type?this.key===g.key&&this.value===g.value:!1}substituteConstants(){return this}evaluate(g){return typeof this.value=="string"?!1:parseFloat(g.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(g){return g.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=S;class a{constructor(g,M){this.key=g,this.regexp=M,this.type=7,this.negated=null}static create(g,M){return new a(g,M)}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.key<g.key)return-1;if(this.key>g.key)return 1;const M=this.regexp?this.regexp.source:"",U=g.regexp?g.regexp.source:"";return M<U?-1:M>U?1:0}equals(g){if(g.type===this.type){const M=this.regexp?this.regexp.source:"",U=g.regexp?g.regexp.source:"";return this.key===g.key&&M===U}return!1}substituteConstants(){return this}evaluate(g){let M=g.getValue(this.key);return this.regexp?this.regexp.test(M):!1}serialize(){const g=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${g}`}keys(){return[this.key]}map(g){return g.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=a;class i{constructor(g){this._actual=g,this.type=8}static create(g){return new i(g)}cmp(g){return g.type!==this.type?this.type-g.type:this._actual.cmp(g._actual)}equals(g){return g.type===this.type?this._actual.equals(g._actual):!1}substituteConstants(){return this}evaluate(g){return!this._actual.evaluate(g)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(g){return new i(this._actual.map(g))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function n(N){let g=null;for(let M=0,U=N.length;M<U;M++){const j=N[M].substituteConstants();if(N[M]!==j&&g===null){g=[];for(let K=0;K<M;K++)g[K]=N[K]}g!==null&&(g[M]=j)}return g===null?N:g}class o{constructor(g,M){this.expr=g,this.negated=M,this.type=6}static create(g,M){return o._normalizeArr(g,M)}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.expr.length<g.expr.length)return-1;if(this.expr.length>g.expr.length)return 1;for(let M=0,U=this.expr.length;M<U;M++){const j=F(this.expr[M],g.expr[M]);if(j!==0)return j}return 0}equals(g){if(g.type===this.type){if(this.expr.length!==g.expr.length)return!1;for(let M=0,U=this.expr.length;M<U;M++)if(!this.expr[M].equals(g.expr[M]))return!1;return!0}return!1}substituteConstants(){const g=n(this.expr);return g===this.expr?this:o.create(g,this.negated)}evaluate(g){for(let M=0,U=this.expr.length;M<U;M++)if(!this.expr[M].evaluate(g))return!1;return!0}static _normalizeArr(g,M){const U=[];let j=!1;for(const K of g)if(!!K){if(K.type===1){j=!0;continue}if(K.type===0)return y.INSTANCE;if(K.type===6){U.push(...K.expr);continue}U.push(K)}if(U.length===0&&j)return c.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(F);for(let K=1;K<U.length;K++)U[K-1].equals(U[K])&&(U.splice(K,1),K--);if(U.length===1)return U[0];for(;U.length>1;){const K=U[U.length-1];if(K.type!==9)break;U.pop();const B=U.pop(),x=U.length===0,z=l.create(K.expr.map(G=>o.create([G,B],null)),null,x);z&&(U.push(z),U.sort(F))}return U.length===1?U[0]:new o(U,M)}}serialize(){return this.expr.map(g=>g.serialize()).join(" && ")}keys(){const g=[];for(let M of this.expr)g.push(...M.keys());return g}map(g){return new o(this.expr.map(M=>M.map(g)),null)}negate(){if(!this.negated){const g=[];for(let M of this.expr)g.push(M.negate());this.negated=l.create(g,this,!0)}return this.negated}}class l{constructor(g,M){this.expr=g,this.negated=M,this.type=9}static create(g,M,U){return l._normalizeArr(g,M,U)}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.expr.length<g.expr.length)return-1;if(this.expr.length>g.expr.length)return 1;for(let M=0,U=this.expr.length;M<U;M++){const j=F(this.expr[M],g.expr[M]);if(j!==0)return j}return 0}equals(g){if(g.type===this.type){if(this.expr.length!==g.expr.length)return!1;for(let M=0,U=this.expr.length;M<U;M++)if(!this.expr[M].equals(g.expr[M]))return!1;return!0}return!1}substituteConstants(){const g=n(this.expr);return g===this.expr?this:l.create(g,this.negated,!1)}evaluate(g){for(let M=0,U=this.expr.length;M<U;M++)if(this.expr[M].evaluate(g))return!0;return!1}static _normalizeArr(g,M,U){let j=[],K=!1;if(g){for(let B=0,x=g.length;B<x;B++){const z=g[B];if(!!z){if(z.type===0){K=!0;continue}if(z.type===1)return c.INSTANCE;if(z.type===9){j=j.concat(z.expr);continue}j.push(z)}}if(j.length===0&&K)return y.INSTANCE;j.sort(F)}if(j.length!==0){if(j.length===1)return j[0];for(let B=1;B<j.length;B++)j[B-1].equals(j[B])&&(j.splice(B,1),B--);if(j.length===1)return j[0];if(U){for(let B=0;B<j.length;B++)for(let x=B+1;x<j.length;x++)A(j[B],j[x])&&(j.splice(x,1),x--);if(j.length===1)return j[0]}return new l(j,M)}}serialize(){return this.expr.map(g=>g.serialize()).join(" || ")}keys(){const g=[];for(let M of this.expr)g.push(...M.keys());return g}map(g){return new l(this.expr.map(M=>M.map(g)),null)}negate(){if(!this.negated){let g=[];for(let M of this.expr)g.push(M.negate());for(;g.length>1;){const M=g.shift(),U=g.shift(),j=[];for(const B of L(M))for(const x of L(U))j.push(o.create([B,x],null));const K=g.length===0;g.unshift(l.create(j,null,K))}this.negated=g[0]}return this.negated}}class f extends E{constructor(g,M,U){super(g,null);this._defaultValue=M,typeof U=="object"?f._info.push({...U,key:g}):U!==!0&&f._info.push({key:g,description:U,type:M!=null?typeof M:void 0})}static all(){return f._info.values()}bindTo(g){return g.createKey(this.key,this._defaultValue)}getValue(g){return g.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(g){return v.create(this.key,g)}notEqualsTo(g){return R.create(this.key,g)}}e.RawContextKey=f,f._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function m(N,g){return N<g?-1:N>g?1:0}function b(N,g,M,U){return N<M?-1:N>M?1:g<U?-1:g>U?1:0}function A(N,g){if(g.type===6&&N.type!==9&&N.type!==6){for(const j of g.expr)if(N.equals(j))return!0}const M=N.negate(),U=L(M).concat(L(g));U.sort(F);for(let j=0;j<U.length;j++){const B=U[j].negate();for(let x=j+1;x<U.length;x++){const z=U[x];if(B.equals(z))return!0}}return!1}e.implies=A;function L(N){return N.type===9?N.expr:[N]}}),define(pe[186],ve([0,1,4]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,d.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,d.refineServiceDecorator)(e.IEnvironmentService)}),define(pe[187],ve([0,1,4]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,d.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,d.createDecorator)("externalTerminal")}),define(pe[188],ve([0,1,38,10,9,11,97,29,113,163,187]),function(ee,e,d,t,I,C,T,k,D,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const y=P.localize(0,null);class c{async getDefaultTerminalForPlatforms(){return{windows:E.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class E extends c{openTerminal(s,u){return this.spawnTerminal(d,s,D.getWindowsShell(),u)}spawnTerminal(s,u,r,S){const a=u.windowsExec||E.getDefaultTerminalWindows();S&&S[1]===":"&&(S=S[0].toUpperCase()+S.substr(1));const i=I.basename(a).toLowerCase();if(i==="cmder"||i==="cmder.exe")return s.spawn(a,S?[S]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return a.indexOf(" ")>=0&&n.push('""'),n.push(a),(i==="wt"||i==="wt.exe")&&n.push("-d ."),new Promise((o,l)=>{const f=_(process),m=s.spawn(r,n,{cwd:S,env:f});m.on("error",l),m.on("exit",()=>o())})}runInTerminal(s,u,r,S,a){const i="windowsExec"in a&&a.windowsExec?a.windowsExec:E.getDefaultTerminalWindows();return new Promise((n,o)=>{const l=`"${u} - ${y}"`,f=`""${r.join('" "')}" & pause"`,m=["/c","start",l,"/wait",i,"/c",f],b=Object.assign({},_(process),S);Object.keys(b).filter(N=>b[N]===null).forEach(N=>delete b[N]);const A={cwd:u,env:b,windowsVerbatimArguments:!0};d.spawn(E.CMD,m,A).on("error",N=>{o(R(N))}),n(void 0)})}static getDefaultTerminalWindows(){if(!E._DEFAULT_TERMINAL_WINDOWS){const s=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");E._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${s?"Sysnative":"System32"}\\cmd.exe`}return E._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=E,E.CMD="cmd.exe";class v extends c{openTerminal(s,u){return this.spawnTerminal(d,s,u)}runInTerminal(s,u,r,S,a){const i=a.osxExec||F.DEFAULT_TERMINAL_OSX;return new Promise((n,o)=>{if(i===F.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const l=i===F.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",m=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${l}.scpt`,ee).fsPath,"-t",s||y,"-w",u];for(let L of r)m.push("-a"),m.push(L);if(S){const L=Object.assign({},_(process),S);for(let N in L){const g=L[N];g===null?(m.push("-u"),m.push(N)):(m.push("-e"),m.push(`${N}=${g}`))}}let b="";const A=d.spawn(v.OSASCRIPT,m);A.on("error",L=>{o(R(L))}),A.stderr.on("data",L=>{b+=L.toString()}),A.on("exit",L=>{if(L===0)n(void 0);else if(b){const N=b.split(`
`,1);o(new Error(N[0]))}else o(new Error(P.localize(1,null,l,L)))})}else o(new Error(P.localize(2,null,i)))})}spawnTerminal(s,u,r){const S=u.osxExec||F.DEFAULT_TERMINAL_OSX;return new Promise((a,i)=>{const n=["-a",S];r&&n.push(r);const o=_(process),l=s.spawn("/usr/bin/open",n,{cwd:r,env:o});l.on("error",i),l.on("exit",()=>a())})}}e.MacExternalTerminalService=v,v.OSASCRIPT="/usr/bin/osascript";class w extends c{openTerminal(s,u){return this.spawnTerminal(d,s,u)}runInTerminal(s,u,r,S,a){const i=a.linuxExec?Promise.resolve(a.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((n,o)=>{let l=[];i.then(f=>{f.indexOf("gnome-terminal")>=0?l.push("-x"):l.push("-e"),l.push("bash"),l.push("-c");const m=`${p(r)}; echo; read -p "${w.WAIT_MESSAGE}" -n1;`;l.push(`''${m}''`);const b=Object.assign({},_(process),S);Object.keys(b).filter(g=>b[g]===null).forEach(g=>delete b[g]);const A={cwd:u,env:b};let L="";const N=d.spawn(f,l,A);N.on("error",g=>{o(R(g))}),N.stderr.on("data",g=>{L+=g.toString()}),N.on("exit",g=>{if(g===0)n(void 0);else if(L){const M=L.split(`
`,1);o(new Error(M[0]))}else o(new Error(P.localize(4,null,f,g)))})})})}static async getDefaultTerminalLinuxReady(){if(!w._DEFAULT_TERMINAL_LINUX_READY)if(!C.isLinux)w._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const s=await k.Promises.exists("/etc/debian_version");w._DEFAULT_TERMINAL_LINUX_READY=new Promise(u=>{s?u("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?u("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?u("konsole"):process.env.COLORTERM?u(process.env.COLORTERM):process.env.TERM?u(process.env.TERM):u("xterm")})}return w._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(s,u,r){const S=u.linuxExec?Promise.resolve(u.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((a,i)=>{S.then(n=>{const o=_(process),l=s.spawn(n,[],{cwd:r,env:o});l.on("error",i),l.on("exit",()=>a())})})}}e.LinuxExternalTerminalService=w,w.WAIT_MESSAGE=P.localize(3,null);function _(h){const s={...h.env};return(0,T.sanitizeProcessEnvironment)(s),s}function R(h){return"errno"in h&&h.errno==="ENOENT"&&"path"in h&&typeof h.path=="string"?new Error(P.localize(5,null,h.path)):h}function p(h){let s="";for(let u of h)u.indexOf(" ")>=0?s+='"'+u+'"':s+=u,s+=" ";return s}}),define(pe[42],ve([0,1,24,9,8,18,2,164,4]),function(ee,e,d,t,I,C,T,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,D.createDecorator)("fileService");function P(K){return K.create===!0}e.isFileOpenForWriteOptions=P;var F;(function(K){K[K.Unknown=0]="Unknown",K[K.File=1]="File",K[K.Directory=2]="Directory",K[K.SymbolicLink=64]="SymbolicLink"})(F=e.FileType||(e.FileType={}));var y;(function(K){K[K.Readonly=1]="Readonly"})(y=e.FilePermission||(e.FilePermission={}));var c;(function(K){K[K.FileReadWrite=2]="FileReadWrite",K[K.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",K[K.FileReadStream=16]="FileReadStream",K[K.FileFolderCopy=8]="FileFolderCopy",K[K.PathCaseSensitive=1024]="PathCaseSensitive",K[K.Readonly=2048]="Readonly",K[K.Trash=4096]="Trash",K[K.FileWriteUnlock=8192]="FileWriteUnlock",K[K.FileAtomicRead=16384]="FileAtomicRead"})(c=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E(K){return!!(K.capabilities&2)}e.hasReadWriteCapability=E;function v(K){return!!(K.capabilities&8)}e.hasFileFolderCopyCapability=v;function w(K){return!!(K.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function _(K){return!!(K.capabilities&16)}e.hasFileReadStreamCapability=_;function R(K){return E(K)?!!(K.capabilities&16384):!1}e.hasFileAtomicReadCapability=R;var p;(function(K){K.FileExists="EntryExists",K.FileNotFound="EntryNotFound",K.FileNotADirectory="EntryNotADirectory",K.FileIsADirectory="EntryIsADirectory",K.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",K.FileTooLarge="EntryTooLarge",K.FileWriteLocked="EntryWriteLocked",K.NoPermissions="NoPermissions",K.Unavailable="Unavailable",K.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class h extends Error{constructor(B,x){super(B);this.code=x}}e.FileSystemProviderError=h;function s(K,B){const x=new h(K.toString(),B);return r(x,B),x}e.createFileSystemProviderError=s;function u(K){return K||s((0,k.localize)(0,null),p.Unknown)}e.ensureFileSystemProviderError=u;function r(K,B){return K.name=B?`${B} (FileSystemError)`:"FileSystemError",K}e.markAsFileSystemProviderError=r;function S(K){if(!K)return p.Unknown;if(K instanceof h)return K.code;const B=/^(.+) \(FileSystemError\)$/.exec(K.name);if(!B)return p.Unknown;switch(B[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=S;function a(K){if(K instanceof m)return K.fileOperationResult;switch(S(K)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var i;(function(K){K[K.CREATE=0]="CREATE",K[K.DELETE=1]="DELETE",K[K.MOVE=2]="MOVE",K[K.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class n{constructor(B,x,z){this.resource=B,this.operation=x,this.target=z}isOperation(B){return this.operation===B}}e.FileOperationEvent=n;var o;(function(K){K[K.UPDATED=0]="UPDATED",K[K.ADDED=1]="ADDED",K[K.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class l{constructor(B,x){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=B;const z=new Map;for(const G of B){const q=z.get(G.type);switch(q?q.push([G.resource,G]):z.set(G.type,[[G.resource,G]]),G.type){case 1:this.rawAdded.push(G.resource);break;case 0:this.rawUpdated.push(G.resource);break;case 2:this.rawDeleted.push(G.resource);break}}for(const[G,q]of z)switch(G){case 1:this.added=d.TernarySearchTree.forUris(()=>x),this.added.fill(q);break;case 0:this.updated=d.TernarySearchTree.forUris(()=>x),this.updated.fill(q);break;case 2:this.deleted=d.TernarySearchTree.forUris(()=>x),this.deleted.fill(q);break}}contains(B,...x){return this.doContains(B,{includeChildren:!1},...x)}affects(B,...x){return this.doContains(B,{includeChildren:!0},...x)}doContains(B,x,...z){if(!B)return!1;const G=z.length>0;return!!((!G||z.includes(1))&&(this.added?.get(B)||x.includeChildren&&this.added?.findSuperstr(B))||(!G||z.includes(0))&&(this.updated?.get(B)||x.includeChildren&&this.updated?.findSuperstr(B))||(!G||z.includes(2))&&(this.deleted?.findSubstr(B)||x.includeChildren&&this.deleted?.findSuperstr(B)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=l;function f(K,B,x){return!K||!B||K===B||B.length>K.length?!1:(B.charAt(B.length-1)!==t.sep&&(B+=t.sep),x?(0,I.startsWithIgnoreCase)(K,B):K.indexOf(B)===0)}e.isParent=f;class m extends Error{constructor(B,x,z){super(B);this.fileOperationResult=x,this.options=z}}e.FileOperationError=m;class b extends m{constructor(B,x,z){super(B,2,z);this.stat=x}}e.NotModifiedSinceFileOperationError=b;var A;(function(K){K[K.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",K[K.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",K[K.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",K[K.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",K[K.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",K[K.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",K[K.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",K[K.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",K[K.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",K[K.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",K[K.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",K[K.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var L;(function(K){K[K.FILE=0]="FILE",K[K.FOLDER=1]="FOLDER",K[K.ROOT_FOLDER=2]="ROOT_FOLDER"})(L=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function N(K){if(!(typeof K.size!="number"||typeof K.mtime!="number"))return K.mtime.toString(29)+K.size.toString(31)}e.etag=N;async function g(K,B){if(!B.hasProvider(T.URI.from({scheme:K.scheme})))return new Promise(x=>{const z=B.onDidChangeFileSystemProviderRegistrations(G=>{G.scheme===K.scheme&&G.added&&(z.dispose(),x())})})}e.whenProviderRegistered=g,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class M{static formatSize(B){return(0,C.isNumber)(B)||(B=0),B<M.KB?(0,k.localize)(1,null,B.toFixed(0)):B<M.MB?(0,k.localize)(2,null,(B/M.KB).toFixed(2)):B<M.GB?(0,k.localize)(3,null,(B/M.MB).toFixed(2)):B<M.TB?(0,k.localize)(4,null,(B/M.GB).toFixed(2)):(0,k.localize)(5,null,(B/M.TB).toFixed(2))}}e.ByteSize=M,M.KB=1024,M.MB=M.KB*M.KB,M.GB=M.MB*M.KB,M.TB=M.GB*M.KB;var U;(function(K){K[K.IA32=0]="IA32",K[K.OTHER=1]="OTHER"})(U=e.Arch||(e.Arch={}));function j(K){return{maxFileSize:K===0?300*M.MB:16*M.GB,maxHeapSize:K===0?700*M.MB:2*700*M.MB}}e.getPlatformLimits=j}),define(pe[84],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class d{constructor(...I){this._entries=new Map;for(let[C,T]of I)this.set(C,T)}set(I,C){const T=this._entries.get(I);return this._entries.set(I,C),T}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}e.ServiceCollection=d}),define(pe[189],ve([0,1,13,16,115,185,4,84]),function(ee,e,d,t,I,C,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const D=!1;class P extends Error{constructor(v){super("cyclic dependency between services");this.message=v.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${v.toString()}`}}class F{constructor(v=new k.ServiceCollection,w=!1,_){this._activeInstantiations=new Set,this._services=v,this._strict=w,this._parent=_,this._services.set(T.IInstantiationService,this)}createChild(v){return new F(v,this._strict,this)}invokeFunction(v,...w){let _=c.traceInvocation(v),R=!1;try{return v({get:h=>{if(R)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(h,_);if(!s)throw new Error(`[invokeFunction] unknown service '${h}'`);return s}},...w)}finally{R=!0,_.stop()}}createInstance(v,...w){let _,R;return v instanceof I.SyncDescriptor?(_=c.traceCreation(v.ctor),R=this._createInstance(v.ctor,v.staticArguments.concat(w),_)):(_=c.traceCreation(v),R=this._createInstance(v,w,_)),_.stop(),R}_createInstance(v,w=[],_){let R=T._util.getServiceDependencies(v).sort((s,u)=>s.index-u.index),p=[];for(const s of R){let u=this._getOrCreateServiceInstance(s.id,_);if(!u&&this._strict&&!s.optional)throw new Error(`[createInstance] ${v.name} depends on UNKNOWN service ${s.id}.`);p.push(u)}let h=R.length>0?R[0].index:w.length;if(w.length!==h){console.warn(`[createInstance] First service dependency of ${v.name} at position ${h+1} conflicts with ${w.length} static arguments`);let s=h-w.length;s>0?w=w.concat(new Array(s)):w=w.slice(0,h)}return new v(...[...w,...p])}_setServiceInstance(v,w){if(this._services.get(v)instanceof I.SyncDescriptor)this._services.set(v,w);else if(this._parent)this._parent._setServiceInstance(v,w);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(v){let w=this._services.get(v);return!w&&this._parent?this._parent._getServiceInstanceOrDescriptor(v):w}_getOrCreateServiceInstance(v,w){let _=this._getServiceInstanceOrDescriptor(v);return _ instanceof I.SyncDescriptor?this._safeCreateAndCacheServiceInstance(v,_,w.branch(v,!0)):(w.branch(v,!1),_)}_safeCreateAndCacheServiceInstance(v,w,_){if(this._activeInstantiations.has(v))throw new Error(`illegal state - RECURSIVELY instantiating service '${v}'`);this._activeInstantiations.add(v);try{return this._createAndCacheServiceInstance(v,w,_)}finally{this._activeInstantiations.delete(v)}}_createAndCacheServiceInstance(v,w,_){const R=new C.Graph(s=>s.id.toString());let p=0;const h=[{id:v,desc:w,_trace:_}];for(;h.length;){const s=h.pop();if(R.lookupOrInsertNode(s),p++>1e3)throw new P(R);for(let u of T._util.getServiceDependencies(s.desc.ctor)){let r=this._getServiceInstanceOrDescriptor(u.id);if(!r&&!u.optional&&console.warn(`[createInstance] ${v} depends on ${u.id} which is NOT registered.`),r instanceof I.SyncDescriptor){const S={id:u.id,desc:r,_trace:s._trace.branch(u.id,!0)};R.insertEdge(s,S),h.push(S)}}}for(;;){const s=R.roots();if(s.length===0){if(!R.isEmpty())throw new P(R);break}for(const{data:u}of s){if(this._getServiceInstanceOrDescriptor(u.id)instanceof I.SyncDescriptor){const S=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,S)}R.removeNode(u)}}return this._getServiceInstanceOrDescriptor(v)}_createServiceInstanceWithOwner(v,w,_=[],R,p){if(this._services.get(v)instanceof I.SyncDescriptor)return this._createServiceInstance(w,_,R,p);if(this._parent)return this._parent._createServiceInstanceWithOwner(v,w,_,R,p);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}_createServiceInstance(v,w=[],_,R){if(_){const p=new d.IdleValue(()=>this._createInstance(v,w,R));return new Proxy(Object.create(null),{get(h,s){if(s in h)return h[s];let u=p.value,r=u[s];return typeof r!="function"||(r=r.bind(u),h[s]=r),r},set(h,s,u){return p.value[s]=u,!0}})}else return this._createInstance(v,w,R)}}e.InstantiationService=F;var y;(function(E){E[E.Creation=0]="Creation",E[E.Invocation=1]="Invocation",E[E.Branch=2]="Branch"})(y||(y={}));class c{constructor(v,w){this.type=v,this.name=w,this._start=Date.now(),this._dep=[]}static traceInvocation(v){return D?new c(1,v.name||v.toString().substring(0,42).replace(/\n/g,"")):c._None}static traceCreation(v){return D?new c(0,v.name):c._None}branch(v,w){let _=new c(2,v.toString());return this._dep.push([v,w,_]),_}stop(){let v=Date.now()-this._start;c._totals+=v;let w=!1;function _(p,h){let s=[],u=new Array(p+1).join("	");for(const[r,S,a]of h._dep)if(S&&a){w=!0,s.push(`${u}CREATES -> ${r}`);let i=_(p+1,a);i&&s.push(i)}else s.push(`${u}uses -> ${r}`);return s.join(`
`)}let R=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${_(1,this)}`,`DONE, took ${v.toFixed(2)}ms (grand total ${c._totals.toFixed(2)}ms)`];(v>2||w)&&console.log(R.join(`
`))}}e.Trace=c,c._None=new class extends c{constructor(){super(-1,null)}stop(){}branch(){return this}},c._totals=0}),define(pe[12],ve([0,1,49,3,6,11,4]),function(ee,e,d,t,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function k(){return new Date().toISOString()}var D;(function(S){S[S.Trace=0]="Trace",S[S.Debug=1]="Debug",S[S.Info=2]="Info",S[S.Warning=3]="Warning",S[S.Error=4]="Error",S[S.Critical=5]="Critical",S[S.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;function P(S,a,i){switch(a){case D.Trace:S.trace(i);break;case D.Debug:S.debug(i);break;case D.Info:S.info(i);break;case D.Warning:S.warn(i);break;case D.Error:S.error(i);break;case D.Critical:S.critical(i);break;default:throw new Error("Invalid log level")}}e.log=P;function F(S){let a="";for(let i=0;i<S.length;i++){let n=S[i];if(typeof n=="object")try{n=JSON.stringify(n)}catch{}a+=(i>0?" ":"")+n}return a}e.format=F;class y extends I.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(a){this.level!==a&&(this.level=a,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=y;class c extends y{constructor(a){super();this.logAlways=a}checkLogLevel(a){return this.logAlways||this.getLevel()<=a}trace(a,...i){this.checkLogLevel(D.Trace)&&this.log(D.Trace,F([a,...i]))}debug(a,...i){this.checkLogLevel(D.Debug)&&this.log(D.Debug,F([a,...i]))}info(a,...i){this.checkLogLevel(D.Info)&&this.log(D.Info,F([a,...i]))}warn(a,...i){this.checkLogLevel(D.Warning)&&this.log(D.Warning,F([a,...i]))}error(a,...i){if(this.checkLogLevel(D.Error))if(a instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=a.stack,this.log(D.Error,F(n))}else this.log(D.Error,F([a,...i]))}critical(a,...i){this.checkLogLevel(D.Critical)&&this.log(D.Critical,F([a,...i]))}flush(){}}e.AbstractMessageLogger=c;class E extends y{constructor(a=e.DEFAULT_LOG_LEVEL){super();this.setLevel(a),this.useColors=!C.isWindows}trace(a,...i){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,a,...i):console.log(`[main ${k()}]`,a,...i))}debug(a,...i){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,a,...i):console.log(`[main ${k()}]`,a,...i))}info(a,...i){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,a,...i):console.log(`[main ${k()}]`,a,...i))}warn(a,...i){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,a,...i):console.warn(`[main ${k()}]`,a,...i))}error(a,...i){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,a,...i):console.error(`[main ${k()}]`,a,...i))}critical(a,...i){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,a,...i):console.error(`[main ${k()}]`,a,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=E;class v extends y{constructor(a=e.DEFAULT_LOG_LEVEL){super();this.setLevel(a)}trace(a,...i){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",a,...i)}debug(a,...i){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",a,...i)}info(a,...i){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",a,...i)}warn(a,...i){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",a,...i)}error(a,...i){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",a,...i)}critical(a,...i){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",a,...i)}dispose(){}flush(){}}e.ConsoleLogger=v;class w extends y{constructor(a,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=a,this.setLevel(i)}trace(a,...i){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(a),...i])}debug(a,...i){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(a),...i])}info(a,...i){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(a),...i])}warn(a,...i){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(a),...i])}error(a,...i){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(a),...i])}critical(a,...i){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(a),...i])}extractMessage(a){return typeof a=="string"?a:(0,d.toErrorMessage)(a,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=w;class _ extends y{constructor(a){super();this.logServices=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const i of this.logServices)i.setLevel(a);super.setLevel(a)}trace(a,...i){for(const n of this.logServices)n.trace(a,...i)}debug(a,...i){for(const n of this.logServices)n.debug(a,...i)}info(a,...i){for(const n of this.logServices)n.info(a,...i)}warn(a,...i){for(const n of this.logServices)n.warn(a,...i)}error(a,...i){for(const n of this.logServices)n.error(a,...i)}critical(a,...i){for(const n of this.logServices)n.critical(a,...i)}flush(){for(const a of this.logServices)a.flush()}dispose(){for(const a of this.logServices)a.dispose()}}e.MultiplexLogService=_;class R extends I.Disposable{constructor(a){super();this.logger=a,this._register(a)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(a){this.logger.setLevel(a)}getLevel(){return this.logger.getLevel()}trace(a,...i){this.logger.trace(a,...i)}debug(a,...i){this.logger.debug(a,...i)}info(a,...i){this.logger.info(a,...i)}warn(a,...i){this.logger.warn(a,...i)}error(a,...i){this.logger.error(a,...i)}critical(a,...i){this.logger.critical(a,...i)}flush(){this.logger.flush()}}e.LogService=R;class p extends I.Disposable{constructor(a,i){super();this.logLevel=a,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(n))}))}getLogger(a){return this.loggers.get(a.toString())}createLogger(a,i){let n=this.loggers.get(a.toString());return n||(n=this.doCreateLogger(a,i?.always?D.Trace:this.logLevel,i),this.loggers.set(a.toString(),n),i?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(a=>a.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=p;class h{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(a){}getLevel(){return D.Info}trace(a,...i){}debug(a,...i){}info(a,...i){}warn(a,...i){}error(a,...i){}critical(a,...i){}dispose(){}flush(){}}e.NullLogService=h;function s(S){if(S.verbose)return D.Trace;if(typeof S.logLevel=="string"){const a=u(S.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=s;function u(S){switch(S){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=u;function r(S){switch(S){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=r}),define(pe[190],ve([0,1,42,12]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function I(k,D,P,F,y){try{const c=await new Promise((v,w)=>{ee(["spdlog"],v,w)});c.setFlushOn(t.LogLevel.Trace);const E=await c.createAsyncRotatingLogger(k,D,P,F);return y&&E.clearFormatters(),E}catch(c){console.error(c)}return null}function C(k,D,P){switch(D){case t.LogLevel.Trace:k.trace(P);break;case t.LogLevel.Debug:k.debug(P);break;case t.LogLevel.Info:k.info(P);break;case t.LogLevel.Warning:k.warn(P);break;case t.LogLevel.Error:k.error(P);break;case t.LogLevel.Critical:k.critical(P);break;default:throw new Error("Invalid log level")}}class T extends t.AbstractMessageLogger{constructor(D,P,F,y,c){super();this.buffer=[],this.setLevel(c),this._loggerCreationPromise=this._createSpdLogLogger(D,P,F,y),this._register(this.onDidChangeLogLevel(E=>{this._logger&&this._logger.setLevel(E)}))}async _createSpdLogLogger(D,P,F,y){const c=F?6:1,E=30/c*d.ByteSize.MB,v=await I(D,P,E,c,y);if(v){this._logger=v,this._logger.setLevel(this.getLevel());for(const{level:w,message:_}of this.buffer)C(this._logger,w,_);this.buffer=[]}}log(D,P){this._logger?C(this._logger,D,P):this.getLevel()<=D&&this.buffer.push({level:D,message:P})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=T}),define(pe[117],ve([0,1,47,165,4]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var C;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(C=e.MarkerTag||(e.MarkerTag={}));var T;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(T=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function P(v,w){return w-v}D.compare=P;const F=Object.create(null);F[D.Error]=(0,t.localize)(0,null),F[D.Warning]=(0,t.localize)(1,null),F[D.Info]=(0,t.localize)(2,null);function y(v){return F[v]||""}D.toString=y;function c(v){switch(v){case d.default.Error:return D.Error;case d.default.Warning:return D.Warning;case d.default.Info:return D.Info;case d.default.Ignore:return D.Hint}}D.fromSeverity=c;function E(v){switch(v){case D.Error:return d.default.Error;case D.Warning:return d.default.Warning;case D.Info:return d.default.Info;case D.Hint:return d.default.Ignore}}D.toSeverity=E}(T=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(D){const P="";function F(c){return y(c,!0)}D.makeKey=F;function y(c,E){let v=[P];return c.source?v.push(c.source.replace("\xA6","\\\xA6")):v.push(P),c.code?typeof c.code=="string"?v.push(c.code.replace("\xA6","\\\xA6")):v.push(c.code.value.replace("\xA6","\\\xA6")):v.push(P),c.severity!==void 0&&c.severity!==null?v.push(T.toString(c.severity)):v.push(P),c.message&&E?v.push(c.message.replace("\xA6","\\\xA6")):v.push(P),c.startLineNumber!==void 0&&c.startLineNumber!==null?v.push(c.startLineNumber.toString()):v.push(P),c.startColumn!==void 0&&c.startColumn!==null?v.push(c.startColumn.toString()):v.push(P),c.endLineNumber!==void 0&&c.endLineNumber!==null?v.push(c.endLineNumber.toString()):v.push(P),c.endColumn!==void 0&&c.endColumn!==null?v.push(c.endColumn.toString()):v.push(P),v.push(P),v.join("\xA6")}D.makeKeyOptionalMessage=y})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,I.createDecorator)("markerService")}),define(pe[191],ve([0,1,3,47,4]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,I.createDecorator)("notificationService");var C;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(C=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var T;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(T=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new D,this.onDidClose=d.Event.None,this.onDidChangeVisibility=d.Event.None}updateSeverity(F){}updateMessage(F){}updateActions(F){}close(){}}e.NoOpNotification=k;class D{infinite(){}done(){}total(F){}worked(F){}}e.NoOpProgress=D}),define(pe[192],ve([0,1,6,8,2,4]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.selectionFragment=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,C.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return d.Disposable.None},registerValidator(){return d.Disposable.None},registerExternalUriResolver(){return d.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return d.Disposable.None},async open(){return!1},async resolveExternalUri(P){return{resolved:P,dispose(){}}}});function T(P,F){return I.URI.isUri(P)?(0,t.equalsIgnoreCase)(P.scheme,F):(0,t.startsWithIgnoreCase)(P,F+":")}e.matchesScheme=T;function k(P,...F){return F.some(y=>T(P,y))}e.matchesSomeScheme=k;function D(P){let F;const y=/^L?(\d+)(?:,(\d+))?/.exec(P.fragment);return y&&(F={startLineNumber:parseInt(y[1]),startColumn:y[2]?parseInt(y[2]):1}),F}e.selectionFragment=D}),define(pe[193],ve([0,1,10,11,37,22,183]),function(ee,e,d,t,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const D=t.globals.vscode.context.configuration();if(D)k=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof ee?.__$__nodeRequire=="function"){const D=(0,C.dirname)(d.FileAccess.asFileUri("",ee));k=ee.__$__nodeRequire((0,C.joinPath)(D,"product.json").fsPath);const P=ee.__$__nodeRequire((0,C.joinPath)(D,"package.json").fsPath);try{const w=(...h)=>h.reduce((s,u)=>(Object.keys(u).forEach(r=>{Array.isArray(s[r])&&Array.isArray(u[r])?s[r]=u[r]:typeof s[r]=="object"&&typeof u[r]=="object"?s[r]=w(s[r],u[r]):s[r]=u[r]}),s),{}),_=(0,T.getUserDataPath)({}),R=t.isWindows?`file:///${_}/product.json`:`file://${_}/product.json`,p=ee.__$__nodeRequire(d.FileAccess.asFileUri(R,ee).fsPath);k=w(k,p)}catch{}I.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`,serverDataFolderName:k.serverDataFolderName?`${k.serverDataFolderName}-dev`:void 0});const{serviceUrl:F,cacheUrl:y,itemUrl:c,controlUrl:E,recommendationsUrl:v}=k.extensionsGallery||{};Object.assign(k,{extensionsGallery:{serviceUrl:I.env.VSCODE_GALLERY_SERVICE_URL||F,cacheUrl:I.env.VSCODE_GALLERY_CACHE_URL||y,itemUrl:I.env.VSCODE_GALLERY_ITEM_URL||c,controlUrl:I.env.VSCODE_GALLERY_CONTROL_URL||E,recommendationsUrl:I.env.VSCODE_GALLERY_RECOMMENDATIONS_URL||v}}),Object.assign(k,{version:P.version})}else k={},Object.keys(k).length===0&&Object.assign(k,{version:"1.64.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=k});var Me=this&&this.__param||function(ee,e){return function(d,t){e(d,t,ee)}};define(pe[118],ve([0,1,13,21,6,4]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,C.createDecorator)("progressService");var T;(function(F){F[F.Explorer=1]="Explorer",F[F.Scm=3]="Scm",F[F.Extensions=5]="Extensions",F[F.Window=10]="Window",F[F.Notification=15]="Notification",F[F.Dialog=20]="Dialog"})(T=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(y){this.callback=y}get value(){return this._value}report(y){this._value=y,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let D=class extends I.Disposable{constructor(y,c){super();this.deferred=new d.DeferredPromise,c.withProgress(y,E=>(this.reporter=E,this.lastStep&&E.report(this.lastStep),this.deferred.p)),this._register((0,I.toDisposable)(()=>this.deferred.complete()))}report(y){this.reporter?this.reporter.report(y):this.lastStep=y}};D=Be([Me(1,e.IProgressService)],D),e.UnmanagedProgress=D;class P extends I.Disposable{constructor(y){super();this.progressIndicator=y,this.currentOperationId=0,this.currentOperationDisposables=this._register(new I.DisposableStore)}start(y){this.stop();const c=++this.currentOperationId,E=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{c===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},y),this.currentOperationDisposables.add((0,I.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,I.toDisposable)(()=>E.cancel())),this.currentOperationDisposables.add((0,I.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:c,token:E.token,stop:()=>this.doStop(c),isCurrent:()=>this.currentOperationId===c}}stop(){this.doStop(this.currentOperationId)}doStop(y){this.currentOperationId===y&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,C.createDecorator)("editorProgressService")}),define(pe[50],ve([0,1,55,18]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.data=new Map}add(T,k){d.ok(t.isString(T)),d.ok(t.isObject(k)),d.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,k)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new I}),define(pe[194],ve([0,1,3,50]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class C{constructor(){this._onDidChangeSchema=new d.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,P){this.schemasById[I(D)]=P,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new C;t.Registry.add(e.Extensions.JSONContribution,T)}),define(pe[119],ve([0,1,17,3,18,160,194,50]),function(ee,e,d,t,I,C,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var D;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(D=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const F=k.Registry.as(T.Extensions.JSONContribution);class y{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(u,r=!0){this.registerConfigurations([u],r)}registerConfigurations(u,r=!0){const S=this.doRegisterConfigurations(u,r);F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:S})}deregisterConfigurations(u){const r=this.doDeregisterConfigurations(u);F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:u,remove:r}){const S=[];S.push(...this.doDeregisterConfigurations(r)),S.push(...this.doRegisterConfigurations(u,!1)),F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,d.distinct)(S)})}registerDefaultConfigurations(u){const r=[],S=[];for(const{overrides:a,source:i}of u)for(const n in a)if(r.push(n),e.OVERRIDE_PROPERTY_REGEX.test(n)){const o={...this.configurationDefaultsOverrides.get(n)?.value||{},...a[n]};this.configurationDefaultsOverrides.set(n,{source:i,value:o});const l={type:"object",default:o,description:C.localize(1,null,n),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:o,source:I.isString(i)?void 0:i};S.push(...v(n)),this.configurationProperties[n]=l,this.defaultLanguageConfigurationOverridesNode.properties[n]=l}else{this.configurationDefaultsOverrides.set(n,{value:a[n],source:i});const o=this.configurationProperties[n];o&&(this.updatePropertyDefaultValue(n,o),this.updateSchema(n,o))}this.registerOverrideIdentifiers(S),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(u){const r=[];for(const{overrides:S,source:a}of u)for(const i in S){const n=this.configurationDefaultsOverrides.get(i),o=I.isString(a)?a:a?.id,l=I.isString(n?.source)?n?.source:n?.source?.id;if(o===l)if(r.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const f=this.configurationProperties[i];f&&(this.updatePropertyDefaultValue(i,f),this.updateSchema(i,f))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...u){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(u){for(const r of u)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(u,r){const S=[];return u.forEach(a=>{S.push(...this.validateAndRegisterProperties(a,r,a.extensionInfo,a.restrictedProperties)),this.configurationContributors.push(a),this.registerJSONConfiguration(a)}),S}doDeregisterConfigurations(u){const r=[],S=a=>{if(a.properties)for(const i in a.properties)r.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,a.properties[i]);a.allOf&&a.allOf.forEach(i=>S(i))};for(const a of u){S(a);const i=this.configurationContributors.indexOf(a);i!==-1&&this.configurationContributors.splice(i,1)}return r}validateAndRegisterProperties(u,r=!0,S,a,i=3){i=I.isUndefinedOrNull(u.scope)?i:u.scope;let n=[],o=u.properties;if(o)for(let f in o){if(r&&p(f)){delete o[f];continue}const m=o[f];if(m.source=S,m.defaultDefaultValue=o[f].default,this.updatePropertyDefaultValue(f,m),e.OVERRIDE_PROPERTY_REGEX.test(f)?m.scope=void 0:(m.scope=I.isUndefinedOrNull(m.scope)?i:m.scope,m.restricted=I.isUndefinedOrNull(m.restricted)?!!a?.includes(f):m.restricted),o[f].hasOwnProperty("included")&&!o[f].included){this.excludedConfigurationProperties[f]=o[f],delete o[f];continue}else this.configurationProperties[f]=o[f];!o[f].deprecationMessage&&o[f].markdownDeprecationMessage&&(o[f].deprecationMessage=o[f].markdownDeprecationMessage),n.push(f)}let l=u.allOf;if(l)for(let f of l)n.push(...this.validateAndRegisterProperties(f,r,S,a,i));return n}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(u){const r=S=>{let a=S.properties;if(a)for(const n in a)this.updateSchema(n,a[n]);let i=S.allOf;i&&i.forEach(r)};r(u)}updateSchema(u,r){switch(e.allSettings.properties[u]=r,r.scope){case 1:e.applicationSettings.properties[u]=r;break;case 2:e.machineSettings.properties[u]=r;break;case 6:e.machineOverridableSettings.properties[u]=r;break;case 3:e.windowSettings.properties[u]=r;break;case 4:e.resourceSettings.properties[u]=r;break;case 5:e.resourceSettings.properties[u]=r,this.resourceLanguageSettingsSchema.properties[u]=r;break}}removeFromSchema(u,r){switch(delete e.allSettings.properties[u],r.scope){case 1:delete e.applicationSettings.properties[u];break;case 2:delete e.machineSettings.properties[u];break;case 6:delete e.machineOverridableSettings.properties[u];break;case 3:delete e.windowSettings.properties[u];break;case 4:case 5:delete e.resourceSettings.properties[u],delete this.resourceLanguageSettingsSchema.properties[u];break}}updateOverridePropertyPatternKey(){for(const u of this.overrideIdentifiers.values()){const r=`[${u}]`,S={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,S),e.allSettings.properties[r]=S,e.applicationSettings.properties[r]=S,e.machineSettings.properties[r]=S,e.machineOverridableSettings.properties[r]=S,e.windowSettings.properties[r]=S,e.resourceSettings.properties[r]=S}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const u={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(u,r){const S=this.configurationDefaultsOverrides.get(u);let a=S?.value,i=S?.source;I.isUndefined(a)&&(a=r.defaultDefaultValue,i=void 0),I.isUndefined(a)&&(a=_(r.type)),r.default=a,r.defaultValueSource=i}}const c="\\[([^\\]]+)\\]",E=new RegExp(c,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${c})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function v(s){const u=[];if(e.OVERRIDE_PROPERTY_REGEX.test(s)){let r=E.exec(s);for(;r?.length;){const S=r[1].trim();S&&u.push(S),r=E.exec(s)}}return(0,d.distinct)(u)}e.overrideIdentifiersFromKey=v;function w(s){return s.reduce((u,r)=>`${u}[${r}]`,"")}e.keyFromOverrideIdentifiers=w;function _(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=_;const R=new y;k.Registry.add(e.Extensions.Configuration,R);function p(s){return s.trim()?e.OVERRIDE_PROPERTY_REGEX.test(s)?C.localize(7,null,s):R.getConfigurationProperties()[s]!==void 0?C.localize(8,null,s):null:C.localize(6,null)}e.validateProperty=p;function h(){const s=[],u=R.getConfigurationProperties();for(const r of Object.keys(u))s.push([r,u[r].scope]);return s.push(["launch",4]),s.push(["task",4]),s}e.getScopes=h}),define(pe[195],ve([0,1,17,3,57,6,24,25,18,2,116,119,50]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class E{constructor(a={},i=[],n=[]){this._contents=a,this._keys=i,this._overrides=n,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(a){return a?(0,F.getConfigurationValue)(this.contents,a):this.contents}getOverrideValue(a,i){const n=this.getContentsForOverrideIdentifer(i);return n?a?(0,F.getConfigurationValue)(n,a):n:void 0}getKeysForOverrideIdentifier(a){const i=[];for(const n of this.overrides)n.identifiers.includes(a)&&i.push(...n.keys);return d.distinct(i)}getAllOverrideIdentifiers(){const a=[];for(const i of this.overrides)a.push(...i.identifiers);return d.distinct(a)}override(a){let i=this.overrideConfigurations.get(a);return i||(i=this.createOverrideConfigurationModel(a),this.overrideConfigurations.set(a,i)),i}merge(...a){const i=k.deepClone(this.contents),n=k.deepClone(this.overrides),o=[...this.keys];for(const l of a){this.mergeContents(i,l.contents);for(const f of l.overrides){const[m]=n.filter(b=>d.equals(b.identifiers,f.identifiers));m?(this.mergeContents(m.contents,f.contents),m.keys.push(...f.keys),m.keys=d.distinct(m.keys)):n.push(k.deepClone(f))}for(const f of l.keys)o.indexOf(f)===-1&&o.push(f)}return new E(i,o,n)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(a){const i=this.getContentsForOverrideIdentifer(a);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const o of d.distinct([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[o],f=i[o];f&&(typeof l=="object"&&typeof f=="object"?(l=k.deepClone(l),this.mergeContents(l,f)):l=f),n[o]=l}return new E(n,this.keys,this.overrides)}mergeContents(a,i){for(const n of Object.keys(i)){if(n in a&&D.isObject(a[n])&&D.isObject(i[n])){this.mergeContents(a[n],i[n]);continue}a[n]=k.deepClone(i[n])}}checkAndFreeze(a){return this.isFrozen&&!Object.isFrozen(a)?k.deepFreeze(a):a}getContentsForOverrideIdentifer(a){let i=null,n=null;const o=l=>{l&&(n?this.mergeContents(n,l):n=k.deepClone(l))};for(const l of this.overrides)d.equals(l.identifiers,[a])?i=l.contents:l.identifiers.includes(a)&&o(l.contents);return o(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(a,i){this.addKey(a),(0,F.addToValueTree)(this.contents,a,i,n=>{throw new Error(n)})}removeValue(a){this.removeKey(a)&&(0,F.removeFromValueTree)(this.contents,a)}addKey(a){let i=this.keys.length;for(let n=0;n<i;n++)a.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,a)}removeKey(a){let i=this.keys.indexOf(a);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=E;class v extends E{constructor(a={}){const i=c.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),n=Object.keys(i),o=Object.create(null),l=[];for(const f in i){const m=a[f],b=m!==void 0?m:i[f].default;(0,F.addToValueTree)(o,f,b,A=>console.error(`Conflict in default settings: ${A}`))}for(const f of Object.keys(o))y.OVERRIDE_PROPERTY_REGEX.test(f)&&l.push({identifiers:(0,y.overrideIdentifiersFromKey)(f),keys:Object.keys(o[f]),contents:(0,F.toValuesTree)(o[f],m=>console.error(`Conflict in default settings file: ${m}`))});super(o,n,l)}}e.DefaultConfigurationModel=v;class w{constructor(a){this._name=a,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(a,i){if(!D.isUndefinedOrNull(a)){const n=this.doParseContent(a);this.parseRaw(n,i)}}reparse(a){this._raw&&this.parseRaw(this._raw,a)}parseRaw(a,i){this._raw=a;const{contents:n,keys:o,overrides:l,restricted:f}=this.doParseRaw(a,i);this._configurationModel=new E(n,o,l),this._restrictedConfigurations=f||[]}doParseContent(a){let i={},n=null,o=[],l=[],f=[];function m(A){Array.isArray(o)?o.push(A):n!==null&&(o[n]=A)}let b={onObjectBegin:()=>{let A={};m(A),l.push(o),o=A,n=null},onObjectProperty:A=>{n=A},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{let A=[];m(A),l.push(o),o=A,n=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:m,onError:(A,L,N)=>{f.push({error:A,offset:L,length:N})}};if(a)try{I.visit(a,b),i=o[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return i}doParseRaw(a,i){const n=c.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),o=this.filter(a,n,!0,i);a=o.raw;const l=(0,F.toValuesTree)(a,b=>console.error(`Conflict in settings file ${this._name}: ${b}`)),f=Object.keys(a),m=this.toOverrides(a,b=>console.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:l,keys:f,overrides:m,restricted:o.restricted}}filter(a,i,n,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:a,restricted:[]};const l={},f=[];for(let m in a)if(y.OVERRIDE_PROPERTY_REGEX.test(m)&&n){const b=this.filter(a[m],i,!1,o);l[m]=b.raw,f.push(...b.restricted)}else{const b=i[m],A=b?typeof b.scope!="undefined"?b.scope:3:void 0;b?.restricted&&f.push(m),(A===void 0||o.scopes===void 0||o.scopes.includes(A))&&(o.skipRestricted&&b?.restricted||(l[m]=a[m]))}return{raw:l,restricted:f}}toOverrides(a,i){const n=[];for(const o of Object.keys(a))if(y.OVERRIDE_PROPERTY_REGEX.test(o)){const l={};for(const f in a[o])l[f]=a[o][f];n.push({identifiers:(0,y.overrideIdentifiersFromKey)(o),keys:Object.keys(l),contents:(0,F.toValuesTree)(l,i)})}return n}}e.ConfigurationModelParser=w;class _ extends C.Disposable{constructor(a,i,n,o){super();this.userSettingsResource=a,this.scopes=i,this.fileService=o,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const a=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(a.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new E}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=_;class R{constructor(a,i,n=new E,o=new E,l=new T.ResourceMap,f=new E,m=new T.ResourceMap,b=!0){this._defaultConfiguration=a,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=o,this._folderConfigurations=l,this._memoryConfiguration=f,this._memoryConfigurationByResource=m,this._freeze=b,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(a,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(a)}updateValue(a,i,n={}){let o;n.resource?(o=this._memoryConfigurationByResource.get(n.resource),o||(o=new E,this._memoryConfigurationByResource.set(n.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(a):o.setValue(a,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(a,i,n){const o=this.getConsolidateConfigurationModel(i,n),l=this.getFolderConfigurationModelForResource(i.resource,n),f=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,m=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(a):this._defaultConfiguration.freeze().getValue(a),b=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(a):this.userConfiguration.freeze().getValue(a),A=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(a):this.localUserConfiguration.freeze().getValue(a),L=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(a):this.remoteUserConfiguration.freeze().getValue(a),N=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(a):this._workspaceConfiguration.freeze().getValue(a):void 0,g=l?i.overrideIdentifier?l.freeze().override(i.overrideIdentifier).getValue(a):l.freeze().getValue(a):void 0,M=i.overrideIdentifier?f.override(i.overrideIdentifier).getValue(a):f.getValue(a),U=o.getValue(a),j=d.distinct(d.flatten(o.overrides.map(K=>K.identifiers))).filter(K=>o.getOverrideValue(a,K)!==void 0);return{defaultValue:m,userValue:b,userLocalValue:A,userRemoteValue:L,workspaceValue:N,workspaceFolderValue:g,memoryValue:M,value:U,default:m!==void 0?{value:this._defaultConfiguration.freeze().getValue(a),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(a,i.overrideIdentifier):void 0}:void 0,user:b!==void 0?{value:this.userConfiguration.freeze().getValue(a),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(a,i.overrideIdentifier):void 0}:void 0,userLocal:A!==void 0?{value:this.localUserConfiguration.freeze().getValue(a),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(a,i.overrideIdentifier):void 0}:void 0,userRemote:L!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(a),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(a,i.overrideIdentifier):void 0}:void 0,workspace:N!==void 0?{value:this._workspaceConfiguration.freeze().getValue(a),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(a,i.overrideIdentifier):void 0}:void 0,workspaceFolder:g!==void 0?{value:l?.freeze().getValue(a),override:i.overrideIdentifier?l?.freeze().getOverrideValue(a,i.overrideIdentifier):void 0}:void 0,memory:M!==void 0?{value:f.getValue(a),override:i.overrideIdentifier?f.getOverrideValue(a,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:j.length?j:void 0}}keys(a){const i=this.getFolderConfigurationModelForResource(void 0,a);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(a){this._defaultConfiguration=a,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(a){this._localUserConfiguration=a,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(a){this._remoteUserConfiguration=a,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(a){this._workspaceConfiguration=a,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(a,i){this._folderConfigurations.set(a,i),this._foldersConsolidatedConfigurations.delete(a)}deleteFolderConfiguration(a){this.folderConfigurations.delete(a),this._foldersConsolidatedConfigurations.delete(a)}compareAndUpdateDefaultConfiguration(a,i){const n=[];if(!i){const{added:o,updated:l,removed:f}=u(this._defaultConfiguration,a);i=[...o,...l,...f]}for(const o of i)for(const l of(0,y.overrideIdentifiersFromKey)(o)){const f=this._defaultConfiguration.getKeysForOverrideIdentifier(l),m=a.getKeysForOverrideIdentifier(l),b=[...m.filter(A=>f.indexOf(A)===-1),...f.filter(A=>m.indexOf(A)===-1),...f.filter(A=>!k.equals(this._defaultConfiguration.override(l).getValue(A),a.override(l).getValue(A)))];n.push([l,b])}return this.updateDefaultConfiguration(a),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(a){const{added:i,updated:n,removed:o,overrides:l}=u(this.localUserConfiguration,a),f=[...i,...n,...o];return f.length&&this.updateLocalUserConfiguration(a),{keys:f,overrides:l}}compareAndUpdateRemoteUserConfiguration(a){const{added:i,updated:n,removed:o,overrides:l}=u(this.remoteUserConfiguration,a);let f=[...i,...n,...o];return f.length&&this.updateRemoteUserConfiguration(a),{keys:f,overrides:l}}compareAndUpdateWorkspaceConfiguration(a){const{added:i,updated:n,removed:o,overrides:l}=u(this.workspaceConfiguration,a);let f=[...i,...n,...o];return f.length&&this.updateWorkspaceConfiguration(a),{keys:f,overrides:l}}compareAndUpdateFolderConfiguration(a,i){const n=this.folderConfigurations.get(a),{added:o,updated:l,removed:f,overrides:m}=u(n,i);let b=[...o,...l,...f];return(b.length||!n)&&this.updateFolderConfiguration(a,i),{keys:b,overrides:m}}compareAndDeleteFolderConfiguration(a){const i=this.folderConfigurations.get(a);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:n,updated:o,removed:l,overrides:f}=u(i,void 0);return{keys:[...n,...o,...l],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(a,i){let n=this.getConsolidatedConfigurationModelForResource(a,i);return a.overrideIdentifier?n.override(a.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:a},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&a){const o=i.getFolder(a);o&&(n=this.getFolderConsolidatedConfiguration(o.uri)||n);const l=this._memoryConfigurationByResource.get(a);l&&(n=n.merge(l))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(a){let i=this._foldersConsolidatedConfigurations.get(a);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(a);o?(i=n.merge(o),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(a,i)):i=n}return i}getFolderConfigurationModelForResource(a,i){if(i&&a){const n=i.getFolder(a);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((a,i)=>{const{contents:n,overrides:o,keys:l}=this._folderConfigurations.get(i);return a.push([i,{contents:n,overrides:o,keys:l}]),a},[])}}allKeys(){const a=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>a.add(i)),this.userConfiguration.freeze().keys.forEach(i=>a.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>a.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>a.add(n))),[...a.values()]}allOverrideIdentifiers(){const a=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>a.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>a.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>a.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(n=>a.add(n))),[...a.values()]}getAllKeysForOverrideIdentifier(a){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(a).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(a).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(a).forEach(o=>i.add(o))),[...i.values()]}static parse(a){const i=this.parseConfigurationModel(a.defaults),n=this.parseConfigurationModel(a.user),o=this.parseConfigurationModel(a.workspace),l=a.folders.reduce((f,m)=>(f.set(P.URI.revive(m[0]),this.parseConfigurationModel(m[1])),f),new T.ResourceMap);return new R(i,n,new E,o,l,new E,new T.ResourceMap,!1)}static parseConfigurationModel(a){return new E(a.contents,a.keys,a.overrides).freeze()}}e.Configuration=R;function p(...S){if(S.length===0)return{keys:[],overrides:[]};if(S.length===1)return S[0];const a=new Set,i=new Map;for(const o of S)o.keys.forEach(l=>a.add(l)),o.overrides.forEach(([l,f])=>{const m=(0,T.getOrSet)(i,l,new Set);f.forEach(b=>m.add(b))});const n=[];return i.forEach((o,l)=>n.push([l,[...o.values()]])),{keys:[...a.values()],overrides:n}}e.mergeChanges=p;class h{constructor(a,i,n,o){this.change=a,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=o,this._previousConfiguration=void 0;const l=new Set;a.keys.forEach(m=>l.add(m)),a.overrides.forEach(([,m])=>m.forEach(b=>l.add(b))),this.affectedKeys=[...l.values()];const f=new E;this.affectedKeys.forEach(m=>f.setValue(m,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=R.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(a,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,a)){if(i){const n=this.previousConfiguration?this.previousConfiguration.getValue(a,i,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(a,i,this.currentWorkspace);return!k.equals(n,o)}return!0}return!1}doesAffectedKeysTreeContains(a,i){let n=(0,F.toValuesTree)({[i]:!0},()=>{}),o;for(;typeof n=="object"&&(o=Object.keys(n)[0]);){if(a=a[o],!a)return!1;n=n[o]}return!0}}e.ConfigurationChangeEvent=h;class s extends h{constructor(a,i,n,o){super({keys:a.allKeys(),overrides:[]},void 0,a,i);this.source=n,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=s;function u(S,a){const{added:i,removed:n,updated:o}=r(a,S),l=[],f=S?.getAllOverrideIdentifiers()||[],m=a?.getAllOverrideIdentifiers()||[];if(a){const b=m.filter(A=>!f.includes(A));for(const A of b)l.push([A,a.getKeysForOverrideIdentifier(A)])}if(S){const b=f.filter(A=>!m.includes(A));for(const A of b)l.push([A,S.getKeysForOverrideIdentifier(A)])}if(a&&S){for(const b of f)if(m.includes(b)){const A=r({contents:S.getOverrideValue(void 0,b)||{},keys:S.getKeysForOverrideIdentifier(b)},{contents:a.getOverrideValue(void 0,b)||{},keys:a.getKeysForOverrideIdentifier(b)});l.push([b,[...A.added,...A.removed,...A.updated]])}}return{added:i,removed:n,updated:o,overrides:l}}function r(S,a){const i=S?a?S.keys.filter(l=>a.keys.indexOf(l)===-1):[...S.keys]:[],n=a?S?a.keys.filter(l=>S.keys.indexOf(l)===-1):[...a.keys]:[],o=[];if(S&&a){for(const l of a.keys)if(S.keys.indexOf(l)!==-1){const f=(0,F.getConfigurationValue)(a.contents,l),m=(0,F.getConfigurationValue)(S.contents,l);k.equals(f,m)||o.push(l)}}return{added:i,removed:n,updated:o}}}),define(pe[120],ve([0,1,4]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,d.createDecorator)("remoteAuthorityResolverService");var t;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(t=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class I extends Error{constructor(T,k=t.Unknown,D){super(T);this._message=T,this._code=k,this._detail=D,this.isHandled=k===t.NotAvailable&&D===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,I.prototype)}static isTemporarilyNotAvailable(T){return T instanceof I&&T._code===t.TemporarilyNotAvailable}static isNoResolverFound(T){return T instanceof I&&T._code===t.NoResolverFound}static isHandled(T){return T instanceof I&&T.isHandled}}e.RemoteAuthorityResolverError=I}),define(pe[85],ve([0,1,10]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function t(C){return C.scheme===d.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=t;function I(C){if(!C)return;const T=C.indexOf("+");return T<0?C:C.substr(0,T)}e.getRemoteName=I}),define(pe[27],ve([0,1,8,4,85]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.getWorkspaceSupportTypeMessage=C;function T(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class D{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,v){if(typeof E=="undefined"||E===null)return typeof v=="undefined"||v===null;if(typeof v=="undefined"||v===null)return!1;if(typeof E=="string"||typeof v=="string"){let w=typeof E=="string"?E:E.value,_=typeof v=="string"?v:v.value;return d.equalsIgnoreCase(w,_)}return E._lower===v._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}e.ExtensionIdentifier=D;function P(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function F(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=F;function y(c,E){if(E){const v=`onResolveRemoteAuthority:${(0,I.getRemoteName)(E)}`;return c.activationEvents?.indexOf(v)!==-1}return!1}e.isResolverExtension=y,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(pe[121],ve([0,1,8,27]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function I(v,w){return v.uuid&&w.uuid?v.uuid===w.uuid:v.id===w.id?!0:(0,d.compareIgnoreCase)(v.id,w.id)===0}e.areSameExtensions=I;class C{constructor(w,_){this.version=_,this.id=w.id,this.uuid=w.uuid}key(){return`${this.id}-${this.version}`}equals(w){return w instanceof C?I(this,w)&&this.version===w.version:!1}}e.ExtensionIdentifierWithVersion=C;function T(v,w){return`${v}.${w}`}e.getExtensionId=T;function k(v){return v.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function D(v,w){return k(T(v,w))}e.getGalleryExtensionId=D;function P(v,w){const _=[],R=p=>{for(const h of _)if(h.some(s=>I(w(s),w(p))))return h;return null};for(const p of v){const h=R(p);h?h.push(p):_.push([p])}return _}e.groupByExtension=P;function F(v){return{id:v.identifier.id,name:v.manifest.name,galleryId:null,publisherId:v.publisherId,publisherName:v.manifest.publisher,publisherDisplayName:v.publisherDisplayName,dependencies:v.manifest.extensionDependencies&&v.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=F;function y(v){return{id:v.identifier.id,name:v.name,galleryId:v.identifier.uuid,publisherId:v.publisherId,publisherName:v.publisher,publisherDisplayName:v.publisherDisplayName,isPreReleaseVersion:v.properties.isPreReleaseVersion,dependencies:!!(v.properties.dependencies&&v.properties.dependencies.length>0),...v.telemetryData}}e.getGalleryExtensionTelemetryData=y,e.BetterMergeId=new t.ExtensionIdentifier("pprice.better-merge");function c(v){const w=new Set;if(v.malicious)for(const _ of v.malicious)w.add(_.id);return w}e.getMaliciousExtensionsSet=c;function E(v,w){const _=[],R=w.manifest.extensionDependencies?.slice(0)??[];for(;R.length;){const p=R.shift();if(p&&_.every(h=>!I(h.identifier,{id:p}))){const h=v.filter(s=>I(s.identifier,{id:p}));h.length===1&&(_.push(h[0]),R.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return _}e.getExtensionDependencies=E}),define(pe[196],ve([0,1,10,161,121,4]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.getIdAndVersion=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";const T=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function k(r){const S=T.exec(r);return S&&S[1]?[(0,I.adoptToGalleryExtensionId)(S[1]),S[2]]:[(0,I.adoptToGalleryExtensionId)(r),void 0]}e.getIdAndVersion=k;var D;(function(r){r.WIN32_X64="win32-x64",r.WIN32_IA32="win32-ia32",r.WIN32_ARM64="win32-arm64",r.LINUX_X64="linux-x64",r.LINUX_ARM64="linux-arm64",r.LINUX_ARMHF="linux-armhf",r.ALPINE_X64="alpine-x64",r.ALPINE_ARM64="alpine-arm64",r.DARWIN_X64="darwin-x64",r.DARWIN_ARM64="darwin-arm64",r.WEB="web",r.UNIVERSAL="universal",r.UNKNOWN="unknown",r.UNDEFINED="undefined"})(D=e.TargetPlatform||(e.TargetPlatform={}));function P(r){switch(r){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=P;function F(r){switch(r){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=F;function y(r,S){switch(r){case 3:return S==="x64"?"win32-x64":S==="ia32"?"win32-ia32":S==="arm64"?"win32-arm64":"unknown";case 2:return S==="x64"?"linux-x64":S==="arm64"?"linux-arm64":S==="arm"?"linux-armhf":"unknown";case"alpine":return S==="x64"?"alpine-x64":S==="arm64"?"alpine-arm64":"unknown";case 1:return S==="x64"?"darwin-x64":S==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=y;function c(r,S){return S==="web"&&!r.includes("web")}e.isNotWebExtensionInWebTargetPlatform=c;function E(r,S,a){return c(S,a)?!1:r==="undefined"||r==="universal"?!0:r==="unknown"?!1:r===a?!0:v(a).includes(r)}e.isTargetPlatformCompatible=E;function v(r){switch(r){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=v;function w(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(!r.uuid||typeof r.uuid=="string")}e.isIExtensionIdentifier=w;var _;(function(r){r[r.NoneOrRelevance=0]="NoneOrRelevance",r[r.LastUpdatedDate=1]="LastUpdatedDate",r[r.Title=2]="Title",r[r.PublisherName=3]="PublisherName",r[r.InstallCount=4]="InstallCount",r[r.PublishedDate=10]="PublishedDate",r[r.AverageRating=6]="AverageRating",r[r.WeightedRating=12]="WeightedRating"})(_=e.SortBy||(e.SortBy={}));var R;(function(r){r[r.Default=0]="Default",r[r.Ascending=1]="Ascending",r[r.Descending=2]="Descending"})(R=e.SortOrder||(e.SortOrder={}));var p;(function(r){r.Install="install",r.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var h;(function(r){r[r.None=1]="None",r[r.Install=2]="Install",r[r.Update=3]="Update",r[r.Migrate=4]="Migrate"})(h=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService");var s;(function(r){r.Unsupported="Unsupported",r.UnsupportedPreRelease="UnsupportedPreRelease",r.Malicious="Malicious",r.Incompatible="Incompatible",r.IncompatiblePreRelease="IncompatiblePreRelease",r.IncompatibleTargetPlatform="IncompatibleTargetPlatform",r.ReleaseVersionNotFound="ReleaseVersionNotFound",r.Invalid="Invalid",r.Download="Download",r.Extract="Extract",r.Delete="Delete",r.Rename="Rename",r.CorruptZip="CorruptZip",r.IncompleteZip="IncompleteZip",r.Internal="Internal"})(s=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class u extends Error{constructor(S,a){super(S);this.code=a,this.name=a}}e.ExtensionManagementError=u,e.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=d.FileAccess.asBrowserUri("./media/defaultIcon.png",ee).toString(!0),e.ExtensionsLabel=(0,t.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,t.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,C.createDecorator)("IExtensionManagementCLIService")}),define(pe[197],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class d{constructor(){this.validators=new Map}vsda(){return new Promise((I,C)=>ee(["vsda"],I,C))}async createNewMessage(I){try{const C=await this.vsda(),T=new C.validator;if(T){const k=String(d._nextId++);return this.validators.set(k,T),{id:k,data:T.createNewMessage(I)}}}catch{}return{id:"",data:I}}async validate(I,C){if(!I.id)return!0;const T=this.validators.get(I.id);if(!T)return!1;this.validators.delete(I.id);try{return T.validate(C)==="ok"}catch{return!1}}async sign(I){try{const C=await this.vsda(),T=new C.signer;if(T)return T.sign(I)}catch{}return I}}e.SignService=d,d._nextId=1}),define(pe[198],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class d{constructor(I){this._callback=I,this._terminalBufferMap=new Map}dispose(){for(const I of this._terminalBufferMap.values())I.dispose()}startBuffering(I,C,T=5){let k;return k=C(D=>{const P=typeof D=="string"?D:D.data;let F=this._terminalBufferMap.get(I);if(F){F.data.push(P);return}const y=setTimeout(()=>this.flushBuffer(I),T);F={data:[P],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(I),k.dispose()}},this._terminalBufferMap.set(I,F)}),k}stopBuffering(I){const C=this._terminalBufferMap.get(I);C&&C.dispose()}flushBuffer(I){const C=this._terminalBufferMap.get(I);C&&(this._terminalBufferMap.delete(I),this._callback(I,C.data.join("")))}}e.TerminalDataBufferer=d}),define(pe[199],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var d;(function(t){t.DARK="dark",t.LIGHT="light",t.HIGH_CONTRAST="hc"})(d=e.ColorScheme||(e.ColorScheme={}))}),define(pe[86],ve([0,1,73,3,6,4,50,199]),function(ee,e,d,t,I,C,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var D;(function(_){function R(p){return p&&typeof p=="object"&&typeof p.id=="string"}_.isThemeColor=R})(D=e.ThemeColor||(e.ThemeColor={}));function P(_){return{id:_}}e.themeColorFromId=P;var F;(function(_){function R(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||D.isThemeColor(i.color))}_.isThemeIcon=R;const p=new RegExp(`^\\$\\((${d.CSSIcon.iconNameExpression}(?:${d.CSSIcon.iconModifierExpression})?)\\)$`);function h(i){const n=p.exec(i);if(!n)return;let[,o]=n;return{id:o}}_.fromString=h;function s(i){return{id:i}}_.fromId=s;function u(i,n){let o=i.id;const l=o.lastIndexOf("~");return l!==-1&&(o=o.substring(0,l)),n&&(o=`${o}~${n}`),{id:o}}_.modify=u;function r(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}_.getModifier=r;function S(i,n){return i.id===n.id&&i.color?.id===n.color?.id}_.isEqual=S;function a(i,n){return{id:i.id,color:n?P(n):void 0}}_.asThemeIcon=a,_.asClassNameArray=d.CSSIcon.asClassNameArray,_.asClassName=d.CSSIcon.asClassName,_.asCSSSelector=d.CSSIcon.asCSSSelector})(F=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=d.Codicon.file,e.FolderThemeIcon=d.Codicon.folder;function y(_){switch(_){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=y,e.Extensions={ThemingContribution:"base.contributions.theming"};class c{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(R){return this.themingParticipants.push(R),this.onThemingParticipantAddedEmitter.fire(R),(0,I.toDisposable)(()=>{const p=this.themingParticipants.indexOf(R);this.themingParticipants.splice(p,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let E=new c;T.Registry.add(e.Extensions.ThemingContribution,E);function v(_){return E.onColorThemeChange(_)}e.registerThemingParticipant=v;class w extends I.Disposable{constructor(R){super();this.themeService=R,this.theme=R.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(p=>this.onThemeChange(p)))}onThemeChange(R){this.theme=R,this.updateStyles()}updateStyles(){}getColor(R,p){let h=this.theme.getColor(R);return h&&p&&(h=p(h,this.theme)),h?h.toString():null}}e.Themable=w}),define(pe[122],ve([0,1,3,11,4,12]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,I.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,I.createDecorator)("sharedTunnelsService");var T;(function(v){v.Http="http",v.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(v){v.ConstantPrivate="constantPrivate",v.Private="private",v.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var D;(function(v){v[v.Notify=1]="Notify",v[v.OpenBrowser=2]="OpenBrowser",v[v.OpenPreview=3]="OpenPreview",v[v.Silent=4]="Silent",v[v.Ignore=5]="Ignore",v[v.OpenBrowserOnce=6]="OpenBrowserOnce"})(D=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function P(v){if(v.scheme!=="http"&&v.scheme!=="https")return;const w=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(v.authority);if(!!w)return{address:w[1],port:+w[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function F(v){return e.LOCALHOST_ADDRESSES.indexOf(v)>=0}e.isLocalhost=F,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(v){return e.ALL_INTERFACES_ADDRESSES.indexOf(v)>=0}e.isAllInterfaces=y;function c(v,w){return w?w!==1&&v<1024:!t.isWindows&&v<1024}e.isPortPrivileged=c;let E=class{constructor(w){this.logService=w,this._onTunnelOpened=new d.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new d.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new d.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(w){return this._tunnelProvider=w,w?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(w){this._canElevate=w.elevation,this._privacyOptions=w.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const w=[],_=Array.from(this._tunnels.values());for(let R of _){const p=Array.from(R.values());for(let h of p){const s=await h.value;s&&w.push(s)}}return w}async dispose(){for(const w of this._tunnels.values()){for(const{value:_}of w.values())await _.then(R=>R?.dispose());w.clear()}this._tunnels.clear()}openTunnel(w,_,R,p,h=!1,s=k.Private,u){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${_}:${R} on local port ${p}.`),!w)return;_||(_="localhost");const r=this.retainOrCreateTunnel(w,_,R,p,h,s,u);return r?r.then(S=>{if(!S){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(_,R);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.makeTunnel(S);return(S.tunnelRemoteHost!==_||S.tunnelRemotePort!==R)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(a),a}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(w){return{tunnelRemotePort:w.tunnelRemotePort,tunnelRemoteHost:w.tunnelRemoteHost,tunnelLocalPort:w.tunnelLocalPort,localAddress:w.localAddress,privacy:w.privacy,protocol:w.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${w.tunnelRemoteHost}:${w.tunnelRemotePort} `);const _=this._tunnels.get(w.tunnelRemoteHost);if(_){const R=_.get(w.tunnelRemotePort);R&&(R.refcount--,await this.tryDisposeTunnel(w.tunnelRemoteHost,w.tunnelRemotePort,R))}}}}async tryDisposeTunnel(w,_,R){if(R.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${w}:${_}.`);const p=R.value.then(async h=>{h&&(await h.dispose(!0),this._onTunnelClosed.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this._tunnels.has(w)&&this._tunnels.get(w).delete(_),p}}async closeTunnel(w,_){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${w}:${_} `);const R=this._tunnels.get(w);if(R&&R.has(_)){const p=R.get(_);p.refcount=0,await this.tryDisposeTunnel(w,_,p)}}addTunnelToMap(w,_,R){this._tunnels.has(w)||this._tunnels.set(w,new Map),this._tunnels.get(w).set(_,{refcount:1,value:R})}async removeEmptyTunnelFromMap(w,_){const R=this._tunnels.get(w);R&&(await R.get(_)||R.delete(_),R.size===0&&this._tunnels.delete(w))}getTunnelFromMap(w,_){let R=[w];F(w)?(R.push(...e.LOCALHOST_ADDRESSES),R.push(...e.ALL_INTERFACES_ADDRESSES)):y(w)&&R.push(...e.ALL_INTERFACES_ADDRESSES);const p=R.map(h=>this._tunnels.get(h));for(const h of p){const s=h?.get(_);if(s)return s}}canTunnel(w){return!!P(w)}createWithProvider(w,_,R,p,h,s,u){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${_}:${R} on local port ${p}.`);const S={elevationRequired:h?c(p===void 0?R:p):!1},a={remoteAddress:{host:_,port:R},localAddressPort:p,privacy:s,public:s!==k.Private,protocol:u},i=w.forwardPort(a,S);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(_,R,i),i}};E=Be([Me(0,C.ILogService)],E),e.AbstractTunnelService=E}),define(pe[200],ve([0,1,10]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function t(k){return k.scheme!==d.Schemas.file&&k.scheme!==d.Schemas.vscodeRemote}e.isVirtualResource=t;function I(k){if(k.folders.length)return k.folders.every(D=>t(D.uri))?k.folders[0].uri:void 0;if(k.configuration&&t(k.configuration))return k.configuration}e.getVirtualWorkspaceLocation=I;function C(k){return I(k)?.scheme}e.getVirtualWorkspaceScheme=C;function T(k){return I(k)!==void 0}e.isVirtualWorkspace=T}),define(pe[43],ve([0,1,24,22,2,4]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var T;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(T=e.WorkbenchState||(e.WorkbenchState={}));function k(c){const E=c;return!!(E&&typeof E=="object"&&typeof E.id=="string"&&Array.isArray(E.folders))}e.isWorkspace=k;function D(c){const E=c;return!!(E&&typeof E=="object"&&I.URI.isUri(E.uri)&&typeof E.name=="string"&&typeof E.toResource=="function")}e.isWorkspaceFolder=D;class P{constructor(E,v,w,_,R){this._id=E,this._transient=w,this._configuration=_,this._ignorePathCasing=R,this._foldersMap=d.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=v}update(E){this._id=E.id,this._configuration=E.configuration,this._transient=E.transient,this._ignorePathCasing=E._ignorePathCasing,this.folders=E.folders}get folders(){return this._folders}set folders(E){this._folders=E,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(E){this._configuration=E}getFolder(E){return E&&this._foldersMap.findSubstr(E.with({scheme:E.scheme,authority:E.authority,path:E.path}))||null}updateFoldersMap(){this._foldersMap=d.TernarySearchTree.forUris(this._ignorePathCasing);for(const E of this.folders)this._foldersMap.set(E.uri,E)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=P;class F{constructor(E,v){this.raw=v,this.uri=E.uri,this.index=E.index,this.name=E.name}toResource(E){return(0,t.joinPath)(this.uri,E)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=F;function y(c){return new F({uri:c,index:0,name:(0,t.basenameOrAuthority)(c)},{uri:c.toString()})}e.toWorkspaceFolder=y}),define(pe[201],ve([0,1,28,57,141,79,10,9,11,22,2,166,4,85,43]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isWorkspaceBackupInfo=e.isFolderBackupInfo=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const w=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,y.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function _(B){return(typeof B=="string"?(0,k.extname)(B):(0,P.extname)(B))===w}e.hasWorkspaceFileExtension=_,e.IWorkspacesService=(0,c.createDecorator)("workspacesService");function R(B){return B.hasOwnProperty("workspace")}e.isRecentWorkspace=R;function p(B){return B.hasOwnProperty("folderUri")}e.isRecentFolder=p;function h(B){return B.hasOwnProperty("fileUri")}e.isRecentFile=h;function s(B){return B&&B.hasOwnProperty("folderUri")}e.isFolderBackupInfo=s;function u(B){return B&&B.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=u;function r(B){const x=B;return typeof x?.id=="string"&&F.URI.isUri(x.uri)}e.isSingleFolderWorkspaceIdentifier=r;function S(B){if(B.configuration)return{id:B.id,configPath:B.configuration};if(B.folders.length===1)return{id:B.id,uri:B.folders[0].uri}}e.toWorkspaceIdentifier=S;function a(B){const x=B;return typeof x?.id=="string"&&F.URI.isUri(x.configPath)}e.isWorkspaceIdentifier=a;function i(B){const x=B;if(x?.uri)return{id:x.id,uri:F.URI.revive(x.uri)};const z=B;if(z?.configPath)return{id:z.id,configPath:F.URI.revive(z.configPath)};if(B?.id)return{id:B.id}}e.reviveIdentifier=i;function n(B,x){return P.extUriBiasedIgnorePathCase.isEqualOrParent(B,x.untitledWorkspacesHome)}e.isUntitledWorkspace=n;function o(B){return l(B)||f(B)}e.isStoredWorkspaceFolder=o;function l(B){const x=B;return typeof x?.path=="string"&&(!x.name||typeof x.name=="string")}e.isRawFileWorkspaceFolder=l;function f(B){const x=B;return typeof x?.uri=="string"&&(!x.name||typeof x.name=="string")}e.isRawUriWorkspaceFolder=f;function m(B,x,z,G,q=!D.isWindows,Z){if(B.scheme!==G.scheme)return{name:z,uri:B.toString(!0)};let se=x?void 0:Z.relativePath(G,B);if(se!==void 0)se.length===0?se=".":D.isWindows&&B.scheme===T.Schemas.file&&!q&&(se=se.replace(/\//g,"\\"));else if(B.scheme===T.Schemas.file)se=B.fsPath,D.isWindows&&(se=(0,C.normalizeDriveLetter)(se),q&&(se=(0,d.toSlashes)(se)));else{if(!Z.isEqualAuthority(B.authority,G.authority))return{name:z,uri:B.toString(!0)};se=B.path}return{name:z,path:se}}e.getStoredWorkspaceFolder=m;function b(B,x,z){let G=[],q=new Set;const Z=z.dirname(x);for(let se of B){let ue;if(l(se))se.path&&(ue=z.resolvePath(Z,se.path));else if(f(se))try{ue=F.URI.parse(se.uri),ue.path[0]!=="/"&&(ue=ue.with({path:"/"+ue.path}))}catch(te){console.warn(te)}if(ue){let te=z.getComparisonKey(ue);if(!q.has(te)){q.add(te);const J=se.name||z.basenameOrAuthority(ue);G.push(new v.WorkspaceFolder({uri:ue,name:J,index:G.length},se))}}}return G}e.toWorkspaceFolders=b;function A(B,x,z,G,q){let Z=L(x,B);const se=q.dirname(x),ue=q.dirname(G),te=[],J=N(Z.folders);for(const Ie of Z.folders){const Ne=l(Ie)?q.resolvePath(se,Ie.path):F.URI.parse(Ie.uri);let Ee;z?Ee=!1:Ee=!l(Ie)||(0,k.isAbsolute)(Ie.path),te.push(m(Ne,Ee,Ie.name,ue,J,q))}const ae={insertSpaces:!1,tabSize:4,eol:D.isLinux||D.isMacintosh?`
`:`\r
`},he=I.setProperty(B,["folders"],te,ae);let we=I.applyEdits(B,he);return(0,P.isEqualAuthority)(Z.remoteAuthority,(0,E.getRemoteAuthority)(G))&&(we=I.applyEdits(we,I.removeProperty(we,["remoteAuthority"],ae))),we}e.rewriteWorkspaceFileForNewLocation=A;function L(B,x){let z=t.parse(x);if(z&&Array.isArray(z.folders))z.folders=z.folders.filter(G=>o(G));else throw new Error(`${B} looks like an invalid workspace file.`);return z}function N(B){return D.isWindows?B.some(x=>l(x)&&x.path.indexOf("/")>=0):!0}e.useSlashForPath=N;function g(B){return B.workspace&&typeof B.workspace=="object"&&typeof B.workspace.id=="string"&&typeof B.workspace.configPath=="string"}function M(B){return typeof B.folderUri=="string"}function U(B){return typeof B.fileUri=="string"}function j(B,x){const z={workspaces:[],files:[]};if(B){const G=function(Z,se){for(let ue=0;ue<Z.length;ue++)try{se(Z[ue],ue)}catch(te){x.warn(`Error restoring recent entry ${JSON.stringify(Z[ue])}: ${te.toString()}. Skip entry.`)}},q=B;if(Array.isArray(q.entries))G(q.entries,Z=>{const se=Z.label,ue=Z.remoteAuthority;g(Z)?z.workspaces.push({label:se,remoteAuthority:ue,workspace:{id:Z.workspace.id,configPath:F.URI.parse(Z.workspace.configPath)}}):M(Z)?z.workspaces.push({label:se,remoteAuthority:ue,folderUri:F.URI.parse(Z.folderUri)}):U(Z)&&z.files.push({label:se,remoteAuthority:ue,fileUri:F.URI.parse(Z.fileUri)})});else{const Z=B;Array.isArray(Z.workspaces3)&&G(Z.workspaces3,(se,ue)=>{const te=Array.isArray(Z.workspaceLabels)&&Z.workspaceLabels[ue]||void 0;typeof se=="object"&&typeof se.id=="string"&&typeof se.configURIPath=="string"?z.workspaces.push({label:te,workspace:{id:se.id,configPath:F.URI.parse(se.configURIPath)}}):typeof se=="string"&&z.workspaces.push({label:te,folderUri:F.URI.parse(se)})}),Array.isArray(Z.files2)&&G(Z.files2,(se,ue)=>{const te=Array.isArray(Z.fileLabels)&&Z.fileLabels[ue]||void 0;typeof se=="string"&&z.files.push({label:te,fileUri:F.URI.parse(se)})})}}return z}e.restoreRecentlyOpened=j;function K(B){const x={entries:[]};for(const z of B.workspaces)p(z)?x.entries.push({folderUri:z.folderUri.toString(),label:z.label,remoteAuthority:z.remoteAuthority}):x.entries.push({workspace:{id:z.workspace.id,configPath:z.workspace.configPath.toString()},label:z.label,remoteAuthority:z.remoteAuthority});for(const z of B.files)x.entries.push({fileUri:z.fileUri.toString(),label:z.label,remoteAuthority:z.remoteAuthority});return x}e.toStoreData=K}),define(pe[87],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class d{constructor(I){this.id=I,this._data=new Map,this._idPool=1}add(I){const C=this._idPool++;return this._data.set(C,I),this.logDebugInfo(),C}get(I,C){return this._data.has(I)?this._data.get(I)[C]:void 0}delete(I){this._data.delete(I),this.logDebugInfo()}logDebugInfo(){!d.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=d,d.enableDebugLogging=!1}),define(pe[44],ve([0,1,10,22,4]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class C{constructor(){this._systemSchemes=new Set(Object.keys(d.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(k=>{const D=this._providerInfo.get(k.scheme);return!(D===void 0||D&1024)})}$acceptProviderInfos(k,D){D===null?this._providerInfo.delete(k.scheme):this._providerInfo.set(k.scheme,D)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=C,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(pe[26],ve([0,1,4]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,d.createDecorator)("IExtHostInitDataService")}),define(pe[202],ve([0,1,13]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(T,k,D){this._deferredPromises=new Map,this._id=T,this._shared=k,this._storage=D,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new d.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const F of P.values())F.complete()}catch(F){for(const y of P.values())y.error(F)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this._init}get(T,k){let D=this._value[T];return typeof D=="undefined"&&(D=k),D}update(T,k){this._value[T]=k;let D=this._deferredPromises.get(T);if(D!==void 0)return D.p;const P=new d.DeferredPromise;return this._deferredPromises.set(T,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class I extends t{constructor(T,k){super(T.identifier.value,!0,k);this._extension=T}setKeysForSync(T){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},T)}}e.ExtensionGlobalMemento=I}),define(pe[203],ve([0,1,3,2,12]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let C=class{constructor(k,D){this._logService=k,this._notebooksAndEditors=D,this._onDidChangeNotebookDocumentMetadata=new d.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new d.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(k,D,P){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(k)).acceptModelChanged(D.value,P)}$acceptDirtyStateChanged(k,D){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(k)).acceptDirty(D)}$acceptModelSaved(k){const D=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(k));this._onDidSaveNotebookDocument.fire(D.apiNotebook)}$acceptDocumentPropertiesChanged(k,D){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",k.path,D);const P=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(k));P.acceptDocumentPropertiesChanged(D),D.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:P.apiNotebook})}};C=Be([Me(0,I.ILogService)],C),e.ExtHostNotebookDocuments=C}),define(pe[14],ve([0,1,4]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,d.createDecorator)("IExtHostRpcService");class t{constructor(C){this.getProxy=C.getProxy.bind(C),this.set=C.set.bind(C),this.assertRegistered=C.assertRegistered.bind(C),this.drain=C.drain.bind(C)}}e.ExtHostRpcService=t});var Qe=this&&this.__classPrivateFieldSet||function(ee,e,d,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,d):I?I.value=d:e.set(ee,d),d},Te=this&&this.__classPrivateFieldGet||function(ee,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(ee):t?t.value:e.get(ee)};define(pe[204],ve([0,1,27,3]),function(ee,e,d,t){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class C{constructor(k,D){I.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=d.ExtensionIdentifier.toKey(k.identifier),Qe(this,I,D,"f"),Te(this,I,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(k){return Te(this,I,"f").get(this._id,k)}store(k,D){return Te(this,I,"f").store(this._id,k,D)}delete(k){return Te(this,I,"f").delete(this._id,k)}}e.ExtensionSecrets=C,I=new WeakMap}),define(pe[123],ve([0,1,4,3]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class I{constructor(){this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new t.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._level>=2,isUsageEnabled:this._level>=3}}$initializeTelemetryLevel(T){this._level=T}$onDidChangeTelemetryLevel(T){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=T,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=I,e.IExtHostTelemetry=(0,d.createDecorator)("IExtHostTelemetry")}),define(pe[63],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var d;(function(p){p[p.Upsert=0]="Upsert",p[p.RemoveChild=1]="RemoveChild",p[p.Invalidated=2]="Invalidated",p[p.SetProp=3]="SetProp",p[p.Bulk=4]="Bulk"})(d=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const t=new WeakMap,I=(p,h)=>{const s={controllerId:h};return t.set(p,s),s};e.createPrivateApiFor=I;const C=p=>t.get(p);e.getPrivateApiFor=C;const T=(p,h,s,u)=>{let r=s;return{enumerable:!0,configurable:!1,get(){return r},set(S){if(!u(r,S)){const a=r;r=S,p.listener?.({op:3,key:h,value:S,previous:a})}}}},k=(p,h)=>p===h,D={range:(p,h)=>p===h?!0:!p||!h?!1:p.isEqual(h),label:k,description:k,sortText:k,busy:k,error:k,canResolveChildren:k,tags:(p,h)=>!(p.length!==h.length||p.some(s=>!h.find(u=>s.id===u.id)))},P=Object.keys(D),F=(p,h)=>({range:T(p,"range",void 0,D.range),label:T(p,"label",h,D.label),description:T(p,"description",void 0,D.description),sortText:T(p,"sortText",void 0,D.sortText),canResolveChildren:T(p,"canResolveChildren",!1,D.canResolveChildren),busy:T(p,"busy",!1,D.busy),error:T(p,"error",void 0,D.error),tags:T(p,"tags",[],D.tags)}),y=(p,h)=>{const s=new Map;for(const u of P)D[u](p[u],h[u])||s.set(u,h[u]);return s};e.diffTestItems=y;class c extends Error{constructor(h){super(`Attempted to insert a duplicate test item ID ${h}`)}}e.DuplicateTestItemError=c;class E extends Error{constructor(h){super(`TestItem with ID "${h}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=E;class v extends Error{constructor(h,s,u){super(`TestItem with ID "${h}" is from controller "${s}" and cannot be added as a child of an item from controller "${u}".`)}}e.MixedTestItemController=v;const w=p=>{const h=(0,e.getPrivateApiFor)(p);let s=new Map;return{get size(){return s.size},forEach(u,r){for(const S of s.values())u.call(r,S,this)},replace(u){const r=new Map,S=new Set(s.keys()),a={op:4,ops:[]};for(const i of u){if(!(i instanceof _))throw new E(i.id);const n=(0,e.getPrivateApiFor)(i).controllerId;if(n!==h.controllerId)throw new v(i.id,n,h.controllerId);if(r.has(i.id))throw new c(i.id);r.set(i.id,i),S.delete(i.id),a.ops.push({op:0,item:i})}for(const i of S.keys())a.ops.push({op:1,id:i});h.listener?.(a),s=r},add(u){if(!(u instanceof _))throw new E(u.id);s.set(u.id,u),h.listener?.({op:0,item:u})},delete(u){s.delete(u)&&h.listener?.({op:1,id:u})},get(u){return s.get(u)},toJSON(){return Array.from(s.values())},[Symbol.iterator](){return s.values()}}};class _{constructor(h,s,u,r){if(s.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(s)} symbol`);const S=(0,e.createPrivateApiFor)(this,h);Object.defineProperties(this,{id:{value:s,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return S.parent instanceof R?void 0:S.parent}},children:{value:w(this),enumerable:!0,writable:!1},...F(S,u)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=_;class R extends _{constructor(h,s){super(h,h,s,void 0)}}e.TestItemRootImpl=R}),define(pe[51],ve([0,1,4,122,3,14]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var T;(function(D){function P(y){return{remoteAddress:y.remoteAddress,localAddress:y.localAddress,public:!!y.public,privacy:y.privacy??(y.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:y.protocol}}D.fromApiTunnel=P;function F(y){return{remoteAddress:{host:y.tunnelRemoteHost,port:y.tunnelRemotePort},localAddress:y.localAddress,public:y.privacy!==t.TunnelPrivacyId.ConstantPrivate&&y.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:y.privacy,protocol:y.protocol}}D.fromServiceTunnel=F})(T=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,d.createDecorator)("IExtHostTunnelService");let k=class{constructor(P){this.onDidChangeTunnels=new I.Emitter().event}async $applyCandidateFilter(P){return P}async openTunnel(P,F){}async getTunnels(){return[]}async setTunnelFactory(P){return{dispose:()=>{}}}registerPortsAttributesProvider(P,F){return{dispose:()=>{}}}async $providePortAttributes(P,F,y,c,E){return[]}async $forwardPort(P,F){}async $closeTunnel(P){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=Be([Me(0,C.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var Qe=this&&this.__classPrivateFieldSet||function(ee,e,d,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,d):I?I.value=d:e.set(ee,d),d},Te=this&&this.__classPrivateFieldGet||function(ee,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(ee):t?t.value:e.get(ee)};define(pe[7],ve([0,1,17,16,100,24,96,8,18,2,33,42,120]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c){"use strict";var E,v,w,_,R,p,h,s,u,r,S,a,i,n,o,l,f,m,b,A;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function L(X){function V(){return Reflect.construct(X,arguments,this.constructor)}return Object.defineProperty(V,"name",Object.getOwnPropertyDescriptor(X,"name")),Object.setPrototypeOf(V,X),Object.setPrototypeOf(V.prototype,X.prototype),V}let N=R=class{constructor(V){E.set(this,void 0),Qe(this,E,V,"f")}static from(...V){let le=V;return new R(function(){if(le){for(const De of le)De&&typeof De.dispose=="function"&&De.dispose();le=void 0}})}dispose(){typeof Te(this,E,"f")=="function"&&(Te(this,E,"f").call(this),Qe(this,E,void 0,"f"))}};E=new WeakMap,N=R=Be([L],N),e.Disposable=N;let g=p=class{constructor(V,le){if(V<0)throw(0,t.illegalArgument)("line must be non-negative");if(le<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=V,this._character=le}static Min(...V){if(V.length===0)throw new TypeError;let le=V[0];for(let De=1;De<V.length;De++){const qe=V[De];qe.isBefore(le)&&(le=qe)}return le}static Max(...V){if(V.length===0)throw new TypeError;let le=V[0];for(let De=1;De<V.length;De++){const qe=V[De];qe.isAfter(le)&&(le=qe)}return le}static isPosition(V){if(!V)return!1;if(V instanceof p)return!0;let{line:le,character:De}=V;return typeof le=="number"&&typeof De=="number"}get line(){return this._line}get character(){return this._character}isBefore(V){return this._line<V._line?!0:V._line<this._line?!1:this._character<V._character}isBeforeOrEqual(V){return this._line<V._line?!0:V._line<this._line?!1:this._character<=V._character}isAfter(V){return!this.isBeforeOrEqual(V)}isAfterOrEqual(V){return!this.isBefore(V)}isEqual(V){return this._line===V._line&&this._character===V._character}compareTo(V){return this._line<V._line?-1:this._line>V.line?1:this._character<V._character?-1:this._character>V._character?1:0}translate(V,le=0){if(V===null||le===null)throw(0,t.illegalArgument)();let De;return typeof V=="undefined"?De=0:typeof V=="number"?De=V:(De=typeof V.lineDelta=="number"?V.lineDelta:0,le=typeof V.characterDelta=="number"?V.characterDelta:0),De===0&&le===0?this:new p(this.line+De,this.character+le)}with(V,le=this.character){if(V===null||le===null)throw(0,t.illegalArgument)();let De;return typeof V=="undefined"?De=this.line:typeof V=="number"?De=V:(De=typeof V.line=="number"?V.line:this.line,le=typeof V.character=="number"?V.character:this.character),De===this.line&&le===this.character?this:new p(De,le)}toJSON(){return{line:this.line,character:this.character}}};g=p=Be([L],g),e.Position=g;let M=h=class{constructor(V,le,De,qe){let Ye,et;if(typeof V=="number"&&typeof le=="number"&&typeof De=="number"&&typeof qe=="number"?(Ye=new g(V,le),et=new g(De,qe)):V instanceof g&&le instanceof g&&(Ye=V,et=le),!Ye||!et)throw new Error("Invalid arguments");Ye.isBefore(et)?(this._start=Ye,this._end=et):(this._start=et,this._end=Ye)}static isRange(V){return V instanceof h?!0:V?g.isPosition(V.start)&&g.isPosition(V.end):!1}get start(){return this._start}get end(){return this._end}contains(V){return V instanceof h?this.contains(V._start)&&this.contains(V._end):V instanceof g?!(V.isBefore(this._start)||this._end.isBefore(V)):!1}isEqual(V){return this._start.isEqual(V._start)&&this._end.isEqual(V._end)}intersection(V){const le=g.Max(V.start,this._start),De=g.Min(V.end,this._end);if(!le.isAfter(De))return new h(le,De)}union(V){if(this.contains(V))return this;if(V.contains(this))return V;const le=g.Min(V.start,this._start),De=g.Max(V.end,this.end);return new h(le,De)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(V,le=this.end){if(V===null||le===null)throw(0,t.illegalArgument)();let De;return V?g.isPosition(V)?De=V:(De=V.start||this.start,le=V.end||this.end):De=this.start,De.isEqual(this._start)&&le.isEqual(this.end)?this:new h(De,le)}toJSON(){return[this.start,this.end]}};M=h=Be([L],M),e.Range=M;let U=s=class extends M{constructor(V,le,De,qe){let Ye,et;if(typeof V=="number"&&typeof le=="number"&&typeof De=="number"&&typeof qe=="number"?(Ye=new g(V,le),et=new g(De,qe)):V instanceof g&&le instanceof g&&(Ye=V,et=le),!Ye||!et)throw new Error("Invalid arguments");super(Ye,et);this._anchor=Ye,this._active=et}static isSelection(V){return V instanceof s?!0:V?M.isRange(V)&&g.isPosition(V.anchor)&&g.isPosition(V.active)&&typeof V.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};U=s=Be([L],U),e.Selection=U;class j{constructor(V,le,De){if(typeof V!="string"||V.length===0)throw(0,t.illegalArgument)("host");if(typeof le!="number"||le===0||Math.round(le)!==le)throw(0,t.illegalArgument)("port");if(typeof De!="undefined"&&(typeof De!="string"||De.length===0||!/^[0-9A-Za-z\-]+$/.test(De)))throw(0,t.illegalArgument)("connectionToken");this.host=V,this.port=Math.round(le),this.connectionToken=De}}e.ResolvedAuthority=j;class K extends Error{constructor(V,le=c.RemoteAuthorityResolverErrorCode.Unknown,De){super(V);this._message=V,this._code=le,this._detail=De,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,K.prototype)}static NotAvailable(V,le){return new K(V,c.RemoteAuthorityResolverErrorCode.NotAvailable,le)}static TemporarilyNotAvailable(V){return new K(V,c.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=K;var B;(function(X){X[X.LF=1]="LF",X[X.CRLF=2]="CRLF"})(B=e.EndOfLine||(e.EndOfLine={}));var x;(function(X){X[X.Replace=1]="Replace",X[X.Append=2]="Append",X[X.Prepend=3]="Prepend"})(x=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let z=u=class{constructor(V,le){this._range=V,this._newText=le}static isTextEdit(V){return V instanceof u?!0:V?M.isRange(V)&&typeof V.newText=="string":!1}static replace(V,le){return new u(V,le)}static insert(V,le){return u.replace(new M(V,V),le)}static delete(V){return u.replace(V,"")}static setEndOfLine(V){const le=new u(new M(new g(0,0),new g(0,0)),"");return le.newEol=V,le}get range(){return this._range}set range(V){if(V&&!M.isRange(V))throw(0,t.illegalArgument)("range");this._range=V}get newText(){return this._newText||""}set newText(V){if(V&&typeof V!="string")throw(0,t.illegalArgument)("newText");this._newText=V}get newEol(){return this._newEol}set newEol(V){if(V&&typeof V!="number")throw(0,t.illegalArgument)("newEol");this._newEol=V}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};z=u=Be([L],z),e.TextEdit=z;var G;(function(X){X[X.File=1]="File",X[X.Text=2]="Text",X[X.Cell=3]="Cell",X[X.CellReplace=5]="CellReplace"})(G=e.FileEditType||(e.FileEditType={}));let q=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(V,le,De,qe){this._edits.push({_type:1,from:V,to:le,options:De,metadata:qe})}createFile(V,le,De){this._edits.push({_type:1,from:void 0,to:V,options:le,metadata:De})}deleteFile(V,le,De){this._edits.push({_type:1,from:V,to:void 0,options:le,metadata:De})}replaceNotebookMetadata(V,le,De){this._edits.push({_type:3,metadata:De,uri:V,edit:{editType:5,metadata:le},notebookMetadata:le})}replaceNotebookCells(V,le,De,qe,Ye){let et,nt,_t=[],At;if(xt.isNotebookRange(le)&&$t.isNotebookCellDataArray(De)&&!$t.isNotebookCellDataArray(qe)?(et=le.start,nt=le.end,_t=De,At=qe):typeof le=="number"&&typeof De=="number"&&$t.isNotebookCellDataArray(qe)&&(et=le,nt=De,_t=qe,At=Ye),et===void 0||nt===void 0)throw new Error("Invalid arguments");(et!==nt||_t.length>0)&&this._edits.push({_type:5,uri:V,index:et,count:nt-et,cells:_t,metadata:At})}replaceNotebookCellMetadata(V,le,De,qe){this._edits.push({_type:3,metadata:qe,uri:V,edit:{editType:8,index:le,metadata:De}})}replace(V,le,De,qe){this._edits.push({_type:2,uri:V,edit:new z(le,De),metadata:qe})}insert(V,le,De,qe){this.replace(V,new M(le,le),De,qe)}delete(V,le,De){this.replace(V,le,"",De)}has(V){return this._edits.some(le=>le._type===2&&le.uri.toString()===V.toString())}set(V,le){if(le)for(const De of le)De&&this._edits.push({_type:2,uri:V,edit:De});else{for(let De=0;De<this._edits.length;De++){const qe=this._edits[De];qe._type===2&&qe.uri.toString()===V.toString()&&(this._edits[De]=void 0)}(0,d.coalesceInPlace)(this._edits)}}get(V){const le=[];for(let De of this._edits)De._type===2&&De.uri.toString()===V.toString()&&le.push(De.edit);return le}entries(){const V=new C.ResourceMap;for(let le of this._edits)if(le._type===2){let De=V.get(le.uri);De||(De=[le.uri,[]],V.set(le.uri,De)),De[1].push(le.edit)}return[...V.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};q=Be([L],q),e.WorkspaceEdit=q;let Z=r=class{constructor(V){this._tabstop=1,this.value=V||""}static isSnippetString(V){return V instanceof r?!0:V?typeof V.value=="string":!1}static _escape(V){return V.replace(/\$|}|\\/g,"\\$&")}appendText(V){return this.value+=r._escape(V),this}appendTabstop(V=this._tabstop++){return this.value+="$",this.value+=V,this}appendPlaceholder(V,le=this._tabstop++){if(typeof V=="function"){const De=new r;De._tabstop=this._tabstop,V(De),this._tabstop=De._tabstop,V=De.value}else V=r._escape(V);return this.value+="${",this.value+=le,this.value+=":",this.value+=V,this.value+="}",this}appendChoice(V,le=this._tabstop++){const De=V.map(qe=>qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=le,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(V,le){if(typeof le=="function"){const De=new r;De._tabstop=this._tabstop,le(De),this._tabstop=De._tabstop,le=De.value}else typeof le=="string"&&(le=le.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=V,le&&(this.value+=":",this.value+=le),this.value+="}",this}};Z=r=Be([L],Z),e.SnippetString=Z;var se;(function(X){X[X.Unnecessary=1]="Unnecessary",X[X.Deprecated=2]="Deprecated"})(se=e.DiagnosticTag||(e.DiagnosticTag={}));var ue;(function(X){X[X.Hint=3]="Hint",X[X.Information=2]="Information",X[X.Warning=1]="Warning",X[X.Error=0]="Error"})(ue=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let te=S=class{constructor(V,le){if(this.uri=V,le)if(le instanceof M)this.range=le;else if(le instanceof g)this.range=new M(le,le);else throw new Error("Illegal argument")}static isLocation(V){return V instanceof S?!0:V?M.isRange(V.range)&&P.URI.isUri(V.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};te=S=Be([L],te),e.Location=te;let J=class{constructor(V,le){this.location=V,this.message=le}static is(V){return V?typeof V.message=="string"&&V.location&&M.isRange(V.location.range)&&P.URI.isUri(V.location.uri):!1}static isEqual(V,le){return V===le?!0:!V||!le?!1:V.message===le.message&&V.location.range.isEqual(le.location.range)&&V.location.uri.toString()===le.location.uri.toString()}};J=Be([L],J),e.DiagnosticRelatedInformation=J;let ae=class{constructor(V,le,De=ue.Error){if(!M.isRange(V))throw new TypeError("range must be set");if(!le)throw new TypeError("message must be set");this.range=V,this.message=le,this.severity=De}toJSON(){return{severity:ue[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(V,le){return V===le?!0:!V||!le?!1:V.message===le.message&&V.severity===le.severity&&V.code===le.code&&V.severity===le.severity&&V.source===le.source&&V.range.isEqual(le.range)&&(0,d.equals)(V.tags,le.tags)&&(0,d.equals)(V.relatedInformation,le.relatedInformation,J.isEqual)}};ae=Be([L],ae),e.Diagnostic=ae;let he=class{constructor(V,le){if(!V)throw new Error("Illegal argument, contents must be defined");Array.isArray(V)?this.contents=V:this.contents=[V],this.range=le}};he=Be([L],he),e.Hover=he;var we;(function(X){X[X.Text=0]="Text",X[X.Read=1]="Read",X[X.Write=2]="Write"})(we=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ie=class{constructor(V,le=we.Text){this.range=V,this.kind=le}toJSON(){return{range:this.range,kind:we[this.kind]}}};Ie=Be([L],Ie),e.DocumentHighlight=Ie;var Ne;(function(X){X[X.File=0]="File",X[X.Module=1]="Module",X[X.Namespace=2]="Namespace",X[X.Package=3]="Package",X[X.Class=4]="Class",X[X.Method=5]="Method",X[X.Property=6]="Property",X[X.Field=7]="Field",X[X.Constructor=8]="Constructor",X[X.Enum=9]="Enum",X[X.Interface=10]="Interface",X[X.Function=11]="Function",X[X.Variable=12]="Variable",X[X.Constant=13]="Constant",X[X.String=14]="String",X[X.Number=15]="Number",X[X.Boolean=16]="Boolean",X[X.Array=17]="Array",X[X.Object=18]="Object",X[X.Key=19]="Key",X[X.Null=20]="Null",X[X.EnumMember=21]="EnumMember",X[X.Struct=22]="Struct",X[X.Event=23]="Event",X[X.Operator=24]="Operator",X[X.TypeParameter=25]="TypeParameter"})(Ne=e.SymbolKind||(e.SymbolKind={}));var Ee;(function(X){X[X.Deprecated=1]="Deprecated"})(Ee=e.SymbolTag||(e.SymbolTag={}));let be=a=class{constructor(V,le,De,qe,Ye){this.name=V,this.kind=le,this.containerName=Ye,typeof De=="string"&&(this.containerName=De),qe instanceof te?this.location=qe:De instanceof M&&(this.location=new te(qe,De)),a.validate(this)}static validate(V){if(!V.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ne[this.kind],location:this.location,containerName:this.containerName}}};be=a=Be([L],be),e.SymbolInformation=be;let H=i=class{constructor(V,le,De,qe,Ye){this.name=V,this.detail=le,this.kind=De,this.range=qe,this.selectionRange=Ye,this.children=[],i.validate(this)}static validate(V){if(!V.name)throw new Error("name must not be falsy");if(!V.range.contains(V.selectionRange))throw new Error("selectionRange must be contained in fullRange");V.children&&V.children.forEach(i.validate)}};H=i=Be([L],H),e.DocumentSymbol=H;var W;(function(X){X[X.Invoke=1]="Invoke",X[X.Automatic=2]="Automatic"})(W=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let O=class{constructor(V,le){this.title=V,this.kind=le}};O=Be([L],O),e.CodeAction=O;let $=n=class{constructor(V){this.value=V}append(V){return new n(this.value?this.value+n.sep+V:V)}intersects(V){return this.contains(V)||V.contains(this)}contains(V){return this.value===V.value||V.value.startsWith(this.value+n.sep)}};$.sep=".",$=n=Be([L],$),e.CodeActionKind=$,$.Empty=new $(""),$.QuickFix=$.Empty.append("quickfix"),$.Refactor=$.Empty.append("refactor"),$.RefactorExtract=$.Refactor.append("extract"),$.RefactorInline=$.Refactor.append("inline"),$.RefactorRewrite=$.Refactor.append("rewrite"),$.Source=$.Empty.append("source"),$.SourceOrganizeImports=$.Source.append("organizeImports"),$.SourceFixAll=$.Source.append("fixAll");let Q=class{constructor(V,le){if(this.range=V,this.parent=le,le&&!le.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Q=Be([L],Q),e.SelectionRange=Q;class re{constructor(V,le,De,qe,Ye,et){this.kind=V,this.name=le,this.detail=De,this.uri=qe,this.range=Ye,this.selectionRange=et}}e.CallHierarchyItem=re;class de{constructor(V,le){this.fromRanges=le,this.from=V}}e.CallHierarchyIncomingCall=de;class ye{constructor(V,le){this.fromRanges=le,this.to=V}}e.CallHierarchyOutgoingCall=ye;var Ae;(function(X){X[X.Information=0]="Information",X[X.Warning=1]="Warning",X[X.Error=2]="Error"})(Ae=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let We=class{constructor(V,le){this.range=V,this.command=le}get isResolved(){return!!this.command}};We=Be([L],We),e.CodeLens=We;let $e=o=class{constructor(V,le=!1){v.set(this,void 0),Qe(this,v,new I.MarkdownString(V,{supportThemeIcons:le}),"f")}static isMarkdownString(V){return V instanceof o?!0:V&&V.appendCodeblock&&V.appendMarkdown&&V.appendText&&V.value!==void 0}get value(){return Te(this,v,"f").value}set value(V){Te(this,v,"f").value=V}get isTrusted(){return Te(this,v,"f").isTrusted}set isTrusted(V){Te(this,v,"f").isTrusted=V}get supportThemeIcons(){return Te(this,v,"f").supportThemeIcons}set supportThemeIcons(V){Te(this,v,"f").supportThemeIcons=V}get supportHtml(){return Te(this,v,"f").supportHtml}set supportHtml(V){Te(this,v,"f").supportHtml=V}appendText(V){return Te(this,v,"f").appendText(V),this}appendMarkdown(V){return Te(this,v,"f").appendMarkdown(V),this}appendCodeblock(V,le){return Te(this,v,"f").appendCodeblock(le??"",V),this}};v=new WeakMap,$e=o=Be([L],$e),e.MarkdownString=$e;let je=class{constructor(V,le){this.label=V,this.documentation=le}};je=Be([L],je),e.ParameterInformation=je;let He=class{constructor(V,le){this.label=V,this.documentation=le,this.parameters=[]}};He=Be([L],He),e.SignatureInformation=He;let Ue=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ue=Be([L],Ue),e.SignatureHelp=Ue;var Je;(function(X){X[X.Invoke=1]="Invoke",X[X.TriggerCharacter=2]="TriggerCharacter",X[X.ContentChange=3]="ContentChange"})(Je=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var rt;(function(X){X[X.Other=0]="Other",X[X.Type=1]="Type",X[X.Parameter=2]="Parameter"})(rt=e.InlayHintKind||(e.InlayHintKind={}));let Re=class{constructor(V){this.label=V}};Re=Be([L],Re),e.InlayHintLabelPart=Re;let tt=class{constructor(V,le,De){this.label=V,this.position=le,this.kind=De}};tt=Be([L],tt),e.InlayHint=tt;var ne;(function(X){X[X.Invoke=0]="Invoke",X[X.TriggerCharacter=1]="TriggerCharacter",X[X.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ne=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var oe;(function(X){X[X.Text=0]="Text",X[X.Method=1]="Method",X[X.Function=2]="Function",X[X.Constructor=3]="Constructor",X[X.Field=4]="Field",X[X.Variable=5]="Variable",X[X.Class=6]="Class",X[X.Interface=7]="Interface",X[X.Module=8]="Module",X[X.Property=9]="Property",X[X.Unit=10]="Unit",X[X.Value=11]="Value",X[X.Enum=12]="Enum",X[X.Keyword=13]="Keyword",X[X.Snippet=14]="Snippet",X[X.Color=15]="Color",X[X.File=16]="File",X[X.Reference=17]="Reference",X[X.Folder=18]="Folder",X[X.EnumMember=19]="EnumMember",X[X.Constant=20]="Constant",X[X.Struct=21]="Struct",X[X.Event=22]="Event",X[X.Operator=23]="Operator",X[X.TypeParameter=24]="TypeParameter",X[X.User=25]="User",X[X.Issue=26]="Issue"})(oe=e.CompletionItemKind||(e.CompletionItemKind={}));var Y;(function(X){X[X.Deprecated=1]="Deprecated"})(Y=e.CompletionItemTag||(e.CompletionItemTag={}));let ge=class{constructor(V,le){this.label=V,this.kind=le}toJSON(){return{label:this.label,kind:this.kind&&oe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ge=Be([L],ge),e.CompletionItem=ge;let _e=class{constructor(V=[],le=!1){this.items=V,this.isIncomplete=le}};_e=Be([L],_e),e.CompletionList=_e;let Oe=class{constructor(V,le,De){this.text=V,this.range=le,this.command=De}};Oe=Be([L],Oe),e.InlineSuggestion=Oe;let ze=class{constructor(V){this.items=V}};ze=Be([L],ze),e.InlineSuggestions=ze;var Ze;(function(X){X[X.Active=-1]="Active",X[X.Beside=-2]="Beside",X[X.One=1]="One",X[X.Two=2]="Two",X[X.Three=3]="Three",X[X.Four=4]="Four",X[X.Five=5]="Five",X[X.Six=6]="Six",X[X.Seven=7]="Seven",X[X.Eight=8]="Eight",X[X.Nine=9]="Nine"})(Ze=e.ViewColumn||(e.ViewColumn={}));var lt;(function(X){X[X.Left=1]="Left",X[X.Right=2]="Right"})(lt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var vt;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative"})(vt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ge;(function(X){X[X.Manual=1]="Manual",X[X.AfterDelay=2]="AfterDelay",X[X.FocusOut=3]="FocusOut"})(Ge=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var at;(function(X){X[X.Default=0]="Default",X[X.InCenter=1]="InCenter",X[X.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",X[X.AtTop=3]="AtTop"})(at=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Xe;(function(X){X[X.Keyboard=1]="Keyboard",X[X.Mouse=2]="Mouse",X[X.Command=3]="Command"})(Xe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var st;(function(X){X[X.Undo=1]="Undo",X[X.Redo=2]="Redo"})(st=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var yt;(function(X){X[X.OpenOpen=0]="OpenOpen",X[X.ClosedClosed=1]="ClosedClosed",X[X.OpenClosed=2]="OpenClosed",X[X.ClosedOpen=3]="ClosedOpen"})(yt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(X){function V(le){switch(le){case"keyboard":return X.Keyboard;case"mouse":return X.Mouse;case"api":return X.Command}}X.fromValue=V}(Xe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Pt=class{constructor(V,le){if(le&&!P.URI.isUri(le))throw(0,t.illegalArgument)("target");if(!M.isRange(V)||V.isEmpty)throw(0,t.illegalArgument)("range");this.range=V,this.target=le}};Pt=Be([L],Pt),e.DocumentLink=Pt;let Ct=class{constructor(V,le,De,qe){this.red=V,this.green=le,this.blue=De,this.alpha=qe}};Ct=Be([L],Ct),e.Color=Ct;let ht=class{constructor(V,le){if(le&&!(le instanceof Ct))throw(0,t.illegalArgument)("color");if(!M.isRange(V)||V.isEmpty)throw(0,t.illegalArgument)("range");this.range=V,this.color=le}};ht=Be([L],ht),e.ColorInformation=ht;let kt=class{constructor(V){if(!V||typeof V!="string")throw(0,t.illegalArgument)("label");this.label=V}};kt=Be([L],kt),e.ColorPresentation=kt;var Ft;(function(X){X[X.RGB=0]="RGB",X[X.HEX=1]="HEX",X[X.HSL=2]="HSL"})(Ft=e.ColorFormat||(e.ColorFormat={}));var Mt;(function(X){X[X.Error=0]="Error",X[X.Warning=1]="Warning",X[X.Information=2]="Information"})(Mt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class xe{constructor(V,le,De){if(this.startIndex=V,this.length=le,this.tooltip=De,typeof V!="number"||V<0)throw(0,t.illegalArgument)("startIndex");if(typeof le!="number"||le<1)throw(0,t.illegalArgument)("length");if(De!==void 0&&typeof De!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=xe;var Se;(function(X){X[X.Panel=1]="Panel",X[X.Editor=2]="Editor"})(Se=e.TerminalLocation||(e.TerminalLocation={}));class Ce{constructor(V){this.options=V,typeof V!="object"&&(0,t.illegalArgument)("options")}}e.TerminalProfile=Ce;var me;(function(X){X[X.Always=1]="Always",X[X.Silent=2]="Silent",X[X.Never=3]="Never"})(me=e.TaskRevealKind||(e.TaskRevealKind={}));var ie;(function(X){X[X.Shared=1]="Shared",X[X.Dedicated=2]="Dedicated",X[X.New=3]="New"})(ie=e.TaskPanelKind||(e.TaskPanelKind={}));let ke=l=class{constructor(V,le){if(this.label=le,typeof V!="string"||typeof le!="string")throw(0,t.illegalArgument)("name");this._id=V}static from(V){switch(V){case"clean":return l.Clean;case"build":return l.Build;case"rebuild":return l.Rebuild;case"test":return l.Test;default:return}}get id(){return this._id}};ke.Clean=new l("clean","Clean"),ke.Build=new l("build","Build"),ke.Rebuild=new l("rebuild","Rebuild"),ke.Test=new l("test","Test"),ke=l=Be([L],ke),e.TaskGroup=ke;function Le(X){let V="";for(let le=0;le<X.length;le++)V+=X[le].replace(/,/g,",,")+",";return V}let Ke=class{constructor(V,le,De){if(typeof V!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=V,le!==void 0&&(Array.isArray(le)?(this._args=le,this._options=De):this._options=le)}get process(){return this._process}set process(V){if(typeof V!="string")throw(0,t.illegalArgument)("process");this._process=V}get args(){return this._args}set args(V){Array.isArray(V)||(V=[]),this._args=V}get options(){return this._options}set options(V){this._options=V}computeId(){const V=[];if(V.push("process"),this._process!==void 0&&V.push(this._process),this._args&&this._args.length>0)for(let le of this._args)V.push(le);return Le(V)}};Ke=Be([L],Ke),e.ProcessExecution=Ke;let Ve=class{constructor(V,le,De){if(this._args=[],Array.isArray(le)){if(!V)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof V!="string"&&typeof V.value!="string")throw(0,t.illegalArgument)("command");this._command=V,this._args=le,this._options=De}else{if(typeof V!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=V,this._options=le}}get commandLine(){return this._commandLine}set commandLine(V){if(typeof V!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=V}get command(){return this._command?this._command:""}set command(V){if(typeof V!="string"&&typeof V.value!="string")throw(0,t.illegalArgument)("command");this._command=V}get args(){return this._args}set args(V){this._args=V||[]}get options(){return this._options}set options(V){this._options=V}computeId(){const V=[];if(V.push("shell"),this._commandLine!==void 0&&V.push(this._commandLine),this._command!==void 0&&V.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let le of this._args)V.push(typeof le=="string"?le:le.value);return Le(V)}};Ve=Be([L],Ve),e.ShellExecution=Ve;var ct;(function(X){X[X.Escape=1]="Escape",X[X.Strong=2]="Strong",X[X.Weak=3]="Weak"})(ct=e.ShellQuoting||(e.ShellQuoting={}));var bt;(function(X){X[X.Global=1]="Global",X[X.Workspace=2]="Workspace"})(bt=e.TaskScope||(e.TaskScope={}));class Et{constructor(V){this._callback=V}computeId(){return"customExecution"+(0,F.generateUuid)()}set callback(V){this._callback=V}get callback(){return this._callback}}e.CustomExecution=Et;let ot=f=class{constructor(V,le,De,qe,Ye,et){this.__deprecated=!1,this._definition=this.definition=V;let nt;typeof le=="string"?(this._name=this.name=le,this._source=this.source=De,this.execution=qe,nt=Ye,this.__deprecated=!0):le===bt.Global||le===bt.Workspace?(this.target=le,this._name=this.name=De,this._source=this.source=qe,this.execution=Ye,nt=et):(this.target=le,this._name=this.name=De,this._source=this.source=qe,this.execution=Ye,nt=et),typeof nt=="string"?(this._problemMatchers=[nt],this._hasDefinedMatchers=!0):Array.isArray(nt)?(this._problemMatchers=nt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(V){this.__id=V}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ke?this._definition={type:f.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ve?this._definition={type:f.ShellType,id:this._execution.computeId()}:this._execution instanceof Et?this._definition={type:f.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:f.EmptyType,id:(0,F.generateUuid)()}}get definition(){return this._definition}set definition(V){if(V==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=V}get scope(){return this._scope}set target(V){this.clear(),this._scope=V}get name(){return this._name}set name(V){if(typeof V!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=V}get execution(){return this._execution}set execution(V){V===null&&(V=void 0),this.clear(),this._execution=V;const le=this._definition.type;(f.EmptyType===le||f.ProcessType===le||f.ShellType===le||f.ExtensionCallbackType===le)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(V){if(Array.isArray(V))this.clear(),this._problemMatchers=V,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(V){V!==!0&&V!==!1&&(V=!1),this.clear(),this._isBackground=V}get source(){return this._source}set source(V){if(typeof V!="string"||V.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=V}get group(){return this._group}set group(V){V===null&&(V=void 0),this.clear(),this._group=V}get detail(){return this._detail}set detail(V){V===null&&(V=void 0),this._detail=V}get presentationOptions(){return this._presentationOptions}set presentationOptions(V){V==null&&(V=Object.create(null)),this.clear(),this._presentationOptions=V}get runOptions(){return this._runOptions}set runOptions(V){V==null&&(V=Object.create(null)),this.clear(),this._runOptions=V}};ot.ExtensionCallbackType="customExecution",ot.ProcessType="process",ot.ShellType="shell",ot.EmptyType="$empty",ot=f=Be([L],ot),e.Task=ot;var ft;(function(X){X[X.SourceControl=1]="SourceControl",X[X.Window=10]="Window",X[X.Notification=15]="Notification"})(ft=e.ProgressLocation||(e.ProgressLocation={}));let dt=class{constructor(V,le=Bt.None){this.collapsibleState=le,P.URI.isUri(V)?this.resourceUri=V:this.label=V}};dt=Be([L],dt),e.TreeItem=dt;var Bt;(function(X){X[X.None=0]="None",X[X.Collapsed=1]="Collapsed",X[X.Expanded=2]="Expanded"})(Bt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let It=class{constructor(V){this._value=V}async asString(){return JSON.stringify(this._value)}};It=Be([L],It),e.TreeDataTransferItem=It;let Lt=class{constructor(){this._items=new Map}get(V){return this._items.get(V)}set(V,le){this._items.set(V,le)}forEach(V){this._items.forEach(V)}};Lt=Be([L],Lt),e.TreeDataTransfer=Lt;let St=class{constructor(V,le){this.id=V,this.color=le}};St=Be([L],St),e.ThemeIcon=St,St.File=new St("file"),St.Folder=new St("folder");let gt=class{constructor(V){this.id=V}};gt=Be([L],gt),e.ThemeColor=gt;var Ot;(function(X){X[X.Global=1]="Global",X[X.Workspace=2]="Workspace",X[X.WorkspaceFolder=3]="WorkspaceFolder"})(Ot=e.ConfigurationTarget||(e.ConfigurationTarget={}));let qt=class{constructor(V,le){if(typeof V!="string"&&(!V||!P.URI.isUri(V)&&!P.URI.isUri(V.uri)))throw(0,t.illegalArgument)("base");if(typeof le!="string")throw(0,t.illegalArgument)("pattern");typeof V=="string"?this.baseUri=P.URI.file(V):P.URI.isUri(V)?this.baseUri=V:this.baseUri=V.uri,this.pattern=le}get base(){return this._base}set base(V){this._base=V,this._baseUri=P.URI.file(V)}get baseUri(){return this._baseUri}set baseUri(V){this._baseUri=V,this._base=V.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};qt=Be([L],qt),e.RelativePattern=qt;let mt=class{constructor(V,le,De,qe){this.enabled=typeof V=="boolean"?V:!0,typeof le=="string"&&(this.condition=le),typeof De=="string"&&(this.hitCondition=De),typeof qe=="string"&&(this.logMessage=qe)}get id(){return this._id||(this._id=(0,F.generateUuid)()),this._id}};mt=Be([L],mt),e.Breakpoint=mt;let Wt=class extends mt{constructor(V,le,De,qe,Ye){super(le,De,qe,Ye);if(V===null)throw(0,t.illegalArgument)("location");this.location=V}};Wt=Be([L],Wt),e.SourceBreakpoint=Wt;let Kt=class extends mt{constructor(V,le,De,qe,Ye){super(le,De,qe,Ye);this.functionName=V}};Kt=Be([L],Kt),e.FunctionBreakpoint=Kt;let Yt=class extends mt{constructor(V,le,De,qe,Ye,et,nt){super(qe,Ye,et,nt);if(!le)throw(0,t.illegalArgument)("dataId");this.label=V,this.dataId=le,this.canPersist=De}};Yt=Be([L],Yt),e.DataBreakpoint=Yt;let ai=class{constructor(V,le,De){this.command=V,this.args=le||[],this.options=De}};ai=Be([L],ai),e.DebugAdapterExecutable=ai;let Tt=class{constructor(V,le){this.port=V,this.host=le}};Tt=Be([L],Tt),e.DebugAdapterServer=Tt;let Jt=class{constructor(V){this.path=V}};Jt=Be([L],Jt),e.DebugAdapterNamedPipeServer=Jt;let ci=class{constructor(V){this.implementation=V}};ci=Be([L],ci),e.DebugAdapterInlineImplementation=ci;let Gt=class{constructor(V,le){this.range=V,this.expression=le}};Gt=Be([L],Gt),e.EvaluatableExpression=Gt;var Zt;(function(X){X[X.Automatic=0]="Automatic",X[X.Explicit=1]="Explicit"})(Zt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let ut=class{constructor(V,le){this.range=V,this.text=le}};ut=Be([L],ut),e.InlineValueText=ut;let li=class{constructor(V,le,De=!0){this.range=V,this.variableName=le,this.caseSensitiveLookup=De}};li=Be([L],li),e.InlineValueVariableLookup=li;let Nt=class{constructor(V,le){this.range=V,this.expression=le}};Nt=Be([L],Nt),e.InlineValueEvaluatableExpression=Nt;let zt=class{constructor(V,le){this.frameId=V,this.stoppedLocation=le}};zt=Be([L],zt),e.InlineValueContext=zt;var vi;(function(X){X[X.Changed=1]="Changed",X[X.Created=2]="Created",X[X.Deleted=3]="Deleted"})(vi=e.FileChangeType||(e.FileChangeType={}));let ui=m=class extends Error{constructor(V,le=y.FileSystemProviderErrorCode.Unknown,De){super(P.URI.isUri(V)?V.toString(!0):V);this.code=De?.name??"Unknown",(0,y.markAsFileSystemProviderError)(this,le),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,m.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}static FileExists(V){return new m(V,y.FileSystemProviderErrorCode.FileExists,m.FileExists)}static FileNotFound(V){return new m(V,y.FileSystemProviderErrorCode.FileNotFound,m.FileNotFound)}static FileNotADirectory(V){return new m(V,y.FileSystemProviderErrorCode.FileNotADirectory,m.FileNotADirectory)}static FileIsADirectory(V){return new m(V,y.FileSystemProviderErrorCode.FileIsADirectory,m.FileIsADirectory)}static NoPermissions(V){return new m(V,y.FileSystemProviderErrorCode.NoPermissions,m.NoPermissions)}static Unavailable(V){return new m(V,y.FileSystemProviderErrorCode.Unavailable,m.Unavailable)}};ui=m=Be([L],ui),e.FileSystemError=ui;let ei=class{constructor(V,le,De){this.start=V,this.end=le,this.kind=De}};ei=Be([L],ei),e.FoldingRange=ei;var Ci;(function(X){X[X.Comment=1]="Comment",X[X.Imports=2]="Imports",X[X.Region=3]="Region"})(Ci=e.FoldingRangeKind||(e.FoldingRangeKind={}));var wi;(function(X){X[X.Collapsed=0]="Collapsed",X[X.Expanded=1]="Expanded"})(wi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var ti;(function(X){X[X.Editing=0]="Editing",X[X.Preview=1]="Preview"})(ti=e.CommentMode||(e.CommentMode={}));class Di{constructor(V,le=[]){this.tokenTypes=V,this.tokenModifiers=le}}e.SemanticTokensLegend=Di;function di(X){return typeof X=="undefined"||(0,D.isStringArray)(X)}class Qt{constructor(V){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,V){this._hasLegend=!0;for(let le=0,De=V.tokenTypes.length;le<De;le++)this._tokenTypeStrToInt.set(V.tokenTypes[le],le);for(let le=0,De=V.tokenModifiers.length;le<De;le++)this._tokenModifierStrToInt.set(V.tokenModifiers[le],le)}}push(V,le,De,qe,Ye){if(typeof V=="number"&&typeof le=="number"&&typeof De=="number"&&typeof qe=="number"&&(typeof Ye=="number"||typeof Ye=="undefined"))return typeof Ye=="undefined"&&(Ye=0),this._pushEncoded(V,le,De,qe,Ye);if(M.isRange(V)&&typeof le=="string"&&di(De))return this._push(V,le,De);throw(0,t.illegalArgument)()}_push(V,le,De){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(V.start.line!==V.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(le))throw new Error("`tokenType` is not in the provided legend");const qe=V.start.line,Ye=V.start.character,et=V.end.character-V.start.character,nt=this._tokenTypeStrToInt.get(le);let _t=0;if(De)for(const At of De){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Ut=this._tokenModifierStrToInt.get(At);_t|=1<<Ut>>>0}this._pushEncoded(qe,Ye,et,nt,_t)}_pushEncoded(V,le,De,qe,Ye){if(this._dataIsSortedAndDeltaEncoded&&(V<this._prevLine||V===this._prevLine&&le<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const _t=this._data.length/5|0;let At=0,Ut=0;for(let Ht=0;Ht<_t;Ht++){let Vt=this._data[5*Ht],gi=this._data[5*Ht+1];Vt===0?(Vt=At,gi+=Ut):Vt+=At,this._data[5*Ht]=Vt,this._data[5*Ht+1]=gi,At=Vt,Ut=gi}}let et=V,nt=le;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(et-=this._prevLine,et===0&&(nt-=this._prevChar)),this._data[this._dataLen++]=et,this._data[this._dataLen++]=nt,this._data[this._dataLen++]=De,this._data[this._dataLen++]=qe,this._data[this._dataLen++]=Ye,this._prevLine=V,this._prevChar=le}static _sortAndDeltaEncode(V){let le=[];const De=V.length/5|0;for(let nt=0;nt<De;nt++)le[nt]=nt;le.sort((nt,_t)=>{const At=V[5*nt],Ut=V[5*_t];if(At===Ut){const Ht=V[5*nt+1],Vt=V[5*_t+1];return Ht-Vt}return At-Ut});const qe=new Uint32Array(V.length);let Ye=0,et=0;for(let nt=0;nt<De;nt++){const _t=5*le[nt],At=V[_t+0],Ut=V[_t+1],Ht=V[_t+2],Vt=V[_t+3],gi=V[_t+4],xi=At-Ye,Ji=xi===0?Ut-et:Ut,pi=5*nt;qe[pi+0]=xi,qe[pi+1]=Ji,qe[pi+2]=Ht,qe[pi+3]=Vt,qe[pi+4]=gi,Ye=At,et=Ut}return qe}build(V){return this._dataIsSortedAndDeltaEncoded?new hi(new Uint32Array(this._data),V):new hi(Qt._sortAndDeltaEncode(this._data),V)}}e.SemanticTokensBuilder=Qt;class hi{constructor(V,le){this.resultId=le,this.data=V}}e.SemanticTokens=hi;class ki{constructor(V,le,De){this.start=V,this.deleteCount=le,this.data=De}}e.SemanticTokensEdit=ki;class Xt{constructor(V,le){this.resultId=le,this.edits=V}}e.SemanticTokensEdits=Xt;var Ii;(function(X){X[X.Separate=0]="Separate",X[X.MergeWithParent=1]="MergeWithParent"})(Ii=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Pi;(function(X){X[X.Initial=1]="Initial",X[X.Dynamic=2]="Dynamic"})(Pi=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ii=class{constructor(){}};ii.Back={iconPath:new St("arrow-left")},ii=Be([L],ii),e.QuickInputButtons=ii;var Ti;(function(X){X[X.Separator=-1]="Separator",X[X.Default=0]="Default"})(Ti=e.QuickPickItemKind||(e.QuickPickItemKind={}));var fi;(function(X){X[X.UI=1]="UI",X[X.Workspace=2]="Workspace"})(fi=e.ExtensionKind||(e.ExtensionKind={}));class bi{constructor(V,le,De){this.badge=V,this.tooltip=le,this.color=De}static validate(V){if(V.badge){let le=(0,k.nextCharLength)(V.badge,0);if(le<V.badge.length&&(le+=(0,k.nextCharLength)(V.badge,le)),V.badge.length>le)throw new Error("The 'badge'-property must be undefined or a short character")}if(!V.color&&!V.badge&&!V.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=bi;let ni=class{constructor(V){this.kind=V}};ni=Be([L],ni),e.ColorTheme=ni;var Fe;(function(X){X[X.Light=1]="Light",X[X.Dark=2]="Dark",X[X.HighContrast=3]="HighContrast"})(Fe=e.ColorThemeKind||(e.ColorThemeKind={}));class xt{constructor(V,le){if(V<0)throw(0,t.illegalArgument)("start must be positive");if(le<0)throw(0,t.illegalArgument)("end must be positive");V<=le?(this._start=V,this._end=le):(this._start=le,this._end=V)}static isNotebookRange(V){return V instanceof xt?!0:V?typeof V.start=="number"&&typeof V.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(V){let le=this._start,De=this._end;return V.start!==void 0&&(le=V.start),V.end!==void 0&&(De=V.end),le===this._start&&De===this._end?this:new xt(le,De)}}e.NotebookRange=xt;class $t{constructor(V,le,De,qe,Ye,et,nt){this.kind=V,this.value=le,this.languageId=De,this.mime=qe,this.outputs=Ye??[],this.metadata=et,this.executionSummary=nt,$t.validate(this)}static validate(V){if(typeof V.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof V.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof V.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(V){return Array.isArray(V)&&V.every(le=>$t.isNotebookCellData(le))}static isNotebookCellData(V){return!0}}e.NotebookCellData=$t;class pt{constructor(V){this.cells=V}}e.NotebookData=pt;class Rt{constructor(V,le){this.data=V,this.mime=le;const De=(0,T.normalizeMimeType)(le,!0);if(!De)throw new Error(`INVALID mime type: ${le}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}static isNotebookCellOutputItem(V){return V instanceof Rt?!0:V?typeof V.mime=="string"&&V.data instanceof Uint8Array:!1}static error(V){const le={name:V.name,message:V.message,stack:V.stack};return Rt.json(le,"application/vnd.code.notebook.error")}static stdout(V){return Rt.text(V,"application/vnd.code.notebook.stdout")}static stderr(V){return Rt.text(V,"application/vnd.code.notebook.stderr")}static bytes(V,le="application/octet-stream"){return new Rt(V,le)}static text(V,le=T.Mimes.text){const De=Te(Rt,w,"f",_).encode(String(V));return new Rt(De,le)}static json(V,le="application/json"){const De=JSON.stringify(V,void 0,"	");return Rt.text(De,le)}}e.NotebookCellOutputItem=Rt,w=Rt,_={value:new TextEncoder};class ri{constructor(V,le,De){this.items=ri.ensureUniqueMimeTypes(V,!0),typeof le=="string"?(this.id=le,this.metadata=De):(this.id=(0,F.generateUuid)(),this.metadata=le??De)}static isNotebookCellOutput(V){return V instanceof ri?!0:!V||typeof V!="object"?!1:typeof V.id=="string"&&(0,D.isArray)(V.items)}static ensureUniqueMimeTypes(V,le=!1){const De=new Set,qe=new Set;for(let Ye=0;Ye<V.length;Ye++){const et=V[Ye],nt=(0,T.normalizeMimeType)(et.mime);if(!De.has(nt)){De.add(nt);continue}qe.add(Ye),le&&console.warn(`DUPLICATED mime type '${et.mime}' will be dropped`)}return qe.size===0?V:V.filter((Ye,et)=>!qe.has(et))}}e.NotebookCellOutput=ri;var Ei;(function(X){X[X.Markup=1]="Markup",X[X.Code=2]="Code"})(Ei=e.NotebookCellKind||(e.NotebookCellKind={}));var Si;(function(X){X[X.Idle=1]="Idle",X[X.Pending=2]="Pending",X[X.Executing=3]="Executing"})(Si=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ai;(function(X){X[X.Left=1]="Left",X[X.Right=2]="Right"})(Ai=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Ri;(function(X){X[X.Default=0]="Default",X[X.InCenter=1]="InCenter",X[X.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",X[X.AtTop=3]="AtTop"})(Ri=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Li{constructor(V,le){this.text=V,this.alignment=le}}e.NotebookCellStatusBarItem=Li;var Fi;(function(X){X[X.Default=1]="Default",X[X.Preferred=2]="Preferred"})(Fi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class _i{constructor(V,le=[]){this.uri=V,this.provides=(0,d.asArray)(le)}}e.NotebookRendererScript=_i;let mi=class{constructor(V,le){this.label=V,this.timestamp=le}};mi=Be([L],mi),e.TimelineItem=mi;var Mi;(function(X){X[X.Production=1]="Production",X[X.Development=2]="Development",X[X.Test=3]="Test"})(Mi=e.ExtensionMode||(e.ExtensionMode={}));var Oi;(function(X){X[X.Node=1]="Node",X[X.Webworker=2]="Webworker"})(Oi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ni;(function(X){X[X.Other=0]="Other",X[X.Comment=1]="Comment",X[X.String=2]="String",X[X.RegEx=3]="RegEx"})(Ni=e.StandardTokenType||(e.StandardTokenType={}));class Ui{constructor(V,le){this.ranges=V,this.wordPattern=le}}e.LinkedEditingRanges=Ui;class ce{constructor(V,le){this._port=V,this._autoForwardAction=le}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=ce;var fe;(function(X){X[X.Queued=1]="Queued",X[X.Running=2]="Running",X[X.Passed=3]="Passed",X[X.Failed=4]="Failed",X[X.Skipped=5]="Skipped",X[X.Errored=6]="Errored"})(fe=e.TestResultState||(e.TestResultState={}));var Pe;(function(X){X[X.Run=1]="Run",X[X.Debug=2]="Debug",X[X.Coverage=3]="Coverage"})(Pe=e.TestRunProfileKind||(e.TestRunProfileKind={}));let it=class{constructor(V=void 0,le=void 0,De=void 0){this.include=V,this.exclude=le,this.profile=De}};it=Be([L],it),e.TestRunRequest=it;let wt=b=class{constructor(V){this.message=V}static diff(V,le,De){const qe=new b(V);return qe.expectedOutput=le,qe.actualOutput=De,qe}};wt=b=Be([L],wt),e.TestMessage=wt;let Dt=class{constructor(V){this.id=V}};Dt=Be([L],Dt),e.TestTag=Dt;let si=class{constructor(V,le){this.covered=V,this.total=le}};si=Be([L],si),e.CoveredCount=si;let Bi=A=class{constructor(V,le,De,qe){this.uri=V,this.statementCoverage=le,this.branchCoverage=De,this.functionCoverage=qe}static fromDetails(V,le){const De=new si(0,0),qe=new si(0,0),Ye=new si(0,0);for(const nt of le)if("branches"in nt){De.total+=1,De.covered+=nt.executionCount>0?1:0;for(const _t of nt.branches)qe.total+=1,qe.covered+=_t.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=nt.executionCount>0?1:0;const et=new A(V,De,qe.total>0?qe:void 0,Ye.total>0?Ye:void 0);return et.detailedCoverage=le,et}};Bi=A=Be([L],Bi),e.FileCoverage=Bi;let Wi=class{constructor(V,le,De=[]){this.executionCount=V,this.location=le,this.branches=De}};Wi=Be([L],Wi),e.StatementCoverage=Wi;let $i=class{constructor(V,le){this.executionCount=V,this.location=le}};$i=Be([L],$i),e.BranchCoverage=$i;let Hi=class{constructor(V,le){this.executionCount=V,this.location=le}};Hi=Be([L],Hi),e.FunctionCoverage=Hi;var Ki;(function(X){X[X.None=0]="None",X[X.Option=1]="Option",X[X.Default=2]="Default",X[X.Preferred=3]="Preferred"})(Ki=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Qi;(function(X){X[X.Untrusted=0]="Untrusted",X[X.Trusted=1]="Trusted",X[X.Unspecified=2]="Unspecified"})(Qi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Xi;(function(X){X[X.Notify=1]="Notify",X[X.OpenBrowser=2]="OpenBrowser",X[X.OpenPreview=3]="OpenPreview",X[X.Silent=4]="Silent",X[X.Ignore=5]="Ignore",X[X.OpenBrowserOnce=6]="OpenBrowserOnce"})(Xi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Yi{constructor(V,le,De,qe,Ye,et){this.kind=V,this.name=le,this.detail=De,this.uri=qe,this.range=Ye,this.selectionRange=et}}e.TypeHierarchyItem=Yi}),define(pe[124],ve([0,1,55,10,8,152,110,7,17]),function(ee,e,d,t,I,C,T,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function F(v,w){w?P.set(v,w):P.delete(v)}e.setWordDefinitionFor=F;function y(v){return P.get(v)}e.getWordDefinitionFor=y;class c extends C.MirrorTextModel{constructor(w,_,R,p,h,s,u,r){super(_,R,p,h);this._proxy=w,this._languageId=s,this._isDirty=u,this._notebook=r,this._isDisposed=!1}dispose(){(0,d.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(w){return(0,D.equals)(this._lines,w)}get document(){if(!this._document){const w=this;this._document={get uri(){return w._uri},get fileName(){return w._uri.fsPath},get isUntitled(){return w._uri.scheme===t.Schemas.untitled},get languageId(){return w._languageId},get version(){return w._versionId},get isClosed(){return w._isDisposed},get isDirty(){return w._isDirty},get notebook(){return w._notebook},save(){return w._save()},getText(_){return _?w._getTextInRange(_):w.getText()},get eol(){return w._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return w._lines.length},lineAt(_){return w._lineAt(_)},offsetAt(_){return w._offsetAt(_)},positionAt(_){return w._positionAt(_)},validateRange(_){return w._validateRange(_)},validatePosition(_){return w._validatePosition(_)},getWordRangeAtPosition(_,R){return w._getWordRangeAtPosition(_,R)}}}return Object.freeze(this._document)}_acceptLanguageId(w){(0,d.ok)(!this._isDisposed),this._languageId=w}_acceptIsDirty(w){(0,d.ok)(!this._isDisposed),this._isDirty=w}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(w){const _=this._validateRange(w);if(_.isEmpty)return"";if(_.isSingleLine)return this._lines[_.start.line].substring(_.start.character,_.end.character);const R=this._eol,p=_.start.line,h=_.end.line,s=[];s.push(this._lines[p].substring(_.start.character));for(let u=p+1;u<h;u++)s.push(this._lines[u]);return s.push(this._lines[h].substring(0,_.end.character)),s.join(R)}_lineAt(w){let _;if(w instanceof k.Position?_=w.line:typeof w=="number"&&(_=w),typeof _!="number"||_<0||_>=this._lines.length||Math.floor(_)!==_)throw new Error("Illegal value for `line`");return new E(_,this._lines[_],_===this._lines.length-1)}_offsetAt(w){return w=this._validatePosition(w),this._ensureLineStarts(),this._lineStarts.getPrefixSum(w.line-1)+w.character}_positionAt(w){w=Math.floor(w),w=Math.max(0,w),this._ensureLineStarts();const _=this._lineStarts.getIndexOf(w),R=this._lines[_.index].length;return new k.Position(_.index,Math.min(_.remainder,R))}_validateRange(w){if(!(w instanceof k.Range))throw new Error("Invalid argument");const _=this._validatePosition(w.start),R=this._validatePosition(w.end);return _===w.start&&R===w.end?w:new k.Range(_.line,_.character,R.line,R.character)}_validatePosition(w){if(!(w instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return w.with(0,0);let{line:_,character:R}=w,p=!1;if(_<0)_=0,R=0,p=!0;else if(_>=this._lines.length)_=this._lines.length-1,R=this._lines[_].length,p=!0;else{const h=this._lines[_].length;R<0?(R=0,p=!0):R>h&&(R=h,p=!0)}return p?new k.Position(_,R):w}_getWordRangeAtPosition(w,_){const R=this._validatePosition(w);if(!_)_=y(this._languageId);else if((0,I.regExpLeadsToEndlessLoop)(_))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${_.source}' because it matches the empty string.`);const p=(0,T.getWordAtText)(R.character+1,(0,T.ensureValidWordDefinition)(_),this._lines[R.line],0);if(p)return new k.Range(R.line,p.startColumn-1,R.line,p.endColumn-1)}}e.ExtHostDocumentData=c;class E{constructor(w,_,R){this._line=w,this._text=_,this._isLastLine=R}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=E}),define(pe[205],ve([0,1,7,3,111,6,80,24,2,33]),function(ee,e,d,t,I,C,T,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class F{constructor(c,E,v,w){this._notebook=v,this._selector=w,this._disposables=new C.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,P.generateUuid)()}),this._init(),this._disposables.add(E.onDidChangeDocument(R=>{const p=this._cellUris.get(R.document.uri);p!==void 0&&(this._cellLengths.setValue(p,this._cells[p].document.getText().length+1),this._cellLines.setValue(p,this._cells[p].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const _=R=>{R===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(c.onDidChangeNotebookCells(R=>_(R.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const c=[],E=[];for(const v of this._notebook.getCells())v.kind===d.NotebookCellKind.Code&&(!this._selector||(0,T.score)(this._selector,v.document.uri,v.document.languageId,!0))&&(this._cellUris.set(v.document.uri,this._cells.length),this._cells.push(v),c.push(v.document.getText().length+1),E.push(v.document.lineCount));this._cellLengths=new I.PrefixSumComputer(new Uint32Array(c)),this._cellLines=new I.PrefixSumComputer(new Uint32Array(E))}get version(){return this._versionId}getText(c){if(!c){let p="";for(const h of this._cells)p+=h.document.getText()+`
`;return p=p.slice(0,-1),p}if(c.isEmpty)return"";const E=this.locationAt(c.start),v=this.locationAt(c.end),w=this._cellUris.get(E.uri),_=this._cellUris.get(v.uri);if(w===void 0||_===void 0)return"";if(w===_)return this._cells[w].document.getText(new d.Range(E.range.start,v.range.end));const R=[this._cells[w].document.getText(new d.Range(E.range.start,new d.Position(this._cells[w].document.lineCount,0)))];for(let p=w+1;p<_;p++)R.push(this._cells[p].document.getText());return R.push(this._cells[_].document.getText(new d.Range(new d.Position(0,0),v.range.end))),R.join(`
`)}offsetAt(c){const E=this._cellLines.getIndexOf(c.line),v=this._cellLengths.getPrefixSum(E.index-1),w=this._cells[E.index].document.offsetAt(c.with(E.remainder));return v+w}positionAt(c){if(typeof c=="number"){const v=this._cellLengths.getIndexOf(c),w=this._cellLines.getPrefixSum(v.index-1);return this._cells[v.index].document.positionAt(v.remainder).translate(w)}const E=this._cellUris.get(c.uri);if(E!==void 0){const v=this._cellLines.getPrefixSum(E-1);return new d.Position(v+c.range.start.line,c.range.start.character)}return new d.Position(0,0)}locationAt(c){d.Range.isRange(c)||(c=new d.Range(c,c));const E=this._cellLines.getIndexOf(c.start.line);let v=E;c.isEmpty||(v=this._cellLines.getIndexOf(c.end.line));const w=new d.Position(E.remainder,c.start.character),_=new d.Position(v.remainder,c.end.character),R=new d.Range(w,_),p=this._cells[E.index];return new d.Location(p.document.uri,p.document.validateRange(R))}contains(c){return this._cellUris.has(c)}validateRange(c){const E=this.validatePosition(c.start),v=this.validatePosition(c.end);return c.with(E,v)}validatePosition(c){const E=this._cellLines.getIndexOf(c.line),v=new d.Position(E.remainder,c.character),w=this._cells[E.index].document.validatePosition(v),_=this._cellLines.getPrefixSum(E.index-1);return new d.Position(_+w.line,w.character)}}e.ExtHostNotebookConcatDocument=F}),define(pe[206],ve([0,1,7,14,3]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let C=class{constructor(k){this._actual=new d.ColorTheme(d.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new I.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let D=k==="light"?d.ColorThemeKind.Light:k==="dark"?d.ColorThemeKind.Dark:d.ColorThemeKind.HighContrast;this._actual=new d.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};C=Be([Me(0,t.IExtHostRpcService)],C),e.ExtHostTheming=C}),define(pe[64],ve([0,1,4]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,d.createDecorator)("IURITransformerService");class t{constructor(C){C?(this.transformIncoming=C.transformIncoming.bind(C),this.transformOutgoing=C.transformOutgoing.bind(C),this.transformOutgoingURI=C.transformOutgoingURI.bind(C),this.transformOutgoingScheme=C.transformOutgoingScheme.bind(C)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.URITransformerService=t}),define(pe[207],ve([0,1,23]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(D){let P=this.buffers.indexOf(D);return P<0&&(P=this.buffers.length,this.buffers.push(D)),P}}function I(k,D){if(D.serializeBuffersForPostMessage){const P=new t,F=(E,v)=>{if(v instanceof ArrayBuffer){const w=P.add(v);return{$$vscode_array_buffer_reference$$:!0,index:w}}else if(ArrayBuffer.isView(v)){const w=C(v);if(w){const _=P.add(v.buffer);return{$$vscode_array_buffer_reference$$:!0,index:_,view:{type:w,byteLength:v.byteLength,byteOffset:v.byteOffset}}}}return v},y=JSON.stringify(k,F),c=P.buffers.map(E=>{const v=new Uint8Array(E);return d.VSBuffer.wrap(v)});return{message:y,buffers:c}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=I;function C(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function T(k,D){const P=D.map(c=>{const E=new ArrayBuffer(c.byteLength);return new Uint8Array(E).set(c.buffer),E}),F=D.length?(c,E)=>{if(typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const v=E,{index:w}=v,_=P[w];if(v.view)switch(v.view.type){case 1:return new Int8Array(_,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(_,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(_,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(_,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(_,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(_,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(_,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(_,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(_,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(_,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(_,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return _}return E}:void 0;return{message:JSON.parse(k,F),arrayBuffers:P}}e.deserializeWebviewMessage=T}),define(pe[208],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var d;(function(t){function I(T){const k=new Map;return T.types.forEach((D,P)=>{k.set(D,{asString:async()=>T.items[P].asString})}),k}t.toITreeDataTransfer=I;async function C(T){const k={types:[],items:[]},D=Array.from(T.entries());for(const P of D)k.types.push(P[0]),k.items.push({asString:await P[1].asString()});return k}t.toTreeDataTransferDTO=C})(d=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(pe[88],ve([0,1,10,2]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function I(k,D){return k.scheme===d.Schemas.http||k.scheme===d.Schemas.https?k:(D&&D.authority&&D.isRemote&&k.scheme===d.Schemas.file&&(k=t.URI.from({scheme:d.Schemas.vscodeRemote,authority:D.authority,path:k.path})),t.URI.from({scheme:d.Schemas.https,authority:`${k.scheme}+${C(k.authority)}.${e.webviewRootResourceAuthority}`,path:k.path,fragment:k.fragment,query:k.query}))}e.asWebviewUri=I;function C(k){return k.replace(/./g,D=>{const P=D.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?D:"-"+P.toString(16).padStart(4,"0")})}function T(k){return k.replace(/-([0-9a-f]{4})/g,(D,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=T}),define(pe[209],ve([0,1,3,6,88]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class C{constructor(k,D,P){this._proxy=k,this._editors=D,this._initData=P,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(D.onDidChangeVisibleTextEditors(()=>{const F=D.getVisibleTextEditors();for(const y of this._insets.values())F.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this._insets.forEach(k=>k.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(k,D,P,F,y){let c;for(const h of this._editors.getVisibleTextEditors(!0))if(h.value===k){c=h;break}if(!c)throw new Error("not a visible editor");const E=this,v=this._handlePool++,w=new d.Emitter,_=new d.Emitter,R=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(h){return(0,I.asWebviewUri)(h,E._initData.remote)}get cspSource(){return I.webviewGenericCspSource}set options(h){this._options=h,E._proxy.$setOptions(v,h)}get options(){return this._options}set html(h){this._html=h,E._proxy.$setHtml(v,h)}get html(){return this._html}get onDidReceiveMessage(){return w.event}postMessage(h){return E._proxy.$postMessage(v,h)}},p=new class{constructor(){this.editor=k,this.line=D,this.height=P,this.webview=R,this.onDidDispose=_.event}dispose(){E._insets.has(v)&&(E._insets.delete(v),E._proxy.$disposeEditorInset(v),_.fire(),_.dispose(),w.dispose())}};return this._proxy.$createEditorInset(v,c.id,c.value.document.uri,D+1,P,F||{},y.identifier,y.extensionLocation),this._insets.set(v,{editor:k,inset:p,onDidReceiveMessage:w}),p}$onDidDispose(k){const D=this._insets.get(k);D&&D.inset.dispose()}$onDidReceiveMessage(k,D){const P=this._insets.get(k);P&&P.onDidReceiveMessage.fire(D)}}e.ExtHostEditorInsets=C}),define(pe[210],ve([0,1,176,18,2,6,4,50,42,17,10]),function(ee,e,d,t,I,C,T,k,D,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,d.localize)(0,null),providerDisplayName:(0,d.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function y(g,M,U){for(const j of U.visibleEditorPanes)if(j.group.id===M&&g.matches(j.input))return j.getViewState()}e.findViewStateForEditor=y;function c(g){if(s(g))return!1;const M=g;return I.URI.isUri(M?.resource)}e.isResourceEditorInput=c;function E(g){if(s(g))return!1;const M=g;return M?.original!==void 0&&M.modified!==void 0}e.isResourceDiffEditorInput=E;function v(g){if(s(g)||E(g))return!1;const M=g;return M?.primary!==void 0&&M.secondary!==void 0}e.isResourceSideBySideEditorInput=v;function w(g){if(s(g))return!1;const M=g;return M?M.resource===void 0||M.resource.scheme===F.Schemas.untitled||M.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=w;var _;(function(g){g[g.SHORT=0]="SHORT",g[g.MEDIUM=1]="MEDIUM",g[g.LONG=2]="LONG"})(_=e.Verbosity||(e.Verbosity={}));var R;(function(g){g[g.EXPLICIT=1]="EXPLICIT",g[g.AUTO=2]="AUTO",g[g.FOCUS_CHANGE=3]="FOCUS_CHANGE",g[g.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(R=e.SaveReason||(e.SaveReason={}));var p;(function(g){g[g.None=0]="None",g[g.Readonly=2]="Readonly",g[g.Untitled=4]="Untitled",g[g.Singleton=8]="Singleton",g[g.RequiresTrust=16]="RequiresTrust",g[g.CanSplitInGroup=32]="CanSplitInGroup",g[g.ForceDescription=64]="ForceDescription"})(p=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class h extends C.Disposable{}e.AbstractEditorInput=h;function s(g){return g instanceof h}e.isEditorInput=s;function u(g){const M=g;return I.URI.isUri(M?.preferredResource)}function r(g){const M=g;return s(M?.primary)&&s(M?.secondary)}e.isSideBySideEditorInput=r;function S(g){const M=g;return s(M?.modified)&&s(M?.original)}e.isDiffEditorInput=S;function a(g){return s(g?.editor)}e.isEditorInputWithOptions=a;function i(g){const M=g;return a(g)&&M?.group!==void 0}e.isEditorInputWithOptionsAndGroup=i;function n(g){const M=g;return typeof M?.groupId=="number"&&s(M.editor)}e.isEditorIdentifier=n;var o;(function(g){g[g.UNKNOWN=0]="UNKNOWN",g[g.REPLACE=1]="REPLACE",g[g.MOVE=2]="MOVE",g[g.UNPIN=3]="UNPIN"})(o=e.EditorCloseContext||(e.EditorCloseContext={}));var l;(function(g){g[g.GROUP_ACTIVE=0]="GROUP_ACTIVE",g[g.GROUP_INDEX=1]="GROUP_INDEX",g[g.GROUP_LOCKED=2]="GROUP_LOCKED",g[g.EDITOR_OPEN=3]="EDITOR_OPEN",g[g.EDITOR_CLOSE=4]="EDITOR_CLOSE",g[g.EDITOR_MOVE=5]="EDITOR_MOVE",g[g.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",g[g.EDITOR_LABEL=7]="EDITOR_LABEL",g[g.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",g[g.EDITOR_PIN=9]="EDITOR_PIN",g[g.EDITOR_STICKY=10]="EDITOR_STICKY",g[g.EDITOR_DIRTY=11]="EDITOR_DIRTY",g[g.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(l=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var f;(function(g){g[g.PRIMARY=1]="PRIMARY",g[g.SECONDARY=2]="SECONDARY",g[g.BOTH=3]="BOTH",g[g.ANY=4]="ANY"})(f=e.SideBySideEditor||(e.SideBySideEditor={}));class m{getOriginalUri(M,U){if(!M)return;if(U?.supportSideBySide){const{primary:K,secondary:B}=this.getSideEditors(M);if(K&&B){if(U?.supportSideBySide===f.BOTH)return{primary:this.getOriginalUri(K,{filterByScheme:U.filterByScheme}),secondary:this.getOriginalUri(B,{filterByScheme:U.filterByScheme})};if(U?.supportSideBySide===f.ANY)return this.getOriginalUri(K,{filterByScheme:U.filterByScheme})??this.getOriginalUri(B,{filterByScheme:U.filterByScheme});M=U.supportSideBySide===f.PRIMARY?K:B}}if(E(M)||v(M))return;const j=u(M)?M.preferredResource:M.resource;return!j||!U||!U.filterByScheme?j:this.filterUri(j,U.filterByScheme)}getSideEditors(M){return r(M)||v(M)?{primary:M.primary,secondary:M.secondary}:S(M)||E(M)?{primary:M.modified,secondary:M.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(M,U){if(!M)return;if(U?.supportSideBySide){const{primary:K,secondary:B}=this.getSideEditors(M);if(K&&B){if(U?.supportSideBySide===f.BOTH)return{primary:this.getCanonicalUri(K,{filterByScheme:U.filterByScheme}),secondary:this.getCanonicalUri(B,{filterByScheme:U.filterByScheme})};if(U?.supportSideBySide===f.ANY)return this.getCanonicalUri(K,{filterByScheme:U.filterByScheme})??this.getCanonicalUri(B,{filterByScheme:U.filterByScheme});M=U.supportSideBySide===f.PRIMARY?K:B}}if(E(M)||v(M))return;const j=M.resource;return!j||!U||!U.filterByScheme?j:this.filterUri(j,U.filterByScheme)}filterUri(M,U){if(Array.isArray(U)){if(U.some(j=>M.scheme===j))return M}else if(U===M.scheme)return M}}e.EditorResourceAccessor=new m;var b;(function(g){g[g.LEFT=0]="LEFT",g[g.RIGHT=1]="RIGHT"})(b=e.CloseDirection||(e.CloseDirection={}));class A{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(M){const U=this.instantiationService=M.get(T.IInstantiationService);for(const[j,K]of this.editorSerializerConstructors)this.createEditorSerializer(j,K,U);this.editorSerializerConstructors.clear()}createEditorSerializer(M,U,j){const K=j.createInstance(U);this.editorSerializerInstances.set(M,K)}registerFileEditorFactory(M){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=M}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(M,U){if(this.editorSerializerConstructors.has(M)||this.editorSerializerInstances.has(M))throw new Error(`A editor serializer with type ID '${M}' was already registered.`);return this.instantiationService?this.createEditorSerializer(M,U,this.instantiationService):this.editorSerializerConstructors.set(M,U),(0,C.toDisposable)(()=>{this.editorSerializerConstructors.delete(M),this.editorSerializerInstances.delete(M)})}getEditorSerializer(M){return this.editorSerializerInstances.get(typeof M=="string"?M:M.typeId)}}k.Registry.add(e.EditorExtensions.EditorFactory,new A);async function L(g,M){if(!g||!g.length)return[];const U=await Promise.all(g.map(async j=>{const K=I.URI.revive(j.fileUri);if(!K||!await M.canHandleResource(K))return;let x=j.exists,z=j.type;if(typeof x!="boolean"||typeof z!="number")try{z=(await M.resolve(K)).isDirectory?D.FileType.Directory:D.FileType.Unknown,x=!0}catch{x=!1}if(!x&&j.openOnlyIfExists||z===D.FileType.Directory)return;const G={selection:x?j.selection:void 0,pinned:!0,override:j.editorOverrideId};let q;return x?q={resource:K,options:G}:q={resource:K,options:G,forceUntitled:!0},q}));return(0,P.coalesce)(U)}e.pathsToEditors=L;var N;(function(g){g[g.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",g[g.SEQUENTIAL=1]="SEQUENTIAL"})(N=e.EditorsOrder||(e.EditorsOrder={}))}),define(pe[125],ve([0,1,3,13,177]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class C{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new d.Emitter,this._onExit=new d.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,D,P,F){const y={command:k};if(D&&Object.keys(D).length>0&&(y.arguments=D),this.internalSend("request",y),typeof F=="number"){const c=setTimeout(()=>{clearTimeout(c);const E=this.pendingRequests.get(y.seq);if(E){this.pendingRequests.delete(y.seq);const v={type:"response",seq:0,request_seq:y.seq,success:!1,command:k,message:(0,I.localize)(0,null,F,k)};E(v)}},F)}return P&&this.pendingRequests.set(y.seq,P),y.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,D){return k.type!=="event"||D.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,t.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":{const D=k,P=this.pendingRequests.get(D.request_seq);P&&(this.pendingRequests.delete(D.request_seq),P(D));break}}}}internalSend(k,D){D.type=k,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((D,P)=>k.set(P,D)),await(0,t.timeout)(500),k.forEach((D,P)=>{D({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=C}),define(pe[211],ve([0,1,8,2,9,25,10]),function(ee,e,d,t,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function D(a,i,n){return a.replace(k,function(o,l){return i&&l.length>0&&l[0]!=="_"?o:n&&n.hasOwnProperty(l)?n[l]:o})}e.formatPII=D;function P(a){const i={};for(const n of Object.keys(a))n.startsWith("!")||(i[n]=a[n]);return i}e.filterExceptionsFromTelemetry=P;function F(a){return a.configuration.request==="attach"&&!y(a)&&(!a.parentSession||F(a.parentSession))}e.isSessionAttach=F;function y(a){let i=a.configuration.type;if(!!i)return i==="vslsShare"&&(i=a.configuration.adapterProxy.configuration.type),(0,d.equalsIgnoreCase)(i,"extensionhost")||(0,d.equalsIgnoreCase)(i,"pwa-extensionhost")?a:a.parentSession?y(a.parentSession):void 0}e.getExtensionHostDebugSession=y;function c(a){return a.type&&(a.label||a.program||a.runtime)}e.isDebuggerMainContribution=c;function E(a,i,n){let o,l=0;const f=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let m=null;for(;m=f.exec(a);){const b=m.index+1,A=b+m[0].length;if(b<=i&&A>=n){o=m[0],l=b;break}}if(o){const b=/\w+/g;let A=null;for(;(A=b.exec(o))&&!(A.index+1+l+A[0].length>=n););A&&(o=o.substring(0,b.lastIndex))}return o?{start:l,end:l+o.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=E;const v=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function w(a){return!!(a&&a.match(v))}e.isUri=w;function _(a){if(typeof a.path=="string"&&!(typeof a.sourceReference=="number"&&a.sourceReference>0)){if(w(a.path))return t.URI.parse(a.path);if((0,I.isAbsolute)(a.path))return t.URI.file(a.path)}return a.path}function R(a){if(typeof a.path=="object"){const i=t.URI.revive(a.path);if(i)return i.scheme===T.Schemas.file?i.fsPath:i.toString()}return a.path}function p(a,i){const n=i?_:R,o=(0,C.deepClone)(a);return s(o,(l,f)=>{l&&f&&(f.path=n(f))}),o}e.convertToDAPaths=p;function h(a,i){const n=i?_:R,o=(0,C.deepClone)(a);return s(o,(l,f)=>{!l&&f&&(f.path=n(f))}),o}e.convertToVSCPaths=h;function s(a,i){switch(a.type){case"event":{const n=a;switch(n.event){case"output":i(!1,n.body.source);break;case"loadedSource":i(!1,n.body.source);break;case"breakpoint":i(!1,n.body.breakpoint.source);break;default:break}break}case"request":{const n=a;switch(n.command){case"setBreakpoints":i(!0,n.arguments.source);break;case"breakpointLocations":i(!0,n.arguments.source);break;case"source":i(!0,n.arguments.source);break;case"gotoTargets":i(!0,n.arguments.source);break;case"launchVSCode":n.arguments.args.forEach(o=>i(!1,o));break;default:break}break}case"response":{const n=a;if(n.success&&n.body)switch(n.command){case"stackTrace":n.body.stackFrames.forEach(o=>i(!1,o.source));break;case"loadedSources":n.body.sources.forEach(o=>i(!1,o));break;case"scopes":n.body.scopes.forEach(o=>i(!1,o.source));break;case"setFunctionBreakpoints":n.body.breakpoints.forEach(o=>i(!1,o.source));break;case"setBreakpoints":n.body.breakpoints.forEach(o=>i(!1,o.source));break;default:break}break}}}function u(a){return a.filter(i=>!i.presentation?.hidden).sort((i,n)=>i.presentation?n.presentation?i.presentation.group?n.presentation.group?i.presentation.group!==n.presentation.group?i.presentation.group.localeCompare(n.presentation.group):r(i.presentation.order,n.presentation.order):-1:n.presentation.group?1:r(i.presentation.order,n.presentation.order):-1:n.presentation?1:0)}e.getVisibleAndSorted=u;function r(a,i){return typeof a!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:a-i}async function S(a,i){const n=a.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorLanguageId});if(n!=="none"&&(await i.saveAll(),n==="allEditorsInActiveGroup")){const o=i.activeEditorPane;o&&o.input.resource?.scheme===T.Schemas.untitled&&await i.save({editor:o.input,groupId:o.group.id})}await a.reloadConfiguration()}e.saveAllBeforeDebugStart=S}),define(pe[212],ve([0,1,29,38,178,126,9,8,25,11,196,125]),function(ee,e,d,t,I,C,T,k,D,P,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class c extends y.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(p,h){this.outputStream=h,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,p.on("data",s=>this.handleData(s))}sendMessage(p){if(this.outputStream){const h=JSON.stringify(p);this.outputStream.write(`Content-Length: ${Buffer.byteLength(h,"utf8")}${c.TWO_CRLF}${h}`,"utf8")}}handleData(p){for(this.rawData=Buffer.concat([this.rawData,p]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const h=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,h.length>0)try{this.acceptMessage(JSON.parse(h))}catch(s){this._onError.fire(new Error((s.message||s)+`
`+h))}continue}}else{const h=this.rawData.indexOf(c.TWO_CRLF);if(h!==-1){const u=this.rawData.toString("utf8",0,h).split(c.HEADER_LINESEPARATOR);for(const r of u){const S=r.split(c.HEADER_FIELDSEPARATOR);S[0]==="Content-Length"&&(this.contentLength=Number(S[1]))}this.rawData=this.rawData.slice(h+c.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=c,c.TWO_CRLF=`\r
\r
`,c.HEADER_LINESEPARATOR=/\r?\n/,c.HEADER_FIELDSEPARATOR=/: */;class E extends c{startSession(){return new Promise((p,h)=>{let s=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),p(),s=!0}),this.socket.on("close",()=>{s?this._onError.fire(new Error("connection closed")):h(new Error("connection closed"))}),this.socket.on("error",u=>{s?this._onError.fire(u):h(u)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=E;class v extends E{constructor(p){super();this.adapterServer=p}createConnection(p){return C.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",p)}}e.SocketDebugAdapter=v;class w extends E{constructor(p){super();this.adapterServer=p}createConnection(p){return C.createConnection(this.adapterServer.path,p)}}e.NamedPipeDebugAdapter=w;class _ extends c{constructor(p,h,s){super();this.adapterExecutable=p,this.debugType=h,this.outputService=s}async startSession(){const p=this.adapterExecutable.command,h=this.adapterExecutable.args,s=this.adapterExecutable.options||{};try{if(p)if(T.isAbsolute(p)){if(!await d.Promises.exists(p))throw new Error(I.localize(0,null,p))}else p.indexOf("/")<0&&p.indexOf("\\")<0;else throw new Error(I.localize(1,null,this.debugType));let u=process.env;if(s.env&&Object.keys(s.env).length>0&&(u=D.mixin(D.deepClone(process.env),s.env)),p==="node")if(Array.isArray(h)&&h.length>0){const S=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,a={env:u,execArgv:S?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};s.cwd&&(a.cwd=s.cwd);const i=t.fork(h[0],h.slice(1),a);if(!i.pid)throw new Error(I.localize(2,null,h[0]));this.serverProcess=i}else throw new Error(I.localize(3,null));else{const S={env:u};s.cwd&&(S.cwd=s.cwd),this.serverProcess=t.spawn(p,h,S)}this.serverProcess.on("error",S=>{this._onError.fire(S)}),this.serverProcess.on("exit",(S,a)=>{this._onExit.fire(S)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",S=>{this._onError.fire(S)}),this.serverProcess.stdin.on("error",S=>{this._onError.fire(S)});const r=this.outputService;if(r){const S=a=>a.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",a=>{const i=r.getChannel(F.ExtensionsChannelId);i&&i.append(S(a))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(u){this._onError.fire(u)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),P.isWindows?new Promise((p,h)=>{const s=t.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(u,r,S){if(u)return h(u)});s.on("exit",p),s.on("error",h)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(p,h){if(!p)return;const s=Object.create(null);p.runtime&&(p.runtime.indexOf("./")===0?s.runtime=T.join(h,p.runtime):s.runtime=p.runtime),p.runtimeArgs&&(s.runtimeArgs=p.runtimeArgs),p.program&&(T.isAbsolute(p.program)?s.program=p.program:s.program=T.join(h,p.program)),p.args&&(s.args=p.args);const u=p;return u.win&&(s.win=_.extract(u.win,h)),u.winx86&&(s.winx86=_.extract(u.winx86,h)),u.windows&&(s.windows=_.extract(u.windows,h)),u.osx&&(s.osx=_.extract(u.osx,h)),u.linux&&(s.linux=_.extract(u.linux,h)),s}static platformAdapterExecutable(p,h){let s=Object.create(null);h=h.toLowerCase();for(const n of p)if(n.contributes){const o=n.contributes.debuggers;o&&o.length>0&&o.filter(l=>typeof l.type=="string"&&k.equalsIgnoreCase(l.type,h)).forEach(l=>{const f=_.extract(l,n.extensionLocation.fsPath);s=D.mixin(s,f,n.isBuiltin)})}let u;P.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?u=s.winx86||s.win||s.windows:P.isWindows?u=s.win||s.windows:P.isMacintosh?u=s.osx:P.isLinux&&(u=s.linux),u=u||s;const r=u.program||s.program,S=u.args||s.args,a=u.runtime||s.runtime,i=u.runtimeArgs||s.runtimeArgs;if(a)return{type:"executable",command:a,args:(i||[]).concat(typeof r=="string"?[r]:[]).concat(S||[])};if(r)return{type:"executable",command:r,args:S||[]}}}e.ExecutableDebugAdapter=_}),define(pe[213],ve([0,1,38,11,28,188]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function T(c,E){return new Promise((v,w)=>{let _="";const R=d.spawn(c,E);R.pid&&R.stdout.on("data",p=>{_+=p.toString()}),R.on("error",p=>{w(p)}),R.on("close",p=>{v(_)})})}let k;function D(c,E){if(!k)if(t.isWindows)k=new C.WindowsExternalTerminalService;else if(t.isMacintosh)k=new C.MacExternalTerminalService;else if(t.isLinux)k=new C.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const v=E.getConfiguration("terminal");return k.runInTerminal(c.title,c.cwd,c.args,c.env||{},v.external||{})}e.runInExternalTerminal=D;async function P(c){if(c)if(t.isWindows){const E=await new Promise((v,w)=>{ee(["windows-process-tree"],v,w)});return new Promise(v=>{E.getProcessTree(c,w=>{v(w.children.length>0)})})}else return T("/usr/bin/pgrep",["-lP",String(c)]).then(E=>{const v=E.trim();return!(v.length===0||v.indexOf(" tmux")>=0)},E=>!0);return Promise.resolve(!0)}e.hasChildProcesses=P;var F;(function(c){c[c.cmd=0]="cmd",c[c.powershell=1]="powershell",c[c.bash=2]="bash"})(F||(F={}));function y(c,E,v,w){c=c.trim().toLowerCase();let _;c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0?_=1:c.indexOf("cmd.exe")>=0?_=0:c.indexOf("bash")>=0?_=2:t.isWindows?_=0:_=2;let R,p=" ";switch(_){case 1:if(R=h=>(h=h.replace(/\'/g,"''"),h.length>0&&h.charAt(h.length-1)==="\\"?`'${h}\\'`:`'${h}'`),v){const h=(0,I.getDriveLetter)(v);h&&(p+=`${h}:; `),p+=`cd ${R(v)}; `}if(w)for(const h in w){const s=w[h];s===null?p+=`Remove-Item env:${h}; `:p+=`\${env:${h}}='${s}'; `}if(E.length>0){const h=R(E.shift());p+=h[0]==="'"?`& ${h} `:`${h} `;for(const s of E)p+=`${R(s)} `}break;case 0:if(R=h=>(h=h.replace(/\"/g,'""'),h.indexOf(" ")>=0||h.indexOf('"')>=0||h.length===0?`"${h}"`:h),v){const h=(0,I.getDriveLetter)(v);h&&(p+=`${h}: && `),p+=`cd ${R(v)} && `}if(w){p+='cmd /C "';for(const h in w){let s=w[h];s===null?p+=`set "${h}=" && `:(s=s.replace(/[\^\&\|\<\>]/g,u=>`^${u}`),p+=`set "${h}=${s}" && `)}}for(const h of E)p+=`${R(h)} `;w&&(p+='"');break;case 2:{R=s=>(s=s.replace(/(["'\\\$])/g,"\\$1"),s.indexOf(" ")>=0||s.indexOf(";")>=0||s.length===0?`"${s}"`:s);const h=s=>/[^\w@%\/+=,.:^-]/.test(s)?`'${s.replace(/'/g,"'\\''")}'`:s;if(v&&(p+=`cd ${R(v)} ; `),w){p+="/usr/bin/env";for(const s in w){const u=w[s];u===null?p+=` -u ${h(s)}`:p+=` ${h(`${s}=${u}`)}`}p+=" "}for(const s of E)p+=`${R(s)} `;break}}return p}e.prepareCommand=y}),define(pe[127],ve([0,1,32,77,96,10,9,11,83]),function(ee,e,d,t,I,C,T,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var P;(function(b){b[b.Markup=1]="Markup",b[b.Code=2]="Code"})(P=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",I.Mimes.latex,I.Mimes.markdown,"image/png","image/jpeg",I.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[I.Mimes.latex,I.Mimes.markdown,"application/json",I.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var F;(function(b){b[b.Running=1]="Running",b[b.Idle=2]="Idle"})(F=e.NotebookRunState||(e.NotebookRunState={}));var y;(function(b){b[b.Pending=2]="Pending",b[b.Executing=3]="Executing"})(y=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var c;(function(b){b[b.WithHardKernelDependency=0]="WithHardKernelDependency",b[b.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",b[b.Pure=2]="Pure",b[b.Never=3]="Never"})(c=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var E;(function(b){b.Always="always",b.Never="never",b.Optional="optional"})(E=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var v;(function(b){b[b.ModelChange=1]="ModelChange",b[b.Move=2]="Move",b[b.ChangeLanguage=5]="ChangeLanguage",b[b.Initialize=6]="Initialize",b[b.ChangeCellMetadata=7]="ChangeCellMetadata",b[b.Output=8]="Output",b[b.OutputItem=9]="OutputItem",b[b.ChangeCellContent=10]="ChangeCellContent",b[b.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",b[b.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",b[b.ChangeCellMime=13]="ChangeCellMime",b[b.Unknown=100]="Unknown"})(v=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var w;(function(b){b[b.Handle=0]="Handle",b[b.Index=1]="Index"})(w=e.SelectionStateType||(e.SelectionStateType={}));var _;(function(b){b[b.Replace=1]="Replace",b[b.Output=2]="Output",b[b.Metadata=3]="Metadata",b[b.CellLanguage=4]="CellLanguage",b[b.DocumentMetadata=5]="DocumentMetadata",b[b.Move=6]="Move",b[b.OutputItems=7]="OutputItems",b[b.PartialMetadata=8]="PartialMetadata",b[b.PartialInternalMetadata=9]="PartialInternalMetadata"})(_=e.CellEditType||(e.CellEditType={}));var R;(function(b){b.scheme=C.Schemas.vscodeNotebookCell;const A=/^ch(\d{7,})/;function L(K,B){return K.with({scheme:b.scheme,fragment:`ch${B.toString().padStart(7,"0")}${K.scheme!==C.Schemas.file?K.scheme:""}`})}b.generate=L;function N(K){if(K.scheme!==b.scheme)return;const B=A.exec(K.fragment);return B?{handle:Number(B[1]),notebook:K.with({scheme:K.fragment.substring(B[0].length)||C.Schemas.file,fragment:null})}:void 0}b.parse=N;function g(K,B,x){return K.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`ch${B.toString().padStart(7,"0")},${x??""},${K.scheme!==C.Schemas.file?K.scheme:""}`})}b.generateCellOutputUri=g;function M(K){if(K.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const B=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(K.fragment);if(!B)return;const x=Number(B[1]),z=B[2]&&B[2]!==""?B[2]:void 0,G=B[3];return{handle:x,outputId:z,notebook:K.with({scheme:G||C.Schemas.file,fragment:null})}}b.parseCellOutputUri=M;function U(K,B,x){return K.with({scheme:x,fragment:`ch${B.toString().padStart(7,"0")}${K.scheme!==C.Schemas.file?K.scheme:""}`})}b.generateCellUri=U;function j(K,B){if(K.scheme!==B)return;const x=A.exec(K.fragment);return x?{handle:Number(x[1]),notebook:K.with({scheme:K.fragment.substring(x[0].length)||C.Schemas.file,fragment:null})}:void 0}b.parseCellUri=j})(R=e.CellUri||(e.CellUri={}));const p=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[I.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function h(b){return p.get(b)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=h;function s(b){return p.get(b)?.supportedByCore??!1}e.mimeTypeSupportedByCore=s;function u(b){return p.get(b)?.mergeable??!1}e.mimeTypeIsMergeable=u;const r=b=>k.isWindows?b.replace(/\//g,"\\"):b;class S{constructor(A=[],L=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=L,this.order=[...new Set(A)].map(N=>({pattern:N,matches:d.parse(r(N))}))}sort(A){const L=new Map(t.Iterable.map(A,g=>[g,r(g)]));let N=[];for(const{matches:g}of this.order)for(const[M,U]of L)if(g(U)){N.push(M),L.delete(M);break}return L.size&&(N=N.concat([...L.keys()].sort((g,M)=>this.defaultOrder.indexOf(g)-this.defaultOrder.indexOf(M)))),N}prioritize(A,L){const N=this.findIndex(A);if(N===-1){this.order.unshift({pattern:A,matches:d.parse(r(A))});return}const g=new Set(L.map(U=>this.findIndex(U,N)));g.delete(-1);const M=Array.from(g).sort();this.order.splice(N+1,0,...M.map(U=>this.order[U]));for(let U=M.length-1;U>=0;U--)this.order.splice(M[U],1)}toArray(){return this.order.map(A=>A.pattern)}findIndex(A,L=this.order.length){const N=r(A);for(let g=0;g<L;g++)if(this.order[g].matches(N))return g;return-1}}e.MimeTypeDisplayOrder=S;function a(b,A,L,N=(g,M)=>g===M){const g=[];function M(K,B,x){if(B===0&&x.length===0)return;const z=g[g.length-1];z&&z.start+z.deleteCount===K?(z.deleteCount+=B,z.toInsert.push(...x)):g.push({start:K,deleteCount:B,toInsert:x})}let U=0,j=0;for(;;){if(U===b.length){M(U,0,A.slice(j));break}if(j===A.length){M(U,b.length-U,[]);break}const K=b[U],B=A[j];if(N(K,B)){U+=1,j+=1;continue}L(B)?(M(U,1,[]),U+=1):(M(U,0,[B]),j+=1)}return g}e.diff=a,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(b){b.default="default",b.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function n(b){const A=b;return!!((typeof A.include=="string"||d.isRelativePattern(A.include))&&(typeof A.exclude=="string"||d.isRelativePattern(A.exclude)))}e.isDocumentExcludePattern=n;function o(b,A,L){if(Array.isArray(b.viewType)&&b.viewType.indexOf(A)>=0||b.viewType===A)return!0;if(b.filenamePattern){const N=n(b.filenamePattern)?b.filenamePattern.include:b.filenamePattern,g=n(b.filenamePattern)?b.filenamePattern.exclude:void 0;if(d.match(N,(0,T.basename)(L.fsPath).toLowerCase()))return!(g&&d.match(g,(0,T.basename)(L.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o;class l{constructor(A){this.textModel=A}getElements(){const A=new Int32Array(this.textModel.cells.length);for(let L=0;L<this.textModel.cells.length;L++)A[L]=this.textModel.cells[L].getHashValue();return A}}e.CellSequence=l,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode"};var f;(function(b){b[b.Left=1]="Left",b[b.Right=2]="Right"})(f=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class m{static create(A){return`${m._prefix}${A}`}static parse(A){if(A.startsWith(m._prefix))return A.substring(m._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=m,m._prefix="notebook/"}),define(pe[214],ve([0,1,4]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,d.createDecorator)("INotebookExecutionService")}),define(pe[215],ve([0,1,4,83]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new t.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new t.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new t.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,d.createDecorator)(e.OUTPUT_SERVICE_ID);var I;(function(C){C[C.Append=1]="Append",C[C.Replace=2]="Replace",C[C.Clear=3]="Clear"})(I=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(pe[216],ve([0,1,180,4,83]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new I.RawContextKey("customExecutionSupported",!0,d.localize(0,null)),e.ShellExecutionSupportedContext=new I.RawContextKey("shellExecutionSupported",!1,d.localize(1,null)),e.ProcessExecutionSupportedContext=new I.RawContextKey("processExecutionSupported",!1,d.localize(2,null)),e.ITaskService=(0,t.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(pe[217],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function d(I){return[...I.entries()]}e.serializeEnvironmentVariableCollection=d;function t(I){return new Map(I)}e.deserializeEnvironmentVariableCollection=t}),define(pe[128],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var d;(function(y){y[y.Unset=0]="Unset",y[y.Queued=1]="Queued",y[y.Running=2]="Running",y[y.Passed=3]="Passed",y[y.Failed=4]="Failed",y[y.Skipped=5]="Skipped",y[y.Errored=6]="Errored"})(d=e.TestResultState||(e.TestResultState={}));var t;(function(y){y[y.Run=2]="Run",y[y.Debug=4]="Debug",y[y.Coverage=8]="Coverage",y[y.HasNonDefaultProfile=16]="HasNonDefaultProfile",y[y.HasConfigurable=32]="HasConfigurable"})(t=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var I;(function(y){y[y.Error=0]="Error",y[y.Info=1]="Info"})(I=e.TestMessageType||(e.TestMessageType={}));var C;(function(y){y[y.NotExpandable=0]="NotExpandable",y[y.Expandable=1]="Expandable",y[y.BusyExpanding=2]="BusyExpanding",y[y.Expanded=3]="Expanded"})(C=e.TestItemExpandState||(e.TestItemExpandState={}));const T=(y,c)=>{c.expand!==void 0&&(y.expand=c.expand),c.item!==void 0&&(y.item=y.item?Object.assign(y.item,c.item):c.item)};e.applyTestItemUpdate=T;var k;(function(y){y[y.Function=0]="Function",y[y.Statement=1]="Statement"})(k=e.DetailType||(e.DetailType={}));var D;(function(y){y[y.Add=0]="Add",y[y.Update=1]="Update",y[y.Remove=2]="Remove",y[y.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",y[y.Retire=4]="Retire",y[y.AddTag=5]="AddTag",y[y.RemoveTag=6]="RemoveTag"})(D=e.TestDiffOpType||(e.TestDiffOpType={}));class P{add(c){}update(c){}remove(c,E){}complete(){}}e.IncrementalChangeCollector=P;class F{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(c){const E=this.createChangeCollector();for(const v of c)switch(v[0]){case 0:{const w=v[1];if(w.parent){if(this.items.has(w.parent)){const _=this.items.get(w.parent);_.children.add(w.item.extId);const R=this.createItem(w,_);this.items.set(w.item.extId,R),E.add(R)}}else{const _=this.createItem(w);this.roots.add(_),this.items.set(w.item.extId,_),E.add(_)}w.expand===2&&this.busyControllerCount++;break}case 1:{const w=v[1],_=this.items.get(w.extId);if(!_)break;w.expand!==void 0&&(_.expand===2&&this.busyControllerCount--,w.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(_,w),E.update(_);break}case 2:{const w=this.items.get(v[1]);if(!w)break;w.parent?this.items.get(w.parent).children.delete(w.item.extId):this.roots.delete(w);const _=[[v[1]]];for(;_.length;)for(const R of _.pop()){const p=this.items.get(R);p&&(_.push(p.children),this.items.delete(R),E.remove(p,p!==w),p.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(v[1]);break;case 3:this.updatePendingRoots(v[1]);break;case 5:this._tags.set(v[1].id,v[1]);break;case 6:this._tags.delete(v[1]);break}E.complete()}retireTest(c){}updatePendingRoots(c){this.pendingRootCount+=c}createChangeCollector(){return new P}}e.AbstractIncrementalTestCollection=F}),define(pe[89],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var d;(function(C){C.Delimiter="\0"})(d=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(C){C[C.IsSame=0]="IsSame",C[C.Disconnected=1]="Disconnected",C[C.IsChild=2]="IsChild",C[C.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class I{constructor(T,k=T.length){if(this.path=T,this.viewEnd=k,T.length===0||k<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(T,k,D=T.parent){if(T.id===k)return new I([k]);let P=[T.id];for(let F=D;F&&F.id!==k;F=F.parent)P.push(F.id);return P.push(k),new I(P.reverse())}static isRoot(T){return!T.includes("\0")}static root(T){const k=T.indexOf("\0");return k===-1?T:T.slice(0,k)}static fromString(T){return new I(T.split("\0"))}static join(T,k){return new I([...T.path,k])}static joinToString(T,k){return T.toString()+"\0"+k}static compare(T,k){return T===k?0:k.startsWith(T+"\0")?2:T.startsWith(k+"\0")?3:1}get parentId(){return this.viewEnd>1?new I(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let T=1;T<=this.viewEnd;T++)yield new I(this.path,T)}compare(T){if(typeof T=="string")return I.compare(this.toString(),T);for(let k=0;k<T.viewEnd&&k<this.viewEnd;k++)if(T.path[k]!==this.path[k])return 1;return T.viewEnd>this.viewEnd?2:T.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let T=1;T<this.viewEnd;T++)this.stringifed+="\0",this.stringifed+=this.path[T]}return this.stringifed}}e.TestId=I}),define(pe[218],ve([0,1,9,37,18,25,11,79,181]),function(ee,e,d,t,I,C,T,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(y,c,E){this._contributedVariables=new Map,this._context=y,this._labelService=c,E&&(this._envVariablesPromise=E.then(v=>this.prepareEnv(v)))}prepareEnv(y){if(T.isWindows){const c=Object.create(null);return Object.keys(y).forEach(E=>{c[E.toLowerCase()]=y[E]}),c}return y}resolveWithEnvironment(y,c,E){return this.recursiveResolve(this.prepareEnv(y),c?c.uri:void 0,E)}async resolveAsync(y,c){return this.recursiveResolve(await this._envVariablesPromise,y?y.uri:void 0,c)}async resolveAnyBase(y,c,E,v){const w=C.deepClone(c);return T.isWindows&&w.windows?Object.keys(w.windows).forEach(_=>w[_]=w.windows[_]):T.isMacintosh&&w.osx?Object.keys(w.osx).forEach(_=>w[_]=w.osx[_]):T.isLinux&&w.linux&&Object.keys(w.linux).forEach(_=>w[_]=w.linux[_]),delete w.windows,delete w.osx,delete w.linux,this.recursiveResolve(await this._envVariablesPromise,y?y.uri:void 0,w,E,v)}async resolveAnyAsync(y,c,E){return this.resolveAnyBase(y,c,E)}async resolveAnyMap(y,c,E){const v=new Map;return{newConfig:await this.resolveAnyBase(y,c,E,v),resolvedVariables:v}}resolveWithInteractionReplace(y,c,E,v){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,c,E,v){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,c){if(this._contributedVariables.has(y))throw new Error("Variable "+y+" is contributed twice.");this._contributedVariables.set(y,c)}recursiveResolve(y,c,E,v,w){if(I.isString(E))return this.resolveString(y,c,E,v,w);if(I.isArray(E))return E.map(_=>this.recursiveResolve(y,c,_,v,w));if(I.isObject(E)){let _=Object.create(null);return Object.keys(E).forEach(R=>{const p=this.resolveString(y,c,R,v,w);_[p]=this.recursiveResolve(y,c,E[R],v,w)}),_}return E}resolveString(y,c,E,v,w){return E.replace(P.VARIABLE_REGEXP,(R,p)=>{if(p.includes(P.VARIABLE_LHS))return R;let h=this.evaluateSingleVariable(y,R,p,c,v);return w&&w.set(p,h),h!==R&&I.isString(h)&&h.match(P.VARIABLE_REGEXP)&&(h=this.resolveString(y,c,h,v,w)),h})}fsPath(y){return this._labelService?this._labelService.getUriLabel(y,{noPrefix:!0}):y.fsPath}evaluateSingleVariable(y,c,E,v,w){let _;const R=E.split(":");R.length>1&&(E=R[0],_=R[1]);const p=()=>{const u=this._context.getFilePath();if(u)return u;throw new Error((0,D.localize)(0,null,c))},h=()=>{const u=p();if(this._context.getWorkspaceFolderPathForFile){const r=this._context.getWorkspaceFolderPathForFile();if(r)return r}throw new Error((0,D.localize)(1,null,c,d.basename(u)))},s=()=>{if(_){const u=this._context.getFolderUri(_);if(u)return u;throw new Error((0,D.localize)(2,null,c,_))}if(v)return v;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,c)):new Error((0,D.localize)(4,null,c))};switch(E){case"env":if(_){if(y){const u=y[T.isWindows?_.toLowerCase():_];if(I.isString(u))return u}return""}throw new Error((0,D.localize)(5,null,c));case"config":if(_){const u=this._context.getConfigurationValue(v,_);if(I.isUndefinedOrNull(u))throw new Error((0,D.localize)(6,null,c,_));if(I.isObject(u))throw new Error((0,D.localize)(7,null,c,_));return u}throw new Error((0,D.localize)(8,null,c));case"command":return this.resolveFromMap(c,_,w,"command");case"input":return this.resolveFromMap(c,_,w,"input");default:switch(E){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(s()));case"cwd":return v||_?(0,k.normalizeDriveLetter)(this.fsPath(s())):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return d.basename(this.fsPath(s()));case"lineNumber":{const u=this._context.getLineNumber();if(u)return u;throw new Error((0,D.localize)(9,null,c))}case"selectedText":{const u=this._context.getSelectedText();if(u)return u;throw new Error((0,D.localize)(10,null,c))}case"file":return p();case"fileWorkspaceFolder":return h();case"relativeFile":return v||_?d.relative(this.fsPath(s()),p()):p();case"relativeFileDirname":{const u=d.dirname(p());if(v||_){const r=d.relative(this.fsPath(s()),u);return r.length===0?".":r}return u}case"fileDirname":return d.dirname(p());case"fileExtname":return d.extname(p());case"fileBasename":return d.basename(p());case"fileBasenameNoExtension":{const u=d.basename(p());return u.slice(0,u.length-d.extname(u).length)}case"fileDirnameBasename":return d.basename(d.dirname(p()));case"execPath":{const u=this._context.getExecPath();return u||c}case"execInstallFolder":{const u=this._context.getAppRoot();return u||c}case"pathSeparator":return d.sep;default:try{const u=_?`${E}:${_}`:E;return this.resolveFromMap(c,u,w,void 0)}catch{return c}}}}resolveFromMap(y,c,E,v){if(c&&E){const w=v===void 0?E[c]:E[v+":"+c];if(typeof w=="string")return w;throw new Error((0,D.localize)(11,null,y))}return y}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(pe[129],ve([0,1,4,210]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,d.createDecorator)("editorGroupsService");var I;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var C;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var k;(function(v){v[v.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",v[v.EVEN=1]="EVEN",v[v.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));function P(v){const w=v;return(0,t.isEditorInput)(w?.editor)&&(0,t.isEditorInput)(w?.replacement)}e.isEditorReplacement=P;var F;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(F=e.GroupsOrder||(e.GroupsOrder={}));var y;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(y=e.OpenEditorContext||(e.OpenEditorContext={}));function c(v){const w=v;return!!w&&typeof w.id=="number"&&Array.isArray(w.editors)}e.isEditorGroup=c;function E(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=E}),define(pe[219],ve([0,1,4,129]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,d.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function I(C){const T=C;return typeof C=="number"||(0,t.isEditorGroup)(T)}e.isPreferredGroup=I}),define(pe[15],ve([0,1,17,23,100,142,59,25,18,2,41,82,182,117,63,127,89,219,7]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c,E,v,w,_,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var h;(function(Se){function Ce(ie){const{selectionStartLineNumber:ke,selectionStartColumn:Le,positionLineNumber:Ke,positionColumn:Ve}=ie,ct=new p.Position(ke-1,Le-1),bt=new p.Position(Ke-1,Ve-1);return new p.Selection(ct,bt)}Se.to=Ce;function me(ie){const{anchor:ke,active:Le}=ie;return{selectionStartLineNumber:ke.line+1,selectionStartColumn:ke.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}Se.from=me})(h=e.Selection||(e.Selection={}));var s;(function(Se){function Ce(ie){if(!ie)return;const{start:ke,end:Le}=ie;return{startLineNumber:ke.line+1,startColumn:ke.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}Se.from=Ce;function me(ie){if(!ie)return;const{startLineNumber:ke,startColumn:Le,endLineNumber:Ke,endColumn:Ve}=ie;return new p.Range(ke-1,Le-1,Ke-1,Ve-1)}Se.to=me})(s=e.Range||(e.Range={}));var u;(function(Se){function Ce(me){switch(me){case 1:return p.StandardTokenType.Comment;case 0:return p.StandardTokenType.Other;case 3:return p.StandardTokenType.RegEx;case 2:return p.StandardTokenType.String}}Se.to=Ce})(u=e.TokenType||(e.TokenType={}));var r;(function(Se){function Ce(ie){return new p.Position(ie.lineNumber-1,ie.column-1)}Se.to=Ce;function me(ie){return{lineNumber:ie.line+1,column:ie.character+1}}Se.from=me})(r=e.Position||(e.Position={}));var S;(function(Se){function Ce(ke,Le){return(0,d.coalesce)((0,d.asArray)(ke).map(Ke=>me(Ke,Le)))}Se.from=Ce;function me(ke,Le){if(typeof ke=="string")return{$serialized:!0,language:ke};if(ke)return{$serialized:!0,language:ke.language,scheme:ie(ke.scheme,Le),pattern:oe.from(ke.pattern)??void 0,exclusive:ke.exclusive}}function ie(ke,Le){return Le&&typeof ke=="string"?Le.transformOutgoingScheme(ke):ke}})(S=e.DocumentSelector||(e.DocumentSelector={}));var a;(function(Se){function Ce(ie){switch(ie){case p.DiagnosticTag.Unnecessary:return 1;case p.DiagnosticTag.Deprecated:return 2}}Se.from=Ce;function me(ie){switch(ie){case 1:return p.DiagnosticTag.Unnecessary;case 2:return p.DiagnosticTag.Deprecated;default:return}}Se.to=me})(a=e.DiagnosticTag||(e.DiagnosticTag={}));var i;(function(Se){function Ce(ie){let ke;return ie.code&&((0,D.isString)(ie.code)||(0,D.isNumber)(ie.code)?ke=String(ie.code):ke={value:String(ie.code.value),target:ie.code.target}),{...s.from(ie.range),message:ie.message,source:ie.source,code:ke,severity:o.from(ie.severity),relatedInformation:ie.relatedInformation&&ie.relatedInformation.map(n.from),tags:Array.isArray(ie.tags)?(0,d.coalesce)(ie.tags.map(a.from)):void 0}}Se.from=Ce;function me(ie){const ke=new p.Diagnostic(s.to(ie),ie.message,o.to(ie.severity));return ke.source=ie.source,ke.code=(0,D.isString)(ie.code)?ie.code:ie.code?.value,ke.relatedInformation=ie.relatedInformation&&ie.relatedInformation.map(n.to),ke.tags=ie.tags&&(0,d.coalesce)(ie.tags.map(a.to)),ke}Se.to=me})(i=e.Diagnostic||(e.Diagnostic={}));var n;(function(Se){function Ce(ie){return{...s.from(ie.location.range),message:ie.message,resource:ie.location.uri}}Se.from=Ce;function me(ie){return new p.DiagnosticRelatedInformation(new p.Location(ie.resource,s.to(ie)),ie.message)}Se.to=me})(n=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var o;(function(Se){function Ce(ie){switch(ie){case p.DiagnosticSeverity.Error:return E.MarkerSeverity.Error;case p.DiagnosticSeverity.Warning:return E.MarkerSeverity.Warning;case p.DiagnosticSeverity.Information:return E.MarkerSeverity.Info;case p.DiagnosticSeverity.Hint:return E.MarkerSeverity.Hint}return E.MarkerSeverity.Error}Se.from=Ce;function me(ie){switch(ie){case E.MarkerSeverity.Info:return p.DiagnosticSeverity.Information;case E.MarkerSeverity.Warning:return p.DiagnosticSeverity.Warning;case E.MarkerSeverity.Error:return p.DiagnosticSeverity.Error;case E.MarkerSeverity.Hint:return p.DiagnosticSeverity.Hint;default:return p.DiagnosticSeverity.Error}}Se.to=me})(o=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var l;(function(Se){function Ce(ie){return typeof ie=="number"&&ie>=p.ViewColumn.One?ie-1:ie===p.ViewColumn.Beside?R.SIDE_GROUP:R.ACTIVE_GROUP}Se.from=Ce;function me(ie){if(typeof ie=="number"&&ie>=0)return ie+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=me})(l=e.ViewColumn||(e.ViewColumn={}));function f(Se){return typeof Se.range!="undefined"}function m(Se){return Se.length===0?!0:!!f(Se[0])}e.isDecorationOptionsArr=m;var b;(function(Se){function Ce(Ve){return Ve.map(Se.from)}Se.fromMany=Ce;function me(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function ie(Ve){let ct;if(me(Ve)){const{language:ft,value:dt}=Ve;ct={value:"```"+ft+`
`+dt+"\n```\n"}}else p.MarkdownString.isMarkdownString(Ve)?ct={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml}:typeof Ve=="string"?ct={value:Ve}:ct={value:""};const bt=Object.create(null);ct.uris=bt;const Et=ft=>{try{let dt=P.URI.parse(ft,!0);dt=dt.with({query:ke(dt.query,bt)}),bt[ft]=dt}catch{}return""},ot=new C.marked.Renderer;return ot.link=Et,ot.image=ft=>typeof ft=="string"?Et(I.parseHrefAndDimensions(ft).href):"",(0,C.marked)(ct.value,{renderer:ot}),ct}Se.from=ie;function ke(Ve,ct){if(!Ve)return Ve;let bt;try{bt=(0,T.parse)(Ve)}catch{}if(!bt)return Ve;let Et=!1;return bt=(0,k.cloneAndChange)(bt,ot=>{if(P.URI.isUri(ot)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[ft]=ot,Et=!0,ft}else return}),Et?JSON.stringify(bt):Ve}function Le(Ve){const ct=new p.MarkdownString(Ve.value,Ve.supportThemeIcons);return ct.isTrusted=Ve.isTrusted,ct.supportHtml=Ve.supportHtml,ct}Se.to=Le;function Ke(Ve){if(!!Ve)return typeof Ve=="string"?Ve:Se.from(Ve)}Se.fromStrict=Ke})(b=e.MarkdownString||(e.MarkdownString={}));function A(Se){return m(Se)?Se.map(Ce=>({range:s.from(Ce.range),hoverMessage:Array.isArray(Ce.hoverMessage)?b.fromMany(Ce.hoverMessage):Ce.hoverMessage?b.from(Ce.hoverMessage):void 0,renderOptions:Ce.renderOptions})):Se.map(Ce=>({range:s.from(Ce)}))}e.fromRangeOrRangeWithMessage=A;function L(Se){return typeof Se=="undefined"?Se:typeof Se=="string"?P.URI.file(Se):Se}e.pathOrURIToURI=L;var N;(function(Se){function Ce(me){return typeof me=="undefined"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?L(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}Se.from=Ce})(N=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var g;(function(Se){function Ce(me){return typeof me=="undefined"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?L(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?N.from(me.before):void 0,after:me.after?N.from(me.after):void 0}}Se.from=Ce})(g=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var M;(function(Se){function Ce(me){if(typeof me=="undefined")return me;switch(me){case p.DecorationRangeBehavior.OpenOpen:return 0;case p.DecorationRangeBehavior.ClosedClosed:return 1;case p.DecorationRangeBehavior.OpenClosed:return 2;case p.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=Ce})(M=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var U;(function(Se){function Ce(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?M.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?g.from(me.light):void 0,dark:me.dark?g.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?L(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?N.from(me.before):void 0,after:me.after?N.from(me.after):void 0}}Se.from=Ce})(U=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var j;(function(Se){function Ce(ie){return{text:ie.newText,eol:ie.newEol&&Je.from(ie.newEol),range:s.from(ie.range)}}Se.from=Ce;function me(ie){const ke=new p.TextEdit(s.to(ie.range),ie.text);return ke.newEol=typeof ie.eol=="undefined"?void 0:Je.to(ie.eol),ke}Se.to=me})(j=e.TextEdit||(e.TextEdit={}));var K;(function(Se){function Ce(ie,ke,Le){const Ke={edits:[]};if(ie instanceof p.WorkspaceEdit)for(let Ve of ie._allEntries())if(Ve._type===1)Ke.edits.push({_type:1,oldUri:Ve.from,newUri:Ve.to,options:Ve.options,metadata:Ve.metadata});else if(Ve._type===2){const ct=ke?.getDocument(Ve.uri);Ke.edits.push({_type:2,resource:Ve.uri,edit:j.from(Ve.edit),modelVersionId:ct?.version,metadata:Ve.metadata})}else Ve._type===3?Ke.edits.push({_type:3,metadata:Ve.metadata,resource:Ve.uri,edit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Le?.getNotebookDocument(Ve.uri,!0)?.apiNotebook.version}):Ve._type===5&&Ke.edits.push({_type:3,metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Le?.getNotebookDocument(Ve.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(Ze.from)}});return Ke}Se.from=Ce;function me(ie){const ke=new p.WorkspaceEdit;for(const Le of ie.edits)Le.edit?ke.replace(P.URI.revive(Le.resource),s.to(Le.edit.range),Le.edit.text):ke.renameFile(P.URI.revive(Le.oldUri),P.URI.revive(Le.newUri),Le.options);return ke}Se.to=me})(K=e.WorkspaceEdit||(e.WorkspaceEdit={}));var B;(function(Se){const Ce=Object.create(null);Ce[p.SymbolKind.File]=0,Ce[p.SymbolKind.Module]=1,Ce[p.SymbolKind.Namespace]=2,Ce[p.SymbolKind.Package]=3,Ce[p.SymbolKind.Class]=4,Ce[p.SymbolKind.Method]=5,Ce[p.SymbolKind.Property]=6,Ce[p.SymbolKind.Field]=7,Ce[p.SymbolKind.Constructor]=8,Ce[p.SymbolKind.Enum]=9,Ce[p.SymbolKind.Interface]=10,Ce[p.SymbolKind.Function]=11,Ce[p.SymbolKind.Variable]=12,Ce[p.SymbolKind.Constant]=13,Ce[p.SymbolKind.String]=14,Ce[p.SymbolKind.Number]=15,Ce[p.SymbolKind.Boolean]=16,Ce[p.SymbolKind.Array]=17,Ce[p.SymbolKind.Object]=18,Ce[p.SymbolKind.Key]=19,Ce[p.SymbolKind.Null]=20,Ce[p.SymbolKind.EnumMember]=21,Ce[p.SymbolKind.Struct]=22,Ce[p.SymbolKind.Event]=23,Ce[p.SymbolKind.Operator]=24,Ce[p.SymbolKind.TypeParameter]=25;function me(ke){return typeof Ce[ke]=="number"?Ce[ke]:6}Se.from=me;function ie(ke){for(const Le in Ce)if(Ce[Le]===ke)return Number(Le);return p.SymbolKind.Property}Se.to=ie})(B=e.SymbolKind||(e.SymbolKind={}));var x;(function(Se){function Ce(ie){switch(ie){case p.SymbolTag.Deprecated:return 1}}Se.from=Ce;function me(ie){switch(ie){case 1:return p.SymbolTag.Deprecated}}Se.to=me})(x=e.SymbolTag||(e.SymbolTag={}));var z;(function(Se){function Ce(ie){return{name:ie.name,kind:B.from(ie.kind),tags:ie.tags&&ie.tags.map(x.from),containerName:ie.containerName,location:ue.from(ie.location)}}Se.from=Ce;function me(ie){const ke=new p.SymbolInformation(ie.name,B.to(ie.kind),ie.containerName,ue.to(ie.location));return ke.tags=ie.tags&&ie.tags.map(x.to),ke}Se.to=me})(z=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var G;(function(Se){function Ce(ie){const ke={name:ie.name||"!!MISSING: name!!",detail:ie.detail,range:s.from(ie.range),selectionRange:s.from(ie.selectionRange),kind:B.from(ie.kind),tags:ie.tags?.map(x.from)??[]};return ie.children&&(ke.children=ie.children.map(Ce)),ke}Se.from=Ce;function me(ie){const ke=new p.DocumentSymbol(ie.name,ie.detail,B.to(ie.kind),s.to(ie.range),s.to(ie.selectionRange));return(0,d.isNonEmptyArray)(ie.tags)&&(ke.tags=ie.tags.map(x.to)),ie.children&&(ke.children=ie.children.map(me)),ke}Se.to=me})(G=e.DocumentSymbol||(e.DocumentSymbol={}));var q;(function(Se){function Ce(ie){const ke=new p.CallHierarchyItem(B.to(ie.kind),ie.name,ie.detail||"",P.URI.revive(ie.uri),s.to(ie.range),s.to(ie.selectionRange));return ke._sessionId=ie._sessionId,ke._itemId=ie._itemId,ke}Se.to=Ce;function me(ie,ke,Le){if(ke=ke??ie._sessionId,Le=Le??ie._itemId,ke===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Le,name:ie.name,detail:ie.detail,kind:B.from(ie.kind),uri:ie.uri,range:s.from(ie.range),selectionRange:s.from(ie.selectionRange),tags:ie.tags?.map(x.from)}}Se.from=me})(q=e.CallHierarchyItem||(e.CallHierarchyItem={}));var Z;(function(Se){function Ce(me){return new p.CallHierarchyIncomingCall(q.to(me.from),me.fromRanges.map(ie=>s.to(ie)))}Se.to=Ce})(Z=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var se;(function(Se){function Ce(me){return new p.CallHierarchyOutgoingCall(q.to(me.to),me.fromRanges.map(ie=>s.to(ie)))}Se.to=Ce})(se=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ue;(function(Se){function Ce(ie){return{range:ie.range&&s.from(ie.range),uri:ie.uri}}Se.from=Ce;function me(ie){return new p.Location(P.URI.revive(ie.uri),s.to(ie.range))}Se.to=me})(ue=e.location||(e.location={}));var te;(function(Se){function Ce(ie){const ke=ie,Le=ie;return{originSelectionRange:ke.originSelectionRange?s.from(ke.originSelectionRange):void 0,uri:ke.targetUri?ke.targetUri:Le.uri,range:s.from(ke.targetRange?ke.targetRange:Le.range),targetSelectionRange:ke.targetSelectionRange?s.from(ke.targetSelectionRange):void 0}}Se.from=Ce;function me(ie){return{targetUri:P.URI.revive(ie.uri),targetRange:s.to(ie.range),targetSelectionRange:ie.targetSelectionRange?s.to(ie.targetSelectionRange):void 0,originSelectionRange:ie.originSelectionRange?s.to(ie.originSelectionRange):void 0}}Se.to=me})(te=e.DefinitionLink||(e.DefinitionLink={}));var J;(function(Se){function Ce(ie){return{range:s.from(ie.range),contents:b.fromMany(ie.contents)}}Se.from=Ce;function me(ie){return new p.Hover(ie.contents.map(b.to),s.to(ie.range))}Se.to=me})(J=e.Hover||(e.Hover={}));var ae;(function(Se){function Ce(ie){return{range:s.from(ie.range),expression:ie.expression}}Se.from=Ce;function me(ie){return new p.EvaluatableExpression(s.to(ie.range),ie.expression)}Se.to=me})(ae=e.EvaluatableExpression||(e.EvaluatableExpression={}));var he;(function(Se){function Ce(ie){if(ie instanceof p.InlineValueText)return{type:"text",range:s.from(ie.range),text:ie.text};if(ie instanceof p.InlineValueVariableLookup)return{type:"variable",range:s.from(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};if(ie instanceof p.InlineValueEvaluatableExpression)return{type:"expression",range:s.from(ie.range),expression:ie.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=Ce;function me(ie){switch(ie.type){case"text":return{range:s.to(ie.range),text:ie.text};case"variable":return{range:s.to(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};case"expression":return{range:s.to(ie.range),expression:ie.expression}}}Se.to=me})(he=e.InlineValue||(e.InlineValue={}));var we;(function(Se){function Ce(ie){return{frameId:ie.frameId,stoppedLocation:s.from(ie.stoppedLocation)}}Se.from=Ce;function me(ie){return new p.InlineValueContext(ie.frameId,s.to(ie.stoppedLocation))}Se.to=me})(we=e.InlineValueContext||(e.InlineValueContext={}));var Ie;(function(Se){function Ce(ie){return{range:s.from(ie.range),kind:ie.kind}}Se.from=Ce;function me(ie){return new p.DocumentHighlight(s.to(ie.range),ie.kind)}Se.to=me})(Ie=e.DocumentHighlight||(e.DocumentHighlight={}));var Ne;(function(Se){function Ce(me){switch(me){case 1:return p.CompletionTriggerKind.TriggerCharacter;case 2:return p.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return p.CompletionTriggerKind.Invoke}}Se.to=Ce})(Ne=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ee;(function(Se){function Ce(me){return{triggerKind:Ne.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}Se.to=Ce})(Ee=e.CompletionContext||(e.CompletionContext={}));var be;(function(Se){function Ce(ie){switch(ie){case p.CompletionItemTag.Deprecated:return 1}}Se.from=Ce;function me(ie){switch(ie){case 1:return p.CompletionItemTag.Deprecated}}Se.to=me})(be=e.CompletionItemTag||(e.CompletionItemTag={}));var H;(function(Se){const Ce=new Map([[p.CompletionItemKind.Method,0],[p.CompletionItemKind.Function,1],[p.CompletionItemKind.Constructor,2],[p.CompletionItemKind.Field,3],[p.CompletionItemKind.Variable,4],[p.CompletionItemKind.Class,5],[p.CompletionItemKind.Interface,7],[p.CompletionItemKind.Struct,6],[p.CompletionItemKind.Module,8],[p.CompletionItemKind.Property,9],[p.CompletionItemKind.Unit,12],[p.CompletionItemKind.Value,13],[p.CompletionItemKind.Constant,14],[p.CompletionItemKind.Enum,15],[p.CompletionItemKind.EnumMember,16],[p.CompletionItemKind.Keyword,17],[p.CompletionItemKind.Snippet,27],[p.CompletionItemKind.Text,18],[p.CompletionItemKind.Color,19],[p.CompletionItemKind.File,20],[p.CompletionItemKind.Reference,21],[p.CompletionItemKind.Folder,23],[p.CompletionItemKind.Event,10],[p.CompletionItemKind.Operator,11],[p.CompletionItemKind.TypeParameter,24],[p.CompletionItemKind.Issue,26],[p.CompletionItemKind.User,25]]);function me(Le){return Ce.get(Le)??9}Se.from=me;const ie=new Map([[0,p.CompletionItemKind.Method],[1,p.CompletionItemKind.Function],[2,p.CompletionItemKind.Constructor],[3,p.CompletionItemKind.Field],[4,p.CompletionItemKind.Variable],[5,p.CompletionItemKind.Class],[7,p.CompletionItemKind.Interface],[6,p.CompletionItemKind.Struct],[8,p.CompletionItemKind.Module],[9,p.CompletionItemKind.Property],[12,p.CompletionItemKind.Unit],[13,p.CompletionItemKind.Value],[14,p.CompletionItemKind.Constant],[15,p.CompletionItemKind.Enum],[16,p.CompletionItemKind.EnumMember],[17,p.CompletionItemKind.Keyword],[27,p.CompletionItemKind.Snippet],[18,p.CompletionItemKind.Text],[19,p.CompletionItemKind.Color],[20,p.CompletionItemKind.File],[21,p.CompletionItemKind.Reference],[23,p.CompletionItemKind.Folder],[10,p.CompletionItemKind.Event],[11,p.CompletionItemKind.Operator],[24,p.CompletionItemKind.TypeParameter],[25,p.CompletionItemKind.User],[26,p.CompletionItemKind.Issue]]);function ke(Le){return ie.get(Le)??p.CompletionItemKind.Property}Se.to=ke})(H=e.CompletionItemKind||(e.CompletionItemKind={}));var W;(function(Se){function Ce(me,ie){const ke=new p.CompletionItem(me.label);return ke.insertText=me.insertText,ke.kind=H.to(me.kind),ke.tags=me.tags?.map(be.to),ke.detail=me.detail,ke.documentation=I.isMarkdownString(me.documentation)?b.to(me.documentation):me.documentation,ke.sortText=me.sortText,ke.filterText=me.filterText,ke.preselect=me.preselect,ke.commitCharacters=me.commitCharacters,F.Range.isIRange(me.range)?ke.range=s.to(me.range):typeof me.range=="object"&&(ke.range={inserting:s.to(me.range.insert),replacing:s.to(me.range.replace)}),ke.keepWhitespace=typeof me.insertTextRules=="undefined"?!1:Boolean(me.insertTextRules&1),typeof me.insertTextRules!="undefined"&&me.insertTextRules&4?ke.insertText=new p.SnippetString(me.insertText):(ke.insertText=me.insertText,ke.textEdit=ke.range instanceof p.Range?new p.TextEdit(ke.range,ke.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(ke.additionalTextEdits=me.additionalTextEdits.map(Le=>j.to(Le))),ke.command=ie&&me.command?ie.fromInternal(me.command):void 0,ke}Se.to=Ce})(W=e.CompletionItem||(e.CompletionItem={}));var O;(function(Se){function Ce(ie){return{label:ie.label,documentation:ie.documentation?b.fromStrict(ie.documentation):void 0}}Se.from=Ce;function me(ie){return{label:ie.label,documentation:I.isMarkdownString(ie.documentation)?b.to(ie.documentation):ie.documentation}}Se.to=me})(O=e.ParameterInformation||(e.ParameterInformation={}));var $;(function(Se){function Ce(ie){return{label:ie.label,documentation:ie.documentation?b.fromStrict(ie.documentation):void 0,parameters:Array.isArray(ie.parameters)?ie.parameters.map(O.from):[],activeParameter:ie.activeParameter}}Se.from=Ce;function me(ie){return{label:ie.label,documentation:I.isMarkdownString(ie.documentation)?b.to(ie.documentation):ie.documentation,parameters:Array.isArray(ie.parameters)?ie.parameters.map(O.to):[],activeParameter:ie.activeParameter}}Se.to=me})($=e.SignatureInformation||(e.SignatureInformation={}));var Q;(function(Se){function Ce(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map($.from):[]}}Se.from=Ce;function me(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map($.to):[]}}Se.to=me})(Q=e.SignatureHelp||(e.SignatureHelp={}));var re;(function(Se){function Ce(me,ie){const ke=new p.InlayHint(typeof ie.label=="string"?ie.label:ie.label.map(de.to.bind(void 0,me)),r.to(ie.position),ye.to(ie.kind));return ke.tooltip=I.isMarkdownString(ie.tooltip)?b.to(ie.tooltip):ie.tooltip,ke.paddingLeft=ie.paddingLeft,ke.paddingRight=ie.paddingRight,ke}Se.to=Ce})(re=e.InlayHint||(e.InlayHint={}));var de;(function(Se){function Ce(me,ie){const ke=new p.InlayHintLabelPart(ie.label);return ke.tooltip=I.isMarkdownString(ie.tooltip)?b.to(ie.tooltip):ie.tooltip,y.Command.is(ie.command)&&(ke.command=me.fromInternal(ie.command)),ie.location&&(ke.location=ue.to(ie.location)),ke}Se.to=Ce})(de=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var ye;(function(Se){function Ce(ie){return ie}Se.from=Ce;function me(ie){return ie}Se.to=me})(ye=e.InlayHintKind||(e.InlayHintKind={}));var Ae;(function(Se){function Ce(ie){return{range:s.from(ie.range),url:ie.target,tooltip:ie.tooltip}}Se.from=Ce;function me(ie){let ke;if(ie.url)try{ke=typeof ie.url=="string"?P.URI.parse(ie.url,!0):P.URI.revive(ie.url)}catch{}return new p.DocumentLink(s.to(ie.range),ke)}Se.to=me})(Ae=e.DocumentLink||(e.DocumentLink={}));var We;(function(Se){function Ce(ie){const ke=new p.ColorPresentation(ie.label);return ie.textEdit&&(ke.textEdit=j.to(ie.textEdit)),ie.additionalTextEdits&&(ke.additionalTextEdits=ie.additionalTextEdits.map(Le=>j.to(Le))),ke}Se.to=Ce;function me(ie){return{label:ie.label,textEdit:ie.textEdit?j.from(ie.textEdit):void 0,additionalTextEdits:ie.additionalTextEdits?ie.additionalTextEdits.map(ke=>j.from(ke)):void 0}}Se.from=me})(We=e.ColorPresentation||(e.ColorPresentation={}));var $e;(function(Se){function Ce(ie){return new p.Color(ie[0],ie[1],ie[2],ie[3])}Se.to=Ce;function me(ie){return[ie.red,ie.green,ie.blue,ie.alpha]}Se.from=me})($e=e.Color||(e.Color={}));var je;(function(Se){function Ce(ie){return{range:s.from(ie.range)}}Se.from=Ce;function me(ie){return new p.SelectionRange(s.to(ie.range))}Se.to=me})(je=e.SelectionRange||(e.SelectionRange={}));var He;(function(Se){function Ce(me){switch(me){case 2:return p.TextDocumentSaveReason.AfterDelay;case 1:return p.TextDocumentSaveReason.Manual;case 3:case 4:return p.TextDocumentSaveReason.FocusOut}}Se.to=Ce})(He=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ue;(function(Se){function Ce(ie){switch(ie){case p.TextEditorLineNumbersStyle.Off:return 0;case p.TextEditorLineNumbersStyle.Relative:return 2;case p.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=Ce;function me(ie){switch(ie){case 0:return p.TextEditorLineNumbersStyle.Off;case 2:return p.TextEditorLineNumbersStyle.Relative;case 1:default:return p.TextEditorLineNumbersStyle.On}}Se.to=me})(Ue=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Je;(function(Se){function Ce(ie){if(ie===p.EndOfLine.CRLF)return 1;if(ie===p.EndOfLine.LF)return 0}Se.from=Ce;function me(ie){if(ie===1)return p.EndOfLine.CRLF;if(ie===0)return p.EndOfLine.LF}Se.to=me})(Je=e.EndOfLine||(e.EndOfLine={}));var rt;(function(Se){function Ce(me){if(typeof me=="object")return me.viewId;switch(me){case p.ProgressLocation.SourceControl:return 3;case p.ProgressLocation.Window:return 10;case p.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=Ce})(rt=e.ProgressLocation||(e.ProgressLocation={}));var Re;(function(Se){function Ce(me){const ie={start:me.start+1,end:me.end+1};return me.kind&&(ie.kind=tt.from(me.kind)),ie}Se.from=Ce})(Re=e.FoldingRange||(e.FoldingRange={}));var tt;(function(Se){function Ce(me){if(me)switch(me){case p.FoldingRangeKind.Comment:return y.FoldingRangeKind.Comment;case p.FoldingRangeKind.Imports:return y.FoldingRangeKind.Imports;case p.FoldingRangeKind.Region:return y.FoldingRangeKind.Region}}Se.from=Ce})(tt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ne;(function(Se){function Ce(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?s.from(me.selection):void 0,override:typeof me.override=="boolean"?c.EditorResolution.DISABLED:void 0}}Se.from=Ce})(ne=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var oe;(function(Se){function Ce(Le){return Le instanceof p.RelativePattern?Le.toJSON():typeof Le=="string"?Le:me(Le)||ie(Le)?new p.RelativePattern(Le.baseUri??Le.base,Le.pattern).toJSON():Le}Se.from=Ce;function me(Le){const Ke=Le;return Ke?P.URI.isUri(Ke.baseUri)&&typeof Ke.pattern=="string":!1}function ie(Le){const Ke=Le;return Ke?typeof Ke.base=="string"&&typeof Ke.pattern=="string":!1}function ke(Le){return typeof Le=="string"?Le:new p.RelativePattern(P.URI.revive(Le.baseUri),Le.pattern)}Se.to=ke})(oe=e.GlobPattern||(e.GlobPattern={}));var Y;(function(Se){function Ce(me){if(me){if(Array.isArray(me))return me.map(Ce);if(typeof me=="string")return me;{const ie=me;return{language:ie.language,scheme:ie.scheme,pattern:oe.from(ie.pattern),exclusive:ie.exclusive}}}else return}Se.from=Ce})(Y=e.LanguageSelector||(e.LanguageSelector={}));var ge;(function(Se){function Ce(ie){return{start:ie.start,end:ie.end}}Se.from=Ce;function me(ie){return new p.NotebookRange(ie.start,ie.end)}Se.to=me})(ge=e.NotebookRange||(e.NotebookRange={}));var _e;(function(Se){function Ce(ie){return{timing:typeof ie.runStartTime=="number"&&typeof ie.runEndTime=="number"?{startTime:ie.runStartTime,endTime:ie.runEndTime}:void 0,executionOrder:ie.executionOrder,success:ie.lastRunSuccess}}Se.to=Ce;function me(ie){return{lastRunSuccess:ie.success,runStartTime:ie.timing?.startTime,runEndTime:ie.timing?.endTime,executionOrder:ie.executionOrder}}Se.from=me})(_e=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Oe;(function(Se){function Ce(ie){switch(ie){case p.NotebookCellKind.Markup:return w.CellKind.Markup;case p.NotebookCellKind.Code:default:return w.CellKind.Code}}Se.from=Ce;function me(ie){switch(ie){case w.CellKind.Markup:return p.NotebookCellKind.Markup;case w.CellKind.Code:default:return p.NotebookCellKind.Code}}Se.to=me})(Oe=e.NotebookCellKind||(e.NotebookCellKind={}));var ze;(function(Se){function Ce(ie){const ke={metadata:ie.metadata??Object.create(null),cells:[]};for(let Le of ie.cells)p.NotebookCellData.validate(Le),ke.cells.push(Ze.from(Le));return ke}Se.from=Ce;function me(ie){const ke=new p.NotebookData(ie.cells.map(Ze.to));return(0,D.isEmptyObject)(ie.metadata)||(ke.metadata=ie.metadata),ke}Se.to=me})(ze=e.NotebookData||(e.NotebookData={}));var Ze;(function(Se){function Ce(ie){return{cellKind:Oe.from(ie.kind),language:ie.languageId,mime:ie.mime,source:ie.value,metadata:ie.metadata,internalMetadata:_e.from(ie.executionSummary??{}),outputs:ie.outputs?ie.outputs.map(vt.from):[]}}Se.from=Ce;function me(ie){return new p.NotebookCellData(Oe.to(ie.cellKind),ie.source,ie.language,ie.mime,ie.outputs?ie.outputs.map(vt.to):void 0,ie.metadata,ie.internalMetadata?_e.to(ie.internalMetadata):void 0)}Se.to=me})(Ze=e.NotebookCellData||(e.NotebookCellData={}));var lt;(function(Se){function Ce(ie){return{mime:ie.mime,valueBytes:t.VSBuffer.wrap(ie.data)}}Se.from=Ce;function me(ie){return new p.NotebookCellOutputItem(ie.valueBytes.buffer,ie.mime)}Se.to=me})(lt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var vt;(function(Se){function Ce(ie){return{outputId:ie.id,items:ie.items.map(lt.from),metadata:ie.metadata}}Se.from=Ce;function me(ie){const ke=ie.items.map(lt.to);return new p.NotebookCellOutput(ke,ie.outputId,ie.metadata)}Se.to=me})(vt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ge;(function(Se){function Ce(ke){return ie(ke)?{include:(0,D.withNullAsUndefined)(oe.from(ke.include)),exclude:(0,D.withNullAsUndefined)(oe.from(ke.exclude))}:(0,D.withNullAsUndefined)(oe.from(ke))}Se.from=Ce;function me(ke){return ie(ke)?{include:oe.to(ke.include),exclude:oe.to(ke.exclude)}:oe.to(ke)}Se.to=me;function ie(ke){const Le=ke;return Le?!!Le.include&&!!Le.exclude:!1}})(Ge=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var at;(function(Se){function Ce(me){return{backgroundColor:me.backgroundColor,borderColor:me.borderColor,top:me.top?N.from(me.top):void 0}}Se.from=Ce})(at=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Xe;(function(Se){function Ce(me,ie,ke){const Le=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===p.NotebookCellStatusBarAlignment.Left?1:2,command:ie.toInternal(Le,ke),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}Se.from=Ce})(Xe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var st;(function(Se){function Ce(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{}}}Se.from=Ce})(st=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var yt;(function(Se){function Ce(ie){return{uri:ie.uri,provides:ie.provides}}Se.from=Ce;function me(ie){return new p.NotebookRendererScript(P.URI.revive(ie.uri),ie.provides)}Se.to=me})(yt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Pt;(function(Se){function Ce(ie){return{message:b.fromStrict(ie.message)||"",type:0,expected:ie.expectedOutput,actual:ie.actualOutput,location:ie.location?ue.from(ie.location):void 0}}Se.from=Ce;function me(ie){const ke=new p.TestMessage(typeof ie.message=="string"?ie.message:b.to(ie.message));return ke.actualOutput=ie.actual,ke.expectedOutput=ie.expected,ke.location=ie.location?ue.to(ie.location):void 0,ke}Se.to=me})(Pt=e.TestMessage||(e.TestMessage={}));var Ct;(function(Se){let Ce;(function(me){me.Delimiter="\0"})(Ce||(Ce={})),Se.namespace=(me,ie)=>me+"\0"+ie,Se.denamespace=me=>{const ie=me.indexOf("\0");return{ctrlId:me.slice(0,ie),tagId:me.slice(ie+1)}}})(Ct=e.TestTag||(e.TestTag={}));var ht;(function(Se){function Ce(Le){const Ke=(0,v.getPrivateApiFor)(Le).controllerId;return{extId:_.TestId.fromExtHostTestItem(Le,Ke).toString(),label:Le.label,uri:Le.uri,tags:Le.tags.map(Ve=>Ct.namespace(Ke,Ve.id)),range:s.from(Le.range)||null,description:Le.description||null,sortText:Le.sortText||null,error:Le.error&&b.fromStrict(Le.error)||null}}Se.from=Ce;function me(Le){return{parent:void 0,error:void 0,id:_.TestId.fromString(Le.extId).localId,label:Le.label,uri:P.URI.revive(Le.uri),tags:(Le.tags||[]).map(Ke=>{const{tagId:Ve}=Ct.denamespace(Ke);return new p.TestTag(Ve)}),range:s.to(Le.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Le.description||void 0,sortText:Le.sortText||void 0}}Se.toPlain=me;function ie(Le){const Ke=_.TestId.fromString(Le.extId),Ve=new v.TestItemImpl(Ke.controllerId,Ke.localId,Le.label,P.URI.revive(Le.uri));return Ve.range=s.to(Le.range||void 0),Ve.description=Le.description||void 0,Ve.sortText=Le.sortText||void 0,Ve}function ke(Le){let Ke;for(const Ve of Le.tests){const ct=ie(Ve.item);(0,v.getPrivateApiFor)(ct).parent=Ke,Ke=ct}return Ke}Se.toItemFromContext=ke})(ht=e.TestItem||(e.TestItem={})),function(Se){function Ce(ie){return{id:ie.id}}Se.from=Ce;function me(ie){return new p.TestTag(ie.id)}Se.to=me}(Ct=e.TestTag||(e.TestTag={}));var kt;(function(Se){const Ce=(ie,ke)=>{const Le={...ht.toPlain(ie.item),parent:void 0,taskStates:ie.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(Ve=>Ve.type===0).map(Pt.to)})),children:ie.children.map(Ke=>ke.get(Ke)).filter(D.isDefined).map(Ke=>Ce(Ke,ke))};for(const Ke of Le.children)Ke.parent=Le;return Le};function me(ie){const ke=[],Le=new Map;for(const Ke of ie.items)Le.set(Ke.item.extId,Ke),ie.request.targets.some(Ve=>Ve.controllerId===Ke.controllerId&&Ve.testIds.includes(Ke.item.extId))&&ke.push(Ke);return{completedAt:ie.completedAt,results:ke.map(Ke=>Ce(Ke,Le))}}Se.to=me})(kt=e.TestResults||(e.TestResults={}));var Ft;(function(Se){function Ce(Le){return{covered:Le.covered,total:Le.covered}}function me(Le){return"line"in Le?r.from(Le):s.from(Le)}function ie(Le){return"branches"in Le?{count:Le.executionCount,location:me(Le.location),type:1,branches:Le.branches.length?Le.branches.map(Ke=>({count:Ke.executionCount,location:Ke.location&&me(Ke.location)})):void 0}:{type:0,count:Le.executionCount,location:me(Le.location)}}Se.fromDetailed=ie;function ke(Le){return{uri:Le.uri,statement:Ce(Le.statementCoverage),branch:Le.branchCoverage&&Ce(Le.branchCoverage),function:Le.functionCoverage&&Ce(Le.functionCoverage),details:Le.detailedCoverage?.map(ie)}}Se.fromFile=ke})(Ft=e.TestCoverage||(e.TestCoverage={}));var Mt;(function(Se){function Ce(me){switch(me){case 1:return p.CodeActionTriggerKind.Invoke;case 2:return p.CodeActionTriggerKind.Automatic}}Se.to=Ce})(Mt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var xe;(function(Se){function Ce(ie){const ke=new p.TypeHierarchyItem(B.to(ie.kind),ie.name,ie.detail||"",P.URI.revive(ie.uri),s.to(ie.range),s.to(ie.selectionRange));return ke._sessionId=ie._sessionId,ke._itemId=ie._itemId,ke}Se.to=Ce;function me(ie,ke,Le){if(ke=ke??ie._sessionId,Le=Le??ie._itemId,ke===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Le,kind:B.from(ie.kind),name:ie.name,detail:ie.detail??"",uri:ie.uri,range:s.from(ie.range),selectionRange:s.from(ie.selectionRange),tags:ie.tags?.map(x.from)}}Se.from=me})(xe=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(pe[220],ve([0,1,2,16,7,15,94]),function(ee,e,d,t,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(P,F,y,c={timeout:1500,errors:3}){this._logService=P,this._documents=F,this._mainThreadBulkEdits=y,this._thresholds=c,this._callbacks=new T.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(F,y,c)=>{const v={dispose:this._callbacks.push([F,y,P])};return Array.isArray(c)&&c.push(v),v}}async $participateInSave(P,F){const y=d.URI.revive(P);let c=!1;const E=setTimeout(()=>c=!0,this._thresholds.timeout),v=[];try{for(let w of[...this._callbacks]){if(c)break;const _=this._documents.getDocument(y),R=await this._deliverEventAsyncAndBlameBadListeners(w,{document:_,reason:C.TextDocumentSaveReason.to(F)});v.push(R)}}finally{clearTimeout(E)}return v}_deliverEventAsyncAndBlameBadListeners([P,F,y],c){const E=this._badListeners.get(P);return typeof E=="number"&&E>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(y,P,F,c).then(()=>!0,v=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' threw ERROR`),this._logService.error(v),!(v instanceof Error)||v.message!=="concurrent_edits"){const w=this._badListeners.get(P);this._badListeners.set(P,w?w+1:1),typeof w=="number"&&w>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,F,y,c){const E=[],v=Date.now(),{document:w,reason:_}=c,{version:R}=w,p=Object.freeze({document:w,reason:_,waitUntil(h){if(Object.isFrozen(E))throw(0,t.illegalState)("waitUntil can not be called async");E.push(Promise.resolve(h))}});try{F.apply(y,[p])}catch(h){return Promise.reject(h)}return Object.freeze(E),new Promise((h,s)=>{const u=setTimeout(()=>s(new Error("timeout")),this._thresholds.timeout);return Promise.all(E).then(r=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-v}ms`),clearTimeout(u),h(r)}).catch(r=>{clearTimeout(u),s(r)})}).then(h=>{const s={edits:[]};for(const u of h)if(Array.isArray(u)&&u.every(r=>r instanceof I.TextEdit))for(const{newText:r,newEol:S,range:a}of u)s.edits.push({_type:2,resource:w.uri,edit:{range:a&&C.Range.from(a),text:r,eol:S&&C.EndOfLine.from(S)}});if(s.edits.length!==0)return R===w.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(s):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(pe[221],ve([0,1,10,25,2,15,127]),function(ee,e,d,t,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class k{constructor(y,c,E,v){this.start=y,this.deletedCount=c,this.deletedItems=E,this.items=v}static asApiEvents(y){return y.map(c=>({start:c.start,deletedCount:c.deletedCount,deletedItems:c.deletedItems,items:c.items.map(E=>E.apiCell)}))}}class D{constructor(y,c,E){this.notebook=y,this._extHostDocument=c,this._cellData=E,this.handle=E.handle,this.uri=I.URI.revive(E.uri),this.cellKind=E.cellKind,this._outputs=E.outputs.map(C.NotebookCellOutput.to),this._internalMetadata=E.internalMetadata??{},this._metadata=Object.freeze(E.metadata??{}),this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}static asModelAddData(y,c){return{EOL:c.eol,lines:c.source,languageId:c.language,uri:c.uri,isDirty:!1,versionId:1,notebook:y}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const y=this,c=this._extHostDocument.getDocument(this.uri);if(!c)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:C.NotebookCellKind.to(this._cellData.cellKind),document:c.document,get mime(){return y._mime},set mime(E){y._mime=E},get outputs(){return y._outputs.slice(0)},get metadata(){return y._metadata},get executionSummary(){return y._previousResult}})}return this._apiCell}setOutputs(y){this._outputs=y.map(C.NotebookCellOutput.to)}setOutputItems(y,c,E){const v=E.map(C.NotebookCellOutputItem.to),w=this._outputs.find(_=>_.id===y);w&&(c||(w.items.length=0),w.items.push(...v))}setMetadata(y){this._metadata=Object.freeze(y)}setInternalMetadata(y){this._internalMetadata=y,this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.ExtHostCell=D;class P{constructor(y,c,E,v,w,_){this._proxy=y,this._textDocumentsAndEditors=c,this._textDocuments=E,this._emitter=v,this.uri=w,this.handle=P._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=_.viewType,this._metadata=Object.freeze(_.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,_.cells]],!0),this._versionId=_.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const y=this;this._notebook={get uri(){return y.uri},get version(){return y._versionId},get notebookType(){return y._notebookType},get isDirty(){return y._isDirty},get isUntitled(){return y.uri.scheme===d.Schemas.untitled},get isClosed(){return y._disposed},get metadata(){return y._metadata},get cellCount(){return y._cells.length},cellAt(c){return c=y._validateIndex(c),y._cells[c].apiCell},getCells(c){return(c?y._getCells(c):y._cells).map(v=>v.apiCell)},save(){return y._save()}}}return this._notebook}updateBackup(y){this._backup?.delete(),this._backup=y}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(y){y.metadata&&(this._metadata=Object.freeze({...this._metadata,...y.metadata}))}acceptDirty(y){this._isDirty=y}acceptModelChanged(y,c){this._versionId=y.versionId,this._isDirty=c;for(const E of y.rawEvents)E.kind===T.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(E.changes,!1):E.kind===T.NotebookCellsChangeType.Move?this._moveCell(E.index,E.newIdx):E.kind===T.NotebookCellsChangeType.Output?this._setCellOutputs(E.index,E.outputs):E.kind===T.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(E.index,E.outputId,E.append,E.outputItems):E.kind===T.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(E.index,E.language):E.kind===T.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(E.index,E.mime):E.kind===T.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(E.index,E.metadata):E.kind===T.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(E.index,E.internalMetadata)}_validateIndex(y){return y=y|0,y<0?0:y>=this._cells.length?this._cells.length-1:y}_validateRange(y){let c=y.start|0,E=y.end|0;return c<0&&(c=0),E>this._cells.length&&(E=this._cells.length),y.with({start:c,end:E})}_getCells(y){y=this._validateRange(y);const c=[];for(let E=y.start;E<y.end;E++)c.push(this._cells[E]);return c}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(y,c){if(this._disposed)return;const E=[],v=[],w=[];y.reverse().forEach(_=>{const p=_[2].map(u=>{const r=new D(this,this._textDocumentsAndEditors,u);return c||v.push(D.asModelAddData(this.apiNotebook,u)),r}),h=new k(_[0],_[1],[],p),s=this._cells.splice(_[0],_[1],...p);for(const u of s)w.push(u.uri),h.deletedItems.push(u.apiCell);E.push(h)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:v,removedDocuments:w}),c||this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:k.asApiEvents(E)}))}_moveCell(y,c){const E=this._cells.splice(y,1);this._cells.splice(c,0,...E);const v=[new k(y,1,E.map(w=>w.apiCell),[]),new k(c,0,[],E)];this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:k.asApiEvents(v)}))}_setCellOutputs(y,c){const E=this._cells[y];E.setOutputs(c),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[E.apiCell]}))}_setCellOutputItems(y,c,E,v){const w=this._cells[y];w.setOutputItems(c,E,v),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[w.apiCell]}))}_changeCellLanguage(y,c){const E=this._cells[y];E.apiCell.document.languageId!==c&&this._textDocuments.$acceptModelLanguageChanged(E.uri,c)}_changeCellMime(y,c){const E=this._cells[y];E.apiCell.mime=c}_changeCellMetadata(y,c){const E=this._cells[y],v=E.apiCell.metadata;E.setMetadata(c);const w=E.apiCell.metadata;(0,t.equals)(v,w)||this._emitter.emitCellMetadataChange((0,t.deepFreeze)({document:this.apiNotebook,cell:E.apiCell}))}_changeCellInternalMetadata(y,c){this._cells[y].setInternalMetadata(c)}getCellFromApiCell(y){return this._cells.find(c=>c.apiCell===y)}getCellFromIndex(y){return this._cells[y]}getCell(y){return this._cells.find(c=>c.handle===y)}getCellIndex(y){return this._cells.indexOf(y)}}e.ExtHostNotebookDocument=P,P._handlePool=0}),define(pe[130],ve([0,1,7,15,16]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class C{constructor(D){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=D}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(D){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:D})}replaceCellMetadata(D,P){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:D,metadata:P})}replaceCells(D,P,F){this._throwIfFinalized(),!(D===P&&F.length===0)&&this._collectedEdits.push({editType:1,index:D,count:P-D,cells:F.map(t.NotebookCellData.from)})}}class T{constructor(D,P,F,y,c,E){this.id=D,this._proxy=P,this.notebookData=F,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=c,this._visibleRanges=y,this._viewColumn=E}get apiEditor(){if(!this._editor){const D=this;this._editor={get document(){return D.notebookData.apiNotebook},get selections(){return D._selections},set selections(P){if(!Array.isArray(P)||!P.every(d.NotebookRange.isNotebookRange))throw(0,I.illegalArgument)("selections");D._selections=P,D._trySetSelections(P)},get visibleRanges(){return D._visibleRanges},revealRange(P,F){D._proxy.$tryRevealRange(D.id,t.NotebookRange.from(P),F??d.NotebookEditorRevealType.Default)},get viewColumn(){return D._viewColumn},edit(P){const F=new C(this.document.version);return P(F),D._applyEdit(F.finalize())},setDecorations(P,F){return D.setDecorations(P,F)}},T.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(D){this._visible=D}_acceptVisibleRanges(D){this._visibleRanges=D}_acceptSelections(D){this._selections=D}_trySetSelections(D){this._proxy.$trySetSelections(this.id,D.map(t.NotebookRange.from))}_acceptViewColumn(D){this._viewColumn=D}_applyEdit(D){if(D.cellEdits.length===0)return Promise.resolve(!0);const P=[];let F=-1;for(let y=0;y<D.cellEdits.length;y++){if(F<0){P.push(D.cellEdits[y]),F++;continue}const E=P[F],v=D.cellEdits[y];if(E.editType===1&&v.editType===1&&E.index===v.index){E.cells.push(...D.cellEdits[y].cells),E.count+=D.cellEdits[y].count;continue}P.push(D.cellEdits[y]),F++}return this._proxy.$tryApplyEdits(this.id,D.documentVersionId,P)}setDecorations(D,P){if(!(P.isEmpty&&!this._hasDecorationsForKey.has(D.key)))return P.isEmpty?this._hasDecorationsForKey.delete(D.key):this._hasDecorationsForKey.add(D.key),this._proxy.$trySetDecorations(this.id,t.NotebookRange.from(P),D.key)}}e.ExtHostNotebookEditor=T,T.apiEditorsToExtHost=new WeakMap}),define(pe[222],ve([0,1,15,118,169,21,56,16]),function(ee,e,d,t,I,C,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class D{constructor(c){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=c}async withProgress(c,E,v){const w=this._handles++,{title:_,location:R,cancellable:p}=E,h={label:(0,I.localize)(0,null,c.displayName||c.name),id:c.identifier.value};return this._proxy.$startProgress(w,{location:d.ProgressLocation.from(R),title:_,source:h,cancellable:p},c.isUnderDevelopment?void 0:c.identifier.value).catch(k.onUnexpectedExternalError),this._withProgress(w,v,!!p)}_withProgress(c,E,v){let w;v&&(w=new C.CancellationTokenSource,this._mapHandleToCancellationSource.set(c,w));const _=p=>{this._proxy.$progressEnd(p),this._mapHandleToCancellationSource.delete(p),w&&w.dispose()};let R;try{R=E(new F(this._proxy,c),v&&w?w.token:C.CancellationToken.None)}catch(p){throw _(c),p}return R.then(p=>_(c),p=>_(c)),R}$acceptProgressCanceled(c){const E=this._mapHandleToCancellationSource.get(c);E&&(E.cancel(),this._mapHandleToCancellationSource.delete(c))}}e.ExtHostProgress=D;function P(y,c){return y.message=c.message,typeof c.increment=="number"&&(typeof y.increment=="number"?y.increment+=c.increment:y.increment=c.increment),y}class F extends t.Progress{constructor(c,E){super(v=>this.throttledReport(v));this._proxy=c,this._handle=E}throttledReport(c){this._proxy.$progressReport(this._handle,c)}}Be([(0,T.throttle)(100,(y,c)=>P(y,c),()=>Object.create(null))],F.prototype,"throttledReport",null)}),define(pe[131],ve([0,1,55,16,76,15,7]),function(ee,e,d,t,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(c,E,v){const w=k._Keys.nextId();c.$registerTextEditorDecorationType(E.identifier,w,C.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:w,dispose(){c.$removeTextEditorDecorationType(w)}})}}e.TextEditorDecorationType=k,k._Keys=new I.IdGenerator("TextEditorDecorationType");class D{constructor(c,E){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=c,this._documentVersionId=c.version,this._undoStopBefore=E.undoStopBefore,this._undoStopAfter=E.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(c,E){this._throwIfFinalized();let v=null;if(c instanceof T.Position)v=new T.Range(c,c);else if(c instanceof T.Range)v=c;else throw new Error("Unrecognized location");this._pushEdit(v,E,!1)}insert(c,E){this._throwIfFinalized(),this._pushEdit(new T.Range(c,c),E,!0)}delete(c){this._throwIfFinalized();let E=null;if(c instanceof T.Range)E=c;else throw new Error("Unrecognized location");this._pushEdit(E,null,!0)}_pushEdit(c,E,v){const w=this._document.validateRange(c);this._collectedEdits.push({range:w,text:E,forceMoveMarkers:v})}setEndOfLine(c){if(this._throwIfFinalized(),c!==T.EndOfLine.LF&&c!==T.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=c}}e.TextEditorEdit=D;class P{constructor(c,E,v,w){this._proxy=c,this._id=E,this._accept(v),this._logService=w;const _=this;this.value={get tabSize(){return _._tabSize},set tabSize(R){_._setTabSize(R)},get insertSpaces(){return _._insertSpaces},set insertSpaces(R){_._setInsertSpaces(R)},get cursorStyle(){return _._cursorStyle},set cursorStyle(R){_._setCursorStyle(R)},get lineNumbers(){return _._lineNumbers},set lineNumbers(R){_._setLineNumbers(R)}}}_accept(c){this._tabSize=c.tabSize,this._insertSpaces=c.insertSpaces,this._cursorStyle=c.cursorStyle,this._lineNumbers=C.TextEditorLineNumbersStyle.to(c.lineNumbers)}_validateTabSize(c){if(c==="auto")return"auto";if(typeof c=="number"){const E=Math.floor(c);return E>0?E:null}if(typeof c=="string"){const E=parseInt(c,10);return isNaN(E)?null:E>0?E:null}return null}_setTabSize(c){const E=this._validateTabSize(c);if(E!==null){if(typeof E=="number"){if(this._tabSize===E)return;this._tabSize=E}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:E}))}}_validateInsertSpaces(c){return c==="auto"?"auto":c==="false"?!1:Boolean(c)}_setInsertSpaces(c){const E=this._validateInsertSpaces(c);if(typeof E=="boolean"){if(this._insertSpaces===E)return;this._insertSpaces=E}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:E}))}_setCursorStyle(c){this._cursorStyle!==c&&(this._cursorStyle=c,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:c})))}_setLineNumbers(c){this._lineNumbers!==c&&(this._lineNumbers=c,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:C.TextEditorLineNumbersStyle.from(c)})))}assign(c){const E={};let v=!1;if(typeof c.tabSize!="undefined"){const w=this._validateTabSize(c.tabSize);w==="auto"?(v=!0,E.tabSize=w):typeof w=="number"&&this._tabSize!==w&&(this._tabSize=w,v=!0,E.tabSize=w)}if(typeof c.insertSpaces!="undefined"){const w=this._validateInsertSpaces(c.insertSpaces);w==="auto"?(v=!0,E.insertSpaces=w):this._insertSpaces!==w&&(this._insertSpaces=w,v=!0,E.insertSpaces=w)}typeof c.cursorStyle!="undefined"&&this._cursorStyle!==c.cursorStyle&&(this._cursorStyle=c.cursorStyle,v=!0,E.cursorStyle=c.cursorStyle),typeof c.lineNumbers!="undefined"&&this._lineNumbers!==c.lineNumbers&&(this._lineNumbers=c.lineNumbers,v=!0,E.lineNumbers=C.TextEditorLineNumbersStyle.from(c.lineNumbers)),v&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,E))}_warnOnError(c,E){E.catch(v=>{this._logService.warn(`ExtHostTextEditorOptions '${c}' failed:'`),this._logService.warn(v)})}}e.ExtHostTextEditorOptions=P;class F{constructor(c,E,v,w,_,R,p,h){this.id=c,this._proxy=E,this._logService=v,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=_,this._options=new P(this._proxy,this.id,R,v),this._visibleRanges=p,this._viewColumn=h;const s=this;this.value=Object.freeze({get document(){return w.getValue()},set document(u){throw(0,t.readonly)("document")},get selection(){return s._selections&&s._selections[0]},set selection(u){if(!(u instanceof T.Selection))throw(0,t.illegalArgument)("selection");s._selections=[u],s._trySetSelection()},get selections(){return s._selections},set selections(u){if(!Array.isArray(u)||u.some(r=>!(r instanceof T.Selection)))throw(0,t.illegalArgument)("selections");s._selections=u,s._trySetSelection()},get visibleRanges(){return s._visibleRanges},set visibleRanges(u){throw(0,t.readonly)("visibleRanges")},get options(){return s._options.value},set options(u){s._disposed||s._options.assign(u)},get viewColumn(){return s._viewColumn},set viewColumn(u){throw(0,t.readonly)("viewColumn")},edit(u,r={undoStopBefore:!0,undoStopAfter:!0}){if(s._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const S=new D(w.getValue(),r);return u(S),s._applyEdit(S)},insertSnippet(u,r,S={undoStopBefore:!0,undoStopAfter:!0}){if(s._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!r||Array.isArray(r)&&r.length===0)a=s._selections.map(i=>C.Range.from(i));else if(r instanceof T.Position){const{lineNumber:i,column:n}=C.Position.from(r);a=[{startLineNumber:i,startColumn:n,endLineNumber:i,endColumn:n}]}else if(r instanceof T.Range)a=[C.Range.from(r)];else{a=[];for(const i of r)if(i instanceof T.Range)a.push(C.Range.from(i));else{const{lineNumber:n,column:o}=C.Position.from(i);a.push({startLineNumber:n,startColumn:o,endLineNumber:n,endColumn:o})}}return E.$tryInsertSnippet(c,u.value,a,S)},setDecorations(u,r){const S=r.length===0;S&&!s._hasDecorationsForKey.has(u.key)||(S?s._hasDecorationsForKey.delete(u.key):s._hasDecorationsForKey.add(u.key),s._runOnProxy(()=>{if(C.isDecorationOptionsArr(r))return E.$trySetDecorations(c,u.key,C.fromRangeOrRangeWithMessage(r));{const a=new Array(4*r.length);for(let i=0,n=r.length;i<n;i++){const o=r[i];a[4*i]=o.start.line+1,a[4*i+1]=o.start.character+1,a[4*i+2]=o.end.line+1,a[4*i+3]=o.end.character+1}return E.$trySetDecorationsFast(c,u.key,a)}}))},revealRange(u,r){s._runOnProxy(()=>E.$tryRevealRange(c,C.Range.from(u),r||T.TextEditorRevealType.Default))},show(u){E.$tryShowEditor(c,C.ViewColumn.from(u))},hide(){E.$tryHideEditor(c)}})}dispose(){(0,d.ok)(!this._disposed),this._disposed=!0}_acceptOptions(c){(0,d.ok)(!this._disposed),this._options._accept(c)}_acceptVisibleRanges(c){(0,d.ok)(!this._disposed),this._visibleRanges=c}_acceptViewColumn(c){(0,d.ok)(!this._disposed),this._viewColumn=c}_acceptSelections(c){(0,d.ok)(!this._disposed),this._selections=c}async _trySetSelection(){const c=this._selections.map(C.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,c)),this.value}_applyEdit(c){const E=c.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const v=E.edits.map(_=>_.range);v.sort((_,R)=>_.end.line===R.end.line?_.end.character===R.end.character?_.start.line===R.start.line?_.start.character-R.start.character:_.start.line-R.start.line:_.end.character-R.end.character:_.end.line-R.end.line);for(let _=0,R=v.length-1;_<R;_++){const p=v[_].end;if(v[_+1].start.isBefore(p))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const w=E.edits.map(_=>({range:C.Range.from(_.range),text:_.text,forceMoveMarkers:_.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,E.documentVersionId,w,{setEndOfLine:typeof E.setEndOfLine=="number"?C.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}_runOnProxy(c){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this._logService.warn(E),null))}}e.ExtHostTextEditor=F}),define(pe[223],ve([0,1,13,3,6,18,63,15,128,89]),function(ee,e,d,t,I,C,T,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class F extends I.Disposable{constructor(c){super();this.controllerId=c,this.debounceSendDiff=this._register(new d.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.root=new T.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(c){this._resolveHandler=c;for(const E of this.tree.values())this.updateExpandability(E)}collectDiff(){const c=this.diff;return this.diff=[],c}pushDiff(c){const E=this.diff[this.diff.length-1];if(E&&c[0]===1){if(E[0]===1&&E[1].extId===c[1].extId){(0,D.applyTestItemUpdate)(E[1],c[1]);return}if(E[0]===0&&E[1].item.extId===c[1].extId){(0,D.applyTestItemUpdate)(E[1],c[1]);return}}this.diff.push(c),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(c,E){const v=this.tree.get(c);if(!!v){if((v.expandLevels===void 0||E>v.expandLevels)&&(v.expandLevels=E),v.expand===1){const w=this.resolveChildren(v);return w.isOpen()?this.expandChildren(v,E-1):w.wait().then(()=>this.expandChildren(v,E-1))}else if(v.expand===3)return v.resolveBarrier?.isOpen()===!1?v.resolveBarrier.wait().then(()=>this.expandChildren(v,E-1)):this.expandChildren(v,E-1)}}dispose(){for(const c of this.tree.values())(0,T.getPrivateApiFor)(c.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(c,E){switch(E.op){case 2:this.pushDiff([4,c.fullId.toString()]);break;case 1:this.removeItem(P.TestId.joinToString(c.fullId,E.id));break;case 0:this.upsertItem(E.item,c);break;case 4:for(const v of E.ops)this.onTestItemEvent(c,v);break;case 3:{const{key:v,value:w,previous:_}=E,R=c.fullId.toString();switch(v){case"canResolveChildren":this.updateExpandability(c);break;case"tags":this.diffTagRefs(w,_,R);break;case"range":this.pushDiff([1,{extId:R,item:{range:k.Range.from(w)}}]);break;case"error":this.pushDiff([1,{extId:R,item:{error:k.MarkdownString.fromStrict(w)||null}}]);break;default:this.pushDiff([1,{extId:R,item:{[v]:w??null}}]);break}break}default:(0,C.assertNever)(E)}}upsertItem(c,E){if(!(c instanceof T.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${c.id} did not`);const v=P.TestId.fromExtHostTestItem(c,this.root.id,E?.actual),w=(0,T.getPrivateApiFor)(c);w.parent&&w.parent!==E?.actual&&w.parent.children.delete(c.id);let _=this.tree.get(v.toString());if(!_){_={fullId:v,actual:c,parent:E?v.parentId:null,expandLevels:E?.expandLevels?E.expandLevels-1:void 0,expand:0},c.tags.forEach(this.incrementTagRefs,this),this.tree.set(_.fullId.toString(),_),this.setItemParent(c,E),this.pushDiff([0,{parent:_.parent&&_.parent.toString(),controllerId:this.controllerId,expand:_.expand,item:k.TestItem.from(c)}]),this.connectItemAndChildren(c,_,E);return}if(_.actual===c){this.connectItem(c,_,E);return}const R=_.actual.children,p=_.actual,h=(0,T.diffTestItems)(p,c);(0,T.getPrivateApiFor)(p).listener=void 0,_.actual=c,_.expand=0;for(const[s,u]of h)this.onTestItemEvent(_,{op:3,key:s,value:u,previous:p[s]});this.connectItemAndChildren(c,_,E);for(const s of R)c.children.get(s.id)||this.removeItem(P.TestId.joinToString(v,s.id))}diffTagRefs(c,E,v){const w=new Set(E.map(_=>_.id));for(const _ of c)w.delete(_.id)||this.incrementTagRefs(_);this.pushDiff([1,{extId:v,item:{tags:c.map(_=>k.TestTag.namespace(this.controllerId,_.id))}}]),w.forEach(this.decrementTagRefs,this)}incrementTagRefs(c){const E=this.tags.get(c.id);E?E.refCount++:(this.tags.set(c.id,{refCount:1}),this.pushDiff([5,{id:k.TestTag.namespace(this.controllerId,c.id),ctrlLabel:this.root.label}]))}decrementTagRefs(c){const E=this.tags.get(c);E&&!--E.refCount&&(this.tags.delete(c),this.pushDiff([6,k.TestTag.namespace(this.controllerId,c)]))}setItemParent(c,E){(0,T.getPrivateApiFor)(c).parent=E&&E.actual!==this.root?E.actual:void 0}connectItem(c,E,v){this.setItemParent(c,v);const w=(0,T.getPrivateApiFor)(c);w.parent=v?.actual,w.listener=_=>this.onTestItemEvent(E,_),this.updateExpandability(E)}connectItemAndChildren(c,E,v){this.connectItem(c,E,v);for(const w of c.children)this.upsertItem(w,E)}updateExpandability(c){let E;this._resolveHandler?c.resolveBarrier?E=c.resolveBarrier.isOpen()?3:2:E=c.actual.canResolveChildren?1:0:E=0,E!==c.expand&&(c.expand=E,this.pushDiff([1,{extId:c.fullId.toString(),expand:E}]),E===1&&c.expandLevels!==void 0&&this.resolveChildren(c))}expandChildren(c,E){if(E<0)return;const v=[];for(const w of c.actual.children){const _=this.expand(P.TestId.joinToString(c.fullId,w.id),E);(0,d.isThenable)(_)&&v.push(_)}if(v.length)return Promise.all(v).then(()=>{})}resolveChildren(c){if(c.resolveBarrier)return c.resolveBarrier;if(!this._resolveHandler){const _=new d.Barrier;return _.open(),_}c.expand=2,this.pushExpandStateUpdate(c);const E=c.resolveBarrier=new d.Barrier,v=_=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),c.actual!==this.root&&(c.actual.error=_.stack||_.message||String(_))};let w;try{w=this._resolveHandler(c.actual===this.root?void 0:c.actual)}catch(_){v(_)}return(0,d.isThenable)(w)?w.catch(v).then(()=>{E.open(),this.updateExpandability(c)}):(E.open(),this.updateExpandability(c)),c.resolveBarrier}pushExpandStateUpdate(c){this.pushDiff([1,{extId:c.fullId.toString(),expand:c.expand}])}removeItem(c){const E=this.tree.get(c);if(!E)throw new Error("attempting to remove non-existent child");this.pushDiff([2,c]);const v=[E];for(;v.length;){const w=v.pop();if(!!w){(0,T.getPrivateApiFor)(w.actual).listener=void 0;for(const _ of w.actual.tags)this.decrementTagRefs(_.id);this.tree.delete(w.fullId.toString());for(const _ of w.actual.children)v.push(this.tree.get(P.TestId.joinToString(w.fullId,_.id)))}}}flushDiff(){const c=this.collectDiff();c.length&&this.diffOpEmitter.fire(c)}}e.SingleUseTestCollection=F}),define(pe[224],ve([0,1,4,186]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,d.refineServiceDecorator)(t.IEnvironmentService)}),define(pe[225],ve([0,1,27,3,9]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class C{constructor(F){this.removedDueToLooping=F}}e.DeltaExtensionsResult=C;class T{constructor(F){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=F,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const F of this._extensionDescriptions){if(this._extensionsMap.has(d.ExtensionIdentifier.toKey(F.identifier))){console.error("Extension `"+F.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(d.ExtensionIdentifier.toKey(F.identifier),F),this._extensionsArr.push(F),Array.isArray(F.activationEvents))for(let y of F.activationEvents)y==="onUri"&&(y=`onUri:${d.ExtensionIdentifier.toKey(F.identifier)}`),this._activationMap.has(y)||this._activationMap.set(y,[]),this._activationMap.get(y).push(F)}}keepOnly(F){const y=new Set;F.forEach(c=>y.add(d.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>y.has(d.ExtensionIdentifier.toKey(c.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(F,y){F.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(F));const c=T._findLoopingExtensions(this._extensionDescriptions);if(y=y.concat(c.map(E=>E.identifier)),y.length>0){const E=new Set;y.forEach(v=>E.add(d.ExtensionIdentifier.toKey(v))),this._extensionDescriptions=this._extensionDescriptions.filter(v=>!E.has(d.ExtensionIdentifier.toKey(v.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new C(c)}static _findLoopingExtensions(F){const y=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(_){this._nodesSet.has(_)||(this._nodesSet.add(_),this._nodesArr.push(_))}addArc(_,R){this.addNode(_),this.addNode(R),this._arcs.has(_)?this._arcs.get(_).push(R):this._arcs.set(_,[R])}getArcs(_){return this._arcs.has(_)?this._arcs.get(_):[]}hasOnlyGoodArcs(_,R){const p=y.getArcs(_);for(let h=0;h<p.length;h++)if(!R.has(p[h]))return!1;return!0}getNodes(){return this._nodesArr}};let c=new Map;for(let _ of F){const R=d.ExtensionIdentifier.toKey(_.identifier);if(c.set(R,_),_.extensionDependencies)for(let p of _.extensionDependencies){const h=d.ExtensionIdentifier.toKey(p);y.addArc(R,h)}}let E=new Set;y.getNodes().filter(_=>y.getArcs(_).length===0).forEach(_=>E.add(_));let v=y.getNodes().filter(_=>!E.has(_)),w;do{w=!1;for(let _=0;_<v.length;_++){const R=v[_];y.hasOnlyGoodArcs(R,E)&&(v.splice(_,1),_--,E.add(R),w=!0)}}while(w);return v.map(_=>c.get(_))}containsActivationEvent(F){return this._activationMap.has(F)}containsExtension(F){return this._extensionsMap.has(d.ExtensionIdentifier.toKey(F))}getExtensionDescriptionsForActivationEvent(F){const y=this._activationMap.get(F);return y?y.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(F){const y=this._extensionsMap.get(d.ExtensionIdentifier.toKey(F));return y||void 0}}e.ExtensionDescriptionRegistry=T;var k;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(k||(k={}));function D(P,F){const y=P.isBuiltin?0:P.isUnderDevelopment?2:1,c=F.isBuiltin?0:F.isUnderDevelopment?2:1;if(y!==c)return y-c;const E=I.posix.basename(P.extensionLocation.path),v=I.posix.basename(F.extensionLocation.path);return E<v?-1:E>v?1:0}}),define(pe[226],ve([0,1,23]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var t;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(t=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var I;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(I=e.MessageType||(e.MessageType={}));function C(k){const D=d.VSBuffer.alloc(1);switch(k){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=C;function T(k,D){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=T}),define(pe[30],ve([0,1,3,2,4,27,121]),function(ee,e,d,t,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new C.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,I.createDecorator)("extensionService");var k;(function(s){s[s.None=0]="None",s[s.LocalProcess=1]="LocalProcess",s[s.LocalWebWorker=2]="LocalWebWorker",s[s.Remote=3]="Remote"})(k=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function D(s){switch(s){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=D;class P{constructor(u){this.dependency=u}}e.MissingExtensionDependency=P;var F;(function(s){s[s.LocalProcess=0]="LocalProcess",s[s.LocalWebWorker=1]="LocalWebWorker",s[s.Remote=2]="Remote"})(F=e.ExtensionHostKind||(e.ExtensionHostKind={}));function y(s){switch(s){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=y;function c(s,u){return s.enabledApiProposals?s.enabledApiProposals.includes(u):!1}e.isProposedApiEnabled=c;function E(s,u){if(!c(s,u))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${u}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${u}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}e.checkProposedApiEnabled=E;class v{constructor(u,r,S,a){this.codeLoadingTime=u,this.activateCallTime=r,this.activateResolvedTime=S,this.activationReason=a}}e.ActivationTimes=v;class w{constructor(u,r){this.description=u,this.value=r}}e.ExtensionPointContribution=w,e.ExtensionHostLogFileName="exthost";var _;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(_=e.ActivationKind||(e.ActivationKind={}));function R(s){return{type:s.isBuiltin?0:1,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,T.getGalleryExtensionId)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation}}e.toExtension=R;function p(s,u){return{identifier:new C.ExtensionIdentifier((0,T.getExtensionId)(s.manifest.publisher,s.manifest.name)),isBuiltin:s.type===0,isUserBuiltin:s.type===1&&s.isBuiltin,isUnderDevelopment:!!u,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid}}e.toExtensionDescription=p;class h{constructor(){this.onDidRegisterExtensions=d.Event.None,this.onDidChangeExtensionsStatus=d.Event.None,this.onDidChangeExtensions=d.Event.None,this.onWillActivateByEvent=d.Event.None,this.onDidChangeResponsiveChange=d.Event.None}activateByEvent(u){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(u){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(u,r){return Promise.resolve()}_onWillActivateExtension(u){}_onDidActivateExtension(u,r,S,a,i){}_onDidActivateExtensionError(u,r){}_onExtensionRuntimeError(u,r){}_onExtensionHostExit(u){}}e.NullExtensionService=h}),define(pe[227],ve([0,1,16,27,30,12]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const T=Promise.resolve(void 0);class k{constructor(w,_,R,p){this.startup=w,this.codeLoadingTime=_,this.activateCallTime=R,this.activateResolvedTime=p}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class D{constructor(w){this._startup=w,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(w,_){return w===-1||_===-1?-1:_-w}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=D;class P{constructor(w,_,R,p,h,s){this.activationFailed=w,this.activationFailedError=_,this.activationTimes=R,this.module=p,this.exports=h,this.subscriptions=s}}e.ActivatedExtension=P;class F extends P{constructor(w){super(!1,null,w,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=F;class y extends P{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=y;class c extends P{constructor(w){super(!0,w,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=c;let E=class{constructor(w,_,R,p,h){this._logService=h,this._isDisposed=!1,this._registry=w,this._resolvedExtensionsSet=new Set,_.forEach(s=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(s))),this._hostExtensionsMap=new Map,R.forEach(s=>this._hostExtensionsMap.set(t.ExtensionIdentifier.toKey(s),s)),this._host=p,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(w){const _=t.ExtensionIdentifier.toKey(w);return this._activatedExtensions.has(_)}getActivatedExtension(w){const _=t.ExtensionIdentifier.toKey(w),R=this._activatedExtensions.get(_);if(!R)throw new Error("Extension `"+w.value+"` is not known or not activated");return R}activateByEvent(w,_){if(this._alreadyActivatedEvents[w])return T;const R=this._registry.getExtensionDescriptionsForActivationEvent(w);return this._activateExtensions(R.map(p=>({id:p.identifier,reason:{startup:_,extensionId:p.identifier,activationEvent:w}}))).then(()=>{this._alreadyActivatedEvents[w]=!0})}activateById(w,_){const R=this._registry.getExtensionDescription(w);if(!R)throw new Error("Extension `"+w+"` is not known");return this._activateExtensions([{id:R.identifier,reason:_}])}_handleActivateRequest(w,_,R){if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(w.id))){_[t.ExtensionIdentifier.toKey(w.id)]=w;return}const p=this._registry.getExtensionDescription(w.id);if(!p){const u=new Error(`Cannot activate unknown extension '${w.id.value}'`);this._host.onExtensionActivationError(w.id,u,new I.MissingExtensionDependency(w.id.value)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(w.id),new c(u));return}const h=typeof p.extensionDependencies=="undefined"?[]:p.extensionDependencies;let s=!0;for(let u=0,r=h.length;u<r;u++){const S=h[u];if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(S)))continue;const a=this._activatedExtensions.get(t.ExtensionIdentifier.toKey(S));if(a&&!a.activationFailed)continue;if(a&&a.activationFailed){const l=p.displayName||p.identifier.value,f=this._registry.getExtensionDescription(S),m=f&&f.displayName||S,b=new Error(`Cannot activate the '${l}' extension because its dependency '${m}' failed to activate`);b.detail=a.activationFailedError,this._host.onExtensionActivationError(p.identifier,b,null),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(p.identifier),new c(b));return}if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(S))){s=!1,_[t.ExtensionIdentifier.toKey(S)]={id:this._hostExtensionsMap.get(t.ExtensionIdentifier.toKey(S)),reason:w.reason};continue}const i=this._registry.getExtensionDescription(S);if(i){if(!i.main&&!i.browser)continue;s=!1,_[t.ExtensionIdentifier.toKey(S)]={id:i.identifier,reason:w.reason};continue}const n=p.displayName||p.identifier.value,o=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${S}'`);this._host.onExtensionActivationError(p.identifier,o,new I.MissingExtensionDependency(S)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(p.identifier),new c(o));return}s?_[t.ExtensionIdentifier.toKey(p.identifier)]=w:R.push(w)}_activateExtensions(w){if(w.length===0||(w=w.filter(h=>!this._activatedExtensions.has(t.ExtensionIdentifier.toKey(h.id))),w.length===0))return Promise.resolve(void 0);const _=Object.create(null),R=[];for(let h=0,s=w.length;h<s;h++)this._handleActivateRequest(w[h],_,R);for(let h=0,s=R.length;h<s;h++){const u=t.ExtensionIdentifier.toKey(R[h].id);_[u]&&delete _[u]}const p=Object.keys(_).map(h=>_[h]);return R.length===0?Promise.all(p.map(h=>this._activateExtension(h.id,h.reason))).then(h=>{}):this._activateExtensions(p).then(h=>this._activateExtensions(R))}_activateExtension(w,_){const R=t.ExtensionIdentifier.toKey(w);if(this._activatedExtensions.has(R))return Promise.resolve(void 0);const p=this._activatingExtensions.get(R);if(p)return p;const h=this._host.actualActivateExtension(w,_).then(void 0,s=>{const u=new Error;return s&&s.name&&(u.name=s.name),s&&s.message?u.message=`Activating extension '${w.value}' failed: ${s.message}.`:u.message=`Activating extension '${w.value}' failed: ${s}.`,s&&s.stack&&(u.stack=s.stack),this._isDisposed&&d.isCancellationError(s)?new c(s):(this._host.onExtensionActivationError(w,u,null),this._logService.error(`Activating extension ${w.value} failed due to an error:`),this._logService.error(s),new c(s))}).then(s=>{this._activatedExtensions.set(R,s),this._activatingExtensions.delete(R)});return this._activatingExtensions.set(R,h),h}};E=Be([Me(4,C.ILogService)],E),e.ExtensionsActivator=E}),define(pe[228],ve([0,1,12,26,30]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let C=class extends d.LogService{constructor(k,D){super(k.createLogger(D.logFile,{name:I.ExtensionHostLogFileName}))}};C=Be([Me(0,d.ILoggerService),Me(1,t.IExtHostInitDataService)],C),e.ExtHostLogService=C}),define(pe[229],ve([0,1,16]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((C,T)=>{this._actualOk=C,this._actualErr=T,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(C){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=C,this._actual&&this._actualOk(C))}resolveErr(C){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=C,this._actual?this._actualErr(C):(0,d.onUnexpectedError)(C))}then(C,T){return this._ensureActual().then(C,T)}catch(C){return this._ensureActual().then(void 0,C)}finally(C){return this._ensureActual().finally(C)}}e.LazyPromise=t}),define(pe[52],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class d{constructor(D){this._proxyIdentifierBrand=void 0,this.sid=D,this.nid=++d.count}}e.ProxyIdentifier=d,d.count=0;const t=[];function I(k){const D=new d(k);return t[D.nid]=D,D}e.createProxyIdentifier=I;function C(k){return t[k].sid}e.getStringIdentifierForProxy=C;class T{constructor(D){this.value=D}}e.SerializableObjectWithBuffers=T}),define(pe[5],ve([0,1,59,2,52]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var C;(function(p){p[p.Desktop=1]="Desktop",p[p.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var T;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(T=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(p){p[p.Editable=0]="Editable",p[p.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(p){p[p.Int8Array=1]="Int8Array",p[p.Uint8Array=2]="Uint8Array",p[p.Uint8ClampedArray=3]="Uint8ClampedArray",p[p.Int16Array=4]="Int16Array",p[p.Uint16Array=5]="Uint16Array",p[p.Int32Array=6]="Int32Array",p[p.Uint32Array=7]="Uint32Array",p[p.Float32Array=8]="Float32Array",p[p.Float64Array=9]="Float64Array",p[p.BigInt64Array=10]="BigInt64Array",p[p.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(p){p[p.Text=1]="Text",p[p.Error=2]="Error",p[p.Rich=3]="Rich"})(P=e.CellOutputKind||(e.CellOutputKind={}));var F;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(F=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var y;(function(p){p[p.None=0]="None",p[p.Process=1]="Process",p[p.Output=2]="Output"})(y=e.CandidatePortSource||(e.CandidatePortSource={}));class c{static mixin(h){return h._id=c._n++,h}}e.IdObject=c,c._n=0;var E;(function(p){p.label="a",p.kind="b",p.detail="c",p.documentation="d",p.sortText="e",p.filterText="f",p.preselect="g",p.insertText="h",p.insertTextRules="i",p.range="j",p.commitCharacters="k",p.additionalTextEdits="l",p.command="m",p.kindModifier="n"})(E=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var v;(function(p){p.defaultRanges="a",p.completions="b",p.isIncomplete="c",p.duration="d"})(v=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var w;(function(p){p[p.File=1]="File",p[p.Text=2]="Text",p[p.Cell=3]="Cell"})(w=e.WorkspaceEditType||(e.WorkspaceEditType={}));function _(p){if(p&&p.edits)for(const h of p.edits)typeof h.resource=="object"?h.resource=t.URI.revive(h.resource):(h.newUri=t.URI.revive(h.newUri),h.oldUri=t.URI.revive(h.oldUri)),h.metadata&&h.metadata.iconPath&&(h.metadata=(0,d.revive)(h.metadata));return p}e.reviveWorkspaceEditDto=_;var R;(function(p){p[p.Workspace=0]="Workspace",p[p.TextDocument=1]="TextDocument"})(R=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,I.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,I.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,I.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,I.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,I.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,I.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,I.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,I.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,I.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,I.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,I.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,I.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,I.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,I.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,I.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,I.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,I.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,I.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,I.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,I.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createProxyIdentifier)("ExtHostTelemetry")}}),define(pe[90],ve([0,1,5,3,4]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class C{constructor(k){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(d.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,D){return this._proxy.$getPassword(k,D)}store(k,D,P){return this._proxy.$setPassword(k,D,P)}delete(k,D){return this._proxy.$deletePassword(k,D)}}e.ExtHostSecretState=C,e.IExtHostSecretState=(0,I.createDecorator)("IExtHostSecretState")}),define(pe[65],ve([0,1,4,12,5,14]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,d.createDecorator)("IExtHostApiDeprecationService");let T=class{constructor(D,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(I.MainContext.MainThreadTelemetry)}report(D,P,F){const y=this.getUsageKey(D,P);this._reportedUsages.has(y)||(this._reportedUsages.add(y),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${F}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:D}))}getUsageKey(D,P){return`${D}-${P.identifier.value}`}};T=Be([Me(0,C.IExtHostRpcService),Me(1,t.ILogService)],T),e.ExtHostApiDeprecationService=T,e.NullApiDeprecationService=Object.freeze(new class{report(k,D,P){}})}),define(pe[230],ve([0,1,3,5,7,27]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class T{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new d.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}async getSession(D,P,F,y={}){const c=C.ExtensionIdentifier.toKey(D.identifier),E=this._inFlightRequests.get(c)||[],v=[...F].sort().join(" ");let w=E.find(_=>_.scopes===v);if(w)return w.result;{const _=this._getSession(D,c,P,F,y);w={scopes:v,result:_},E.push(w),this._inFlightRequests.set(c,E);try{await _}finally{const R=E.findIndex(p=>p.scopes===v);R>-1&&(E.splice(R),this._inFlightRequests.set(c,E))}return _}}async _getSession(D,P,F,y,c={}){await this._proxy.$ensureProvider(F);const E=D.displayName||D.name;return this._proxy.$getSession(F,y,P,E,c)}async removeSession(D,P){const F=this._authenticationProviders.get(D);return F?F.provider.removeSession(P):this._proxy.$removeSession(D,P)}registerAuthenticationProvider(D,P,F,y){if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:P,provider:F,options:y??{supportsMultipleAccounts:!1}}),this._providers.find(E=>E.id===D)||this._providers.push({id:D,label:P});const c=F.onDidChangeSessions(E=>{this._proxy.$sendDidChangeSessions(D,{added:E.added??[],changed:E.changed??[],removed:E.removed??[]})});return this._proxy.$registerAuthenticationProvider(D,P,y?.supportsMultipleAccounts??!1),new I.Disposable(()=>{c.dispose(),this._authenticationProviders.delete(D);const E=this._providers.findIndex(v=>v.id===D);E>-1&&this._providers.splice(E),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,P){const F=this._authenticationProviders.get(D);if(F)return Promise.resolve(F.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,P){const F=this._authenticationProviders.get(D);if(F)return Promise.resolve(F.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,P){const F=this._authenticationProviders.get(D);if(F)return Promise.resolve(F.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,P){return this._onDidChangeSessions.fire({provider:{id:D,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=T}),define(pe[231],ve([0,1,5,14,15]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let C=class{constructor(k,D){this._extHostDocumentsAndEditors=D,this._proxy=k.getProxy(d.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(k){const D=I.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};C=Be([Me(0,t.IExtHostRpcService)],C),e.ExtHostBulkEdits=C}),define(pe[232],ve([0,1,5]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(C){const T=C.getProxy(d.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(k){return T.$writeText(k)}})}}e.ExtHostClipboard=t});var Qe=this&&this.__classPrivateFieldSet||function(ee,e,d,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,d):I?I.value=d:e.set(ee,d),d},Te=this&&this.__classPrivateFieldGet||function(ee,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(ee):t?t.value:e.get(ee)};define(pe[39],ve([0,1,18,7,15,25,5,17,12,59,41,48,2,6,4,14,63,23,52,49]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c,E,v,w,_,R,p,h){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let u=class{constructor(o,l){s.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,Qe(this,s,o.getProxy(T.MainContext.MainThreadCommands),"f"),this._logService=l,this.converter=new r(this,f=>{const m=this._apiCommands.get(f);return m?.result===a.Void?m:void 0},l),this._argumentProcessors=[{processArgument(f){return(0,P.revive)(f)}},{processArgument(f){return(0,C.cloneAndChange)(f,function(m){if(F.Range.isIRange(m))return I.Range.to(m);if(y.Position.isIPosition(m))return I.Position.to(m);if(F.Range.isIRange(m.range)&&c.URI.isUri(m.uri))return I.location.to(m);if(m instanceof R.VSBuffer)return m.buffer.buffer;if(!Array.isArray(m))return m})}}]}registerArgumentProcessor(o){this._argumentProcessors.push(o)}registerApiCommand(o){const l=this.registerCommand(!1,o.id,async(...f)=>{const m=o.args.map((A,L)=>{if(!A.validate(f[L]))throw new Error(`Invalid argument '${A.name}' when running '${o.id}', received: ${f[L]}`);return A.convert(f[L])}),b=await this.executeCommand(o.internalId,...m);return o.result.convert(b,f,this.converter)},void 0,{description:o.description,args:o.args,returns:o.result.description});return this._apiCommands.set(o.id,o),new t.Disposable(()=>{l.dispose(),this._apiCommands.delete(o.id)})}registerCommand(o,l,f,m,b,A){if(this._logService.trace("ExtHostCommands#registerCommand",l),!l.trim().length)throw new Error("invalid id");if(this._commands.has(l))throw new Error(`command '${l}' already exists`);return this._commands.set(l,{callback:f,thisArg:m,description:b,extension:A}),o&&Te(this,s,"f").$registerCommand(l),new t.Disposable(()=>{this._commands.delete(l)&&o&&Te(this,s,"f").$unregisterCommand(l)})}executeCommand(o,...l){return this._logService.trace("ExtHostCommands#executeCommand",o),this._doExecuteCommand(o,l,!0)}async _doExecuteCommand(o,l,f){if(this._commands.has(o))return this._executeContributedCommand(o,l,!1);{let m=!1;const b=(0,C.cloneAndChange)(l,function(A){if(A instanceof t.Position)return I.Position.from(A);if(A instanceof t.Range)return I.Range.from(A);if(A instanceof t.Location)return I.location.from(A);if(t.NotebookRange.isNotebookRange(A))return I.NotebookRange.from(A);if(A instanceof ArrayBuffer)return m=!0,R.VSBuffer.wrap(new Uint8Array(A));if(A instanceof Uint8Array)return m=!0,R.VSBuffer.wrap(A);if(!Array.isArray(A))return A});try{const A=await Te(this,s,"f").$executeCommand(o,m?new p.SerializableObjectWithBuffers(b):b,f);return(0,P.revive)(A)}catch(A){if(A instanceof Error&&A.message==="$executeCommand:retry")return this._doExecuteCommand(o,l,!1);throw A}}}async _executeContributedCommand(o,l,f){const m=this._commands.get(o);if(!m)throw new Error("Unknown command");let{callback:b,thisArg:A,description:L}=m;if(L)for(let N=0;N<L.args.length;N++)try{(0,d.validateConstraint)(l[N],L.args[N].constraint)}catch{throw new Error(`Running the contributed command: '${o}' failed. Illegal argument '${L.args[N].name}' - ${L.args[N].description}`)}try{return await b.apply(A,l)}catch(N){if(o===this.converter.delegatingCommandId){const g=this.converter.getActualCommand(...l);g&&(o=g.command)}throw this._logService.error(N,o,m.extension?.identifier),f?new class extends Error{constructor(){super((0,h.toErrorMessage)(N));this.id=o,this.source=m.extension?.displayName??m.extension?.name}}:N}}$executeContributedCommand(o,...l){return this._logService.trace("ExtHostCommands#$executeContributedCommand",o),this._commands.has(o)?(l=l.map(f=>this._argumentProcessors.reduce((m,b)=>b.processArgument(m),f)),this._executeContributedCommand(o,l,!0)):Promise.reject(new Error(`Contributed command '${o}' does not exist.`))}getCommands(o=!1){return this._logService.trace("ExtHostCommands#getCommands",o),Te(this,s,"f").$getCommands().then(l=>(o&&(l=l.filter(f=>f[0]!=="_")),l))}$getContributedCommandHandlerDescriptions(){const o=Object.create(null);for(let[l,f]of this._commands){let{description:m}=f;m&&(o[l]=m)}return Promise.resolve(o)}};s=new WeakMap,u=Be([Me(0,w.IExtHostRpcService),Me(1,D.ILogService)],u),e.ExtHostCommands=u,e.IExtHostCommands=(0,v.createDecorator)("IExtHostCommands");class r{constructor(o,l,f){this._commands=o,this._lookupApiCommand=l,this._logService=f,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(o,l){if(!o)return;const f={$ident:void 0,id:o.command,title:o.title,tooltip:o.tooltip};if(!o.command)return f;const m=this._lookupApiCommand(o.command);if(m)f.id=m.internalId,f.arguments=m.args.map((b,A)=>b.convert(o.arguments&&o.arguments[A]));else if((0,k.isNonEmptyArray)(o.arguments)){const b=++this._cachIdPool;this._cache.set(b,o),l.add((0,E.toDisposable)(()=>{this._cache.delete(b),this._logService.trace("CommandsConverter#DISPOSE",b)})),f.$ident=b,f.id=this.delegatingCommandId,f.arguments=[b],this._logService.trace("CommandsConverter#CREATE",o.command,b)}return f}fromInternal(o){return typeof o.$ident=="number"?this._cache.get(o.$ident):{command:o.id,title:o.title,arguments:o.arguments}}getActualCommand(...o){return this._cache.get(o[0])}_executeConvertedCommand(...o){const l=this.getActualCommand(...o);return this._logService.trace("CommandsConverter#EXECUTE",o[0],l?l.command:"MISSING"),l?this._commands.executeCommand(l.command,...l.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=r;class S{constructor(o,l,f,m){this.name=o,this.description=l,this.validate=f,this.convert=m}optional(){return new S(this.name,`(optional) ${this.description}`,o=>o==null||this.validate(o),o=>o===void 0?void 0:o===null?null:this.convert(o))}with(o,l){return new S(o??this.name,l??this.description,this.validate,this.convert)}}e.ApiCommandArgument=S,S.Uri=new S("uri","Uri of a text document",n=>c.URI.isUri(n),n=>n),S.Position=new S("position","A position in a text document",n=>t.Position.isPosition(n),I.Position.from),S.Range=new S("range","A range in a text document",n=>t.Range.isRange(n),I.Range.from),S.Selection=new S("selection","A selection in a text document",n=>t.Selection.isSelection(n),I.Selection.from),S.Number=new S("number","",n=>typeof n=="number",n=>n),S.String=new S("string","",n=>typeof n=="string",n=>n),S.CallHierarchyItem=new S("item","A call hierarchy item",n=>n instanceof t.CallHierarchyItem,I.CallHierarchyItem.from),S.TypeHierarchyItem=new S("item","A type hierarchy item",n=>n instanceof t.TypeHierarchyItem,I.TypeHierarchyItem.from),S.TestItem=new S("testItem","A VS Code TestItem",n=>n instanceof _.TestItemImpl,I.TestItem.from);class a{constructor(o,l){this.description=o,this.convert=l}}e.ApiCommandResult=a,a.Void=new a("no result",n=>n);class i{constructor(o,l,f,m,b){this.id=o,this.internalId=l,this.description=f,this.args=m,this.result=b}}e.ApiCommand=i}),define(pe[233],ve([0,1,15,7,82,39,17,112]),function(ee,e,d,t,I,C,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const D=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",F(d.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,E)=>{if((0,T.isFalsyOrEmpty)(c))return;class v extends t.SymbolInformation{static to(_){const R=new v(_.name,d.SymbolKind.to(_.kind),_.containerName||"",new t.Location(E[0],d.Range.to(_.range)));return R.detail=_.detail,R.range=R.location.range,R.selectionRange=d.Range.to(_.selectionRange),R.children=_.children?_.children.map(v.to):[],R}}return c.map(v.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",F(d.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",F(d.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",c=>typeof c=="string",c=>c),new C.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",F(d.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",F(d.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",F(d.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",c=>Array.isArray(c)&&c.every(E=>t.Position.isPosition(E)),c=>c.map(d.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",c=>c.map(E=>{let v;for(const w of E.reverse())v=new t.SelectionRange(d.Range.to(w),v);return v}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",c=>c.map(d.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(d.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(d.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(d.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",c=>{if(!!c)return{range:d.Range.to(c.range),placeholder:c.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",c=>{if(!!c){if(c.rejectReason)throw new Error(c.rejectReason);return d.WorkspaceEdit.to(c)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(d.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new t.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const E=(0,k.decodeSemanticTokensDto)(c);if(E.type==="full")return new t.SemanticTokens(E.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new t.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const E=(0,k.decodeSemanticTokensDto)(c);if(E.type==="full")return new t.SemanticTokens(E.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(c,E,v)=>{if(!c)return new t.CompletionList([]);const w=c.suggestions.map(_=>d.CompletionItem.to(_,v));return new t.CompletionList(w,c.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",c=>{if(c)return d.SignatureHelp.to(c)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(c,E,v)=>F(w=>new t.CodeLens(d.Range.to(w.range),w.command&&v.fromInternal(w.command)))(c))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>t.Range.isRange(c),c=>t.Selection.isSelection(c)?d.Selection.from(c):d.Range.from(c)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(c,E,v)=>F(w=>{if(w._isSynthetic){if(!w.command)throw new Error("Synthetic code actions must have a command");return v.fromInternal(w.command)}else{const _=new t.CodeAction(w.title,w.kind?new t.CodeActionKind(w.kind):void 0);return w.edit&&(_.edit=d.WorkspaceEdit.to(w.edit)),w.command&&(_.command=v.fromInternal(w.command)),_.isPreferred=w.isPreferred,_}})(c))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(E=>new t.ColorInformation(d.Range.to(E.range),d.Color.to(E.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",c=>c instanceof t.Color,d.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:d.Range.from(c.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(d.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",(c,E,v)=>c.map(d.InlayHint.to.bind(void 0,v)))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",F(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(E=>d.NotebookExclusiveDocumentPattern.to(E))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",c=>c.map(d.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[d.ViewColumn.from(c),void 0]:[d.ViewColumn.from(c.viewColumn),d.TextEditorOpenOptions.from(c)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[d.ViewColumn.from(c),void 0]:[d.ViewColumn.from(c.viewColumn),d.TextEditorOpenOptions.from(c)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[d.ViewColumn.from(c.viewColumn),d.TextEditorOpenOptions.from(c)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(d.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(d.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(d.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void)];class P{static register(E){D.forEach(E.registerApiCommand,E)}}e.ExtHostApiCommands=P;function F(c){return E=>{if(Array.isArray(E))return E.map(c)}}function y(c){if(!Array.isArray(c))return;const E=[];for(const v of c)I.isLocationLink(v)?E.push(d.DefinitionLink.to(v)):E.push(d.location.to(v));return E}}),define(pe[234],ve([0,1,13,56,3,6,2,82,27,15,7,30,5]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function E(v,w,_){const R=v.getProxy(c.MainContext.MainThreadComments);class p{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,w.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const o=this._commentControllers.get(n.handle);return o||n}else if(n&&n.$mid===7){const o=this._commentControllers.get(n.commentControlHandle);if(!o)return n;const l=o.getCommentThread(n.commentThreadHandle);return l||n}else if(n&&n.$mid===8){const o=this._commentControllers.get(n.thread.commentControlHandle);if(!o)return n;const l=o.getCommentThread(n.thread.commentThreadHandle);return l?{thread:l,text:n.text}:n}else if(n&&n.$mid===9){const o=this._commentControllers.get(n.thread.commentControlHandle);if(!o)return n;const l=o.getCommentThread(n.thread.commentThreadHandle);if(!l)return n;let f=n.commentUniqueId,m=l.getCommentByUniqueId(f);return m||n}else if(n&&n.$mid===10){const o=this._commentControllers.get(n.thread.commentControlHandle);if(!o)return n;const l=o.getCommentThread(n.thread.commentThreadHandle);if(!l)return n;let f=n.text,m=n.commentUniqueId,b=l.getCommentByUniqueId(m);return b?(b.body=f,b):n}return n}})}createCommentController(n,o,l){const f=p.handlePool++,m=new s(n,f,o,l);this._commentControllers.set(m.handle,m);const b=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(n.identifier))||[];return b.push(m),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(n.identifier),b),m.value}$createCommentThreadTemplate(n,o,l){const f=this._commentControllers.get(n);!f||f.$createCommentThreadTemplate(o,l)}async $updateCommentThreadTemplate(n,o,l){const f=this._commentControllers.get(n);!f||f.$updateCommentThreadTemplate(o,l)}$deleteCommentThread(n,o){const l=this._commentControllers.get(n);l&&l.$deleteCommentThread(o)}$provideCommentingRanges(n,o,l){const f=this._commentControllers.get(n);if(!f||!f.commentingRangeProvider)return Promise.resolve(void 0);const m=_.getDocument(T.URI.revive(o));return(0,d.asPromise)(()=>f.commentingRangeProvider.provideCommentingRanges(m,l)).then(b=>b?b.map(A=>P.Range.from(A)):void 0)}$toggleReaction(n,o,l,f,m){const b=this._commentControllers.get(n);return!b||!b.reactionHandler?Promise.resolve(void 0):(0,d.asPromise)(()=>{const A=b.getCommentThread(o);if(A){const L=A.getCommentByUniqueId(f.uniqueIdInThread);if(b!==void 0&&L&&b.reactionHandler)return b.reactionHandler(L,S(m))}return Promise.resolve(void 0)})}dispose(){}}p.handlePool=0;class h{constructor(n,o,l,f,m,b,A){this._commentControllerHandle=o,this._id=l,this._uri=f,this._range=m,this._comments=b,this.extensionDescription=A,this.handle=h._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new I.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputDisposables.value=new C.DisposableStore,this._id===void 0&&(this._id=`${n}.${this.handle}`),R.$createCommentThread(o,this.handle,this._id,this._uri,P.Range.from(this._range),A.identifier),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=b,this._localDisposables.push({dispose:()=>{R.$deleteCommentThread(o,this.handle)}});const L=this;this.value={get uri(){return L.uri},get range(){return L.range},set range(N){L.range=N},get comments(){return L.comments},set comments(N){L.comments=N},get collapsibleState(){return L.collapsibleState},set collapsibleState(N){L.collapsibleState=N},get canReply(){return L.canReply},set canReply(N){L.canReply=N},get contextValue(){return L.contextValue},set contextValue(N){L.contextValue=N},get label(){return L.label},set label(N){L.label=N},dispose:()=>{L.dispose()}}}set threadId(n){this._id=n}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(n){n.isEqual(this._range)||(this._range=n,this.modifications.range=n,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(n){this._canReply!==n&&(this._canReply=n,this.modifications.canReply=n,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(n){this._label=n,this.modifications.label=n,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(n){this._contextValue=n,this.modifications.contextValue=n,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(n){this._comments=n,this.modifications.comments=n,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(n){this._collapseState=n,this.modifications.collapsibleState=n,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new C.DisposableStore);const n=l=>Object.prototype.hasOwnProperty.call(this.modifications,l),o={};n("range")&&(o.range=P.Range.from(this._range)),n("label")&&(o.label=this.label),n("contextValue")&&(o.contextValue=this.contextValue??null),n("comments")&&(o.comments=this._comments.map(l=>u(this,l,this._commentsMap))),n("collapsibleState")&&(o.collapseState=a(this._collapseState)),n("canReply")&&(o.canReply=this.canReply),this.modifications={},R.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,o)}getCommentByUniqueId(n){for(let o of this._commentsMap){let l=o[0],f=o[1];if(n===f)return l}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(n=>n.dispose())}}h._handlePool=0,Be([(0,t.debounce)(100)],h.prototype,"eventuallyUpdateCommentThread",null);class s{constructor(n,o,l,f){this._extension=n,this._handle=o,this._id=l,this._label=f,this._threads=new Map,R.$registerCommentController(this.handle,l,f);const m=this;this.value=Object.freeze({id:m.id,label:m.label,get options(){return m.options},set options(b){m.options=b},get commentingRangeProvider(){return m.commentingRangeProvider},set commentingRangeProvider(b){m.commentingRangeProvider=b},get reactionHandler(){return m.reactionHandler},set reactionHandler(b){m.reactionHandler=b},createCommentThread(b,A,L){return m.createCommentThread(b,A,L).value},dispose:()=>{m.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{R.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(n){this._commentingRangeProvider=n,R.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(n){this._reactionHandler=n,R.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!n})}get options(){return this._options}set options(n){this._options=n,R.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(n,o,l,f){if(typeof n=="string"){const m=new h(this.id,this.handle,n,o,l,f,this._extension);return this._threads.set(m.handle,m),m}else{const m=new h(this.id,this.handle,void 0,n,o,l,this._extension);return this._threads.set(m.handle,m),m}}$createCommentThreadTemplate(n,o){const l=new h(this.id,this.handle,void 0,T.URI.revive(n),P.Range.to(o),[],this._extension);return l.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(l.handle,l),l}$updateCommentThreadTemplate(n,o){let l=this._threads.get(n);l&&(l.range=P.Range.to(o))}$deleteCommentThread(n){let o=this._threads.get(n);o&&o.dispose(),this._threads.delete(n)}getCommentThread(n){return this._threads.get(n)}dispose(){this._threads.forEach(n=>{n.dispose()}),this._localDisposables.forEach(n=>n.dispose())}}function u(i,n,o){let l=o.get(n);l||(l=++i.commentHandle,o.set(n,l));const f=n.author&&n.author.iconPath?n.author.iconPath.toString():void 0;n.timestamp&&(0,y.checkProposedApiEnabled)(i.extensionDescription,"commentTimestamp");let m;return n.timestamp&&(m={source:n.timestamp,$mid:14}),{mode:n.mode,contextValue:n.contextValue,uniqueIdInThread:l,body:typeof n.body=="string"?n.body:P.MarkdownString.from(n.body),userName:n.author.name,userIconPath:f,label:n.label,commentReactions:n.reactions?n.reactions.map(b=>r(b)):void 0,timestamp:m}}function r(i){return{label:i.label,iconPath:i.iconPath?P.pathOrURIToURI(i.iconPath):void 0,count:i.count,hasReacted:i.authorHasReacted}}function S(i){return{label:i.label||"",count:i.count||0,iconPath:i.iconPath?T.URI.revive(i.iconPath):"",authorHasReacted:i.hasReacted||!1}}function a(i){if(i!==void 0)switch(i){case F.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case F.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}return new p}e.createExtHostComments=E}),define(pe[132],ve([0,1,2,5,7,4,14,12,17,8,9]),function(ee,e,d,t,I,C,T,k,D,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let y=class yi{constructor(E,v){this._logService=v,this._provider=new Map,this._proxy=E.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(E,v){const w=yi._handlePool++;this._provider.set(w,{provider:E,extensionId:v}),this._proxy.$registerDecorationProvider(w,v.value);const _=E.onDidChangeFileDecorations&&E.onDidChangeFileDecorations(R=>{if(!R){this._proxy.$onDidChange(w,null);return}let p=(0,D.asArray)(R);if(p.length<=yi._maxEventSize){this._proxy.$onDidChange(w,p);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",v.value,p.length);const h=p.map(r=>({uri:r,rank:(0,P.count)(r.path,"/")})),s=(0,D.groupBy)(h,(r,S)=>r.rank-S.rank||(0,P.compare)(r.uri.path,S.uri.path));let u=[];e:for(let r of s){let S;for(let a of r){let i=(0,F.dirname)(a.uri.path);if(S!==i&&(S=i,u.push(a.uri)>=yi._maxEventSize))break e}}this._proxy.$onDidChange(w,u)});return new I.Disposable(()=>{_?.dispose(),this._proxy.$unregisterDecorationProvider(w),this._provider.delete(w)})}async $provideDecorations(E,v,w){if(!this._provider.has(E))return Object.create(null);const _=Object.create(null),{provider:R,extensionId:p}=this._provider.get(E);return await Promise.all(v.map(async h=>{try{const{uri:s,id:u}=h,r=await Promise.resolve(R.provideFileDecoration(d.URI.revive(s),w));if(!r)return;try{I.FileDecoration.validate(r),_[u]=[r.propagate,r.tooltip,r.badge,r.color]}catch(S){this._logService.warn(`INVALID decoration from extension '${p.value}': ${S}`)}}catch(s){this._logService.error(s)}})),_}};y._handlePool=0,y._maxEventSize=250,y=Be([Me(0,T.IExtHostRpcService),Me(1,k.ILogService)],y),e.ExtHostDecorations=y,e.IExtHostDecorations=(0,C.createDecorator)("IExtHostDecorations")});var Qe=this&&this.__classPrivateFieldSet||function(ee,e,d,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,d):I?I.value=d:e.set(ee,d),d},Te=this&&this.__classPrivateFieldGet||function(ee,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(ee):t?t.value:e.get(ee)};define(pe[235],ve([0,1,167,117,2,5,7,15,3,12,24,44]),function(ee,e,d,t,I,C,T,k,D,P,F,y){"use strict";var c,E,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class w{constructor(p,h,s,u,r,S){this._name=p,this._owner=h,this._maxDiagnosticsPerFile=s,c.set(this,void 0),E.set(this,void 0),v.set(this,void 0),this._isDisposed=!1,Qe(this,v,new F.ResourceMap(a=>u.getComparisonKey(a)),"f"),Qe(this,c,r,"f"),Qe(this,E,S,"f")}dispose(){this._isDisposed||(Te(this,E,"f").fire([...Te(this,v,"f").keys()]),Te(this,c,"f")&&Te(this,c,"f").$clear(this._owner),Te(this,v,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(p,h){if(!p){this.clear();return}this._checkDisposed();let s=[];if(I.URI.isUri(p)){if(!h){this.delete(p);return}Te(this,v,"f").set(p,h.slice()),s=[p]}else if(Array.isArray(p)){s=[];let r;p=[...p].sort(w._compareIndexedTuplesByUri);for(const S of p){const[a,i]=S;if((!r||a.toString()!==r.toString())&&(r&&Te(this,v,"f").get(r).length===0&&Te(this,v,"f").delete(r),r=a,s.push(a),Te(this,v,"f").set(a,[])),i){const n=Te(this,v,"f").get(a);n&&n.push(...i)}else{const n=Te(this,v,"f").get(a);n&&(n.length=0)}}}if(Te(this,E,"f").fire(s),!Te(this,c,"f"))return;const u=[];for(let r of s){let S=[];const a=Te(this,v,"f").get(r);if(a)if(a.length>this._maxDiagnosticsPerFile){S=[];const i=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let n=0;n<4;n++)for(let o of a)if(o.severity===i[n]&&S.push(k.Diagnostic.from(o))===this._maxDiagnosticsPerFile)break e;S.push({severity:t.MarkerSeverity.Info,message:(0,d.localize)(0,null,a.length-this._maxDiagnosticsPerFile),startLineNumber:S[S.length-1].startLineNumber,startColumn:S[S.length-1].startColumn,endLineNumber:S[S.length-1].endLineNumber,endColumn:S[S.length-1].endColumn})}else S=a.map(i=>k.Diagnostic.from(i));u.push([r,S])}Te(this,c,"f").$changeMany(this._owner,u)}delete(p){this._checkDisposed(),Te(this,E,"f").fire([p]),Te(this,v,"f").delete(p),Te(this,c,"f")&&Te(this,c,"f").$changeMany(this._owner,[[p,void 0]])}clear(){this._checkDisposed(),Te(this,E,"f").fire([...Te(this,v,"f").keys()]),Te(this,v,"f").clear(),Te(this,c,"f")&&Te(this,c,"f").$clear(this._owner)}forEach(p,h){this._checkDisposed();for(let s of Te(this,v,"f").keys())p.apply(h,[s,this.get(s),this])}get(p){this._checkDisposed();const h=Te(this,v,"f").get(p);return Array.isArray(h)?Object.freeze(h.slice(0)):[]}has(p){return this._checkDisposed(),Array.isArray(Te(this,v,"f").get(p))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(p,h){return p[0].toString()<h[0].toString()?-1:p[0].toString()>h[0].toString()?1:0}}e.DiagnosticCollection=w,c=new WeakMap,E=new WeakMap,v=new WeakMap;let _=class oi{constructor(p,h,s){this._logService=h,this._fileSystemInfoService=s,this._collections=new Map,this._onDidChangeDiagnostics=new D.DebounceEmitter({merge:u=>u.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this._onDidChangeDiagnostics.event,oi._mapper),this._proxy=p.getProxy(C.MainContext.MainThreadDiagnostics)}static _mapper(p){const h=new F.ResourceMap;for(const s of p)h.set(s,s);return{uris:Object.freeze(Array.from(h.values()))}}createDiagnosticCollection(p,h){const{_collections:s,_proxy:u,_onDidChangeDiagnostics:r,_logService:S,_fileSystemInfoService:a}=this,i=new class{$changeMany(l,f){u.$changeMany(l,f),S.trace("[DiagnosticCollection] change many (extension, owner, uris)",p.value,l,f.length===0?"CLEARING":f)}$clear(l){u.$clear(l),S.trace("[DiagnosticCollection] remove all (extension, owner)",p.value,l)}dispose(){u.dispose()}};let n;if(!h)h="_generated_diagnostic_collection_name_#"+oi._idPool++,n=h;else if(!s.has(h))n=h;else{this._logService.warn(`DiagnosticCollection with name '${h}' does already exist.`);do n=h+oi._idPool++;while(s.has(n))}return new class extends w{constructor(){super(h,n,oi._maxDiagnosticsPerFile,a.extUri,i,r);s.set(n,this)}dispose(){super.dispose(),s.delete(n)}}}getDiagnostics(p){if(p)return this._getDiagnostics(p);{const h=new Map,s=[];for(const u of this._collections.values())u.forEach((r,S)=>{let a=h.get(r.toString());typeof a=="undefined"&&(a=s.length,h.set(r.toString(),a),s.push([r,[]])),s[a][1]=s[a][1].concat(...S)});return s}}_getDiagnostics(p){let h=[];for(let s of this._collections.values())s.has(p)&&(h=h.concat(s.get(p)));return h}$acceptMarkersChange(p){if(!this._mirrorCollection){const h="_generated_mirror",s=new w(h,h,oi._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(h,s),this._mirrorCollection=s}for(const[h,s]of p)this._mirrorCollection.set(I.URI.revive(h),s.map(k.Diagnostic.to))}};_._idPool=0,_._maxDiagnosticsPerFile=1e3,_=Be([Me(1,P.ILogService),Me(2,y.IExtHostFileSystemInfo)],_),e.ExtHostDiagnostics=_}),define(pe[236],ve([0,1,2,5]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class I{constructor(T){this._proxy=T.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(T){return this._proxy.$showOpenDialog(T).then(k=>k?k.map(D=>d.URI.revive(D)):void 0)}showSaveDialog(T){return this._proxy.$showSaveDialog(T).then(k=>k?d.URI.revive(k):void 0)}}e.ExtHostDialogs=I}),define(pe[237],ve([0,1,16,2,7,5,10,21,8]),function(ee,e,d,t,I,C,T,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(y,c,E){this._documentsAndEditors=c,this._logService=E,this._documentContentProviders=new Map,this._proxy=y.getProxy(C.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,c){if(Object.keys(T.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const E=P._handlePool++;this._documentContentProviders.set(E,c),this._proxy.$registerTextContentProvider(E,y);let v;return typeof c.onDidChange=="function"&&(v=c.onDidChange(w=>{if(w.scheme!==y){this._logService.warn(`Provider for scheme '${y}' is firing event for schema '${w.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(w)&&this.$provideTextDocumentContent(E,w).then(_=>{if(!_&&typeof _!="string")return;const R=this._documentsAndEditors.getDocument(w);if(!R)return;const p=(0,D.splitLines)(_);if(!R.equalLines(p))return this._proxy.$onVirtualDocumentChange(w,_)},d.onUnexpectedError)})),new I.Disposable(()=>{this._documentContentProviders.delete(E)&&this._proxy.$unregisterTextContentProvider(E),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(y,c){const E=this._documentContentProviders.get(y);return E?Promise.resolve(E.provideTextDocumentContent(t.URI.revive(c),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(pe[238],ve([0,1,3,6,2,5,124,15,18,25,7]),function(ee,e,d,t,I,C,T,k,D,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class y{constructor(E,v){this._onDidAddDocument=new d.Emitter,this._onDidRemoveDocument=new d.Emitter,this._onDidChangeDocument=new d.Emitter,this._onDidSaveDocument=new d.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=E.getProxy(C.MainContext.MainThreadDocuments),this._documentsAndEditors=v,this._documentsAndEditors.onDidRemoveDocuments(w=>{for(const _ of w)this._onDidRemoveDocument.fire(_.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(w=>{for(const _ of w)this._onDidAddDocument.fire(_.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(E){if(!E)return;const v=this._documentsAndEditors.getDocument(E);if(v)return v}getDocument(E){const v=this.getDocumentData(E);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return v.document}ensureDocumentData(E){const v=this._documentsAndEditors.getDocument(E);if(v)return Promise.resolve(v);let w=this._documentLoader.get(E.toString());return w||(w=this._proxy.$tryOpenDocument(E).then(_=>{this._documentLoader.delete(E.toString());const R=I.URI.revive(_);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(R))},_=>(this._documentLoader.delete(E.toString()),Promise.reject(_))),this._documentLoader.set(E.toString(),w)),w}createDocumentData(E){return this._proxy.$tryCreateDocument(E).then(v=>I.URI.revive(v))}$acceptModelLanguageChanged(E,v){const w=I.URI.revive(E),_=this._documentsAndEditors.getDocument(w);if(!_)throw new Error("unknown document");this._onDidRemoveDocument.fire(_.document),_._acceptLanguageId(v),this._onDidAddDocument.fire(_.document)}$acceptModelSaved(E){const v=I.URI.revive(E),w=this._documentsAndEditors.getDocument(v);if(!w)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this._onDidSaveDocument.fire(w.document)}$acceptDirtyStateChanged(E,v){const w=I.URI.revive(E),_=this._documentsAndEditors.getDocument(w);if(!_)throw new Error("unknown document");_._acceptIsDirty(v),this._onDidChangeDocument.fire({document:_.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,v,w){const _=I.URI.revive(E),R=this._documentsAndEditors.getDocument(_);if(!R)throw new Error("unknown document");R._acceptIsDirty(w),R.onEvents(v);let p;v.isUndoing?p=F.TextDocumentChangeReason.Undo:v.isRedoing&&(p=F.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:R.document,contentChanges:v.changes.map(h=>({range:k.Range.to(h.range),rangeOffset:h.rangeOffset,rangeLength:h.rangeLength,text:h.text})),reason:p}))}setWordDefinitionFor(E,v){(0,T.setWordDefinitionFor)(E,v)}}e.ExtHostDocuments=y}),define(pe[45],ve([0,1,55,3,6,2,4,5,124,14,131,15,12,24,10,77,93]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c,E,v,w,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class R{constructor(s){this.value=s,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let p=class{constructor(s,u){this._extHostRpc=s,this._logService=u,this._activeEditorId=null,this._editors=new Map,this._documents=new E.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(s){this.acceptDocumentsAndEditorsDelta(s)}acceptDocumentsAndEditorsDelta(s){const u=[],r=[],S=[];if(s.removedDocuments)for(const a of s.removedDocuments){const i=C.URI.revive(a),n=this._documents.get(i);n?.unref()&&(this._documents.delete(i),u.push(n.value))}if(s.addedDocuments)for(const a of s.addedDocuments){const i=C.URI.revive(a.uri);let n=this._documents.get(i);if(n&&i.scheme!==v.Schemas.vscodeNotebookCell&&i.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);n||(n=new R(new D.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),i,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty,a.notebook)),this._documents.set(i,n),r.push(n.value)),n.ref()}if(s.removedEditors)for(const a of s.removedEditors){const i=this._editors.get(a);this._editors.delete(a),i&&S.push(i)}if(s.addedEditors)for(const a of s.addedEditors){const i=C.URI.revive(a.documentUri);d.ok(this._documents.has(i),`document '${i}' does not exist`),d.ok(!this._editors.has(a.id),`editor '${a.id}' already exists!`);const n=this._documents.get(i).value,o=new F.ExtHostTextEditor(a.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new _.Lazy(()=>n.document),a.selections.map(y.Selection.to),a.options,a.visibleRanges.map(l=>y.Range.to(l)),typeof a.editorPosition=="number"?y.ViewColumn.to(a.editorPosition):void 0);this._editors.set(a.id,o)}s.newActiveEditor!==void 0&&(d.ok(s.newActiveEditor===null||this._editors.has(s.newActiveEditor),`active editor '${s.newActiveEditor}' does not exist`),this._activeEditorId=s.newActiveEditor),(0,I.dispose)(u),(0,I.dispose)(S),s.removedDocuments&&this._onDidRemoveDocuments.fire(u),s.addedDocuments&&this._onDidAddDocuments.fire(r),(s.removedEditors||s.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(a=>a.value)),s.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(s){return this._documents.get(s)?.value}allDocuments(){return w.Iterable.map(this._documents.values(),s=>s.value)}getEditor(s){return this._editors.get(s)}activeEditor(s){if(!this._activeEditorId)return;const u=this._editors.get(this._activeEditorId);return s?u:u?.value}allEditors(){return[...this._editors.values()]}};p=Be([Me(0,P.IExtHostRpcService),Me(1,c.ILogService)],p),e.ExtHostDocumentsAndEditors=p,e.IExtHostDocumentsAndEditors=(0,T.createDecorator)("IExtHostDocumentsAndEditors")}),define(pe[53],ve([0,1,15,5,2,3,4,14,13]),function(ee,e,d,t,I,C,T,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,T.createDecorator)("IExtHostEditorTabs");let P=class{constructor(y){this._onDidChangeTabs=new C.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new C.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=y.getProxy(t.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(y){let c=-1;this._tabs=y.map((v,w)=>(v.isActive&&(c=w),Object.freeze({label:v.label,viewColumn:d.ViewColumn.to(v.viewColumn),index:w,resource:I.URI.revive(v.resource),additionalResourcesAndViewIds:v.additionalResourcesAndViewIds.map(({resource:_,viewId:R})=>({resource:I.URI.revive(_),viewId:R})),viewId:v.editorId,isActive:v.isActive,move:async(_,R)=>{this._proxy.$moveTab(v,_,d.ViewColumn.from(R)),await(0,D.raceTimeout)(C.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(v),await(0,D.raceTimeout)(C.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((v,w)=>v.viewColumn===w.viewColumn?v.index-w.index:v.viewColumn-w.viewColumn);const E=this._activeTab;this._activeTab=c===-1?void 0:this._tabs[c],this._activeTab!==E&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};P=Be([Me(0,k.IExtHostRpcService)],P),e.ExtHostEditorTabs=P}),define(pe[239],ve([0,1,2,5,6,7,15,150,8,23,30]),function(ee,e,d,t,I,C,T,k,D,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class y{constructor(){this._schemes=[]}add(v){this._stateMachine=void 0,this._schemes.push(v)}delete(v){const w=this._schemes.indexOf(v);w>=0&&(this._schemes.splice(w,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const v=this._schemes.sort(),w=[];let _,R,p=14,h=14;for(const s of v){let u=_?(0,D.commonPrefixLength)(_,s):0;for(u===0?R=1:R=h;u<s.length;u++)u+1===s.length?(p=h,h=9):h+=1,w.push([R,s.toUpperCase().charCodeAt(u),h]),w.push([R,s.toLowerCase().charCodeAt(u),h]),R=h;_=s,h=p}w.push([9,58,10]),w.push([10,47,12]),this._stateMachine=new k.StateMachine(w)}}provideDocumentLinks(v){this._initStateMachine();const w=[],_=k.LinkComputer.computeLinks({getLineContent(R){return v.lineAt(R-1).text},getLineCount(){return v.lineCount}},this._stateMachine);for(const R of _){const p=T.DocumentLink.to(R);p.target&&w.push(p)}return w}}class c{constructor(v,w){this._extHostLanguageFeatures=w,this._linkProvider=new y,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=v.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(v,w,_,R={}){if(this._registeredSchemes.has(w))throw new Error(`a provider for the scheme '${w}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(v,"*",this._linkProvider));const p=this._handlePool++;this._linkProvider.add(w),this._registeredSchemes.add(w),this._fsProvider.set(p,_);let h=2;R.isCaseSensitive&&(h+=1024),R.isReadonly&&(h+=2048),typeof _.copy=="function"&&(h+=8),typeof _.open=="function"&&typeof _.close=="function"&&typeof _.read=="function"&&typeof _.write=="function"&&((0,F.checkProposedApiEnabled)(v,"fsChunks"),h+=4),this._proxy.$registerFileSystemProvider(p,w,h).catch(u=>{console.error(`FAILED to register filesystem provider of ${v.identifier.value}-extension for the scheme ${w}`),console.error(u)});const s=_.onDidChangeFile(u=>{const r=[];for(const S of u){let{uri:a,type:i}=S;if(a.scheme!==w)continue;let n;switch(i){case C.FileChangeType.Changed:n=0;break;case C.FileChangeType.Created:n=1;break;case C.FileChangeType.Deleted:n=2;break;default:throw new Error("Unknown FileChangeType")}r.push({resource:a,type:n})}this._proxy.$onFileSystemChange(p,r)});return(0,I.toDisposable)(()=>{s.dispose(),this._linkProvider.delete(w),this._registeredSchemes.delete(w),this._fsProvider.delete(p),this._proxy.$unregisterProvider(p)})}static _asIStat(v){const{type:w,ctime:_,mtime:R,size:p,permissions:h}=v;return{type:w,ctime:_,mtime:R,size:p,permissions:h}}$stat(v,w){return Promise.resolve(this._getFsProvider(v).stat(d.URI.revive(w))).then(_=>c._asIStat(_))}$readdir(v,w){return Promise.resolve(this._getFsProvider(v).readDirectory(d.URI.revive(w)))}$readFile(v,w){return Promise.resolve(this._getFsProvider(v).readFile(d.URI.revive(w))).then(_=>P.VSBuffer.wrap(_))}$writeFile(v,w,_,R){return Promise.resolve(this._getFsProvider(v).writeFile(d.URI.revive(w),_.buffer,R))}$delete(v,w,_){return Promise.resolve(this._getFsProvider(v).delete(d.URI.revive(w),_))}$rename(v,w,_,R){return Promise.resolve(this._getFsProvider(v).rename(d.URI.revive(w),d.URI.revive(_),R))}$copy(v,w,_,R){const p=this._getFsProvider(v);if(!p.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(p.copy(d.URI.revive(w),d.URI.revive(_),R))}$mkdir(v,w){return Promise.resolve(this._getFsProvider(v).createDirectory(d.URI.revive(w)))}$watch(v,w,_,R){const p=this._getFsProvider(v).watch(d.URI.revive(_),R);this._watches.set(w,p)}$unwatch(v,w){const _=this._watches.get(w);_&&(_.dispose(),this._watches.delete(w))}$open(v,w,_){const R=this._getFsProvider(v);if(!R.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(R.open(d.URI.revive(w),_))}$close(v,w){const _=this._getFsProvider(v);if(!_.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(_.close(w))}$read(v,w,_,R){const p=this._getFsProvider(v);if(!p.read)throw new Error('FileSystemProvider does not implement "read"');const h=P.VSBuffer.alloc(R);return Promise.resolve(p.read(w,_,h.buffer,0,R)).then(s=>h.slice(0,s))}$write(v,w,_,R){const p=this._getFsProvider(v);if(!p.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(p.write(w,_,R.buffer,0,R.byteLength))}_getFsProvider(v){const w=this._fsProvider.get(v);if(!w){const _=new Error;throw _.name="ENOPRO",_.message="no provider",_}return w}}e.ExtHostFileSystem=c}),define(pe[66],ve([0,1,5,42,7,23,4,14,44,6]),function(ee,e,d,t,I,C,T,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let F=class jt{constructor(c,E){this._fileSystemProvider=new Map,this._proxy=c.getProxy(d.MainContext.MainThreadFileSystem);const v=this;this.value=Object.freeze({async stat(w){try{const _=v._fileSystemProvider.get(w.scheme);if(!_)return await v._proxy.$stat(w);await v._proxy.$ensureActivation(w.scheme);const R=await _.stat(w);return{type:R.type,ctime:R.ctime,mtime:R.mtime,size:R.size,permissions:R.permissions}}catch(_){jt._handleError(_)}},async readDirectory(w){try{const _=v._fileSystemProvider.get(w.scheme);return _?(await v._proxy.$ensureActivation(w.scheme),(await _.readDirectory(w)).slice()):await v._proxy.$readdir(w)}catch(_){return jt._handleError(_)}},async createDirectory(w){try{return await v._proxy.$mkdir(w)}catch(_){return jt._handleError(_)}},async readFile(w){try{const _=v._fileSystemProvider.get(w.scheme);return _?(await v._proxy.$ensureActivation(w.scheme),(await _.readFile(w)).slice()):(await v._proxy.$readFile(w)).buffer}catch(_){return jt._handleError(_)}},async writeFile(w,_){try{return await v._proxy.$writeFile(w,C.VSBuffer.wrap(_))}catch(R){return jt._handleError(R)}},async delete(w,_){try{const R=v._fileSystemProvider.get(w.scheme);return R?(await v._proxy.$ensureActivation(w.scheme),await R.delete(w,{recursive:!1,..._})):await v._proxy.$delete(w,{recursive:!1,useTrash:!1,..._})}catch(R){return jt._handleError(R)}},async rename(w,_,R){try{return await v._proxy.$rename(w,_,{overwrite:!1,...R})}catch(p){return jt._handleError(p)}},async copy(w,_,R){try{return await v._proxy.$copy(w,_,{overwrite:!1,...R})}catch(p){return jt._handleError(p)}},isWritableFileSystem(w){const _=E.getCapabilities(w);if(typeof _=="number")return!(_&2048)}})}static _handleError(c){if(c instanceof I.FileSystemError)throw c;if(!(c instanceof Error))throw new I.FileSystemError(String(c));if(c.name==="ENOPRO")throw I.FileSystemError.Unavailable(c.message);switch(c.name){case t.FileSystemProviderErrorCode.FileExists:throw I.FileSystemError.FileExists(c.message);case t.FileSystemProviderErrorCode.FileNotFound:throw I.FileSystemError.FileNotFound(c.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw I.FileSystemError.FileNotADirectory(c.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw I.FileSystemError.FileIsADirectory(c.message);case t.FileSystemProviderErrorCode.NoPermissions:throw I.FileSystemError.NoPermissions(c.message);case t.FileSystemProviderErrorCode.Unavailable:throw I.FileSystemError.Unavailable(c.message);default:throw new I.FileSystemError(c.message,c.name)}}addFileSystemProvider(c,E){return this._fileSystemProvider.set(c,E),(0,P.toDisposable)(()=>this._fileSystemProvider.delete(c))}};F=Be([Me(0,k.IExtHostRpcService),Me(1,D.IExtHostFileSystemInfo)],F),e.ExtHostConsumerFileSystem=F,e.IExtHostConsumerFileSystem=(0,T.createDecorator)("IExtHostConsumerFileSystem")}),define(pe[240],ve([0,1,3,32,2,5,15,7]),function(ee,e,d,t,I,C,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(y,c,E,v,w,_,R,p){this._onDidCreate=new d.Emitter,this._onDidChange=new d.Emitter,this._onDidDelete=new d.Emitter;const h=this.ensureWatching(y,E,w);this._config=0,_&&(this._config+=1),R&&(this._config+=2),p&&(this._config+=4);const s=(0,t.parse)(w),u=typeof w=="string",r=v(S=>{if(!_)for(let a of S.created){const i=I.URI.revive(a);s(i.fsPath)&&(!u||c.getWorkspaceFolder(i))&&this._onDidCreate.fire(i)}if(!R)for(let a of S.changed){const i=I.URI.revive(a);s(i.fsPath)&&(!u||c.getWorkspaceFolder(i))&&this._onDidChange.fire(i)}if(!p)for(let a of S.deleted){const i=I.URI.revive(a);s(i.fsPath)&&(!u||c.getWorkspaceFolder(i))&&this._onDidDelete.fire(i)}});this._disposable=k.Disposable.from(h,this._onDidCreate,this._onDidChange,this._onDidDelete,r)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(y,c,E){let v=k.Disposable.from();if(typeof E=="string")return v;const w=y.getProxy(C.MainContext.MainThreadFileSystem);let _=!1;(E.pattern.includes(t.GLOBSTAR)||E.pattern.includes(t.GLOB_SPLIT))&&(_=!0);const R=Math.random();return w.$watch(c.identifier.value,R,E.baseUri,{recursive:_,excludes:[]}),k.Disposable.from({dispose:()=>w.$unwatch(R)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class P{constructor(y,c,E){this._mainContext=y,this._logService=c,this._extHostDocumentsAndEditors=E,this._onFileSystemEvent=new d.Emitter,this._onDidRenameFile=new d.Emitter,this._onDidCreateFile=new d.Emitter,this._onDidDeleteFile=new d.Emitter,this._onWillRenameFile=new d.AsyncEmitter,this._onWillCreateFile=new d.AsyncEmitter,this._onWillDeleteFile=new d.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(y,c,E,v,w,_){return new D(this._mainContext,y,c,this._onFileSystemEvent.event,T.GlobPattern.from(E),v,w,_)}$onFileEvent(y){this._onFileSystemEvent.fire(y)}$onDidRunFileOperation(y,c){switch(y){case 2:this._onDidRenameFile.fire(Object.freeze({files:c.map(E=>({oldUri:I.URI.revive(E.source),newUri:I.URI.revive(E.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:c.map(E=>I.URI.revive(E.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:c.map(E=>I.URI.revive(E.target))}));break;default:}}getOnWillRenameFileEvent(y){return this._createWillExecuteEvent(y,this._onWillRenameFile)}getOnWillCreateFileEvent(y){return this._createWillExecuteEvent(y,this._onWillCreateFile)}getOnWillDeleteFileEvent(y){return this._createWillExecuteEvent(y,this._onWillDeleteFile)}_createWillExecuteEvent(y,c){return(E,v,w)=>{const _=function(p){E.call(v,p)};return _.extension=y,c.event(_,void 0,w)}}async $onWillRunFileOperation(y,c,E,v){switch(y){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:c.map(w=>({oldUri:I.URI.revive(w.source),newUri:I.URI.revive(w.target)}))},E,v);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:c.map(w=>I.URI.revive(w.target))},E,v);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:c.map(w=>I.URI.revive(w.target))},E,v)}}async _fireWillEvent(y,c,E,v){const w=new Set,_=[];if(await y.fireAsync(c,v,async(p,h)=>{const s=Date.now(),u=await Promise.resolve(p);u instanceof k.WorkspaceEdit&&(_.push(u),w.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-s>E&&this._logService.warn("SLOW file-participant",h.extension.identifier)}),v.isCancellationRequested||_.length===0)return;const R={edits:[]};for(let p of _){let{edits:h}=T.WorkspaceEdit.from(p,this._extHostDocumentsAndEditors);R.edits=R.edits.concat(h)}return{edit:R,extensionNames:Array.from(w)}}}e.ExtHostFileSystemEventService=P}),define(pe[241],ve([0,1,2,39]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class I{constructor(T,k,D,P){this._extHostNotebooks=k,this._textDocumentsAndEditors=D,this._commands=P;const F=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",y=>!0,y=>y),new t.ApiCommandArgument("resource","Interactive resource Uri",y=>!0,y=>y),new t.ApiCommandArgument("controllerId","Notebook controller Id",y=>!0,y=>y),new t.ApiCommandArgument("title","Interactive editor title",y=>!0,y=>y)],new t.ApiCommandResult("Notebook and input URI",y=>{if(y.notebookEditorId!==void 0){const c=this._extHostNotebooks.getEditorById(y.notebookEditorId);return{notebookUri:d.URI.revive(y.notebookUri),inputUri:d.URI.revive(y.inputUri),notebookEditor:c.apiEditor}}return{notebookUri:d.URI.revive(y.notebookUri),inputUri:d.URI.revive(y.inputUri)}}));this._commands.registerApiCommand(F)}$willAddInteractiveDocument(T,k,D,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],languageId:D,uri:T,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(d.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(T,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[T]})}}e.ExtHostInteractive=I}),define(pe[242],ve([0,1,6,5]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class I{constructor(T){this._handlePool=0,this._proxy=T.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(T){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,T),(0,d.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=I}),define(pe[243],ve([0,1,2,25,15,7,5,8,41,17,18,146,21,6,112,76,87,46,16,3,13]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c,E,v,w,_,R,p,h,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class u{constructor(H,W){this._documents=H,this._provider=W}async provideDocumentSymbols(H,W){const O=this._documents.getDocument(H),$=await this._provider.provideDocumentSymbols(O,W);if(!(0,P.isFalsyOrEmpty)($))return $[0]instanceof C.DocumentSymbol?$.map(I.DocumentSymbol.from):u._asDocumentSymbolTree($)}static _asDocumentSymbolTree(H){H=H.slice(0).sort(($,Q)=>{let re=$.location.range.start.compareTo(Q.location.range.start);return re===0&&(re=Q.location.range.end.compareTo($.location.range.end)),re});const W=[],O=[];for(const $ of H){const Q={name:$.name||"!!MISSING: name!!",kind:I.SymbolKind.from($.kind),tags:$.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:$.containerName,range:I.Range.from($.location.range),selectionRange:I.Range.from($.location.range),children:[]};for(;;){if(O.length===0){O.push(Q),W.push(Q);break}const re=O[O.length-1];if(D.Range.containsRange(re.range,Q.range)&&!D.Range.equalsRange(re.range,Q.range)){re.children&&re.children.push(Q),O.push(Q);break}O.pop()}}return W}}class r{constructor(H,W,O){this._documents=H,this._commands=W,this._provider=O,this._cache=new _.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(H,W){const O=this._documents.getDocument(H),$=await this._provider.provideCodeLenses(O,W);if(!$||W.isCancellationRequested)return;const Q=this._cache.add($),re=new E.DisposableStore;this._disposables.set(Q,re);const de={cacheId:Q,lenses:[]};for(let ye=0;ye<$.length;ye++)de.lenses.push({cacheId:[Q,ye],range:I.Range.from($[ye].range),command:this._commands.toInternal($[ye].command,re)});return de}async resolveCodeLens(H,W){const O=H.cacheId&&this._cache.get(...H.cacheId);if(!O)return;let $;if(typeof this._provider.resolveCodeLens!="function"||O.isResolved?$=O:$=await this._provider.resolveCodeLens(O,W),$||($=O),W.isCancellationRequested)return;const Q=H.cacheId&&this._disposables.get(H.cacheId[0]);if(!!Q)return H.command=this._commands.toInternal($.command??r._badCmd,Q),H}releaseCodeLenses(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}}r._badCmd={command:"missing",title:"!!MISSING: command!!"};function S(be){return Array.isArray(be)?be.map(I.DefinitionLink.from):be?[I.DefinitionLink.from(be)]:[]}class a{constructor(H,W){this._documents=H,this._provider=W}async provideDefinition(H,W,O){const $=this._documents.getDocument(H),Q=I.Position.to(W),re=await this._provider.provideDefinition($,Q,O);return S(re)}}class i{constructor(H,W){this._documents=H,this._provider=W}async provideDeclaration(H,W,O){const $=this._documents.getDocument(H),Q=I.Position.to(W),re=await this._provider.provideDeclaration($,Q,O);return S(re)}}class n{constructor(H,W){this._documents=H,this._provider=W}async provideImplementation(H,W,O){const $=this._documents.getDocument(H),Q=I.Position.to(W),re=await this._provider.provideImplementation($,Q,O);return S(re)}}class o{constructor(H,W){this._documents=H,this._provider=W}async provideTypeDefinition(H,W,O){const $=this._documents.getDocument(H),Q=I.Position.to(W),re=await this._provider.provideTypeDefinition($,Q,O);return S(re)}}class l{constructor(H,W){this._documents=H,this._provider=W}async provideHover(H,W,O){const $=this._documents.getDocument(H),Q=I.Position.to(W),re=await this._provider.provideHover($,Q,O);if(!(!re||(0,P.isFalsyOrEmpty)(re.contents)))return re.range||(re.range=$.getWordRangeAtPosition(Q)),re.range||(re.range=new C.Range(Q,Q)),I.Hover.from(re)}}class f{constructor(H,W){this._documents=H,this._provider=W}async provideEvaluatableExpression(H,W,O){const $=this._documents.getDocument(H),Q=I.Position.to(W),re=await this._provider.provideEvaluatableExpression($,Q,O);if(re)return I.EvaluatableExpression.from(re)}}class m{constructor(H,W){this._documents=H,this._provider=W}async provideInlineValues(H,W,O,$){const Q=this._documents.getDocument(H),re=await this._provider.provideInlineValues(Q,I.Range.to(W),I.InlineValueContext.to(O),$);if(Array.isArray(re))return re.map(de=>I.InlineValue.from(de))}}class b{constructor(H,W){this._documents=H,this._provider=W}async provideDocumentHighlights(H,W,O){const $=this._documents.getDocument(H),Q=I.Position.to(W),re=await this._provider.provideDocumentHighlights($,Q,O);if(Array.isArray(re))return re.map(I.DocumentHighlight.from)}}class A{constructor(H,W){this._documents=H,this._provider=W}async provideLinkedEditingRanges(H,W,O){const $=this._documents.getDocument(H),Q=I.Position.to(W),re=await this._provider.provideLinkedEditingRanges($,Q,O);if(re&&Array.isArray(re.ranges))return{ranges:(0,P.coalesce)(re.ranges.map(I.Range.from)),wordPattern:re.wordPattern}}}class L{constructor(H,W){this._documents=H,this._provider=W}async provideReferences(H,W,O,$){const Q=this._documents.getDocument(H),re=I.Position.to(W),de=await this._provider.provideReferences(Q,re,O,$);if(Array.isArray(de))return de.map(I.location.from)}}class N{constructor(H,W,O,$,Q,re,de){this._documents=H,this._commands=W,this._diagnostics=O,this._provider=$,this._logService=Q,this._extension=re,this._apiDeprecation=de,this._cache=new _.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(H,W,O,$){const Q=this._documents.getDocument(H),re=y.Selection.isISelection(W)?I.Selection.to(W):I.Range.to(W),de=[];for(const He of this._diagnostics.getDiagnostics(H))if(re.intersection(He.range)&&de.push(He)>N._maxCodeActionsPerFile)break;const ye={diagnostics:de,only:O.only?new C.CodeActionKind(O.only):void 0,triggerKind:I.CodeActionTriggerKind.to(O.trigger)},Ae=await this._provider.provideCodeActions(Q,re,ye,$);if(!(0,P.isNonEmptyArray)(Ae)||$.isCancellationRequested)return;const We=this._cache.add(Ae),$e=new E.DisposableStore;this._disposables.set(We,$e);const je=[];for(let He=0;He<Ae.length;He++){const Ue=Ae[He];!Ue||(N._isCommand(Ue)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),je.push({_isSynthetic:!0,title:Ue.title,command:this._commands.toInternal(Ue,$e)})):(ye.only&&(Ue.kind?ye.only.contains(Ue.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ye.only.value} 'requested but returned code action is of kind '${Ue.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ye.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),je.push({cacheId:[We,He],title:Ue.title,command:Ue.command&&this._commands.toInternal(Ue.command,$e),diagnostics:Ue.diagnostics&&Ue.diagnostics.map(I.Diagnostic.from),edit:Ue.edit&&I.WorkspaceEdit.from(Ue.edit),kind:Ue.kind&&Ue.kind.value,isPreferred:Ue.isPreferred,disabled:Ue.disabled?.reason})))}return{cacheId:We,actions:je}}async resolveCodeAction(H,W){const[O,$]=H,Q=this._cache.get(O,$);if(!Q||N._isCommand(Q)||!this._provider.resolveCodeAction)return;const re=await this._provider.resolveCodeAction(Q,W)??Q;return re?.edit?I.WorkspaceEdit.from(re.edit):void 0}releaseCodeActions(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}static _isCommand(H){return typeof H.command=="string"&&typeof H.title=="string"}}N._maxCodeActionsPerFile=1e3;class g{constructor(H,W){this._documents=H,this._provider=W}async provideDocumentFormattingEdits(H,W,O){const $=this._documents.getDocument(H),Q=await this._provider.provideDocumentFormattingEdits($,W,O);if(Array.isArray(Q))return Q.map(I.TextEdit.from)}}class M{constructor(H,W){this._documents=H,this._provider=W}async provideDocumentRangeFormattingEdits(H,W,O,$){const Q=this._documents.getDocument(H),re=I.Range.to(W),de=await this._provider.provideDocumentRangeFormattingEdits(Q,re,O,$);if(Array.isArray(de))return de.map(I.TextEdit.from)}}class U{constructor(H,W){this._documents=H,this._provider=W,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(H,W,O,$,Q){const re=this._documents.getDocument(H),de=I.Position.to(W),ye=await this._provider.provideOnTypeFormattingEdits(re,de,O,$,Q);if(Array.isArray(ye))return ye.map(I.TextEdit.from)}}class j{constructor(H,W){this._provider=H,this._logService=W,this._cache=new _.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(H,W){const O=await this._provider.provideWorkspaceSymbols(H,W);if(!(0,P.isNonEmptyArray)(O))return{symbols:[]};const $=this._cache.add(O),Q={cacheId:$,symbols:[]};for(let re=0;re<O.length;re++){const de=O[re];if(!de||!de.name){this._logService.warn("INVALID SymbolInformation",de);continue}Q.symbols.push({...I.WorkspaceSymbol.from(de),cacheId:[$,re]})}return Q}async resolveWorkspaceSymbol(H,W){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!H.cacheId)return H;const O=this._cache.get(...H.cacheId);if(O){const $=await this._provider.resolveWorkspaceSymbol(O,W);return $&&(0,t.mixin)(H,I.WorkspaceSymbol.from($),!0)}}releaseWorkspaceSymbols(H){this._cache.delete(H)}}class K{constructor(H,W,O){this._documents=H,this._provider=W,this._logService=O}static supportsResolving(H){return typeof H.prepareRename=="function"}async provideRenameEdits(H,W,O,$){const Q=this._documents.getDocument(H),re=I.Position.to(W);try{const de=await this._provider.provideRenameEdits(Q,re,O,$);return de?I.WorkspaceEdit.from(de):void 0}catch(de){const ye=K._asMessage(de);return ye?{rejectReason:ye,edits:void 0}:Promise.reject(de)}}async resolveRenameLocation(H,W,O){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const $=this._documents.getDocument(H),Q=I.Position.to(W);try{const re=await this._provider.prepareRename($,Q,O);let de,ye;if(C.Range.isRange(re)?(de=re,ye=$.getText(re)):(0,F.isObject)(re)&&(de=re.range,ye=re.placeholder),!de||!ye)return;if(de.start.line>Q.line||de.end.line<Q.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(de),text:ye}}catch(re){const de=K._asMessage(re);return de?{rejectReason:de,range:void 0,text:void 0}:Promise.reject(re)}}static _asMessage(H){return typeof H=="string"?H:H instanceof Error&&typeof H.message=="string"?H.message:void 0}}class B{constructor(H,W){this.resultId=H,this.tokens=W}}class x{constructor(H,W){this._documents=H,this._provider=W,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(H,W,O){const $=this._documents.getDocument(H),Q=W!==0?this._previousResults.get(W):null;let re=typeof Q?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits($,Q.resultId,O):await this._provider.provideDocumentSemanticTokens($,O);return Q&&this._previousResults.delete(W),re?(re=x._fixProvidedSemanticTokens(re),this._send(x._convertToEdits(Q,re),re)):null}async releaseDocumentSemanticColoring(H){this._previousResults.delete(H)}static _fixProvidedSemanticTokens(H){return x._isSemanticTokens(H)?x._isCorrectSemanticTokens(H)?H:new C.SemanticTokens(new Uint32Array(H.data),H.resultId):x._isSemanticTokensEdits(H)?x._isCorrectSemanticTokensEdits(H)?H:new C.SemanticTokensEdits(H.edits.map(W=>new C.SemanticTokensEdit(W.start,W.deleteCount,W.data?new Uint32Array(W.data):W.data)),H.resultId):H}static _isSemanticTokens(H){return H&&!!H.data}static _isCorrectSemanticTokens(H){return H.data instanceof Uint32Array}static _isSemanticTokensEdits(H){return H&&Array.isArray(H.edits)}static _isCorrectSemanticTokensEdits(H){for(const W of H.edits)if(!(W.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(H,W){if(!x._isSemanticTokens(W)||!H||!H.tokens)return W;const O=H.tokens,$=O.length,Q=W.data,re=Q.length;let de=0;const ye=Math.min($,re);for(;de<ye&&O[de]===Q[de];)de++;if(de===$&&de===re)return new C.SemanticTokensEdits([],W.resultId);let Ae=0;const We=ye-de;for(;Ae<We&&O[$-Ae-1]===Q[re-Ae-1];)Ae++;return new C.SemanticTokensEdits([{start:de,deleteCount:$-de-Ae,data:Q.subarray(de,re-Ae)}],W.resultId)}_send(H,W){if(x._isSemanticTokens(H)){const O=this._nextResultId++;return this._previousResults.set(O,new B(H.resultId,H.data)),(0,v.encodeSemanticTokensDto)({id:O,type:"full",data:H.data})}if(x._isSemanticTokensEdits(H)){const O=this._nextResultId++;return x._isSemanticTokens(W)?this._previousResults.set(O,new B(W.resultId,W.data)):this._previousResults.set(O,new B(H.resultId)),(0,v.encodeSemanticTokensDto)({id:O,type:"delta",deltas:(H.edits||[]).map($=>({start:$.start,deleteCount:$.deleteCount,data:$.data}))})}return null}}e.DocumentSemanticTokensAdapter=x;class z{constructor(H,W){this._documents=H,this._provider=W}async provideDocumentRangeSemanticTokens(H,W,O){const $=this._documents.getDocument(H),Q=await this._provider.provideDocumentRangeSemanticTokens($,I.Range.to(W),O);return Q?this._send(Q):null}_send(H){return(0,v.encodeSemanticTokensDto)({id:0,type:"full",data:H.data})}}e.DocumentRangeSemanticTokensAdapter=z;class G{constructor(H,W,O,$,Q){this._documents=H,this._commands=W,this._provider=O,this._apiDeprecation=$,this._extension=Q,this._cache=new _.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(H){return typeof H.resolveCompletionItem=="function"}async provideCompletionItems(H,W,O,$){const Q=this._documents.getDocument(H),re=I.Position.to(W),de=Q.getWordRangeAtPosition(re)||new C.Range(re,re),ye=de.with({end:re}),Ae=new R.StopWatch(!0),We=await this._provider.provideCompletionItems(Q,re,$,I.CompletionContext.to(O));if(!We||$.isCancellationRequested)return;const $e=Array.isArray(We)?new C.CompletionList(We):We,je=G.supportsResolving(this._provider)?this._cache.add($e.items):this._cache.add([]),He=new E.DisposableStore;this._disposables.set(je,He);const Ue=[],Je={x:je,b:Ue,a:{replace:I.Range.from(de),insert:I.Range.from(ye)},c:$e.isIncomplete||void 0,d:Ae.elapsed()};for(let rt=0;rt<$e.items.length;rt++){const Re=$e.items[rt],tt=this._convertCompletionItem(Re,[je,rt],ye,de);Ue.push(tt)}return Je}async resolveCompletionItem(H,W){if(typeof this._provider.resolveCompletionItem!="function")return;const O=this._cache.get(...H);if(!O)return;const $=await this._provider.resolveCompletionItem(O,W);if(!!$)return this._convertCompletionItem($,H)}releaseCompletionItems(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}_convertCompletionItem(H,W,O,$){const Q=this._disposables.get(W[0]);if(!Q)throw Error("DisposableStore is missing...");const re={x:W,a:H.label,b:H.kind!==void 0?I.CompletionItemKind.from(H.kind):void 0,n:H.tags&&H.tags.map(I.CompletionItemTag.from),c:H.detail,d:typeof H.documentation=="undefined"?void 0:I.MarkdownString.fromStrict(H.documentation),e:H.sortText!==H.label?H.sortText:void 0,f:H.filterText!==H.label?H.filterText:void 0,g:H.preselect||void 0,i:H.keepWhitespace?1:0,k:H.commitCharacters,l:H.additionalTextEdits&&H.additionalTextEdits.map(I.TextEdit.from),m:this._commands.toInternal(H.command,Q)};H.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),re.h=H.textEdit.newText):typeof H.insertText=="string"?re.h=H.insertText:H.insertText instanceof C.SnippetString&&(re.h=H.insertText.value,re.i|=4);let de;return H.textEdit?de=H.textEdit.range:H.range&&(de=H.range),C.Range.isRange(de)?re.j=I.Range.from(de):de&&(!O?.isEqual(de.inserting)||!$?.isEqual(de.replacing))&&(re.j={insert:I.Range.from(de.inserting),replace:I.Range.from(de.replacing)}),re}}class q{constructor(H,W,O){this._documents=H,this._provider=W,this._commands=O,this._cache=new _.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(H,W,O,$){const Q=this._documents.getDocument(H),re=I.Position.to(W),de=await this._provider.provideInlineCompletionItems(Q,re,{selectedCompletionInfo:O.selectedSuggestionInfo?{range:I.Range.to(O.selectedSuggestionInfo.range),text:O.selectedSuggestionInfo.text,isSnippetText:O.selectedSuggestionInfo.isSnippetText,completionKind:I.CompletionItemKind.to(O.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:O.triggerKind},$);if(!de||$.isCancellationRequested)return;const ye=(0,F.isArray)(de)?{items:de}:de,Ae=this._cache.add(ye.items);let We;return{pid:Ae,items:ye.items.map(($e,je)=>{let He;return $e.command&&(We||(We=new E.DisposableStore,this._disposables.set(Ae,We)),He=this._commands.toInternal($e.command,We)),{text:$e.text,range:$e.range?I.Range.from($e.range):void 0,command:He,idx:je,completeBracketPairs:$e.completeBracketPairs}})}}disposeCompletions(H){this._cache.delete(H);const W=this._disposables.get(H);W&&W.clear(),this._disposables.delete(H)}handleDidShowCompletionItem(H,W){const O=this._cache.get(H,W);O&&Z.get(this._provider).fireOnDidShowCompletionItem({completionItem:O})}}class Z{constructor(){this._onDidShowCompletionItemEmitter=new h.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(H){let W=Z.map.get(H);return W||(W=new Z,Z.map.set(H,W)),W}fireOnDidShowCompletionItem(H){this._onDidShowCompletionItemEmitter.fire(H)}}e.InlineCompletionController=Z,Z.map=new WeakMap;class se{constructor(H,W){this._documents=H,this._provider=W,this._cache=new _.Cache("SignatureHelp")}async provideSignatureHelp(H,W,O,$){const Q=this._documents.getDocument(H),re=I.Position.to(W),de=this.reviveContext(O),ye=await this._provider.provideSignatureHelp(Q,re,$,de);if(ye){const Ae=this._cache.add([ye]);return{...I.SignatureHelp.from(ye),id:Ae}}}reviveContext(H){let W;if(H.activeSignatureHelp){const O=I.SignatureHelp.to(H.activeSignatureHelp),$=this._cache.get(H.activeSignatureHelp.id,0);$?(W=$,W.activeSignature=O.activeSignature,W.activeParameter=O.activeParameter):W=O}return{...H,activeSignatureHelp:W}}releaseSignatureHelp(H){this._cache.delete(H)}}class ue{constructor(H,W,O,$,Q){this._documents=H,this._commands=W,this._provider=O,this._logService=$,this._extension=Q,this._cache=new _.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(H,W,O){const $=this._documents.getDocument(H),Q=I.Range.to(W),re=await this._provider.provideInlayHints($,Q,O);if(!Array.isArray(re)||re.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${W}`);return}if(O.isCancellationRequested)return;const de=this._cache.add(re);this._disposables.set(de,new E.DisposableStore);const ye={hints:[],cacheId:de};for(let Ae=0;Ae<re.length;Ae++)this._isValidInlayHint(re[Ae],Q)&&ye.hints.push(this._convertInlayHint(re[Ae],[de,Ae]));return this._logService.trace(`[InlayHints] ${ye.hints.length} inlay hints from '${this._extension.identifier.value}' for ${W}`),ye}async resolveInlayHint(H,W){if(typeof this._provider.resolveInlayHint!="function")return;const O=this._cache.get(...H);if(!O)return;const $=await this._provider.resolveInlayHint(O,W);if(!!$&&!!this._isValidInlayHint($))return this._convertInlayHint($,H)}releaseHints(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}_isValidInlayHint(H,W){return H.label.length===0||Array.isArray(H.label)&&H.label.every(O=>O.label.length===0)?(console.log("INVALID inlay hint, empty label",H),!1):!(W&&!W.contains(H.position))}_convertInlayHint(H,W){const O=this._disposables.get(W[0]);if(!O)throw Error("DisposableStore is missing...");const $={label:"",cacheId:W,tooltip:H.tooltip&&I.MarkdownString.from(H.tooltip),position:I.Position.from(H.position),kind:I.InlayHintKind.from(H.kind??C.InlayHintKind.Other),paddingLeft:H.paddingLeft,paddingRight:H.paddingRight};return typeof H.label=="string"?$.label=H.label:$.label=H.label.map(Q=>{let re={label:Q.label};return re.tooltip=Q.tooltip&&I.MarkdownString.from(Q.tooltip),C.Location.isLocation(Q.location)&&(re.location=I.location.from(Q.location)),Q.command&&(re.command=this._commands.toInternal(Q.command,O)),re}),$}}class te{constructor(H,W){this._documents=H,this._provider=W,this._cache=new _.Cache("DocumentLink")}async provideLinks(H,W){const O=this._documents.getDocument(H),$=await this._provider.provideDocumentLinks(O,W);if(!(!Array.isArray($)||$.length===0)&&!W.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:$.filter(te._validateLink).map(I.DocumentLink.from)};{const Q=this._cache.add($),re={links:[],cacheId:Q};for(let de=0;de<$.length;de++){if(!te._validateLink($[de]))continue;const ye=I.DocumentLink.from($[de]);ye.cacheId=[Q,de],re.links.push(ye)}return re}}}static _validateLink(H){return H.target&&H.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(H,W){if(typeof this._provider.resolveDocumentLink!="function")return;const O=this._cache.get(...H);if(!O)return;const $=await this._provider.resolveDocumentLink(O,W);if(!(!$||!te._validateLink($)))return I.DocumentLink.from($)}releaseLinks(H){this._cache.delete(H)}}class J{constructor(H,W){this._documents=H,this._provider=W}async provideColors(H,W){const O=this._documents.getDocument(H),$=await this._provider.provideDocumentColors(O,W);return Array.isArray($)?$.map(re=>({color:I.Color.from(re.color),range:I.Range.from(re.range)})):[]}async provideColorPresentations(H,W,O){const $=this._documents.getDocument(H),Q=I.Range.to(W.range),re=I.Color.to(W.color),de=await this._provider.provideColorPresentations(re,{document:$,range:Q},O);if(!!Array.isArray(de))return de.map(I.ColorPresentation.from)}}class ae{constructor(H,W){this._documents=H,this._provider=W}async provideFoldingRanges(H,W,O){const $=this._documents.getDocument(H),Q=await this._provider.provideFoldingRanges($,W,O);if(!!Array.isArray(Q))return Q.map(I.FoldingRange.from)}}class he{constructor(H,W,O){this._documents=H,this._provider=W,this._logService=O}async provideSelectionRanges(H,W,O){const $=this._documents.getDocument(H),Q=W.map(I.Position.to),re=await this._provider.provideSelectionRanges($,Q,O);if(!(0,P.isNonEmptyArray)(re))return[];if(re.length!==Q.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const de=[];for(let ye=0;ye<Q.length;ye++){const Ae=[];de.push(Ae);let We=Q[ye],$e=re[ye];for(;;){if(!$e.range.contains(We))throw new Error("INVALID selection range, must contain the previous range");if(Ae.push(I.SelectionRange.from($e)),!$e.parent)break;We=$e.range,$e=$e.parent}}return de}}class we{constructor(H,W){this._documents=H,this._provider=W,this._idPool=new w.IdGenerator(""),this._cache=new Map}async prepareSession(H,W,O){const $=this._documents.getDocument(H),Q=I.Position.to(W),re=await this._provider.prepareCallHierarchy($,Q,O);if(!re)return;const de=this._idPool.nextId();return this._cache.set(de,new Map),Array.isArray(re)?re.map(ye=>this._cacheAndConvertItem(de,ye)):[this._cacheAndConvertItem(de,re)]}async provideCallsTo(H,W,O){const $=this._itemFromCache(H,W);if(!$)throw new Error("missing call hierarchy item");const Q=await this._provider.provideCallHierarchyIncomingCalls($,O);if(!!Q)return Q.map(re=>({from:this._cacheAndConvertItem(H,re.from),fromRanges:re.fromRanges.map(de=>I.Range.from(de))}))}async provideCallsFrom(H,W,O){const $=this._itemFromCache(H,W);if(!$)throw new Error("missing call hierarchy item");const Q=await this._provider.provideCallHierarchyOutgoingCalls($,O);if(!!Q)return Q.map(re=>({to:this._cacheAndConvertItem(H,re.to),fromRanges:re.fromRanges.map(de=>I.Range.from(de))}))}releaseSession(H){this._cache.delete(H)}_cacheAndConvertItem(H,W){const O=this._cache.get(H),$=I.CallHierarchyItem.from(W,H,O.size.toString(36));return O.set($._itemId,W),$}_itemFromCache(H,W){return this._cache.get(H)?.get(W)}}class Ie{constructor(H,W){this._documents=H,this._provider=W,this._idPool=new w.IdGenerator(""),this._cache=new Map}async prepareSession(H,W,O){const $=this._documents.getDocument(H),Q=I.Position.to(W),re=await this._provider.prepareTypeHierarchy($,Q,O);if(!re)return;const de=this._idPool.nextId();return this._cache.set(de,new Map),Array.isArray(re)?re.map(ye=>this._cacheAndConvertItem(de,ye)):[this._cacheAndConvertItem(de,re)]}async provideSupertypes(H,W,O){const $=this._itemFromCache(H,W);if(!$)throw new Error("missing type hierarchy item");const Q=await this._provider.provideTypeHierarchySupertypes($,O);if(!!Q)return Q.map(re=>this._cacheAndConvertItem(H,re))}async provideSubtypes(H,W,O){const $=this._itemFromCache(H,W);if(!$)throw new Error("missing type hierarchy item");const Q=await this._provider.provideTypeHierarchySubtypes($,O);if(!!Q)return Q.map(re=>this._cacheAndConvertItem(H,re))}releaseSession(H){this._cache.delete(H)}_cacheAndConvertItem(H,W){const O=this._cache.get(H),$=I.TypeHierarchyItem.from(W,H,O.size.toString(36));return O.set($._itemId,W),$}_itemFromCache(H,W){return this._cache.get(H)?.get(W)}}class Ne{constructor(H,W){this.adapter=H,this.extension=W}}class Ee{constructor(H,W,O,$,Q,re,de){this._adapter=new Map,this._uriTransformer=W,this._proxy=H.getProxy(T.MainContext.MainThreadLanguageFeatures),this._documents=O,this._commands=$,this._diagnostics=Q,this._logService=re,this._apiDeprecation=de}_transformDocumentSelector(H){return I.DocumentSelector.from(H,this._uriTransformer)}_createDisposable(H){return new C.Disposable(()=>{this._adapter.delete(H),this._proxy.$unregister(H)})}_nextHandle(){return Ee._handlePool++}async _withAdapter(H,W,O,$,Q){const re=this._adapter.get(H);if(!re||!(re.adapter instanceof W))return $;const de=Date.now();this._logService.trace(`[${re.extension.identifier.value}] INVOKE provider '${O.toString().replace(/[\r\n]/g,"")}'`);const ye=O(re.adapter,re.extension);return Promise.resolve(ye).catch(Ae=>{(0,p.isCancellationError)(Ae)||(this._logService.error(`[${re.extension.identifier.value}] provider FAILED`),this._logService.error(Ae))}).finally(()=>{this._logService.trace(`[${re.extension.identifier.value}] provider DONE after ${Date.now()-de}ms`)}),c.CancellationToken.isCancellationToken(Q)?(0,s.raceCancellationError)(ye,Q):ye}_addNewAdapter(H,W){const O=this._nextHandle();return this._adapter.set(O,new Ne(H,W)),O}static _extLabel(H){return H.displayName||H.name}registerDocumentSymbolProvider(H,W,O,$){const Q=this._addNewAdapter(new u(this._documents,O),H),re=$&&$.label||Ee._extLabel(H);return this._proxy.$registerDocumentSymbolProvider(Q,this._transformDocumentSelector(W),re),this._createDisposable(Q)}$provideDocumentSymbols(H,W,O){return this._withAdapter(H,u,$=>$.provideDocumentSymbols(d.URI.revive(W),O),void 0,O)}registerCodeLensProvider(H,W,O){const $=this._nextHandle(),Q=typeof O.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set($,new Ne(new r(this._documents,this._commands.converter,O),H)),this._proxy.$registerCodeLensSupport($,this._transformDocumentSelector(W),Q);let re=this._createDisposable($);if(Q!==void 0){const de=O.onDidChangeCodeLenses(ye=>this._proxy.$emitCodeLensEvent(Q));re=C.Disposable.from(re,de)}return re}$provideCodeLenses(H,W,O){return this._withAdapter(H,r,$=>$.provideCodeLenses(d.URI.revive(W),O),void 0,void 0)}$resolveCodeLens(H,W,O){return this._withAdapter(H,r,$=>$.resolveCodeLens(W,O),void 0,void 0)}$releaseCodeLenses(H,W){this._withAdapter(H,r,O=>Promise.resolve(O.releaseCodeLenses(W)),void 0,void 0)}registerDefinitionProvider(H,W,O){const $=this._addNewAdapter(new a(this._documents,O),H);return this._proxy.$registerDefinitionSupport($,this._transformDocumentSelector(W)),this._createDisposable($)}$provideDefinition(H,W,O,$){return this._withAdapter(H,a,Q=>Q.provideDefinition(d.URI.revive(W),O,$),[],$)}registerDeclarationProvider(H,W,O){const $=this._addNewAdapter(new i(this._documents,O),H);return this._proxy.$registerDeclarationSupport($,this._transformDocumentSelector(W)),this._createDisposable($)}$provideDeclaration(H,W,O,$){return this._withAdapter(H,i,Q=>Q.provideDeclaration(d.URI.revive(W),O,$),[],$)}registerImplementationProvider(H,W,O){const $=this._addNewAdapter(new n(this._documents,O),H);return this._proxy.$registerImplementationSupport($,this._transformDocumentSelector(W)),this._createDisposable($)}$provideImplementation(H,W,O,$){return this._withAdapter(H,n,Q=>Q.provideImplementation(d.URI.revive(W),O,$),[],$)}registerTypeDefinitionProvider(H,W,O){const $=this._addNewAdapter(new o(this._documents,O),H);return this._proxy.$registerTypeDefinitionSupport($,this._transformDocumentSelector(W)),this._createDisposable($)}$provideTypeDefinition(H,W,O,$){return this._withAdapter(H,o,Q=>Q.provideTypeDefinition(d.URI.revive(W),O,$),[],$)}registerHoverProvider(H,W,O,$){const Q=this._addNewAdapter(new l(this._documents,O),H);return this._proxy.$registerHoverProvider(Q,this._transformDocumentSelector(W)),this._createDisposable(Q)}$provideHover(H,W,O,$){return this._withAdapter(H,l,Q=>Q.provideHover(d.URI.revive(W),O,$),void 0,void 0)}registerEvaluatableExpressionProvider(H,W,O,$){const Q=this._addNewAdapter(new f(this._documents,O),H);return this._proxy.$registerEvaluatableExpressionProvider(Q,this._transformDocumentSelector(W)),this._createDisposable(Q)}$provideEvaluatableExpression(H,W,O,$){return this._withAdapter(H,f,Q=>Q.provideEvaluatableExpression(d.URI.revive(W),O,$),void 0,void 0)}registerInlineValuesProvider(H,W,O,$){const Q=typeof O.onDidChangeInlineValues=="function"?this._nextHandle():void 0,re=this._addNewAdapter(new m(this._documents,O),H);this._proxy.$registerInlineValuesProvider(re,this._transformDocumentSelector(W),Q);let de=this._createDisposable(re);if(Q!==void 0){const ye=O.onDidChangeInlineValues(Ae=>this._proxy.$emitInlineValuesEvent(Q));de=C.Disposable.from(de,ye)}return de}$provideInlineValues(H,W,O,$,Q){return this._withAdapter(H,m,re=>re.provideInlineValues(d.URI.revive(W),O,$,Q),void 0,void 0)}registerDocumentHighlightProvider(H,W,O){const $=this._addNewAdapter(new b(this._documents,O),H);return this._proxy.$registerDocumentHighlightProvider($,this._transformDocumentSelector(W)),this._createDisposable($)}$provideDocumentHighlights(H,W,O,$){return this._withAdapter(H,b,Q=>Q.provideDocumentHighlights(d.URI.revive(W),O,$),void 0,void 0)}registerLinkedEditingRangeProvider(H,W,O){const $=this._addNewAdapter(new A(this._documents,O),H);return this._proxy.$registerLinkedEditingRangeProvider($,this._transformDocumentSelector(W)),this._createDisposable($)}$provideLinkedEditingRanges(H,W,O,$){return this._withAdapter(H,A,async Q=>{const re=await Q.provideLinkedEditingRanges(d.URI.revive(W),O,$);if(re)return{ranges:re.ranges,wordPattern:re.wordPattern?Ee._serializeRegExp(re.wordPattern):void 0}},void 0,void 0)}registerReferenceProvider(H,W,O){const $=this._addNewAdapter(new L(this._documents,O),H);return this._proxy.$registerReferenceSupport($,this._transformDocumentSelector(W)),this._createDisposable($)}$provideReferences(H,W,O,$,Q){return this._withAdapter(H,L,re=>re.provideReferences(d.URI.revive(W),O,$,Q),void 0,Q)}registerCodeActionProvider(H,W,O,$){const Q=new E.DisposableStore,re=this._addNewAdapter(new N(this._documents,this._commands.converter,this._diagnostics,O,this._logService,H,this._apiDeprecation),H);return this._proxy.$registerQuickFixSupport(re,this._transformDocumentSelector(W),{providedKinds:$?.providedCodeActionKinds?.map(de=>de.value),documentation:$?.documentation?.map(de=>({kind:de.kind.value,command:this._commands.converter.toInternal(de.command,Q)}))},Ee._extLabel(H),Boolean(O.resolveCodeAction)),Q.add(this._createDisposable(re)),Q}$provideCodeActions(H,W,O,$,Q){return this._withAdapter(H,N,re=>re.provideCodeActions(d.URI.revive(W),O,$,Q),void 0,void 0)}$resolveCodeAction(H,W,O){return this._withAdapter(H,N,$=>$.resolveCodeAction(W,O),void 0,void 0)}$releaseCodeActions(H,W){this._withAdapter(H,N,O=>Promise.resolve(O.releaseCodeActions(W)),void 0,void 0)}registerDocumentFormattingEditProvider(H,W,O){const $=this._addNewAdapter(new g(this._documents,O),H);return this._proxy.$registerDocumentFormattingSupport($,this._transformDocumentSelector(W),H.identifier,H.displayName||H.name),this._createDisposable($)}$provideDocumentFormattingEdits(H,W,O,$){return this._withAdapter(H,g,Q=>Q.provideDocumentFormattingEdits(d.URI.revive(W),O,$),void 0,void 0)}registerDocumentRangeFormattingEditProvider(H,W,O){const $=this._addNewAdapter(new M(this._documents,O),H);return this._proxy.$registerRangeFormattingSupport($,this._transformDocumentSelector(W),H.identifier,H.displayName||H.name),this._createDisposable($)}$provideDocumentRangeFormattingEdits(H,W,O,$,Q){return this._withAdapter(H,M,re=>re.provideDocumentRangeFormattingEdits(d.URI.revive(W),O,$,Q),void 0,void 0)}registerOnTypeFormattingEditProvider(H,W,O,$){const Q=this._addNewAdapter(new U(this._documents,O),H);return this._proxy.$registerOnTypeFormattingSupport(Q,this._transformDocumentSelector(W),$,H.identifier),this._createDisposable(Q)}$provideOnTypeFormattingEdits(H,W,O,$,Q,re){return this._withAdapter(H,U,de=>de.provideOnTypeFormattingEdits(d.URI.revive(W),O,$,Q,re),void 0,void 0)}registerWorkspaceSymbolProvider(H,W){const O=this._addNewAdapter(new j(W,this._logService),H);return this._proxy.$registerNavigateTypeSupport(O,typeof W.resolveWorkspaceSymbol=="function"),this._createDisposable(O)}$provideWorkspaceSymbols(H,W,O){return this._withAdapter(H,j,$=>$.provideWorkspaceSymbols(W,O),{symbols:[]},O)}$resolveWorkspaceSymbol(H,W,O){return this._withAdapter(H,j,$=>$.resolveWorkspaceSymbol(W,O),void 0,void 0)}$releaseWorkspaceSymbols(H,W){this._withAdapter(H,j,O=>O.releaseWorkspaceSymbols(W),void 0,void 0)}registerRenameProvider(H,W,O){const $=this._addNewAdapter(new K(this._documents,O,this._logService),H);return this._proxy.$registerRenameSupport($,this._transformDocumentSelector(W),K.supportsResolving(O)),this._createDisposable($)}$provideRenameEdits(H,W,O,$,Q){return this._withAdapter(H,K,re=>re.provideRenameEdits(d.URI.revive(W),O,$,Q),void 0,void 0)}$resolveRenameLocation(H,W,O,$){return this._withAdapter(H,K,Q=>Q.resolveRenameLocation(d.URI.revive(W),O,$),void 0,void 0)}registerDocumentSemanticTokensProvider(H,W,O,$){const Q=this._addNewAdapter(new x(this._documents,O),H),re=typeof O.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(Q,this._transformDocumentSelector(W),$,re);let de=this._createDisposable(Q);if(re){const ye=O.onDidChangeSemanticTokens(Ae=>this._proxy.$emitDocumentSemanticTokensEvent(re));de=C.Disposable.from(de,ye)}return de}$provideDocumentSemanticTokens(H,W,O,$){return this._withAdapter(H,x,Q=>Q.provideDocumentSemanticTokens(d.URI.revive(W),O,$),null,void 0)}$releaseDocumentSemanticTokens(H,W){this._withAdapter(H,x,O=>O.releaseDocumentSemanticColoring(W),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(H,W,O,$){const Q=this._addNewAdapter(new z(this._documents,O),H);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Q,this._transformDocumentSelector(W),$),this._createDisposable(Q)}$provideDocumentRangeSemanticTokens(H,W,O,$){return this._withAdapter(H,z,Q=>Q.provideDocumentRangeSemanticTokens(d.URI.revive(W),O,$),null,void 0)}registerCompletionItemProvider(H,W,O,$){const Q=this._addNewAdapter(new G(this._documents,this._commands.converter,O,this._apiDeprecation,H),H);return this._proxy.$registerSuggestSupport(Q,this._transformDocumentSelector(W),$,G.supportsResolving(O),`${H.identifier.value}(${$.join("")})`),this._createDisposable(Q)}$provideCompletionItems(H,W,O,$,Q){return this._withAdapter(H,G,re=>re.provideCompletionItems(d.URI.revive(W),O,$,Q),void 0,Q)}$resolveCompletionItem(H,W,O){return this._withAdapter(H,G,$=>$.resolveCompletionItem(W,O),void 0,O)}$releaseCompletionItems(H,W){this._withAdapter(H,G,O=>O.releaseCompletionItems(W),void 0,void 0)}registerInlineCompletionsProvider(H,W,O){const $=this._addNewAdapter(new q(this._documents,O,this._commands.converter),H);return this._proxy.$registerInlineCompletionsSupport($,this._transformDocumentSelector(W)),this._createDisposable($)}$provideInlineCompletions(H,W,O,$,Q){return this._withAdapter(H,q,re=>re.provideInlineCompletions(d.URI.revive(W),O,$,Q),void 0,void 0)}$handleInlineCompletionDidShow(H,W,O){this._withAdapter(H,q,async $=>{$.handleDidShowCompletionItem(W,O)},void 0,void 0)}$freeInlineCompletionsList(H,W){this._withAdapter(H,q,async O=>{O.disposeCompletions(W)},void 0,void 0)}registerSignatureHelpProvider(H,W,O,$){const Q=Array.isArray($)?{triggerCharacters:$,retriggerCharacters:[]}:$,re=this._addNewAdapter(new se(this._documents,O),H);return this._proxy.$registerSignatureHelpProvider(re,this._transformDocumentSelector(W),Q),this._createDisposable(re)}$provideSignatureHelp(H,W,O,$,Q){return this._withAdapter(H,se,re=>re.provideSignatureHelp(d.URI.revive(W),O,$,Q),void 0,void 0)}$releaseSignatureHelp(H,W){this._withAdapter(H,se,O=>O.releaseSignatureHelp(W),void 0,void 0)}registerInlayHintsProvider(H,W,O){const $=typeof O.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Q=this._addNewAdapter(new ue(this._documents,this._commands.converter,O,this._logService,H),H);this._proxy.$registerInlayHintsProvider(Q,this._transformDocumentSelector(W),typeof O.resolveInlayHint=="function",$,Ee._extLabel(H));let re=this._createDisposable(Q);if($!==void 0){const de=O.onDidChangeInlayHints(ye=>this._proxy.$emitInlayHintsEvent($));re=C.Disposable.from(re,de)}return re}$provideInlayHints(H,W,O,$){return this._withAdapter(H,ue,Q=>Q.provideInlayHints(d.URI.revive(W),O,$),void 0,$)}$resolveInlayHint(H,W,O){return this._withAdapter(H,ue,$=>$.resolveInlayHint(W,O),void 0,O)}$releaseInlayHints(H,W){this._withAdapter(H,ue,O=>O.releaseHints(W),void 0,void 0)}registerDocumentLinkProvider(H,W,O){const $=this._addNewAdapter(new te(this._documents,O),H);return this._proxy.$registerDocumentLinkProvider($,this._transformDocumentSelector(W),typeof O.resolveDocumentLink=="function"),this._createDisposable($)}$provideDocumentLinks(H,W,O){return this._withAdapter(H,te,$=>$.provideLinks(d.URI.revive(W),O),void 0,void 0)}$resolveDocumentLink(H,W,O){return this._withAdapter(H,te,$=>$.resolveLink(W,O),void 0,void 0)}$releaseDocumentLinks(H,W){this._withAdapter(H,te,O=>O.releaseLinks(W),void 0,void 0)}registerColorProvider(H,W,O){const $=this._addNewAdapter(new J(this._documents,O),H);return this._proxy.$registerDocumentColorProvider($,this._transformDocumentSelector(W)),this._createDisposable($)}$provideDocumentColors(H,W,O){return this._withAdapter(H,J,$=>$.provideColors(d.URI.revive(W),O),[],void 0)}$provideColorPresentations(H,W,O,$){return this._withAdapter(H,J,Q=>Q.provideColorPresentations(d.URI.revive(W),O,$),void 0,void 0)}registerFoldingRangeProvider(H,W,O){const $=this._nextHandle(),Q=typeof O.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set($,new Ne(new ae(this._documents,O),H)),this._proxy.$registerFoldingRangeProvider($,this._transformDocumentSelector(W),Q);let re=this._createDisposable($);if(Q!==void 0){const de=O.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Q));re=C.Disposable.from(re,de)}return re}$provideFoldingRanges(H,W,O,$){return this._withAdapter(H,ae,Q=>Q.provideFoldingRanges(d.URI.revive(W),O,$),void 0,void 0)}registerSelectionRangeProvider(H,W,O){const $=this._addNewAdapter(new he(this._documents,O,this._logService),H);return this._proxy.$registerSelectionRangeProvider($,this._transformDocumentSelector(W)),this._createDisposable($)}$provideSelectionRanges(H,W,O,$){return this._withAdapter(H,he,Q=>Q.provideSelectionRanges(d.URI.revive(W),O,$),[],$)}registerCallHierarchyProvider(H,W,O){const $=this._addNewAdapter(new we(this._documents,O),H);return this._proxy.$registerCallHierarchyProvider($,this._transformDocumentSelector(W)),this._createDisposable($)}$prepareCallHierarchy(H,W,O,$){return this._withAdapter(H,we,Q=>Promise.resolve(Q.prepareSession(d.URI.revive(W),O,$)),void 0,$)}$provideCallHierarchyIncomingCalls(H,W,O,$){return this._withAdapter(H,we,Q=>Q.provideCallsTo(W,O,$),void 0,$)}$provideCallHierarchyOutgoingCalls(H,W,O,$){return this._withAdapter(H,we,Q=>Q.provideCallsFrom(W,O,$),void 0,$)}$releaseCallHierarchy(H,W){this._withAdapter(H,we,O=>Promise.resolve(O.releaseSession(W)),void 0,void 0)}registerTypeHierarchyProvider(H,W,O){const $=this._addNewAdapter(new Ie(this._documents,O),H);return this._proxy.$registerTypeHierarchyProvider($,this._transformDocumentSelector(W)),this._createDisposable($)}$prepareTypeHierarchy(H,W,O,$){return this._withAdapter(H,Ie,Q=>Promise.resolve(Q.prepareSession(d.URI.revive(W),O,$)),void 0,$)}$provideTypeHierarchySupertypes(H,W,O,$){return this._withAdapter(H,Ie,Q=>Q.provideSupertypes(W,O,$),void 0,$)}$provideTypeHierarchySubtypes(H,W,O,$){return this._withAdapter(H,Ie,Q=>Q.provideSubtypes(W,O,$),void 0,$)}$releaseTypeHierarchy(H,W){this._withAdapter(H,Ie,O=>Promise.resolve(O.releaseSession(W)),void 0,void 0)}static _serializeRegExp(H){return{pattern:H.source,flags:(0,k.regExpFlags)(H)}}static _serializeIndentationRule(H){return{decreaseIndentPattern:Ee._serializeRegExp(H.decreaseIndentPattern),increaseIndentPattern:Ee._serializeRegExp(H.increaseIndentPattern),indentNextLinePattern:H.indentNextLinePattern?Ee._serializeRegExp(H.indentNextLinePattern):void 0,unIndentedLinePattern:H.unIndentedLinePattern?Ee._serializeRegExp(H.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(H){return{beforeText:Ee._serializeRegExp(H.beforeText),afterText:H.afterText?Ee._serializeRegExp(H.afterText):void 0,previousLineText:H.previousLineText?Ee._serializeRegExp(H.previousLineText):void 0,action:H.action}}static _serializeOnEnterRules(H){return H.map(Ee._serializeOnEnterRule)}setLanguageConfiguration(H,W,O){let{wordPattern:$}=O;if($&&(0,k.regExpLeadsToEndlessLoop)($))throw new Error(`Invalid language configuration: wordPattern '${$}' is not allowed to match the empty string.`);$?this._documents.setWordDefinitionFor(W,$):this._documents.setWordDefinitionFor(W,void 0),O.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",H,"Do not use."),O.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",H,"Do not use.");const Q=this._nextHandle(),re={comments:O.comments,brackets:O.brackets,wordPattern:O.wordPattern?Ee._serializeRegExp(O.wordPattern):void 0,indentationRules:O.indentationRules?Ee._serializeIndentationRule(O.indentationRules):void 0,onEnterRules:O.onEnterRules?Ee._serializeOnEnterRules(O.onEnterRules):void 0,__electricCharacterSupport:O.__electricCharacterSupport,__characterPairSupport:O.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Q,W,re),this._createDisposable(Q)}$setWordDefinitions(H){for(const W of H)this._documents.setWordDefinitionFor(W.languageId,new RegExp(W.regexSource,W.regexFlags))}}e.ExtHostLanguageFeatures=Ee,Ee._handlePool=0}),define(pe[244],ve([0,1,5,15,7,47,13,6]),function(ee,e,d,t,I,C,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class D{constructor(F,y,c,E){this._documents=y,this._commands=c,this._uriTransformer=E,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=F.getProxy(d.MainContext.MainThreadLanguages)}$acceptLanguageIds(F){this._languageIds=F}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(F,y){await this._proxy.$changeLanguage(F,y);const c=this._documents.getDocumentData(F);if(!c)throw new Error(`document '${F.toString}' NOT found`);return c.document}async tokenAtPosition(F,y){const c=F.version,E=t.Position.from(y),v=await this._proxy.$tokensAtPosition(F.uri,E),w={type:I.StandardTokenType.Other,range:F.getWordRangeAtPosition(y)??new I.Range(y.line,y.character,y.line,y.character)};if(!v)return w;const _={range:t.Range.to(v.range),type:t.TokenType.to(v.type)};return!_.range.contains(y)||c!==F.version?w:_}createLanguageStatusItem(F,y,c){const E=this._handlePool++,v=this._proxy,w=this._ids,_=`${F.identifier.value}/${y}`;if(w.has(_))throw new Error(`LanguageStatusItem with id '${y}' ALREADY exists`);w.add(_);const R={selector:c,id:y,name:F.displayName??F.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let p,h=new k.DisposableStore;const s=()=>{p?.dispose(),p=(0,T.disposableTimeout)(()=>{h.clear(),this._proxy.$setLanguageStatus(E,{id:_,name:R.name??F.displayName??F.name,source:F.displayName??F.name,selector:t.DocumentSelector.from(R.selector,this._uriTransformer),label:R.text,detail:R.detail??"",severity:R.severity===I.LanguageStatusSeverity.Error?C.default.Error:R.severity===I.LanguageStatusSeverity.Warning?C.default.Warning:C.default.Info,command:R.command&&this._commands.toInternal(R.command,h),accessibilityInfo:R.accessibilityInformation,busy:R.busy})},0)},u={dispose(){h.dispose(),p?.dispose(),v.$removeLanguageStatus(E),w.delete(_)},get id(){return R.id},get name(){return R.name},set name(r){R.name=r,s()},get selector(){return R.selector},set selector(r){R.selector=r,s()},get text(){return R.text},set text(r){R.text=r,s()},get detail(){return R.detail},set detail(r){R.detail=r,s()},get severity(){return R.severity},set severity(r){R.severity=r,s()},get accessibilityInformation(){return R.accessibilityInformation},set accessibilityInformation(r){R.accessibilityInformation=r,s()},get command(){return R.command},set command(r){R.command=r,s()},get busy(){return R.busy},set busy(r){R.busy=r,s()}};return s(),u}}e.ExtHostLanguages=D}),define(pe[133],ve([0,1,12,5,26,14,3]),function(ee,e,d,t,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends d.AbstractLoggerService{constructor(F,y){const c=new T.Emitter;super(y.logLevel,c.event);this._proxy=F.getProxy(t.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(c)}$setLevel(F){this._onDidChangeLogLevel.fire(F)}doCreateLogger(F,y,c){return new D(this._proxy,F,y,c)}};k=Be([Me(0,C.IExtHostRpcService),Me(1,I.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class D extends d.AbstractMessageLogger{constructor(F,y,c,E){super(E?.always);this.proxy=F,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(c),this.proxy.$createLogger(y,E).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(F,y){const c=[[F,y]];this.isLoggerCreated?this.doLog(c):this.buffer.push(...c)}doLog(F){this.proxy.$log(this.file,F)}}}),define(pe[245],ve([0,1,5,12,30]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function C(k){return k&&k.title}let T=class{constructor(D,P){this._logService=P,this._proxy=D.getProxy(d.MainContext.MainThreadMessageService)}showMessage(D,P,F,y,c){const E={source:{identifier:D.identifier,label:D.displayName||D.name}};let v;typeof y=="string"||C(y)?v=[y,...c]:(E.modal=y?.modal,E.useCustom=y?.useCustom,E.detail=y?.detail,v=c),E.useCustom&&(0,I.checkProposedApiEnabled)(D,"resolvers");const w=[];for(let _=0;_<v.length;_++){const R=v[_];if(typeof R=="string")w.push({title:R,handle:_,isCloseAffordance:!1});else if(typeof R=="object"){let{title:p,isCloseAffordance:h}=R;w.push({title:p,isCloseAffordance:!!h,handle:_})}else this._logService.warn("Invalid message item:",R)}return this._proxy.$showMessage(P,F,E,w).then(_=>{if(typeof _=="number")return v[_]})}};T=Be([Me(1,t.ILogService)],T),e.ExtHostMessageService=T}),define(pe[246],ve([0,1,23,3,58,6,24,8,18,2,87,5,15,7,52,221,130]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c,E,v,w,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class R{constructor(h,s,u,r,S){this._textDocumentsAndEditors=u,this._textDocuments=r,this._extensionStoragePaths=S,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new T.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new t.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new t.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new t.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new F.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=h.getProxy(y.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=h.getProxy(y.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=h.getProxy(y.MainContext.MainThreadNotebookEditors),this._commandsConverter=s.converter,s.registerArgumentProcessor({processArgument:a=>{if(a&&a.$mid===12){const i=a.notebookEditor?.notebookUri,n=a.cell.handle,l=this._documents.get(i)?.getCell(n);if(l)return l.apiCell}return a}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(h=>h.apiEditor)}getEditorById(h){const s=this._editors.get(h);if(!s)throw new Error(`unknown text editor: ${h}. known editors: ${[...this._editors.keys()]} `);return s}getIdByEditor(h){for(const[s,u]of this._editors)if(u.apiEditor===h)return s}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(h,s){const u=this._documents.get(h);if(!u&&!s)throw new Error(`NO notebook document for '${h}'`);return u}_getProviderData(h){const s=this._notebookContentProviders.get(h);if(!s)throw new Error(`NO provider for '${h}'`);return s}registerNotebookContentProvider(h,s,u,r,S){if((0,k.isFalsyOrWhitespace)(s))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(s))throw new Error(`Notebook provider for '${s}' already registered`);this._notebookContentProviders.set(s,{extension:h,provider:u});let a;return u.onDidChangeNotebookContentOptions&&(a=u.onDidChangeNotebookContentOptions(()=>{const i=c.NotebookDocumentContentOptions.from(u.options);this._notebookProxy.$updateNotebookProviderOptions(s,i)})),this._notebookProxy.$registerNotebookProvider({id:h.identifier,location:h.extensionLocation},s,c.NotebookDocumentContentOptions.from(r),R._convertNotebookRegistrationData(h,S)),new E.Disposable(()=>{a?.dispose(),this._notebookContentProviders.delete(s),this._notebookProxy.$unregisterNotebookProvider(s)})}static _convertNotebookRegistrationData(h,s){if(!s)return;const u=s.filenamePattern.map(r=>c.NotebookExclusiveDocumentPattern.from(r)).filter(r=>r!==void 0);if(s.filenamePattern&&!u){console.warn(`Notebook content provider view options file name pattern is invalid ${s.filenamePattern}`);return}return{extension:h.identifier,providerDisplayName:h.displayName||h.name,displayName:s.displayName,filenamePattern:u,exclusive:s.exclusive||!1}}registerNotebookCellStatusBarItemProvider(h,s,u){const r=R._notebookStatusBarItemProviderHandlePool++,S=typeof u.onDidChangeCellStatusBarItems=="function"?R._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(r,u),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(r,S,s);let a;return S!==void 0&&(a=u.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(S))),new E.Disposable(()=>{this._notebookStatusBarItemProviders.delete(r),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(r,S),a&&a.dispose()})}async createNotebookDocument(h){const s=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:h.viewType,content:h.content&&c.NotebookData.from(h.content)});return P.URI.revive(s)}async openNotebookDocument(h){const s=this._documents.get(h);if(s)return s.apiNotebook;const u=await this._notebookDocumentsProxy.$tryOpenNotebook(h),r=this._documents.get(P.URI.revive(u));return(0,D.assertIsDefined)(r?.apiNotebook)}async showNotebookDocument(h,s){P.URI.isUri(h)&&(h=await this.openNotebookDocument(h));let u;typeof s=="object"?u={position:c.ViewColumn.from(s.viewColumn),preserveFocus:s.preserveFocus,selections:s.selections&&s.selections.map(c.NotebookRange.from),pinned:typeof s.preview=="boolean"?!s.preview:void 0}:u={preserveFocus:!1};const r=await this._notebookEditorsProxy.$tryShowNotebookDocument(h.uri,h.notebookType,u),S=r&&this._editors.get(r)?.apiEditor;if(S)return S;throw r?new Error(`Could NOT open editor for "${h.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${h.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(h,s,u,r){const S=this._notebookStatusBarItemProviders.get(h),a=P.URI.revive(s),i=this._documents.get(a);if(!i||!S)return;const n=i.getCellFromIndex(u);if(!n)return;const o=await S.provideCellStatusBarItems(n.apiCell,r);if(!o)return;const l=new C.DisposableStore,f=this._statusBarCache.add([l]),b=(Array.isArray(o)?o:[o]).map(A=>c.NotebookStatusBarItem.from(A,this._commandsConverter,l));return{cacheId:f,items:b}}$releaseNotebookCellStatusBarItems(h){this._statusBarCache.delete(h)}registerNotebookSerializer(h,s,u,r,S){if((0,k.isFalsyOrWhitespace)(s))throw new Error("viewType cannot be empty or just whitespace");const a=this._handlePool++;return this._notebookSerializer.set(a,u),this._notebookProxy.$registerNotebookSerializer(a,{id:h.identifier,location:h.extensionLocation},s,c.NotebookDocumentContentOptions.from(r),R._convertNotebookRegistrationData(h,S)),(0,C.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(a)})}async $dataToNotebook(h,s,u){const r=this._notebookSerializer.get(h);if(!r)throw new Error("NO serializer found");const S=await r.deserializeNotebook(s.buffer,u);return new v.SerializableObjectWithBuffers(c.NotebookData.from(S))}async $notebookToData(h,s,u){const r=this._notebookSerializer.get(h);if(!r)throw new Error("NO serializer found");const S=await r.serializeNotebook(c.NotebookData.to(s.value),u);return d.VSBuffer.wrap(S)}async $openNotebook(h,s,u,r,S){const{provider:a}=this._getProviderData(h),i=await a.openNotebook(P.URI.revive(s),{backupId:u,untitledDocumentData:r?.buffer},S);return new v.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(c.NotebookCellData.from)})}async $saveNotebook(h,s,u){const r=this.getNotebookDocument(P.URI.revive(s)),{provider:S}=this._getProviderData(h);return await S.saveNotebook(r.apiNotebook,u),!0}async $saveNotebookAs(h,s,u,r){const S=this.getNotebookDocument(P.URI.revive(s)),{provider:a}=this._getProviderData(h);return await a.saveNotebookAs(P.URI.revive(u),S.apiNotebook,r),!0}async $backupNotebook(h,s,u){const r=this.getNotebookDocument(P.URI.revive(s)),S=this._getProviderData(h),a=this._extensionStoragePaths.workspaceValue(S.extension)??this._extensionStoragePaths.globalValue(S.extension),i=String((0,I.hash)([r.uri.toString(),this._backupIdPool++])),n=P.URI.joinPath(a,i),o=await S.provider.backupNotebook(r.apiNotebook,{destination:n},u);return r.updateBackup(o),o.id}_createExtHostEditor(h,s,u){if(this._editors.has(s))throw new Error(`editor with id ALREADY EXSIST: ${s}`);const r=new _.ExtHostNotebookEditor(s,this._notebookEditorsProxy,h,u.visibleRanges.map(c.NotebookRange.to),u.selections.map(c.NotebookRange.to),typeof u.viewColumn=="number"?c.ViewColumn.to(u.viewColumn):void 0);this._editors.set(s,r)}$acceptDocumentAndEditorsDelta(h){if(h.value.removedDocuments)for(const u of h.value.removedDocuments){const r=P.URI.revive(u),S=this._documents.get(r);S&&(S.dispose(),this._documents.delete(r),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:S.apiNotebook.getCells().map(a=>a.document.uri)}),this._onDidCloseNotebookDocument.fire(S.apiNotebook));for(const a of this._editors.values())a.notebookData.uri.toString()===r.toString()&&this._editors.delete(a.id)}if(h.value.addedDocuments){const u=[];for(const r of h.value.addedDocuments){const S=P.URI.revive(r.uri);if(this._documents.has(S))throw new Error(`adding EXISTING notebook ${S} `);const a=this,i=new w.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(n){a._onDidChangeNotebookCells.fire(n)},emitCellOutputsChange(n){a._onDidChangeCellOutputs.fire(n)},emitCellMetadataChange(n){a._onDidChangeCellMetadata.fire(n)}},S,r);u.push(...r.cells.map(n=>w.ExtHostCell.asModelAddData(i.apiNotebook,n))),this._documents.get(S)?.dispose(),this._documents.set(S,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:u}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(h.value.addedEditors)for(const u of h.value.addedEditors){if(this._editors.has(u.id))return;const r=P.URI.revive(u.documentUri),S=this._documents.get(r);S&&this._createExtHostEditor(S,u.id,u)}const s=[];if(h.value.removedEditors)for(const u of h.value.removedEditors){const r=this._editors.get(u);r&&(this._editors.delete(u),this._activeNotebookEditor?.id===r.id&&(this._activeNotebookEditor=void 0),s.push(r))}if(h.value.visibleEditors){this._visibleNotebookEditors=h.value.visibleEditors.map(r=>this._editors.get(r)).filter(r=>!!r);const u=new Set;this._visibleNotebookEditors.forEach(r=>u.add(r.id));for(const r of this._editors.values()){const S=u.has(r.id);r._acceptVisibility(S)}this._visibleNotebookEditors=[...this._editors.values()].map(r=>r).filter(r=>r.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}h.value.newActiveEditor===null?this._activeNotebookEditor=void 0:h.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(h.value.newActiveEditor)),h.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=R,R._notebookStatusBarItemProviderHandlePool=0}),define(pe[247],ve([0,1,3,76,12,5,14,15]),function(ee,e,d,t,I,C,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class D{constructor(y,c){const E=D._Keys.nextId();y.$registerNotebookEditorDecorationType(E,k.NotebookDecorationRenderOptions.from(c)),this.value={key:E,dispose(){y.$removeNotebookEditorDecorationType(E)}}}}D._Keys=new t.IdGenerator("NotebookEditorDecorationType");let P=class{constructor(y,c,E){this._logService=y,this._extHostRpc=c,this._notebooksAndEditors=E,this._onDidChangeNotebookEditorSelection=new d.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new d.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(y){return new D(this._extHostRpc.getProxy(C.MainContext.MainThreadNotebookEditors),y).value}$acceptEditorPropertiesChanged(y,c){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",y,c);const E=this._notebooksAndEditors.getEditorById(y);c.visibleRanges&&E._acceptVisibleRanges(c.visibleRanges.ranges.map(k.NotebookRange.to)),c.selections&&E._acceptSelections(c.selections.selections.map(k.NotebookRange.to)),c.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),c.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(y){for(const c in y)this._notebooksAndEditors.getEditorById(c)._acceptViewColumn(k.ViewColumn.to(y[c]))}};P=Be([Me(0,I.ILogService),Me(1,T.IExtHostRpcService)],P),e.ExtHostNotebookEditors=P}),define(pe[248],ve([0,1,17,13,21,3,6,24,2,27,12,5,39,15,7,88,214,30,52]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c,E,v,w,_,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let h=class{constructor(i,n,o,l,f){this._initData=n,this._extHostNotebook=o,this._commands=l,this._logService=f,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new C.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=i.getProxy(y.MainContext.MainThreadNotebookKernels);const m=new c.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new c.ApiCommandArgument("options","Select kernel options",b=>!0,b=>{if(b&&"notebookEditor"in b&&"id"in b){const A=this._extHostNotebook.getIdByEditor(b.notebookEditor);return{id:b.id,extension:b.extension,notebookEditorId:A}}else if(b&&"notebookEditor"in b){const A=this._extHostNotebook.getIdByEditor(b.notebookEditor);if(A===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${b.notebookEditor.document.uri.toString()}`);return{notebookEditorId:A}}return b})],c.ApiCommandResult.Void);this._commands.registerApiCommand(m)}createNotebookController(i,n,o,l,f,m){for(const Z of this._kernelData.values())if(Z.controller.id===n&&P.ExtensionIdentifier.equals(i.identifier,Z.extensionId))throw new Error(`notebook controller with id '${n}' ALREADY exist`);const b=this._handlePool++,A=this;this._logService.trace(`NotebookController[${b}], CREATED by ${i.identifier.value}, ${n}`);const L=()=>console.warn(`NO execute handler from notebook controller '${j.id}' of extension: '${i.identifier}'`);let N=!1;const g=new T.DisposableStore,M=new C.Emitter,U=new C.Emitter,j={id:S(i,n),notebookType:o,extensionId:i.identifier,extensionLocation:i.extensionLocation,label:l||i.identifier.value,preloads:m?m.map(E.NotebookRendererScript.from):[]};let K=f??L,B;this._proxy.$addKernel(b,j).catch(Z=>{console.log(Z),N=!0});let x=0;const z=()=>{if(N)return;const Z=++x;Promise.resolve().then(()=>{Z===x&&this._proxy.$updateKernel(b,j)})},G=new k.ResourceMap,q={get id(){return n},get notebookType(){return j.notebookType},onDidChangeSelectedNotebooks:M.event,get label(){return j.label},set label(Z){j.label=Z??i.displayName??i.name,z()},get detail(){return j.detail??""},set detail(Z){j.detail=Z,z()},get description(){return j.description??""},set description(Z){j.description=Z,z()},get kind(){return(0,R.checkProposedApiEnabled)(i,"notebookControllerKind"),j.kind??""},set kind(Z){(0,R.checkProposedApiEnabled)(i,"notebookControllerKind"),j.kind=Z,z()},get supportedLanguages(){return j.supportedLanguages},set supportedLanguages(Z){j.supportedLanguages=Z,z()},get supportsExecutionOrder(){return j.supportsExecutionOrder??!1},set supportsExecutionOrder(Z){j.supportsExecutionOrder=Z,z()},get rendererScripts(){return j.preloads?j.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(Z){K=Z??L},get interruptHandler(){return B},set interruptHandler(Z){B=Z,j.supportsInterrupt=Boolean(Z),z()},createNotebookCellExecution(Z){if(N)throw new Error("notebook controller is DISPOSED");if(!G.has(Z.notebook.uri))throw A._logService.trace(`NotebookController[${b}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(G.keys()).map(se=>se.toString())),new Error(`notebook controller is NOT associated to notebook: ${Z.notebook.uri.toString()}`);return A._createNotebookCellExecution(Z,S(i,this.id))},dispose:()=>{N||(this._logService.trace(`NotebookController[${b}], DISPOSED`),N=!0,this._kernelData.delete(b),g.dispose(),M.dispose(),U.dispose(),this._proxy.$removeKernel(b))},updateNotebookAffinity(Z,se){A._proxy.$updateNotebookPriority(b,Z.uri,se)},onDidReceiveMessage:U.event,postMessage(Z,se){return(0,R.checkProposedApiEnabled)(i,"notebookMessaging"),A._proxy.$postMessage(b,se&&A._extHostNotebook.getIdByEditor(se),Z)},asWebviewUri(Z){return(0,R.checkProposedApiEnabled)(i,"notebookMessaging"),(0,w.asWebviewUri)(Z,A._initData.remote)}};return this._kernelData.set(b,{extensionId:i.identifier,controller:q,onDidReceiveMessage:U,onDidChangeSelection:M,associatedNotebooks:G}),q}$acceptNotebookAssociation(i,n,o){const l=this._kernelData.get(i);if(l){const f=this._extHostNotebook.getNotebookDocument(D.URI.revive(n));o?l.associatedNotebooks.set(f.uri,!0):l.associatedNotebooks.delete(f.uri),this._logService.trace(`NotebookController[${i}] ASSOCIATE notebook`,f.uri.toString(),o),l.onDidChangeSelection.fire({selected:o,notebook:f.apiNotebook})}}async $executeCells(i,n,o){const l=this._kernelData.get(i);if(!l)return;const f=this._extHostNotebook.getNotebookDocument(D.URI.revive(n)),m=[];for(const b of o){const A=f.getCell(b);A&&m.push(A.apiCell)}try{this._logService.trace(`NotebookController[${i}] EXECUTE cells`,f.uri.toString(),m.length),await l.controller.executeHandler.call(l.controller,m,f.apiNotebook,l.controller)}catch(b){this._logService.error(`NotebookController[${i}] execute cells FAILED`,b),console.error(b)}}async $cancelCells(i,n,o){const l=this._kernelData.get(i);if(!l)return;const f=this._extHostNotebook.getNotebookDocument(D.URI.revive(n));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,f.apiNotebook);else for(const m of o){const b=f.getCell(m);b&&this._activeExecutions.get(b.uri)?.cancel()}}$acceptKernelMessageFromRenderer(i,n,o){const l=this._kernelData.get(i);if(!l)return;const f=this._extHostNotebook.getEditorById(n);l.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:o}))}$cellExecutionChanged(i,n,o){const f=this._extHostNotebook.getNotebookDocument(D.URI.revive(i)).getCell(n);f&&this._onDidChangeCellExecutionState.fire({cell:f.apiCell,state:o??v.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(i,n){if(i.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const l=this._extHostNotebook.getNotebookDocument(i.notebook.uri).getCellFromApiCell(i);if(!l)throw new Error("invalid cell");if(this._activeExecutions.has(l.uri))throw new Error(`duplicate execution for ${l.uri}`);const f=new u(n,l,this._proxy);this._activeExecutions.set(l.uri,f);const m=f.onDidChangeState(()=>{f.state===s.Resolved&&(f.dispose(),m.dispose(),this._activeExecutions.delete(l.uri))});return f.asApiObject()}};h=Be([Me(4,F.ILogService)],h),e.ExtHostNotebookKernels=h;var s;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(s||(s={}));class u extends T.Disposable{constructor(i,n,o){super();this._cell=n,this._proxy=o,this._handle=u.HANDLE++,this._onDidChangeState=new C.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=s.Init,this._tokenSource=this._register(new I.CancellationTokenSource),this._collector=new r(10,l=>this.update(l)),this._executionOrder=n.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,i,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(i){await this._collector.addItem(i)}async update(i){const n=Array.isArray(i)?i:[i];return this._proxy.$updateExecution(this._handle,new p.SerializableObjectWithBuffers(n))}verifyStateForOutput(){if(this._state===s.Init)throw new Error("Must call start before modifying cell output");if(this._state===s.Resolved)throw new Error("Cannot modify cell output after calling resolve")}validateAndConvertOutputs(i){return i.map(n=>{const o=v.NotebookCellOutput.ensureUniqueMimeTypes(n.items,!0);return o===n.items?E.NotebookCellOutput.from(n):E.NotebookCellOutput.from({items:o,id:n.id,metadata:n.metadata})})}async updateOutputs(i,n,o){const l=this.validateAndConvertOutputs((0,d.asArray)(i));return this.updateSoon({editType:_.CellExecutionUpdateType.Output,append:o,outputs:l})}async updateOutputItems(i,n,o){return i=v.NotebookCellOutput.ensureUniqueMimeTypes((0,d.asArray)(i),!0),this.updateSoon({editType:_.CellExecutionUpdateType.OutputItems,items:i.map(E.NotebookCellOutputItem.from),outputId:n.id,append:o})}asApiObject(){const i=this;return Object.freeze({get token(){return i._tokenSource.token},get cell(){return i._cell.apiCell},get executionOrder(){return i._executionOrder},set executionOrder(o){i._executionOrder=o,i.update([{editType:_.CellExecutionUpdateType.ExecutionState,executionOrder:i._executionOrder}])},start(o){if(i._state===s.Resolved||i._state===s.Started)throw new Error("Cannot call start again");i._state=s.Started,i._onDidChangeState.fire(),i.update({editType:_.CellExecutionUpdateType.ExecutionState,runStartTime:o})},end(o,l){if(i._state===s.Resolved)throw new Error("Cannot call resolve twice");i._state=s.Resolved,i._onDidChangeState.fire(),i._collector.flush(),i._proxy.$completeExecution(i._handle,new p.SerializableObjectWithBuffers({runEndTime:l,lastRunSuccess:o}))},clearOutput(o){return i.verifyStateForOutput(),i.updateOutputs([],o,!1)},appendOutput(o,l){return i.verifyStateForOutput(),i.updateOutputs(o,l,!0)},replaceOutput(o,l){return i.verifyStateForOutput(),i.updateOutputs(o,l,!1)},appendOutputItems(o,l){return i.verifyStateForOutput(),i.updateOutputItems(o,l,!0)},replaceOutputItems(o,l){return i.verifyStateForOutput(),i.updateOutputItems(o,l,!1)}})}}u.HANDLE=0;class r{constructor(i,n){this.delay=i,this.callback=n,this.batch=[],this.startedTimer=Date.now()}addItem(i){return this.batch.push(i),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const i=this.currentDeferred;this.currentDeferred=void 0;const n=this.batch;return this.batch=[],this.callback(n).finally(()=>i.complete())}}function S(a,i){return`${a.identifier.value}/${i}`}}),define(pe[249],ve([0,1,3,5,130,30]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class T{constructor(D,P){this._extHostNotebook=P,this._rendererMessageEmitters=new Map,this.proxy=D.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(D,P,F){const y=this._extHostNotebook.getEditorById(D);this._rendererMessageEmitters.get(P)?.fire({editor:y.apiEditor,message:F})}createRendererMessaging(D,P){if(!D.contributes?.notebookRenderer?.some(E=>E.id===P))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${P})`);const F=(0,C.isProposedApiEnabled)(D,"notebookEditor"),y=new WeakMap;return{onDidReceiveMessage:(E,v,w)=>{const _=F?E:R=>{const p={};y.set(p,R.editor),E({editor:p,message:R.message})};return this.getOrCreateEmitterFor(P).event(_,v,w)},postMessage:(E,v)=>{I.ExtHostNotebookEditor.apiEditorsToExtHost.has(E)&&([E,v]=[v,E]);const w=F?v:y.get(v),_=w&&I.ExtHostNotebookEditor.apiEditorsToExtHost.get(w);return this.proxy.$postMessage(_?.id,P,E)}}}getOrCreateEmitterFor(D){let P=this._rendererMessageEmitters.get(D);return P||(P=new d.Emitter({onLastListenerRemove:()=>{P?.dispose(),this._rendererMessageEmitters.delete(D)}}),this._rendererMessageEmitters.set(D,P),P)}}e.ExtHostNotebookRenderers=T}),define(pe[134],ve([0,1,5,6,4,14,12,215,66,26,44,156,23]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class E extends t.Disposable{constructor(_,R,p,h){super();this.id=_,this.name=R,this.logger=p,this.proxy=h,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(_){this.append(_+`
`)}append(_){this.write(_),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Append))}clear(){const _=this.offset;this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Clear,_)}replace(_){const R=this.offset;this.write(_),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Replace,R),this.visible&&this.logger.flush()}show(_,R){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof _=="boolean"?_:R))}hide(){this.proxy.$close(this.id)}write(_){this.offset+=c.VSBuffer.fromString(_).byteLength,this.logger.info(_)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=E;let v=class{constructor(_,R,p,h,s){this.extHostFileSystem=p,this.extHostFileSystemInfo=h,this.loggerService=s,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=_.getProxy(d.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(R.logsLocation,`output_logging_${(0,y.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(_){this.visibleChannelId=_;for(const[R,p]of this.channels)p.visible=R===this.visibleChannelId}createOutputChannel(_,R){if(_=_.trim(),!_)throw new Error("illegal argument `name`. must not be falsy");const p=this.doCreateOutputChannel(_,R);return p.then(h=>{this.channels.set(h.id,h),h.visible=h.id===this.visibleChannelId}),this.createExtHostOutputChannel(_,p)}async doCreateOutputChannel(_,R){const p=await this.createOutputDirectory(),h=this.extHostFileSystemInfo.extUri.joinPath(p,`${this.namePool++}-${_.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),s=this.loggerService.createLogger(h,{always:!0,donotRotate:!0,donotUseFormatters:!0}),u=await this.proxy.$register(_,!1,h,R.identifier.value);return new E(u,_,s,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(_,R){let p=!1;const h=()=>{if(p)throw new Error("Channel has been closed")};return{get name(){return _},append(s){h(),R.then(u=>u.append(s))},appendLine(s){h(),R.then(u=>u.appendLine(s))},clear(){h(),R.then(s=>s.clear())},replace(s){h(),R.then(u=>u.replace(s))},show(s,u){h(),R.then(r=>r.show(s,u))},hide(){h(),R.then(s=>s.hide())},dispose(){p=!0,R.then(s=>s.dispose())}}}};v=Be([Me(0,C.IExtHostRpcService),Me(1,P.IExtHostInitDataService),Me(2,D.IExtHostConsumerFileSystem),Me(3,F.IExtHostFileSystemInfo),Me(4,T.ILoggerService)],v),e.ExtHostOutputService=v,e.IExtHostOutputService=(0,I.createDecorator)("IExtHostOutputService")}),define(pe[250],ve([0,1,13,21,3,6,5,2,7,16,17,47,86]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function E(v,w,_){const R=v.getProxy(T.MainContext.MainThreadQuickOpen);class p{constructor(o,l){this._sessions=new Map,this._instances=0,this._workspace=o,this._commands=l}showQuickPick(o,l,f=t.CancellationToken.None){this._onDidSelectItem=void 0;const m=Promise.resolve(o),b=++this._instances,A=R.$show(b,{title:l?.title,placeHolder:l?.placeHolder,matchOnDescription:l?.matchOnDescription,matchOnDetail:l?.matchOnDetail,ignoreFocusLost:l?.ignoreFocusOut,canPickMany:l?.canPickMany},f),L={},N=A.then(()=>L);return Promise.race([N,m]).then(g=>{if(g!==L)return m.then(M=>{const U=[];for(let j=0;j<M.length;j++){const K=M[j];typeof K=="string"?U.push({label:K,handle:j}):K.kind===D.QuickPickItemKind.Separator?U.push({type:"separator",label:K.label}):U.push({label:K.label,description:K.description,detail:K.detail,picked:K.picked,alwaysShow:K.alwaysShow,handle:j})}return l&&typeof l.onDidSelectItem=="function"&&(this._onDidSelectItem=j=>{l.onDidSelectItem(M[j])}),R.$setItems(b,U),A.then(j=>{if(typeof j=="number")return M[j];if(Array.isArray(j))return j.map(K=>M[K])})})}).then(void 0,g=>{if(!(0,P.isCancellationError)(g))return R.$setError(b,g),Promise.reject(g)})}$onItemSelected(o){this._onDidSelectItem&&this._onDidSelectItem(o)}showInput(o,l=t.CancellationToken.None){return this._validateInput=o?o.validateInput:void 0,R.$input(o,typeof this._validateInput=="function",l).then(void 0,f=>{if(!(0,P.isCancellationError)(f))return Promise.reject(f)})}$validateInput(o){return this._validateInput?(0,d.asPromise)(()=>this._validateInput(o)):Promise.resolve(void 0)}async showWorkspaceFolderPick(o,l=t.CancellationToken.None){const f=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[o]);if(!f)return;const m=await this._workspace.getWorkspaceFolders2();if(!!m)return m.find(b=>b.uri.toString()===f.uri.toString())}createQuickPick(o){const l=new a(o,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}createInputBox(o){const l=new i(o,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}$onDidChangeValue(o,l){const f=this._sessions.get(o);f&&f._fireDidChangeValue(l)}$onDidAccept(o){const l=this._sessions.get(o);l&&l._fireDidAccept()}$onDidChangeActive(o,l){const f=this._sessions.get(o);f instanceof a&&f._fireDidChangeActive(l)}$onDidChangeSelection(o,l){const f=this._sessions.get(o);f instanceof a&&f._fireDidChangeSelection(l)}$onDidTriggerButton(o,l){const f=this._sessions.get(o);f&&f._fireDidTriggerButton(l)}$onDidTriggerItemButton(o,l,f){const m=this._sessions.get(o);m instanceof a&&m._fireDidTriggerItemButton(l,f)}$onDidHide(o){const l=this._sessions.get(o);l&&l._fireDidHide()}}class h{constructor(o,l){this._extensionId=o,this._onDidDispose=l,this._id=a._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new I.Emitter,this._onDidChangeValueEmitter=new I.Emitter,this._onDidTriggerButtonEmitter=new I.Emitter,this._onDidHideEmitter=new I.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(o){this._title=o,this.update({title:o})}get step(){return this._steps}set step(o){this._steps=o,this.update({step:o})}get totalSteps(){return this._totalSteps}set totalSteps(o){this._totalSteps=o,this.update({totalSteps:o})}get enabled(){return this._enabled}set enabled(o){this._enabled=o,this.update({enabled:o})}get busy(){return this._busy}set busy(o){this._busy=o,this.update({busy:o})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(o){this._ignoreFocusOut=o,this.update({ignoreFocusOut:o})}get value(){return this._value}set value(o){this._value=o,this.update({value:o})}get placeholder(){return this._placeholder}set placeholder(o){this._placeholder=o,this.update({placeholder:o})}get buttons(){return this._buttons}set buttons(o){this._buttons=o.slice(),this._handlesToButtons.clear(),o.forEach((l,f)=>{const m=l===D.QuickInputButtons.Back?-1:f;this._handlesToButtons.set(m,l)}),this.update({buttons:o.map((l,f)=>({...S(l),tooltip:l.tooltip,handle:l===D.QuickInputButtons.Back?-1:f}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(o){this._value=o,this._onDidChangeValueEmitter.fire(o)}_fireDidTriggerButton(o){const l=this._handlesToButtons.get(o);l&&this._onDidTriggerButtonEmitter.fire(l)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,C.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),R.$dispose(this._id))}update(o){if(!this._disposed){for(const l of Object.keys(o)){const f=o[l];this._pendingUpdate[l]=f===void 0?null:f}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){R.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}h._nextId=1;function s(n){if(n instanceof D.ThemeIcon)return{id:n.id};const o=r(n),l=u(n);return{dark:typeof o=="string"?k.URI.file(o):o,light:typeof l=="string"?k.URI.file(l):l}}function u(n){return typeof n=="object"&&"light"in n?n.light:n}function r(n){return typeof n=="object"&&"dark"in n?n.dark:n}function S(n){const o=s(n.iconPath);let l,f;return"id"in o?f=c.ThemeIcon.asClassName(o):l=o,{iconPath:l,iconClass:f}}class a extends h{constructor(o,l){super(o.identifier,l);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new I.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new I.Emitter,this._onDidTriggerItemButtonEmitter=new I.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(o){this._items=o.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),o.forEach((f,m)=>{this._handlesToItems.set(m,f),this._itemsToHandles.set(f,m)});const l=[];for(let f=0;f<o.length;f++){const m=o[f];m.kind===D.QuickPickItemKind.Separator?l.push({type:"separator",label:m.label}):l.push({handle:f,label:m.label,description:m.description,detail:m.detail,picked:m.picked,alwaysShow:m.alwaysShow,buttons:m.buttons?.map((b,A)=>({...S(b),tooltip:b.tooltip,handle:A}))})}this.update({items:l})}get canSelectMany(){return this._canSelectMany}set canSelectMany(o){this._canSelectMany=o,this.update({canSelectMany:o})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(o){this._matchOnDescription=o,this.update({matchOnDescription:o})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(o){this._matchOnDetail=o,this.update({matchOnDetail:o})}get sortByLabel(){return this._sortByLabel}set sortByLabel(o){this._sortByLabel=o,this.update({sortByLabel:o})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(o){this._keepScrollPosition=o,this.update({keepScrollPosition:o})}get activeItems(){return this._activeItems}set activeItems(o){this._activeItems=o.filter(l=>this._itemsToHandles.has(l)),this.update({activeItems:this._activeItems.map(l=>this._itemsToHandles.get(l))})}get selectedItems(){return this._selectedItems}set selectedItems(o){this._selectedItems=o.filter(l=>this._itemsToHandles.has(l)),this.update({selectedItems:this._selectedItems.map(l=>this._itemsToHandles.get(l))})}_fireDidChangeActive(o){const l=(0,F.coalesce)(o.map(f=>this._handlesToItems.get(f)));this._activeItems=l,this._onDidChangeActiveEmitter.fire(l)}_fireDidChangeSelection(o){const l=(0,F.coalesce)(o.map(f=>this._handlesToItems.get(f)));this._selectedItems=l,this._onDidChangeSelectionEmitter.fire(l)}_fireDidTriggerItemButton(o,l){const f=this._handlesToItems.get(o);if(!f||!f.buttons||!f.buttons.length)return;const m=f.buttons[l];m&&this._onDidTriggerItemButtonEmitter.fire({button:m,item:f})}}class i extends h{constructor(o,l){super(o,l);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(o){this._password=o,this.update({password:o})}get prompt(){return this._prompt}set prompt(o){this._prompt=o,this.update({prompt:o})}get validationMessage(){return this._validationMessage}set validationMessage(o){this._validationMessage=o,this.update({validationMessage:o,severity:o?y.default.Error:y.default.Ignore})}}return new p(w,_)}e.createExtHostQuickOpen=E});var Qe=this&&this.__classPrivateFieldSet||function(ee,e,d,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,d):I?I.value=d:e.set(ee,d),d},Te=this&&this.__classPrivateFieldGet||function(ee,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(ee):t?t.value:e.get(ee)};define(pe[251],ve([0,1,2,3,56,6,13,5,17,102,12,27,86,15,30]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c,E,v){"use strict";var w,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function R(f){if(f)return typeof f.iconPath=="string"?d.URI.file(f.iconPath):d.URI.isUri(f.iconPath)||c.ThemeIcon.isThemeIcon(f.iconPath)?f.iconPath:void 0}function p(f,m){if(!f.iconPath&&!m.iconPath)return 0;if(f.iconPath){if(!m.iconPath)return 1}else return-1;const b=typeof f.iconPath=="string"?f.iconPath:d.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id,A=typeof m.iconPath=="string"?m.iconPath:d.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id;return(0,P.comparePaths)(b,A)}function h(f,m){let b=0;if(f.strikeThrough!==m.strikeThrough)return f.strikeThrough?1:-1;if(f.faded!==m.faded)return f.faded?1:-1;if(f.tooltip!==m.tooltip)return(f.tooltip||"").localeCompare(m.tooltip||"");if(b=p(f,m),b!==0)return b;if(f.light&&m.light)b=p(f.light,m.light);else{if(f.light)return 1;if(m.light)return-1}if(b!==0)return b;if(f.dark&&m.dark)b=p(f.dark,m.dark);else{if(f.dark)return 1;if(m.dark)return-1}return b}function s(f,m){if(f.command!==m.command)return f.command<m.command?-1:1;if(f.title!==m.title)return f.title<m.title?-1:1;if(f.tooltip!==m.tooltip){if(f.tooltip!==void 0&&m.tooltip!==void 0)return f.tooltip<m.tooltip?-1:1;if(f.tooltip!==void 0)return 1;if(m.tooltip!==void 0)return-1}if(f.arguments===m.arguments)return 0;if(f.arguments)if(m.arguments){if(f.arguments.length!==m.arguments.length)return f.arguments.length-m.arguments.length}else return 1;else return-1;for(let b=0;b<f.arguments.length;b++){const A=f.arguments[b],L=m.arguments[b];if(A!==L)return A<L?-1:1}return 0}function u(f,m){let b=(0,P.comparePaths)(f.resourceUri.fsPath,m.resourceUri.fsPath,!0);if(b!==0)return b;if(f.command&&m.command)b=s(f.command,m.command);else{if(f.command)return 1;if(m.command)return-1}if(b!==0)return b;if(f.decorations&&m.decorations)b=h(f.decorations,m.decorations);else{if(f.decorations)return 1;if(m.decorations)return-1}return b}function r(f,m){for(let b=0;b<f.length;b++)if(f[b]!==m[b])return!1;return!0}function S(f,m){return f.command===m.command&&f.title===m.title&&f.tooltip===m.tooltip&&(f.arguments&&m.arguments?r(f.arguments,m.arguments):f.arguments===m.arguments)}function a(f,m){return(0,D.equals)(f,m,S)}class i{constructor(m,b,A){this._extension=m,this._sourceControlHandle=A,w.set(this,void 0),this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._visible=!0,Qe(this,w,b,"f")}get value(){return this._value}set value(m){m=m??"",Te(this,w,"f").$setInputBoxValue(this._sourceControlHandle,m),this.updateValue(m)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(m){Te(this,w,"f").$setInputBoxPlaceholder(this._sourceControlHandle,m),this._placeholder=m}get validateInput(){return(0,v.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(m){if((0,v.checkProposedApiEnabled)(this._extension,"scmValidation"),m&&typeof m!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=m,Te(this,w,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!m)}get visible(){return this._visible}set visible(m){m=!!m,this._visible!==m&&(this._visible=m,Te(this,w,"f").$setInputBoxVisibility(this._sourceControlHandle,m))}showValidationMessage(m,b){(0,v.checkProposedApiEnabled)(this._extension,"scmValidation"),Te(this,w,"f").$showValidationMessage(this._sourceControlHandle,m,b)}$onInputBoxValueChange(m){this.updateValue(m)}updateValue(m){this._value=m,this._onDidChange.fire(m)}}e.ExtHostSCMInputBox=i,w=new WeakMap;class n{constructor(m,b,A,L,N){this._proxy=m,this._commands=b,this._sourceControlHandle=A,this._id=L,this._label=N,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=n._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(m){this._label=m,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,m)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(m){this._hideWhenEmpty=m,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(m){this._resourceStates=[...m],this._onDidUpdateResourceStates.fire()}getResourceState(m){return this._resourceStatesMap.get(m)}$executeResourceCommand(m,b){const A=this._resourceStatesCommandsMap.get(m);return A?(0,T.asPromise)(()=>this._commands.executeCommand(A.command,...A.arguments||[],b)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const m=[...this._resourceStates].sort(u),A=(0,D.sortedDiff)(this._resourceSnapshot,m,u).map(g=>{const M=g.toInsert.map(U=>{const j=this._resourceHandlePool++;this._resourceStatesMap.set(j,U);const K=U.resourceUri;let B;if(U.command)if(U.command.command==="vscode.open"||U.command.command==="vscode.diff"){const ae=new C.DisposableStore;B=this._commands.converter.toInternal(U.command,ae),this._resourceStatesDisposablesMap.set(j,ae)}else this._resourceStatesCommandsMap.set(j,U.command);const x=R(U.decorations),z=U.decorations&&R(U.decorations.light)||x,G=U.decorations&&R(U.decorations.dark)||x,q=[z,G],Z=U.decorations&&U.decorations.tooltip||"",se=U.decorations&&!!U.decorations.strikeThrough,ue=U.decorations&&!!U.decorations.faded,te=U.contextValue||"";return{rawResource:[j,K,q,Z,se,ue,te,B],handle:j}});return{start:g.start,deleteCount:g.deleteCount,toInsert:M}}),L=A.map(({start:g,deleteCount:M,toInsert:U})=>[g,M,U.map(j=>j.rawResource)]),N=A.reverse();for(const{start:g,deleteCount:M,toInsert:U}of N){const j=U.map(B=>B.handle),K=this._handlesSnapshot.splice(g,M,...j);for(const B of K)this._resourceStatesMap.delete(B),this._resourceStatesCommandsMap.delete(B),this._resourceStatesDisposablesMap.get(B)?.dispose(),this._resourceStatesDisposablesMap.delete(B)}return this._resourceSnapshot=m,L}dispose(){this._disposed=!0,this._onDidDispose.fire()}}n._handlePool=0;class o{constructor(m,b,A,L,N,g){this._extension=m,this._commands=A,this._id=L,this._label=N,this._rootUri=g,_.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new C.MutableDisposable,this._statusBarDisposables=new C.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=o._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Qe(this,_,b,"f"),this._inputBox=new i(m,Te(this,_,"f"),this.handle),Te(this,_,"f").$registerSourceControl(this.handle,L,N,g)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(m){this._count!==m&&(this._count=m,Te(this,_,"f").$updateSourceControl(this.handle,{count:m}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(m){this._quickDiffProvider=m,Te(this,_,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!m})}get commitTemplate(){return this._commitTemplate}set commitTemplate(m){m!==this._commitTemplate&&(this._commitTemplate=m,Te(this,_,"f").$updateSourceControl(this.handle,{commitTemplate:m}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(m){this._acceptInputDisposables.value=new C.DisposableStore,this._acceptInputCommand=m;const b=this._commands.converter.toInternal(m,this._acceptInputDisposables.value);Te(this,_,"f").$updateSourceControl(this.handle,{acceptInputCommand:b})}get actionButton(){return(0,v.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(m){(0,v.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new C.DisposableStore,this._actionButton=m;const b=m!==void 0?{command:this._commands.converter.toInternal(m.command,this._actionButtonDisposables.value),description:m.description}:void 0;Te(this,_,"f").$updateSourceControl(this.handle,{actionButton:b??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(m){if(this._statusBarCommands&&m&&a(this._statusBarCommands,m))return;this._statusBarDisposables.value=new C.DisposableStore,this._statusBarCommands=m;const b=(m||[]).map(A=>this._commands.converter.toInternal(A,this._statusBarDisposables.value));Te(this,_,"f").$updateSourceControl(this.handle,{statusBarCommands:b})}get selected(){return this._selected}createResourceGroup(m,b){const A=new n(Te(this,_,"f"),this._commands,this.handle,m,b),L=t.Event.once(A.onDidDispose)(()=>this.createdResourceGroups.delete(A));return this.createdResourceGroups.set(A,L),this.eventuallyAddResourceGroups(),A}eventuallyAddResourceGroups(){const m=[],b=[];for(const[A,L]of this.createdResourceGroups){L.dispose();const N=A.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(A),this.eventuallyUpdateResourceStates()});t.Event.once(A.onDidDispose)(()=>{this.updatedResourceGroups.delete(A),N.dispose(),this._groups.delete(A.handle),Te(this,_,"f").$unregisterGroup(this.handle,A.handle)}),m.push([A.handle,A.id,A.label,A.features]);const g=A._takeResourceStateSnapshot();g.length>0&&b.push([A.handle,g]),this._groups.set(A.handle,A)}Te(this,_,"f").$registerGroups(this.handle,m,b),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const m=[];this.updatedResourceGroups.forEach(b=>{const A=b._takeResourceStateSnapshot();A.length!==0&&m.push([b.handle,A])}),m.length>0&&Te(this,_,"f").$spliceResourceStates(this.handle,m),this.updatedResourceGroups.clear()}getResourceGroup(m){return this._groups.get(m)}setSelectionState(m){this._selected=m,this._onDidChangeSelection.fire(m)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(m=>m.dispose()),Te(this,_,"f").$unregisterSourceControl(this.handle)}}_=new WeakMap,o._handlePool=0,Be([(0,I.debounce)(100)],o.prototype,"eventuallyAddResourceGroups",null),Be([(0,I.debounce)(100)],o.prototype,"eventuallyUpdateResourceStates",null);let l=class Vi{constructor(m,b,A){this._commands=b,this.logService=A,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=m.getProxy(k.MainContext.MainThreadSCM),this._telemetry=m.getProxy(k.MainContext.MainThreadTelemetry),b.registerArgumentProcessor({processArgument:L=>{if(L&&L.$mid===3){const N=this._sourceControls.get(L.sourceControlHandle);if(!N)return L;const g=N.getResourceGroup(L.groupHandle);return g?g.getResourceState(L.handle):L}else if(L&&L.$mid===4){const N=this._sourceControls.get(L.sourceControlHandle);return N?N.getResourceGroup(L.groupHandle):L}else if(L&&L.$mid===5){const N=this._sourceControls.get(L.handle);return N||L}return L}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(m,b,A,L){this.logService.trace("ExtHostSCM#createSourceControl",m.identifier.value,b,A,L),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:m.identifier.value});const N=Vi._handlePool++,g=new o(m,this._proxy,this._commands,b,A,L);this._sourceControls.set(N,g);const M=this._sourceControlsByExtension.get(y.ExtensionIdentifier.toKey(m.identifier))||[];return M.push(g),this._sourceControlsByExtension.set(y.ExtensionIdentifier.toKey(m.identifier),M),g}getLastInputBox(m){this.logService.trace("ExtHostSCM#getLastInputBox",m.identifier.value);const b=this._sourceControlsByExtension.get(y.ExtensionIdentifier.toKey(m.identifier)),A=b&&b[b.length-1];return A&&A.inputBox}$provideOriginalResource(m,b,A){const L=d.URI.revive(b);this.logService.trace("ExtHostSCM#$provideOriginalResource",m,L.toString());const N=this._sourceControls.get(m);return!N||!N.quickDiffProvider||!N.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.asPromise)(()=>N.quickDiffProvider.provideOriginalResource(L,A)).then(g=>g||null)}$onInputBoxValueChange(m,b){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",m);const A=this._sourceControls.get(m);return A&&A.inputBox.$onInputBoxValueChange(b),Promise.resolve(void 0)}$executeResourceCommand(m,b,A,L){this.logService.trace("ExtHostSCM#$executeResourceCommand",m,b,A);const N=this._sourceControls.get(m);if(!N)return Promise.resolve(void 0);const g=N.getResourceGroup(b);return g?g.$executeResourceCommand(A,L):Promise.resolve(void 0)}$validateInput(m,b,A){this.logService.trace("ExtHostSCM#$validateInput",m);const L=this._sourceControls.get(m);return!L||!L.inputBox.validateInput?Promise.resolve(void 0):(0,T.asPromise)(()=>L.inputBox.validateInput(b,A)).then(N=>{if(!N)return Promise.resolve(void 0);const g=E.MarkdownString.fromStrict(N.message);return g?Promise.resolve([g,N.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(m){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",m),m!==void 0&&this._sourceControls.get(m)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=m,Promise.resolve(void 0)}};l._handlePool=0,l=Be([Me(2,F.ILogService)],l),e.ExtHostSCM=l});var Qe=this&&this.__classPrivateFieldSet||function(ee,e,d,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,d):I?I.value=d:e.set(ee,d),d},Te=this&&this.__classPrivateFieldGet||function(ee,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(ee):t?t.value:e.get(ee)};define(pe[252],ve([0,1,7,5,170,6,15,18]),function(ee,e,d,t,I,C,T,k){"use strict";var D,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class F{constructor(v,w,_,R,p=d.StatusBarAlignment.Left,h){D.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new C.DisposableStore,Qe(this,D,v,"f"),Qe(this,P,w,"f"),this._entryId=F.ID_GEN++,this._extension=_,this._id=R,this._alignment=p,this._priority=this.validatePriority(h)}validatePriority(v){if(!!(0,k.isNumber)(v))return v===Number.POSITIVE_INFINITY?Number.MAX_VALUE:v===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:v}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(v){this._text=v,this.update()}set name(v){this._name=v,this.update()}set tooltip(v){this._tooltip=v,this.update()}set color(v){this._color=v,this.update()}set backgroundColor(v){v&&!F.ALLOWED_BACKGROUND_COLORS.has(v.id)&&(v=void 0),this._backgroundColor=v,this.update()}set command(v){this._command?.fromApi!==v&&(this._internalCommandRegistration.clear(),typeof v=="string"?this._command={fromApi:v,internal:Te(this,P,"f").toInternal({title:"",command:v},this._internalCommandRegistration)}:v?this._command={fromApi:v,internal:Te(this,P,"f").toInternal(v,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(v){this._accessibilityInformation=v,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Te(this,D,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let v;this._extension?this._id?v=`${this._extension.identifier.value}.${this._id}`:v=this._extension.identifier.value:v=this._id;let w;this._name?w=this._name:w=(0,I.localize)(0,null,this._extension.displayName||this._extension.name);let _=this._color;this._backgroundColor&&(_=F.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const R=this._tooltip?T.MarkdownString.fromStrict(this._tooltip):void 0;Te(this,D,"f").$setEntry(this._entryId,v,w,this._text,R,this._command?.internal,_,this._backgroundColor,this._alignment===d.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=F,D=new WeakMap,P=new WeakMap,F.ID_GEN=0,F.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new d.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new d.ThemeColor("statusBarItem.warningForeground")]]);class y{constructor(v){this._messages=[],this._item=v.createStatusBarEntry(void 0,"status.extensionMessage",d.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,I.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(v){const w={message:v};return this._messages.unshift(w),this._update(),new d.Disposable(()=>{const _=this._messages.indexOf(w);_>=0&&(this._messages.splice(_,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class c{constructor(v,w){this._proxy=v.getProxy(t.MainContext.MainThreadStatusBar),this._commands=w,this._statusMessage=new y(this)}createStatusBarEntry(v,w,_,R){return new F(this._proxy,this._commands,v,w,_,R)}setStatusBarMessage(v,w){const _=this._statusMessage.setMessage(v);let R;return typeof w=="number"?R=setTimeout(()=>_.dispose(),w):typeof w!="undefined"&&w.then(()=>_.dispose(),()=>_.dispose()),new d.Disposable(()=>{_.dispose(),clearTimeout(R)})}}e.ExtHostStatusBar=c}),define(pe[91],ve([0,1,5,3,4]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class C{constructor(k){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(d.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,D){this._proxy.$registerExtensionStorageKeysToSync(k,D)}initializeExtensionStorage(k,D,P){return this._proxy.$initializeExtensionStorage(k,D).then(F=>F||P)}setValue(k,D,P){return this._proxy.$setValue(k,D,P)}$acceptValue(k,D,P){this._onDidChangeStorage.fire({shared:k,key:D,value:P})}}e.ExtHostStorage=C,e.IExtHostStorage=(0,I.createDecorator)("IExtHostStorage")}),define(pe[67],ve([0,1,4,26,12,66,2]),function(ee,e,d,t,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,d.createDecorator)("IExtensionStoragePaths");let k=class{constructor(P,F,y){this._logService=F,this._extHostFileSystem=y,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(c=>this._value=c)}async _getWorkspaceStorageURI(P){return T.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,F=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(F),this._logService.trace("[ExtHostStorage] storage dir already exists",F),F}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",F),await this._extHostFileSystem.value.createDirectory(F),await this._extHostFileSystem.value.writeFile(T.URI.joinPath(F,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:T.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),F}catch(y){this._logService.error("[ExtHostStorage]",y);return}}workspaceValue(P){if(this._value)return T.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return T.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};k=Be([Me(0,t.IExtHostInitDataService),Me(1,I.ILogService),Me(2,C.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(pe[34],ve([0,1,3,5,4,2,14,6,7,171,16,217,21,33,198,86,18,13]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c,E,v,w,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,I.createDecorator)("IExtHostTerminalService");class p{constructor(o,l,f,m){this._proxy=o,this._id=l,this._creationOptions=f,this._name=m,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(A=>this._pidPromiseComplete=A);const b=this;this.value={get name(){return b._name||""},get processId(){return b._pidPromise},get creationOptions(){return b._creationOptions},get exitStatus(){return b._exitStatus},get state(){return b._state},sendText(A,L=!0){b._checkDisposed(),b._proxy.$sendText(b._id,A,L)},show(A){b._checkDisposed(),b._proxy.$show(b._id,A)},hide(){b._checkDisposed(),b._proxy.$hide(b._id)},dispose(){b._disposed||(b._disposed=!0,b._proxy.$dispose(b._id))},get dimensions(){if(!(b._cols===void 0||b._rows===void 0))return{columns:b._cols,rows:b._rows}}}}async create(o,l){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:o.name,shellPath:(0,_.withNullAsUndefined)(o.shellPath),shellArgs:(0,_.withNullAsUndefined)(o.shellArgs),cwd:(0,_.withNullAsUndefined)(o.cwd),env:(0,_.withNullAsUndefined)(o.env),icon:(0,_.withNullAsUndefined)(a(o.iconPath)),color:w.ThemeColor.isThemeColor(o.color)?o.color.id:void 0,initialText:(0,_.withNullAsUndefined)(o.message),strictEnv:(0,_.withNullAsUndefined)(o.strictEnv),hideFromUser:(0,_.withNullAsUndefined)(o.hideFromUser),isFeatureTerminal:(0,_.withNullAsUndefined)(l?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,_.withNullAsUndefined)(l?.useShellEnvironment),location:l?.location||this._serializeParentTerminal(o.location,l?.resolvedExtHostIdentifier),disablePersistence:(0,_.withNullAsUndefined)(o.disablePersistence)})}async createExtensionTerminal(o,l,f,m){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:f,color:w.ThemeColor.isThemeColor(m)?m.id:void 0,location:this._serializeParentTerminal(o,l),disablePersistence:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(o,l){return typeof o=="object"?"parentTerminal"in o&&o.parentTerminal&&l?{parentTerminal:l}:"viewColumn"in o?{viewColumn:o.viewColumn,preserveFocus:o.preserveFocus}:void 0:o}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(o){this._name=o}setExitCode(o){this._exitStatus=Object.freeze({code:o})}setDimensions(o,l){return o===this._cols&&l===this._rows||o===0||l===0?!1:(this._cols=o,this._rows=l,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(o){this._pidPromiseComplete?(this._pidPromiseComplete(o),this._pidPromiseComplete=void 0):this._pidPromise.then(l=>{l!==o&&(this._pidPromise=Promise.resolve(o))})}}e.ExtHostTerminal=p;class h{constructor(o){this._pty=o,this.id=0,this.shouldPersist=!1,this._onProcessData=new d.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new d.Emitter,this._onDidChangeProperty=new d.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new d.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(o){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${o}`)}updateProperty(o,l){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${o}, value: ${l}`)}async start(){}shutdown(){this._pty.close()}input(o){this._pty.handleInput?.(o)}resize(o,l){this._pty.setDimensions?.({columns:o,rows:l})}async processBinary(o){}acknowledgeDataEvent(o){}async setUnicodeVersion(o){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(o){this._pty.onDidWrite(l=>this._onProcessData.fire(l)),this._pty.onDidClose?.((l=void 0)=>{this._onProcessExit.fire(l===void 0?void 0:l)}),this._pty.onDidOverrideDimensions?.(l=>{l&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:l.columns,rows:l.rows}})}),this._pty.onDidChangeName?.(l=>{this._onDidChangeProperty.fire({type:"title",value:l})}),this._pty.open(o||void 0),o&&this._pty.setDimensions?.(o),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=h;let s=1,u=class extends k.Disposable{constructor(o,l){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new d.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new d.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new d.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new d.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new d.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=l.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new v.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new d.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(o),this._register({dispose:()=>{for(const[f,m]of this._terminalProcesses)m.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(o=>o.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(o){return(o?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(o){return(o?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(o,l){const f=new p(this._proxy,(0,E.generateUuid)(),o,o.name),m=new h(o.pty);return f.createExtensionTerminal(o.location,this._serializeParentTerminal(o,l).resolvedExtHostIdentifier,a(o.iconPath),i(o.color)).then(b=>{const A=this._setupExtHostProcessListeners(b,m);this._terminalProcessDisposables[b]=A}),this._terminals.push(f),f.value}_serializeParentTerminal(o,l){if(l=l||{},o.location&&typeof o.location=="object"&&"parentTerminal"in o.location){const f=o.location.parentTerminal;if(f){const m=this._terminals.find(b=>b.value===f);m&&(l.resolvedExtHostIdentifier=m._id)}}else o.location&&typeof o.location!="object"?l.location=o.location:l.location&&typeof l.location=="object"&&"splitActiveTerminal"in l.location&&(l.location={splitActiveTerminal:!0});return l}attachPtyToTerminal(o,l){if(!this._getTerminalById(o))throw new Error(`Cannot resolve terminal with id ${o} for virtual process`);const m=new h(l),b=this._setupExtHostProcessListeners(o,m);this._terminalProcessDisposables[o]=b}async $acceptActiveTerminalChanged(o){const l=this._activeTerminal;if(o===null){this._activeTerminal=void 0,l!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const f=this._getTerminalById(o);f&&(this._activeTerminal=f,l!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(o,l){const f=this._getTerminalById(o);f&&this._onDidWriteTerminalData.fire({terminal:f.value,data:l})}async $acceptTerminalDimensions(o,l,f){const m=this._getTerminalById(o);m&&m.setDimensions(l,f)&&this._onDidChangeTerminalDimensions.fire({terminal:m.value,dimensions:m.value.dimensions})}async $acceptTerminalMaximumDimensions(o,l,f){this._terminalProcesses.get(o)?.resize(l,f)}async $acceptTerminalTitleChange(o,l){const f=this._getTerminalById(o);f&&(f.name=l)}async $acceptTerminalClosed(o,l){const f=this._getTerminalObjectIndexById(this._terminals,o);if(f!==null){const m=this._terminals.splice(f,1)[0];m.setExitCode(l),this._onDidCloseTerminal.fire(m.value)}}$acceptTerminalOpened(o,l,f,m){if(l){const L=this._getTerminalObjectIndexById(this._terminals,l);if(L!==null){this._terminals[L]._id=o,this._onDidOpenTerminal.fire(this.terminals[L]),this._terminals[L].isOpen=!0;return}}const b={name:m.name,shellPath:m.executable,shellArgs:m.args,cwd:typeof m.cwd=="string"?m.cwd:C.URI.revive(m.cwd),env:m.env,hideFromUser:m.hideFromUser},A=new p(this._proxy,o,b,f);this._terminals.push(A),this._onDidOpenTerminal.fire(A.value),A.isOpen=!0}async $acceptTerminalProcessId(o,l){const f=this._getTerminalById(o);f&&f._setProcessId(l)}async $startExtensionTerminal(o,l){const f=this._getTerminalById(o);if(!f)return{message:(0,P.localize)(0,null,o)};f.isOpen||await new Promise(b=>{const A=this.onDidOpenTerminal(async L=>{L===f.value&&(A.dispose(),b())})});const m=this._terminalProcesses.get(o);m?m.startSendingEvents(l):this._extensionTerminalAwaitingStart[o]={initialDimensions:l}}_setupExtHostProcessListeners(o,l){const f=new k.DisposableStore;f.add(l.onProcessReady(b=>this._proxy.$sendProcessReady(o,b.pid,b.cwd))),f.add(l.onDidChangeProperty(b=>this._proxy.$sendProcessProperty(o,b))),this._bufferer.startBuffering(o,l.onProcessData),f.add(l.onProcessExit(b=>this._onProcessExit(o,b))),this._terminalProcesses.set(o,l);const m=this._extensionTerminalAwaitingStart[o];return m&&l instanceof h&&(l.startSendingEvents(m.initialDimensions),delete this._extensionTerminalAwaitingStart[o]),f}$acceptProcessAckDataEvent(o,l){this._terminalProcesses.get(o)?.acknowledgeDataEvent(l)}$acceptProcessInput(o,l){this._terminalProcesses.get(o)?.input(l)}$acceptTerminalInteraction(o){const l=this._getTerminalById(o);l?.setInteractedWith()&&this._onDidChangeTerminalState.fire(l.value)}$acceptProcessResize(o,l,f){try{this._terminalProcesses.get(o)?.resize(l,f)}catch(m){if(m.code!=="EPIPE"&&m.code!=="ERR_IPC_CHANNEL_CLOSED")throw m}}$acceptProcessShutdown(o,l){this._terminalProcesses.get(o)?.shutdown(l)}$acceptProcessRequestInitialCwd(o){this._terminalProcesses.get(o)?.getInitialCwd().then(l=>this._proxy.$sendProcessProperty(o,{type:"initialCwd",value:l}))}$acceptProcessRequestCwd(o){this._terminalProcesses.get(o)?.getCwd().then(l=>this._proxy.$sendProcessProperty(o,{type:"cwd",value:l}))}$acceptProcessRequestLatency(o){return Promise.resolve(o)}registerLinkProvider(o){return this._linkProviders.add(o),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(o),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(o,l,f){if(this._profileProviders.has(l))throw new Error(`Terminal profile provider "${l}" already registered`);return this._profileProviders.set(l,f),this._proxy.$registerProfileProvider(l,o.identifier.value),new D.Disposable(()=>{this._profileProviders.delete(l),this._proxy.$unregisterProfileProvider(l)})}async $createContributedProfileTerminal(o,l){const f=new c.CancellationTokenSource().token;let m=await this._profileProviders.get(o)?.provideTerminalProfile(f);if(!f.isCancellationRequested){if(m&&!("options"in m)&&(m={options:m}),!m||!("options"in m))throw new Error(`No terminal profile options provided for id "${o}"`);if("pty"in m.options){this.createExtensionTerminal(m.options,l);return}this.createTerminalFromOptions(m.options,l)}}async $provideLinks(o,l){const f=this._getTerminalById(o);if(!f)return[];this._terminalLinkCache.delete(o);const m=this._terminalLinkCancellationSource.get(o);m&&m.dispose(!0);const b=new c.CancellationTokenSource;this._terminalLinkCancellationSource.set(o,b);const A=[],L={terminal:f.value,line:l},N=[];for(const U of this._linkProviders)N.push(R.Promises.withAsyncBody(async j=>{b.token.onCancellationRequested(()=>j({provider:U,links:[]}));const K=await U.provideTerminalLinks(L,b.token)||[];b.token.isCancellationRequested||j({provider:U,links:K})}));const g=await Promise.all(N);if(b.token.isCancellationRequested)return[];const M=new Map;for(const U of g)U&&U.links.length>0&&A.push(...U.links.map(j=>{const K={id:s++,startIndex:j.startIndex,length:j.length,label:j.tooltip};return M.set(K.id,{provider:U.provider,link:j}),K}));return this._terminalLinkCache.set(o,M),A}$activateLink(o,l){const f=this._terminalLinkCache.get(o)?.get(l);!f||f.provider.handleTerminalLink(f.link)}_onProcessExit(o,l){this._bufferer.stopBuffering(o),this._terminalProcesses.delete(o),delete this._extensionTerminalAwaitingStart[o];const f=this._terminalProcessDisposables[o];f&&(f.dispose(),delete this._terminalProcessDisposables[o]),this._proxy.$sendProcessExit(o,l)}_getTerminalById(o){return this._getTerminalObjectById(this._terminals,o)}_getTerminalObjectById(o,l){const f=this._getTerminalObjectIndexById(o,l);return f!==null?o[f]:null}_getTerminalObjectIndexById(o,l){let f=null;return o.some((m,b)=>m._id===l?(f=b,!0):!1),f}getEnvironmentVariableCollection(o){let l=this._environmentVariableCollections.get(o.identifier.value);return l||(l=new r,this._setEnvironmentVariableCollection(o.identifier.value,l)),l}_syncEnvironmentVariableCollection(o,l){const f=(0,y.serializeEnvironmentVariableCollection)(l.map);this._proxy.$setEnvironmentVariableCollection(o,l.persistent,f.length===0?void 0:f)}$initEnvironmentVariableCollections(o){o.forEach(l=>{const f=l[0],m=new r(l[1]);this._setEnvironmentVariableCollection(f,m)})}$acceptDefaultProfile(o,l){this._defaultProfile=o,this._defaultAutomationProfile=l}_setEnvironmentVariableCollection(o,l){this._environmentVariableCollections.set(o,l),l.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(o,l)})}};u=Be([Me(1,T.IExtHostRpcService)],u),e.BaseExtHostTerminalService=u;class r{constructor(o){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new d.Emitter,this.map=new Map(o)}get persistent(){return this._persistent}set persistent(o){this._persistent=o,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(o,l){this._setIfDiffers(o,{value:l,type:D.EnvironmentVariableMutatorType.Replace})}append(o,l){this._setIfDiffers(o,{value:l,type:D.EnvironmentVariableMutatorType.Append})}prepend(o,l){this._setIfDiffers(o,{value:l,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(o,l){const f=this.map.get(o);(!f||f.value!==l.value||f.type!==l.type)&&(this.map.set(o,l),this._onDidChangeCollection.fire())}get(o){return this.map.get(o)}forEach(o,l){this.map.forEach((f,m)=>o.call(l,m,f,this))}delete(o){this.map.delete(o),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=r;let S=class extends u{constructor(o){super(!1,o)}createTerminal(o,l,f){throw new F.NotSupportedError}createTerminalFromOptions(o,l){throw new F.NotSupportedError}};S=Be([Me(0,T.IExtHostRpcService)],S),e.WorkerExtHostTerminalService=S;function a(n){if(!(!n||typeof n=="string"))return"id"in n?{id:n.id,color:n.color}:n}function i(n){return w.ThemeColor.isThemeColor(n)?n:void 0}});var Qe=this&&this.__classPrivateFieldSet||function(ee,e,d,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,d):I?I.value=d:e.set(ee,d),d},Te=this&&this.__classPrivateFieldGet||function(ee,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(ee):t?t.value:e.get(ee)};define(pe[253],ve([0,1,17,23,21,3,75,58,6,25,18,33,5,14,63,15,7,223,128,89]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c,E,v,w,_,R,p,h){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let u=class{constructor(L,N){this.resultsChangedEmitter=new C.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=L.getProxy(c.MainContext.MainThreadTesting),this.observer=new f(this.proxy),this.runTracker=new S(this.proxy),N.registerArgumentProcessor({processArgument:g=>g?.$mid===13?w.TestItem.toItemFromContext(g):g})}createTestController(L,N,g){if(this.controllers.has(L))throw new Error(`Attempt to insert a duplicate controller with ID "${L}"`);const M=new D.DisposableStore,U=M.add(new R.SingleUseTestCollection(L));U.root.label=N;const j=new Map,K=this.proxy,B={items:U.root.children,get label(){return N},set label(z){N=z,U.root.label=z,K.$updateController(L,{label:N})},get refreshHandler(){return g},set refreshHandler(z){g=z,K.$updateController(L,{canRefresh:!!z})},get id(){return L},createRunProfile:(z,G,q,Z,se)=>{let ue=(0,k.hash)(z);for(;j.has(ue);)ue++;const te=new m(this.proxy,L,ue,z,G,q,Z,se);return j.set(ue,te),te},createTestItem(z,G,q){return new v.TestItemImpl(L,z,G,q)},createTestRun:(z,G,q=!0)=>this.runTracker.createTestRun(L,U,z,G,q),set resolveHandler(z){U.resolveHandler=z},get resolveHandler(){return U.resolveHandler},dispose:()=>{M.dispose()}};K.$registerTestController(L,N,!!g),M.add((0,D.toDisposable)(()=>K.$unregisterTestController(L)));const x={controller:B,collection:U,profiles:j};return this.controllers.set(L,x),M.add((0,D.toDisposable)(()=>this.controllers.delete(L))),M.add(U.onDidGenerateDiff(z=>K.$publishDiff(L,z))),B}createTestObserver(){return this.observer.checkout()}async runTests(L,N=I.CancellationToken.None){const g=a(L);if(!g)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const M=this.controllers.get(g.controllerId);if(!M)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:L.include?.map(U=>U.id)??[M.collection.root.id],profileGroup:b[g.kind],profileId:g.profileId,controllerId:g.controllerId}],exclude:L.exclude?.map(U=>U.id)},N)}$provideFileCoverage(L,N,g){return(0,d.mapFind)(this.runTracker.trackers,U=>U.id===L?U.getCoverage(N):void 0)?.provideFileCoverage(g)??Promise.resolve([])}$resolveFileCoverage(L,N,g,M){return(0,d.mapFind)(this.runTracker.trackers,j=>j.id===L?j.getCoverage(N):void 0)?.resolveFileCoverage(g,M)??Promise.resolve([])}$configureRunProfile(L,N){this.controllers.get(L)?.profiles.get(N)?.configureHandler?.()}async $refreshTests(L,N){await this.controllers.get(L)?.controller.refreshHandler?.(N)}$publishTestResults(L){this.results=Object.freeze(L.map(N=>(0,P.deepFreeze)(w.TestResults.to(N))).concat(this.results).sort((N,g)=>g.completedAt-N.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(L,N){const g=this.controllers.get(h.TestId.fromString(L).controllerId)?.collection;g&&(await g.expand(L,N<0?1/0:N),g.flushDiff())}$acceptDiff(L){this.observer.applyDiff(L)}async $runControllerTests(L,N){const g=this.controllers.get(L.controllerId);if(!g)return;const{collection:M,profiles:U}=g,j=U.get(L.profileId);if(!j)return;const K=L.testIds.map(G=>M.tree.get(G)).filter(F.isDefined),B=L.excludeExtIds.map(G=>g.collection.tree.get(G)).filter(F.isDefined).filter(G=>K.some(q=>q.fullId.compare(G.fullId)===2));if(!K.length)return;const x=new _.TestRunRequest(K.some(G=>G.actual instanceof v.TestItemRootImpl)?void 0:K.map(G=>G.actual),B.map(G=>G.actual),j),z=this.runTracker.prepareForMainThreadTestRun(x,i.fromInternal(L,g.collection),N);try{await j.runHandler(x,N)}finally{z.isRunning&&!N.isCancellationRequested&&await C.Event.toPromise(z.onEnd),z.dispose()}}$cancelExtensionTestRun(L){L===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(L)}};u=Be([Me(0,E.IExtHostRpcService)],u),e.ExtHostTesting=u;class r extends D.Disposable{constructor(L,N,g){super();this.dto=L,this.proxy=N,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new C.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new I.CancellationTokenSource(g)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:M}of this.tasks.values())M.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(L){return this.tasks.get(L)?.coverage}createRun(L){const N=this.dto.id,g=this.dto.controllerId,M=(0,y.generateUuid)(),U=new n(this.proxy,N,M),j=z=>(G,...q)=>{if(B){console.warn(`Setting the state of test "${G.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(G)||(this.ensureTestIsKnown(G),z(G,...q))},K=(z,G)=>{const q=G instanceof Array?G.map(w.TestMessage.from):[w.TestMessage.from(G)];if(z.uri&&z.range){const Z={range:w.Range.from(z.range),uri:z.uri};for(const se of q)se.location=se.location||Z}this.proxy.$appendTestMessagesInRun(N,M,h.TestId.fromExtHostTestItem(z,g).toString(),q)};let B=!1;const x={isPersisted:this.dto.isPersisted,token:this.cts.token,name:L,get coverageProvider(){return U.coverageProvider},set coverageProvider(z){U.coverageProvider=z},enqueued:j(z=>{this.proxy.$updateTestStateInRun(N,M,h.TestId.fromExtHostTestItem(z,g).toString(),1)}),skipped:j(z=>{this.proxy.$updateTestStateInRun(N,M,h.TestId.fromExtHostTestItem(z,g).toString(),5)}),started:j(z=>{this.proxy.$updateTestStateInRun(N,M,h.TestId.fromExtHostTestItem(z,g).toString(),2)}),errored:j((z,G,q)=>{K(z,G),this.proxy.$updateTestStateInRun(N,M,h.TestId.fromExtHostTestItem(z,g).toString(),6,q)}),failed:j((z,G,q)=>{K(z,G),this.proxy.$updateTestStateInRun(N,M,h.TestId.fromExtHostTestItem(z,g).toString(),4,q)}),passed:j((z,G)=>{this.proxy.$updateTestStateInRun(N,M,h.TestId.fromExtHostTestItem(z,this.dto.controllerId).toString(),3,G)}),appendOutput:(z,G,q)=>{B||(q&&(this.dto.isIncluded(q)?this.ensureTestIsKnown(q):q=void 0),this.proxy.$appendOutputToRun(N,M,t.VSBuffer.fromString(z),G&&w.location.from(G),q&&h.TestId.fromExtHostTestItem(q,g).toString()))},end:()=>{B||(B=!0,this.proxy.$finishedTestRunTask(N,M),this.tasks.delete(M),this.isRunning||this.dispose())}};return this.tasks.set(M,{run:x,coverage:U}),this.proxy.$startedTestRunTask(N,{id:M,name:L,running:!0}),x}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(L){if(!(L instanceof v.TestItemImpl))throw new v.InvalidTestItemError(L.id);if(this.sharedTestIds.has(h.TestId.fromExtHostTestItem(L,this.dto.controllerId).toString()))return;const N=[],g=this.dto.colllection.root;for(;;){const M=w.TestItem.from(L);if(N.unshift(M),this.sharedTestIds.has(M.extId)||(this.sharedTestIds.add(M.extId),L===g))break;L=L.parent||g}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,N)}}class S{constructor(L){this.proxy=L,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(L,N,g){return this.getTracker(L,N,g)}cancelRunById(L){for(const N of this.tracked.values())if(N.id===L){N.dispose();return}}cancelAllRuns(){for(const L of this.tracked.values())L.dispose()}createTestRun(L,N,g,M,U){const j=this.tracked.get(g);if(j)return j.createRun(M);const K=i.fromPublic(L,N,g,U),B=a(g);this.proxy.$startedExtensionTestRun({controllerId:L,profile:B&&{group:b[B.kind],id:B.profileId},exclude:g.exclude?.map(z=>z.id)??[],id:K.id,include:g.include?.map(z=>z.id)??[N.root.id],persist:U});const x=this.getTracker(g,K);return x.onEnd(()=>this.proxy.$finishedExtensionTestRun(K.id)),x.createRun(M)}getTracker(L,N,g){const M=new r(N,this.proxy,g);return this.tracked.set(L,M),M.onEnd(()=>this.tracked.delete(L)),M}}e.TestRunCoordinator=S;const a=A=>{if(!!A.profile){if(!(A.profile instanceof m))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return A.profile}};class i{constructor(L,N,g,M,U,j){this.controllerId=L,this.id=N,this.isPersisted=U,this.colllection=j,this.includePrefix=g.map(K=>K+"\0"),this.excludePrefix=M.map(K=>K+"\0")}static fromPublic(L,N,g,M){return new i(L,(0,y.generateUuid)(),g.include?.map(U=>h.TestId.fromExtHostTestItem(U,L).toString())??[L],g.exclude?.map(U=>h.TestId.fromExtHostTestItem(U,L).toString())??[],M,N)}static fromInternal(L,N){return new i(L.controllerId,L.runId,L.testIds,L.excludeExtIds,!0,N)}isIncluded(L){const N=h.TestId.fromExtHostTestItem(L,this.controllerId).toString()+"\0";for(const g of this.excludePrefix)if(N===g||N.startsWith(g))return!1;for(const g of this.includePrefix)if(N===g||N.startsWith(g))return!0;return!1}}e.TestRunDto=i;class n{constructor(L,N,g){this.proxy=L,this.runId=N,this.taskId=g}set coverageProvider(L){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!L||(this._coverageProvider=L,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(L){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(L))());try{return(await this.fileCoverage)?.map(w.TestCoverage.fromFile)??[]}catch(N){throw this.fileCoverage=void 0,N}}async resolveFileCoverage(L,N){const g=await this.fileCoverage;let M=g?.[L];return!this._coverageProvider||!g||!M?[]:(M.detailedCoverage||(M=g[L]=await this._coverageProvider.resolveFileCoverage?.(M,N)??M),M.detailedCoverage?.map(w.TestCoverage.fromDetailed)??[])}}class o extends p.IncrementalChangeCollector{constructor(L){super();this.emitter=L,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(L){this.added.add(L)}update(L){Object.assign(L.revived,w.TestItem.toPlain(L.item)),this.added.has(L)||this.updated.add(L)}remove(L){if(this.added.has(L)){this.added.delete(L);return}if(this.updated.delete(L),L.parent&&this.alreadyRemoved.has(L.parent)){this.alreadyRemoved.add(L.item.extId);return}this.removed.add(L)}getChangeEvent(){const{added:L,updated:N,removed:g}=this;return{get added(){return[...L].map(M=>M.revived)},get updated(){return[...N].map(M=>M.revived)},get removed(){return[...g].map(M=>M.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class l extends p.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new C.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(L){return this.items.get(L)}getMirroredTestDataByReference(L){return this.items.get(L.id)}createItem(L,N){return{...L,revived:w.TestItem.toPlain(L.item),depth:N?N.depth+1:0,children:new Set}}createChangeCollector(){return new o(this.changeEmitter)}}e.MirroredTestCollection=l;class f{constructor(L){this.proxy=L}checkout(){this.current||(this.current=this.createObserverData());const L=this.current;return L.observers++,{onDidChangeTest:L.tests.onDidChangeTests,get tests(){return[...L.tests.rootTests].map(N=>N.revived)},dispose:(0,T.once)(()=>{--L.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(L){return this.current?.tests.getMirroredTestDataByReference(L)}applyDiff(L){this.current?.tests.apply(L)}createObserverData(){const L=new l;return this.proxy.$subscribeToDiffs(),{observers:0,tests:L}}}class m{constructor(L,N,g,M,U,j,K=!1,B=void 0){this.controllerId=N,this.profileId=g,this._label=M,this.kind=U,this.runHandler=j,this._isDefault=K,this._tag=B,s.set(this,void 0),Qe(this,s,L,"f");const x=b[U];if(typeof x!="number")throw new Error(`Unknown TestRunProfile.group ${U}`);Te(this,s,"f").$publishTestRunProfile({profileId:g,controllerId:N,tag:B?w.TestTag.namespace(this.controllerId,B.id):null,label:M,group:x,isDefault:K,hasConfigurationHandler:!1})}get label(){return this._label}set label(L){L!==this._label&&(this._label=L,Te(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:L}))}get isDefault(){return this._isDefault}set isDefault(L){L!==this._isDefault&&(this._isDefault=L,Te(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:L}))}get tag(){return this._tag}set tag(L){L?.id!==this._tag?.id&&(this._tag=L,Te(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:L?w.TestTag.namespace(this.controllerId,L.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(L){L!==this._configureHandler&&(this._configureHandler=L,Te(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!L}))}dispose(){Te(this,s,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=m,s=new WeakMap;const b={[_.TestRunProfileKind.Coverage]:8,[_.TestRunProfileKind.Debug]:4,[_.TestRunProfileKind.Run]:2}}),define(pe[254],ve([0,1,3,17,5,131,15,7]),function(ee,e,d,t,I,C,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(F,y){this._extHostDocumentsAndEditors=y,this._onDidChangeTextEditorSelection=new d.Emitter,this._onDidChangeTextEditorOptions=new d.Emitter,this._onDidChangeTextEditorVisibleRanges=new d.Emitter,this._onDidChangeTextEditorViewColumn=new d.Emitter,this._onDidChangeActiveTextEditor=new d.Emitter,this._onDidChangeVisibleTextEditors=new d.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=F.getProxy(I.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(c=>this._onDidChangeVisibleTextEditors.fire(c)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(c=>this._onDidChangeActiveTextEditor.fire(c))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(F){const y=this._extHostDocumentsAndEditors.allEditors();return F?y:y.map(c=>c.value)}async showTextDocument(F,y,c){let E;typeof y=="number"?E={position:T.ViewColumn.from(y),preserveFocus:c}:typeof y=="object"?E={position:T.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selection:typeof y.selection=="object"?T.Range.from(y.selection):void 0,pinned:typeof y.preview=="boolean"?!y.preview:void 0}:E={preserveFocus:!1};const v=await this._proxy.$tryShowTextDocument(F.uri,E),w=v&&this._extHostDocumentsAndEditors.getEditor(v);if(w)return w.value;throw v?new Error(`Could NOT open editor for "${F.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${F.uri.toString()}".`)}createTextEditorDecorationType(F,y){return new C.TextEditorDecorationType(this._proxy,F,y).value}$acceptEditorPropertiesChanged(F,y){const c=this._extHostDocumentsAndEditors.getEditor(F);if(!c)throw new Error("unknown text editor");if(y.options&&c._acceptOptions(y.options),y.selections){const E=y.selections.selections.map(T.Selection.to);c._acceptSelections(E)}if(y.visibleRanges){const E=t.coalesce(y.visibleRanges.map(T.Range.to));c._acceptVisibleRanges(E)}if(y.options&&this._onDidChangeTextEditorOptions.fire({textEditor:c.value,options:{...y.options,lineNumbers:T.TextEditorLineNumbersStyle.to(y.options.lineNumbers)}}),y.selections){const E=k.TextEditorSelectionChangeKind.fromValue(y.selections.source),v=y.selections.selections.map(T.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:c.value,selections:v,kind:E})}if(y.visibleRanges){const E=t.coalesce(y.visibleRanges.map(T.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:c.value,visibleRanges:E})}}$acceptEditorPositionData(F){for(const y in F){const c=this._extHostDocumentsAndEditors.getEditor(y);if(!c)throw new Error("Unknown text editor");const E=T.ViewColumn.to(F[y]);c.value.viewColumn!==E&&(c._acceptViewColumn(E),this._onDidChangeTextEditorViewColumn.fire({textEditor:c.value,viewColumn:E}))}}getDiffInformation(F){return Promise.resolve(this._proxy.$getDiffInformation(F))}}e.ExtHostEditors=D}),define(pe[255],ve([0,1,2,4,5,6,7]),function(ee,e,d,t,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class k{constructor(F,y){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=F.getProxy(I.MainContext.MainThreadTimeline),y.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===11){const E=c.uri===void 0?void 0:d.URI.revive(c.uri);return this._itemsBySourceAndUriMap.get(c.source)?.get(D(E))?.get(c.handle)}return c}})}async $getTimeline(F,y,c,E,v){return this._providers.get(F)?.provideTimeline(d.URI.revive(y),c,E,v)}registerTimelineProvider(F,y,c,E){const v=new C.DisposableStore,w=this.convertTimelineItem(y.id,E,v).bind(this);let _;y.onDidChange&&(_=y.onDidChange(p=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...p,id:y.id}),this));const R=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...y,scheme:F,onDidChange:void 0,async provideTimeline(p,h,s,u){u?.resetCache&&(v.clear(),R.get(y.id)?.clear());const r=await y.provideTimeline(p,h,s);if(r==null)return;const S=w(p,u);return{...r,source:y.id,items:r.items.map(S)}},dispose(){for(const p of R.values())p.get(y.id)?.clear();_?.dispose(),v.dispose()}})}convertTimelineItem(F,y,c){return(E,v)=>{let w;if(v?.cacheResults){let _=this._itemsBySourceAndUriMap.get(F);_===void 0&&(_=new Map,this._itemsBySourceAndUriMap.set(F,_));const R=D(E);w=_.get(R),w===void 0&&(w=new Map,_.set(R,w))}return _=>{const{iconPath:R,...p}=_,h=`${F}|${_.id??_.timestamp}`;w?.set(h,_);let s,u,r;return _.iconPath&&(R instanceof T.ThemeIcon?r={id:R.id,color:R.color}:d.URI.isUri(R)?(s=R,u=R):{light:s,dark:u}=R),{...p,id:p.id??void 0,handle:h,source:F,command:_.command?y.toInternal(_.command,c):void 0,icon:s,iconDark:u,themeIcon:r,accessibilityInformation:_.accessibilityInformation}}}}registerTimelineProviderCore(F){if(this._providers.get(F.id))throw new Error(`Timeline Provider ${F.id} already exists.`);return this._proxy.$registerTimelineProvider({id:F.id,label:F.label,scheme:F.scheme}),this._providers.set(F.id,F),(0,C.toDisposable)(()=>{for(const c of this._itemsBySourceAndUriMap.values())c.get(F.id)?.clear();this._providers.delete(F.id),this._proxy.$unregisterTimelineProvider(F.id),F.dispose()})}}e.ExtHostTimeline=k;function D(P){return P?.toString()}}),define(pe[256],ve([0,1,6,10,2,5]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class T{constructor(D){this._openers=new Map,this._proxy=D.getProxy(C.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,P,F,y){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const c=y.schemes.find(E=>!T.supportedSchemes.has(E));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,F),this._proxy.$registerUriOpener(P,y.schemes,D,y.label),(0,d.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(D,P,F){const y=this._openers.get(D);if(!y)throw new Error(`Unknown opener with id: ${D}`);const c=I.URI.revive(P);return y.canOpenExternalUri(c,F)}async $openUri(D,P,F){const y=this._openers.get(D);if(!y)throw new Error(`Unknown opener id: '${D}'`);return y.openExternalUri(I.URI.revive(P.resolvedUri),{sourceUri:I.URI.revive(P.sourceUri)},F)}}e.ExtHostUriOpeners=T,T.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(pe[257],ve([0,1,5,2,6,16,27]),function(ee,e,d,t,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(d.MainContext.MainThreadUrls)}registerUriHandler(P,F){if(this.handles.has(T.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const y=k.HandlePool++;return this.handles.add(T.ExtensionIdentifier.toKey(P)),this.handlers.set(y,F),this._proxy.$registerUriHandler(y,P),(0,I.toDisposable)(()=>{this.handles.delete(T.ExtensionIdentifier.toKey(P)),this.handlers.delete(y),this._proxy.$unregisterUriHandler(y)})}$handleExternalUri(P,F){const y=this.handlers.get(P);if(!y)return Promise.resolve(void 0);try{y.handleUri(t.URI.revive(F))}catch(c){(0,C.onUnexpectedError)(c)}return Promise.resolve(void 0)}async createAppUri(P){return t.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=k,k.HandlePool=0});var Qe=this&&this.__classPrivateFieldSet||function(ee,e,d,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,d):I?I.value=d:e.set(ee,d),d},Te=this&&this.__classPrivateFieldGet||function(ee,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(ee):t?t.value:e.get(ee)};define(pe[68],ve([0,1,3,10,2,184,207,88,5]),function(ee,e,d,t,I,C,T,k,D){"use strict";var P,F,y,c,E,v,w,_,R,p,h,s;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class u{constructor(f,m,b,A,L,N,g){P.set(this,void 0),F.set(this,void 0),y.set(this,void 0),c.set(this,void 0),E.set(this,void 0),v.set(this,void 0),w.set(this,""),_.set(this,void 0),R.set(this,!1),p.set(this,!1),h.set(this,!1),this._onMessageEmitter=new d.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,s.set(this,new d.Emitter),this._onDidDispose=Te(this,s,"f").event,Qe(this,P,f,"f"),Qe(this,F,m,"f"),Qe(this,_,b,"f"),Qe(this,c,A,"f"),Qe(this,E,L,"f"),Qe(this,v,N,"f"),Qe(this,h,r(N),"f"),Qe(this,y,g,"f")}dispose(){Qe(this,R,!0,"f"),Te(this,s,"f").fire(),Te(this,s,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(f){return Qe(this,p,!0,"f"),(0,k.asWebviewUri)(f,Te(this,c,"f").remote)}get cspSource(){const f=Te(this,v,"f").extensionLocation;if(f.scheme===t.Schemas.https||f.scheme===t.Schemas.http){let m=f.toString();return m.endsWith("/")||(m+="/"),m+" "+k.webviewGenericCspSource}return k.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Te(this,w,"f")}set html(f){this.assertNotDisposed(),Te(this,w,"f")!==f&&(Qe(this,w,f,"f"),!Te(this,p,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(f)&&(Qe(this,p,!0,"f"),Te(this,y,"f").report("Webview vscode-resource: uris",Te(this,v,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Te(this,F,"f").$setHtml(Te(this,P,"f"),f))}get options(){return this.assertNotDisposed(),Te(this,_,"f")}set options(f){this.assertNotDisposed(),Te(this,F,"f").$setOptions(Te(this,P,"f"),i(Te(this,v,"f"),Te(this,E,"f"),f)),Qe(this,_,f,"f")}async postMessage(f){if(Te(this,R,"f"))return!1;const m=(0,T.serializeWebviewMessage)(f,{serializeBuffersForPostMessage:Te(this,h,"f")});return Te(this,F,"f").$postMessage(Te(this,P,"f"),m.message,...m.buffers)}assertNotDisposed(){if(Te(this,R,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=u,P=new WeakMap,F=new WeakMap,y=new WeakMap,c=new WeakMap,E=new WeakMap,v=new WeakMap,w=new WeakMap,_=new WeakMap,R=new WeakMap,p=new WeakMap,h=new WeakMap,s=new WeakMap;function r(l){try{const f=(0,C.normalizeVersion)((0,C.parseVersion)(l.engines.vscode));return!!f&&f.majorBase>=1&&f.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=r;class S{constructor(f,m,b,A,L){this.initData=m,this.workspace=b,this._logService=A,this._deprecationService=L,this._webviews=new Map,this._webviewProxy=f.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(f,m,b){const A=this.getWebview(f);if(A){const{message:L}=(0,T.deserializeWebviewMessage)(m,b.value);A._onMessageEmitter.fire(L)}}$onMissingCsp(f,m){this._logService.warn(`${m} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(f,m,b){const A=new u(f,this._webviewProxy,n(m),this.initData,this.workspace,b,this._deprecationService);return this._webviews.set(f,A),A._onDidDispose(()=>{this._webviews.delete(f)}),A}deleteWebview(f){this._webviews.delete(f)}getWebview(f){return this._webviews.get(f)}}e.ExtHostWebviews=S;function a(l){return{id:l.identifier,location:l.extensionLocation}}e.toExtensionData=a;function i(l,f,m){return{enableCommandUris:m.enableCommandUris,enableScripts:m.enableScripts,enableForms:m.enableForms,portMapping:m.portMapping,localResourceRoots:m.localResourceRoots||o(l,f)}}e.serializeWebviewOptions=i;function n(l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots?.map(f=>I.URI.from(f))}}e.reviveOptions=n;function o(l,f){return[...(f?.getWorkspaceFolders()||[]).map(m=>m.uri),l.extensionLocation]}}),define(pe[258],ve([0,1,21,58,6,10,22,2,15,68,87,5,7]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class E{constructor(r,S){this.document=r,this._storagePath=S,this._backupCounter=1,this._edits=new F.Cache("custom documents")}addEdit(r){return this._edits.add([r])}async undo(r,S){await this.getEdit(r).undo(),S||this.disposeBackup()}async redo(r,S){await this.getEdit(r).redo(),S||this.disposeBackup()}disposeEdits(r){for(const S of r)this._edits.delete(S)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const r=s(this.document.uri)+this._backupCounter++;return(0,T.joinPath)(this._storagePath,r)}updateBackup(r){this._backup?.delete(),this._backup=r}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(r){const S=this._edits.get(r,0);if(!S)throw new Error("No edit found");return S}}class v{constructor(){this._documents=new Map}get(r,S){return this._documents.get(this.key(r,S))}add(r,S,a){const i=this.key(r,S.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${r} resource:${S.uri}`);const n=new E(S,a);return this._documents.set(i,n),n}delete(r,S){const a=this.key(r,S.uri);this._documents.delete(a)}key(r,S){return`${r}@@@${S}`}}var w;(function(u){u[u.Text=0]="Text",u[u.Custom=1]="Custom"})(w||(w={}));class _{constructor(){this._providers=new Map}addTextProvider(r,S,a){return this.add(0,r,S,a)}addCustomProvider(r,S,a){return this.add(1,r,S,a)}get(r){return this._providers.get(r)}add(r,S,a,i){if(this._providers.has(S))throw new Error(`Provider for viewType:${S} already registered`);return this._providers.set(S,{type:r,extension:a,provider:i}),new c.Disposable(()=>this._providers.delete(S))}}class R{constructor(r,S,a,i,n){this._extHostDocuments=S,this._extensionStoragePaths=a,this._extHostWebview=i,this._extHostWebviewPanels=n,this._editorProviders=new _,this._documents=new v,this._proxy=r.getProxy(y.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(r,S,a,i){const n=new I.DisposableStore;return p(a)?(n.add(this._editorProviders.addTextProvider(S,r,a)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(r),S,i.webviewOptions||{},{supportsMove:!!a.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(r))):(n.add(this._editorProviders.addCustomProvider(S,r,a)),this.supportEditing(a)&&n.add(a.onDidChangeCustomDocument(o=>{const l=this.getCustomDocumentEntry(S,o.document.uri);if(h(o)){const f=l.addEdit(o);this._proxy.$onDidEdit(o.document.uri,S,f,o.label)}else this._proxy.$onContentChange(o.document.uri,S)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(r),S,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(r))),c.Disposable.from(n,new c.Disposable(()=>{this._proxy.$unregisterEditorProvider(S)}))}async $createCustomDocument(r,S,a,i,n){const o=this._editorProviders.get(S);if(!o)throw new Error(`No provider found for '${S}'`);if(o.type!==1)throw new Error(`Invalid provide type for '${S}'`);const l=k.URI.revive(r),f=await o.provider.openCustomDocument(l,{backupId:a,untitledDocumentData:i?.buffer},n);let m;return this.supportEditing(o.provider)&&this._extensionStoragePaths&&(m=this._extensionStoragePaths.workspaceValue(o.extension)??this._extensionStoragePaths.globalValue(o.extension)),this._documents.add(S,f,m),{editable:this.supportEditing(o.provider)}}async $disposeCustomDocument(r,S){const a=this._editorProviders.get(S);if(!a)throw new Error(`No provider found for '${S}'`);if(a.type!==1)throw new Error(`Invalid provider type for '${S}'`);const i=k.URI.revive(r),{document:n}=this.getCustomDocumentEntry(S,i);this._documents.delete(S,n),n.dispose()}async $resolveWebviewEditor(r,S,a,i,n,o){const l=this._editorProviders.get(a);if(!l)throw new Error(`No provider found for '${a}'`);const f=D.ViewColumn.to(n),m=this._extHostWebview.createNewWebview(S,i.webviewOptions,l.extension),b=this._extHostWebviewPanels.createNewWebviewPanel(S,a,i.title,f,i.panelOptions,m),A=k.URI.revive(r);switch(l.type){case 1:{const{document:L}=this.getCustomDocumentEntry(a,A);return l.provider.resolveCustomEditor(L,b,o)}case 0:{const L=this._extHostDocuments.getDocument(A);return l.provider.resolveCustomTextEditor(L,b,o)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,S,a){this.getCustomDocumentEntry(S,r).disposeEdits(a)}async $onMoveCustomEditor(r,S,a){const i=this._editorProviders.get(a);if(!i)throw new Error(`No provider found for '${a}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${a}'`);const n=this._extHostWebviewPanels.getWebviewPanel(r);if(!n)throw new Error("No webview found");const o=k.URI.revive(S),l=this._extHostDocuments.getDocument(o);await i.provider.moveCustomTextEditor(l,n,d.CancellationToken.None)}async $undo(r,S,a,i){return this.getCustomDocumentEntry(S,r).undo(a,i)}async $redo(r,S,a,i){return this.getCustomDocumentEntry(S,r).redo(a,i)}async $revert(r,S,a){const i=this.getCustomDocumentEntry(S,r);await this.getCustomEditorProvider(S).revertCustomDocument(i.document,a),i.disposeBackup()}async $onSave(r,S,a){const i=this.getCustomDocumentEntry(S,r);await this.getCustomEditorProvider(S).saveCustomDocument(i.document,a),i.disposeBackup()}async $onSaveAs(r,S,a,i){const n=this.getCustomDocumentEntry(S,r);return this.getCustomEditorProvider(S).saveCustomDocumentAs(n.document,k.URI.revive(a),i)}async $backup(r,S,a){const i=this.getCustomDocumentEntry(S,r),o=await this.getCustomEditorProvider(S).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},a);return i.updateBackup(o),o.id}getCustomDocumentEntry(r,S){const a=this._documents.get(r,k.URI.revive(S));if(!a)throw new Error("No custom document found");return a}getCustomEditorProvider(r){const a=this._editorProviders.get(r)?.provider;if(!a||!this.supportEditing(a))throw new Error("Custom document is not editable");return a}supportEditing(r){return!!r.onDidChangeCustomDocument}}e.ExtHostCustomEditors=R;function p(u){return typeof u.resolveCustomTextEditor=="function"}function h(u){return typeof u.undo=="function"&&typeof u.redo=="function"}function s(u){const r=u.scheme===C.Schemas.file||u.scheme===C.Schemas.untitled?u.fsPath:u.toString();return(0,t.hash)(r)+""}});var Qe=this&&this.__classPrivateFieldSet||function(ee,e,d,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,d):I?I.value=d:e.set(ee,d),d},Te=this&&this.__classPrivateFieldGet||function(ee,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(ee):t?t.value:e.get(ee)};define(pe[259],ve([0,1,3,6,2,33,15,68,5,7]),function(ee,e,d,t,I,C,T,k,D,P){"use strict";var F,y,c,E,v,w,_,R,p,h,s,u,r;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class S extends t.Disposable{constructor(o,l,f,m,b,A,L){super();F.set(this,void 0),y.set(this,void 0),c.set(this,void 0),E.set(this,void 0),v.set(this,void 0),w.set(this,void 0),_.set(this,void 0),R.set(this,void 0),p.set(this,!0),h.set(this,!0),s.set(this,!1),u.set(this,this._register(new d.Emitter)),this.onDidDispose=Te(this,u,"f").event,r.set(this,this._register(new d.Emitter)),this.onDidChangeViewState=Te(this,r,"f").event,Qe(this,F,o,"f"),Qe(this,y,l,"f"),Qe(this,c,f,"f"),Qe(this,v,A,"f"),Qe(this,R,b,"f"),Qe(this,w,m,"f"),Qe(this,E,L,"f")}dispose(){Te(this,s,"f")||(Qe(this,s,!0,"f"),Te(this,u,"f").fire(),Te(this,y,"f").$disposeWebview(Te(this,F,"f")),Te(this,E,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Te(this,E,"f")}get viewType(){return this.assertNotDisposed(),Te(this,c,"f")}get title(){return this.assertNotDisposed(),Te(this,w,"f")}set title(o){this.assertNotDisposed(),Te(this,w,"f")!==o&&(Qe(this,w,o,"f"),Te(this,y,"f").$setTitle(Te(this,F,"f"),o))}get iconPath(){return this.assertNotDisposed(),Te(this,_,"f")}set iconPath(o){this.assertNotDisposed(),Te(this,_,"f")!==o&&(Qe(this,_,o,"f"),Te(this,y,"f").$setIconPath(Te(this,F,"f"),I.URI.isUri(o)?{light:o,dark:o}:o))}get options(){return Te(this,v,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Te(this,R,"f")=="number"&&Te(this,R,"f")<0))return Te(this,R,"f")}get active(){return this.assertNotDisposed(),Te(this,h,"f")}get visible(){return this.assertNotDisposed(),Te(this,p,"f")}_updateViewState(o){Te(this,s,"f")||(this.active!==o.active||this.visible!==o.visible||this.viewColumn!==o.viewColumn)&&(Qe(this,h,o.active,"f"),Qe(this,p,o.visible,"f"),Qe(this,R,o.viewColumn,"f"),Te(this,r,"f").fire({webviewPanel:this}))}reveal(o,l){this.assertNotDisposed(),Te(this,y,"f").$reveal(Te(this,F,"f"),{viewColumn:typeof o=="undefined"?void 0:T.ViewColumn.from(o),preserveFocus:!!l})}assertNotDisposed(){if(Te(this,s,"f"))throw new Error("Webview is disposed")}}F=new WeakMap,y=new WeakMap,c=new WeakMap,E=new WeakMap,v=new WeakMap,w=new WeakMap,_=new WeakMap,R=new WeakMap,p=new WeakMap,h=new WeakMap,s=new WeakMap,u=new WeakMap,r=new WeakMap;class a{constructor(o,l,f){this.webviews=l,this.workspace=f,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=o.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,C.generateUuid)()}createWebviewPanel(o,l,f,m,b={}){const A=typeof m=="object"?m.viewColumn:m,L={viewColumn:T.ViewColumn.from(A),preserveFocus:typeof m=="object"&&!!m.preserveFocus},N=(0,k.shouldSerializeBuffersForPostMessage)(o),g=a.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(o),g,l,{title:f,panelOptions:i(b),webviewOptions:(0,k.serializeWebviewOptions)(o,this.workspace,b),serializeBuffersForPostMessage:N},L);const M=this.webviews.createNewWebview(g,b,o);return this.createNewWebviewPanel(g,l,f,A,b,M)}$onDidChangeWebviewPanelViewStates(o){const l=Object.keys(o);l.sort((f,m)=>{const b=o[f],A=o[m];return b.active?1:A.active?-1:+b.visible-+A.visible});for(const f of l){const m=this.getWebviewPanel(f);if(!m)continue;const b=o[f];m._updateViewState({active:b.active,visible:b.visible,viewColumn:T.ViewColumn.to(b.position)})}}async $onDidDisposeWebviewPanel(o){this.getWebviewPanel(o)?.dispose(),this._webviewPanels.delete(o),this.webviews.deleteWebview(o)}registerWebviewPanelSerializer(o,l,f){if(this._serializers.has(l))throw new Error(`Serializer for '${l}' already registered`);return this._serializers.set(l,{serializer:f,extension:o}),this._proxy.$registerSerializer(l,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(o)}),new P.Disposable(()=>{this._serializers.delete(l),this._proxy.$unregisterSerializer(l)})}async $deserializeWebviewPanel(o,l,f,m){const b=this._serializers.get(l);if(!b)throw new Error(`No serializer found for '${l}'`);const{serializer:A,extension:L}=b,N=this.webviews.createNewWebview(o,f.webviewOptions,L),g=this.createNewWebviewPanel(o,l,f.title,m,f.panelOptions,N);await A.deserializeWebviewPanel(g,f.state)}createNewWebviewPanel(o,l,f,m,b,A){const L=new S(o,this._proxy,l,f,m,b,A);return this._webviewPanels.set(o,L),L}getWebviewPanel(o){return this._webviewPanels.get(o)}}e.ExtHostWebviewPanels=a;function i(n){return{enableFindWidget:n.enableFindWidget,retainContextWhenHidden:n.retainContextWhenHidden}}});var Qe=this&&this.__classPrivateFieldSet||function(ee,e,d,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,d):I?I.value=d:e.set(ee,d),d},Te=this&&this.__classPrivateFieldGet||function(ee,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(ee):t?t.value:e.get(ee)};define(pe[260],ve([0,1,3,6,68,5,7]),function(ee,e,d,t,I,C,T){"use strict";var k,D,P,F,y,c,E,v,w,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class R extends t.Disposable{constructor(s,u,r,S,a,i){super();k.set(this,void 0),D.set(this,void 0),P.set(this,void 0),F.set(this,void 0),y.set(this,!1),c.set(this,void 0),E.set(this,void 0),v.set(this,void 0),w.set(this,this._register(new d.Emitter)),this.onDidChangeVisibility=Te(this,w,"f").event,_.set(this,this._register(new d.Emitter)),this.onDidDispose=Te(this,_,"f").event,Qe(this,P,r,"f"),Qe(this,E,S,"f"),Qe(this,k,s,"f"),Qe(this,D,u,"f"),Qe(this,F,a,"f"),Qe(this,c,i,"f")}dispose(){Te(this,y,"f")||(Qe(this,y,!0,"f"),Te(this,_,"f").fire(),Te(this,F,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Te(this,E,"f")}set title(s){this.assertNotDisposed(),Te(this,E,"f")!==s&&(Qe(this,E,s,"f"),Te(this,D,"f").$setWebviewViewTitle(Te(this,k,"f"),s))}get description(){return this.assertNotDisposed(),Te(this,v,"f")}set description(s){this.assertNotDisposed(),Te(this,v,"f")!==s&&(Qe(this,v,s,"f"),Te(this,D,"f").$setWebviewViewDescription(Te(this,k,"f"),s))}get visible(){return Te(this,c,"f")}get webview(){return Te(this,F,"f")}get viewType(){return Te(this,P,"f")}_setVisible(s){s===Te(this,c,"f")||Te(this,y,"f")||(Qe(this,c,s,"f"),Te(this,w,"f").fire())}show(s){this.assertNotDisposed(),Te(this,D,"f").$show(Te(this,k,"f"),!!s)}assertNotDisposed(){if(Te(this,y,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,D=new WeakMap,P=new WeakMap,F=new WeakMap,y=new WeakMap,c=new WeakMap,E=new WeakMap,v=new WeakMap,w=new WeakMap,_=new WeakMap;class p{constructor(s,u){this._extHostWebview=u,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=s.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(s,u,r,S){if(this._viewProviders.has(u))throw new Error(`View provider for '${u}' already registered`);return this._viewProviders.set(u,{provider:r,extension:s}),this._proxy.$registerWebviewViewProvider((0,I.toExtensionData)(s),u,{retainContextWhenHidden:S?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new T.Disposable(()=>{this._viewProviders.delete(u),this._proxy.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(s,u,r,S,a){const i=this._viewProviders.get(u);if(!i)throw new Error(`No view provider found for '${u}'`);const{provider:n,extension:o}=i,l=this._extHostWebview.createNewWebview(s,{},o),f=new R(s,this._proxy,u,r,l,!0);this._webviewViews.set(s,f),await n.resolveWebviewView(f,{state:S},a)}async $onDidChangeWebviewViewVisibility(s,u){this.getWebviewView(s)._setVisible(u)}async $disposeWebviewView(s){const u=this.getWebviewView(s);this._webviewViews.delete(s),u.dispose(),this._extHostWebview.deleteWebview(s)}getWebviewView(s){const u=this._webviewViews.get(s);if(!u)throw new Error("No webview found");return u}}e.ExtHostWebviewViews=p}),define(pe[135],ve([0,1,3,5,2,10,8,4,14]),function(ee,e,d,t,I,C,T,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class ji{constructor(y){this._onDidChangeWindowState=new d.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=ji.InitialState,this._proxy=y.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(c=>this.$onDidChangeWindowFocus(c))}get state(){return this._state}$onDidChangeWindowFocus(y){y!==this._state.focused&&(this._state={...this._state,focused:y},this._onDidChangeWindowState.fire(this._state))}openUri(y,c){let E;if(typeof y=="string"){E=y;try{y=I.URI.parse(y)}catch{return Promise.reject(`Invalid uri - '${y}'`)}}return(0,T.isFalsyOrWhitespace)(y.scheme)?Promise.reject("Invalid scheme - cannot be empty"):y.scheme===C.Schemas.command?Promise.reject(`Invalid scheme '${y.scheme}'`):this._proxy.$openUri(y,E,c)}async asExternalUri(y,c){if((0,T.isFalsyOrWhitespace)(y.scheme))return Promise.reject("Invalid scheme - cannot be empty");const E=await this._proxy.$asExternalUri(y,c);return I.URI.from(E)}};P.InitialState={focused:!0},P=Be([Me(0,D.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(pe[261],ve([0,1,9,61,33,39,6,5,2,14]),function(ee,e,d,t,I,C,T,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let F=class extends T.Disposable{constructor(c,E){super();const v=c.getProxy(k.MainContext.MainThreadDownloadService);E.registerCommand(!1,"_workbench.downloadResource",async w=>{const _=D.URI.file((0,d.join)((0,t.tmpdir)(),(0,I.generateUuid)()));return await v.$download(w,_),_})}};F=Be([Me(0,P.IExtHostRpcService),Me(1,C.IExtHostCommands)],F),e.ExtHostDownloadService=F}),define(pe[262],ve([0,1,133,10,190,33]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class T extends d.ExtHostLoggerService{doCreateLogger(D,P,F){return D.scheme===t.Schemas.file?new I.SpdLogLogger(F?.name||(0,C.generateUuid)(),D.fsPath,!F?.donotRotate,!!F?.donotUseFormatters,P):super.doCreateLogger(D,P,F)}}e.ExtHostLoggerService=T}),define(pe[263],ve([0,1,60,9,2,67,6,10,13,29]),function(ee,e,d,t,I,C,T,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class F extends C.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(r){const S=await super._getWorkspaceStorageURI(r);if(S.scheme!==k.Schemas.file)return S;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${S.fsPath}.`),S;const a=S.fsPath;let i=0;do{let n;i===0?n=a:n=/[/\\]$/.test(a)?`${a.substr(0,a.length-1)}-${i}`:`${a}-${i}`,await y(n);const o=t.join(n,"vscode.lock"),l=await w(this._logService,o,!1);if(l)return this._workspaceStorageLock=l,process.on("exit",()=>{l.dispose()}),I.URI.file(n);i++}while(i<10);return S}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=F;async function y(u){try{await P.Promises.stat(u);return}catch{}try{await P.Promises.mkdir(u,{recursive:!0})}catch{}}const c=1e3,E=10*60*1e3;class v extends T.Disposable{constructor(r,S){super();this.logService=r,this.filename=S,this._timer=this._register(new D.IntervalTimer),this._timer.cancelAndSet(async()=>{const a=await _(r,S);(!a||a.pid!==process.pid)&&(r.info(`Lock '${S}': The lock was lost unexpectedly.`),this._timer.cancel());try{await P.Promises.utimes(S,new Date,new Date)}catch(i){r.error(i),r.info(`Lock '${S}': Could not update mtime.`)}},c)}dispose(){super.dispose();try{d.unlinkSync(this.filename)}catch{}}async setWillRelease(r){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${r} ms.`);try{const S={pid:process.pid,willReleaseAt:Date.now()+r};await P.Promises.writeFile(this.filename,JSON.stringify(S),{flag:"w"})}catch(S){this.logService.error(S)}}}async function w(u,r,S){try{const i={pid:process.pid,willReleaseAt:0};await P.Promises.writeFile(r,JSON.stringify(i),{flag:"wx"})}catch(i){u.error(i)}const a=await _(u,r);return!a||a.pid!==process.pid?S?(u.info(`Lock '${r}': Could not acquire lock, giving up.`),null):(u.info(`Lock '${r}': Could not acquire lock, checking if the file is stale.`),h(u,r)):(u.info(`Lock '${r}': Lock acquired.`),new v(u,r))}async function _(u,r){let S;try{S=await P.Promises.readFile(r)}catch(a){return u.error(a),null}try{return JSON.parse(String(S))}catch(a){return u.error(a),null}}async function R(u,r){let S;try{S=await P.Promises.stat(r)}catch(a){return u.error(a),0}return S.mtime.getTime()}function p(u){try{return process.kill(u,0),!0}catch{return!1}}async function h(u,r){const S=await _(u,r);if(!S)return u.info(`Lock '${r}': Could not read pid of lock holder.`),s(u,r);if(S.willReleaseAt){let l=S.willReleaseAt-Date.now();if(l<5e3){for(l>0?u.info(`Lock '${r}': The lockfile is scheduled to be released in ${l} ms.`):u.info(`Lock '${r}': The lockfile is scheduled to have been released.`);l>0;){if(await(0,D.timeout)(Math.min(100,l)),await R(u,r)===0)return s(u,r);l=S.willReleaseAt-Date.now()}return s(u,r)}}if(!p(S.pid))return u.info(`Lock '${r}': The pid ${S.pid} appears to be gone.`),s(u,r);const a=await R(u,r),i=Date.now()-a;if(i<=E)return u.info(`Lock '${r}': The lock does not look stale, elapsed: ${i} ms, giving up.`),null;u.info(`Lock '${r}': The lock looks stale, waiting for 2s.`),await(0,D.timeout)(2e3);const n=await R(u,r),o=Date.now()-n;return o<=E?(u.info(`Lock '${r}': The lock does not look stale, elapsed: ${o} ms, giving up.`),null):(u.info(`Lock '${r}': The lock looks stale even after waiting for 2s.`),s(u,r))}async function s(u,r){u.info(`Lock '${r}': Deleting a stale lock.`);try{await P.Promises.unlink(r)}catch{}return w(u,r,!0)}}),define(pe[264],ve([0,1,33,14,34]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let C=class extends I.BaseExtHostTerminalService{constructor(k){super(!0,k)}createTerminal(k,D,P){return this.createTerminalFromOptions({name:k,shellPath:D,shellArgs:P})}createTerminalFromOptions(k,D){const P=new I.ExtHostTerminal(this._proxy,(0,d.generateUuid)(),k,k.name);return this._terminals.push(P),P.create(k,this._serializeParentTerminal(k,D)),P.value}};C=Be([Me(0,t.IExtHostRpcService)],C),e.ExtHostTerminalService=C}),define(pe[265],ve([0,1,5,14,175,6,26,2,38,22,29,7,11,51,3,122,95,12]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c,E,v,w,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class p{constructor(f,m,b){this.remoteAddress=f,this.localAddress=m,this._dispose=b,this._onDispose=new v.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function h(l){const f=l.trim().split(`
`),m=[];return f.forEach(A=>{const L=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(A);L&&L.length>=3&&m.push({pid:parseInt(L[1],10),socket:parseInt(L[2],10)})}),m.reduce((A,L)=>(A[L.socket]=L,A),{})}e.getSockets=h;function s(...l){const f=[].concat(...l.map(r));return[...new Map(f.filter(m=>m.st==="0A").map(m=>{const b=m.local_address.split(":");return{socket:parseInt(m.inode,10),ip:u(b[0]),port:parseInt(b[1],16)}}).map(m=>[m.ip+":"+m.port,m])).values()]}e.loadListeningPorts=s;function u(l){let f="";if(l.length===8)for(let m=l.length-2;m>=0;m-=2)f+=parseInt(l.substr(m,2),16),m!==0&&(f+=".");else for(let m=l.length-4;m>=0;m-=4)f+=parseInt(l.substr(m,4),16).toString(16),m!==0&&(f+=":");return f}e.parseIpAddress=u;function r(l){const f=l.trim().split(`
`),m=f.shift().trim().split(/\s+/).filter(A=>A!=="rx_queue"&&A!=="tm->when");return f.map(A=>A.trim().split(/\s+/).reduce((L,N,g)=>(L[m[g]||g]=N,L),{}))}e.loadConnectionTable=r;function S(l){return!!l.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||l.indexOf("out/server-main.js")!==-1||l.indexOf("_productName=VSCode")!==-1}function a(l){const f=l.trim().split(`
`),m=[];return f.forEach(b=>{const A=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(b);A&&A.length>=4&&m.push({pid:parseInt(A[1],10),ppid:parseInt(A[2]),cmd:A[3]})}),m}e.getRootProcesses=a;async function i(l,f,m){const b=m.reduce((L,N)=>(L[N.pid]=N,L),{}),A=[];return l.forEach(({socket:L,ip:N,port:g})=>{const M=f[L]?f[L].pid:void 0,U=M?b[M]?.cmd:void 0;M&&U&&!S(U)&&A.push({host:N,port:g,detail:U,pid:M})}),A}e.findPorts=i;function n(l,f,m){const b=new Map,A=a(f);for(const L of l){const N=m.get(L.port);if(N){b.set(L.port,N);continue}const g=A.find(M=>M.cmd.includes(`${L.port}`));if(g){let M=g,U;do U=A.find(j=>j.ppid===M.pid),U&&(M=U);while(U);b.set(L.port,{host:L.ip,port:L.port,pid:M.pid,detail:M.cmd,ppid:M.ppid})}else b.set(L.port,{host:L.ip,port:L.port,ppid:Number.MAX_VALUE})}return b}e.tryFindRootPorts=n;let o=class extends C.Disposable{constructor(f,m,b){super();this.logService=b,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new v.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=f.getProxy(d.MainContext.MainThreadTunnelService),c.isLinux&&m.remote.isRemote&&m.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(f,m){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${f.identifier.value} called openTunnel API for ${m.remoteAddress.host}:${m.remoteAddress.port}.`);const b=await this._proxy.$openTunnel(m,f.displayName);if(b){const A=new p(b.remoteAddress,b.localAddress,()=>this._proxy.$closeTunnel(b.remoteAddress));return this._register(A),A}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(f){return Math.max(f*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(f,m){const b=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(b,{selector:f,provider:m}),this._proxy.$registerPortsAttributesProvider(f,b),new y.Disposable(()=>{this._portAttributesProviders.delete(b),this._proxy.$unregisterPortsAttributesProvider(b)})}async $providePortAttributes(f,m,b,A,L){const N=[];for(const M of f){const U=this._portAttributesProviders.get(M);if(!U)return[];N.push(...await Promise.all(m.map(async j=>U.provider.providePortAttributes(j,b,A,L))))}const g=N.filter(M=>!!M);return g.length>0?g.map(M=>({autoForwardAction:M.autoForwardAction,port:M.port})):[]}async $registerCandidateFinder(f){if(f&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=f;let m=new _.MovingAverage,b;for(;this._candidateFindingEnabled;){const A=new Date().getTime(),L=(await this.findCandidatePorts()).filter(g=>(0,w.isLocalhost)(g.host)||(0,w.isAllInterfaces)(g.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${L.map(g=>g.port).join(", ")}`);const N=new Date().getTime()-A;m.update(N),(!b||JSON.stringify(b)!==JSON.stringify(L))&&(b=L,await this._proxy.$onFoundNewCandidates(b)),await new Promise(g=>setTimeout(()=>g(),this.calculateDelay(m.value)))}}async setTunnelFactory(f){if(f){if(f.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(f.candidatePortSource),f.showCandidatePort&&(this._showCandidatePort=f.showCandidatePort,this._proxy.$setCandidateFilter()),f.tunnelFactory){this._forwardPortProvider=f.tunnelFactory;let m=f.tunnelFeatures?.privacyOptions??[];f.tunnelFeatures?.public&&m.length===0&&(m=[{id:"private",label:I.localize(0,null),themeIcon:"lock"},{id:"public",label:I.localize(1,null),themeIcon:"eye"}]);const b=f.tunnelFeatures?{elevation:!!f.tunnelFeatures?.elevation,public:!!f.tunnelFeatures?.public,privacyOptions:m}:void 0;this._proxy.$setTunnelProvider(b)}}else this._forwardPortProvider=void 0;return(0,C.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(f,m){if(this._extensionTunnels.has(f.host)){const b=this._extensionTunnels.get(f.host);b.has(f.port)&&(m&&b.get(f.port).disposeListener.dispose(),await b.get(f.port).tunnel.dispose(),b.delete(f.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(f,m){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const b=this._forwardPortProvider(f,m);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),b!==void 0){const A=await b;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(f.remoteAddress.host)||this._extensionTunnels.set(f.remoteAddress.host,new Map);const L=this._register(A.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(A.remoteAddress))));return this._extensionTunnels.get(f.remoteAddress.host).set(f.remoteAddress.port,{tunnel:A,disposeListener:L}),E.TunnelDto.fromApiTunnel(A)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(f){const m=await Promise.all(f.map(A=>this._showCandidatePort(A.host,A.port,A.detail??""))),b=f.filter((A,L)=>m[L]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${f.map(A=>A.port).join(", ")} to ${b.map(A=>A.port).join(", ")}`),b}async findCandidatePorts(){let f="",m="";try{f=await F.Promises.readFile("/proc/net/tcp","utf8"),m=await F.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const b=s(f,m),A=await new Promise(B=>{(0,D.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(x,z,G)=>{B(z)})}),L=h(A),N=await F.Promises.readdir("/proc"),g=[];for(let B of N)try{const x=Number(B),z=P.joinPath(k.URI.file("/proc"),B);if((await F.Promises.stat(z.fsPath)).isDirectory()&&!isNaN(x)){const q=await F.Promises.readlink(P.joinPath(z,"cwd").fsPath),Z=await F.Promises.readFile(P.joinPath(z,"cmdline").fsPath,"utf8");g.push({pid:x,cwd:q,cmd:Z})}}catch{}const M=[],U=b.filter(B=>{const x=L[B.socket];return x||M.push(B),x}),j=i(U,L,g);let K;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${M.length}`),M.length>0){const B=await new Promise(x=>{(0,D.exec)("ps -F -A -l | grep root",(z,G,q)=>{x(G)})});this._foundRootPorts=n(M,B,this._foundRootPorts),K=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${K.join(", ")}`)}return j.then(B=>K?B.concat(K):B)}};o=Be([Me(0,t.IExtHostRpcService),Me(1,T.IExtHostInitDataService),Me(2,R.ILogService)],o),e.ExtHostTunnelService=o}),define(pe[266],ve([0,1,13,23,21,16,3,6,104,229,52]),function(ee,e,d,t,I,C,T,k,D,P,F){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function c(b,A){try{return JSON.stringify(b,A)}catch{return"null"}}const E="$$ref$$",v={[E]:-1};class w{constructor(A,L){this.jsonString=A,this.referencedBuffers=L}}function _(b,A=null,L=!1){const N=[];return{jsonString:(L?c:JSON.stringify)(b,(M,U)=>{if(typeof U=="undefined")return v;if(typeof U=="object"){if(U instanceof t.VSBuffer){const j=N.push(U)-1;return{[E]:j}}if(A)return A(M,U)}return U}),referencedBuffers:N}}e.stringifyJsonWithBufferRefs=_;function R(b,A,L){return JSON.parse(b,(N,g)=>{if(g){const M=g[E];if(typeof M=="number")return A[M];if(L&&g.$mid===1)return L.transformIncoming(g)}return g})}e.parseJsonAndRestoreBufferRefs=R;function p(b,A){return JSON.stringify(b,A)}function h(b){return b?(A,L)=>L&&L.$mid===1?b.transformOutgoing(L):L:null}var s;(function(b){b[b.LocalSide=0]="LocalSide",b[b.OtherSide=1]="OtherSide"})(s=e.RequestInitiator||(e.RequestInitiator={}));var u;(function(b){b[b.Responsive=0]="Responsive",b[b.Unresponsive=1]="Unresponsive"})(u=e.ResponsiveState||(e.ResponsiveState={}));const r=()=>{},S=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class i extends k.Disposable{constructor(A,L=null,N=null){super();this[y]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=A,this._logger=L,this._uriTransformer=N,this._uriReplacer=h(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let g=0,M=F.ProxyIdentifier.count;g<M;g++)this._locals[g]=null,this._proxies[g]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new d.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(g=>this._receiveOneMessage(g))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(A=>{this._pendingRPCReplies[A].resolveErr(C.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(A){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(A){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(A){this._responsiveState!==A&&(this._responsiveState=A,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(A){return this._uriTransformer?(0,D.transformIncomingURIs)(A,this._uriTransformer):A}getProxy(A){const{nid:L,sid:N}=A;return this._proxies[L]||(this._proxies[L]=this._createProxy(L,N)),this._proxies[L]}_createProxy(A,L){let N={get:(g,M)=>(typeof M=="string"&&!g[M]&&M.charCodeAt(0)===36&&(g[M]=(...U)=>this._remoteCall(A,M,U)),M===a?L:g[M])};return new Proxy(Object.create(null),N)}set(A,L){return this._locals[A.nid]=L,L}assertRegistered(A){for(let L=0,N=A.length;L<N;L++){const g=A[L];if(!this._locals[g.nid])throw new Error(`Missing proxy instance ${g.sid}`)}}_receiveOneMessage(A){if(this._isDisposed)return;const L=A.byteLength,N=n.read(A,0),g=N.readUInt8(),M=N.readUInt32();switch(g){case 1:case 2:{let{rpcId:U,method:j,args:K}=l.deserializeRequestJSONArgs(N);this._uriTransformer&&(K=(0,D.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(L,M,U,j,K,g===2);break}case 3:case 4:{let{rpcId:U,method:j,args:K}=l.deserializeRequestMixedArgs(N);this._uriTransformer&&(K=(0,D.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(L,M,U,j,K,g===4);break}case 5:{this._logger&&this._logger.logIncoming(L,M,0,"ack"),this._onDidReceiveAcknowledge(M);break}case 6:{this._receiveCancel(L,M);break}case 7:{this._receiveReply(L,M,void 0);break}case 9:{let U=l.deserializeReplyOKJSON(N);this._uriTransformer&&(U=(0,D.transformIncomingURIs)(U,this._uriTransformer)),this._receiveReply(L,M,U);break}case 10:{const U=l.deserializeReplyOKJSONWithBuffers(N,this._uriTransformer);this._receiveReply(L,M,U);break}case 8:{let U=l.deserializeReplyOKVSBuffer(N);this._receiveReply(L,M,U);break}case 11:{let U=l.deserializeReplyErrError(N);this._uriTransformer&&(U=(0,D.transformIncomingURIs)(U,this._uriTransformer)),this._receiveReplyErr(L,M,U);break}case 12:{this._receiveReplyErr(L,M,void 0);break}default:console.error("received unexpected message"),console.error(A)}}_receiveRequest(A,L,N,g,M,U){this._logger&&this._logger.logIncoming(A,L,1,`receiveRequest ${(0,F.getStringIdentifierForProxy)(N)}.${g}(`,M);const j=String(L);let K,B;if(U){const z=new I.CancellationTokenSource;M.push(z.token),K=this._invokeHandler(N,g,M),B=()=>z.cancel()}else K=this._invokeHandler(N,g,M),B=r;this._cancelInvokedHandlers[j]=B;const x=l.serializeAcknowledged(L);this._logger&&this._logger.logOutgoing(x.byteLength,L,1,"ack"),this._protocol.send(x),K.then(z=>{delete this._cancelInvokedHandlers[j];const G=l.serializeReplyOK(L,z,this._uriReplacer);this._logger&&this._logger.logOutgoing(G.byteLength,L,1,"reply:",z),this._protocol.send(G)},z=>{delete this._cancelInvokedHandlers[j];const G=l.serializeReplyErr(L,z);this._logger&&this._logger.logOutgoing(G.byteLength,L,1,"replyErr:",z),this._protocol.send(G)})}_receiveCancel(A,L){this._logger&&this._logger.logIncoming(A,L,1,"receiveCancel");const N=String(L);this._cancelInvokedHandlers[N]&&this._cancelInvokedHandlers[N]()}_receiveReply(A,L,N){this._logger&&this._logger.logIncoming(A,L,0,"receiveReply:",N);const g=String(L);if(!this._pendingRPCReplies.hasOwnProperty(g))return;const M=this._pendingRPCReplies[g];delete this._pendingRPCReplies[g],M.resolveOk(N)}_receiveReplyErr(A,L,N){this._logger&&this._logger.logIncoming(A,L,0,"receiveReplyErr:",N);const g=String(L);if(!this._pendingRPCReplies.hasOwnProperty(g))return;const M=this._pendingRPCReplies[g];delete this._pendingRPCReplies[g];let U;N&&(N.$isError?(U=new Error,U.name=N.name,U.message=N.message,U.stack=N.stack):U=N),M.resolveErr(U)}_invokeHandler(A,L,N){try{return Promise.resolve(this._doInvokeHandler(A,L,N))}catch(g){return Promise.reject(g)}}_doInvokeHandler(A,L,N){const g=this._locals[A];if(!g)throw new Error("Unknown actor "+(0,F.getStringIdentifierForProxy)(A));let M=g[L];if(typeof M!="function")throw new Error("Unknown method "+L+" on actor "+(0,F.getStringIdentifierForProxy)(A));return M.apply(g,N)}_remoteCall(A,L,N){if(this._isDisposed)return Promise.reject(C.canceled());let g=null;if(N.length>0&&I.CancellationToken.isCancellationToken(N[N.length-1])&&(g=N.pop()),g&&g.isCancellationRequested)return Promise.reject(C.canceled());const M=l.serializeRequestArguments(N,this._uriReplacer),U=++this._lastMessageId,j=String(U),K=new P.LazyPromise;g&&g.onCancellationRequested(()=>{const x=l.serializeCancel(U);this._logger&&this._logger.logOutgoing(x.byteLength,U,0,"cancel"),this._protocol.send(l.serializeCancel(U))}),this._pendingRPCReplies[j]=K,this._onWillSendRequest(U);const B=l.serializeRequest(U,A,L,M,!!g);return this._logger&&this._logger.logOutgoing(B.byteLength,U,0,`request: ${(0,F.getStringIdentifierForProxy)(A)}.${L}(`,N),this._protocol.send(B),K}}e.RPCProtocol=i,y=S,i.UNRESPONSIVE_TIME=3*1e3;class n{constructor(A,L){this._buff=A,this._offset=L}static alloc(A,L,N){let g=new n(t.VSBuffer.alloc(N+1+4),0);return g.writeUInt8(A),g.writeUInt32(L),g}static read(A,L){return new n(A,L)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(A){this._buff.writeUInt8(A,this._offset),this._offset+=1}readUInt8(){const A=this._buff.readUInt8(this._offset);return this._offset+=1,A}writeUInt32(A){this._buff.writeUInt32BE(A,this._offset),this._offset+=4}readUInt32(){const A=this._buff.readUInt32BE(this._offset);return this._offset+=4,A}static sizeShortString(A){return 1+A.byteLength}writeShortString(A){this._buff.writeUInt8(A.byteLength,this._offset),this._offset+=1,this._buff.set(A,this._offset),this._offset+=A.byteLength}readShortString(){const A=this._buff.readUInt8(this._offset);this._offset+=1;const N=this._buff.slice(this._offset,this._offset+A).toString();return this._offset+=A,N}static sizeLongString(A){return 4+A.byteLength}writeLongString(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}readLongString(){const A=this._buff.readUInt32BE(this._offset);this._offset+=4;const N=this._buff.slice(this._offset,this._offset+A).toString();return this._offset+=A,N}writeBuffer(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}static sizeVSBuffer(A){return 4+A.byteLength}writeVSBuffer(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}readVSBuffer(){const A=this._buff.readUInt32BE(this._offset);this._offset+=4;const L=this._buff.slice(this._offset,this._offset+A);return this._offset+=A,L}static sizeMixedArray(A){let L=0;L+=1;for(let N=0,g=A.length;N<g;N++){const M=A[N];switch(L+=1,M.type){case 1:L+=this.sizeLongString(M.value);break;case 2:L+=this.sizeVSBuffer(M.value);break;case 3:L+=this.sizeUInt32,L+=this.sizeLongString(M.value);for(let U=0;U<M.buffers.length;++U)L+=this.sizeVSBuffer(M.buffers[U]);break;case 4:break}}return L}writeMixedArray(A){this._buff.writeUInt8(A.length,this._offset),this._offset+=1;for(let L=0,N=A.length;L<N;L++){const g=A[L];switch(g.type){case 1:this.writeUInt8(1),this.writeLongString(g.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(g.value);break;case 3:this.writeUInt8(3),this.writeUInt32(g.buffers.length),this.writeLongString(g.value);for(let M=0;M<g.buffers.length;++M)this.writeBuffer(g.buffers[M]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const A=this._buff.readUInt8(this._offset);this._offset+=1;let L=new Array(A);for(let N=0;N<A;N++)switch(this.readUInt8()){case 1:L[N]=this.readLongString();break;case 2:L[N]=this.readVSBuffer();break;case 3:{const M=this.readUInt32(),U=this.readLongString(),j=[];for(let K=0;K<M;++K)j.push(this.readVSBuffer());L[N]=new F.SerializableObjectWithBuffers(R(U,j,null));break}case 4:L[N]=void 0;break}return L}}n.sizeUInt32=4;var o;(function(b){b[b.Simple=0]="Simple",b[b.Mixed=1]="Mixed"})(o||(o={}));class l{static _useMixedArgSerialization(A){for(let L=0,N=A.length;L<N;L++)if(A[L]instanceof t.VSBuffer||A[L]instanceof F.SerializableObjectWithBuffers||typeof A[L]=="undefined")return!0;return!1}static serializeRequestArguments(A,L){if(this._useMixedArgSerialization(A)){const N=[];for(let g=0,M=A.length;g<M;g++){const U=A[g];if(U instanceof t.VSBuffer)N[g]={type:2,value:U};else if(typeof U=="undefined")N[g]={type:4};else if(U instanceof F.SerializableObjectWithBuffers){const{jsonString:j,referencedBuffers:K}=_(U.value,L);N[g]={type:3,value:t.VSBuffer.fromString(j),buffers:K}}else N[g]={type:1,value:t.VSBuffer.fromString(p(U,L))}}return{type:1,args:N}}return{type:0,args:p(A,L)}}static serializeRequest(A,L,N,g,M){switch(g.type){case 0:return this._requestJSONArgs(A,L,N,g.args,M);case 1:return this._requestMixedArgs(A,L,N,g.args,M)}}static _requestJSONArgs(A,L,N,g,M){const U=t.VSBuffer.fromString(N),j=t.VSBuffer.fromString(g);let K=0;K+=n.sizeUInt8(),K+=n.sizeShortString(U),K+=n.sizeLongString(j);let B=n.alloc(M?2:1,A,K);return B.writeUInt8(L),B.writeShortString(U),B.writeLongString(j),B.buffer}static deserializeRequestJSONArgs(A){const L=A.readUInt8(),N=A.readShortString(),g=A.readLongString();return{rpcId:L,method:N,args:JSON.parse(g)}}static _requestMixedArgs(A,L,N,g,M){const U=t.VSBuffer.fromString(N);let j=0;j+=n.sizeUInt8(),j+=n.sizeShortString(U),j+=n.sizeMixedArray(g);let K=n.alloc(M?4:3,A,j);return K.writeUInt8(L),K.writeShortString(U),K.writeMixedArray(g),K.buffer}static deserializeRequestMixedArgs(A){const L=A.readUInt8(),N=A.readShortString(),g=A.readMixedArray(),M=new Array(g.length);for(let U=0,j=g.length;U<j;U++){const K=g[U];typeof K=="string"?M[U]=JSON.parse(K):M[U]=K}return{rpcId:L,method:N,args:M}}static serializeAcknowledged(A){return n.alloc(5,A,0).buffer}static serializeCancel(A){return n.alloc(6,A,0).buffer}static serializeReplyOK(A,L,N){if(typeof L=="undefined")return this._serializeReplyOKEmpty(A);if(L instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(A,L);if(L instanceof F.SerializableObjectWithBuffers){const{jsonString:g,referencedBuffers:M}=_(L.value,N,!0);return this._serializeReplyOKJSONWithBuffers(A,g,M)}else return this._serializeReplyOKJSON(A,c(L,N))}static _serializeReplyOKEmpty(A){return n.alloc(7,A,0).buffer}static _serializeReplyOKVSBuffer(A,L){let N=0;N+=n.sizeVSBuffer(L);let g=n.alloc(8,A,N);return g.writeVSBuffer(L),g.buffer}static deserializeReplyOKVSBuffer(A){return A.readVSBuffer()}static _serializeReplyOKJSON(A,L){const N=t.VSBuffer.fromString(L);let g=0;g+=n.sizeLongString(N);let M=n.alloc(9,A,g);return M.writeLongString(N),M.buffer}static _serializeReplyOKJSONWithBuffers(A,L,N){const g=t.VSBuffer.fromString(L);let M=0;M+=n.sizeUInt32,M+=n.sizeLongString(g);for(const j of N)M+=n.sizeVSBuffer(j);let U=n.alloc(10,A,M);U.writeUInt32(N.length),U.writeLongString(g);for(const j of N)U.writeBuffer(j);return U.buffer}static deserializeReplyOKJSON(A){const L=A.readLongString();return JSON.parse(L)}static deserializeReplyOKJSONWithBuffers(A,L){const N=A.readUInt32(),g=A.readLongString(),M=[];for(let U=0;U<N;++U)M.push(A.readVSBuffer());return new F.SerializableObjectWithBuffers(R(g,M,L))}static serializeReplyErr(A,L){return L?this._serializeReplyErrEror(A,L):this._serializeReplyErrEmpty(A)}static _serializeReplyErrEror(A,L){const N=t.VSBuffer.fromString(c(C.transformErrorForSerialization(L),null));let g=0;g+=n.sizeLongString(N);let M=n.alloc(11,A,g);return M.writeLongString(N),M.buffer}static deserializeReplyErrError(A){const L=A.readLongString();return JSON.parse(L)}static _serializeReplyErrEmpty(A){return n.alloc(12,A,0).buffer}}var f;(function(b){b[b.RequestJSONArgs=1]="RequestJSONArgs",b[b.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",b[b.RequestMixedArgs=3]="RequestMixedArgs",b[b.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",b[b.Acknowledged=5]="Acknowledged",b[b.Cancel=6]="Cancel",b[b.ReplyOKEmpty=7]="ReplyOKEmpty",b[b.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",b[b.ReplyOKJSON=9]="ReplyOKJSON",b[b.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",b[b.ReplyErrError=11]="ReplyErrError",b[b.ReplyErrEmpty=12]="ReplyErrEmpty"})(f||(f={}));var m;(function(b){b[b.String=1]="String",b[b.VSBuffer=2]="VSBuffer",b[b.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",b[b.Undefined=4]="Undefined"})(m||(m={}))}),define(pe[267],ve([0,1,4]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,d.createDecorator)("remoteAgentService")}),define(pe[268],ve([0,1,28,10,9,11,22,2,4,200,43,224,267]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,D.createDecorator)("pathService");let E=class qi{constructor(w,_,R,p){this.localUserHome=w,this.remoteAgentService=_,this.environmentService=R,this.contextService=p,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||C.OS)(),this.resolveUserHome=(async()=>{const h=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=h?.userHome||w})()}hasValidBasename(w,_,R){return typeof _=="string"||typeof _=="undefined"?this.resolveOS.then(p=>this.doHasValidBasename(w,p,_)):this.doHasValidBasename(w,_,R)}doHasValidBasename(w,_,R){return w.scheme===t.Schemas.file||w.scheme===t.Schemas.vscodeRemote?(0,d.isValidBasename)(R??(0,T.basename)(w),_===1):!0}get defaultUriScheme(){return qi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(w,_){if(w.remoteAuthority)return t.Schemas.vscodeRemote;const R=(0,P.getVirtualWorkspaceScheme)(_.getWorkspace());if(R)return R;const p=_.getWorkspace().folders[0];if(p)return p.uri.scheme;const h=_.getWorkspace().configuration;return h?h.scheme:t.Schemas.file}async userHome(w){return w?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(w=>w===1?I.win32:I.posix)}async fileURI(w){let _="";if(await this.resolveOS===1&&(w=w.replace(/\\/g,"/")),w[0]==="/"&&w[1]==="/"){const p=w.indexOf("/",2);p===-1?(_=w.substring(2),w="/"):(_=w.substring(2,p),w=w.substring(p)||"/")}return k.URI.from({scheme:t.Schemas.file,authority:_,path:w,query:"",fragment:""})}};E=Be([Me(1,c.IRemoteAgentService),Me(2,y.IWorkbenchEnvironmentService),Me(3,F.IWorkspaceContextService)],E),e.AbstractPathService=E}),define(pe[69],ve([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class d{constructor(T,k){this.line=T,this.character=k}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,k){return new d(0,0)}with(T){return new d(0,0)}}e.Position=d;class t{constructor(T,k,D,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new d(T,k),this.end=new d(D,P)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new t(0,0,0,0)}with(T){return new t(0,0,0,0)}}e.Range=t;var I;(function(C){C[C.Information=1]="Information",C[C.Warning=2]="Warning"})(I=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(pe[31],ve([0,1,17,32,25,28,8,4,9,16,69,13]),function(ee,e,d,t,I,C,T,k,D,P,F,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return F.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const c="\u27EA ",E=" characters skipped \u27EB",v=(c.length+E.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var w;(function(x){x[x.file=0]="file",x[x.text=1]="text"})(w=e.SearchProviderType||(e.SearchProviderType={}));var _;(function(x){x[x.File=1]="File",x[x.Text=2]="Text"})(_=e.QueryType||(e.QueryType={}));function R(x){return!!x.preview}e.resultIsMatch=R;function p(x){return!!x.resource}e.isFileMatch=p;function h(x){return!!x.message}e.isProgressMessage=h;var s;(function(x){x[x.Normal=0]="Normal",x[x.NewSearchStarted=1]="NewSearchStarted"})(s=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class u{constructor(z){this.resource=z,this.results=[]}}e.FileMatch=u;class r{constructor(z,G,q){this.ranges=G;const Z=Array.isArray(G)?G:[G];if(q&&q.matchLines===1&&S(Z)){z=(0,T.getNLines)(z,q.matchLines);let se="",ue=0,te=0;const J=Math.floor(q.charsPerLine/5),ae=[];for(const he of Z){const we=Math.max(he.startColumn-J,0),Ie=he.startColumn+q.charsPerLine;if(we>te+J+v){const Ne=c+(we-te)+E;se+=Ne+z.slice(we,Ie),ue+=we-(te+Ne.length)}else se+=z.slice(te,Ie);ae.push(new i(0,he.startColumn-ue,he.endColumn-ue)),te=Ie}this.preview={text:se,matches:Array.isArray(this.ranges)?ae:ae[0]}}else{const se=Array.isArray(G)?G[0].startLineNumber:G.startLineNumber;this.preview={text:z,matches:(0,d.mapArrayOrNot)(G,ue=>new a(ue.startLineNumber-se,ue.startColumn,ue.endLineNumber-se,ue.endColumn))}}}}e.TextSearchMatch=r;function S(x){const z=x[0].startLineNumber;for(const G of x)if(G.startLineNumber!==z||G.endLineNumber!==z)return!1;return!0}class a{constructor(z,G,q,Z){this.startLineNumber=z,this.startColumn=G,this.endLineNumber=q,this.endColumn=Z}}e.SearchRange=a;class i extends a{constructor(z,G,q){super(z,G,z,q)}}e.OneLineRange=i;var n;(function(x){x.Default="default",x.FileNames="fileNames",x.Type="type",x.Modified="modified",x.CountDescending="countDescending",x.CountAscending="countAscending"})(n=e.SearchSortOrder||(e.SearchSortOrder={}));function o(x,z=!0){const G=x&&x.files&&x.files.exclude,q=z&&x&&x.search&&x.search.exclude;if(!G&&!q)return;if(!G||!q)return G||q;let Z=Object.create(null);return Z=I.mixin(Z,I.deepClone(G)),Z=I.mixin(Z,I.deepClone(q),!0),Z}e.getExcludes=o;function l(x,z){return x.excludePattern&&t.match(x.excludePattern,z)?!1:x.includePattern||x.usingSearchPaths?x.includePattern&&t.match(x.includePattern,z)?!0:x.usingSearchPaths?!!x.folderQueries&&x.folderQueries.some(G=>{const q=G.folder.fsPath;if(C.isEqualOrParent(z,q)){const Z=D.relative(q,z);return!G.includePattern||!!t.match(G.includePattern,Z)}else return!1}):!1:!0}e.pathIncludedInQuery=l;var f;(function(x){x[x.unknownEncoding=1]="unknownEncoding",x[x.regexParseError=2]="regexParseError",x[x.globParseError=3]="globParseError",x[x.invalidLiteral=4]="invalidLiteral",x[x.rgProcessError=5]="rgProcessError",x[x.other=6]="other",x[x.canceled=7]="canceled"})(f=e.SearchErrorCode||(e.SearchErrorCode={}));class m extends Error{constructor(z,G){super(z);this.code=G}}e.SearchError=m;function b(x){const z=x.message;if((0,P.isCancellationError)(x))return new m(z,f.canceled);try{const G=JSON.parse(z);return new m(G.message,G.code)}catch{return new m(z,f.other)}}e.deserializeSearchError=b;function A(x){const z={message:x.message,code:x.code};return new Error(JSON.stringify(z))}e.serializeSearchError=A;function L(x){return x.type==="error"?!0:x.type==="success"}e.isSerializedSearchComplete=L;function N(x){return x.type==="success"}e.isSerializedSearchSuccess=N;function g(x){return!!x.path}e.isSerializedFileMatch=g;function M(x,z){const G=x.searchPath?x.searchPath:x.relativePath;return(0,T.fuzzyContains)(G,z)}e.isFilePatternMatch=M;class U{constructor(z){this.path=z,this.results=[]}addMatch(z){this.results.push(z)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=U;function j(x,z){const G={...x||{},...z||{}};return Object.keys(G).filter(q=>{const Z=G[q];return typeof Z=="boolean"&&Z})}e.resolvePatternsForProvider=j;class K{constructor(z,G){this._parsedIncludeExpression=null,this._excludeExpression={...z.excludePattern||{},...G.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let q=z.includePattern;G.includePattern&&(q?q={...q,...G.includePattern}:q=G.includePattern),q&&(this._parsedIncludeExpression=t.parse(q))}matchesExcludesSync(z,G,q){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(z,G,q))}includedInQuerySync(z,G,q){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(z,G,q)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(z,G,q))}includedInQuery(z,G,q){const Z=this._parsedExcludeExpression(z,G,q),se=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(z,G,q):!0;return(0,y.isThenable)(Z)?Z.then(ue=>ue?!1:se()):se()}hasSiblingExcludeClauses(){return B(this._excludeExpression)}}e.QueryGlobTester=K;function B(x){for(const z in x)if(typeof x[z]!="boolean")return!0;return!1}}),define(pe[35],ve([0,1,17,13,21,3,24,10,95,22,8,18,2,173,4,12,191,43,44,26,14,15,7,31,5]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c,E,v,w,_,R,p,h,s,u,r,S,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function i(L,N,g){return new P.ExtUri(M=>f(M,g)).isEqual(L,N)}function n(L,N,g){return i(L.uri,N.uri,g)?0:(0,F.compare)(L.uri.toString(),N.uri.toString())}function o(L,N,g){return L.index!==N.index?L.index<N.index?-1:1:i(L.uri,N.uri,g)?(0,F.compare)(L.name,N.name):(0,F.compare)(L.uri.toString(),N.uri.toString())}function l(L,N,g,M){const U=L.slice(0).sort((K,B)=>g(K,B,M)),j=N.slice(0).sort((K,B)=>g(K,B,M));return(0,d.delta)(U,j,(K,B)=>g(K,B,M))}function f(L,N){const g=N.getCapabilities(L.scheme);return!(g&&g&1024)}class m extends R.Workspace{constructor(N,g,M,U,j,K,B){super(N,M.map(x=>new R.WorkspaceFolder(x)),U,j,B);this._name=g,this._isUntitled=K,this._workspaceFolders=[],this._structure=T.TernarySearchTree.forUris(B),M.forEach(x=>{this._workspaceFolders.push(x),this._structure.set(x.uri,x)})}static toExtHostWorkspace(N,g,M,U){if(!N)return{workspace:null,added:[],removed:[]};const{id:j,name:K,folders:B,configuration:x,transient:z,isUntitled:G}=N,q=[],Z=g;g?B.forEach((J,ae)=>{const he=c.URI.revive(J.uri),we=m._findFolder(M||g,he,U);we?(we.name=J.name,we.index=J.index,q.push(we)):q.push({uri:he,name:J.name,index:ae})}):q.push(...B.map(({uri:J,name:ae,index:he})=>({uri:c.URI.revive(J),name:ae,index:he}))),q.sort((J,ae)=>J.index<ae.index?-1:1);const se=new m(j,K,q,!!z,x?c.URI.revive(x):null,!!G,J=>f(J,U)),{added:ue,removed:te}=l(Z?Z.workspaceFolders:[],se.workspaceFolders,n,U);return{workspace:se,added:ue,removed:te}}static _findFolder(N,g,M){for(let U=0;U<N.folders.length;U++){const j=N.workspaceFolders[U];if(i(j.uri,g,M))return j}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(N,g){return g&&this._structure.get(N)&&(N=(0,P.dirname)(N)),this._structure.findSubstr(N)}resolveWorkspaceFolder(N){return this._structure.get(N)}}let b=class{constructor(N,g,M,U){this._onDidChangeWorkspace=new C.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new C.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=U,this._extHostFileSystemInfo=M,this._requestIdProvider=new D.Counter,this._barrier=new t.Barrier,this._proxy=N.getProxy(a.MainContext.MainThreadWorkspace),this._messageService=N.getProxy(a.MainContext.MainThreadMessageService);const j=g.workspace;this._confirmedWorkspace=j?new m(j.id,j.name,[],!!j.transient,j.configuration?c.URI.revive(j.configuration):null,!!j.isUntitled,K=>f(K,M)):void 0}$initializeWorkspace(N,g){this._trusted=g,this.$acceptWorkspaceData(N),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?c.URI.from({scheme:k.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(N,g,M,...U){const j=[];if(Array.isArray(U)&&U.forEach(G=>{c.URI.isUri(G.uri)&&!j.some(q=>i(q.uri,G.uri,this._extHostFileSystemInfo))&&j.push({uri:G.uri,name:G.name||(0,P.basenameOrAuthority)(G.uri)})}),this._unconfirmedWorkspace||[g,M].some(G=>typeof G!="number"||G<0)||M===0&&j.length===0)return!1;const K=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(g+M>K.length)return!1;const B=K.slice(0);B.splice(g,M,...j.map(G=>({uri:G.uri,name:G.name||(0,P.basenameOrAuthority)(G.uri),index:void 0})));for(let G=0;G<B.length;G++){const q=B[G];if(B.some((Z,se)=>se!==G&&i(q.uri,Z.uri,this._extHostFileSystemInfo)))return!1}B.forEach((G,q)=>G.index=q);const{added:x,removed:z}=l(K,B,o,this._extHostFileSystemInfo);if(x.length===0&&z.length===0)return!1;if(this._proxy){const G=N.displayName||N.name;this._proxy.$updateWorkspaceFolders(G,g,M,j).then(void 0,q=>{this._unconfirmedWorkspace=void 0;const Z={source:{identifier:N.identifier,label:N.displayName||N.name}};this._messageService.$showMessage(_.Severity.Error,(0,E.localize)(0,null,G,q.toString()),Z,[])})}return this.trySetWorkspaceFolders(B),!0}getWorkspaceFolder(N,g){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,g)}async getWorkspaceFolder2(N,g){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,g)}async resolveWorkspaceFolder(N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(N)}getPath(){if(!this._actualWorkspace)return;const{folders:N}=this._actualWorkspace;if(N.length!==0)return N[0].uri.fsPath}getRelativePath(N,g){let M,U="";if(typeof N=="string"?(M=c.URI.file(N),U=N):typeof N!="undefined"&&(M=N,U=N.fsPath),!M)return U;const j=this.getWorkspaceFolder(M,!0);if(!j)return U;typeof g=="undefined"&&this._actualWorkspace&&(g=this._actualWorkspace.folders.length>1);let K=(0,P.relativePath)(j.uri,M);return g&&j.name&&(K=`${j.name}/${K}`),K}trySetWorkspaceFolders(N){this._actualWorkspace&&(this._unconfirmedWorkspace=m.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:N,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:g,added:M,removed:U}=m.toExtHostWorkspace(N,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=g||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:M,removed:U}))}findFiles(N,g,M,U,j=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let K;if(g===null?K=!1:g&&(typeof g=="string"?K=g:K=g.pattern),j&&j.isCancellationRequested)return Promise.resolve([]);const{includePattern:B,folder:x}=A(u.GlobPattern.from(N));return this._proxy.$startFileSearch((0,y.withUndefinedAsNull)(B),(0,y.withUndefinedAsNull)(x),(0,y.withUndefinedAsNull)(K),(0,y.withUndefinedAsNull)(M),j).then(z=>Array.isArray(z)?z.map(G=>c.URI.revive(G)):[])}async findTextInFiles(N,g,M,U,j=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const K=this._requestIdProvider.getNext(),B=typeof g.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:g.previewOptions,{includePattern:x,folder:z}=A(u.GlobPattern.from(g.include)),G=typeof g.exclude=="string"?g.exclude:g.exclude?g.exclude.pattern:void 0,q={ignoreSymlinks:typeof g.followSymlinks=="boolean"?!g.followSymlinks:void 0,disregardIgnoreFiles:typeof g.useIgnoreFiles=="boolean"?!g.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof g.useGlobalIgnoreFiles=="boolean"?!g.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof g.useParentIgnoreFiles=="boolean"?!g.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof g.useDefaultExcludes=="boolean"?!g.useDefaultExcludes:!0,fileEncoding:g.encoding,maxResults:g.maxResults,previewOptions:B,afterContext:g.afterContext,beforeContext:g.beforeContext,includePattern:x,excludePattern:G},Z=!1;if(this._activeSearchCallbacks[K]=se=>{if(Z)return;const ue=c.URI.revive(se.resource);se.results.forEach(te=>{(0,S.resultIsMatch)(te)?M({uri:ue,preview:{text:te.preview.text,matches:(0,d.mapArrayOrNot)(te.preview.matches,J=>new r.Range(J.startLineNumber,J.startColumn,J.endLineNumber,J.endColumn))},ranges:(0,d.mapArrayOrNot)(te.ranges,J=>new r.Range(J.startLineNumber,J.startColumn,J.endLineNumber,J.endColumn))}):M({uri:ue,text:te.text,lineNumber:te.lineNumber})})},j.isCancellationRequested)return{};try{const se=await this._proxy.$startTextSearch(N,(0,y.withUndefinedAsNull)(z),q,K,j);return delete this._activeSearchCallbacks[K],se||{}}catch(se){throw delete this._activeSearchCallbacks[K],se}}$handleTextSearchResult(N,g){this._activeSearchCallbacks[g]&&this._activeSearchCallbacks[g](N)}saveAll(N){return this._proxy.$saveAll(N)}resolveProxy(N){return this._proxy.$resolveProxy(N)}get trusted(){return this._trusted}requestWorkspaceTrust(N){return this._proxy.$requestWorkspaceTrust(N)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};b=Be([Me(0,s.IExtHostRpcService),Me(1,h.IExtHostInitDataService),Me(2,p.IExtHostFileSystemInfo),Me(3,w.ILogService)],b),e.ExtHostWorkspace=b,e.IExtHostWorkspace=(0,v.createDecorator)("IExtHostWorkspace");function A(L){let N,g;return L&&(typeof L=="string"?N=L:(N=L.pattern,g=c.URI.revive(L.baseUri))),{includePattern:N,folder:g}}}),define(pe[36],ve([0,1,25,3,35,5,7,195,119,18,13,4,14,12,2]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function w(S,a){if(a){const i=a.split(".");let n=S;for(let o=0;n&&o<i.length;o++)n=n[i[o]];return n}}function _(S){return S instanceof v.URI}function R(S){return S&&S.uri instanceof v.URI&&S.languageId&&typeof S.languageId=="string"}function p(S){return S&&!S.uri&&S.languageId&&typeof S.languageId=="string"}function h(S){return S&&S.uri instanceof v.URI&&(!S.name||typeof S.name=="string")&&(!S.index||typeof S.index=="number")}function s(S){if(_(S))return{resource:S};if(R(S))return{resource:S.uri,overrideIdentifier:S.languageId};if(p(S))return{overrideIdentifier:S.languageId};if(h(S))return{resource:S.uri};if(S===null)return{resource:null}}let u=class{constructor(a,i,n){this._proxy=a.getProxy(C.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=n,this._barrier=new F.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(a=>this._actual)}$initializeConfiguration(a){this._actual=new r(this._proxy,this._extHostWorkspace,a,this._logService),this._barrier.open()}$acceptConfigurationChanged(a,i){this.getConfigProvider().then(n=>n.$acceptConfigurationChanged(a,i))}};u=Be([Me(0,c.IExtHostRpcService),Me(1,I.IExtHostWorkspace),Me(2,E.ILogService)],u),e.ExtHostConfiguration=u;class r{constructor(a,i,n,o){this._onDidChangeConfiguration=new t.Emitter,this._proxy=a,this._logService=o,this._extHostWorkspace=i,this._configuration=k.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(a,i){const n={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,n))}getConfiguration(a,i,n){const o=s(i)||{},l=this._toReadonlyValue(a?w(this._configuration.getValue(void 0,o,this._extHostWorkspace.workspace),a):this._configuration.getValue(void 0,o,this._extHostWorkspace.workspace));a&&this._validateConfigurationAccess(a,o,n?.identifier);function f(b){if(b==null)return null;if(typeof b=="boolean")return b?1:4;switch(b){case T.ConfigurationTarget.Global:return 1;case T.ConfigurationTarget.Workspace:return 4;case T.ConfigurationTarget.WorkspaceFolder:return 5}}const m={has(b){return typeof w(l,b)!="undefined"},get:(b,A)=>{this._validateConfigurationAccess(a?`${a}.${b}`:b,o,n?.identifier);let L=w(l,b);if(typeof L=="undefined")L=A;else{let N;const g=(M,U)=>{let j;const K=()=>{N=N||(0,d.deepClone)(l),j=j||w(N,U)};return(0,P.isObject)(M)?new Proxy(M,{get:(B,x)=>{if(typeof x=="string"&&x.toLowerCase()==="tojson")return K(),()=>j;if(N)return j=j||w(N,U),j[x];const z=B[x];return typeof x=="string"?g(z,`${U}.${x}`):z},set:(B,x,z)=>(K(),j&&(j[x]=z),!0),deleteProperty:(B,x)=>(K(),j&&delete j[x],!0),defineProperty:(B,x,z)=>(K(),j&&Object.defineProperty(j,x,z),!0)}):M};L=g(L,b)}return L},update:(b,A,L,N)=>{b=a?`${a}.${b}`:b;const g=f(L);return A!==void 0?this._proxy.$updateConfigurationOption(g,b,A,o,N):this._proxy.$removeConfigurationOption(g,b,o,N)},inspect:b=>{b=a?`${a}.${b}`:b;const A=(0,d.deepClone)(this._configuration.inspect(b,o,this._extHostWorkspace.workspace));if(A)return{key:b,defaultValue:A.default?.value,globalValue:A.user?.value,workspaceValue:A.workspace?.value,workspaceFolderValue:A.workspaceFolder?.value,defaultLanguageValue:A.default?.override,globalLanguageValue:A.user?.override,workspaceLanguageValue:A.workspace?.override,workspaceFolderLanguageValue:A.workspaceFolder?.override,languageIds:A.overrideIdentifiers}}};return typeof l=="object"&&(0,d.mixin)(m,l,!1),Object.freeze(m)}_toReadonlyValue(a){const i=n=>(0,P.isObject)(n)?new Proxy(n,{get:(o,l)=>i(o[l]),set:(o,l,f)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(l)}' of object`)},deleteProperty:(o,l)=>{throw new Error(`TypeError: Cannot delete read only property '${String(l)}' of object`)},defineProperty:(o,l)=>{throw new Error(`TypeError: Cannot define property '${String(l)}' for a readonly object`)},setPrototypeOf:o=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):n;return i(a)}_validateConfigurationAccess(a,i,n){const o=D.OVERRIDE_PROPERTY_REGEX.test(a)?4:this._configurationScopes.get(a),l=n?`[${n.value}] `:"";if(o===4){typeof i?.resource=="undefined"&&this._logService.warn(`${l}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(o===3){i?.resource&&this._logService.warn(`${l}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(a,i){const n=new k.ConfigurationChangeEvent(a,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(o,l)=>n.affectsConfiguration(o,s(l))})}_toMap(a){return a.reduce((i,n)=>(i.set(n[0],n[1]),i),new Map)}}e.ExtHostConfigProvider=r,e.IExtHostConfiguration=(0,y.createDecorator)("IExtHostConfiguration")});var Qe=this&&this.__classPrivateFieldSet||function(ee,e,d,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,d):I?I.value=d:e.set(ee,d),d},Te=this&&this.__classPrivateFieldGet||function(ee,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(ee):t?t.value:e.get(ee)};define(pe[70],ve([0,1,2,13,3,5,7,35,45,36,21,34,14,26,4,10,11,12,65,216,16]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c,E,v,w,_,R,p,h,s){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var r;(function(U){function j(B){if(B!=null)return B}U.from=j;function K(B){if(B!=null)return B}U.to=K})(r=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var S;(function(U){function j(B){if(B!=null)return B}U.from=j;function K(B){if(B!=null)return B}U.to=K})(S=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var a;(function(U){function j(B){if(B!=null)return B}U.from=j;function K(B){if(B!=null)return B}U.to=K})(a=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(U){function j(x){if(x){const z=x;return z&&!!z.process}else return!1}U.is=j;function K(x){if(x==null)return;const z={process:x.process,args:x.args};return x.options&&(z.options=a.from(x.options)),z}U.from=K;function B(x){if(x!=null)return new T.ProcessExecution(x.process,x.args,x.options)}U.to=B})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var n;(function(U){function j(B){if(B!=null)return B}U.from=j;function K(B){if(B!=null)return B}U.to=K})(n=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var o;(function(U){function j(x){if(x){const z=x;return z&&(!!z.commandLine||!!z.command)}else return!1}U.is=j;function K(x){if(x==null)return;const z={};return x.commandLine!==void 0?z.commandLine=x.commandLine:(z.command=x.command,z.args=x.args),x.options&&(z.options=n.from(x.options)),z}U.from=K;function B(x){if(!(x==null||x.command===void 0&&x.commandLine===void 0))return x.commandLine?new T.ShellExecution(x.commandLine,x.options):new T.ShellExecution(x.command,x.args?x.args:[],x.options)}U.to=B})(o=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var l;(function(U){function j(x){if(x){let z=x;return z&&z.customExecution==="customExecution"}else return!1}U.is=j;function K(x){return{customExecution:"customExecution"}}U.from=K;function B(x,z){return z.get(x)}U.to=B})(l=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var f;(function(U){function j(K,B){let x;return K.scope!==void 0&&typeof K.scope!="number"?x=K.scope.uri:K.scope!==void 0&&typeof K.scope=="number"&&(K.scope===T.TaskScope.Workspace&&B&&B.workspaceFile?x=B.workspaceFile:x=h.USER_TASKS_GROUP_KEY),{id:K._id,workspaceFolder:x}}U.from=j})(f=e.TaskHandleDTO||(e.TaskHandleDTO={}));var m;(function(U){function j(K){if(K!=null)return{_id:K.id,isDefault:K.isDefault}}U.from=j})(m=e.TaskGroupDTO||(e.TaskGroupDTO={}));var b;(function(U){function j(x,z){if(x==null)return[];const G=[];for(let q of x){const Z=K(q,z);Z&&G.push(Z)}return G}U.fromMany=j;function K(x,z){if(x==null)return;let G;x.execution instanceof T.ProcessExecution?G=i.from(x.execution):x.execution instanceof T.ShellExecution?G=o.from(x.execution):x.execution&&x.execution instanceof T.CustomExecution&&(G=l.from(x.execution));const q=r.from(x.definition);let Z;return x.scope?typeof x.scope=="number"?Z=x.scope:Z=x.scope.uri:Z=T.TaskScope.Workspace,!q||!Z?void 0:{_id:x._id,definition:q,name:x.name,source:{extensionId:z.identifier.value,label:x.source,scope:Z},execution:G,isBackground:x.isBackground,group:m.from(x.group),presentationOptions:S.from(x.presentationOptions),problemMatchers:x.problemMatchers,hasDefinedMatchers:x.hasDefinedMatchers,runOptions:x.runOptions?x.runOptions:{reevaluateOnRerun:!0},detail:x.detail}}U.from=K;async function B(x,z,G){if(x==null)return;let q;i.is(x.execution)?q=i.to(x.execution):o.is(x.execution)?q=o.to(x.execution):l.is(x.execution)&&(q=l.to(x._id,G));const Z=r.to(x.definition);let se;if(x.source&&(x.source.scope!==void 0?typeof x.source.scope=="number"?se=x.source.scope:se=await z.resolveWorkspaceFolder(d.URI.revive(x.source.scope)):se=T.TaskScope.Workspace),!Z||!se)return;const ue=new T.Task(Z,se,x.name,x.source.label,q,x.problemMatchers);return x.isBackground!==void 0&&(ue.isBackground=x.isBackground),x.group!==void 0&&(ue.group=T.TaskGroup.from(x.group._id),ue.group&&x.group.isDefault&&(ue.group=new T.TaskGroup(ue.group.id,ue.group.label),x.group.isDefault&&(ue.group.isDefault=x.group.isDefault))),x.presentationOptions&&(ue.presentationOptions=S.to(x.presentationOptions)),x._id&&(ue._id=x._id),x.detail&&(ue.detail=x.detail),ue}U.to=B})(b=e.TaskDTO||(e.TaskDTO={}));var A;(function(U){function j(B){return B}U.from=j;function K(B){if(!!B)return Object.assign(Object.create(null),B)}U.to=K})(A=e.TaskFilterDTO||(e.TaskFilterDTO={}));class L{constructor(j,K,B){this._id=K,this._task=B,u.set(this,void 0),Qe(this,u,j,"f")}get task(){return this._task}terminate(){Te(this,u,"f").terminateTask(this)}fireDidStartProcess(j){}fireDidEndProcess(j){}}u=new WeakMap;var N;(function(U){function j(K){return{id:K._id,task:void 0}}U.from=j})(N=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let g=class{constructor(j,K,B,x,z,G,q,Z){this._onDidExecuteTask=new I.Emitter,this._onDidTerminateTask=new I.Emitter,this._onDidTaskProcessStarted=new I.Emitter,this._onDidTaskProcessEnded=new I.Emitter,this._proxy=j.getProxy(C.MainContext.MainThreadTask),this._workspaceProvider=B,this._editorService=x,this._configurationService=z,this._terminalService=G,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=q,this._deprecationService=Z,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(j,K,B){if(!B)return new T.Disposable(()=>{});const x=this.nextHandle();return this._handlers.set(x,{type:K,provider:B,extension:j}),this._proxy.$registerTaskProvider(x,K),new T.Disposable(()=>{this._handlers.delete(x),this._proxy.$unregisterTaskProvider(x)})}registerTaskSystem(j,K){this._proxy.$registerTaskSystem(j,K)}fetchTasks(j){return this._proxy.$fetchTasks(A.from(j)).then(async K=>{const B=[];for(let x of K){const z=await b.to(x,this._workspaceProvider,this._providedCustomExecutions2);z&&B.push(z)}return B})}get taskExecutions(){const j=[];return this._taskExecutions.forEach(K=>j.push(K)),j}terminateTask(j){if(!(j instanceof L))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(j._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(j,K,B){const x=this._providedCustomExecutions2.get(j.id);x&&(this._activeCustomExecutions2.set(j.id,x),this._terminalService.attachPtyToTerminal(K,await x.callback(B))),this._lastStartedTask=j.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(j)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(j){const K=await this.getTaskExecution(j);this._taskExecutionPromises.delete(j.id),this._taskExecutions.delete(j.id),this.customExecutionComplete(j),this._onDidTerminateTask.fire({execution:K})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(j){const K=await this.getTaskExecution(j.id);this._onDidTaskProcessStarted.fire({execution:K,processId:j.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(j){const K=await this.getTaskExecution(j.id);this._onDidTaskProcessEnded.fire({execution:K,exitCode:j.exitCode})}$provideTasks(j,K){const B=this._handlers.get(j);if(!B)return Promise.reject(new Error("no handler found"));const x=[],z=(0,t.asPromise)(()=>B.provider.provideTasks(F.CancellationToken.None)).then(G=>this.provideTasksInternal(K,x,B,G));return new Promise(G=>{z.then(q=>{Promise.all(x).then(()=>{G(q)})})})}async $resolveTask(j,K){const B=this._handlers.get(j);if(!B)return Promise.reject(new Error("no handler found"));if(K.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${K.definition.type}] cannot be resolved by provider of type [${B.type}].`);const x=await b.to(K,this._workspaceProvider,this._providedCustomExecutions2);if(!x)throw new Error("Unexpected: Task cannot be resolved.");const z=await B.provider.resolveTask(x,F.CancellationToken.None);if(!z)return;this.checkDeprecation(z,B);const G=b.from(z,B.extension);if(!G)throw new Error("Unexpected: Task cannot be resolved.");if(z.definition!==x.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return l.is(G.execution)&&await this.addCustomExecution(G,z,!0),await this.resolveTaskInternal(G)}nextHandle(){return this._handleCounter++}async addCustomExecution(j,K,B){const x=await this._proxy.$createTaskId(j);!B&&!this._providedCustomExecutions2.has(x)&&(this._notProvidedCustomExecutions.add(x),this._activeCustomExecutions2.set(x,K.execution)),this._providedCustomExecutions2.set(x,K.execution)}async getTaskExecution(j,K){if(typeof j=="string"){const z=this._taskExecutionPromises.get(j);if(!z)throw new Error("Unexpected: The specified task is missing an execution");return z}let B=this._taskExecutionPromises.get(j.id);if(B)return B;const x=new Promise((z,G)=>{function q(Z,se,ue){ue?z(new L(Z,se.id,ue)):G("Unexpected: Task does not exist.")}K?q(this,j,K):b.to(j.task,this._workspaceProvider,this._providedCustomExecutions2).then(Z=>q(this,j,Z))});return this._taskExecutionPromises.set(j.id,x),x.then(z=>(this._taskExecutions.set(j.id,z),z),z=>Promise.reject(z))}checkDeprecation(j,K){j._deprecated&&this._deprecationService.report("Task.constructor",K.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(j){this._activeCustomExecutions2.get(j.id)&&this._activeCustomExecutions2.delete(j.id),this._notProvidedCustomExecutions.has(j.id)&&this._lastStartedTask!==j.id&&(this._providedCustomExecutions2.delete(j.id),this._notProvidedCustomExecutions.delete(j.id));let B=this._notProvidedCustomExecutions.values(),x=B.next();for(;!x.done;)!this._activeCustomExecutions2.has(x.value)&&this._lastStartedTask!==x.value&&(this._providedCustomExecutions2.delete(x.value),this._notProvidedCustomExecutions.delete(x.value)),x=B.next()}};g=Be([Me(0,c.IExtHostRpcService),Me(1,E.IExtHostInitDataService),Me(2,k.IExtHostWorkspace),Me(3,D.IExtHostDocumentsAndEditors),Me(4,P.IExtHostConfiguration),Me(5,y.IExtHostTerminalService),Me(6,R.ILogService),Me(7,p.IExtHostApiDeprecationService)],g),e.ExtHostTaskBase=g;let M=class extends g{constructor(j,K,B,x,z,G,q,Z){super(j,K,B,x,z,G,q,Z);this.registerTaskSystem(w.Schemas.vscodeRemote,{scheme:w.Schemas.vscodeRemote,authority:"",platform:_.PlatformToString(0)})}async executeTask(j,K){if(!K.execution)throw new Error("Tasks to execute must include an execution");const B=b.from(K,j);if(B===void 0)throw new Error("Task is not valid");if(l.is(B.execution))await this.addCustomExecution(B,K,!1);else throw new s.NotSupportedError;const x=await this.getTaskExecution(await this._proxy.$getTaskExecution(B),K);return this._proxy.$executeTask(B).catch(z=>{throw new Error(z)}),x}provideTasksInternal(j,K,B,x){const z=[];if(x)for(let G of x){this.checkDeprecation(G,B),(!G.definition||!j[G.definition.type])&&this._logService.warn(`The task [${G.source}, ${G.name}] uses an undefined task type. The task will be ignored in the future.`);const q=b.from(G,B.extension);q&&l.is(q.execution)?(z.push(q),K.push(this.addCustomExecution(q,G,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:z,extension:B.extension}}async resolveTaskInternal(j){if(l.is(j.execution))return j;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(j,K){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(j,K,B){}};M=Be([Me(0,c.IExtHostRpcService),Me(1,E.IExtHostInitDataService),Me(2,k.IExtHostWorkspace),Me(3,D.IExtHostDocumentsAndEditors),Me(4,P.IExtHostConfiguration),Me(5,y.IExtHostTerminalService),Me(6,R.ILogService),Me(7,p.IExtHostApiDeprecationService)],M),e.WorkerExtHostTask=M,e.IExtHostTask=(0,v.createDecorator)("IExtHostTask")}),define(pe[269],ve([0,1,17,74,32,79,24,10,9,22,8,18,2,153,179,116,43,129,268,31]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c,E,v,w,_,R,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let s=class{constructor(f,m,b,A){this.configurationService=f,this.workspaceContextService=m,this.editorGroupsService=b,this.pathService=A}text(f,m,b={}){f=this.getContentPattern(f,b);const A=this.configurationService.getValue(),L=m&&m.some(g=>!this.configurationService.getValue({resource:g}).search.useRipgrep);return{...this.commonQuery(m?.map(_.toWorkspaceFolder),b),type:2,contentPattern:f,previewOptions:b.previewOptions,maxFileSize:b.maxFileSize,usePCRE2:A.search.usePCRE2||L||!1,beforeContext:b.beforeContext,afterContext:b.afterContext,userDisabledExcludesAndIgnoreFiles:b.disregardExcludeSettings&&b.disregardIgnoreFiles}}getContentPattern(f,m){const b=this.configurationService.getValue();f.isRegExp&&(f.pattern=f.pattern.replace(/\r?\n/g,"\\n"));const A={...f,wordSeparators:b.editor.wordSeparators};return this.isCaseSensitive(f,m)&&(A.isCaseSensitive=!0),this.isMultiline(f)&&(A.isMultiline=!0),A}file(f,m={}){return{...this.commonQuery(f,m),type:1,filePattern:m.filePattern?m.filePattern.trim():m.filePattern,exists:m.exists,sortByScore:m.sortByScore,cacheKey:m.cacheKey}}handleIncludeExclude(f,m){return f?(f=Array.isArray(f)?f.map(i):i(f),m?this.parseSearchPaths(f):{pattern:r(...Array.isArray(f)?f:[f])}):{}}commonQuery(f=[],m={}){const b=this.handleIncludeExclude(m.includePattern,m.expandPatterns),A=this.handleIncludeExclude(m.excludePattern,m.expandPatterns),L=f.length>1,N=(b.searchPaths&&b.searchPaths.length?b.searchPaths.map(U=>this.getFolderQueryForSearchPath(U,m,A)):f.map(U=>this.getFolderQueryForRoot(U,m,A,L))).filter(U=>!!U),g={_reason:m._reason,folderQueries:N,usingSearchPaths:!!(b.searchPaths&&b.searchPaths.length),extraFileResources:m.extraFileResources,excludePattern:A.pattern,includePattern:b.pattern,onlyOpenEditors:m.onlyOpenEditors,maxResults:m.maxResults};if(m.onlyOpenEditors){const j=d.coalesce(d.flatten(this.editorGroupsService.groups.map(B=>B.editors.map(x=>x.resource)))).filter(B=>(0,h.pathIncludedInQuery)(g,B.fsPath)),K=this.commonQueryFromFileList(j);return{...g,...K}}const M=m.extraFileResources&&m.extraFileResources.filter(U=>(0,h.pathIncludedInQuery)(g,U.fsPath));return g.extraFileResources=M&&M.length?M:void 0,g}commonQueryFromFileList(f){const m=[],b=new T.ResourceMap,A={};let L=!1;return f.forEach(N=>{if(N.scheme===k.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(N)){const M=this.workspaceContextService.getWorkspaceFolder(N)?.uri??N.with({path:D.dirname(N.fsPath)});let U=b.get(M);U||(L=!0,U={folder:M,includePattern:{}},m.push(U),b.set(M,U));const j=D.relative(M.fsPath,N.fsPath);(0,y.assertIsDefined)(U.includePattern)[j.replace(/\\/g,"/")]=!0}else N.fsPath&&(L=!0,A[N.fsPath]=!0)}),{folderQueries:m,includePattern:A,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(f,m){if(m.isSmartCase){if(f.isRegExp){if(F.containsUppercaseCharacter(f.pattern,!0))return!0}else if(F.containsUppercaseCharacter(f.pattern))return!0}return!!f.isCaseSensitive}isMultiline(f){return f.isMultiline||f.isRegExp&&(0,E.isMultilineRegexSource)(f.pattern)||f.pattern.indexOf(`
`)>=0?!0:!!f.isMultiline}parseSearchPaths(f){const m=K=>D.isAbsolute(K)||/^\.\.?([\/\\]|$)/.test(K),A=(Array.isArray(f)?f:S(f)).map(K=>{const B=this.pathService.resolvedUserHome;return B?(0,C.untildify)(K,B.scheme===k.Schemas.file?B.fsPath:B.path):K}),L=t.groupBy(A,K=>m(K)?"searchPaths":"exprSegments"),N=(L.exprSegments||[]).map(K=>F.rtrim(K,"/")).map(K=>F.rtrim(K,"\\")).map(K=>(K[0]==="."&&(K="*"+K),a(K))),g={},M=this.expandSearchPathPatterns(L.searchPaths||[]);M&&M.length&&(g.searchPaths=M);const U=d.flatten(N),j=r(...U);return j&&(g.pattern=j),g}getExcludesForFolder(f,m){return m.disregardExcludeSettings?void 0:(0,h.getExcludes)(f,!m.disregardSearchExcludeSettings)}expandSearchPathPatterns(f){if(!f||!f.length)return[];const m=d.flatten(f.map(A=>{let{pathPortion:L,globPortion:N}=u(A);N&&(N=n(N));const g=this.expandOneSearchPath(L);return d.flatten(g.map(M=>this.resolveOneSearchPathPattern(M,N)))})),b=new Map;return m.forEach(A=>{const L=A.searchPath.toString(),N=b.get(L);N?A.pattern&&(N.pattern=N.pattern||{},N.pattern[A.pattern]=!0):b.set(L,{searchPath:A.searchPath,pattern:A.pattern?r(A.pattern):void 0})}),Array.from(b.values())}expandOneSearchPath(f){if(D.isAbsolute(f)){const m=this.workspaceContextService.getWorkspace().folders;return m[0]&&m[0].uri.scheme!==k.Schemas.file?[{searchPath:m[0].uri.with({path:f})}]:[{searchPath:c.URI.file(D.normalize(f))}]}if(this.workspaceContextService.getWorkbenchState()===2){const m=this.workspaceContextService.getWorkspace().folders[0].uri;if(f=i(f),f.startsWith("../")||f===".."){const A=D.posix.resolve(m.path,f);return[{searchPath:m.with({path:A})}]}const b=n(f);return[{searchPath:m,pattern:b}]}else{if(f==="./"||f===".\\")return[];{const m=f.replace(/^\.[\/\\]/,""),A=this.workspaceContextService.getWorkspace().folders.map(L=>{const N=m.match(new RegExp(`^${F.escapeRegExpCharacters(L.name)}(?:/(.*)|$)`));return N?{match:N,folder:L}:null}).filter(y.isDefined);if(A.length)return A.map(L=>{const N=L.match[1];return{searchPath:L.folder.uri,pattern:N&&n(N)}});{const L=f.match(/\.[\/\\](.+)[\/\\]?/),N=L?L[1]:f,g=v.localize(0,null,N);throw new Error(g)}}}}resolveOneSearchPathPattern(f,m){const b=f.pattern&&m?`${f.pattern}/${m}`:f.pattern||m,A=[{searchPath:f.searchPath,pattern:b}];return b&&!b.endsWith("**")&&A.push({searchPath:f.searchPath,pattern:b+"/**"}),A}getFolderQueryForSearchPath(f,m,b){const A=this.getFolderQueryForRoot((0,_.toWorkspaceFolder)(f.searchPath),m,b,!1);return A?{...A,includePattern:f.pattern}:null}getFolderQueryForRoot(f,m,b,A){let L;const N=c.URI.isUri(f)?f:f.uri;if(b.searchPaths){const K=b.searchPaths.filter(B=>(0,P.isEqual)(B.searchPath,N))[0];if(K&&!K.pattern)return null;K&&(L=K.pattern)}const g=this.configurationService.getValue({resource:N}),U={...this.getExcludesForFolder(g,m)||{},...L||{}},j=c.URI.isUri(f)?(0,P.basename)(f):f.name;return{folder:N,folderName:A?j:void 0,excludePattern:Object.keys(U).length>0?U:void 0,fileEncoding:g.files&&g.files.encoding,disregardIgnoreFiles:typeof m.disregardIgnoreFiles=="boolean"?m.disregardIgnoreFiles:!g.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof m.disregardGlobalIgnoreFiles=="boolean"?m.disregardGlobalIgnoreFiles:!g.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof m.disregardParentIgnoreFiles=="boolean"?m.disregardParentIgnoreFiles:!g.search.useParentIgnoreFiles,ignoreSymlinks:typeof m.ignoreSymlinks=="boolean"?m.ignoreSymlinks:!g.search.followSymlinks}}};s=Be([Me(0,w.IConfigurationService),Me(1,_.IWorkspaceContextService),Me(2,R.IEditorGroupsService),Me(3,p.IPathService)],s),e.QueryBuilder=s;function u(l){const f=l.match(/[\*\{\}\(\)\[\]\?]/);if(f){const m=f.index,b=l.substr(0,m).match(/[/|\\][^/\\]*$/);if(b){let A=l.substr(0,b.index);return A.match(/[/\\]/)||(A+="/"),{pathPortion:A,globPortion:l.substr((b.index||0)+1)}}}return{pathPortion:l}}function r(...l){return l.length?l.reduce((f,m)=>(f[m]=!0,f),Object.create(null)):void 0}function S(l){return I.splitGlobAware(l,",").map(f=>f.trim()).filter(f=>!!f.length)}function a(l){return[`**/${l}/**`,`**/${l}`].map(m=>m.replace(/\*\*\/\*\*/g,"**"))}function i(l){return l.replace(/\\/g,"/")}function n(l){return i(l).replace(/^\.\//,"").replace(/\/+$/g,"")}function o(l,f){l=d.distinct(l,A=>A.toString());const m=[],b=f.getWorkspace();return l&&l.forEach(A=>{let L;if(f.getWorkbenchState()===2)L=(0,P.relativePath)(b.folders[0].uri,A),L&&L!=="."&&(L="./"+L);else{const N=f.getWorkspaceFolder(A);if(N){const g=N.name;if(b.folders.filter(U=>U.name===g).length===1){const U=(0,P.relativePath)(N.uri,A);U===""?L=`./${N.name}`:L=`./${N.name}/${U}`}else L=A.fsPath}}L&&m.push(L)}),m}e.resolveResourcesForSearchIncludes=o}),define(pe[270],ve([0,1,22,2,21,16,4,269,31,43]),function(ee,e,d,t,I,C,T,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const F=7e3;function y(w,_){const R=_.activationEvents;if(!R)return Promise.resolve(void 0);const p=[],h=[];for(const i of R)if(/^workspaceContains:/.test(i)){const n=i.substr("workspaceContains:".length);n.indexOf("*")>=0||n.indexOf("?")>=0||w.forceUsingSearch?h.push(n):p.push(n)}if(p.length===0&&h.length===0)return Promise.resolve(void 0);let s;const u=new Promise((i,n)=>{s=i}),r=i=>s({activationEvent:i}),S=Promise.all(p.map(i=>c(w,i,r))).then(()=>{}),a=E(w,_.identifier,h,r);return Promise.all([S,a]).then(()=>{s(void 0)}),u}e.checkActivateWorkspaceContainsExtension=y;async function c(w,_,R){for(const p of w.folders)if(await w.exists(d.joinPath(t.URI.revive(p),_))){R(`workspaceContains:${_}`);return}}async function E(w,_,R,p){if(R.length===0)return Promise.resolve(void 0);const h=new I.CancellationTokenSource,s=w.checkExists(w.folders,R,h.token),u=setTimeout(async()=>{h.cancel(),w.logService.info(`Not activating extension '${_.value}': Timed out while searching for 'workspaceContains' pattern ${R.join(",")}`)},F);let r=!1;try{r=await s}catch(S){C.isCancellationError(S)||C.onUnexpectedError(S)}h.dispose(),clearTimeout(u),r&&p(`workspaceContains:${R.join(",")}`)}function v(w,_,R,p){const h=w.get(T.IInstantiationService),s=w.get(D.ISearchService),r=h.createInstance(k.QueryBuilder).file(_.map(S=>(0,P.toWorkspaceFolder)(t.URI.revive(S))),{_reason:"checkExists",includePattern:R,exists:!0});return s.fileSearch(r,p).then(S=>!!S.limitHit,S=>C.isCancellationError(S)?!1:Promise.reject(S))}e.checkGlobFileExists=v});var Qe=this&&this.__classPrivateFieldSet||function(ee,e,d,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ee,d):I?I.value=d:e.set(ee,d),d},Te=this&&this.__classPrivateFieldGet||function(ee,e,d,t){if(d==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return d==="m"?t:d==="a"?t.call(ee):t?t.value:e.get(ee)};define(pe[40],ve([0,1,168,9,71,22,13,6,24,2,12,5,36,227,91,35,30,225,16,27,23,202,7,120,4,26,67,14,84,51,34,3,270,90,204,10]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c,E,v,w,_,R,p,h,s,u,r,S,a,i,n,o,l,f,m,b,A,L,N,g){"use strict";var M,U,j;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,a.createDecorator)("IHostUtils");let K=class Gi extends k.Disposable{constructor(q,Z,se,ue,te,J,ae,he,we,Ie){super();this._onDidChangeRemoteConnectionData=this._register(new b.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=Z,this._extHostContext=se,this._initData=ae,this._extHostWorkspace=ue,this._extHostConfiguration=te,this._logService=J,this._extHostTunnelService=we,this._extHostTerminalService=Ie,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(y.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(y.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(y.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new T.Barrier,this._readyToStartExtensionHost=new T.Barrier,this._readyToRunExtensions=new T.Barrier,this._eagerExtensionsActivated=new T.Barrier,this._registry=new R.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new v.ExtHostStorage(this._extHostContext),this._secretState=new L.ExtHostSecretState(this._extHostContext),this._storagePath=he,this._instaService=q.createChild(new l.ServiceCollection([v.IExtHostStorage,this._storage],[L.IExtHostSecretState,this._secretState]));const Ne=new Set;this._initData.hostExtensions.forEach(Ee=>Ne.add(h.ExtensionIdentifier.toKey(Ee))),this._activator=this._register(new E.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Ee,be,H)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ee,p.transformErrorForSerialization(be),H)},actualActivateExtension:async(Ee,be)=>{if(Ne.has(h.ExtensionIdentifier.toKey(Ee)))return await this._mainThreadExtensionsProxy.$activateExtension(Ee,be),new E.HostExtension;const H=this._registry.getExtensionDescription(Ee);return this._activateExtension(H,be)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),I.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(q){p.onUnexpectedError(q)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let q=[];try{q=this._registry.getAllExtensionDescriptions().map(te=>te.identifier).filter(te=>this.isActivated(te)).map(te=>this._deactivate(te))}catch{}await Promise.all(q)}isActivated(q){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(q):!1}_activateByEvent(q,Z){return this._activator.activateByEvent(q,Z)}_activateById(q,Z){return this._activator.activateById(q,Z)}activateByIdWithErrors(q,Z){return this._activateById(q,Z).then(()=>{const se=this._activator.getActivatedExtension(q);if(se.activationFailed)return Promise.reject(se.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(q=>this._registry)}getExtensionExports(q){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(q).exports:null}async _realPathExtensionUri(q){if(q.scheme!==g.Schemas.file)return q;const Z=await this._hostUtils.realpath(q.fsPath);return P.URI.file(Z)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const q=D.TernarySearchTree.forUris(Z=>C.extUriBiasedIgnorePathCase.ignorePathCasing(Z));for(const Z of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(Z)){const se=await this._realPathExtensionUri(Z.extensionLocation);q.set(se,Z)}return q})()),this._extensionPathIndex}_deactivate(q){let Z=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(q))return Z;const se=this._activator.getActivatedExtension(q);if(!se)return Z;try{typeof se.module.deactivate=="function"&&(Z=Promise.resolve(se.module.deactivate()).then(void 0,ue=>(this._logService.error(ue),Promise.resolve(void 0))))}catch(ue){this._logService.error(`An error occurred when deactivating the extension '${q.value}':`),this._logService.error(ue)}try{(0,k.dispose)(se.subscriptions)}catch(ue){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${q.value}':`),this._logService.error(ue)}return Z}async _activateExtension(q,Z){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(q.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(q.identifier),this._doActivateExtension(q,Z).then(se=>{const ue=se.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(q.identifier,ue.codeLoadingTime,ue.activateCallTime,ue.activateResolvedTime,Z),this._logExtensionActivationTimes(q,Z,"success",ue),se},se=>{throw this._logExtensionActivationTimes(q,Z,"failure"),se})}_logExtensionActivationTimes(q,Z,se,ue){const te=B(q,Z);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...te,...ue||{},outcome:se})}_doActivateExtension(q,Z){const se=B(q,Z);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",se);const ue=this._getEntryPoint(q);if(!ue)return Promise.resolve(new E.EmptyExtension(E.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${q.identifier.value}, startup: ${Z.startup}, activationEvent: '${Z.activationEvent}'${q.identifier.value!==Z.extensionId.value?`, root cause: ${Z.extensionId.value}`:""}`),this._logService.flush();const te=new E.ExtensionActivationTimesBuilder(Z.startup);return Promise.all([this._loadCommonJSModule(q.identifier,(0,C.joinPath)(q.extensionLocation,ue),te),this._loadExtensionContext(q)]).then(J=>(I.mark(`code/extHost/willActivateExtension/${q.identifier.value}`),Gi._callActivate(this._logService,q.identifier,J[0],J[1],te))).then(J=>(I.mark(`code/extHost/didActivateExtension/${q.identifier.value}`),J))}_loadExtensionContext(q){const Z=new u.ExtensionGlobalMemento(q,this._storage),se=new u.ExtensionMemento(q.identifier.value,!1,this._storage),ue=new N.ExtensionSecrets(q,this._secretState),te=q.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,J=this._initData.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${q.identifier.value}`),Promise.all([Z.whenReady,se.whenReady,this._storagePath.whenReady]).then(()=>{const ae=this;let he,we;const Ie=(0,_.isProposedApiEnabled)(q,"ipc")?this._initData.messagePorts?.get(h.ExtensionIdentifier.toKey(q.identifier)):void 0;return Object.freeze({globalState:Z,workspaceState:se,secrets:ue,subscriptions:[],get extensionUri(){return q.extensionLocation},get extensionPath(){return q.extensionLocation.fsPath},asAbsolutePath(Ne){return t.join(q.extensionLocation.fsPath,Ne)},get storagePath(){return ae._storagePath.workspaceValue(q)?.fsPath},get globalStoragePath(){return ae._storagePath.globalValue(q).fsPath},get logPath(){return t.join(ae._initData.logsLocation.fsPath,q.identifier.value)},get logUri(){return P.URI.joinPath(ae._initData.logsLocation,q.identifier.value)},get storageUri(){return ae._storagePath.workspaceValue(q)},get globalStorageUri(){return ae._storagePath.globalValue(q)},get extensionMode(){return te},get extension(){return he===void 0&&(he=new x(ae,q.identifier,q,J)),he},get extensionRuntime(){return(0,_.checkProposedApiEnabled)(q,"extensionRuntime"),ae.extensionRuntime},get environmentVariableCollection(){return ae._extHostTerminalService.getEnvironmentVariableCollection(q)},get messagePassingProtocol(){if(!we){if(!Ie)return;const Ne=b.Event.buffer(b.Event.fromDOMEventEmitter(Ie,"message",Ee=>Ee.data));Ie.start(),we={onDidReceiveMessage:Ne,postMessage:Ie.postMessage.bind(Ie)}}return we}})})}static _callActivate(q,Z,se,ue,te){return se=se||{activate:void 0,deactivate:void 0},this._callActivateOptional(q,Z,se,ue,te).then(J=>new E.ActivatedExtension(!1,null,te.build(),se,J,ue.subscriptions))}static _callActivateOptional(q,Z,se,ue,te){if(typeof se.activate=="function")try{te.activateCallStart(),q.trace(`ExtensionService#_callActivateOptional ${Z.value}`);const J=typeof global=="object"?global:self,ae=se.activate.apply(J,[ue]);return te.activateCallStop(),te.activateResolveStart(),Promise.resolve(ae).then(he=>(te.activateResolveStop(),he))}catch(J){return Promise.reject(J)}else return Promise.resolve(se)}_activateOneStartupFinished(q,Z){this._activateById(q.identifier,{startup:!1,extensionId:q.identifier,activationEvent:Z}).then(void 0,se=>{this._logService.error(se)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(I.getMarks());for(const q of this._registry.getAllExtensionDescriptions())if(q.activationEvents)for(const Z of q.activationEvents)Z==="onStartupFinished"&&this._activateOneStartupFinished(q,Z)}_handleEagerExtensions(){const q=this._activateByEvent("*",!0).then(void 0,te=>{this._logService.error(te)});this._register(this._extHostWorkspace.onDidChangeWorkspace(te=>this._handleWorkspaceContainsEagerExtensions(te.added)));const Z=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],se=this._handleWorkspaceContainsEagerExtensions(Z),ue=Promise.all([q,se]).then(()=>{});return Promise.race([ue,(0,T.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ue}_handleWorkspaceContainsEagerExtensions(q){return q.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(Z=>this._handleWorkspaceContainsEagerExtension(q,Z))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(q,Z){if(this.isActivated(Z.identifier))return;const se=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ue={logService:this._logService,folders:q.map(J=>J.uri),forceUsingSearch:se,exists:J=>this._hostUtils.exists(J.fsPath),checkExists:(J,ae,he)=>this._mainThreadWorkspaceProxy.$checkExists(J,ae,he)},te=await(0,A.checkActivateWorkspaceContainsExtension)(ue,Z);if(!!te)return this._activateById(Z.identifier,{startup:!0,extensionId:Z.identifier,activationEvent:te.activationEvent}).then(void 0,J=>this._logService.error(J))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(q){throw console.error(q),q}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:q,extensionTestsLocationURI:Z}=this._initData.environment;if(!q||!Z)throw new Error(d.localize(0,null));const se=await this._loadCommonJSModule(null,Z,new E.ExtensionActivationTimesBuilder(!1));if(!se||typeof se.run!="function")throw new Error(d.localize(1,null,Z.toString()));return new Promise((ue,te)=>{const J=(we,Ie)=>{we?te(we):ue(typeof Ie=="number"&&Ie>0?1:0)},ae=(0,C.originalFSPath)(Z),he=se.run(ae,J);he&&he.then&&he.then(()=>{ue(0)}).catch(we=>{te(we instanceof Error&&we.stack?we.stack:String(we))})})}async $extensionTestsExit(q){this._logService.info(`Extension host terminating: test runner requested exit with code ${q}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${q}`),this._logService.flush(),this._hostUtils.exit(q)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(q,Z){return this._resolvers[q]=Z,(0,k.toDisposable)(()=>{delete this._resolvers[q]})}async _activateAndGetResolver(q){const Z=q.indexOf("+");if(Z===-1)throw new Error("Not an authority that can be resolved!");const se=q.substr(0,Z);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${se}`,!1),{authorityPrefix:se,resolver:this._resolvers[se]}}async $resolveAuthority(q,Z){this._logService.info(`$resolveAuthority invoked for authority (${z(q)})`);const{authorityPrefix:se,resolver:ue}=await this._activateAndGetResolver(q);if(!ue)return{type:"error",error:{code:S.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${se}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(ue)),I.mark(`code/extHost/willResolveAuthority/${se}`);const te=await ue.resolve(q,{resolveAttempt:Z});I.mark(`code/extHost/didResolveAuthorityOK/${se}`);const J={authority:q,host:te.host,port:te.port,connectionToken:te.connectionToken},ae={extensionHostEnv:te.extensionHostEnv,isTrusted:te.isTrusted,authenticationSession:te.authenticationSessionForInitializingExtensions?{id:te.authenticationSessionForInitializingExtensions.id,providerId:te.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:J,options:ae,tunnelInformation:{environmentTunnels:te.environmentTunnels,features:te.tunnelFeatures}}}}catch(te){if(I.mark(`code/extHost/didResolveAuthorityError/${se}`),te instanceof r.RemoteAuthorityResolverError)return{type:"error",error:{code:te._code,message:te._message,detail:te._detail}};throw te}}async $getCanonicalURI(q,Z){this._logService.info(`$getCanonicalURI invoked for authority (${z(q)})`);const{authorityPrefix:se,resolver:ue}=await this._activateAndGetResolver(q);if(!ue)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${se}`);const te=P.URI.revive(Z);if(typeof ue.getCanonicalURI=="undefined")return te;const J=await(0,T.asPromise)(()=>ue.getCanonicalURI(te));return J||te}$startExtensionHost(q){return this._registry.keepOnly(q),this._startExtensionHost()}$activateByEvent(q,Z){return Z===1?this._activateByEvent(q,!1):this._readyToRunExtensions.wait().then(se=>this._activateByEvent(q,!1))}async $activate(q,Z){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(q)?(await this._activateById(q,Z),!0):!1}async $deltaExtensions(q,Z){q.forEach(ue=>ue.extensionLocation=P.URI.revive(ue.extensionLocation));const se=await this.getExtensionPathIndex();return await Promise.all(Z.map(async ue=>{const te=this._registry.getExtensionDescription(ue);te&&se.delete(await this._realPathExtensionUri(te.extensionLocation))})),await Promise.all(q.map(async ue=>{const te=await this._realPathExtensionUri(ue.extensionLocation);se.set(te,ue)})),this._registry.deltaExtensions(q,Z),Promise.resolve(void 0)}async $test_latency(q){return q}async $test_up(q){return q.byteLength}async $test_down(q){let Z=s.VSBuffer.alloc(q),se=Math.random()%256;for(let ue=0;ue<q;ue++)Z.writeUInt8(se,ue);return Z}async $updateRemoteConnectionData(q){this._remoteConnectionData=q,this._onDidChangeRemoteConnectionData.fire()}};K=Be([Me(0,a.IInstantiationService),Me(1,e.IHostUtils),Me(2,o.IExtHostRpcService),Me(3,w.IExtHostWorkspace),Me(4,c.IExtHostConfiguration),Me(5,F.ILogService),Me(6,i.IExtHostInitDataService),Me(7,n.IExtensionStoragePaths),Me(8,f.IExtHostTunnelService),Me(9,m.IExtHostTerminalService)],K),e.AbstractExtHostExtensionService=K;function B(G,q){return{id:G.identifier.value,name:G.name,extensionVersion:G.version,publisherDisplayName:G.publisher,activationEvents:G.activationEvents?G.activationEvents.join(","):null,isBuiltin:G.isBuiltin,reason:q.activationEvent,reasonId:q.extensionId.value}}e.IExtHostExtensionService=(0,a.createDecorator)("IExtHostExtensionService");class x{constructor(q,Z,se,ue){M.set(this,void 0),U.set(this,void 0),j.set(this,void 0),Qe(this,M,q,"f"),Qe(this,U,Z,"f"),Qe(this,j,se.identifier,"f"),this.id=se.identifier.value,this.extensionUri=se.extensionLocation,this.extensionPath=t.normalize((0,C.originalFSPath)(se.extensionLocation)),this.packageJSON=se,this.extensionKind=ue}get isActive(){return Te(this,M,"f").isActivated(Te(this,j,"f"))}get exports(){if(this.packageJSON.api!=="none")return Te(this,M,"f").getExtensionExports(Te(this,j,"f"))}activate(){return Te(this,M,"f").activateByIdWithErrors(Te(this,j,"f"),{startup:!1,extensionId:Te(this,U,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=x,M=new WeakMap,U=new WeakMap,j=new WeakMap;function z(G){const q=G.indexOf("+");return q===-1?G:G.substring(0,q)}}),define(pe[54],ve([0,1,9,2,3,13,5,7,125,35,40,45,218,36,211,14,4,18,37,53]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c,E,v,w,_,R,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,_.createDecorator)("IExtHostDebugService");let s=class{constructor(l,f,m,b,A,L){this._workspaceService=f,this._extensionService=m,this._editorsService=b,this._configurationService=A,this._editorTabs=L,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new I.Emitter,this._onDidTerminateDebugSession=new I.Emitter,this._onDidChangeActiveDebugSession=new I.Emitter,this._onDidReceiveDebugSessionCustomEvent=new I.Emitter,this._debugServiceProxy=l.getProxy(T.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new I.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new r(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(N=>{N.onDidChange(g=>{this.registerAllDebugTypes(N)}),this.registerAllDebugTypes(N)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(l,f){const m=l;if(typeof m.sourceReference=="number"&&m.sourceReference>0){let b=`debug:${encodeURIComponent(m.path||"")}`,A="?";return f&&(b+=`${A}session=${encodeURIComponent(f.id)}`,A="&"),b+=`${A}ref=${m.sourceReference}`,t.URI.parse(b)}else{if(m.path)return t.URI.file(m.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(l){const f=[];for(const m of l.getAllExtensionDescriptions())if(m.contributes){const b=m.contributes.debuggers;if(b&&b.length>0)for(const A of b)(0,v.isDebuggerMainContribution)(A)&&f.push(A.type)}this._debugServiceProxy.$registerDebugTypes(f)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const l=[];return this._breakpoints.forEach(f=>l.push(f)),l}addBreakpoints(l){this.startBreakpoints();const f=l.filter(A=>{const L=A.id;return this._breakpoints.has(L)?!1:(this._breakpoints.set(L,A),!0)});this.fireBreakpointChanges(f,[],[]);const m=[],b=new Map;for(const A of f)if(A instanceof k.SourceBreakpoint){let L=b.get(A.location.uri.toString());L||(L={type:"sourceMulti",uri:A.location.uri,lines:[]},b.set(A.location.uri.toString(),L),m.push(L)),L.lines.push({id:A.id,enabled:A.enabled,condition:A.condition,hitCondition:A.hitCondition,logMessage:A.logMessage,line:A.location.range.start.line,character:A.location.range.start.character})}else A instanceof k.FunctionBreakpoint&&m.push({type:"function",id:A.id,enabled:A.enabled,hitCondition:A.hitCondition,logMessage:A.logMessage,condition:A.condition,functionName:A.functionName});return this._debugServiceProxy.$registerBreakpoints(m)}removeBreakpoints(l){this.startBreakpoints();const f=l.filter(L=>this._breakpoints.delete(L.id));this.fireBreakpointChanges([],f,[]);const m=f.filter(L=>L instanceof k.SourceBreakpoint).map(L=>L.id),b=f.filter(L=>L instanceof k.FunctionBreakpoint).map(L=>L.id),A=f.filter(L=>L instanceof k.DataBreakpoint).map(L=>L.id);return this._debugServiceProxy.$unregisterBreakpoints(m,b,A)}startDebugging(l,f,m){return this._debugServiceProxy.$startDebugging(l?l.uri:void 0,f,{parentSessionID:m.parentSession?m.parentSession.id:void 0,lifecycleManagedByParent:m.lifecycleManagedByParent,repl:m.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:m.noDebug,compact:m.compact,debugUI:m.debugUI,suppressSaveBeforeStart:m.suppressSaveBeforeStart})}stopDebugging(l){return this._debugServiceProxy.$stopDebugging(l?l.id:void 0)}registerDebugConfigurationProvider(l,f,m){if(!f)return new k.Disposable(()=>{});const b=this._configProviderHandleCounter++;return this._configProviders.push({type:l,handle:b,provider:f}),this._debugServiceProxy.$registerDebugConfigurationProvider(l,m,!!f.provideDebugConfigurations,!!f.resolveDebugConfiguration,!!f.resolveDebugConfigurationWithSubstitutedVariables,b),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(A=>A.provider!==f),this._debugServiceProxy.$unregisterDebugConfigurationProvider(b)})}registerDebugAdapterDescriptorFactory(l,f,m){if(!m)return new k.Disposable(()=>{});if(!this.definesDebugType(l,f))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${f}' debugger.`);if(this.getAdapterDescriptorFactoryByType(f))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const b=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:f,handle:b,factory:m}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(f,b),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(A=>A.factory!==m),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(b)})}registerDebugAdapterTrackerFactory(l,f){if(!f)return new k.Disposable(()=>{});const m=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:l,handle:m,factory:f}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(b=>b.factory!==f)})}async $runInTerminal(l,f){return Promise.resolve(void 0)}async $substituteVariables(l,f){if(!this._variableResolver){const[A,L]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(A||[],this._editorsService,L)}let m;const b=await this.getFolder(l);return b&&(m={uri:b.uri,name:b.name,index:b.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(m,f)}createDebugAdapter(l,f){if(l.type==="implementation")return new i(l.implementation)}createSignService(){}async $startDASession(l,f){const m=this,b=await this.getSession(f);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(b.type),b).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}' (extension might have failed to activate)`);const L=this.convertToDto(A),N=this.createDebugAdapter(L,b);if(!N)throw new Error(`Couldn't create a debug adapter for type '${b.type}'.`);const g=N;return this._debugAdapters.set(l,g),this.getDebugAdapterTrackers(b).then(M=>(M&&this._debugAdaptersTrackers.set(l,M),g.onMessage(async U=>{if(U.type==="request"&&U.command==="handshake"){const j=U,K={type:"response",seq:0,command:j.command,request_seq:j.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const B=await this._signService.sign(j.arguments.value);K.body={signature:B},g.sendResponse(K)}else throw new Error("no signer")}catch(B){K.success=!1,K.message=B.message,g.sendResponse(K)}}else M&&M.onDidSendMessage&&M.onDidSendMessage(U),U=(0,v.convertToVSCPaths)(U,!0),m._debugServiceProxy.$acceptDAMessage(l,U)}),g.onError(U=>{M&&M.onError&&M.onError(U),this._debugServiceProxy.$acceptDAError(l,U.name,U.message,U.stack)}),g.onExit(U=>{M&&M.onExit&&M.onExit((0,R.withNullAsUndefined)(U),void 0),this._debugServiceProxy.$acceptDAExit(l,(0,R.withNullAsUndefined)(U),void 0)}),M&&M.onWillStartSession&&M.onWillStartSession(),g.startSession()))})}$sendDAMessage(l,f){f=(0,v.convertToDAPaths)(f,!1);const m=this._debugAdaptersTrackers.get(l);m&&m.onWillReceiveMessage&&m.onWillReceiveMessage(f);const b=this._debugAdapters.get(l);b&&b.sendMessage(f)}$stopDASession(l){const f=this._debugAdaptersTrackers.get(l);this._debugAdaptersTrackers.delete(l),f&&f.onWillStopSession&&f.onWillStopSession();const m=this._debugAdapters.get(l);return this._debugAdapters.delete(l),m?m.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(l){const f=[],m=[],b=[];if(l.added)for(const A of l.added){const L=A.id;if(L&&!this._breakpoints.has(L)){let N;if(A.type==="function")N=new k.FunctionBreakpoint(A.functionName,A.enabled,A.condition,A.hitCondition,A.logMessage);else if(A.type==="data")N=new k.DataBreakpoint(A.label,A.dataId,A.canPersist,A.enabled,A.hitCondition,A.condition,A.logMessage);else{const g=t.URI.revive(A.uri);N=new k.SourceBreakpoint(new k.Location(g,new k.Position(A.line,A.character)),A.enabled,A.condition,A.hitCondition,A.logMessage)}N._id=L,this._breakpoints.set(L,N),f.push(N)}}if(l.removed)for(const A of l.removed){const L=this._breakpoints.get(A);L&&(this._breakpoints.delete(A),m.push(L))}if(l.changed){for(const A of l.changed)if(A.id){const L=this._breakpoints.get(A.id);if(L){if(L instanceof k.FunctionBreakpoint&&A.type==="function"){const N=L;N.enabled=A.enabled,N.condition=A.condition,N.hitCondition=A.hitCondition,N.logMessage=A.logMessage,N.functionName=A.functionName}else if(L instanceof k.SourceBreakpoint&&A.type==="source"){const N=L;N.enabled=A.enabled,N.condition=A.condition,N.hitCondition=A.hitCondition,N.logMessage=A.logMessage,N.location=new k.Location(t.URI.revive(A.uri),new k.Position(A.line,A.character))}b.push(L)}}}this.fireBreakpointChanges(f,m,b)}$provideDebugConfigurations(l,f,m){return(0,C.asPromise)(async()=>{const b=this.getConfigProviderByHandle(l);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const A=await this.getFolder(f);return b.provideDebugConfigurations(A,m)}).then(b=>{if(!b)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return b})}$resolveDebugConfiguration(l,f,m,b){return(0,C.asPromise)(async()=>{const A=this.getConfigProviderByHandle(l);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const L=await this.getFolder(f);return A.resolveDebugConfiguration(L,m,b)})}$resolveDebugConfigurationWithSubstitutedVariables(l,f,m,b){return(0,C.asPromise)(async()=>{const A=this.getConfigProviderByHandle(l);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const L=await this.getFolder(f);return A.resolveDebugConfigurationWithSubstitutedVariables(L,m,b)})}async $provideDebugAdapter(l,f){const m=this.getAdapterDescriptorFactoryByHandle(l);if(!m)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const b=await this.getSession(f);return this.getAdapterDescriptor(m,b).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}'`);return this.convertToDto(A)})}async $acceptDebugSessionStarted(l){const f=await this.getSession(l);this._onDidStartDebugSession.fire(f)}async $acceptDebugSessionTerminated(l){const f=await this.getSession(l);f&&(this._onDidTerminateDebugSession.fire(f),this._debugSessions.delete(f.id))}async $acceptDebugSessionActiveChanged(l){this._activeDebugSession=l?await this.getSession(l):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(l,f){const m=await this.getSession(l);m&&m._acceptNameChanged(f)}async $acceptDebugSessionCustomEvent(l,f){const b={session:await this.getSession(l),event:f.event,body:f.body};this._onDidReceiveDebugSessionCustomEvent.fire(b)}convertToDto(l){if(l instanceof k.DebugAdapterExecutable)return{type:"executable",command:l.command,args:l.args,options:l.options};if(l instanceof k.DebugAdapterServer)return{type:"server",port:l.port,host:l.host};if(l instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:l.path};if(l instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:l.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(l){const f=this._adapterFactories.filter(m=>m.type===l);if(f.length>0)return f[0].factory}getAdapterDescriptorFactoryByHandle(l){const f=this._adapterFactories.filter(m=>m.handle===l);if(f.length>0)return f[0].factory}getConfigProviderByHandle(l){const f=this._configProviders.filter(m=>m.handle===l);if(f.length>0)return f[0].provider}definesDebugType(l,f){if(l.contributes){const m=l.contributes.debuggers;if(m&&m.length>0){for(const b of m)if(b.label&&b.type&&b.type===f)return!0}}return!1}getDebugAdapterTrackers(l){const m=l.configuration.type,b=this._trackerFactories.filter(A=>A.type===m||A.type==="*").map(A=>(0,C.asPromise)(()=>A.factory.createDebugAdapterTracker(l)).then(L=>L,L=>null));return Promise.race([Promise.all(b).then(A=>{const L=A.filter(N=>!!N);if(L.length>0)return new a(L)}),new Promise((A,L)=>{const N=setTimeout(()=>{clearTimeout(N),L(new Error("timeout"))},1e3)})]).catch(A=>{})}async getAdapterDescriptor(l,f){const m=f.configuration.debugServer;if(typeof m=="number")return Promise.resolve(new k.DebugAdapterServer(m));if(l){const A=await this._extensionService.getExtensionRegistry();return(0,C.asPromise)(()=>l.createDebugAdapterDescriptor(f,this.daExecutableFromPackage(f,A))).then(L=>{if(L)return L})}const b=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(f,b))}daExecutableFromPackage(l,f){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(l,f,m){(l.length>0||f.length>0||m.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:l,removed:f,changed:m}))}async getSession(l){if(l)if(typeof l=="string"){const f=this._debugSessions.get(l);if(f)return f}else{let f=this._debugSessions.get(l.id);if(!f){const m=await this.getFolder(l.folderUri),b=l.parent?this._debugSessions.get(l.parent):void 0;f=new u(this._debugServiceProxy,l.id,l.type,l.name,m,l.configuration,b),this._debugSessions.set(f.id,f),this._debugServiceProxy.$sessionCached(f.id)}return f}throw new Error("cannot find session")}getFolder(l){if(l){const f=t.URI.revive(l);return this._workspaceService.resolveWorkspaceFolder(f)}return Promise.resolve(void 0)}};s=Be([Me(0,w.IExtHostRpcService),Me(1,P.IExtHostWorkspace),Me(2,F.IExtHostExtensionService),Me(3,y.IExtHostDocumentsAndEditors),Me(4,E.IExtHostConfiguration),Me(5,h.IExtHostEditorTabs)],s),e.ExtHostDebugServiceBase=s;class u{constructor(l,f,m,b,A,L,N){this._debugServiceProxy=l,this._id=f,this._type=m,this._name=b,this._workspaceFolder=A,this._configuration=L,this._parentSession=N}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(l){this._name=l,this._debugServiceProxy.$setDebugSessionName(this._id,l)}get parentSession(){return this._parentSession}_acceptNameChanged(l){this._name=l}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(l,f){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,l,f)}getDebugProtocolBreakpoint(l){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,l.id)}}e.ExtHostDebugSession=u;class r{constructor(l){this.value=Object.freeze({append(f){l.$appendDebugConsole(f)},appendLine(f){this.append(f+`
`)}})}}e.ExtHostDebugConsole=r;class S extends c.AbstractVariableResolverService{constructor(l,f,m,b,A){function L(){if(f){const N=f.activeEditor();if(N)return N.document.uri;const g=b.tabs.filter(M=>M.isActive);if(g.length>0){const M=g[0].resource;return M&&(M.primary||M.secondary)?M.primary??M.secondary:g[0].resource}}}super({getFolderUri:N=>{const g=l.filter(M=>M.name===N);if(g&&g.length>0)return g[0].uri},getWorkspaceFolderCount:()=>l.length,getConfigurationValue:(N,g)=>m.getConfiguration(void 0,N).get(g),getAppRoot:()=>p.cwd(),getExecPath:()=>p.env.VSCODE_EXEC_PATH,getFilePath:()=>{const N=L();if(N)return d.normalize(N.fsPath)},getWorkspaceFolderPathForFile:()=>{if(A){const N=L();if(N){const g=A.getWorkspaceFolder(N);if(g)return d.normalize(g.uri.fsPath)}}},getSelectedText:()=>{if(f){const N=f.activeEditor();if(N&&!N.selection.isEmpty)return N.document.getText(N.selection)}},getLineNumber:()=>{if(f){const N=f.activeEditor();if(N)return String(N.selection.end.line+1)}}},void 0,Promise.resolve(p.env))}}e.ExtHostVariableResolverService=S;class a{constructor(l){this.trackers=l}onWillStartSession(){this.trackers.forEach(l=>l.onWillStartSession?l.onWillStartSession():void 0)}onWillReceiveMessage(l){this.trackers.forEach(f=>f.onWillReceiveMessage?f.onWillReceiveMessage(l):void 0)}onDidSendMessage(l){this.trackers.forEach(f=>f.onDidSendMessage?f.onDidSendMessage(l):void 0)}onWillStopSession(){this.trackers.forEach(l=>l.onWillStopSession?l.onWillStopSession():void 0)}onError(l){this.trackers.forEach(f=>f.onError?f.onError(l):void 0)}onExit(l,f){this.trackers.forEach(m=>m.onExit?m.onExit(l,f):void 0)}}class i extends D.AbstractDebugAdapter{constructor(l){super();this.implementation=l,l.onDidSendMessage(f=>{this.acceptMessage(f)})}startSession(){return Promise.resolve(void 0)}sendMessage(l){this.implementation.handleMessage(l)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let n=class extends s{constructor(l,f,m,b,A,L){super(l,f,m,b,A,L)}createVariableResolver(l,f,m){return new S(l,f,m,this._editorTabs)}};n=Be([Me(0,w.IExtHostRpcService),Me(1,P.IExtHostWorkspace),Me(2,F.IExtHostExtensionService),Me(3,y.IExtHostDocumentsAndEditors),Me(4,E.IExtHostConfiguration),Me(5,h.IExtHostEditorTabs)],n),e.WorkerExtHostDebugService=n}),define(pe[271],ve([0,1,71,2,5,36,30,27,14,26,4,40,37,12,8]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let w=class{constructor(u,r,S,a,i,n,o){this._apiFactory=u,this._extensionRegistry=r,this._instaService=S,this._extHostConfiguration=a,this._extHostExtensionService=i,this._initData=n,this._logService=o,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),d.mark("code/extHost/willWaitForConfig");const u=await this._extHostConfiguration.getConfigProvider();d.mark("code/extHost/didWaitForConfig");const r=await this._extHostExtensionService.getExtensionPathIndex();this.register(new R(this._apiFactory,r,this._extensionRegistry,u,this._logService)),this.register(this._instaService.createInstance(p,r)),this.register(this._instaService.createInstance(_)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(h,r,this._initData.environment.appUriScheme))}register(u){if("nodeModuleName"in u)if(Array.isArray(u.nodeModuleName))for(let r of u.nodeModuleName)this._factories.set(r,u);else this._factories.set(u.nodeModuleName,u);typeof u.alternativeModuleName=="function"&&this._alternatives.push(r=>u.alternativeModuleName(r))}};w=Be([Me(2,F.IInstantiationService),Me(3,C.IExtHostConfiguration),Me(4,y.IExtHostExtensionService),Me(5,P.IExtHostInitDataService),Me(6,E.ILogService)],w),e.RequireInterceptor=w;let _=class zi{constructor(u){if(u.environment.appRoot&&zi.aliased.size){const r=(0,v.escapeRegExpCharacters)(this.forceForwardSlashes(u.environment.appRoot.fsPath)),S="[a-z0-9_.-]",a=`@${S}+\\/${S}+|${S}+`,i="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${r}/${i}\\/)(${a})(.*)$`,"i")}}alternativeModuleName(u){if(!this.re)return;const r=this.re.exec(this.forceForwardSlashes(u));if(!r)return;const[,S,a,i]=r,n=zi.aliased.get(a);if(n!==void 0)return console.warn(`${a} as been renamed to ${n}, please update your imports`),S+n+i}forceForwardSlashes(u){return u.replace(/\\/g,"/")}};_.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),_=Be([Me(0,P.IExtHostInitDataService)],_);class R{constructor(u,r,S,a,i){this._apiFactory=u,this._extensionPaths=r,this._extensionRegistry=S,this._configProvider=a,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(u,r){const S=this._extensionPaths.findSubstr(r);if(S){let a=this._extApiImpl.get(k.ExtensionIdentifier.toKey(S.identifier));return a||(a=this._apiFactory(S,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(S.identifier),a)),a}if(!this._defaultApiImpl){let a="";this._extensionPaths.forEach((i,n)=>a+=`	${n} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${r}. These are the extension path mappings: 
${a}`),this._defaultApiImpl=this._apiFactory(T.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let p=class{constructor(u,r,S){this._extensionPaths=u,this.nodeModuleName="keytar",this._mainThreadTelemetry=r.getProxy(I.MainContext.MainThreadTelemetry);const{environment:a}=S,i=r.getProxy(I.MainContext.MainThreadKeytar);if(a.appRoot){let n=a.appRoot.fsPath;c.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,o)=>i.$getPassword(n,o),setPassword:(n,o,l)=>i.$setPassword(n,o,l),deletePassword:(n,o)=>i.$deletePassword(n,o),findPassword:n=>i.$findPassword(n),findCredentials(n){return i.$findCredentials(n)}}}load(u,r){const S=this._extensionPaths.findSubstr(r);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:S?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(u){const r=u.length;if(r<=7||!this.alternativeNames)return;const S=r-7;if((u.charAt(S)==="/"||u.charAt(S)==="\\")&&u.endsWith("keytar")&&(u=u.replace(/\\/g,"/"),this.alternativeNames.has(u)))return"keytar"}};p=Be([Me(1,D.IExtHostRpcService),Me(2,P.IExtHostInitDataService)],p);let h=class{constructor(u,r,S){this._extensionPaths=u,this._appUriScheme=r,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=S.getProxy(I.MainContext.MainThreadTelemetry);const a=S.getProxy(I.MainContext.MainThreadWindow);this._impl=(i,n)=>{const o=t.URI.parse(i);return n?this.callOriginal(i,n):o.scheme==="http"||o.scheme==="https"?a.$openUri(o,i,{allowTunneling:!0}):o.scheme==="mailto"||o.scheme===this._appUriScheme?a.$openUri(o,i,{}):this.callOriginal(i,n)}}load(u,r,S){const a=this._extensionPaths.findSubstr(r);return a&&(this._extensionId=a.identifier.value,this.sendShimmingTelemetry()),this._original=S(u),this._impl}callOriginal(u,r){return this.sendNoForwardTelemetry(),this._original(u,r)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};h=Be([Me(2,D.IExtHostRpcService)],h)}),define(pe[272],ve([0,1,174,11,7,212,35,40,45,36,34,14,54,197,13,213,53]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c,E,v,w,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let R=class extends c.ExtHostDebugServiceBase{constructor(s,u,r,S,a,i,n){super(s,u,r,S,a,n);this._terminalService=i,this._integratedTerminalInstances=new p}createDebugAdapter(s,u){switch(s.type){case"server":return new C.SocketDebugAdapter(s);case"pipeServer":return new C.NamedPipeDebugAdapter(s);case"executable":return new C.ExecutableDebugAdapter(s,u.type)}return super.createDebugAdapter(s,u)}daExecutableFromPackage(s,u){const r=C.ExecutableDebugAdapter.platformAdapterExecutable(u.getAllExtensionDescriptions(),s.type);if(r)return new I.DebugAdapterExecutable(r.command,r.args,r.options)}createSignService(){return new E.SignService}async $runInTerminal(s,u){if(s.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(L=>{this._integratedTerminalInstances.onTerminalClosed(L)}));const r=await this._configurationService.getConfigProvider(),S=this._terminalService.getDefaultShell(!0),a=this._terminalService.getDefaultShellArgs(!0),i=s.title||d.localize(0,null),n=JSON.stringify({shell:S,shellArgs:a});let o=await this._integratedTerminalInstances.checkout(n,i),l,f=!1;if(o)l=s.cwd;else{const L={shellPath:S,shellArgs:a,cwd:s.cwd,name:i,iconPath:new I.ThemeIcon("debug")};f=!0,o=this._terminalService.createTerminalFromOptions(L,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(o,n)}o.show(!0);const m=await o.processId;f?await new Promise(L=>setTimeout(L,1e3)):r.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(S.indexOf("powershell")>=0||S.indexOf("pwsh")>=0||S.indexOf("cmd.exe")>=0?o.sendText("cls"):S.indexOf("bash")>=0?o.sendText("clear"):t.isWindows?o.sendText("cls"):o.sendText("clear"));const b=(0,w.prepareCommand)(S,s.args,l,s.env);o.sendText(b);const A=this.onDidTerminateDebugSession(L=>{L.id===u&&(this._integratedTerminalInstances.free(o),A.dispose())});return m}else if(s.kind==="external")return(0,w.runInExternalTerminal)(s,await this._configurationService.getConfigProvider());return super.$runInTerminal(s,u)}createVariableResolver(s,u,r){return new c.ExtHostVariableResolverService(s,u,r,this._editorTabs,this._workspaceService)}};R=Be([Me(0,y.IExtHostRpcService),Me(1,T.IExtHostWorkspace),Me(2,k.IExtHostExtensionService),Me(3,D.IExtHostDocumentsAndEditors),Me(4,P.IExtHostConfiguration),Me(5,F.IExtHostTerminalService),Me(6,_.IExtHostEditorTabs)],R),e.ExtHostDebugService=R;class p{constructor(){this._terminalInstances=new Map}async checkout(s,u){const S=[...this._terminalInstances.entries()].map(([a,i])=>(0,v.createCancelablePromise)(async n=>{if(a.name!==u||i.lastUsedAt!==-1&&await(0,w.hasChildProcesses)(await a.processId))return null;const o=Date.now();return i.lastUsedAt+p.minUseDelay>o||n.isCancellationRequested||i.config!==s?null:(i.lastUsedAt=o,a)}));return await(0,v.firstParallel)(S,a=>!!a)}insert(s,u){this._terminalInstances.set(s,{lastUsedAt:Date.now(),config:u})}free(s){const u=this._terminalInstances.get(s);u&&(u.lastUsedAt=-1)}onTerminalClosed(s){this._terminalInstances.delete(s)}}p.minUseDelay=1e3}),define(pe[273],ve([0,1,9,2,113,35,54,45,36,43,34,14,26,70,10,12,65,53,22,61]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c,E,v,w,_,R,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let s=class extends E.ExtHostTaskBase{constructor(r,S,a,i,n,o,l,f,m){super(r,S,a,i,n,o,l,f);this.workspaceService=a,this.editorTabs=m,S.remote.isRemote&&S.remote.authority?this.registerTaskSystem(v.Schemas.vscodeRemote,{scheme:v.Schemas.vscodeRemote,authority:S.remote.authority,platform:process.platform}):this.registerTaskSystem(v.Schemas.file,{scheme:v.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(r,S){const a=S;if(!S.execution&&a._id===void 0)throw new Error("Tasks to execute must include an execution");if(a._id!==void 0){const i=E.TaskHandleDTO.from(a,this.workspaceService),n=await this._proxy.$getTaskExecution(i);if(n.task===void 0)throw new Error("Task from execution DTO is undefined");const o=await this.getTaskExecution(n,S);return this._proxy.$executeTask(i).catch(()=>{}),o}else{const i=E.TaskDTO.from(S,r);if(i===void 0)return Promise.reject(new Error("Task is not valid"));E.CustomExecutionDTO.is(i.execution)&&await this.addCustomExecution(i,S,!1);const n=await this.getTaskExecution(await this._proxy.$getTaskExecution(i),S);return this._proxy.$executeTask(i).catch(()=>{}),n}}provideTasksInternal(r,S,a,i){const n=[];if(i)for(let o of i){this.checkDeprecation(o,a),(!o.definition||!r[o.definition.type])&&this._logService.warn(`The task [${o.source}, ${o.name}] uses an undefined task type. The task will be ignored in the future.`);const l=E.TaskDTO.from(o,a.extension);l&&(n.push(l),E.CustomExecutionDTO.is(l.execution)&&S.push(this.addCustomExecution(l,o,!0)))}return{tasks:n,extension:a.extension}}async resolveTaskInternal(r){return r}async getVariableResolver(r){if(this._variableResolver===void 0){const S=await this._configurationService.getConfigProvider();this._variableResolver=new T.ExtHostVariableResolverService(r,this._editorService,S,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(r){let S=r&&r.length>0?r[0]:void 0;if(!S){const a=t.URI.file((0,h.homedir)());S=new P.WorkspaceFolder({uri:a,name:p.basename(a),index:0})}return{uri:S.uri,name:S.name,index:S.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(r,S){const a=t.URI.revive(r),i={process:void 0,variables:Object.create(null)},n=await this._workspaceProvider.resolveWorkspaceFolder(a),o=await this._workspaceProvider.getWorkspaceFolders2()??[],l=await this.getVariableResolver(o),f=n?{uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(o);for(let m of S.variables)i.variables[m]=await l.resolveAsync(f,m);if(S.process!==void 0){let m;if(S.process.path!==void 0){m=S.process.path.split(d.delimiter);for(let b=0;b<m.length;b++)m[b]=await l.resolveAsync(f,m[b])}i.process=await I.win32.findExecutable(await l.resolveAsync(f,S.process.name),S.process.cwd!==void 0?await l.resolveAsync(f,S.process.cwd):void 0,m)}return i}async $jsonTasksSupported(){return!0}async $findExecutable(r,S,a){return I.win32.findExecutable(r,S,a)}};s=Be([Me(0,y.IExtHostRpcService),Me(1,c.IExtHostInitDataService),Me(2,C.IExtHostWorkspace),Me(3,k.IExtHostDocumentsAndEditors),Me(4,D.IExtHostConfiguration),Me(5,F.IExtHostTerminalService),Me(6,w.ILogService),Me(7,_.IExtHostApiDeprecationService),Me(8,R.IExtHostEditorTabs)],s),e.ExtHostTask=s}),define(pe[274],ve([0,1,13,16,71,6,2,5,266,12,62,84,26,189,14,64,40,34]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c,E,v,w,_,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class p{constructor(s,u,r,S,a){this._disposables=new C.DisposableStore,this._isTerminating=!1,this._hostUtils=r,this._rpcProtocol=new D.RPCProtocol(s,null,S),u=p._transform(u,this._rpcProtocol);const i=new y.ServiceCollection(...(0,F.getSingletonServiceDescriptors)());i.set(c.IExtHostInitDataService,{_serviceBrand:void 0,...u,messagePorts:a}),i.set(v.IExtHostRpcService,new v.ExtHostRpcService(this._rpcProtocol)),i.set(w.IURITransformerService,new w.URITransformerService(S)),i.set(_.IHostUtils,r);const n=new E.InstantiationService(i,!0);this._disposables.add(n.invokeFunction(m=>m.get(R.IExtHostTerminalService))),this._disposables.add(n.invokeFunction(m=>m.get(_.IExtHostExtensionService))),this._logService=n.invokeFunction(m=>m.get(P.ILogService)),I.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",u),this._extensionService=n.invokeFunction(m=>m.get(_.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const o=new WeakMap;this._extensionService.getExtensionPathIndex().then(m=>{Error.prepareStackTrace=(b,A)=>{let L="",N,g;for(const M of A)L+=`
	at ${M.toString()}`,g=M.getFileName(),!N&&g&&(N=m.findSubstr(T.URI.file(g)));return o.set(b,N),`${b.name||"Error"}: ${b.message||""}${L}`}});const l=this._rpcProtocol.getProxy(k.MainContext.MainThreadExtensionService),f=this._rpcProtocol.getProxy(k.MainContext.MainThreadErrors);t.setUnexpectedErrorHandler(m=>{const b=t.transformErrorForSerialization(m),A=o.get(m);A?l.$onExtensionRuntimeError(A.identifier,b):f.$onUnexpectedError(b)})}terminate(s){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${s}`),this._logService.flush(),this._disposables.dispose(),t.setUnexpectedErrorHandler(r=>{this._logService.error(r)}),this._rpcProtocol.dispose();const u=this._extensionService.deactivateAll();Promise.race([(0,d.timeout)(5e3),u]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(s,u){s.extensions.forEach(S=>S.extensionLocation=T.URI.revive(u.transformIncomingURIs(S.extensionLocation))),s.environment.appRoot=T.URI.revive(u.transformIncomingURIs(s.environment.appRoot));const r=s.environment.extensionDevelopmentLocationURI;return r&&(s.environment.extensionDevelopmentLocationURI=r.map(S=>T.URI.revive(u.transformIncomingURIs(S)))),s.environment.extensionTestsLocationURI=T.URI.revive(u.transformIncomingURIs(s.environment.extensionTestsLocationURI)),s.environment.globalStorageHome=T.URI.revive(u.transformIncomingURIs(s.environment.globalStorageHome)),s.environment.workspaceStorageHome=T.URI.revive(u.transformIncomingURIs(s.environment.workspaceStorageHome)),s.logsLocation=T.URI.revive(u.transformIncomingURIs(s.logsLocation)),s.logFile=T.URI.revive(u.transformIncomingURIs(s.logFile)),s.workspace=u.transformIncomingURIs(s.workspace),s}}e.ExtensionHostMain=p}),define(pe[275],ve([0,1,9,21,49,32,22,46,31]),function(ee,e,d,t,I,C,T,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(c,E,v){this.config=c,this.provider=E,this.sessionToken=v,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=c.filePattern,this.includePattern=c.includePattern&&C.parse(c.includePattern),this.maxResults=c.maxResults||void 0,this.exists=c.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=c.excludePattern&&C.parse(c.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(c=>c.cancel()),this.activeCancellationTokens=new Set}search(c){const E=this.config.folderQueries||[];return new Promise((v,w)=>{const _=R=>{this.resultCount++,c(R)};if(this.isCanceled)return v({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(R=>{const p=R.toString(),h=d.basename(p);this.globalExcludePattern&&this.globalExcludePattern(p,h)||this.matchFile(_,{base:R,basename:h})}),Promise.all(E.map(R=>this.searchInFolder(R,_))).then(R=>{v({limitHit:this.isLimitHit,stats:R[0]||void 0})},R=>{w(new Error((0,I.toErrorMessage)(R)))})})}async searchInFolder(c,E){const v=new t.CancellationTokenSource,w=this.getSearchOptionsForFolder(c),_=this.initDirectoryTree(),R=new D.QueryGlobTester(this.config,c),p=!R.hasSiblingExcludeClauses();let h;try{this.activeCancellationTokens.add(v),h=k.StopWatch.create();const s=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},w,v.token),u=h.elapsed(),r=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(s&&s.forEach(S=>{const a=d.posix.relative(c.folder.path,S.path);if(p){const i=d.basename(S.path);this.matchFile(E,{base:c.folder,relativePath:a,basename:i});return}this.addDirectoryEntries(_,c.folder,a,E)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(_,R,E),{providerTime:u,postProcessTime:r.elapsed()})}finally{v.dispose(),this.activeCancellationTokens.delete(v)}}getSearchOptionsForFolder(c){const E=(0,D.resolvePatternsForProvider)(this.config.includePattern,c.includePattern),v=(0,D.resolvePatternsForProvider)(this.config.excludePattern,c.excludePattern);return{folder:c.folder,excludes:v,includes:E,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}addDirectoryEntries({pathToEntries:c},E,v,w){if(v===this.filePattern){const R=d.basename(this.filePattern);this.matchFile(w,{base:E,relativePath:this.filePattern,basename:R})}function _(R){const p=d.basename(R),h=d.dirname(R);let s=c[h];s||(s=c[h]=[],_(h)),s.push({base:E,relativePath:R,basename:p})}_(v)}matchDirectoryTree({rootEntries:c,pathToEntries:E},v,w){const _=this,R=this.filePattern;function p(h){const s=C.hasSiblingFn(()=>h.map(u=>u.basename));for(let u=0,r=h.length;u<r;u++){const S=h[u],{relativePath:a,basename:i}=S;if(v.matchesExcludesSync(a,i,R!==i?s:void 0))continue;const n=E[a];if(n)p(n);else{if(a===R)continue;_.matchFile(w,S)}if(_.isLimitHit)break}}p(c)}matchFile(c,E){(!this.includePattern||E.relativePath&&this.includePattern(E.relativePath,E.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||c(E))}}class F{constructor(){this.sessions=new Map}fileSearch(c,E,v,w){const _=this.getSessionTokenSource(c.cacheKey),R=new P(c,E,_&&_.token);let p=0;const h=s=>{p+=s.length,v(s.map(u=>this.rawMatchToSearchItem(u)))};return this.doSearch(R,F.BATCH_SIZE,h,w).then(s=>({limitHit:s.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:p,detailStats:s.stats}}))}clearCache(c){const E=this.getSessionTokenSource(c);E&&E.cancel()}getSessionTokenSource(c){if(!!c)return this.sessions.has(c)||this.sessions.set(c,new t.CancellationTokenSource),this.sessions.get(c)}rawMatchToSearchItem(c){return c.relativePath?{resource:T.joinPath(c.base,c.relativePath)}:{resource:c.base}}doSearch(c,E,v,w){w.onCancellationRequested(()=>{c.cancel()});const _=p=>{p&&(R.push(p),E>0&&R.length>=E&&(v(R),R=[]))};let R=[];return c.search(_).then(p=>(R.length&&v(R),p),p=>(R.length&&v(R),Promise.reject(p)))}}e.FileSearchManager=F,F.BATCH_SIZE=512}),define(pe[136],ve([0,1,17,13,21,49,32,10,9,22,18,2,31]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class E{constructor(s,u,r,S){this.query=s,this.provider=u,this.fileUtils=r,this.processType=S,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(s,u){const r=this.query.folderQueries||[],S=new I.CancellationTokenSource;return u.onCancellationRequested(()=>S.cancel()),new Promise((a,i)=>{this.collector=new w(s);let n=!1;const o=(l,f)=>{if(!n&&!this.isLimitHit){const m=this.resultSize(l);R(l)&&typeof this.query.maxResults=="number"&&this.resultCount+m>this.query.maxResults&&(this.isLimitHit=!0,n=!0,S.cancel(),l=this.trimResultToSize(l,this.query.maxResults-this.resultCount));const b=this.resultSize(l);this.resultCount+=b,(b>0||!R(l))&&this.collector.add(l,f)}};Promise.all(r.map((l,f)=>this.searchInFolder(l,m=>o(m,f),S.token))).then(l=>{S.dispose(),this.collector.flush();const f=l.some(m=>!!m&&!!m.limitHit);a({limitHit:this.isLimitHit||f,messages:(0,d.flatten)(l.map(m=>m?.message?(0,F.isArray)(m.message)?m.message:[m.message]:[])),stats:{type:this.processType}})},l=>{S.dispose();const f=(0,C.toErrorMessage)(l);i(new Error(f))})})}resultSize(s){return R(s)?Array.isArray(s.ranges)?s.ranges.length:1:0}trimResultToSize(s,u){const r=Array.isArray(s.ranges)?s.ranges:[s.ranges],S=Array.isArray(s.preview.matches)?s.preview.matches:[s.preview.matches];return{ranges:r.slice(0,u),preview:{matches:S.slice(0,u),text:s.preview.text},uri:s.uri}}async searchInFolder(s,u,r){const S=new c.QueryGlobTester(this.query,s),a=[],i={report:l=>{if(!this.validateProviderResult(l))return;const f=s.folder.scheme===k.Schemas.file?T.hasSiblingPromiseFn(()=>this.fileUtils.readdir(P.dirname(l.uri))):void 0,m=P.relativePath(s.folder,l.uri);if(m){const b=S.includedInQuery(m,D.basename(m),f);(0,t.isThenable)(b)?a.push(b.then(A=>{A&&u(l)})):b&&u(l)}}},n=this.getSearchOptionsForFolder(s),o=await this.provider.provideTextSearchResults(v(this.query.contentPattern),n,i,r);return a.length&&await Promise.all(a),o}validateProviderResult(s){if(R(s)){if(Array.isArray(s.ranges)){if(!Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(s.preview.matches.length!==s.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(s){const u=(0,c.resolvePatternsForProvider)(this.query.includePattern,s.includePattern),r=(0,c.resolvePatternsForProvider)(this.query.excludePattern,s.excludePattern),S={folder:y.URI.from(s.folder),excludes:r,includes:u,useIgnoreFiles:!s.disregardIgnoreFiles,useGlobalIgnoreFiles:!s.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!s.disregardParentIgnoreFiles,followSymlinks:!s.ignoreSymlinks,encoding:s.fileEncoding&&this.fileUtils.toCanonicalName(s.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return S.usePCRE2=this.query.usePCRE2,S}}e.TextSearchManager=E;function v(h){return{isCaseSensitive:h.isCaseSensitive||!1,isRegExp:h.isRegExp||!1,isWordMatch:h.isWordMatch||!1,isMultiline:h.isMultiline||!1,pattern:h.pattern}}class w{constructor(s){this._onResult=s,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new p(512,u=>this.sendItems(u))}add(s,u){this._currentFileMatch&&(this._currentFolderIdx!==u||!P.isEqual(this._currentUri,s.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=u,this._currentFileMatch={resource:s.uri,results:[]}),this._currentFileMatch.results.push(_(s))}pushToCollector(){const s=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,s)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(s){this._onResult(s)}}e.TextSearchResultsCollector=w;function _(h){return R(h)?{preview:{matches:(0,d.mapArrayOrNot)(h.preview.matches,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character})),text:h.preview.text},ranges:(0,d.mapArrayOrNot)(h.ranges,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character}))}:{text:h.text,lineNumber:h.lineNumber}}function R(h){return!!h.preview}e.extensionResultIsMatch=R;class p{constructor(s,u){this.maxBatchSize=s,this.cb=u,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(s,u){!s||this.addItemToBatch(s,u)}addItems(s,u){!s||this.addItemsToBatch(s,u)}addItemToBatch(s,u){this.batch.push(s),this.batchSize+=u,this.onUpdate()}addItemsToBatch(s,u){this.batch=this.batch.concat(s),this.batchSize+=u,this.onUpdate()}onUpdate(){this.totalNumberCompleted<p.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},p.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=p,p.TIMEOUT=4e3,p.START_BATCH_AFTER_COUNT=50}),define(pe[72],ve([0,1,6,5,4,275,14,64,12,2,136]),function(ee,e,d,t,I,C,T,k,D,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,I.createDecorator)("IExtHostSearch");let y=class{constructor(w,_,R){this.extHostRpc=w,this._uriTransformer=_,this._logService=R,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new C.FileSearchManager}_transformScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}registerTextSearchProvider(w,_){if(this._textSearchUsedSchemes.has(w))throw new Error(`a text search provider for the scheme '${w}' is already registered`);this._textSearchUsedSchemes.add(w);const R=this._handlePool++;return this._textSearchProvider.set(R,_),this._proxy.$registerTextSearchProvider(R,this._transformScheme(w)),(0,d.toDisposable)(()=>{this._textSearchUsedSchemes.delete(w),this._textSearchProvider.delete(R),this._proxy.$unregisterProvider(R)})}registerFileSearchProvider(w,_){if(this._fileSearchUsedSchemes.has(w))throw new Error(`a file search provider for the scheme '${w}' is already registered`);this._fileSearchUsedSchemes.add(w);const R=this._handlePool++;return this._fileSearchProvider.set(R,_),this._proxy.$registerFileSearchProvider(R,this._transformScheme(w)),(0,d.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(w),this._fileSearchProvider.delete(R),this._proxy.$unregisterProvider(R)})}$provideFileSearchResults(w,_,R,p){const h=c(R),s=this._fileSearchProvider.get(w);if(s)return this._fileSearchManager.fileSearch(h,s,u=>{this._proxy.$handleFileMatch(w,_,u.map(r=>r.resource))},p);throw new Error("unknown provider: "+w)}$clearCache(w){return this._fileSearchManager.clearCache(w),Promise.resolve(void 0)}$provideTextSearchResults(w,_,R,p){const h=this._textSearchProvider.get(w);if(!h||!h.provideTextSearchResults)throw new Error(`Unknown provider ${w}`);const s=c(R);return this.createTextSearchManager(s,h).search(r=>this._proxy.$handleTextMatch(w,_,r),p)}$enableExtensionHostSearch(){}createTextSearchManager(w,_){return new F.TextSearchManager(w,_,{readdir:R=>Promise.resolve([]),toCanonicalName:R=>R},"textSearchProvider")}};y=Be([Me(0,T.IExtHostRpcService),Me(1,k.IURITransformerService),Me(2,D.ILogService)],y),e.ExtHostSearch=y;function c(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(E),extraFileResources:v.extraFileResources&&v.extraFileResources.map(w=>P.URI.revive(w))}}e.reviveQuery=c;function E(v){return{...v,folder:P.URI.revive(v.folder)}}}),define(pe[276],ve([0,1,62,134,35,132,36,39,45,34,70,54,72,91,51,65,135,66,44,90,123,53,133,12,228]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c,E,v,w,_,R,p,h,s,u,r,S,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.registerSingleton)(S.ILoggerService,r.ExtHostLoggerService),(0,d.registerSingleton)(S.ILogService,a.ExtHostLogService),(0,d.registerSingleton)(w.IExtHostApiDeprecationService,w.ExtHostApiDeprecationService),(0,d.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,d.registerSingleton)(T.IExtHostConfiguration,T.ExtHostConfiguration),(0,d.registerSingleton)(R.IExtHostConsumerFileSystem,R.ExtHostConsumerFileSystem),(0,d.registerSingleton)(y.IExtHostDebugService,y.WorkerExtHostDebugService),(0,d.registerSingleton)(C.IExtHostDecorations,C.ExtHostDecorations),(0,d.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,d.registerSingleton)(p.IExtHostFileSystemInfo,p.ExtHostFileSystemInfo),(0,d.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService),(0,d.registerSingleton)(c.IExtHostSearch,c.ExtHostSearch),(0,d.registerSingleton)(E.IExtHostStorage,E.ExtHostStorage),(0,d.registerSingleton)(F.IExtHostTask,F.WorkerExtHostTask),(0,d.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,d.registerSingleton)(v.IExtHostTunnelService,v.ExtHostTunnelService),(0,d.registerSingleton)(_.IExtHostWindow,_.ExtHostWindow),(0,d.registerSingleton)(I.IExtHostWorkspace,I.ExtHostWorkspace),(0,d.registerSingleton)(h.IExtHostSecretState,h.ExtHostSecretState),(0,d.registerSingleton)(s.IExtHostTelemetry,s.ExtHostTelemetry),(0,d.registerSingleton)(u.IExtHostEditorTabs,u.ExtHostEditorTabs)}),define(pe[92],ve([0,1,17,12,31,69]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function T(y){return y.startsWith("**")||y.startsWith("/")?y:`/${y}`}e.anchorGlob=T;function k(y,c,E,v){const w=(0,d.mapArrayOrNot)(E,D),_=new I.TextSearchMatch(c,w,v),R=_.preview.matches;return{ranges:(0,d.mapArrayOrNot)(w,P),uri:y,preview:{text:_.preview.text,matches:(0,d.mapArrayOrNot)(R,P)}}}e.createTextSearchResult=k;function D(y){return new I.SearchRange(y.start.line,y.start.character,y.end.line,y.end.character)}function P(y){return new C.Range(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn)}let F=class{constructor(c,E){this.prefix=c,this.logService=E}appendLine(c){this.logService.debug(`${this.prefix}#search`,c)}};F=Be([Me(1,t.ILogService)],F),e.OutputChannel=F}),define(pe[277],ve([0,1,38,9,78,28,11,8,92,278]),function(ee,e,d,t,I,C,T,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const F=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function y(h,s,u,r){const S=c(h,s,u,r),a=s.folder.fsPath;return{cmd:d.spawn(F,S.args,{cwd:a}),rgDiskPath:F,siblingClauses:S.siblingClauses,rgArgs:S,cwd:a}}e.spawnRipgrepCmd=y;function c(h,s,u,r){const S=["--files","--hidden","--case-sensitive"];v([s],u,!1).forEach(i=>{const n=(0,D.anchorGlob)(i);if(S.push("-g",n),T.isMacintosh){const o=(0,I.normalizeNFD)(n);o!==n&&S.push("-g",o)}});const a=E([s],r,void 0,!1);return a.globArgs.forEach(i=>{const n=`!${(0,D.anchorGlob)(i)}`;if(S.push("-g",n),T.isMacintosh){const o=(0,I.normalizeNFD)(n);o!==n&&S.push("-g",o)}}),s.disregardIgnoreFiles!==!1?S.push("--no-ignore"):s.disregardParentIgnoreFiles!==!1&&S.push("--no-ignore-parent"),s.ignoreSymlinks||S.push("--follow"),h.exists&&S.push("--quiet"),S.push("--no-config"),s.disregardGlobalIgnoreFiles&&S.push("--no-ignore-global"),{args:S,siblingClauses:a.siblingClauses}}function E(h,s,u,r=!0){const S=[];let a={};return h.forEach(i=>{const n=Object.assign({},i.excludePattern||{},s||{}),o=w(n,r?i.folder.fsPath:void 0,u);S.push(...o.globArgs),o.siblingClauses&&(a=Object.assign(a,o.siblingClauses))}),{globArgs:S,siblingClauses:a}}e.foldersToRgExcludeGlobs=E;function v(h,s,u=!0){const r=[];return h.forEach(S=>{const a=Object.assign({},s||{},S.includePattern||{}),i=w(a,u?S.folder.fsPath:void 0);r.push(...i.globArgs)}),r}e.foldersToIncludeGlobs=v;function w(h,s,u){const r=[],S={};return Object.keys(h).forEach(a=>{if(u&&u.has(a)||!a)return;const i=h[a];a=R(s?_(s,a):a),a.startsWith("\\\\")?a="\\\\"+a.substr(2).replace(/\\/g,"/"):a=a.replace(/\\/g,"/"),typeof i=="boolean"&&i?(a.startsWith("\\\\")&&(a+="**"),r.push(p(a))):i&&i.when&&(S[a]=i)}),{globArgs:r,siblingClauses:S}}function _(h,s){return t.isAbsolute(s)?s:t.join(h,s)}e.getAbsoluteGlob=_;function R(h){return h=k.rtrim(h,"\\"),k.rtrim(h,"/")}function p(h){return C.getRoot(h).toLowerCase()==="c:/"?h.replace(/^c:[/\\]/i,"/"):h}e.fixDriveC=p}),define(pe[279],ve([0,1,38,60,9,105,17,49,32,78,28,11,46,8,18,29,31,277,103]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c,E,v,w,_,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const h=new Set;process.on("exit",()=>{h.forEach(a=>a())});class s{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&D.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,p.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&D.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(n=>{const o=Object.assign({},n.excludePattern||{},this.config.excludePattern||{}),l=n.folder.fsPath;i.folderQueries.map(f=>f.folder.fsPath).filter(f=>f!==l).forEach(f=>{(0,F.isEqualOrParent)(f,l)&&(o[I.relative(l,f)]=!0)}),this.folderExcludePatterns.set(l,new r(o,l))})}cancel(){this.isCanceled=!0,h.forEach(i=>i())}walk(i,n,o,l,f){if(this.fileWalkSW=c.StopWatch.create(!1),this.isCanceled)return f(null,this.isLimitHit);n.forEach(m=>{const b=I.basename(m.fsPath);this.globalExcludePattern&&this.globalExcludePattern(m.fsPath,b)||this.matchFile(o,{relativePath:m.fsPath,searchPath:void 0})}),this.cmdSW=c.StopWatch.create(!1),this.parallel(i,(m,b)=>{this.call(this.cmdTraversal,this,m,o,l,A=>{if(A){const L=(0,k.toErrorMessage)(A);console.error(L),this.errors.push(L),b(A,void 0)}else b(null,void 0)})},(m,b)=>{this.fileWalkSW.stop();const A=m?T.coalesce(m)[0]:null;f(A,this.isLimitHit)})}parallel(i,n,o){const l=new Array(i.length),f=new Array(i.length);let m=!1,b=0;if(i.length===0)return o(null,[]);i.forEach((A,L)=>{n(A,(N,g)=>{if(N?(m=!0,l[L]=null,f[L]=N):(l[L]=g,f[L]=null),++b===i.length)return o(m?f:null,l)})})}call(i,n,...o){try{i.apply(n,o)}catch(l){o[o.length-1](l)}}cmdTraversal(i,n,o,l){const f=i.folder.fsPath,m=y.isMacintosh;let b;const A=()=>b&&b.kill();h.add(A);let L=B=>{h.delete(A),L=()=>{},l(B)},N="";const g=this.initDirectoryTree();let M;const U=(0,R.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression);b=U.cmd,M=!Object.keys(U.siblingClauses).length;const j=U.rgArgs.args.map(B=>B.match(/^-/)?B:`'${B}'`).join(" ");let K=`${U.rgDiskPath} ${j}
 - cwd: ${U.cwd}`;U.rgArgs.siblingClauses&&(K+=`
 - Sibling clauses: ${JSON.stringify(U.rgArgs.siblingClauses)}`),o({message:K}),this.cmdResultCount=0,this.collectStdout(b,"utf8",o,(B,x,z)=>{if(B){L(B);return}if(this.isLimitHit){L();return}const q=(N+(m?P.normalizeNFC(x||""):x)).split(`
`);if(z){const Z=q.length;q[Z-1]=q[Z-1].trim(),q[Z-1]||q.pop()}else N=q.pop()||"";if(q.length&&q[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=q.length,M){for(const Z of q)if(this.matchFile(n,{base:f,relativePath:Z,searchPath:this.getSearchPath(i,Z)}),this.isLimitHit){A();break}(z||this.isLimitHit)&&L();return}this.addDirectoryEntries(i,g,f,q,n),z&&(this.matchDirectoryTree(g,f,n),L())})}spawnFindCmd(i){const n=this.folderExcludePatterns.get(i.folder.fsPath),o=n.getBasenameTerms(),l=n.getPathTerms(),f=["-L","."];if(o.length||l.length){f.push("-not","(","(");for(const m of o)f.push("-name",m),f.push("-o");for(const m of l)f.push("-path",m),f.push("-o");f.pop(),f.push(")","-prune",")")}return f.push("-type","f"),d.spawn("find",f,{cwd:i.folder.fsPath})}readStdout(i,n,o){let l="";this.collectStdout(i,n,()=>{},(f,m,b)=>{if(f){o(f);return}l+=m,b&&o(null,l)})}collectStdout(i,n,o,l){let f=(A,L,N)=>{(A||N)&&(f=()=>{},this.cmdSW&&this.cmdSW.stop()),l(A,L,N)},m=!1;i.stdout?(this.forwardData(i.stdout,n,f),i.stdout.once("data",()=>m=!0)):o({message:"stdout is null"});let b;i.stderr?b=this.collectData(i.stderr):o({message:"stderr is null"}),i.on("error",A=>{f(A)}),i.on("close",A=>{let L;!m&&(L=this.decodeData(b,n))&&S(L)?f(new Error(`command failed with error code ${A}: ${this.decodeData(b,n)}`)):(this.exists&&A===0&&(this.isLimitHit=!0),f(null,"",!0))})}forwardData(i,n,o){const l=new C.StringDecoder(n);return i.on("data",f=>{o(null,l.write(f))}),l}collectData(i){const n=[];return i.on("data",o=>{n.push(o)}),n}decodeData(i,n){const o=new C.StringDecoder(n);return i.map(l=>o.write(l)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:n},o,l,f){l.indexOf(this.filePattern)!==-1&&this.matchFile(f,{base:o,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const m=b=>{const A=I.basename(b),L=I.dirname(b);let N=n[L];N||(N=n[L]=[],m(L)),N.push({base:o,relativePath:b,basename:A,searchPath:this.getSearchPath(i,b)})};l.forEach(m)}matchDirectoryTree({rootEntries:i,pathToEntries:n},o,l){const f=this,m=this.folderExcludePatterns.get(o),b=this.filePattern;function A(L){f.directoriesWalked++;const N=D.hasSiblingFn(()=>L.map(g=>g.basename));for(let g=0,M=L.length;g<M;g++){const U=L[g],{relativePath:j,basename:K}=U;if(m.test(j,K,b!==K?N:void 0))continue;const B=n[j];if(B)A(B);else{if(f.filesWalked++,j===b)continue;f.matchFile(l,U)}if(f.isLimitHit)break}}A(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,n,o,l,f){const m=i.folder,b=D.hasSiblingFn(()=>o);this.parallel(o,(A,L)=>{if(this.isCanceled||this.isLimitHit)return L(null);const N=n?[n,A].join(I.sep):A;if(this.folderExcludePatterns.get(i.folder.fsPath).test(N,A,this.config.filePattern!==A?b:void 0))return L(null);const g=[m.fsPath,N].join(I.sep);t.lstat(g,(M,U)=>{if(M||this.isCanceled||this.isLimitHit)return L(null);this.statLinkIfNeeded(g,U,(j,K)=>j||this.isCanceled||this.isLimitHit?L(null):K.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(g,U,(B,x)=>B||this.isCanceled||this.isLimitHit||(x=x||"",this.walkedPaths[x])?L(null):(this.walkedPaths[x]=!0,w.Promises.readdir(g).then(z=>{if(this.isCanceled||this.isLimitHit)return L(null);this.doWalk(i,N,z,l,G=>L(G||null))},z=>{L(null)})))):(this.filesWalked++,N===this.filePattern||this.maxFilesize&&v.isNumber(K.size)&&K.size>this.maxFilesize||this.matchFile(l,{base:m.fsPath,relativePath:N,searchPath:this.getSearchPath(i,N)}),L(null,void 0)))})},A=>{const L=A&&T.coalesce(A);return f(L&&L.length>0?L[0]:void 0)})}matchFile(i,n){this.isFileMatch(n)&&(!this.includePattern||this.includePattern(n.relativePath,I.basename(n.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(n))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,_.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,n,o){return n.isSymbolicLink()?t.stat(i,o):o(null,n)}realPathIfNeeded(i,n,o){return n.isSymbolicLink()?t.realpath(i,(l,f)=>l?o(l):o(null,f)):o(null,i)}getSearchPath(i,n){return i.folderName?I.join(i.folderName,n):n}}e.FileWalker=s;class u{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new s(i)}search(i,n,o){this.walker.walk(this.folderQueries,this.extraFiles,i,n,(l,f)=>{o(l,{limitHit:f,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=u;class r{constructor(i,n){this.expression=i,this.root=n,this.init(i)}init(i){let n,o;Object.keys(i).filter(l=>i[l]).forEach(l=>{I.isAbsolute(l)?(n=n||D.getEmptyExpression(),n[l]=i[l]):(o=o||D.getEmptyExpression(),o[l]=i[l])}),this.absoluteParsedExpr=n&&D.parse(n,{trimForExclusions:!0}),this.relativeParsedExpr=o&&D.parse(o,{trimForExclusions:!0})}test(i,n,o){return this.relativeParsedExpr&&this.relativeParsedExpr(i,n,o)||this.absoluteParsedExpr&&this.absoluteParsedExpr(I.join(this.root,i),n,o)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...D.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...D.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...D.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...D.getPathTerms(this.relativeParsedExpr)),i}}function S(a){const i=a.trim().split(`
`),n=i[0].trim();if(n.startsWith("Error parsing regex"))return n;if(n.startsWith("regex parse error"))return E.uppercaseFirstLetter(i[i.length-1].trim());if(n.startsWith("error parsing glob")||n.startsWith("unsupported encoding"))return n.charAt(0).toUpperCase()+n.substr(1);if(n==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(n.startsWith("Literal "))return n}e.rgErrorMsgForDisplay=S}),define(pe[280],ve([0,1,98,23]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function I(a){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(i=>i===a)}e.isUTFEncoding=I,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const C=512,T=512,k=512*8,D=512*128;var P;(function(a){a[a.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(P=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class F extends Error{constructor(i,n){super(i);this.decodeStreamErrorKind=n}}e.DecodeStreamError=F;class y{constructor(i){this.iconvLiteDecoder=i}static async create(i){let n;if(i!==e.UTF8)n=(await new Promise((l,f)=>{ee(["@vscode/iconv-lite-umd"],l,f)})).getDecoder(w(i));else{const o=new TextDecoder;n={write(l){return o.decode(l,{stream:!0})},end(){return o.decode()}}}return new y(n)}write(i){return this.iconvLiteDecoder.write(i)}end(){return this.iconvLiteDecoder.end()}}function c(a,i){const n=i.minBytesRequiredForDetection??i.guessEncoding?k:T;return new Promise((o,l)=>{const f=(0,d.newWriteableStream)(g=>g.join("")),m=[];let b=0,A,L;const N=async()=>{try{const g=await S({buffer:t.VSBuffer.concat(m),bytesRead:b},i.guessEncoding);if(g.seemsBinary&&i.acceptTextOnly)throw new F("Stream is binary but only text is accepted for decoding",1);g.encoding=await i.overwriteEncoding(g.encoding),A=await y.create(g.encoding);const M=A.write(t.VSBuffer.concat(m).buffer);f.write(M),m.length=0,b=0,o({stream:f,detected:g})}catch(g){L?.dispose(),f.destroy(),l(g)}};L=(0,d.listenStream)(a,{onData:async g=>{A?f.write(A.write(g.buffer)):(m.push(g),b+=g.byteLength,b>=n&&(a.pause(),await N(),setTimeout(()=>a.resume())))},onError:g=>f.error(g),onEnd:async()=>{A||await N(),f.end(A?.end())}})})}e.toDecodeStream=c;async function E(a,i,n){const l=(await new Promise((b,A)=>{ee(["@vscode/iconv-lite-umd"],b,A)})).getEncoder(w(i),n);let f=!1,m=!1;return{read(){if(m)return null;const b=a.read();if(typeof b!="string"){if(m=!0,!f&&n?.addBOM)switch(i){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const A=l.end();return A&&A.length>0?(f=!0,t.VSBuffer.wrap(A)):null}return f=!0,t.VSBuffer.wrap(l.write(b))}}}e.toEncodeReadable=E;async function v(a){return(await new Promise((n,o)=>{ee(["@vscode/iconv-lite-umd"],n,o)})).encodingExists(w(a))}e.encodingExists=v;function w(a){return a===e.UTF8_with_bom||a===null?e.UTF8:a}e.toNodeEncoding=w;function _(a,i){if(!a||i<e.UTF16be_BOM.length)return null;const n=a.readUInt8(0),o=a.readUInt8(1);if(n===e.UTF16be_BOM[0]&&o===e.UTF16be_BOM[1])return e.UTF16be;if(n===e.UTF16le_BOM[0]&&o===e.UTF16le_BOM[1])return e.UTF16le;if(i<e.UTF8_BOM.length)return null;const l=a.readUInt8(2);return n===e.UTF8_BOM[0]&&o===e.UTF8_BOM[1]&&l===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=_;const R=["ascii","utf-16","utf-32"];async function p(a){const i=await new Promise((m,b)=>{ee(["jschardet"],m,b)}),n=a.slice(0,D),o=u(n.buffer),l=i.detect(o);if(!l||!l.encoding)return null;const f=l.encoding.toLowerCase();return 0<=R.indexOf(f)?null:s(l.encoding)}const h={ibm866:"cp866",big5:"cp950"};function s(a){const i=a.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return h[i]||i}function u(a){let i="";for(let n=0;n<a.length;n++)i+=String.fromCharCode(a[n]);return i}function r(a){switch(a){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const i=a.match(/windows(\d+)/);return i?"windows-"+i[1]:a}}}e.toCanonicalName=r;function S({buffer:a,bytesRead:i},n){let o=_(a,i),l=!1;if(o!==e.UTF16be&&o!==e.UTF16le&&a){let f=!0,m=!0,b=!1;for(let A=0;A<i&&A<C;A++){const L=A%2==1,N=a.readUInt8(A)===0;if(N&&(b=!0),f&&(L&&!N||!L&&N)&&(f=!1),m&&(L&&N||!L&&!N)&&(m=!1),N&&!f&&!m)break}b&&(f?o=e.UTF16le:m?o=e.UTF16be:l=!0)}return n&&!l&&!o&&a?p(a.slice(0,i)).then(f=>({seemsBinary:!1,encoding:f})):{seemsBinary:l,encoding:o}}e.detectEncodingFromBuffer=S,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(pe[137],ve([0,1,280,29,136]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class C extends I.TextSearchManager{constructor(k,D,P=t,F="searchProcess"){super(k,D,{readdir:y=>P.Promises.readdir(y.fsPath),toCanonicalName:y=>(0,d.toCanonicalName)(y)},F)}}e.NativeTextSearchManager=C}),define(pe[281],ve([0,1,62,4]),function(ee,e,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeViewsDragAndDropService=e.ITreeViewsDragAndDropService=void 0,e.ITreeViewsDragAndDropService=(0,t.createDecorator)("treeViewsDragAndDropService");class I{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(T){if(T&&this._dragOperations.has(T)){const k=this._dragOperations.get(T);return this._dragOperations.delete(T),k}}addDragOperationTransfer(T,k){this._dragOperations.set(T,k)}}e.TreeViewsDragAndDropService=I,(0,d.registerSingleton)(e.ITreeViewsDragAndDropService,I)}),define(pe[282],ve([0,1,172,22,2,3,6,13,7,18,17,15,21,208,281]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function w(p,h){if((0,P.isString)(p))return{label:p};if(p&&typeof p=="object"&&typeof p.label=="string"){let s;return Array.isArray(p.highlights)&&(s=p.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),s=s.length?s:void 0),{label:p.label,highlights:s}}}class _{constructor(h,s,u){this._proxy=h,this.commands=s,this.logService=u,this.treeViews=new Map,this.treeDragAndDropService=new v.TreeViewsDragAndDropService;function r(S){return S&&S.$treeViewId&&S.$treeItemHandle}s.registerArgumentProcessor({processArgument:S=>r(S)?this.convertArgument(S):Array.isArray(S)&&S.length>0?S.map(a=>r(a)?this.convertArgument(a):a):S})}registerTreeDataProvider(h,s,u){const r=this.createTreeView(h,{treeDataProvider:s},u);return{dispose:()=>r.dispose()}}createTreeView(h,s,u){if(!s||!s.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=s.dragAndDropController?.supportedMimeTypes,S=!!s.dragAndDropController?.handleDrag,a=this._proxy.$registerTreeViewDataProvider(h,{showCollapseAll:!!s.showCollapseAll,canSelectMany:!!s.canSelectMany,dragAndDropMimeTypes:r,hasHandleDrag:S}),i=this.createExtHostTreeView(h,s,u);return{get onDidCollapseElement(){return i.onDidCollapseElement},get onDidExpandElement(){return i.onDidExpandElement},get selection(){return i.selectedElements},get onDidChangeSelection(){return i.onDidChangeSelection},get visible(){return i.visible},get onDidChangeVisibility(){return i.onDidChangeVisibility},get message(){return i.message},set message(n){i.message=n},get title(){return i.title},set title(n){i.title=n},get description(){return i.description},set description(n){i.description=n},reveal:(n,o)=>i.reveal(n,o),dispose:async()=>{await a,this.treeViews.delete(h),i.dispose()}}}$getChildren(h,s){const u=this.treeViews.get(h);return u?u.getChildren(s):Promise.reject(new Error((0,d.localize)(0,null,h)))}async $handleDrop(h,s,u,r,S,a){const i=this.treeViews.get(h);if(!i)return Promise.reject(new Error((0,d.localize)(1,null,h)));const n=E.TreeDataTransferConverter.toITreeDataTransfer(s);return S===h&&a&&await this.addAdditionalTransferItems(n,i,a,r),i.onDrop(n,u)}async addAdditionalTransferItems(h,s,u,r){const S=this.treeDragAndDropService.removeDragOperationTransfer(r);if(S)(await S)?.forEach((a,i)=>{a&&h.set(i,a)});else if(r&&s.handleDrag){const a=s.handleDrag(u,h);this.treeDragAndDropService.addDragOperationTransfer(r,a),await a}return h}async $handleDrag(h,s,u){const r=this.treeViews.get(h);if(!r)return Promise.reject(new Error((0,d.localize)(2,null,h)));const S=await this.addAdditionalTransferItems(new Map,r,s,u);if(!!S)return E.TreeDataTransferConverter.toTreeDataTransferDTO(S)}async $hasResolve(h){const s=this.treeViews.get(h);if(!s)throw new Error((0,d.localize)(3,null,h));return s.hasResolve}$resolve(h,s,u){const r=this.treeViews.get(h);if(!r)throw new Error((0,d.localize)(4,null,h));return r.resolveTreeItem(s,u)}$setExpanded(h,s,u){const r=this.treeViews.get(h);if(!r)throw new Error((0,d.localize)(5,null,h));r.setExpanded(s,u)}$setSelection(h,s){const u=this.treeViews.get(h);if(!u)throw new Error((0,d.localize)(6,null,h));u.setSelection(s)}$setVisible(h,s){const u=this.treeViews.get(h);if(!u)throw new Error((0,d.localize)(7,null,h));u.setVisible(s)}createExtHostTreeView(h,s,u){const r=new R(h,s,this._proxy,this.commands.converter,this.logService,u);return this.treeViews.set(h,r),r}convertArgument(h){const s=this.treeViews.get(h.$treeViewId);return s?s.getExtensionElement(h.$treeItemHandle):null}}e.ExtHostTreeViews=_;class R extends T.Disposable{constructor(h,s,u,r,S,a){super();if(this.viewId=h,this.proxy=u,this.commands=r,this.logService=S,this.extension=a,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new C.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new C.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new C.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new C.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new C.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new c.CancellationTokenSource,a.contributes&&a.contributes.views)for(const o in a.contributes.views)for(const l of a.contributes.views[o])l.id===h&&(this._title=l.name);this.dataProvider=s.treeDataProvider,this.dndController=s.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(o=>this._onDidChangeData.fire({message:!1,element:o}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(o=>this._onDidChangeData.fire({message:!1,element:o})));let i,n;this._register(C.Event.debounce(this._onDidChangeData.event,(o,l)=>(o||(o={message:!1,elements:[]}),l.element!==!1&&(i||(i=new Promise(f=>n=f),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(l.element)?o.elements.push(...l.element):o.elements.push(l.element)),l.message&&(o.message=!0),o),200,!0)(({message:o,elements:l})=>{l.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const f=n;return i=null,this.refresh(l).then(()=>f())})),o&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(h=>this.getExtensionElement(h)).filter(h=>!(0,P.isUndefinedOrNull)(h))}async getChildren(h){const s=h?this.getExtensionElement(h):void 0;if(h&&!s)return this.logService.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let u=this.getChildrenNodes(h);return u||(u=await this.fetchChildrenNodes(s)),u?u.map(r=>r.item):void 0}getExtensionElement(h){return this.elements.get(h)}reveal(h,s){s=s||{select:!0,focus:!1};const u=(0,P.isUndefinedOrNull)(s.select)?!0:s.select,r=(0,P.isUndefinedOrNull)(s.focus)?!1:s.focus,S=(0,P.isUndefinedOrNull)(s.expand)?!1:s.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.refreshPromise.then(()=>this.resolveUnknownParentChain(h)).then(a=>this.resolveTreeNode(h,a[a.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:a.map(n=>n.item)},{select:u,focus:r,expand:S})),a=>this.logService.error(a)):this.proxy.$reveal(this.viewId,void 0,{select:u,focus:r,expand:S})}get message(){return this._message}set message(h){this._message=h,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(h){this._title=h,this.proxy.$setTitle(this.viewId,h,this._description)}get description(){return this._description}set description(h){this._description=h,this.proxy.$setTitle(this.viewId,this._title,h)}setExpanded(h,s){const u=this.getExtensionElement(h);u&&(s?this._onDidExpandElement.fire(Object.freeze({element:u})):this._onDidCollapseElement.fire(Object.freeze({element:u})))}setSelection(h){(0,F.equals)(this._selectedHandles,h)||(this._selectedHandles=h,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(h){h!==this._visible&&(this._visible=h,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(h,s){const u=[];for(const r of h){const S=this.getExtensionElement(r);S&&u.push(S)}if(!(!this.dndController?.handleDrag||u.length===0))return await this.dndController.handleDrag(u,s),s}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(h,s){const u=this.getExtensionElement(s);if(!!u)return(0,k.asPromise)(()=>this.dndController?.handleDrop(h,u))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(h,s){if(!this.dataProvider.resolveTreeItem)return;const u=this.elements.get(h);if(u){const r=this.nodes.get(u);if(r){const S=await this.dataProvider.resolveTreeItem(r.extensionItem,u,s)??r.extensionItem;return r.item.tooltip=this.getTooltip(S.tooltip),r.item.command=this.getCommand(r.disposableStore,S.command),r.item}}}resolveUnknownParentChain(h){return this.resolveParent(h).then(s=>s?this.resolveUnknownParentChain(s).then(u=>this.resolveTreeNode(s,u[u.length-1]).then(r=>(u.push(r),u))):Promise.resolve([]))}resolveParent(h){const s=this.nodes.get(h);return s?Promise.resolve(s.parent?this.elements.get(s.parent.item.handle):void 0):(0,k.asPromise)(()=>this.dataProvider.getParent(h))}resolveTreeNode(h,s){const u=this.nodes.get(h);return u?Promise.resolve(u):(0,k.asPromise)(()=>this.dataProvider.getTreeItem(h)).then(r=>this.createHandle(h,r,s,!0)).then(r=>this.getChildren(s?s.item.handle:void 0).then(()=>{const S=this.getExtensionElement(r);if(S){const a=this.nodes.get(S);if(a)return Promise.resolve(a)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}getChildrenNodes(h){if(h){let s;if(typeof h=="string"){const u=this.getExtensionElement(h);s=u?this.nodes.get(u):void 0}else s=h;return s&&s.children||void 0}return this.roots}async fetchChildrenNodes(h){this.clearChildren(h);const s=new c.CancellationTokenSource(this._refreshCancellationSource.token);try{const u=h?this.nodes.get(h):void 0,r=await this.dataProvider.getChildren(h);if(s.token.isCancellationRequested)return;const S=await Promise.all((0,F.coalesce)(r||[]).map(async a=>{const i=await this.dataProvider.getTreeItem(a);return i&&!s.token.isCancellationRequested?this.createAndRegisterTreeNode(a,i,u):null}));return s.token.isCancellationRequested?void 0:(0,F.coalesce)(S)}finally{s.dispose()}}refresh(h){if(h.some(u=>!u))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new c.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const u=this.getHandlesToRefresh(h);if(u.length)return this.refreshHandles(u)}return Promise.resolve(void 0)}getHandlesToRefresh(h){const s=new Set,u=h.map(S=>this.nodes.get(S));for(const S of u)if(S&&!s.has(S.item.handle)){let a=S;for(;a&&a.parent&&u.findIndex(i=>a&&a.parent&&i&&i.item.handle===a.parent.item.handle)===-1;){const i=this.elements.get(a.parent.item.handle);a=i?this.nodes.get(i):void 0}a&&!a.parent&&s.add(S.item.handle)}const r=[];return s.forEach(S=>{const a=this.elements.get(S);if(a){const i=this.nodes.get(a);i&&(!i.parent||!s.has(i.parent.item.handle))&&r.push(S)}}),r}refreshHandles(h){const s={};return Promise.all(h.map(u=>this.refreshNode(u).then(r=>{r&&(s[u]=r.item)}))).then(()=>Object.keys(s).length?this.proxy.$refresh(this.viewId,s):void 0)}refreshNode(h){const s=this.getExtensionElement(h);if(s){const u=this.nodes.get(s);if(u)return this.clearChildren(s),(0,k.asPromise)(()=>this.dataProvider.getTreeItem(s)).then(r=>{if(r){const S=this.createTreeNode(s,r,u.parent);return this.updateNodeCache(s,S,u,u.parent),u.dispose(),S}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(h,s,u){const r=this.createTreeNode(h,s,u);if(s.id&&this.elements.has(r.item.handle))throw new Error((0,d.localize)(8,null,s.id));return this.addNodeToCache(h,r),this.addNodeToParentCache(r,u),r}getTooltip(h){return D.MarkdownString.isMarkdownString(h)?y.MarkdownString.from(h):h}getCommand(h,s){return s?this.commands.toInternal(s,h):void 0}createTreeNode(h,s,u){const r=new T.DisposableStore,S=this.createHandle(h,s,u),a=this.getLightIconPath(s);return{item:{handle:S,parentHandle:u?u.item.handle:void 0,label:w(s.label,this.extension),description:s.description,resourceUri:s.resourceUri,tooltip:this.getTooltip(s.tooltip),command:this.getCommand(r,s.command),contextValue:s.contextValue,icon:a,iconDark:this.getDarkIconPath(s)||a,themeIcon:this.getThemeIcon(s),collapsibleState:(0,P.isUndefinedOrNull)(s.collapsibleState)?D.TreeItemCollapsibleState.None:s.collapsibleState,accessibilityInformation:s.accessibilityInformation},extensionItem:s,parent:u,children:void 0,disposableStore:r,dispose(){r.dispose()}}}getThemeIcon(h){return h.iconPath instanceof D.ThemeIcon?h.iconPath:void 0}createHandle(h,{id:s,label:u,resourceUri:r},S,a){if(s)return`${R.ID_HANDLE_PREFIX}/${s}`;const i=w(u,this.extension),n=S?S.item.handle:R.LABEL_HANDLE_PREFIX;let o=i?i.label:r?(0,t.basename)(r):"";o=o.indexOf("/")!==-1?o.replace("/","//"):o;const l=this.nodes.has(h)?this.nodes.get(h).item.handle:void 0,f=this.getChildrenNodes(S)||[];let m,b=0;do{if(m=`${n}/${b}:${o}`,a||!this.elements.has(m)||l===m)break;b++}while(b<=f.length);return m}getLightIconPath(h){if(h.iconPath&&!(h.iconPath instanceof D.ThemeIcon))return typeof h.iconPath=="string"||I.URI.isUri(h.iconPath)?this.getIconPath(h.iconPath):this.getIconPath(h.iconPath.light)}getDarkIconPath(h){if(h.iconPath&&!(h.iconPath instanceof D.ThemeIcon)&&h.iconPath.dark)return this.getIconPath(h.iconPath.dark)}getIconPath(h){return I.URI.isUri(h)?h:I.URI.file(h)}addNodeToCache(h,s){this.elements.set(s.item.handle,h),this.nodes.set(h,s)}updateNodeCache(h,s,u,r){this.elements.delete(s.item.handle),this.nodes.delete(h),s.item.handle!==u.item.handle&&this.elements.delete(u.item.handle),this.addNodeToCache(h,s);const S=this.getChildrenNodes(r)||[],a=S.filter(i=>i.item.handle===u.item.handle)[0];a&&S.splice(S.indexOf(a),1,s)}addNodeToParentCache(h,s){s?(s.children||(s.children=[]),s.children.push(h)):(this.roots||(this.roots=[]),this.roots.push(h))}clearChildren(h){if(h){const s=this.nodes.get(h);if(s){if(s.children)for(const u of s.children){const r=this.elements.get(u.item.handle);r&&this.clear(r)}s.children=void 0}}else this.clearAll()}clear(h){const s=this.nodes.get(h);if(s){if(s.children)for(const u of s.children){const r=this.elements.get(u.item.handle);r&&this.clear(r)}this.nodes.delete(h),this.elements.delete(s.item.handle),s.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(h=>h.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}R.LABEL_HANDLE_PREFIX="0",R.ID_HANDLE_PREFIX="1"}),define(pe[283],ve([0,1,21,16,3,47,2,114,81,149,80,42,5,233,232,39,234,36,235,236,237,220,238,45,40,239,240,243,244,245,134,222,250,251,252,91,34,254,282,15,7,257,68,135,35,74,209,242,85,132,70,54,72,12,64,14,26,246,206,51,65,230,255,205,67,66,260,258,259,231,44,253,256,90,53,123,248,69,249,10,192,247,203,241,6,30]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c,E,v,w,_,R,p,h,s,u,r,S,a,i,n,o,l,f,m,b,A,L,N,g,M,U,j,K,B,x,z,G,q,Z,se,ue,te,J,ae,he,we,Ie,Ne,Ee,be,H,W,O,$,Q,re,de,ye,Ae,We,$e,je,He,Ue,Je,rt,Re,tt,ne,oe,Y,ge,_e,Oe,ze,Ze,lt,vt,Ge){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function at(Xe){const st=Xe.get(be.IExtHostInitDataService),yt=Xe.get(Ue.IExtHostFileSystemInfo),Pt=Xe.get(Ae.IExtHostConsumerFileSystem),Ct=Xe.get(a.IExtHostExtensionService),ht=Xe.get(q.IExtHostWorkspace),kt=Xe.get(ne.IExtHostTelemetry),Ft=Xe.get(R.IExtHostConfiguration),Mt=Xe.get(Ne.IURITransformerService),xe=Xe.get(Ee.IExtHostRpcService),Se=Xe.get(g.IExtHostStorage),Ce=Xe.get(ye.IExtensionStoragePaths),me=Xe.get(Ie.ILoggerService),ie=Xe.get(Ie.ILogService),ke=Xe.get(O.IExtHostTunnelService),Le=Xe.get($.IExtHostApiDeprecationService),Ke=Xe.get(G.IExtHostWindow),Ve=Xe.get(Re.IExtHostSecretState),ct=Xe.get(tt.IExtHostEditorTabs);xe.set(c.ExtHostContext.ExtHostFileSystemInfo,yt),xe.set(c.ExtHostContext.ExtHostLogLevelServiceShape,me),xe.set(c.ExtHostContext.ExtHostWorkspace,ht),xe.set(c.ExtHostContext.ExtHostConfiguration,Ft),xe.set(c.ExtHostContext.ExtHostExtensionService,Ct),xe.set(c.ExtHostContext.ExtHostStorage,Se),xe.set(c.ExtHostContext.ExtHostTunnelService,ke),xe.set(c.ExtHostContext.ExtHostWindow,Ke),xe.set(c.ExtHostContext.ExtHostSecretState,Ve),xe.set(c.ExtHostContext.ExtHostTelemetry,kt),xe.set(c.ExtHostContext.ExtHostEditorTabs,ct);const bt=xe.set(c.ExtHostContext.ExtHostDecorations,Xe.get(J.IExtHostDecorations)),Et=xe.set(c.ExtHostContext.ExtHostDocumentsAndEditors,Xe.get(S.IExtHostDocumentsAndEditors)),ot=xe.set(c.ExtHostContext.ExtHostCommands,Xe.get(w.IExtHostCommands)),ft=xe.set(c.ExtHostContext.ExtHostTerminalService,Xe.get(M.IExtHostTerminalService)),dt=xe.set(c.ExtHostContext.ExtHostDebugService,Xe.get(he.IExtHostDebugService)),Bt=xe.set(c.ExtHostContext.ExtHostSearch,Xe.get(we.IExtHostSearch)),It=xe.set(c.ExtHostContext.ExtHostTask,Xe.get(ae.IExtHostTask)),Lt=xe.set(c.ExtHostContext.ExtHostOutputService,Xe.get(m.IExtHostOutputService)),St=xe.set(c.ExtHostContext.ExtHostUrls,new x.ExtHostUrls(xe)),gt=xe.set(c.ExtHostContext.ExtHostDocuments,new r.ExtHostDocuments(xe,Et)),Ot=xe.set(c.ExtHostContext.ExtHostDocumentContentProviders,new s.ExtHostDocumentContentProvider(xe,Et,ie)),qt=xe.set(c.ExtHostContext.ExtHostDocumentSaveParticipant,new u.ExtHostDocumentSaveParticipant(ie,gt,xe.getProxy(c.MainContext.MainThreadBulkEdits))),mt=xe.set(c.ExtHostContext.ExtHostNotebook,new H.ExtHostNotebookController(xe,ot,Et,gt,Ce)),Wt=xe.set(c.ExtHostContext.ExtHostNotebookDocuments,new Ze.ExtHostNotebookDocuments(ie,mt)),Kt=xe.set(c.ExtHostContext.ExtHostNotebookEditors,new ze.ExtHostNotebookEditors(ie,xe,mt)),Yt=xe.set(c.ExtHostContext.ExtHostNotebookKernels,new oe.ExtHostNotebookKernels(xe,st,mt,ot,ie)),ai=xe.set(c.ExtHostContext.ExtHostNotebookRenderers,new ge.ExtHostNotebookRenderers(xe,mt)),Tt=xe.set(c.ExtHostContext.ExtHostEditors,new U.ExtHostEditors(xe,Et)),Jt=xe.set(c.ExtHostContext.ExtHostTreeViews,new j.ExtHostTreeViews(xe.getProxy(c.MainContext.MainThreadTreeViews),ot,ie)),ci=xe.set(c.ExtHostContext.ExtHostEditorInsets,new se.ExtHostEditorInsets(xe.getProxy(c.MainContext.MainThreadEditorInsets),Tt,st)),Gt=xe.set(c.ExtHostContext.ExtHostDiagnostics,new p.ExtHostDiagnostics(xe,ie,yt)),Zt=xe.set(c.ExtHostContext.ExtHostLanguages,new l.ExtHostLanguages(xe,gt,ot.converter,Mt)),ut=xe.set(c.ExtHostContext.ExtHostLanguageFeatures,new o.ExtHostLanguageFeatures(xe,Mt,gt,ot,Gt,ie,Le)),li=xe.set(c.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(xe,ut)),Nt=xe.set(c.ExtHostContext.ExtHostFileSystemEventService,new n.ExtHostFileSystemEventService(xe,ie,Et)),zt=xe.set(c.ExtHostContext.ExtHostQuickOpen,(0,A.createExtHostQuickOpen)(xe,ht,ot)),vi=xe.set(c.ExtHostContext.ExtHostSCM,new L.ExtHostSCM(xe,ot,ie)),ui=xe.set(c.ExtHostContext.ExtHostComments,(0,_.createExtHostComments)(xe,ot,gt)),ei=xe.set(c.ExtHostContext.ExtHostProgress,new b.ExtHostProgress(xe.getProxy(c.MainContext.MainThreadProgress))),Ci=xe.set(c.ExtHostContext.ExtHosLabelService,new ue.ExtHostLabelService(xe)),wi=xe.set(c.ExtHostContext.ExtHostTheming,new W.ExtHostTheming(xe)),ti=xe.set(c.ExtHostContext.ExtHostAuthentication,new Q.ExtHostAuthentication(xe)),Di=xe.set(c.ExtHostContext.ExtHostTimeline,new re.ExtHostTimeline(xe,ot)),di=xe.set(c.ExtHostContext.ExtHostWebviews,new z.ExtHostWebviews(xe,{remote:st.remote},ht,ie,Le)),Qt=xe.set(c.ExtHostContext.ExtHostWebviewPanels,new je.ExtHostWebviewPanels(xe,di,ht)),hi=xe.set(c.ExtHostContext.ExtHostCustomEditors,new $e.ExtHostCustomEditors(xe,gt,Ce,di,Qt)),ki=xe.set(c.ExtHostContext.ExtHostWebviewViews,new We.ExtHostWebviewViews(xe,di)),Xt=xe.set(c.ExtHostContext.ExtHostTesting,new Je.ExtHostTesting(xe,ot)),Ii=xe.set(c.ExtHostContext.ExtHostUriOpeners,new rt.ExtHostUriOpeners(xe));xe.set(c.ExtHostContext.ExtHostInteractive,new lt.ExtHostInteractive(xe,mt,Et,ot));const Pi=(0,Z.values)(c.ExtHostContext);xe.assertRegistered(Pi);const ii=new He.ExtHostBulkEdits(xe,Et),Ti=new v.ExtHostClipboard(xe),fi=new f.ExtHostMessageService(xe,ie),bi=new h.ExtHostDialogs(xe),ni=new N.ExtHostStatusBar(xe,ot.converter);return E.ExtHostApiCommands.register(ot),function(Fe,xt,$t){const pt=function(){let ce=!Fe.isUnderDevelopment;function fe(){ce||(ie.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ce=!0)}return function Pe(it){if(Array.isArray(it))it.forEach(Pe);else if(typeof it=="string")fe();else{const wt=it;typeof wt.scheme=="undefined"&&fe(),typeof wt.exclusive=="boolean"&&(0,Ge.checkProposedApiEnabled)(Fe,"documentFiltersExclusive")}return it}}(),Rt={getSession(ce,fe,Pe){return ti.getSession(Fe,ce,fe,Pe)},async hasSession(ce,fe){return(0,Ge.checkProposedApiEnabled)(Fe,"authSession"),!!await ti.getSession(Fe,ce,fe,{silent:!0})},get onDidChangeSessions(){return ti.onDidChangeSessions},registerAuthenticationProvider(ce,fe,Pe,it){return ti.registerAuthenticationProvider(ce,fe,Pe,it)}},ri={registerCommand(ce,fe,Pe){return ot.registerCommand(!0,ce,fe,Pe,void 0,Fe)},registerTextEditorCommand(ce,fe,Pe){return ot.registerCommand(!0,ce,(...it)=>{const wt=Tt.getActiveTextEditor();if(!wt){ie.warn("Cannot execute "+ce+" because there is no active text editor.");return}return wt.edit(Dt=>{fe.apply(Pe,[wt,Dt,...it])}).then(Dt=>{Dt||ie.warn("Edits from command "+ce+" were not applied.")},Dt=>{ie.warn("An error occurred while running command "+ce,Dt)})},void 0,void 0,Fe)},registerDiffInformationCommand:(ce,fe,Pe)=>((0,Ge.checkProposedApiEnabled)(Fe,"diffCommand"),ot.registerCommand(!0,ce,async(...it)=>{const wt=Et.activeEditor(!0);if(!wt){ie.warn("Cannot execute "+ce+" because there is no active text editor.");return}const Dt=await Tt.getDiffInformation(wt.id);fe.apply(Pe,[Dt,...it])},void 0,void 0,Fe)),executeCommand(ce,...fe){return ot.executeCommand(ce,...fe)},getCommands(ce=!1){return ot.getCommands(ce)}},Ei={get machineId(){return st.telemetryInfo.machineId},get sessionId(){return st.telemetryInfo.sessionId},get language(){return st.environment.appLanguage},get appName(){return st.environment.appName},get appRoot(){return st.environment.appRoot?.fsPath??""},get appHost(){return st.environment.appHost},get uriScheme(){return st.environment.appUriScheme},get clipboard(){return Ti.value},get shell(){return ft.getDefaultShell(!1)},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ge.checkProposedApiEnabled)(Fe,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ge.checkProposedApiEnabled)(Fe,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const ce=Date.now()-new Date(st.telemetryInfo.firstSessionDate).getTime();return isNaN(ce)?!1:ce<1e3*60*60*24},openExternal(ce,fe){return Ke.openUri(ce,{allowTunneling:!!st.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(ce){if(ce.scheme===st.environment.appUriScheme)return St.createAppUri(ce);try{return await Ke.asExternalUri(ce,{allowTunneling:!!st.remote.authority})}catch(fe){if((0,Oe.matchesScheme)(ce,_e.Schemas.http)||(0,Oe.matchesScheme)(ce,_e.Schemas.https))return ce;throw fe}},get remoteName(){return(0,te.getRemoteName)(st.remote.authority)},get remoteAuthority(){return(0,Ge.checkProposedApiEnabled)(Fe,"resolvers"),st.remote.authority},get uiKind(){return st.uiKind}};st.environment.extensionTestsLocationURI||Object.freeze(Ei);const Si=st.remote.isRemote?B.ExtensionKind.Workspace:B.ExtensionKind.UI,Ai={createTestController(ce,fe,Pe){return Pe&&(0,Ge.checkProposedApiEnabled)(Fe,"testRefresh"),Xt.createTestController(ce,fe,Pe)},createTestObserver(){return(0,Ge.checkProposedApiEnabled)(Fe,"testObserver"),Xt.createTestObserver()},runTests(ce){return(0,Ge.checkProposedApiEnabled)(Fe,"testObserver"),Xt.runTests(ce)},get onDidChangeTestResults(){return(0,Ge.checkProposedApiEnabled)(Fe,"testObserver"),Xt.onResultsChanged},get testResults(){return(0,Ge.checkProposedApiEnabled)(Fe,"testObserver"),Xt.results}},Ri={getExtension(ce){const fe=xt.getExtensionDescription(ce);if(fe)return new a.Extension(Ct,Fe.identifier,fe,Si)},get all(){return xt.getAllExtensionDescriptions().map(ce=>new a.Extension(Ct,Fe.identifier,ce,Si))},get onDidChange(){return xt.onDidChange}},Li={createDiagnosticCollection(ce){return Gt.createDiagnosticCollection(Fe.identifier,ce)},get onDidChangeDiagnostics(){return Gt.onDidChangeDiagnostics},getDiagnostics:ce=>Gt.getDiagnostics(ce),getLanguages(){return Zt.getLanguages()},setTextDocumentLanguage(ce,fe){return Zt.changeLanguage(ce.uri,fe)},match(ce,fe){return(0,F.score)(K.LanguageSelector.from(ce),fe.uri,fe.languageId,!0)},registerCodeActionsProvider(ce,fe,Pe){return ut.registerCodeActionProvider(Fe,pt(ce),fe,Pe)},registerCodeLensProvider(ce,fe){return ut.registerCodeLensProvider(Fe,pt(ce),fe)},registerDefinitionProvider(ce,fe){return ut.registerDefinitionProvider(Fe,pt(ce),fe)},registerDeclarationProvider(ce,fe){return ut.registerDeclarationProvider(Fe,pt(ce),fe)},registerImplementationProvider(ce,fe){return ut.registerImplementationProvider(Fe,pt(ce),fe)},registerTypeDefinitionProvider(ce,fe){return ut.registerTypeDefinitionProvider(Fe,pt(ce),fe)},registerHoverProvider(ce,fe){return ut.registerHoverProvider(Fe,pt(ce),fe,Fe.identifier)},registerEvaluatableExpressionProvider(ce,fe){return ut.registerEvaluatableExpressionProvider(Fe,pt(ce),fe,Fe.identifier)},registerInlineValuesProvider(ce,fe){return ut.registerInlineValuesProvider(Fe,pt(ce),fe,Fe.identifier)},registerDocumentHighlightProvider(ce,fe){return ut.registerDocumentHighlightProvider(Fe,pt(ce),fe)},registerLinkedEditingRangeProvider(ce,fe){return ut.registerLinkedEditingRangeProvider(Fe,pt(ce),fe)},registerReferenceProvider(ce,fe){return ut.registerReferenceProvider(Fe,pt(ce),fe)},registerRenameProvider(ce,fe){return ut.registerRenameProvider(Fe,pt(ce),fe)},registerDocumentSymbolProvider(ce,fe,Pe){return ut.registerDocumentSymbolProvider(Fe,pt(ce),fe,Pe)},registerWorkspaceSymbolProvider(ce){return ut.registerWorkspaceSymbolProvider(Fe,ce)},registerDocumentFormattingEditProvider(ce,fe){return ut.registerDocumentFormattingEditProvider(Fe,pt(ce),fe)},registerDocumentRangeFormattingEditProvider(ce,fe){return ut.registerDocumentRangeFormattingEditProvider(Fe,pt(ce),fe)},registerOnTypeFormattingEditProvider(ce,fe,Pe,...it){return ut.registerOnTypeFormattingEditProvider(Fe,pt(ce),fe,[Pe].concat(it))},registerDocumentSemanticTokensProvider(ce,fe,Pe){return ut.registerDocumentSemanticTokensProvider(Fe,pt(ce),fe,Pe)},registerDocumentRangeSemanticTokensProvider(ce,fe,Pe){return ut.registerDocumentRangeSemanticTokensProvider(Fe,pt(ce),fe,Pe)},registerSignatureHelpProvider(ce,fe,Pe,...it){return typeof Pe=="object"?ut.registerSignatureHelpProvider(Fe,pt(ce),fe,Pe):ut.registerSignatureHelpProvider(Fe,pt(ce),fe,typeof Pe=="undefined"?[]:[Pe,...it])},registerCompletionItemProvider(ce,fe,...Pe){return ut.registerCompletionItemProvider(Fe,pt(ce),fe,Pe)},registerInlineCompletionItemProvider(ce,fe){return(0,Ge.checkProposedApiEnabled)(Fe,"inlineCompletions"),ut.registerInlineCompletionsProvider(Fe,pt(ce),fe)},registerDocumentLinkProvider(ce,fe){return ut.registerDocumentLinkProvider(Fe,pt(ce),fe)},registerColorProvider(ce,fe){return ut.registerColorProvider(Fe,pt(ce),fe)},registerFoldingRangeProvider(ce,fe){return ut.registerFoldingRangeProvider(Fe,pt(ce),fe)},registerSelectionRangeProvider(ce,fe){return ut.registerSelectionRangeProvider(Fe,ce,fe)},registerCallHierarchyProvider(ce,fe){return ut.registerCallHierarchyProvider(Fe,ce,fe)},registerTypeHierarchyProvider(ce,fe){return ut.registerTypeHierarchyProvider(Fe,ce,fe)},setLanguageConfiguration:(ce,fe)=>ut.setLanguageConfiguration(Fe,ce,fe),getTokenInformationAtPosition(ce,fe){return(0,Ge.checkProposedApiEnabled)(Fe,"tokenInformation"),Zt.tokenAtPosition(ce,fe)},registerInlayHintsProvider(ce,fe){return(0,Ge.checkProposedApiEnabled)(Fe,"inlayHints"),ut.registerInlayHintsProvider(Fe,ce,fe)},createLanguageStatusItem(ce,fe){return(0,Ge.checkProposedApiEnabled)(Fe,"languageStatus"),Zt.createLanguageStatusItem(Fe,ce,fe)}},Fi={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return ft.activeTerminal},get terminals(){return ft.terminals},async showTextDocument(ce,fe,Pe){const it=await(T.URI.isUri(ce)?Promise.resolve(_i.openTextDocument(ce)):Promise.resolve(ce));return Tt.showTextDocument(it,fe,Pe)},createTextEditorDecorationType(ce){return Tt.createTextEditorDecorationType(Fe,ce)},onDidChangeActiveTextEditor(ce,fe,Pe){return Tt.onDidChangeActiveTextEditor(ce,fe,Pe)},onDidChangeVisibleTextEditors(ce,fe,Pe){return Tt.onDidChangeVisibleTextEditors(ce,fe,Pe)},onDidChangeTextEditorSelection(ce,fe,Pe){return Tt.onDidChangeTextEditorSelection(ce,fe,Pe)},onDidChangeTextEditorOptions(ce,fe,Pe){return Tt.onDidChangeTextEditorOptions(ce,fe,Pe)},onDidChangeTextEditorVisibleRanges(ce,fe,Pe){return Tt.onDidChangeTextEditorVisibleRanges(ce,fe,Pe)},onDidChangeTextEditorViewColumn(ce,fe,Pe){return Tt.onDidChangeTextEditorViewColumn(ce,fe,Pe)},onDidCloseTerminal(ce,fe,Pe){return ft.onDidCloseTerminal(ce,fe,Pe)},onDidOpenTerminal(ce,fe,Pe){return ft.onDidOpenTerminal(ce,fe,Pe)},onDidChangeActiveTerminal(ce,fe,Pe){return ft.onDidChangeActiveTerminal(ce,fe,Pe)},onDidChangeTerminalDimensions(ce,fe,Pe){return(0,Ge.checkProposedApiEnabled)(Fe,"terminalDimensions"),ft.onDidChangeTerminalDimensions(ce,fe,Pe)},onDidChangeTerminalState(ce,fe,Pe){return ft.onDidChangeTerminalState(ce,fe,Pe)},onDidWriteTerminalData(ce,fe,Pe){return(0,Ge.checkProposedApiEnabled)(Fe,"terminalDataWriteEvent"),ft.onDidWriteTerminalData(ce,fe,Pe)},get state(){return Ke.state},onDidChangeWindowState(ce,fe,Pe){return Ke.onDidChangeWindowState(ce,fe,Pe)},showInformationMessage(ce,...fe){return fi.showMessage(Fe,C.default.Info,ce,fe[0],fe.slice(1))},showWarningMessage(ce,...fe){return fi.showMessage(Fe,C.default.Warning,ce,fe[0],fe.slice(1))},showErrorMessage(ce,...fe){return fi.showMessage(Fe,C.default.Error,ce,fe[0],fe.slice(1))},showQuickPick(ce,fe,Pe){return zt.showQuickPick(ce,fe,Pe)},showWorkspaceFolderPick(ce){return zt.showWorkspaceFolderPick(ce)},showInputBox(ce,fe){return zt.showInput(ce,fe)},showOpenDialog(ce){return bi.showOpenDialog(ce)},showSaveDialog(ce){return bi.showSaveDialog(ce)},createStatusBarItem(ce,fe,Pe){let it,wt,Dt;return typeof ce=="string"?(it=ce,wt=fe,Dt=Pe):(wt=ce,Dt=fe),ni.createStatusBarEntry(Fe,it,wt,Dt)},setStatusBarMessage(ce,fe){return ni.setStatusBarMessage(ce,fe)},withScmProgress(ce){return Le.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),ei.withProgress(Fe,{location:B.ProgressLocation.SourceControl},(fe,Pe)=>ce({report(it){}}))},withProgress(ce,fe){return ei.withProgress(Fe,ce,fe)},createOutputChannel(ce){return Lt.createOutputChannel(ce,Fe)},createWebviewPanel(ce,fe,Pe,it){return Qt.createWebviewPanel(Fe,ce,fe,Pe,it)},createWebviewTextEditorInset(ce,fe,Pe,it){return(0,Ge.checkProposedApiEnabled)(Fe,"editorInsets"),ci.createWebviewEditorInset(ce,fe,Pe,it,Fe)},createTerminal(ce,fe,Pe){return ce&&typeof ce=="object"&&"disablePersistence"in ce&&(0,Ge.checkProposedApiEnabled)(Fe,"terminalDisablePersistence"),typeof ce=="object"?"pty"in ce?ft.createExtensionTerminal(ce):ft.createTerminalFromOptions(ce):ft.createTerminal(ce,fe,Pe)},registerTerminalLinkProvider(ce){return ft.registerLinkProvider(ce)},registerTerminalProfileProvider(ce,fe){return ft.registerProfileProvider(Fe,ce,fe)},registerTreeDataProvider(ce,fe){return Jt.registerTreeDataProvider(ce,fe,Fe)},createTreeView(ce,fe){return Jt.createTreeView(ce,fe,Fe)},registerWebviewPanelSerializer:(ce,fe)=>Qt.registerWebviewPanelSerializer(Fe,ce,fe),registerCustomEditorProvider:(ce,fe,Pe={})=>hi.registerCustomEditorProvider(Fe,ce,fe,Pe),registerFileDecorationProvider(ce){return bt.registerFileDecorationProvider(ce,Fe.identifier)},registerUriHandler(ce){return St.registerUriHandler(Fe.identifier,ce)},createQuickPick(){return zt.createQuickPick(Fe)},createInputBox(){return zt.createInputBox(Fe.identifier)},get activeColorTheme(){return wi.activeColorTheme},onDidChangeActiveColorTheme(ce,fe,Pe){return wi.onDidChangeActiveColorTheme(ce,fe,Pe)},registerWebviewViewProvider(ce,fe,Pe){return ki.registerWebviewViewProvider(Fe,ce,fe,Pe?.webviewOptions)},get activeNotebookEditor(){return(0,Ge.checkProposedApiEnabled)(Fe,"notebookEditor"),mt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ce,fe,Pe){return(0,Ge.checkProposedApiEnabled)(Fe,"notebookEditor"),mt.onDidChangeActiveNotebookEditor(ce,fe,Pe)},get visibleNotebookEditors(){return(0,Ge.checkProposedApiEnabled)(Fe,"notebookEditor"),mt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,Ge.checkProposedApiEnabled)(Fe,"notebookEditor"),mt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ce,fe,Pe){return(0,Ge.checkProposedApiEnabled)(Fe,"notebookEditor"),Kt.onDidChangeNotebookEditorSelection(ce,fe,Pe)},onDidChangeNotebookEditorVisibleRanges(ce,fe,Pe){return(0,Ge.checkProposedApiEnabled)(Fe,"notebookEditor"),Kt.onDidChangeNotebookEditorVisibleRanges(ce,fe,Pe)},showNotebookDocument(ce,fe){return(0,Ge.checkProposedApiEnabled)(Fe,"notebookEditor"),mt.showNotebookDocument(ce,fe)},registerExternalUriOpener(ce,fe,Pe){return(0,Ge.checkProposedApiEnabled)(Fe,"externalUriOpener"),Ii.registerExternalUriOpener(Fe.identifier,ce,fe,Pe)},get tabs(){return(0,Ge.checkProposedApiEnabled)(Fe,"tabs"),ct.tabs},get activeTab(){return(0,Ge.checkProposedApiEnabled)(Fe,"tabs"),ct.activeTab},get onDidChangeTabs(){return(0,Ge.checkProposedApiEnabled)(Fe,"tabs"),ct.onDidChangeTabs},get onDidChangeActiveTab(){return(0,Ge.checkProposedApiEnabled)(Fe,"tabs"),ct.onDidChangeActiveTab},getInlineCompletionItemController(ce){return(0,Ge.checkProposedApiEnabled)(Fe,"inlineCompletions"),o.InlineCompletionController.get(ce)}},_i={get rootPath(){return Le.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(ce){throw t.readonly()},getWorkspaceFolder(ce){return ht.getWorkspaceFolder(ce)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(ce){throw t.readonly()},get workspaceFile(){return ht.workspaceFile},set workspaceFile(ce){throw t.readonly()},updateWorkspaceFolders:(ce,fe,...Pe)=>ht.updateWorkspaceFolders(Fe,ce,fe||0,...Pe),onDidChangeWorkspaceFolders:function(ce,fe,Pe){return ht.onDidChangeWorkspace(ce,fe,Pe)},asRelativePath:(ce,fe)=>ht.getRelativePath(ce,fe),findFiles:(ce,fe,Pe,it)=>ht.findFiles(ce,fe,Pe,Fe.identifier,it),findTextInFiles:(ce,fe,Pe,it)=>{(0,Ge.checkProposedApiEnabled)(Fe,"findTextInFiles");let wt,Dt;return typeof fe=="object"?(wt=fe,Dt=Pe):(wt={},Dt=fe,it=Pe),ht.findTextInFiles(ce,wt||{},Dt,Fe.identifier,it)},saveAll:ce=>ht.saveAll(ce),applyEdit(ce){return ii.applyWorkspaceEdit(ce)},createFileSystemWatcher:(ce,fe,Pe,it)=>Nt.createFileSystemWatcher(ht,Fe,ce,fe,Pe,it),get textDocuments(){return gt.getAllDocumentData().map(ce=>ce.document)},set textDocuments(ce){throw t.readonly()},openTextDocument(ce){let fe;const Pe=ce;if(typeof ce=="string")fe=Promise.resolve(T.URI.file(ce));else if(T.URI.isUri(ce))fe=Promise.resolve(ce);else if(!Pe||typeof Pe=="object")fe=gt.createDocumentData(Pe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(it=>gt.ensureDocumentData(it).then(wt=>wt.document))},onDidOpenTextDocument:(ce,fe,Pe)=>gt.onDidAddDocument(ce,fe,Pe),onDidCloseTextDocument:(ce,fe,Pe)=>gt.onDidRemoveDocument(ce,fe,Pe),onDidChangeTextDocument:(ce,fe,Pe)=>gt.onDidChangeDocument(ce,fe,Pe),onDidSaveTextDocument:(ce,fe,Pe)=>gt.onDidSaveDocument(ce,fe,Pe),onWillSaveTextDocument:(ce,fe,Pe)=>qt.getOnWillSaveTextDocumentEvent(Fe)(ce,fe,Pe),get notebookDocuments(){return mt.notebookDocuments.map(ce=>ce.apiNotebook)},async openNotebookDocument(ce,fe){let Pe;if(T.URI.isUri(ce))Pe=ce,await mt.openNotebookDocument(ce);else if(typeof ce=="string")Pe=T.URI.revive(await mt.createNotebookDocument({viewType:ce,content:fe}));else throw new Error("Invalid arguments");return mt.getNotebookDocument(Pe).apiNotebook},get onDidOpenNotebookDocument(){return mt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return mt.onDidCloseNotebookDocument},registerNotebookSerializer(ce,fe,Pe,it){return mt.registerNotebookSerializer(Fe,ce,fe,Pe,(0,Ge.isProposedApiEnabled)(Fe,"notebookLiveShare")?it:void 0)},registerNotebookContentProvider:(ce,fe,Pe,it)=>((0,Ge.checkProposedApiEnabled)(Fe,"notebookContentProvider"),mt.registerNotebookContentProvider(Fe,ce,fe,Pe,(0,Ge.isProposedApiEnabled)(Fe,"notebookLiveShare")?it:void 0)),onDidChangeConfiguration:(ce,fe,Pe)=>$t.onDidChangeConfiguration(ce,fe,Pe),getConfiguration(ce,fe){return fe=arguments.length===1?void 0:fe,$t.getConfiguration(ce,fe,Fe)},registerTextDocumentContentProvider(ce,fe){return Ot.registerTextDocumentContentProvider(ce,fe)},registerTaskProvider:(ce,fe)=>(Le.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),It.registerTaskProvider(Fe,ce,fe)),registerFileSystemProvider(ce,fe,Pe){return(0,vt.combinedDisposable)(li.registerFileSystemProvider(Fe,ce,fe,Pe),Pt.addFileSystemProvider(ce,fe))},get fs(){return Pt.value},registerFileSearchProvider:(ce,fe)=>((0,Ge.checkProposedApiEnabled)(Fe,"fileSearchProvider"),Bt.registerFileSearchProvider(ce,fe)),registerTextSearchProvider:(ce,fe)=>((0,Ge.checkProposedApiEnabled)(Fe,"textSearchProvider"),Bt.registerTextSearchProvider(ce,fe)),registerRemoteAuthorityResolver:(ce,fe)=>((0,Ge.checkProposedApiEnabled)(Fe,"resolvers"),Ct.registerRemoteAuthorityResolver(ce,fe)),registerResourceLabelFormatter:ce=>((0,Ge.checkProposedApiEnabled)(Fe,"resolvers"),Ci.$registerResourceLabelFormatter(ce)),onDidCreateFiles:(ce,fe,Pe)=>Nt.onDidCreateFile(ce,fe,Pe),onDidDeleteFiles:(ce,fe,Pe)=>Nt.onDidDeleteFile(ce,fe,Pe),onDidRenameFiles:(ce,fe,Pe)=>Nt.onDidRenameFile(ce,fe,Pe),onWillCreateFiles:(ce,fe,Pe)=>Nt.getOnWillCreateFileEvent(Fe)(ce,fe,Pe),onWillDeleteFiles:(ce,fe,Pe)=>Nt.getOnWillDeleteFileEvent(Fe)(ce,fe,Pe),onWillRenameFiles:(ce,fe,Pe)=>Nt.getOnWillRenameFileEvent(Fe)(ce,fe,Pe),openTunnel:ce=>((0,Ge.checkProposedApiEnabled)(Fe,"resolvers"),ke.openTunnel(Fe,ce).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,Ge.checkProposedApiEnabled)(Fe,"resolvers"),ke.getTunnels()},onDidChangeTunnels:(ce,fe,Pe)=>((0,Ge.checkProposedApiEnabled)(Fe,"resolvers"),ke.onDidChangeTunnels(ce,fe,Pe)),registerPortAttributesProvider:(ce,fe)=>((0,Ge.checkProposedApiEnabled)(Fe,"portsAttributes"),ke.registerPortsAttributesProvider(ce,fe)),registerTimelineProvider:(ce,fe)=>((0,Ge.checkProposedApiEnabled)(Fe,"timeline"),Di.registerTimelineProvider(ce,fe,Fe.identifier,ot.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:ce=>((0,Ge.checkProposedApiEnabled)(Fe,"workspaceTrust"),ht.requestWorkspaceTrust(ce)),onDidGrantWorkspaceTrust:(ce,fe,Pe)=>ht.onDidGrantWorkspaceTrust(ce,fe,Pe)},mi={get inputBox(){return Le.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),vi.getLastInputBox(Fe)},createSourceControl(ce,fe,Pe){return vi.createSourceControl(Fe,ce,fe,Pe)}},Mi={createCommentController(ce,fe){return ui.createCommentController(Fe,ce,fe)}},Oi={get activeDebugSession(){return dt.activeDebugSession},get activeDebugConsole(){return dt.activeDebugConsole},get breakpoints(){return dt.breakpoints},onDidStartDebugSession(ce,fe,Pe){return dt.onDidStartDebugSession(ce,fe,Pe)},onDidTerminateDebugSession(ce,fe,Pe){return dt.onDidTerminateDebugSession(ce,fe,Pe)},onDidChangeActiveDebugSession(ce,fe,Pe){return dt.onDidChangeActiveDebugSession(ce,fe,Pe)},onDidReceiveDebugSessionCustomEvent(ce,fe,Pe){return dt.onDidReceiveDebugSessionCustomEvent(ce,fe,Pe)},onDidChangeBreakpoints(ce,fe,Pe){return dt.onDidChangeBreakpoints(ce,fe,Pe)},registerDebugConfigurationProvider(ce,fe,Pe){return dt.registerDebugConfigurationProvider(ce,fe,Pe||B.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ce,fe){return dt.registerDebugAdapterDescriptorFactory(Fe,ce,fe)},registerDebugAdapterTrackerFactory(ce,fe){return dt.registerDebugAdapterTrackerFactory(ce,fe)},startDebugging(ce,fe,Pe){return!Pe||typeof Pe=="object"&&"configuration"in Pe?dt.startDebugging(ce,fe,{parentSession:Pe}):dt.startDebugging(ce,fe,Pe||{})},stopDebugging(ce){return dt.stopDebugging(ce)},addBreakpoints(ce){return dt.addBreakpoints(ce)},removeBreakpoints(ce){return dt.removeBreakpoints(ce)},asDebugSourceUri(ce,fe){return dt.asDebugSourceUri(ce,fe)}},Ni={registerTaskProvider:(ce,fe)=>It.registerTaskProvider(Fe,ce,fe),fetchTasks:ce=>It.fetchTasks(ce),executeTask:ce=>It.executeTask(Fe,ce),get taskExecutions(){return It.taskExecutions},onDidStartTask:(ce,fe,Pe)=>It.onDidStartTask(ce,fe,Pe),onDidEndTask:(ce,fe,Pe)=>It.onDidEndTask(ce,fe,Pe),onDidStartTaskProcess:(ce,fe,Pe)=>It.onDidStartTaskProcess(ce,fe,Pe),onDidEndTaskProcess:(ce,fe,Pe)=>It.onDidEndTaskProcess(ce,fe,Pe)},Ui={createNotebookController(ce,fe,Pe,it,wt){return Yt.createNotebookController(Fe,ce,fe,Pe,it,(0,Ge.isProposedApiEnabled)(Fe,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(ce,fe)=>mt.registerNotebookCellStatusBarItemProvider(Fe,ce,fe),get onDidSaveNotebookDocument(){return(0,Ge.checkProposedApiEnabled)(Fe,"notebookEditor"),Wt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(ce){return(0,Ge.checkProposedApiEnabled)(Fe,"notebookEditorDecorationType"),Kt.createNotebookEditorDecorationType(ce)},createRendererMessaging(ce){return ai.createRendererMessaging(Fe,ce)},onDidChangeNotebookDocumentMetadata(ce,fe,Pe){return(0,Ge.checkProposedApiEnabled)(Fe,"notebookEditor"),Wt.onDidChangeNotebookDocumentMetadata(ce,fe,Pe)},onDidChangeNotebookCells(ce,fe,Pe){return(0,Ge.checkProposedApiEnabled)(Fe,"notebookEditor"),mt.onDidChangeNotebookCells(ce,fe,Pe)},onDidChangeNotebookCellExecutionState(ce,fe,Pe){return(0,Ge.checkProposedApiEnabled)(Fe,"notebookCellExecutionState"),Yt.onDidChangeNotebookCellExecutionState(ce,fe,Pe)},onDidChangeCellOutputs(ce,fe,Pe){return(0,Ge.checkProposedApiEnabled)(Fe,"notebookEditor"),mt.onDidChangeCellOutputs(ce,fe,Pe)},onDidChangeCellMetadata(ce,fe,Pe){return(0,Ge.checkProposedApiEnabled)(Fe,"notebookEditor"),mt.onDidChangeCellMetadata(ce,fe,Pe)},createConcatTextDocument(ce,fe){return(0,Ge.checkProposedApiEnabled)(Fe,"notebookConcatTextDocument"),new de.ExtHostNotebookConcatDocument(mt,gt,ce,fe)}};return{version:st.version,authentication:Rt,commands:ri,comments:Mi,debug:Oi,env:Ei,extensions:Ri,languages:Li,notebooks:Ui,scm:mi,tasks:Ni,tests:Ai,window:Fi,workspace:_i,Breakpoint:B.Breakpoint,CallHierarchyIncomingCall:B.CallHierarchyIncomingCall,CallHierarchyItem:B.CallHierarchyItem,CallHierarchyOutgoingCall:B.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:d.CancellationTokenSource,CandidatePortSource:c.CandidatePortSource,CodeAction:B.CodeAction,CodeActionKind:B.CodeActionKind,CodeActionTriggerKind:B.CodeActionTriggerKind,CodeLens:B.CodeLens,Color:B.Color,ColorInformation:B.ColorInformation,ColorPresentation:B.ColorPresentation,ColorThemeKind:B.ColorThemeKind,CommentMode:B.CommentMode,CommentThreadCollapsibleState:B.CommentThreadCollapsibleState,CompletionItem:B.CompletionItem,CompletionItemKind:B.CompletionItemKind,CompletionItemTag:B.CompletionItemTag,CompletionList:B.CompletionList,CompletionTriggerKind:B.CompletionTriggerKind,ConfigurationTarget:B.ConfigurationTarget,CustomExecution:B.CustomExecution,DebugAdapterExecutable:B.DebugAdapterExecutable,DebugAdapterInlineImplementation:B.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:B.DebugAdapterNamedPipeServer,DebugAdapterServer:B.DebugAdapterServer,DebugConfigurationProviderTriggerKind:B.DebugConfigurationProviderTriggerKind,DebugConsoleMode:B.DebugConsoleMode,DecorationRangeBehavior:B.DecorationRangeBehavior,Diagnostic:B.Diagnostic,DiagnosticRelatedInformation:B.DiagnosticRelatedInformation,DiagnosticSeverity:B.DiagnosticSeverity,DiagnosticTag:B.DiagnosticTag,Disposable:B.Disposable,DocumentHighlight:B.DocumentHighlight,DocumentHighlightKind:B.DocumentHighlightKind,DocumentLink:B.DocumentLink,DocumentSymbol:B.DocumentSymbol,EndOfLine:B.EndOfLine,EnvironmentVariableMutatorType:B.EnvironmentVariableMutatorType,EvaluatableExpression:B.EvaluatableExpression,InlineValueText:B.InlineValueText,InlineValueVariableLookup:B.InlineValueVariableLookup,InlineValueEvaluatableExpression:B.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:B.InlineCompletionTriggerKind,EventEmitter:I.Emitter,ExtensionKind:B.ExtensionKind,ExtensionMode:B.ExtensionMode,ExternalUriOpenerPriority:B.ExternalUriOpenerPriority,FileChangeType:B.FileChangeType,FileDecoration:B.FileDecoration,FileSystemError:B.FileSystemError,FileType:y.FileType,FilePermission:y.FilePermission,FoldingRange:B.FoldingRange,FoldingRangeKind:B.FoldingRangeKind,FunctionBreakpoint:B.FunctionBreakpoint,InlineCompletionItem:B.InlineSuggestion,InlineCompletionList:B.InlineSuggestions,Hover:B.Hover,IndentAction:P.IndentAction,Location:B.Location,MarkdownString:B.MarkdownString,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:B.ParameterInformation,PortAutoForwardAction:B.PortAutoForwardAction,Position:B.Position,ProcessExecution:B.ProcessExecution,ProgressLocation:B.ProgressLocation,QuickInputButtons:B.QuickInputButtons,Range:B.Range,RelativePattern:B.RelativePattern,Selection:B.Selection,SelectionRange:B.SelectionRange,SemanticTokens:B.SemanticTokens,SemanticTokensBuilder:B.SemanticTokensBuilder,SemanticTokensEdit:B.SemanticTokensEdit,SemanticTokensEdits:B.SemanticTokensEdits,SemanticTokensLegend:B.SemanticTokensLegend,ShellExecution:B.ShellExecution,ShellQuoting:B.ShellQuoting,SignatureHelp:B.SignatureHelp,SignatureHelpTriggerKind:B.SignatureHelpTriggerKind,SignatureInformation:B.SignatureInformation,SnippetString:B.SnippetString,SourceBreakpoint:B.SourceBreakpoint,StandardTokenType:B.StandardTokenType,StatusBarAlignment:B.StatusBarAlignment,SymbolInformation:B.SymbolInformation,SymbolKind:B.SymbolKind,SymbolTag:B.SymbolTag,Task:B.Task,TaskGroup:B.TaskGroup,TaskPanelKind:B.TaskPanelKind,TaskRevealKind:B.TaskRevealKind,TaskScope:B.TaskScope,TerminalLink:B.TerminalLink,TerminalLocation:B.TerminalLocation,TerminalProfile:B.TerminalProfile,TextDocumentSaveReason:B.TextDocumentSaveReason,TextEdit:B.TextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:B.TextEditorLineNumbersStyle,TextEditorRevealType:B.TextEditorRevealType,TextEditorSelectionChangeKind:B.TextEditorSelectionChangeKind,TextDocumentChangeReason:B.TextDocumentChangeReason,ThemeColor:B.ThemeColor,ThemeIcon:B.ThemeIcon,TreeItem:B.TreeItem,TreeItemCollapsibleState:B.TreeItemCollapsibleState,TypeHierarchyItem:B.TypeHierarchyItem,UIKind:c.UIKind,Uri:T.URI,ViewColumn:B.ViewColumn,WorkspaceEdit:B.WorkspaceEdit,InlayHint:B.InlayHint,InlayHintLabelPart:B.InlayHintLabelPart,InlayHintKind:B.InlayHintKind,RemoteAuthorityResolverError:B.RemoteAuthorityResolverError,ResolvedAuthority:B.ResolvedAuthority,SourceControlInputBoxValidationType:B.SourceControlInputBoxValidationType,ExtensionRuntime:B.ExtensionRuntime,TimelineItem:B.TimelineItem,NotebookRange:B.NotebookRange,NotebookCellKind:B.NotebookCellKind,NotebookCellExecutionState:B.NotebookCellExecutionState,NotebookCellData:B.NotebookCellData,NotebookData:B.NotebookData,NotebookRendererScript:B.NotebookRendererScript,NotebookCellStatusBarAlignment:B.NotebookCellStatusBarAlignment,NotebookEditorRevealType:B.NotebookEditorRevealType,NotebookCellOutput:B.NotebookCellOutput,NotebookCellOutputItem:B.NotebookCellOutputItem,NotebookCellStatusBarItem:B.NotebookCellStatusBarItem,NotebookControllerAffinity:B.NotebookControllerAffinity,PortAttributes:B.PortAttributes,LinkedEditingRanges:B.LinkedEditingRanges,TestResultState:B.TestResultState,TestRunRequest:B.TestRunRequest,TestMessage:B.TestMessage,TestTag:B.TestTag,TestRunProfileKind:B.TestRunProfileKind,TextSearchCompleteMessageType:Y.TextSearchCompleteMessageType,TreeDataTransfer:B.TreeDataTransfer,TreeDataTransferItem:B.TreeDataTransferItem,CoveredCount:B.CoveredCount,FileCoverage:B.FileCoverage,StatementCoverage:B.StatementCoverage,BranchCoverage:B.BranchCoverage,FunctionCoverage:B.FunctionCoverage,WorkspaceTrustState:B.WorkspaceTrustState,LanguageStatusSeverity:B.LanguageStatusSeverity,QuickPickItemKind:B.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=at}),define(pe[284],ve([0,1,285,296,297,2,298]),function(ee,e,d,t,I,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function k(y,c,E,v,w,_){const R=_.environment.useHostProxy,p=typeof R=="boolean"?R:!_.remote.isRemote,h=(0,T.createProxyResolver)({resolveProxy:u=>y.resolveProxy(u),getHttpProxySetting:()=>c.getConfiguration("http").get("proxy"),log:(u,r,...S)=>{switch(u){case T.LogLevel.Trace:v.trace(r,...S);break;case T.LogLevel.Debug:v.debug(r,...S);break;case T.LogLevel.Info:v.info(r,...S);break;case T.LogLevel.Warning:v.warn(r,...S);break;case T.LogLevel.Error:v.error(r,...S);break;case T.LogLevel.Critical:v.critical(r,...S);break;case T.LogLevel.Off:break;default:a(u,r,S);break}function a(i,n,...o){v.error("Unknown log level",i),v.error(n,...o)}},getLogLevel:()=>v.getLevel(),proxyResolveTelemetry:u=>{w.$publicLog2("resolveProxy",u)},useHostProxy:p,env:process.env}),s=D(c,h);return F(E,s)}e.connectProxyResolver=k;function D(y,c){const E={config:y.getConfiguration("http").get("proxySupport")||"off"};y.onDidChangeConfiguration(w=>{E.config=y.getConfiguration("http").get("proxySupport")||"off"});const v={config:!!y.getConfiguration("http").get("systemCertificates")};return y.onDidChangeConfiguration(w=>{v.config=!!y.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},d,(0,T.createHttpPatch)(d,c,{config:"off"},v,!0)),on:Object.assign({},d,(0,T.createHttpPatch)(d,c,{config:"on"},v,!0)),override:Object.assign({},d,(0,T.createHttpPatch)(d,c,{config:"override"},v,!0)),onRequest:Object.assign({},d,(0,T.createHttpPatch)(d,c,E,v,!0)),default:Object.assign(d,(0,T.createHttpPatch)(d,c,E,v,!1))},https:{off:Object.assign({},t,(0,T.createHttpPatch)(t,c,{config:"off"},v,!0)),on:Object.assign({},t,(0,T.createHttpPatch)(t,c,{config:"on"},v,!0)),override:Object.assign({},t,(0,T.createHttpPatch)(t,c,{config:"override"},v,!0)),onRequest:Object.assign({},t,(0,T.createHttpPatch)(t,c,E,v,!0)),default:Object.assign(t,(0,T.createHttpPatch)(t,c,E,v,!1))},tls:Object.assign(I,(0,T.createTlsPatch)(I))}}const P=new Map;function F(y,c){return y.getExtensionPathIndex().then(E=>{const v=ee.__$__nodeRequire("module"),w=v._load;v._load=function(R,p,h){if(R==="tls")return c.tls;if(R!=="http"&&R!=="https")return w.apply(this,arguments);const s=c[R],u=E.findSubstr(C.URI.file(p.filename));let r=P.get(u);if(r||P.set(u,r={}),!r[R]){let S=s.default;r[R]={...S}}return r[R]}})}}),define(pe[138],ve([0,1,38,299,105,17,74,32,9,8,2,31,69,300,278,92]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c,E,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const _=v.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class R{constructor(m){this.outputChannel=m}provideTextSearchResults(m,b,A,L){return this.outputChannel.appendLine(`provideTextSearchResults ${m.pattern}, ${JSON.stringify({...b,folder:b.folder.toString()})}`),new Promise((N,g)=>{L.onCancellationRequested(()=>G());const M=S(m,b),U=b.folder.fsPath,j=M.map(te=>te.match(/^-/)?te:`'${te}'`).join(" ");this.outputChannel.appendLine(`${_} ${j}
 - cwd: ${U}`);let K=d.spawn(_,M,{cwd:U});K.on("error",te=>{console.error(te),this.outputChannel.appendLine("Error: "+(te&&te.message)),g((0,y.serializeSearchError)(new y.SearchError(te&&te.message,y.SearchErrorCode.rgProcessError)))});let B=!1;const x=new s(b.maxResults,U,b.previewOptions);x.on("result",te=>{B=!0,Z="",A.report(te)});let z=!1;const G=()=>{z=!0,K&&K.kill(),x&&x.cancel()};let q=!1;x.on("hitLimit",()=>{q=!0,G()});let Z="";K.stdout.on("data",te=>{x.handleData(te),B||(Z+=te)});let se=!1;K.stdout.once("data",()=>se=!0);let ue="";K.stderr.on("data",te=>{const J=te.toString();this.outputChannel.appendLine(J),ue+=J}),K.on("close",()=>{if(this.outputChannel.appendLine(se?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(B?"Got result from parser":"No result from parser"),Z&&this.outputChannel.appendLine(`Got data without result: ${Z}`),this.outputChannel.appendLine(""),z)N({limitHit:q});else{x.flush(),K=null;let te;ue&&!se&&(te=p(ue))?g((0,y.serializeSearchError)(new y.SearchError(te.message,te.code))):N({limitHit:q})}})})}}e.RipgrepTextSearchEngine=R;function p(f){const m=f.split(`
`),b=m[0].trim();if(m.some(L=>L.startsWith("regex parse error")))return new y.SearchError(h(m),y.SearchErrorCode.regexParseError);const A=b.match(/grep config error: unknown encoding: (.*)/);if(A)return new y.SearchError(`Unknown encoding: ${A[1]}`,y.SearchErrorCode.unknownEncoding);if(b.startsWith("error parsing glob"))return new y.SearchError(b.charAt(0).toUpperCase()+b.substr(1),y.SearchErrorCode.globParseError);if(b.startsWith("the literal"))return new y.SearchError(b.charAt(0).toUpperCase()+b.substr(1),y.SearchErrorCode.invalidLiteral);if(b.startsWith("PCRE2: error compiling pattern"))return new y.SearchError(b,y.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=p;function h(f){const m=["Regex parse error"],b=f.filter(A=>A.startsWith("PCRE2:"));if(b.length>=1){const A=b[0].replace("PCRE2:","");if(A.indexOf(":")!==-1&&A.split(":").length>=2){const L=A.split(":")[1];m.push(":"+L)}}return m.join("")}e.buildRegexParseError=h;class s extends t.EventEmitter{constructor(m,b,A){super();this.maxResults=m,this.rootFolder=b,this.previewOptions=A,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new I.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(m,b){return super.on(m,b),this}handleData(m){if(this.isDone)return;const b=typeof m=="string"?m:this.stringDecoder.write(m);this.handleDecodedData(b)}handleDecodedData(m){let b=m.indexOf(`
`);const A=this.remainder+m;if(b>=0)b+=this.remainder.length;else{this.remainder=A;return}let L=0;for(;b>=0;)this.handleLine(A.substring(L,b).trim()),L=b+1,b=A.indexOf(`
`,L);this.remainder=A.substring(L)}handleLine(m){if(this.isDone||!m)return;let b;try{b=JSON.parse(m)}catch{throw new Error(`malformed line from rg: ${m}`)}if(b.type==="match"){const A=u(b.data.path),L=F.URI.file(D.join(this.rootFolder,A)),N=this.createTextSearchMatch(b.data,L);this.onResult(N),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(b.type==="context"){const A=u(b.data.path),L=F.URI.file(D.join(this.rootFolder,A));this.createTextSearchContext(b.data,L).forEach(g=>this.onResult(g))}}createTextSearchMatch(m,b){const A=m.line_number-1,L=u(m.lines),N=Buffer.from(L);let g=0,M=0,U=A;m.submatches.length===0&&m.submatches.push(L.length?{start:0,end:1,match:{text:L[0]}}:{start:0,end:0,match:{text:""}});const j=(0,C.coalesce)(m.submatches.map((K,B)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const x=u(K.match),z=N.slice(g,K.start).toString().length,G=M+z,q=r(x),Z=U,se=q.numLines+Z,ue=q.numLines>0?q.lastLineLength:q.lastLineLength+G;return g=K.end,M=ue,U=se,new c.Range(Z,G,se,ue)}));return(0,w.createTextSearchResult)(b,L,j,this.previewOptions)}createTextSearchContext(m,b){const A=u(m.lines),L=m.line_number;return A.replace(/\r?\n$/,"").split(`
`).map((N,g)=>({text:N,uri:b,lineNumber:L+g}))}onResult(m){this.emit("result",m)}}e.RipgrepParser=s;function u(f){return f.bytes?Buffer.from(f.bytes,"base64").toString():f.text}function r(f){const m=/\n/g;let b=0,A=-1,L;for(;L=m.exec(f);)b++,A=L.index;const N=A>=0?f.length-A-1:f.length;return{numLines:b,lastLineLength:N}}function S(f,m){const b=["--hidden"];b.push(f.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:A,otherIncludes:L}=(0,T.groupBy)(m.includes,g=>g.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(L&&L.length){const g=new Set;L.forEach(M=>{g.add(M)}),b.push("-g","!*"),g.forEach(M=>{a(M).map(w.anchorGlob).forEach(U=>{b.push("-g",U)})})}A&&A.length&&A.forEach(g=>{b.push("-g",g)}),m.excludes.map(w.anchorGlob).forEach(g=>b.push("-g",`!${g}`)),m.maxFileSize&&b.push("--max-filesize",m.maxFileSize+""),m.useIgnoreFiles?m.useParentIgnoreFiles||b.push("--no-ignore-parent"):b.push("--no-ignore"),m.followSymlinks&&b.push("--follow"),m.encoding&&m.encoding!=="utf8"&&b.push("--encoding",m.encoding),f.pattern==="--"&&(f.isRegExp=!0,f.pattern="\\-\\-"),f.isMultiline&&!f.isRegExp&&(f.pattern=(0,P.escapeRegExpCharacters)(f.pattern),f.isRegExp=!0),m.usePCRE2&&b.push("--pcre2"),b.push("--crlf"),f.isRegExp&&(f.pattern=i(f.pattern),b.push("--engine","auto"));let N;if(f.isWordMatch){const M=(0,P.createRegExp)(f.pattern,!!f.isRegExp,{wholeWord:f.isWordMatch}).source.replace(/\\\//g,"/");b.push("--regexp",M)}else if(f.isRegExp){let g=o(f.pattern);g=l(g),b.push("--regexp",g)}else N=f.pattern,b.push("--fixed-strings");return b.push("--no-config"),m.useGlobalIgnoreFiles||b.push("--no-ignore-global"),b.push("--json"),f.isMultiline&&b.push("--multiline"),m.beforeContext&&b.push("--before-context",m.beforeContext+""),m.afterContext&&b.push("--after-context",m.afterContext+""),b.push("--"),N&&b.push(N),b.push("."),b}function a(f){const m=(0,k.splitGlobAware)(f,"/");return m.map((b,A)=>m.slice(0,A+1).join("/"))}e.spreadGlobComponents=a;function i(f){const m=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;f.match(m);)f=f.replace(m,"$1\\x{$2}");const b=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;f.match(b);)f=f.replace(b,"$1\\x{$2}");return f}e.unicodeEscapesToPCRE2=i;const n=f=>f.type==="Assertion"&&f.kind==="lookbehind";function o(f){let m;try{m=new E.RegExpParser().parsePattern(f)}catch{return f}let b="",A=0;const L=(M,U,j)=>{b+=f.slice(A,M)+j,A=U},N=[];return new E.RegExpVisitor({onCharacterEnter(M){if(M.raw!=="\\n")return;const U=N[0];if(!U)L(M.start,M.end,"\\r?\\n");else if(!N.some(n))if(U.type==="CharacterClass")if(U.negate){const j=f.slice(U.start+2,M.start)+f.slice(M.end,U.end-1);if(U.parent?.type==="Quantifier"){const K=U.parent;L(K.start,K.end,(j?`[^${j}]`:".")+(K.greedy?"+":"*"))}else L(U.start,U.end,"(?!\\r?\\n"+(j?`|[${j}]`:"")+")")}else{const j=f.slice(U.start+1,M.start)+f.slice(M.end,U.end-1);L(U.start,U.end,j===""?"\\r?\\n":`(?:[${j}]|\\r?\\n)`)}else U.type==="Quantifier"&&L(M.start,M.end,"(?:\\r?\\n)")},onQuantifierEnter(M){N.unshift(M)},onQuantifierLeave(){N.shift()},onCharacterClassRangeEnter(M){N.unshift(M)},onCharacterClassRangeLeave(){N.shift()},onCharacterClassEnter(M){N.unshift(M)},onCharacterClassLeave(){N.shift()},onAssertionEnter(M){n(M)&&N.push(M)},onAssertionLeave(M){N[0]===M&&N.shift()}}).visit(m),b+=f.slice(A),b}e.fixRegexNewline=o;function l(f){return f.replace(/\n/g,"\\r?\\n")}e.fixNewline=l}),define(pe[286],ve([0,1,21,138,118,10]),function(ee,e,d,t,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class T{constructor(P){this.outputChannel=P,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(P,F,y,c){const E=new t.RipgrepTextSearchEngine(this.outputChannel);if(F.folder.scheme===C.Schemas.userData){const v={...F,folder:F.folder.with({scheme:C.Schemas.file})},w=new I.Progress(_=>y.report({..._,uri:_.uri.with({scheme:F.folder.scheme})}));return this.withToken(c,_=>E.provideTextSearchResults(P,v,w,_))}else return this.withToken(c,v=>E.provideTextSearchResults(P,F,y,v))}async withToken(P,F){const y=k(P);this.inProgress.add(y);const c=await F(y.token);return this.inProgress.delete(y),c}dispose(){this.inProgress.forEach(P=>P.cancel())}}e.RipgrepSearchProvider=T;function k(D){const P=new d.CancellationTokenSource;return D.onCancellationRequested(()=>P.cancel()),P}}),define(pe[287],ve([0,1,29,138,137]),function(ee,e,d,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class C{constructor(D){this.query=D}search(D,P,F){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const y={appendLine(E){F({message:E})}},c=new I.NativeTextSearchManager(this.query,new t.RipgrepTextSearchEngine(y),d);return new Promise((E,v)=>c.search(w=>{P(w.map(T))},D).then(w=>E({limitHit:w.limitHit,type:"success",stats:w.stats}),v))}}e.TextSearchEngineAdapter=C;function T(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((D,P)=>{if(P.ranges){const F=P;return D+(Array.isArray(F.ranges)?F.ranges.length:1)}else return D+1},0)}}}),define(pe[288],ve([0,1,17,13,16,3,103,9,46,2,42,31,279,287]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class v{constructor(s="searchProcess"){this.processType=s,this.caches=Object.create(null)}fileSearch(s){let u;const r=R(s),S=new C.Emitter({onFirstListenerDidAdd:()=>{u=(0,t.createCancelablePromise)(a=>this.doFileSearchWithEngine(c.Engine,r,i=>S.fire(i),a)),u.then(a=>S.fire(a),a=>S.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{u.cancel()}});return S.event}textSearch(s){let u;const r=R(s),S=new C.Emitter({onFirstListenerDidAdd:()=>{u=(0,t.createCancelablePromise)(a=>this.ripgrepTextSearch(r,i=>S.fire(i),a)),u.then(a=>S.fire(a),a=>S.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{u.cancel()}});return S.event}ripgrepTextSearch(s,u,r){return s.maxFileSize=(0,F.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new E.TextSearchEngineAdapter(s).search(r,u,u)}doFileSearch(s,u,r){return this.doFileSearchWithEngine(c.Engine,s,u,r)}doFileSearchWithEngine(s,u,r,S,a=v.BATCH_SIZE){let i=0;const n=l=>{Array.isArray(l)?(i+=l.length,r(l.map(f=>this.rawMatchToSearchItem(f)))):l.relativePath?(i++,r(this.rawMatchToSearchItem(l))):r(l)};if(u.sortByScore){let l=this.trySortedSearchFromCache(u,n,S);if(!l){const f=u.maxResults?Object.assign({},u,{maxResults:null}):u,m=new s(f);l=this.doSortedSearch(m,u,r,n,S)}return new Promise((f,m)=>{l.then(([b,A])=>{const L=A.map(N=>this.rawMatchToSearchItem(N));this.sendProgress(L,r,a),f(b)},m)})}const o=new s(u);return this.doSearch(o,n,a,S).then(l=>({limitHit:l.limitHit,type:"success",stats:{detailStats:l.stats,type:this.processType,fromCache:!1,resultCount:i,sortingTime:void 0}}))}rawMatchToSearchItem(s){return{path:s.base?(0,k.join)(s.base,s.relativePath):s.relativePath}}doSortedSearch(s,u,r,S,a){const i=new C.Emitter;let n=(0,t.createCancelablePromise)(l=>{let f=[];const m=b=>{Array.isArray(b)?f=b:(S(b),i.fire(b))};return this.doSearch(s,m,-1,l).then(b=>[b,f])}),o;if(u.cacheKey){o=this.getOrCreateCache(u.cacheKey);const l={promise:n,event:i.event,resolved:!1};o.resultsToSearchCache[u.filePattern||""]=l,n.then(()=>{l.resolved=!0},f=>{delete o.resultsToSearchCache[u.filePattern||""]}),n=this.preventCancellation(n)}return n.then(([l,f])=>{const m=o?o.scorerCache:Object.create(null),b=(typeof u.maxResults!="number"||u.maxResults>0)&&D.StopWatch.create(!1);return this.sortResults(u,f,m,a).then(A=>{const L=b?b.elapsed():-1;return[{type:"success",stats:{detailStats:l.stats,sortingTime:L,fromCache:!1,type:this.processType,workspaceFolderCount:u.folderQueries.length,resultCount:A.length},messages:l.messages,limitHit:l.limitHit||typeof u.maxResults=="number"&&f.length>u.maxResults},A]})})}getOrCreateCache(s){const u=this.caches[s];return u||(this.caches[s]=new w)}trySortedSearchFromCache(s,u,r){const S=s.cacheKey&&this.caches[s.cacheKey];if(!S)return;const a=this.getResultsFromCache(S,s.filePattern||"",u,r);if(a)return a.then(([i,n,o])=>{const l=D.StopWatch.create(!1);return this.sortResults(s,n,S.scorerCache,r).then(f=>{const m=l.elapsed(),b={fromCache:!0,detailStats:o,type:this.processType,resultCount:n.length,sortingTime:m};return[{type:"success",limitHit:i.limitHit||typeof s.maxResults=="number"&&n.length>s.maxResults,stats:b},f]})})}sortResults(s,u,r,S){const a=(0,T.prepareQuery)(s.filePattern||""),i=(o,l)=>(0,T.compareItemsByFuzzyScore)(o,l,a,!0,_,r),n=typeof s.maxResults=="number"?s.maxResults:Number.MAX_VALUE;return d.topAsync(u,i,n,1e4,S)}sendProgress(s,u,r){if(r&&r>0)for(let S=0;S<s.length;S+=r)u(s.slice(S,S+r));else u(s)}getResultsFromCache(s,u,r,S){const a=D.StopWatch.create(!1),i=u.indexOf(k.sep)>=0;let n;for(const m in s.resultsToSearchCache)if(u.startsWith(m)){if(i&&m.indexOf(k.sep)<0&&m!=="")continue;const b=s.resultsToSearchCache[m];n={promise:this.preventCancellation(b.promise),event:b.event,resolved:b.resolved};break}if(!n)return null;const o=a.elapsed(),l=D.StopWatch.create(!1),f=n.event(r);return S&&S.onCancellationRequested(()=>{f.dispose()}),n.promise.then(([m,b])=>{if(S&&S.isCancellationRequested)throw(0,I.canceled)();const A=[],L=(0,T.prepareQuery)(u).normalizedLowercase;for(const N of b)!(0,y.isFilePatternMatch)(N,L)||A.push(N);return[m,A,{cacheWasResolved:n.resolved,cacheLookupTime:o,cacheFilterTime:l.elapsed(),cacheEntryCount:b.length}]})}doSearch(s,u,r,S){return new Promise((a,i)=>{let n=[];S&&S.onCancellationRequested(()=>s.cancel()),s.search(o=>{o&&(r?(n.push(o),r>0&&n.length>=r&&(u(n),n=[])):u(o))},o=>{u(o)},(o,l)=>{n.length&&u(n),o?i(o):a(l)})})}clearCache(s){return delete this.caches[s],Promise.resolve(void 0)}preventCancellation(s){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(u,r){return s.then(u,r)}catch(u){return this.then(void 0,u)}finally(u){return s.finally(u)}}}}e.SearchService=v,v.BATCH_SIZE=512;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const _=new class{getItemLabel(h){return(0,k.basename)(h.relativePath)}getItemDescription(h){return(0,k.dirname)(h.relativePath)}getItemPath(h){return h.relativePath}};function R(h){return{...h,folderQueries:h.folderQueries&&h.folderQueries.map(p),extraFileResources:h.extraFileResources&&h.extraFileResources.map(s=>P.URI.revive(s))}}function p(h){return{...h,folder:P.URI.revive(h.folder)}}}),define(pe[289],ve([0,1,6,10,2,29,12,26,14,72,64,31,288,286,92,137]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c,E,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let _=class extends P.ExtHostSearch{constructor(p,h,s,u){super(p,s,u);this._pfs=C,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const r=new v.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(t.Schemas.userData,new E.RipgrepSearchProvider(r)),h.remote.isRemote&&h.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const p=new v.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(t.Schemas.file,new E.RipgrepSearchProvider(p)),this.registerInternalFileSearchProvider(t.Schemas.file,new c.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(p,h){const s=this._handlePool++;return this._internalFileSearchProvider=h,this._internalFileSearchHandle=s,this._proxy.$registerFileSearchProvider(s,this._transformScheme(p)),(0,d.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(s)})}$provideFileSearchResults(p,h,s,u){const r=(0,P.reviveQuery)(s);return p===this._internalFileSearchHandle?this.doInternalFileSearch(p,h,r,u):super.$provideFileSearchResults(p,h,s,u)}doInternalFileSearch(p,h,s,u){const r=S=>{if((0,y.isSerializedFileMatch)(S)&&(S=[S]),Array.isArray(S)){this._proxy.$handleFileMatch(p,h,S.map(a=>I.URI.file(a.path)));return}S.message&&this._logService.debug("ExtHostSearch",S.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(s,r,u)}$clearCache(p){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(p),super.$clearCache(p)}createTextSearchManager(p,h){return new w.NativeTextSearchManager(p,h,void 0,"textSearchProvider")}};_=Be([Me(0,D.IExtHostRpcService),Me(1,k.IExtHostInitDataService),Me(2,F.IURITransformerService),Me(3,T.ILogService)],_),e.NativeExtHostSearch=_}),define(pe[139],ve([0,1,301,126,61,23,16,3,6,9,11,33,107,108,302]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class w{constructor(b,A=""){this.debugLabel=A,this.socket=b,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=L=>{if(this.traceSocketEvent("error",{code:L?.code,message:L?.message}),L){if(L.code==="EPIPE")return;(0,T.onUnexpectedError)(L)}},this.socket.on("error",this._errorListener)}traceSocketEvent(b,A){E.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,b,A)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(b){const A=L=>{this.traceSocketEvent("read",L),b(C.VSBuffer.wrap(L))};return this.socket.on("data",A),{dispose:()=>this.socket.off("data",A)}}onClose(b){const A=L=>{this.traceSocketEvent("close",{hadError:L}),b({type:0,hadError:L,error:void 0})};return this.socket.on("close",A),{dispose:()=>this.socket.off("close",A)}}onEnd(b){const A=()=>{this.traceSocketEvent("nodeEndReceived"),b()};return this.socket.on("end",A),{dispose:()=>this.socket.off("end",A)}}write(b){if(!this.socket.destroyed)try{this.traceSocketEvent("write",b),this.socket.write(b.buffer,A=>{if(A){if(A.code==="EPIPE")return;(0,T.onUnexpectedError)(A)}})}catch(A){if(A.code==="EPIPE")return;(0,T.onUnexpectedError)(A)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((b,A)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),b();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),this.traceSocketEvent("nodeDrainEnd"),b()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.NodeSocket=w;var _;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize"})(_||(_={}));var R;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(R||(R={}));class p extends D.Disposable{constructor(b,A,L,N){super();this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=b,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:A,inflateBytesLength:L?.byteLength||0,recordInflateBytes:N}),this._flowManager=this._register(new h(this,A,L,N,this._onData,(g,M)=>this._write(g,M))),this._register(this._flowManager.onError(g=>{console.error(g),(0,T.onUnexpectedError)(g),this._onClose.fire({type:0,hadError:!0,error:g})})),this._incomingData=new E.ChunkStream,this._register(this.socket.onData(g=>this._acceptChunk(g))),this._register(this.socket.onClose(g=>this._onClose.fire(g)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(b,A){this.socket.traceSocketEvent(b,A)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(b){return this._onData.event(b)}onClose(b){return this._onClose.event(b)}onEnd(b){return this.socket.onEnd(b)}write(b){this._flowManager.writeMessage(b)}_write(b,A){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",b);let L=2;b.byteLength<126?L+=0:b.byteLength<2**16?L+=2:L+=8;const N=C.VSBuffer.alloc(L);if(A?N.writeUInt8(194,0):N.writeUInt8(130,0),b.byteLength<126)N.writeUInt8(b.byteLength,1);else if(b.byteLength<2**16){N.writeUInt8(126,1);let g=1;N.writeUInt8(b.byteLength>>>8&255,++g),N.writeUInt8(b.byteLength>>>0&255,++g)}else{N.writeUInt8(127,1);let g=1;N.writeUInt8(0,++g),N.writeUInt8(0,++g),N.writeUInt8(0,++g),N.writeUInt8(0,++g),N.writeUInt8(b.byteLength>>>24&255,++g),N.writeUInt8(b.byteLength>>>16&255,++g),N.writeUInt8(b.byteLength>>>8&255,++g),N.writeUInt8(b.byteLength>>>0&255,++g)}this.socket.write(C.VSBuffer.concat([N,b]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(b){if(b.byteLength!==0){for(this._incomingData.acceptChunk(b);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const A=this._incomingData.peek(this._state.readLen),L=A.readUInt8(0),N=(L&128)>>>7,g=(L&64)>>>6,M=A.readUInt8(1),U=(M&128)>>>7,j=M&127;this._state.state=2,this._state.readLen=2+(U?4:0)+(j===126?2:0)+(j===127?8:0),this._state.fin=N,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(g)),this._state.firstFrameOfMessage=Boolean(N),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const A=this._incomingData.read(this._state.readLen),L=A.readUInt8(1),N=(L&128)>>>7;let g=L&127,M=1;g===126?g=A.readUInt8(++M)*2**8+A.readUInt8(++M):g===127&&(g=A.readUInt8(++M)*0+A.readUInt8(++M)*0+A.readUInt8(++M)*0+A.readUInt8(++M)*0+A.readUInt8(++M)*2**24+A.readUInt8(++M)*2**16+A.readUInt8(++M)*2**8+A.readUInt8(++M));let U=0;N&&(U=A.readUInt8(++M)*2**24+A.readUInt8(++M)*2**16+A.readUInt8(++M)*2**8+A.readUInt8(++M)),this._state.state=3,this._state.readLen=g,this._state.mask=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const A=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",A),r(A,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",A),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(A,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=p;class h extends D.Disposable{constructor(b,A,L,N,g,M){super();this._tracer=b,this._onData=g,this._writeFn=M,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,A?(this._zlibInflateStream=this._register(new s(this._tracer,N,L,{windowBits:15})),this._zlibDeflateStream=this._register(new u(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(U=>this._onError.fire(U))),this._register(this._zlibDeflateStream.onError(U=>this._onError.fire(U)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:C.VSBuffer.alloc(0)}writeMessage(b){this._writeQueue.push(b),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const b=this._writeQueue.shift();if(this._zlibDeflateStream){const A=await this._deflateMessage(this._zlibDeflateStream,b);this._writeFn(A,!0)}else this._writeFn(b,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(b,A){return new Promise((L,N)=>{b.write(A),b.flush(g=>L(g))})}acceptFrame(b,A,L){this._readQueue.push({data:b,isCompressed:A,isLastFrameOfMessage:L}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const b=this._readQueue.shift();if(this._zlibInflateStream&&b.isCompressed){const A=await this._inflateFrame(this._zlibInflateStream,b.data,b.isLastFrameOfMessage);this._onData.fire(A)}else this._onData.fire(b.data)}this._isProcessingReadQueue=!1}}_inflateFrame(b,A,L){return new Promise((N,g)=>{b.write(A),L&&b.write(C.VSBuffer.fromByteArray([0,0,255,255])),b.flush(M=>N(M))})}}class s extends D.Disposable{constructor(b,A,L,N){super();this._tracer=b,this._recordInflateBytes=A,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=v.createInflateRaw(N),this._zlibInflate.on("error",g=>{this._tracer.traceSocketEvent("zlibInflateError",{message:g?.message,code:g?.code}),this._onError.fire(g)}),this._zlibInflate.on("data",g=>{this._tracer.traceSocketEvent("zlibInflateData",g),this._pendingInflateData.push(C.VSBuffer.wrap(g))}),L&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",L.buffer),this._zlibInflate.write(L.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.concat(this._recordedInflateBytes):C.VSBuffer.alloc(0)}write(b){this._recordInflateBytes&&this._recordedInflateBytes.push(b.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",b),this._zlibInflate.write(b.buffer)}flush(b){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const A=C.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,b(A)})}}class u extends D.Disposable{constructor(b,A){super();this._tracer=b,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=v.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",L=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:L?.message,code:L?.code}),this._onError.fire(L)}),this._zlibDeflate.on("data",L=>{this._tracer.traceSocketEvent("zlibDeflateData",L),this._pendingDeflateData.push(C.VSBuffer.wrap(L))})}write(b){this._tracer.traceSocketEvent("zlibDeflateWrite",b.buffer),this._zlibDeflate.write(b.buffer)}flush(b){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let A=C.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,A=A.slice(0,A.byteLength-4),b(A)})}}function r(m,b){if(b===0)return;let A=m.byteLength>>>2;for(let j=0;j<A;j++){const K=m.readUInt32BE(j*4);m.writeUInt32BE(K^b,j*4)}let L=A*4,N=m.byteLength-L;const g=b>>>24&255,M=b>>>16&255,U=b>>>8&255;N>=1&&m.writeUInt8(m.readUInt8(L)^g,L),N>=2&&m.writeUInt8(m.readUInt8(L+1)^M,L+1),N>=3&&m.writeUInt8(m.readUInt8(L+2)^U,L+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const S={[2]:107,[1]:103};function a(){const m=(0,y.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;let b;return e.XDG_RUNTIME_DIR?b=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${m}.sock`):b=(0,P.join)((0,I.tmpdir)(),`vscode-ipc-${m}.sock`),n(b),b}e.createRandomIPCHandle=a;function i(m,b,A){const L=(0,d.createHash)("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${A}-${b}-sock`;let N;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?N=(0,P.join)(e.XDG_RUNTIME_DIR,`vscode-${L.substr(0,8)}-${A}-${b}.sock`):N=(0,P.join)(m,`${A}-${b}.sock`),n(N),N}e.createStaticIPCHandle=i;function n(m){const b=S[F.platform];typeof b=="number"&&m.length>=b&&console.warn(`WARNING: IPC handle "${m}" is longer than ${b} chars, try a shorter --user-data-dir`)}class o extends c.IPCServer{constructor(b){super(o.toClientConnectionEvent(b));this.server=b}static toClientConnectionEvent(b){const A=k.Event.fromNodeEventEmitter(b,"connection");return k.Event.map(A,L=>({protocol:new E.Protocol(new w(L,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(L,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function l(m){return new Promise((b,A)=>{const L=(0,t.createServer)();L.on("error",A),L.listen(m,()=>{L.removeListener("error",A),b(new o(L))})})}e.serve=l;function f(m,b){return new Promise((A,L)=>{const N=(0,t.createConnection)(m,()=>{N.removeListener("error",L),A(E.Client.fromSocket(new w(N,`ipc-client${b}`),b))});N.once("error",L)})}e.connect=f}),define(pe[290],ve([0,1,139,285,60,39,2,201,12]),function(ee,e,d,t,I,C,T,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class P{constructor(c,E,v){this._commands=c,this.logService=E,this._ipcHandlePath=v,this._server=t.createServer((w,_)=>this.onRequest(w,_)),this.setup().catch(w=>(E.error(w),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",c=>this.logService.error(c))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(c,E){const v=[];c.setEncoding("utf8"),c.on("data",w=>v.push(w)),c.on("end",()=>{const w=JSON.parse(v.join(""));switch(w.type){case"open":this.open(w,E);break;case"openExternal":this.openExternal(w,E);break;case"status":this.getStatus(w,E);break;case"extensionManagement":this.manageExtensions(w,E).catch(this.logService.error);break;default:E.writeHead(404),E.write(`Unknown message type: ${w.type}`,_=>{_&&this.logService.error(_)}),E.end();break}})}open(c,E){const{fileURIs:v,folderURIs:w,forceNewWindow:_,diffMode:R,addMode:p,forceReuseWindow:h,gotoLineMode:s,waitMarkerFilePath:u,remoteAuthority:r}=c,S=[];if(Array.isArray(w))for(const o of w)try{S.push({folderUri:T.URI.parse(o)})}catch{}if(Array.isArray(v))for(const o of v)try{(0,k.hasWorkspaceFileExtension)(o)?S.push({workspaceUri:T.URI.parse(o)}):S.push({fileUri:T.URI.parse(o)})}catch{}const a=u?T.URI.file(u):void 0,n={forceNewWindow:_,diffMode:R,addMode:p,gotoLineMode:s,forceReuseWindow:h,preferNewWindow:!h&&!a&&!p,waitMarkerFileURI:a,remoteAuthority:r};this._commands.executeCommand("_remoteCLI.windowOpen",S,n),E.writeHead(200),E.end()}async openExternal(c,E){for(const v of c.uris){const w=T.URI.parse(v),_=w.scheme==="file"?w:v;await this._commands.executeCommand("_remoteCLI.openExternal",_)}E.writeHead(200),E.end()}async manageExtensions(c,E){try{const v=R=>R?.map(p=>/\.vsix$/i.test(p)?T.URI.parse(p):p),w={list:c.list,install:v(c.install),uninstall:v(c.uninstall),force:c.force},_=await this._commands.executeCommand("_remoteCLI.manageExtensions",w);E.writeHead(200),E.write(_)}catch(v){E.writeHead(500),E.write(String(v),w=>{w&&this.logService.error(w)})}E.end()}async getStatus(c,E){try{const v=await this._commands.executeCommand("_remoteCLI.getSystemStatus");E.writeHead(200),E.write(v),E.end()}catch(v){E.writeHead(500),E.write(String(v),w=>{w&&this.logService.error(w)}),E.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&I.existsSync(this._ipcHandlePath)&&I.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=P;let F=class extends P{constructor(c,E){super(c,E,(0,d.createRandomIPCHandle)())}};F=Be([Me(0,C.IExtHostCommands),Me(1,D.ILogService)],F),e.CLIServer=F}),define(pe[291],ve([0,1,71,283,271,5,284,40,261,2,10,7,290,106]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class v extends I.RequireInterceptor{_installInterceptor(){const R=this,p=ee.__$__nodeRequire("module"),h=p._load;p._load=function(S,a,i){return S=u(S),R._factories.has(S)?R._factories.get(S).load(S,P.URI.file((0,E.realpathSync)(a.filename)),n=>h.apply(this,[n,a,i])):h.apply(this,arguments)};const s=p._resolveLookupPaths;p._resolveLookupPaths=(r,S)=>s.call(this,u(r),S);const u=r=>{for(let S of R._alternatives){let a=S(r);if(a){r=a;break}}return r}}}class w extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=y.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const R=this._instaService.invokeFunction(t.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(D.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const r=this._instaService.createInstance(c.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=r.ipcHandlePath}await this._instaService.createInstance(v,R,this._registry).install(),d.mark("code/extHost/didInitAPI");const h=await this._extHostConfiguration.getConfigProvider();await(0,T.connectProxyResolver)(this._extHostWorkspace,h,this,this._logService,this._mainThreadTelemetryProxy,this._initData),d.mark("code/extHost/didInitProxyResolver");const s=process.send,u=this._extHostContext.getProxy(C.MainContext.MainThreadConsole);process.send=(...r)=>r.length===0||!r[0]||r[0].type!=="__$console"?s.apply(process,r):(u.$logExtensionHostMessage(r[0]),!1)}_getEntryPoint(R){return R.main}_loadCommonJSModule(R,p,h){if(p.scheme!==F.Schemas.file)throw new Error(`Cannot load URI: '${p}', must be of file-scheme`);let s=null;h.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${p.toString(!0)}`),this._logService.flush();try{R&&d.mark(`code/extHost/willLoadExtensionCode/${R.value}`),s=ee.__$__nodeRequire(p.fsPath)}catch(u){return Promise.reject(u)}finally{R&&d.mark(`code/extHost/didLoadExtensionCode/${R.value}`),h.codeLoadingStop()}return Promise.resolve(s)}async $setRemoteEnvironment(R){if(!!this._initData.remote.isRemote)for(const p in R){const h=R[p];h===null?delete process.env[p]:process.env[p]=h}}}e.ExtHostExtensionService=w}),define(pe[292],ve([0,1,62,264,273,272,289,291,265,54,40,72,70,34,51,67,263,262,12]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c,E,v,w,_,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.registerSingleton)(F.IExtHostExtensionService,k.ExtHostExtensionService),(0,d.registerSingleton)(p.ILoggerService,R.ExtHostLoggerService),(0,d.registerSingleton)(w.IExtensionStoragePaths,_.ExtensionStoragePaths),(0,d.registerSingleton)(P.IExtHostDebugService,C.ExtHostDebugService),(0,d.registerSingleton)(y.IExtHostSearch,T.NativeExtHostSearch),(0,d.registerSingleton)(c.IExtHostTask,I.ExtHostTask),(0,d.registerSingleton)(E.IExtHostTerminalService,t.ExtHostTerminalService),(0,d.registerSingleton)(v.IExtHostTunnelService,D.ExtHostTunnelService)}),define(pe[293],ve([0,1,126,303,71,16,108,139,193,226,274,23,104,29,106,13,114,276,292]),function(ee,e,d,t,I,C,T,k,D,P,F,y,c,E,v,w,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let n=0;n<process.execArgv.length;n++)process.execArgv[n]==="--inspect-port=0"&&(process.execArgv.splice(n,1),n--)}();const R=t(process.argv.slice(2),{string:["uriTransformerPath"],boolean:["skipWorkspaceStorageLock","useHostProxy"]});(function(){const i=ee.__$__nodeRequire("module"),n=i._load;i._load=function(o){if(o==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return n.apply(this,arguments)}})();const p=process.exit.bind(process);function h(i){process.exit=function(n){if(i)p(n);else{const o=new Error("An extension called process.exit() and this was prevented.");console.warn(o.stack)}},process.crash=function(){const n=new Error("An extension called process.crash() and this was prevented.");console.warn(n.stack)}}let s=function(i){p()};function u(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((i,n)=>{let o=null,l=setTimeout(()=>{s("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const f=108e5,m=3e5,b=new w.ProcessTimeRunOnceScheduler(()=>s("renderer disconnected for too long (1)"),f),A=new w.ProcessTimeRunOnceScheduler(()=>s("renderer disconnected for too long (2)"),m);process.on("message",(N,g)=>{if(N&&N.type==="VSCODE_EXTHOST_IPC_SOCKET"){g.setNoDelay(!0);const M=y.VSBuffer.wrap(Buffer.from(N.initialDataChunk,"base64"));let U;if(N.skipWebSocketFrames)U=new k.NodeSocket(g,"extHost-socket");else{const j=y.VSBuffer.wrap(Buffer.from(N.inflateBytes,"base64"));U=new k.WebSocketNodeSocket(new k.NodeSocket(g,"extHost-socket"),N.permessageDeflate,j,!1)}o?(b.cancel(),A.cancel(),o.beginAcceptReconnection(U,M),o.endAcceptReconnection(),o.sendResume()):(clearTimeout(l),o=new T.PersistentProtocol(U,M),o.sendResume(),o.onDidDispose(()=>s("renderer disconnected")),i(o),o.onSocketClose(()=>{b.schedule()}))}if(N&&N.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(A.isScheduled())return;b.isScheduled()&&A.schedule()}});const L={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(L)});{const i=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((n,o)=>{const l=d.createConnection(i,()=>{l.removeListener("error",o),n(new T.PersistentProtocol(new k.NodeSocket(l,"extHost-renderer")))});l.once("error",o),l.on("close",()=>{s("renderer closed the socket")})})}}async function r(){const i=await u();return new class{constructor(){this._onMessage=new T.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,i.onMessage(n=>{(0,P.isMessageOfType)(n,2)?(this._terminating=!0,s("received terminate message from renderer")):this._onMessage.fire(n)})}send(n){this._terminating||i.send(n)}drain(){return i.drain()}}}function S(i){return new Promise(n=>{const o=i.onMessage(l=>{o.dispose();const f=JSON.parse(l.toString()),m=f.commit,b=D.default.commit;m&&b&&m!==b&&p(55);let A=0;setInterval(function(){try{process.kill(f.parentPid,0),A=0}catch(N){N&&N.code==="EPERM"?(A++,A>=3&&s(`parent process ${f.parentPid} does not exist anymore (3 x EPERM): ${N.message} (code: ${N.code}) (errno: ${N.errno})`)):s(`parent process ${f.parentPid} does not exist anymore: ${N.message} (code: ${N.code}) (errno: ${N.errno})`)}},1e3);let L;try{L=ee.__$__nodeRequire("native-watchdog"),L.start(f.parentPid)}catch(N){(0,C.onUnexpectedError)(N)}i.send((0,P.createMessageOfType)(0)),n({protocol:i,initData:f})});i.send((0,P.createMessageOfType)(1))})}async function a(){const i=[];process.on("unhandledRejection",(A,L)=>{i.push(L),setTimeout(()=>{const N=i.indexOf(L);N>=0&&L.catch(g=>{i.splice(N,1),(0,C.isCancellationError)(g)||(console.warn(`rejected promise not handled within 1 second: ${g}`),g&&g.stack&&console.warn(`stack trace: ${g.stack}`),A&&(0,C.onUnexpectedError)(A))})},1e3)}),process.on("rejectionHandled",A=>{const L=i.indexOf(A);L>=0&&i.splice(L,1)}),process.on("uncaughtException",function(A){(0,C.onUnexpectedError)(A)}),I.mark("code/extHost/willConnectToRenderer");const n=await r();I.mark("code/extHost/didConnectToRenderer");const o=await S(n);I.mark("code/extHost/didWaitForInitData");const{initData:l}=o;h(!!l.environment.extensionTestsLocationURI),l.environment.useHostProxy=!!R.useHostProxy,l.environment.skipWorkspaceStorageLock=(0,_.boolean)(R.skipWorkspaceStorageLock,!1);const f=new class{constructor(){this.pid=process.pid}exit(L){p(L)}exists(L){return E.Promises.exists(L)}realpath(L){return(0,v.realpath)(L)}};let m=null;if(l.remote.authority&&R.uriTransformerPath)try{const L=ee.__$__nodeRequire(R.uriTransformerPath)(l.remote.authority);m=new c.URITransformer(L)}catch(A){console.error(A)}const b=new F.ExtensionHostMain(o.protocol,l,f,m);s=A=>b.terminate(A)}e.startExtensionHostProcess=a}),define(pe[304],ve([0,1,293]),function(ee,e,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,d.startExtensionHostProcess)().catch(t=>console.log(t))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/5554b12acf27056905806867f251c859323ff7e9/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
